/*===========================================================================*/
/*   (Cgen/cgen.scm)                                                         */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


static obj_t _bdb_let_var2651_33_cgen_cgen(obj_t, obj_t, obj_t);
static obj_t no_bdb_newline_178_cgen_cgen();
static obj_t method_init_76_cgen_cgen();
extern obj_t make_box_202_ast_node;
static cop_bglt node__cop_default1765_254_cgen_cgen(node_bglt, obj_t);
extern obj_t block_cgen_cop;
extern obj_t cbox_ref_44_cgen_cop;
extern long add_inlined_method__244___object(obj_t, obj_t, long);
static obj_t __void_kont__176_cgen_cgen(obj_t, obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t fail_ast_node;
static obj_t _make_local_svar_name2653_192_cgen_cgen(obj_t, obj_t, obj_t);
extern setq_bglt node_setq_243_cgen_cgen(variable_bglt, node_bglt);
extern obj_t _void__134_type_cache;
extern obj_t box_ref_242_ast_node;
extern obj_t leave_function_170_tools_error();
extern obj_t _c_port__188_cgen_emit;
extern obj_t string_sans___40_type_tools(obj_t);
extern obj_t sequence_ast_node;
extern obj_t let_var_6_ast_node;
extern obj_t make_typed_declaration_180_type_tools(type_bglt, obj_t);
extern obj_t var_ast_node;
static obj_t _cgen2650_cgen_cgen(obj_t, obj_t);
static cvoid_bglt _void_kont__34_cgen_cgen(obj_t);
extern obj_t closure_ast_node;
extern obj_t _bdb_debug__1_engine_param;
extern obj_t cjump_ex_it_131_cgen_cop;
extern local_bglt make_local_svar_name_219_cgen_cgen(obj_t, type_bglt);
extern obj_t _obj__252_type_cache;
extern obj_t block_kont_197_cgen_cgen(obj_t, obj_t);
extern obj_t cpragma_cgen_cop;
extern obj_t pragma_ast_node;
obj_t _id_kont__126_cgen_cgen = BUNSPEC;
static obj_t make_setq_kont_65_cgen_cgen(variable_bglt, obj_t, obj_t);
extern obj_t varc_cgen_cop;
extern obj_t set_ex_it_116_ast_node;
extern obj_t emit_bdb_loc_8_cgen_emit_cop_239(obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
extern obj_t local_var_164_cgen_cop;
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t catom_cgen_cop;
extern obj_t reset_bdb_loc__217_cgen_emit_cop_239();
extern obj_t nop_cgen_cop;
extern obj_t ccast_cgen_cop;
extern obj_t _unspec__87_type_cache;
extern obj_t cswitch_cgen_cop;
extern obj_t module_initialization_70_cgen_cgen(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_effect_effect(long, char *);
extern obj_t module_initialization_70_coerce_typeof(long, char *);
extern obj_t module_initialization_70_cgen_emit(long, char *);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_cgen_emit_cop_239(long, char *);
extern obj_t module_initialization_70_cgen_prototype(long, char *);
extern obj_t module_initialization_70_cgen_capp(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_numbers_6_5(long, char *);
extern obj_t module_initialization_70___r4_output_6_10_3(long, char *);
extern obj_t cbox_set__132_cgen_cop;
obj_t _the_global__73_cgen_cgen = BUNSPEC;
extern obj_t clabel_cgen_cop;
extern obj_t csetq_cgen_cop;
static obj_t _node_setq2652_252_cgen_cgen(obj_t, obj_t, obj_t);
obj_t _return_kont__110_cgen_cgen = BUNSPEC;
extern obj_t bdb_block_21_cgen_cop;
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
extern obj_t stop_cgen_cop;
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
extern obj_t display_2_122___r4_output_6_10_3(obj_t, obj_t);
extern obj_t let_fun_218_ast_node;
static obj_t imported_modules_init_94_cgen_cgen();
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t add_generic__110___object(obj_t, obj_t);
extern obj_t cif_cgen_cop;
extern obj_t cgen_cgen_cgen(global_bglt);
extern obj_t creturn_cgen_cop;
static obj_t _block_kont_170_cgen_cgen(obj_t, obj_t, obj_t);
extern obj_t get_current_bdb_loc_105_cgen_emit_cop_239();
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
static obj_t library_modules_init_112_cgen_cgen();
extern obj_t sfun_c_188_cgen_cop;
extern obj_t atom_ast_node;
static obj_t _node__cop2654_244_cgen_cgen(obj_t, obj_t, obj_t);
extern obj_t cast_ast_node;
static obj_t toplevel_init_63_cgen_cgen();
extern bool_t emit_cop_45_cgen_emit_cop_239(cop_bglt);
extern obj_t jump_ex_it_184_ast_node;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
extern obj_t cvoid_cgen_cop;
static obj_t _node__cop_default1765_105_cgen_cgen(obj_t, obj_t, obj_t);
extern bool_t side_effect__165_effect_effect(node_bglt);
extern obj_t cmake_box_177_cgen_cop;
static obj_t _anonymous_1871__197_cgen_cgen(obj_t, obj_t);
static obj_t _anonymous_2535__84_cgen_cgen(obj_t, obj_t);
extern obj_t setq_ast_node;
static obj_t _anonymous_2530__1_cgen_cgen(obj_t, obj_t);
extern obj_t box_set__221_ast_node;
extern type_bglt typeof_coerce_typeof(node_bglt);
static obj_t _anonymous_2498__115_cgen_cgen(obj_t, obj_t);
extern obj_t enter_function_81_tools_error(obj_t);
extern obj_t csequence_cgen_cop;
extern obj_t cfail_cgen_cop;
extern obj_t shape_tools_shape(obj_t);
static obj_t _anonymous_1815__101_cgen_cgen(obj_t, obj_t);
static obj_t _anonymous_1814__113_cgen_cgen(obj_t, obj_t);
extern cop_bglt bdb_let_var_254_cgen_cgen(cop_bglt, obj_t);
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _anonymous_1802__126_cgen_cgen(obj_t, obj_t);
extern obj_t _procedure__226_type_cache;
extern obj_t cset_ex_it_123_cgen_cop;
static obj_t sfun__c_170_cgen_cgen(sfun_c_188_bglt, global_bglt);
extern obj_t _classes__134___object;
extern obj_t set_variable_name__102_cgen_prototype(obj_t);
extern obj_t select_ast_node;
obj_t _stop_kont__121_cgen_cgen = BUNSPEC;
extern bool_t _2__206___r4_numbers_6_5(obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern cop_bglt node__cop_142_cgen_cgen(node_bglt, obj_t);
extern obj_t ____74_type_cache;
static obj_t require_initialization_114_cgen_cgen = BUNSPEC;
extern obj_t conditional_ast_node;
static obj_t cnst_init_137_cgen_cgen();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
extern obj_t _bool__149_type_cache;
static obj_t __cnst[11];

DEFINE_EXPORT_PROCEDURE(block_kont_env_244_cgen_cgen, _block_kont_170_cgen_cgen2680, _block_kont_170_cgen_cgen, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2657_cgen_cgen, _anonymous_1815__101_cgen_cgen2681, _anonymous_1815__101_cgen_cgen, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2656_cgen_cgen, _anonymous_1814__113_cgen_cgen2682, _anonymous_1814__113_cgen_cgen, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2655_cgen_cgen, _anonymous_1802__126_cgen_cgen2683, _anonymous_1802__126_cgen_cgen, 0L, 1);
DEFINE_STATIC_PROCEDURE(node__cop_default1765_env_85_cgen_cgen, _node__cop_default1765_105_cgen_cgen2684, _node__cop_default1765_105_cgen_cgen, 0L, 2);
DEFINE_EXPORT_PROCEDURE(bdb_let_var_env_85_cgen_cgen, _bdb_let_var2651_33_cgen_cgen2685, _bdb_let_var2651_33_cgen_cgen, 0L, 2);
DEFINE_EXPORT_PROCEDURE(node_setq_env_20_cgen_cgen, _node_setq2652_252_cgen_cgen2686, _node_setq2652_252_cgen_cgen, 0L, 2);
DEFINE_STATIC_PROCEDURE(_void_kont__env_70_cgen_cgen, __void_kont__176_cgen_cgen2687, __void_kont__176_cgen_cgen, 0L, 1);
DEFINE_EXPORT_GENERIC(node__cop_env_160_cgen_cgen, _node__cop2654_244_cgen_cgen2688, _node__cop2654_244_cgen_cgen, 0L, 2);
DEFINE_STRING(string2675_cgen_cgen, string2675_cgen_cgen2689, "NODE->COP-DEFAULT1765 CELLVAL EXIT TEST AUX LOCATION (IF (>FX *BDB-DEBUG* 0) (LET LOOP ((COP COP)) (COND ((BLOCK? COP) (COP-LOC-SET! COP #unspecified) (LOOP (BLOCK-BODY COP))) ((CSEQUENCE? COP) (WITH-ACCESS::CSEQUENCE COP (C-EXP? COPS) (IF (AND (NOT C-EXP?) (PAIR? COPS)) (BEGIN (COP-LOC-SET! (CAR COPS) #unspecified) (LOOP (CAR COPS)))))) ((CLABEL? COP) (WITH-ACCESS::CLABEL COP (USED? BODY LOC) (IF (NOT USED?) (BEGIN (SET! LOC #unspecified) (LOOP BODY)))))))) (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Cgen/cgen.scm\" . 2085) (BEGIN (STRING? (GLOBAL-NAME GLOBAL))) (SH) SH ", 576);
DEFINE_STRING(string2674_cgen_cgen, string2674_cgen_cgen2690, "No method for this object", 25);
DEFINE_STRING(string2673_cgen_cgen, string2673_cgen_cgen2691, "(", 1);
DEFINE_STRING(string2672_cgen_cgen, string2672_cgen_cgen2692, ")jmpbuf", 7);
DEFINE_STRING(string2671_cgen_cgen, string2671_cgen_cgen2693, "_exit_value_", 12);
DEFINE_STRING(string2669_cgen_cgen, string2669_cgen_cgen2694, "Unexpected `closure' node", 25);
DEFINE_STRING(string2670_cgen_cgen, string2670_cgen_cgen2695, "jmp_buf jmpbuf", 14);
DEFINE_STRING(string2668_cgen_cgen, string2668_cgen_cgen2696, "Unexpected `kwote' node", 23);
DEFINE_STRING(string2667_cgen_cgen, string2667_cgen_cgen2697, "node->cop", 9);
DEFINE_STRING(string2666_cgen_cgen, string2666_cgen_cgen2698, "Illegal local name", 18);
DEFINE_STRING(string2665_cgen_cgen, string2665_cgen_cgen2699, "make-local-svar/name", 20);
DEFINE_STRING(string2664_cgen_cgen, string2664_cgen_cgen2700, ", ", 2);
DEFINE_STRING(string2663_cgen_cgen, string2663_cgen_cgen2701, "()", 2);
DEFINE_STRING(string2662_cgen_cgen, string2662_cgen_cgen2702, "}", 1);
DEFINE_STRING(string2661_cgen_cgen, string2661_cgen_cgen2703, "{ obj_t ___ = BUNSPEC; } /* bdb dummy init stmt */", 50);
DEFINE_STRING(string2659_cgen_cgen, string2659_cgen_cgen2704, " */", 3);
DEFINE_STRING(string2660_cgen_cgen, string2660_cgen_cgen2705, "{ AN_OBJECT;", 12);
DEFINE_STRING(string2658_cgen_cgen, string2658_cgen_cgen2706, "/* ", 3);
DEFINE_EXPORT_PROCEDURE(cgen_env_68_cgen_cgen, _cgen2650_cgen_cgen2707, _cgen2650_cgen_cgen, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_local_svar_name_env_11_cgen_cgen, _make_local_svar_name2653_192_cgen_cgen2708, _make_local_svar_name2653_192_cgen_cgen, 0L, 2);



/* module-initialization */
obj_t 
module_initialization_70_cgen_cgen(long checksum_4054, char *from_4055)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_cgen))
	{
	   require_initialization_114_cgen_cgen =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_cgen();
	   cnst_init_137_cgen_cgen();
	   imported_modules_init_94_cgen_cgen();
	   method_init_76_cgen_cgen();
	   toplevel_init_63_cgen_cgen();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_cgen()
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      module_initialization_70___object(((long) 0), "CGEN_CGEN");
      module_initialization_70___eval(((long) 0), "CGEN_CGEN");
      module_initialization_70___evenv(((long) 0), "CGEN_CGEN");
      module_initialization_70___r4_output_6_10_3(((long) 0), "CGEN_CGEN");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CGEN_CGEN");
      module_initialization_70___r4_numbers_6_5(((long) 0), "CGEN_CGEN");
      module_initialization_70___reader(((long) 0), "CGEN_CGEN");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_cgen()
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      {		/* Cgen/cgen.scm 14 */
	 obj_t cnst_port_138_4047;
	 cnst_port_138_4047 =
	    open_input_string(string2675_cgen_cgen);
	 {
	    long i_4048;
	    i_4048 = ((long) 10);
	  loop_4049:
	    {	/* Cgen/cgen.scm 14 */
	       bool_t test2676_4050;
	       test2676_4050 =
		  (i_4048 == ((long) -1));
	       if (test2676_4050)
		 {	/* Cgen/cgen.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/cgen.scm 14 */
		    {	/* Cgen/cgen.scm 14 */
		       obj_t arg2677_4051;
		       {	/* Cgen/cgen.scm 14 */
			  obj_t list2678_4052;
			  list2678_4052 =
			     MAKE_PAIR(cnst_port_138_4047, BNIL);
			  arg2677_4051 =
			     read___reader(list2678_4052);
		       }
		       CNST_TABLE_SET(i_4048, arg2677_4051);
		    }
		    {	/* Cgen/cgen.scm 14 */
		       int aux_4053;
		       {	/* Cgen/cgen.scm 14 */
			  long aux_4077;
			  aux_4077 =
			     (i_4048 - ((long) 1));
			  aux_4053 =
			     (int) (aux_4077);
		       }
		       {
			  long i_4080;
			  i_4080 =
			     (long) (aux_4053);
			  i_4048 = i_4080;
			  goto loop_4049;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_cgen()
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      _the_global__73_cgen_cgen = BUNSPEC;
      {		/* Cgen/cgen.scm 152 */
	 obj_t _anonymous_1802__126_3996;
	 _anonymous_1802__126_3996 = proc2655_cgen_cgen;
	 _return_kont__110_cgen_cgen = _anonymous_1802__126_3996;
      }
      {		/* Cgen/cgen.scm 169 */
	 obj_t _anonymous_1814__113_3995;
	 _anonymous_1814__113_3995 = proc2656_cgen_cgen;
	 _id_kont__126_cgen_cgen = _anonymous_1814__113_3995;
      }
      {		/* Cgen/cgen.scm 181 */
	 obj_t _anonymous_1815__101_3994;
	 _anonymous_1815__101_3994 = proc2657_cgen_cgen;
	 _stop_kont__121_cgen_cgen = _anonymous_1815__101_3994;
      }
      return BUNSPEC;
   }
}



/* <anonymous:1815> */
obj_t 
_anonymous_1815__101_cgen_cgen(obj_t env_3997, obj_t cop_3998)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 181 */
      {
	 obj_t cop_1063;
	 {	/* Cgen/cgen.scm 183 */
	    stop_bglt aux_4082;
	    cop_1063 = cop_3998;
	    {	/* Cgen/cgen.scm 183 */
	       stop_bglt res2552_2334;
	       {	/* Cgen/cgen.scm 183 */
		  obj_t loc_2326;
		  cop_bglt value_2327;
		  loc_2326 = BFALSE;
		  value_2327 =
		     (cop_bglt) (cop_1063);
		  {	/* ./Cgen/cop.scm 1981 */
		     stop_bglt new1515_2328;
		     new1515_2328 =
			((stop_bglt) BREF(GC_MALLOC(sizeof(struct stop))));
		     {	/* ./Cgen/cop.scm 1981 */
			long arg1936_2329;
			arg1936_2329 =
			   class_num_218___object(stop_cgen_cop);
			{	/* ./Cgen/cop.scm 1981 */
			   obj_t obj_2332;
			   obj_2332 =
			      (obj_t) (new1515_2328);
			   (((obj_t) CREF(obj_2332))->header = MAKE_HEADER(arg1936_2329, 0), BUNSPEC);
			}
		     }
		     {	/* ./Cgen/cop.scm 1981 */
			object_bglt aux_4088;
			aux_4088 =
			   (object_bglt) (new1515_2328);
			OBJECT_WIDENING_SET(aux_4088, loc_2326);
		     }
		     ((((stop_bglt) CREF(new1515_2328))->loc) = ((obj_t) loc_2326), BUNSPEC);
		     ((((stop_bglt) CREF(new1515_2328))->value) = ((cop_bglt) value_2327), BUNSPEC);
		     res2552_2334 = new1515_2328;
		  }
	       }
	       aux_4082 = res2552_2334;
	    }
	    return
	       (obj_t) (aux_4082);
	 }
      }
   }
}



/* <anonymous:1814> */
obj_t 
_anonymous_1814__113_cgen_cgen(obj_t env_3999, obj_t cop_4000)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 169 */
      {
	 obj_t cop_1061;
	 cop_1061 = cop_4000;
	 return cop_1061;
      }
   }
}



/* <anonymous:1802> */
obj_t 
_anonymous_1802__126_cgen_cgen(obj_t env_4001, obj_t cop_4002)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 152 */
      {
	 obj_t cop_1049;
	 {	/* Cgen/cgen.scm 155 */
	    creturn_bglt aux_4094;
	    cop_1049 = cop_4002;
	    {	/* Cgen/cgen.scm 155 */
	       obj_t arg1803_1051;
	       obj_t arg1804_1052;
	       {	/* Cgen/cgen.scm 155 */
		  cop_bglt obj_2292;
		  obj_2292 =
		     (cop_bglt) (cop_1049);
		  arg1803_1051 =
		     (((cop_bglt) CREF(obj_2292))->loc);
	       }
	       {	/* Cgen/cgen.scm 157 */
		  bool_t test1805_1053;
		  test1805_1053 =
		     is_a__118___object(cop_1049, csetq_cgen_cop);
		  if (test1805_1053)
		    {	/* Cgen/cgen.scm 157 */
		       {	/* Cgen/cgen.scm 159 */
			  obj_t arg1806_1054;
			  obj_t arg1809_1056;
			  {	/* Cgen/cgen.scm 159 */
			     cop_bglt obj_2294;
			     obj_2294 =
				(cop_bglt) (cop_1049);
			     arg1806_1054 =
				(((cop_bglt) CREF(obj_2294))->loc);
			  }
			  {	/* Cgen/cgen.scm 161 */
			     catom_bglt arg1810_1057;
			     {	/* Cgen/cgen.scm 161 */
				catom_bglt res2549_2303;
				{	/* Cgen/cgen.scm 161 */
				   obj_t loc_2295;
				   loc_2295 = BFALSE;
				   {	/* ./Cgen/cop.scm 1961 */
				      catom_bglt new1477_2297;
				      new1477_2297 =
					 ((catom_bglt) BREF(GC_MALLOC(sizeof(struct catom))));
				      {		/* ./Cgen/cop.scm 1961 */
					 long arg1949_2298;
					 arg1949_2298 =
					    class_num_218___object(catom_cgen_cop);
					 {	/* ./Cgen/cop.scm 1961 */
					    obj_t obj_2301;
					    obj_2301 =
					       (obj_t) (new1477_2297);
					    (((obj_t) CREF(obj_2301))->header = MAKE_HEADER(arg1949_2298, 0), BUNSPEC);
					 }
				      }
				      {		/* ./Cgen/cop.scm 1961 */
					 object_bglt aux_4105;
					 aux_4105 =
					    (object_bglt) (new1477_2297);
					 OBJECT_WIDENING_SET(aux_4105, loc_2295);
				      }
				      ((((catom_bglt) CREF(new1477_2297))->loc) = ((obj_t) loc_2295), BUNSPEC);
				      ((((catom_bglt) CREF(new1477_2297))->value) = ((obj_t) BUNSPEC), BUNSPEC);
				      res2549_2303 = new1477_2297;
				   }
				}
				arg1810_1057 = res2549_2303;
			     }
			     {	/* Cgen/cgen.scm 161 */
				obj_t list1811_1058;
				{	/* Cgen/cgen.scm 161 */
				   obj_t arg1812_1059;
				   {	/* Cgen/cgen.scm 161 */
				      obj_t aux_4110;
				      aux_4110 =
					 (obj_t) (arg1810_1057);
				      arg1812_1059 =
					 MAKE_PAIR(aux_4110, BNIL);
				   }
				   list1811_1058 =
				      MAKE_PAIR(cop_1049, arg1812_1059);
				}
				arg1809_1056 = list1811_1058;
			     }
			  }
			  {	/* Cgen/cgen.scm 158 */
			     csequence_bglt res2550_2315;
			     {	/* ./Cgen/cop.scm 1975 */
				csequence_bglt new1503_2308;
				new1503_2308 =
				   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
				{	/* ./Cgen/cop.scm 1975 */
				   long arg1940_2309;
				   arg1940_2309 =
				      class_num_218___object(csequence_cgen_cop);
				   {	/* ./Cgen/cop.scm 1975 */
				      obj_t obj_2313;
				      obj_2313 =
					 (obj_t) (new1503_2308);
				      (((obj_t) CREF(obj_2313))->header = MAKE_HEADER(arg1940_2309, 0), BUNSPEC);
				   }
				}
				{	/* ./Cgen/cop.scm 1975 */
				   object_bglt aux_4118;
				   aux_4118 =
				      (object_bglt) (new1503_2308);
				   OBJECT_WIDENING_SET(aux_4118, BFALSE);
				}
				((((csequence_bglt) CREF(new1503_2308))->loc) = ((obj_t) arg1806_1054), BUNSPEC);
				((((csequence_bglt) CREF(new1503_2308))->c_exp__163) = ((bool_t) ((bool_t) 1)), BUNSPEC);
				((((csequence_bglt) CREF(new1503_2308))->cops) = ((obj_t) arg1809_1056), BUNSPEC);
				res2550_2315 = new1503_2308;
			     }
			     arg1804_1052 =
				(obj_t) (res2550_2315);
			  }
		       }
		    }
		  else
		    {	/* Cgen/cgen.scm 157 */
		       arg1804_1052 = cop_1049;
		    }
	       }
	       {	/* Cgen/cgen.scm 154 */
		  creturn_bglt res2551_2324;
		  {	/* Cgen/cgen.scm 154 */
		     cop_bglt value_2317;
		     value_2317 =
			(cop_bglt) (arg1804_1052);
		     {	/* ./Cgen/cop.scm 1955 */
			creturn_bglt new1465_2318;
			new1465_2318 =
			   ((creturn_bglt) BREF(GC_MALLOC(sizeof(struct creturn))));
			{	/* ./Cgen/cop.scm 1955 */
			   long arg1953_2319;
			   arg1953_2319 =
			      class_num_218___object(creturn_cgen_cop);
			   {	/* ./Cgen/cop.scm 1955 */
			      obj_t obj_2322;
			      obj_2322 =
				 (obj_t) (new1465_2318);
			      (((obj_t) CREF(obj_2322))->header = MAKE_HEADER(arg1953_2319, 0), BUNSPEC);
			   }
			}
			{	/* ./Cgen/cop.scm 1955 */
			   object_bglt aux_4130;
			   aux_4130 =
			      (object_bglt) (new1465_2318);
			   OBJECT_WIDENING_SET(aux_4130, BFALSE);
			}
			((((creturn_bglt) CREF(new1465_2318))->loc) = ((obj_t) arg1803_1051), BUNSPEC);
			((((creturn_bglt) CREF(new1465_2318))->value) = ((cop_bglt) value_2317), BUNSPEC);
			res2551_2324 = new1465_2318;
		     }
		  }
		  aux_4094 = res2551_2324;
	       }
	    }
	    return
	       (obj_t) (aux_4094);
	 }
      }
   }
}



/* cgen */
obj_t 
cgen_cgen_cgen(global_bglt global_15)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 47 */
      enter_function_81_tools_error(
	 (((global_bglt) CREF(global_15))->id));
      _the_global__73_cgen_cgen =
	 (obj_t) (global_15);
      {		/* Cgen/cgen.scm 53 */
	 obj_t sh_1077;
	 sh_1077 =
	    shape_tools_shape(
	    (obj_t) (global_15));
	 {	/* Cgen/cgen.scm 54 */
	    bool_t test_4141;
	    {	/* ./Ieee/string.scm 8047 */
	       obj_t aux_4142;
	       aux_4142 =
		  (((global_bglt) CREF(global_15))->name);
	       test_4141 =
		  STRINGP(aux_4142);
	    }
	    if (test_4141)
	      {		/* Cgen/cgen.scm 54 */
		 BUNSPEC;
	      }
	    else
	      {		/* Cgen/cgen.scm 54 */
		 {	/* Cgen/cgen.scm 54 */
		    obj_t arg1830_1079;
		    obj_t arg1831_1080;
		    arg1830_1079 =
		       CNST_TABLE_REF(((long) 0));
		    arg1831_1080 =
		       __EVMEANING_ADDRESS(sh_1077);
		    define_primop_ref__105___evenv(arg1830_1079, arg1831_1080);
		 }
		 notify_assert_fail_37___eval(
		    CNST_TABLE_REF(((long) 1)),
		    CNST_TABLE_REF(((long) 2)),
		    CNST_TABLE_REF(((long) 3)));
		 unbind_primop__163___evenv(
		    CNST_TABLE_REF(((long) 0)));
	      }
	 }
      }
      {		/* Cgen/cgen.scm 55 */
	 sfun_c_188_bglt sfun_1082;
	 {	/* Cgen/cgen.scm 55 */
	    sfun_c_188_bglt obj1637_1097;
	    obj1637_1097 =
	       ((sfun_c_188_bglt) (
		  (((global_bglt) CREF(global_15))->value)));
	    {	/* Cgen/cgen.scm 57 */
	       sfun_c_188_bglt arg1845_1098;
	       {	/* Cgen/cgen.scm 57 */
		  clabel_bglt arg1846_1099;
		  {	/* Cgen/cgen.scm 57 */
		     obj_t arg1848_1101;
		     obj_t arg1849_1102;
		     {	/* Cgen/cgen.scm 57 */
			sfun_bglt obj_2356;
			{	/* Cgen/cgen.scm 57 */
			   value_bglt aux_4156;
			   aux_4156 =
			      (((global_bglt) CREF(global_15))->value);
			   obj_2356 =
			      (sfun_bglt) (aux_4156);
			}
			arg1848_1101 =
			   (((sfun_bglt) CREF(obj_2356))->loc);
		     }
		     arg1849_1102 =
			(((global_bglt) CREF(global_15))->name);
		     {	/* Cgen/cgen.scm 56 */
			clabel_bglt res2553_2370;
			{	/* ./Cgen/cop.scm 1944 */
			   clabel_bglt new1445_2362;
			   new1445_2362 =
			      ((clabel_bglt) BREF(GC_MALLOC(sizeof(struct clabel))));
			   {	/* ./Cgen/cop.scm 1944 */
			      long arg1959_2363;
			      arg1959_2363 =
				 class_num_218___object(clabel_cgen_cop);
			      {		/* ./Cgen/cop.scm 1944 */
				 obj_t obj_2368;
				 obj_2368 =
				    (obj_t) (new1445_2362);
				 (((obj_t) CREF(obj_2368))->header = MAKE_HEADER(arg1959_2363, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Cgen/cop.scm 1944 */
			      object_bglt aux_4165;
			      aux_4165 =
				 (object_bglt) (new1445_2362);
			      OBJECT_WIDENING_SET(aux_4165, BFALSE);
			   }
			   ((((clabel_bglt) CREF(new1445_2362))->loc) = ((obj_t) arg1848_1101), BUNSPEC);
			   ((((clabel_bglt) CREF(new1445_2362))->name) = ((obj_t) arg1849_1102), BUNSPEC);
			   ((((clabel_bglt) CREF(new1445_2362))->used__226) = ((bool_t) ((bool_t) 0)), BUNSPEC);
			   ((((clabel_bglt) CREF(new1445_2362))->body) = ((obj_t) BUNSPEC), BUNSPEC);
			   res2553_2370 = new1445_2362;
			}
			arg1846_1099 = res2553_2370;
		     }
		  }
		  {	/* Cgen/cgen.scm 55 */
		     sfun_c_188_bglt res2554_2376;
		     {	/* ./Cgen/cop.scm 2037 */
			sfun_c_188_bglt new1624_2373;
			new1624_2373 =
			   ((sfun_c_188_bglt) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
			((((sfun_c_188_bglt) CREF(new1624_2373))->label) = ((clabel_bglt) arg1846_1099), BUNSPEC);
			((((sfun_c_188_bglt) CREF(new1624_2373))->integrated) = ((bool_t) ((bool_t) 1)), BUNSPEC);
			res2554_2376 = new1624_2373;
		     }
		     arg1845_1098 = res2554_2376;
		  }
	       }
	       {	/* Cgen/cgen.scm 55 */
		  obj_t aux_4177;
		  object_bglt aux_4175;
		  aux_4177 =
		     (obj_t) (arg1845_1098);
		  aux_4175 =
		     (object_bglt) (obj1637_1097);
		  OBJECT_WIDENING_SET(aux_4175, aux_4177);
	       }
	    }
	    {	/* Cgen/cgen.scm 55 */
	       long arg1851_1104;
	       arg1851_1104 =
		  class_num_218___object(sfun_c_188_cgen_cop);
	       {	/* Cgen/cgen.scm 55 */
		  obj_t obj_2377;
		  obj_2377 =
		     (obj_t) (obj1637_1097);
		  (((obj_t) CREF(obj_2377))->header = MAKE_HEADER(arg1851_1104, 0), BUNSPEC);
	       }
	    }
	    sfun_1082 = obj1637_1097;
	 }
	 {	/* Cgen/cgen.scm 55 */
	    obj_t loc_1083;
	    {	/* Cgen/cgen.scm 60 */
	       sfun_bglt obj_2379;
	       obj_2379 =
		  (sfun_bglt) (sfun_1082);
	       loc_1083 =
		  (((sfun_bglt) CREF(obj_2379))->loc);
	    }
	    {	/* Cgen/cgen.scm 60 */
	       cop_bglt cop_1084;
	       {	/* Cgen/cgen.scm 61 */
		  obj_t arg1842_1094;
		  {	/* Cgen/cgen.scm 62 */
		     bool_t test1843_1095;
		     {	/* Cgen/cgen.scm 62 */
			obj_t obj2_2383;
			obj2_2383 = _void__134_type_cache;
			{	/* ./Ieee/equiv.scm 5508 */
			   obj_t aux_4185;
			   {	/* Cgen/cgen.scm 62 */
			      type_bglt aux_4186;
			      aux_4186 =
				 (((global_bglt) CREF(global_15))->type);
			      aux_4185 =
				 (obj_t) (aux_4186);
			   }
			   test1843_1095 =
			      (aux_4185 == obj2_2383);
			}
		     }
		     if (test1843_1095)
		       {	/* Cgen/cgen.scm 62 */
			  arg1842_1094 = _void_kont__env_70_cgen_cgen;
		       }
		     else
		       {	/* Cgen/cgen.scm 62 */
			  arg1842_1094 = _return_kont__110_cgen_cgen;
		       }
		  }
		  {	/* Cgen/cgen.scm 61 */
		     node_bglt aux_4191;
		     {	/* Cgen/cgen.scm 61 */
			obj_t aux_4192;
			{	/* Cgen/cgen.scm 61 */
			   sfun_bglt obj_2380;
			   obj_2380 =
			      (sfun_bglt) (sfun_1082);
			   aux_4192 =
			      (((sfun_bglt) CREF(obj_2380))->body);
			}
			aux_4191 =
			   (node_bglt) (aux_4192);
		     }
		     cop_1084 =
			node__cop_142_cgen_cgen(aux_4191, arg1842_1094);
		  }
	       }
	       {	/* Cgen/cgen.scm 61 */

		  reset_bdb_loc__217_cgen_emit_cop_239();
		  {	/* Cgen/cgen.scm 66 */
		     obj_t port_2384;
		     port_2384 = _c_port__188_cgen_emit;
		     WRITE_CHAR(((unsigned char) '\n'), port_2384);
		  }
		  {	/* Cgen/cgen.scm 67 */
		     obj_t port_2385;
		     port_2385 = _c_port__188_cgen_emit;
		     WRITE_CHAR(((unsigned char) '\n'), port_2385);
		  }
		  display_2_122___r4_output_6_10_3(string2658_cgen_cgen, _c_port__188_cgen_emit);
		  {	/* Cgen/cgen.scm 69 */
		     obj_t arg1833_1085;
		     arg1833_1085 =
			shape_tools_shape(
			(obj_t) (global_15));
		     display_2_122___r4_output_6_10_3(arg1833_1085, _c_port__188_cgen_emit);
		  }
		  display_2_122___r4_output_6_10_3(string2659_cgen_cgen, _c_port__188_cgen_emit);
		  emit_bdb_loc_8_cgen_emit_cop_239(BFALSE);
		  reset_bdb_loc__217_cgen_emit_cop_239();
		  {	/* Cgen/cgen.scm 79 */
		     clabel_bglt arg1834_1086;
		     {
			obj_t aux_4207;
			{	/* ./Cgen/cop.scm 2038 */
			   object_bglt aux_4208;
			   aux_4208 =
			      (object_bglt) (sfun_1082);
			   aux_4207 =
			      OBJECT_WIDENING(aux_4208);
			}
			arg1834_1086 =
			   (((sfun_c_188_bglt) CREF(aux_4207))->label);
		     }
		     {	/* Cgen/cgen.scm 79 */
			obj_t val1444_2388;
			val1444_2388 =
			   (obj_t) (cop_1084);
			((((clabel_bglt) CREF(arg1834_1086))->body) = ((obj_t) val1444_2388), BUNSPEC);
		     }
		  }
		  sfun__c_170_cgen_cgen(sfun_1082, global_15);
		  {	/* Cgen/cgen.scm 81 */
		     obj_t cop_1087;
		     {	/* Cgen/cgen.scm 81 */
			obj_t cop_2390;
			{	/* Cgen/cgen.scm 81 */
			   clabel_bglt aux_4215;
			   {
			      obj_t aux_4216;
			      {		/* ./Cgen/cop.scm 2038 */
				 object_bglt aux_4217;
				 aux_4217 =
				    (object_bglt) (sfun_1082);
				 aux_4216 =
				    OBJECT_WIDENING(aux_4217);
			      }
			      aux_4215 =
				 (((sfun_c_188_bglt) CREF(aux_4216))->label);
			   }
			   cop_2390 =
			      (obj_t) (aux_4215);
			}
			{	/* Cgen/cgen.scm 190 */
			   bool_t test1868_2392;
			   test1868_2392 =
			      is_a__118___object(cop_2390, block_cgen_cop);
			   if (test1868_2392)
			     {	/* Cgen/cgen.scm 190 */
				cop_1087 = cop_2390;
			     }
			   else
			     {	/* Cgen/cgen.scm 190 */
				{	/* Cgen/cgen.scm 193 */
				   block_bglt res2555_2404;
				   {	/* Cgen/cgen.scm 193 */
				      cop_bglt body_2397;
				      body_2397 =
					 (cop_bglt) (cop_2390);
				      {		/* ./Cgen/cop.scm 1952 */
					 block_bglt new1459_2398;
					 new1459_2398 =
					    ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
					 {	/* ./Cgen/cop.scm 1952 */
					    long arg1955_2399;
					    arg1955_2399 =
					       class_num_218___object(block_cgen_cop);
					    {	/* ./Cgen/cop.scm 1952 */
					       obj_t obj_2402;
					       obj_2402 =
						  (obj_t) (new1459_2398);
					       (((obj_t) CREF(obj_2402))->header = MAKE_HEADER(arg1955_2399, 0), BUNSPEC);
					    }
					 }
					 {	/* ./Cgen/cop.scm 1952 */
					    object_bglt aux_4229;
					    aux_4229 =
					       (object_bglt) (new1459_2398);
					    OBJECT_WIDENING_SET(aux_4229, BFALSE);
					 }
					 ((((block_bglt) CREF(new1459_2398))->loc) = ((obj_t) loc_1083), BUNSPEC);
					 ((((block_bglt) CREF(new1459_2398))->body) = ((cop_bglt) body_2397), BUNSPEC);
					 res2555_2404 = new1459_2398;
				      }
				   }
				   cop_1087 =
				      (obj_t) (res2555_2404);
				}
			     }
			}
		     }
		     CNST_TABLE_REF(((long) 4));
		     display_2_122___r4_output_6_10_3(string2660_cgen_cgen, _c_port__188_cgen_emit);
		     {	/* Cgen/cgen.scm 105 */
			bool_t test1835_1088;
			{	/* Cgen/cgen.scm 105 */
			   bool_t test1836_1089;
			   test1836_1089 =
			      _2__206___r4_numbers_6_5(_bdb_debug__1_engine_param,
			      BINT(((long) 0)));
			   if (test1836_1089)
			     {	/* Cgen/cgen.scm 105 */
				if (
				   STRUCTP(loc_1083))
				  {	/* ./Ieee/equiv.scm 5508 */
				     obj_t aux_4244;
				     obj_t aux_4242;
				     aux_4244 =
					CNST_TABLE_REF(((long) 5));
				     aux_4242 =
					STRUCT_KEY(loc_1083);
				     test1835_1088 =
					(aux_4242 == aux_4244);
				  }
				else
				  {	/* ./Tools/location.sch 1077 */
				     test1835_1088 = ((bool_t) 0);
				  }
			     }
			   else
			     {	/* Cgen/cgen.scm 105 */
				test1835_1088 = ((bool_t) 0);
			     }
			}
			if (test1835_1088)
			  {	/* Cgen/cgen.scm 105 */
			     emit_bdb_loc_8_cgen_emit_cop_239(loc_1083);
			     display_2_122___r4_output_6_10_3(string2661_cgen_cgen, _c_port__188_cgen_emit);
			  }
			else
			  {	/* Cgen/cgen.scm 105 */
			     BUNSPEC;
			  }
		     }
		     emit_cop_45_cgen_emit_cop_239(
			(cop_bglt) (cop_1087));
		     {	/* Cgen/cgen.scm 113 */
			obj_t arg1838_1090;
			arg1838_1090 =
			   get_current_bdb_loc_105_cgen_emit_cop_239();
			emit_bdb_loc_8_cgen_emit_cop_239(arg1838_1090);
		     }
		     {	/* Cgen/cgen.scm 115 */
			obj_t port1639_1091;
			port1639_1091 = _c_port__188_cgen_emit;
			display_2_122___r4_output_6_10_3(string2662_cgen_cgen, port1639_1091);
			WRITE_CHAR(((unsigned char) '\n'), port1639_1091);
		     }
		  }
		  no_bdb_newline_178_cgen_cgen();
		  return
		     leave_function_170_tools_error();
	       }
	    }
	 }
      }
   }
}



/* _cgen2650 */
obj_t 
_cgen2650_cgen_cgen(obj_t env_4003, obj_t global_4004)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 47 */
      return
	 cgen_cgen_cgen(
	 (global_bglt) (global_4004));
   }
}



/* sfun->c */
obj_t 
sfun__c_170_cgen_cgen(sfun_c_188_bglt sfun_16, global_bglt variable_17)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 129 */
      {		/* Cgen/cgen.scm 131 */
	 obj_t arg1852_1106;
	 {	/* Cgen/cgen.scm 131 */
	    obj_t aux_4263;
	    type_bglt aux_4260;
	    {	/* Cgen/cgen.scm 131 */
	       variable_bglt obj_2415;
	       obj_2415 =
		  (variable_bglt) (variable_17);
	       aux_4263 =
		  (((variable_bglt) CREF(obj_2415))->name);
	    }
	    {	/* Cgen/cgen.scm 131 */
	       variable_bglt obj_2414;
	       obj_2414 =
		  (variable_bglt) (variable_17);
	       aux_4260 =
		  (((variable_bglt) CREF(obj_2414))->type);
	    }
	    arg1852_1106 =
	       make_typed_declaration_180_type_tools(aux_4260, aux_4263);
	 }
	 display_2_122___r4_output_6_10_3(arg1852_1106, _c_port__188_cgen_emit);
      }
      {		/* Cgen/cgen.scm 132 */
	 bool_t test_4268;
	 {	/* ./Ieee/pair-list.scm 5912 */
	    obj_t aux_4269;
	    {	/* Cgen/cgen.scm 132 */
	       sfun_bglt obj_2416;
	       obj_2416 =
		  (sfun_bglt) (sfun_16);
	       aux_4269 =
		  (((sfun_bglt) CREF(obj_2416))->args);
	    }
	    test_4268 =
	       NULLP(aux_4269);
	 }
	 if (test_4268)
	   {	/* Cgen/cgen.scm 132 */
	      display_2_122___r4_output_6_10_3(string2663_cgen_cgen, _c_port__188_cgen_emit);
	      return
		 no_bdb_newline_178_cgen_cgen();
	   }
	 else
	   {	/* Cgen/cgen.scm 132 */
	      display_2_122___r4_output_6_10_3(
		 BCHAR(((unsigned char) '(')), _c_port__188_cgen_emit);
	      {
		 obj_t args_1110;
		 {	/* Cgen/cgen.scm 138 */
		    sfun_bglt obj_2418;
		    obj_2418 =
		       (sfun_bglt) (sfun_16);
		    args_1110 =
		       (((sfun_bglt) CREF(obj_2418))->args);
		 }
	       loop_1111:
		 {	/* Cgen/cgen.scm 139 */
		    bool_t test_4277;
		    {	/* ./Ieee/pair-list.scm 5912 */
		       obj_t aux_4278;
		       aux_4278 =
			  CDR(args_1110);
		       test_4277 =
			  NULLP(aux_4278);
		    }
		    if (test_4277)
		      {		/* Cgen/cgen.scm 140 */
			 obj_t instance1641_1114;
			 instance1641_1114 =
			    CAR(args_1110);
			 {	/* Cgen/cgen.scm 141 */
			    obj_t arg1858_1115;
			    {	/* Cgen/cgen.scm 141 */
			       obj_t aux_4285;
			       type_bglt aux_4282;
			       {	/* Cgen/cgen.scm 141 */
				  local_bglt obj_2423;
				  obj_2423 =
				     (local_bglt) (instance1641_1114);
				  aux_4285 =
				     (((local_bglt) CREF(obj_2423))->name);
			       }
			       {	/* Cgen/cgen.scm 141 */
				  local_bglt obj_2422;
				  obj_2422 =
				     (local_bglt) (instance1641_1114);
				  aux_4282 =
				     (((local_bglt) CREF(obj_2422))->type);
			       }
			       arg1858_1115 =
				  make_typed_declaration_180_type_tools(aux_4282, aux_4285);
			    }
			    display_2_122___r4_output_6_10_3(arg1858_1115, _c_port__188_cgen_emit);
			 }
			 {	/* Cgen/cgen.scm 142 */
			    obj_t port_2425;
			    port_2425 = _c_port__188_cgen_emit;
			    WRITE_CHAR(((unsigned char) ')'), port_2425);
			 }
			 return
			    no_bdb_newline_178_cgen_cgen();
		      }
		    else
		      {		/* Cgen/cgen.scm 144 */
			 obj_t instance1642_1118;
			 instance1642_1118 =
			    CAR(args_1110);
			 {	/* Cgen/cgen.scm 145 */
			    obj_t arg1861_1119;
			    {	/* Cgen/cgen.scm 145 */
			       obj_t aux_4296;
			       type_bglt aux_4293;
			       {	/* Cgen/cgen.scm 145 */
				  local_bglt obj_2428;
				  obj_2428 =
				     (local_bglt) (instance1642_1118);
				  aux_4296 =
				     (((local_bglt) CREF(obj_2428))->name);
			       }
			       {	/* Cgen/cgen.scm 145 */
				  local_bglt obj_2427;
				  obj_2427 =
				     (local_bglt) (instance1642_1118);
				  aux_4293 =
				     (((local_bglt) CREF(obj_2427))->type);
			       }
			       arg1861_1119 =
				  make_typed_declaration_180_type_tools(aux_4293, aux_4296);
			    }
			    display_2_122___r4_output_6_10_3(arg1861_1119, _c_port__188_cgen_emit);
			 }
			 display_2_122___r4_output_6_10_3(string2664_cgen_cgen, _c_port__188_cgen_emit);
			 {
			    obj_t args_4302;
			    args_4302 =
			       CDR(args_1110);
			    args_1110 = args_4302;
			    goto loop_1111;
			 }
		      }
		 }
	      }
	   }
      }
   }
}



/* *void-kont* */
cvoid_bglt 
_void_kont__34_cgen_cgen(obj_t cop_18)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 174 */
      {		/* Cgen/cgen.scm 176 */
	 cvoid_bglt res2556_2439;
	 {	/* Cgen/cgen.scm 176 */
	    obj_t loc_2431;
	    cop_bglt value_2432;
	    loc_2431 = BFALSE;
	    value_2432 =
	       (cop_bglt) (cop_18);
	    {	/* ./Cgen/cop.scm 1958 */
	       cvoid_bglt new1471_2433;
	       new1471_2433 =
		  ((cvoid_bglt) BREF(GC_MALLOC(sizeof(struct cvoid))));
	       {	/* ./Cgen/cop.scm 1958 */
		  long arg1951_2434;
		  arg1951_2434 =
		     class_num_218___object(cvoid_cgen_cop);
		  {	/* ./Cgen/cop.scm 1958 */
		     obj_t obj_2437;
		     obj_2437 =
			(obj_t) (new1471_2433);
		     (((obj_t) CREF(obj_2437))->header = MAKE_HEADER(arg1951_2434, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Cgen/cop.scm 1958 */
		  object_bglt aux_4311;
		  aux_4311 =
		     (object_bglt) (new1471_2433);
		  OBJECT_WIDENING_SET(aux_4311, loc_2431);
	       }
	       ((((cvoid_bglt) CREF(new1471_2433))->loc) = ((obj_t) loc_2431), BUNSPEC);
	       ((((cvoid_bglt) CREF(new1471_2433))->value) = ((cop_bglt) value_2432), BUNSPEC);
	       res2556_2439 = new1471_2433;
	    }
	 }
	 return res2556_2439;
      }
   }
}



/* _*void-kont* */
obj_t 
__void_kont__176_cgen_cgen(obj_t env_4005, obj_t cop_4006)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 174 */
      {		/* Cgen/cgen.scm 174 */
	 cvoid_bglt aux_4316;
	 aux_4316 =
	    _void_kont__34_cgen_cgen(cop_4006);
	 return
	    (obj_t) (aux_4316);
      }
   }
}



/* block-kont */
obj_t 
block_kont_197_cgen_cgen(obj_t cop_19, obj_t loc_20)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 188 */
      {		/* Cgen/cgen.scm 190 */
	 bool_t test1868_2440;
	 test1868_2440 =
	    is_a__118___object(cop_19, block_cgen_cop);
	 if (test1868_2440)
	   {	/* Cgen/cgen.scm 190 */
	      return cop_19;
	   }
	 else
	   {	/* Cgen/cgen.scm 190 */
	      {		/* Cgen/cgen.scm 193 */
		 block_bglt res2557_2452;
		 {	/* Cgen/cgen.scm 193 */
		    cop_bglt body_2445;
		    body_2445 =
		       (cop_bglt) (cop_19);
		    {	/* ./Cgen/cop.scm 1952 */
		       block_bglt new1459_2446;
		       new1459_2446 =
			  ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
		       {	/* ./Cgen/cop.scm 1952 */
			  long arg1955_2447;
			  arg1955_2447 =
			     class_num_218___object(block_cgen_cop);
			  {	/* ./Cgen/cop.scm 1952 */
			     obj_t obj_2450;
			     obj_2450 =
				(obj_t) (new1459_2446);
			     (((obj_t) CREF(obj_2450))->header = MAKE_HEADER(arg1955_2447, 0), BUNSPEC);
			  }
		       }
		       {	/* ./Cgen/cop.scm 1952 */
			  object_bglt aux_4326;
			  aux_4326 =
			     (object_bglt) (new1459_2446);
			  OBJECT_WIDENING_SET(aux_4326, BFALSE);
		       }
		       ((((block_bglt) CREF(new1459_2446))->loc) = ((obj_t) loc_20), BUNSPEC);
		       ((((block_bglt) CREF(new1459_2446))->body) = ((cop_bglt) body_2445), BUNSPEC);
		       res2557_2452 = new1459_2446;
		    }
		 }
		 return
		    (obj_t) (res2557_2452);
	      }
	   }
      }
   }
}



/* _block-kont */
obj_t 
_block_kont_170_cgen_cgen(obj_t env_4007, obj_t cop_4008, obj_t loc_4009)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 188 */
      return
	 block_kont_197_cgen_cgen(cop_4008, loc_4009);
   }
}



/* make-setq-kont */
obj_t 
make_setq_kont_65_cgen_cgen(variable_bglt var_23, obj_t loc_24, obj_t kont_25)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 210 */
      {		/* Cgen/cgen.scm 211 */
	 obj_t _anonymous_1871__197_4010;
	 _anonymous_1871__197_4010 =
	    make_fx_procedure(_anonymous_1871__197_cgen_cgen, ((long) 1), ((long) 3));
	 PROCEDURE_SET(_anonymous_1871__197_4010, ((long) 0), loc_24);
	 {	/* Cgen/cgen.scm 211 */
	    obj_t aux_4335;
	    aux_4335 =
	       (obj_t) (var_23);
	    PROCEDURE_SET(_anonymous_1871__197_4010, ((long) 1), aux_4335);
	 }
	 PROCEDURE_SET(_anonymous_1871__197_4010, ((long) 2), kont_25);
	 return _anonymous_1871__197_4010;
      }
   }
}



/* <anonymous:1871> */
obj_t 
_anonymous_1871__197_cgen_cgen(obj_t env_4011, obj_t cop_4015)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 211 */
      {		/* Cgen/cgen.scm 212 */
	 obj_t loc_4012;
	 obj_t var_4013;
	 obj_t kont_4014;
	 loc_4012 =
	    PROCEDURE_REF(env_4011, ((long) 0));
	 var_4013 =
	    PROCEDURE_REF(env_4011, ((long) 1));
	 kont_4014 =
	    PROCEDURE_REF(env_4011, ((long) 2));
	 {
	    obj_t cop_1129;
	    cop_1129 = cop_4015;
	    {	/* Cgen/cgen.scm 212 */
	       bool_t test1872_1131;
	       test1872_1131 =
		  is_a__118___object(cop_1129, cfail_cgen_cop);
	       if (test1872_1131)
		 {	/* Cgen/cgen.scm 212 */
		    return cop_1129;
		 }
	       else
		 {	/* Cgen/cgen.scm 214 */
		    csetq_bglt arg1873_1132;
		    {	/* Cgen/cgen.scm 214 */
		       varc_bglt arg1875_1134;
		       obj_t arg1876_1135;
		       {	/* Cgen/cgen.scm 215 */
			  varc_bglt res2558_2462;
			  {	/* Cgen/cgen.scm 215 */
			     obj_t loc_2454;
			     variable_bglt variable_2455;
			     loc_2454 = BFALSE;
			     variable_2455 =
				(variable_bglt) (var_4013);
			     {	/* ./Cgen/cop.scm 1964 */
				varc_bglt new1483_2456;
				new1483_2456 =
				   ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
				{	/* ./Cgen/cop.scm 1964 */
				   long arg1946_2457;
				   arg1946_2457 =
				      class_num_218___object(varc_cgen_cop);
				   {	/* ./Cgen/cop.scm 1964 */
				      obj_t obj_2460;
				      obj_2460 =
					 (obj_t) (new1483_2456);
				      (((obj_t) CREF(obj_2460))->header = MAKE_HEADER(arg1946_2457, 0), BUNSPEC);
				   }
				}
				{	/* ./Cgen/cop.scm 1964 */
				   object_bglt aux_4349;
				   aux_4349 =
				      (object_bglt) (new1483_2456);
				   OBJECT_WIDENING_SET(aux_4349, loc_2454);
				}
				((((varc_bglt) CREF(new1483_2456))->loc) = ((obj_t) loc_2454), BUNSPEC);
				((((varc_bglt) CREF(new1483_2456))->variable) = ((variable_bglt) variable_2455), BUNSPEC);
				res2558_2462 = new1483_2456;
			     }
			  }
			  arg1875_1134 = res2558_2462;
		       }
		       {	/* Cgen/cgen.scm 217 */
			  bool_t test1878_1137;
			  test1878_1137 =
			     is_a__118___object(cop_1129, csetq_cgen_cop);
			  if (test1878_1137)
			    {	/* Cgen/cgen.scm 217 */
			       {	/* Cgen/cgen.scm 219 */
				  obj_t arg1879_1138;
				  obj_t arg1881_1140;
				  {	/* Cgen/cgen.scm 219 */
				     cop_bglt obj_2464;
				     obj_2464 =
					(cop_bglt) (cop_1129);
				     arg1879_1138 =
					(((cop_bglt) CREF(obj_2464))->loc);
				  }
				  {	/* Cgen/cgen.scm 223 */
				     catom_bglt arg1882_1141;
				     {	/* Cgen/cgen.scm 223 */
					obj_t arg1885_1144;
					{	/* Cgen/cgen.scm 223 */
					   cop_bglt obj_2465;
					   obj_2465 =
					      (cop_bglt) (cop_1129);
					   arg1885_1144 =
					      (((cop_bglt) CREF(obj_2465))->loc);
					}
					{	/* Cgen/cgen.scm 222 */
					   catom_bglt res2559_2474;
					   {	/* ./Cgen/cop.scm 1961 */
					      catom_bglt new1477_2468;
					      new1477_2468 =
						 ((catom_bglt) BREF(GC_MALLOC(sizeof(struct catom))));
					      {		/* ./Cgen/cop.scm 1961 */
						 long arg1949_2469;
						 arg1949_2469 =
						    class_num_218___object(catom_cgen_cop);
						 {	/* ./Cgen/cop.scm 1961 */
						    obj_t obj_2472;
						    obj_2472 =
						       (obj_t) (new1477_2468);
						    (((obj_t) CREF(obj_2472))->header = MAKE_HEADER(arg1949_2469, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Cgen/cop.scm 1961 */
						 object_bglt aux_4364;
						 aux_4364 =
						    (object_bglt) (new1477_2468);
						 OBJECT_WIDENING_SET(aux_4364, BFALSE);
					      }
					      ((((catom_bglt) CREF(new1477_2468))->loc) = ((obj_t) arg1885_1144), BUNSPEC);
					      ((((catom_bglt) CREF(new1477_2468))->value) = ((obj_t) BUNSPEC), BUNSPEC);
					      res2559_2474 = new1477_2468;
					   }
					   arg1882_1141 = res2559_2474;
					}
				     }
				     {	/* Cgen/cgen.scm 221 */
					obj_t list1883_1142;
					{	/* Cgen/cgen.scm 221 */
					   obj_t arg1884_1143;
					   {	/* Cgen/cgen.scm 221 */
					      obj_t aux_4369;
					      aux_4369 =
						 (obj_t) (arg1882_1141);
					      arg1884_1143 =
						 MAKE_PAIR(aux_4369, BNIL);
					   }
					   list1883_1142 =
					      MAKE_PAIR(cop_1129, arg1884_1143);
					}
					arg1881_1140 = list1883_1142;
				     }
				  }
				  {	/* Cgen/cgen.scm 218 */
				     csequence_bglt res2560_2486;
				     {	/* ./Cgen/cop.scm 1975 */
					csequence_bglt new1503_2479;
					new1503_2479 =
					   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					{	/* ./Cgen/cop.scm 1975 */
					   long arg1940_2480;
					   arg1940_2480 =
					      class_num_218___object(csequence_cgen_cop);
					   {	/* ./Cgen/cop.scm 1975 */
					      obj_t obj_2484;
					      obj_2484 =
						 (obj_t) (new1503_2479);
					      (((obj_t) CREF(obj_2484))->header = MAKE_HEADER(arg1940_2480, 0), BUNSPEC);
					   }
					}
					{	/* ./Cgen/cop.scm 1975 */
					   object_bglt aux_4377;
					   aux_4377 =
					      (object_bglt) (new1503_2479);
					   OBJECT_WIDENING_SET(aux_4377, BFALSE);
					}
					((((csequence_bglt) CREF(new1503_2479))->loc) = ((obj_t) arg1879_1138), BUNSPEC);
					((((csequence_bglt) CREF(new1503_2479))->c_exp__163) = ((bool_t) ((bool_t) 1)), BUNSPEC);
					((((csequence_bglt) CREF(new1503_2479))->cops) = ((obj_t) arg1881_1140), BUNSPEC);
					res2560_2486 = new1503_2479;
				     }
				     arg1876_1135 =
					(obj_t) (res2560_2486);
				  }
			       }
			    }
			  else
			    {	/* Cgen/cgen.scm 217 */
			       arg1876_1135 = cop_1129;
			    }
		       }
		       {	/* Cgen/cgen.scm 214 */
			  csetq_bglt res2561_2497;
			  {	/* Cgen/cgen.scm 214 */
			     cop_bglt value_2489;
			     value_2489 =
				(cop_bglt) (arg1876_1135);
			     {	/* ./Cgen/cop.scm 1984 */
				csetq_bglt new1521_2490;
				new1521_2490 =
				   ((csetq_bglt) BREF(GC_MALLOC(sizeof(struct csetq))));
				{	/* ./Cgen/cop.scm 1984 */
				   long arg1934_2491;
				   arg1934_2491 =
				      class_num_218___object(csetq_cgen_cop);
				   {	/* ./Cgen/cop.scm 1984 */
				      obj_t obj_2495;
				      obj_2495 =
					 (obj_t) (new1521_2490);
				      (((obj_t) CREF(obj_2495))->header = MAKE_HEADER(arg1934_2491, 0), BUNSPEC);
				   }
				}
				{	/* ./Cgen/cop.scm 1984 */
				   object_bglt aux_4389;
				   aux_4389 =
				      (object_bglt) (new1521_2490);
				   OBJECT_WIDENING_SET(aux_4389, BFALSE);
				}
				((((csetq_bglt) CREF(new1521_2490))->loc) = ((obj_t) loc_4012), BUNSPEC);
				((((csetq_bglt) CREF(new1521_2490))->var) = ((varc_bglt) arg1875_1134), BUNSPEC);
				((((csetq_bglt) CREF(new1521_2490))->value) = ((cop_bglt) value_2489), BUNSPEC);
				res2561_2497 = new1521_2490;
			     }
			  }
			  arg1873_1132 = res2561_2497;
		       }
		    }
		    return
		       PROCEDURE_ENTRY(kont_4014) (kont_4014,
		       (obj_t) (arg1873_1132), BEOA);
		 }
	    }
	 }
      }
   }
}



/* bdb-let-var */
cop_bglt 
bdb_let_var_254_cgen_cgen(cop_bglt cop_56, obj_t loc_57)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 571 */
      {		/* Cgen/cgen.scm 572 */
	 bool_t test1887_1146;
	 {	/* Cgen/cgen.scm 572 */
	    bool_t test1890_1149;
	    {	/* Cgen/cgen.scm 572 */
	       long n1_2498;
	       n1_2498 =
		  (long) CINT(_bdb_debug__1_engine_param);
	       test1890_1149 =
		  (n1_2498 > ((long) 0));
	    }
	    if (test1890_1149)
	      {		/* Cgen/cgen.scm 572 */
		 if (
		    STRUCTP(loc_57))
		   {	/* ./Ieee/equiv.scm 5508 */
		      obj_t aux_4405;
		      obj_t aux_4403;
		      aux_4405 =
			 CNST_TABLE_REF(((long) 5));
		      aux_4403 =
			 STRUCT_KEY(loc_57);
		      test1887_1146 =
			 (aux_4403 == aux_4405);
		   }
		 else
		   {	/* ./Tools/location.sch 1077 */
		      test1887_1146 = ((bool_t) 0);
		   }
	      }
	    else
	      {		/* Cgen/cgen.scm 572 */
		 test1887_1146 = ((bool_t) 0);
	      }
	 }
	 if (test1887_1146)
	   {	/* Cgen/cgen.scm 573 */
	      bdb_block_21_bglt res2562_2516;
	      {		/* ./Cgen/cop.scm 2041 */
		 bdb_block_21_bglt new1632_2510;
		 new1632_2510 =
		    ((bdb_block_21_bglt) BREF(GC_MALLOC(sizeof(struct bdb_block_21))));
		 {	/* ./Cgen/cop.scm 2041 */
		    long arg1902_2511;
		    arg1902_2511 =
		       class_num_218___object(bdb_block_21_cgen_cop);
		    {	/* ./Cgen/cop.scm 2041 */
		       obj_t obj_2514;
		       obj_2514 =
			  (obj_t) (new1632_2510);
		       (((obj_t) CREF(obj_2514))->header = MAKE_HEADER(arg1902_2511, 0), BUNSPEC);
		    }
		 }
		 {	/* ./Cgen/cop.scm 2041 */
		    object_bglt aux_4413;
		    aux_4413 =
		       (object_bglt) (new1632_2510);
		    OBJECT_WIDENING_SET(aux_4413, BFALSE);
		 }
		 ((((bdb_block_21_bglt) CREF(new1632_2510))->loc) = ((obj_t) loc_57), BUNSPEC);
		 ((((bdb_block_21_bglt) CREF(new1632_2510))->body) = ((cop_bglt) cop_56), BUNSPEC);
		 res2562_2516 = new1632_2510;
	      }
	      return
		 (cop_bglt) (res2562_2516);
	   }
	 else
	   {	/* Cgen/cgen.scm 572 */
	      return cop_56;
	   }
      }
   }
}



/* _bdb-let-var2651 */
obj_t 
_bdb_let_var2651_33_cgen_cgen(obj_t env_4016, obj_t cop_4017, obj_t loc_4018)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 571 */
      {		/* Cgen/cgen.scm 571 */
	 cop_bglt aux_4419;
	 aux_4419 =
	    bdb_let_var_254_cgen_cgen(
	    (cop_bglt) (cop_4017), loc_4018);
	 return
	    (obj_t) (aux_4419);
      }
   }
}



/* node-setq */
setq_bglt 
node_setq_243_cgen_cgen(variable_bglt variable_68, node_bglt value_69)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 765 */
      {		/* Cgen/cgen.scm 767 */
	 obj_t arg1891_1150;
	 obj_t arg1892_1151;
	 var_bglt arg1893_1152;
	 arg1891_1150 =
	    (((node_bglt) CREF(value_69))->loc);
	 arg1892_1151 = _unspec__87_type_cache;
	 {	/* Cgen/cgen.scm 769 */
	    type_bglt arg1896_1155;
	    arg1896_1155 =
	       (((variable_bglt) CREF(variable_68))->type);
	    {	/* Cgen/cgen.scm 769 */
	       var_bglt res2563_2529;
	       {	/* Cgen/cgen.scm 769 */
		  obj_t loc_2519;
		  loc_2519 = BFALSE;
		  {	/* ./Ast/node.scm 1678 */
		     var_bglt new1210_2522;
		     new1210_2522 =
			((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
		     {	/* ./Ast/node.scm 1678 */
			long arg2003_2523;
			arg2003_2523 =
			   class_num_218___object(var_ast_node);
			{	/* ./Ast/node.scm 1678 */
			   obj_t obj_2527;
			   obj_2527 =
			      (obj_t) (new1210_2522);
			   (((obj_t) CREF(obj_2527))->header = MAKE_HEADER(arg2003_2523, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1678 */
			object_bglt aux_4429;
			aux_4429 =
			   (object_bglt) (new1210_2522);
			OBJECT_WIDENING_SET(aux_4429, loc_2519);
		     }
		     ((((var_bglt) CREF(new1210_2522))->loc) = ((obj_t) loc_2519), BUNSPEC);
		     ((((var_bglt) CREF(new1210_2522))->type) = ((type_bglt) arg1896_1155), BUNSPEC);
		     ((((var_bglt) CREF(new1210_2522))->variable) = ((variable_bglt) variable_68), BUNSPEC);
		     res2563_2529 = new1210_2522;
		  }
	       }
	       arg1893_1152 = res2563_2529;
	    }
	 }
	 {	/* Cgen/cgen.scm 766 */
	    setq_bglt res2564_2542;
	    {	/* Cgen/cgen.scm 766 */
	       type_bglt type_2531;
	       type_2531 =
		  (type_bglt) (arg1892_1151);
	       {	/* ./Ast/node.scm 1732 */
		  setq_bglt new1304_2534;
		  new1304_2534 =
		     ((setq_bglt) BREF(GC_MALLOC(sizeof(struct setq))));
		  {	/* ./Ast/node.scm 1732 */
		     long arg1985_2535;
		     arg1985_2535 =
			class_num_218___object(setq_ast_node);
		     {	/* ./Ast/node.scm 1732 */
			obj_t obj_2540;
			obj_2540 =
			   (obj_t) (new1304_2534);
			(((obj_t) CREF(obj_2540))->header = MAKE_HEADER(arg1985_2535, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Ast/node.scm 1732 */
		     object_bglt aux_4440;
		     aux_4440 =
			(object_bglt) (new1304_2534);
		     OBJECT_WIDENING_SET(aux_4440, BFALSE);
		  }
		  ((((setq_bglt) CREF(new1304_2534))->loc) = ((obj_t) arg1891_1150), BUNSPEC);
		  ((((setq_bglt) CREF(new1304_2534))->type) = ((type_bglt) type_2531), BUNSPEC);
		  ((((setq_bglt) CREF(new1304_2534))->var) = ((var_bglt) arg1893_1152), BUNSPEC);
		  ((((setq_bglt) CREF(new1304_2534))->value) = ((node_bglt) value_69), BUNSPEC);
		  res2564_2542 = new1304_2534;
	       }
	    }
	    return res2564_2542;
	 }
      }
   }
}



/* _node-setq2652 */
obj_t 
_node_setq2652_252_cgen_cgen(obj_t env_4019, obj_t variable_4020, obj_t value_4021)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 765 */
      {		/* Cgen/cgen.scm 765 */
	 setq_bglt aux_4447;
	 aux_4447 =
	    node_setq_243_cgen_cgen(
	    (variable_bglt) (variable_4020),
	    (node_bglt) (value_4021));
	 return
	    (obj_t) (aux_4447);
      }
   }
}



/* make-local-svar/name */
local_bglt 
make_local_svar_name_219_cgen_cgen(obj_t id_70, type_bglt type_71)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 778 */
      {		/* Cgen/cgen.scm 779 */
	 local_bglt local_1157;
	 local_1157 =
	    make_local_svar_140_ast_local(id_70, type_71);
	 {	/* Cgen/cgen.scm 780 */
	    bool_t test_4453;
	    {	/* ./Ieee/string.scm 8047 */
	       obj_t aux_4454;
	       aux_4454 =
		  (((local_bglt) CREF(local_1157))->name);
	       test_4453 =
		  STRINGP(aux_4454);
	    }
	    if (test_4453)
	      {		/* Cgen/cgen.scm 780 */
		 BUNSPEC;
	      }
	    else
	      {		/* Cgen/cgen.scm 780 */
		 FAILURE(string2665_cgen_cgen, string2666_cgen_cgen,
		    (obj_t) (local_1157));
	      }
	 }
	 return local_1157;
      }
   }
}



/* _make-local-svar/name2653 */
obj_t 
_make_local_svar_name2653_192_cgen_cgen(obj_t env_4022, obj_t id_4023, obj_t type_4024)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 778 */
      {		/* Cgen/cgen.scm 778 */
	 local_bglt aux_4459;
	 aux_4459 =
	    make_local_svar_name_219_cgen_cgen(id_4023,
	    (type_bglt) (type_4024));
	 return
	    (obj_t) (aux_4459);
      }
   }
}



/* no-bdb-newline */
obj_t 
no_bdb_newline_178_cgen_cgen()
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 789 */
      {		/* Cgen/cgen.scm 790 */
	 bool_t test1900_1160;
	 {	/* Cgen/cgen.scm 790 */
	    obj_t obj1_2548;
	    obj1_2548 = _bdb_debug__1_engine_param;
	    {	/* ./Ieee/equiv.scm 5508 */
	       obj_t aux_4463;
	       aux_4463 =
		  BINT(((long) 0));
	       test1900_1160 =
		  (obj1_2548 == aux_4463);
	    }
	 }
	 if (test1900_1160)
	   {	/* Cgen/cgen.scm 791 */
	      obj_t port_2550;
	      port_2550 = _c_port__188_cgen_emit;
	      {		/* ./Ieee/output.scm 9332 */
		 unsigned char aux_4467;
		 aux_4467 =
		    WRITE_CHAR(((unsigned char) '\n'), port_2550);
		 return
		    BCHAR(aux_4467);
	      }
	   }
	 else
	   {	/* Cgen/cgen.scm 790 */
	      return BUNSPEC;
	   }
      }
   }
}



/* method-init */
obj_t 
method_init_76_cgen_cgen()
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      add_generic__110___object(node__cop_env_160_cgen_cgen, node__cop_default1765_env_85_cgen_cgen);
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, atom_ast_node, ((long) 0));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, kwote_ast_node, ((long) 1));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, var_ast_node, ((long) 2));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, closure_ast_node, ((long) 3));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, sequence_ast_node, ((long) 4));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, pragma_ast_node, ((long) 5));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, cast_ast_node, ((long) 6));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, setq_ast_node, ((long) 7));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, conditional_ast_node, ((long) 8));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, fail_ast_node, ((long) 9));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, select_ast_node, ((long) 10));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, let_fun_218_ast_node, ((long) 11));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, let_var_6_ast_node, ((long) 12));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, set_ex_it_116_ast_node, ((long) 13));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, jump_ex_it_184_ast_node, ((long) 14));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, make_box_202_ast_node, ((long) 15));
      add_inlined_method__244___object(node__cop_env_160_cgen_cgen, box_ref_242_ast_node, ((long) 16));
      {		/* Cgen/cgen.scm 14 */
	 long aux_4488;
	 aux_4488 =
	    add_inlined_method__244___object(node__cop_env_160_cgen_cgen, box_set__221_ast_node, ((long) 17));
	 return
	    BINT(aux_4488);
      }
   }
}



/* node->cop */
cop_bglt 
node__cop_142_cgen_cgen(node_bglt node_26, obj_t kont_27)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 232 */
      {
	 obj_t method2035_1679;
	 obj_t class2040_1680;
	 {	/* Cgen/cgen.scm 232 */
	    obj_t arg2043_1677;
	    obj_t arg2044_1678;
	    {	/* Cgen/cgen.scm 232 */
	       object_bglt obj_2741;
	       obj_2741 =
		  (object_bglt) (node_26);
	       {	/* ./Llib/object.scm 2926 */
		  obj_t pre_method_105_2742;
		  pre_method_105_2742 =
		     PROCEDURE_REF(node__cop_env_160_cgen_cgen, ((long) 2));
		  if (
		     INTEGERP(pre_method_105_2742))
		    {	/* ./Llib/object.scm 2927 */
		       PROCEDURE_SET(node__cop_env_160_cgen_cgen, ((long) 2), BUNSPEC);
		       arg2043_1677 = pre_method_105_2742;
		    }
		  else
		    {	/* ./Llib/object.scm 2914 */
		       long obj_class_num_177_2747;
		       obj_class_num_177_2747 =
			  TYPE(obj_2741);
		       {	/* ./Llib/object.scm 2915 */
			  obj_t arg1176_2748;
			  arg1176_2748 =
			     PROCEDURE_REF(node__cop_env_160_cgen_cgen, ((long) 1));
			  {	/* ./Llib/object.scm 2738 */
			     long arg1177_2752;
			     {	/* ./Llib/object.scm 2738 */
				long arg1178_2753;
				arg1178_2753 =
				   OBJECT_TYPE;
				arg1177_2752 =
				   (obj_class_num_177_2747 - arg1178_2753);
			     }
			     arg2043_1677 =
				VECTOR_REF(arg1176_2748, arg1177_2752);
			  }
		       }
		    }
	       }
	    }
	    {	/* Cgen/cgen.scm 232 */
	       object_bglt object_2758;
	       object_2758 =
		  (object_bglt) (node_26);
	       {	/* ./Llib/object.scm 2695 */
		  long arg1179_2759;
		  {	/* ./Llib/object.scm 2695 */
		     long arg1180_2760;
		     long arg1181_2761;
		     arg1180_2760 =
			TYPE(object_2758);
		     arg1181_2761 =
			OBJECT_TYPE;
		     arg1179_2759 =
			(arg1180_2760 - arg1181_2761);
		  }
		  {	/* ./Llib/object.scm 2695 */
		     obj_t vector_2765;
		     vector_2765 = _classes__134___object;
		     arg2044_1678 =
			VECTOR_REF(vector_2765, arg1179_2759);
		  }
	       }
	    }
	    {	/* Cgen/cgen.scm 232 */
	       obj_t aux_4506;
	       method2035_1679 = arg2043_1677;
	       class2040_1680 = arg2044_1678;
	       {

		  if (
		     INTEGERP(method2035_1679))
		    {	/* Cgen/cgen.scm 232 */
		       switch (
			  (long) CINT(method2035_1679))
			 {
			 case ((long) 0):

			    {	/* Cgen/cgen.scm 232 */
			       atom_bglt node_1686;
			       node_1686 =
				  (atom_bglt) (node_26);
			       {	/* Cgen/cgen.scm 241 */
				  catom_bglt arg2047_1689;
				  {	/* Cgen/cgen.scm 241 */
				     obj_t arg2048_1690;
				     obj_t arg2049_1691;
				     arg2048_1690 =
					(((atom_bglt) CREF(node_1686))->loc);
				     arg2049_1691 =
					(((atom_bglt) CREF(node_1686))->value);
				     {	/* Cgen/cgen.scm 241 */
					catom_bglt res2565_2777;
					{	/* ./Cgen/cop.scm 1961 */
					   catom_bglt new1477_2771;
					   new1477_2771 =
					      ((catom_bglt) BREF(GC_MALLOC(sizeof(struct catom))));
					   {	/* ./Cgen/cop.scm 1961 */
					      long arg1949_2772;
					      arg1949_2772 =
						 class_num_218___object(catom_cgen_cop);
					      {		/* ./Cgen/cop.scm 1961 */
						 obj_t obj_2775;
						 obj_2775 =
						    (obj_t) (new1477_2771);
						 (((obj_t) CREF(obj_2775))->header = MAKE_HEADER(arg1949_2772, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1961 */
					      object_bglt aux_4516;
					      aux_4516 =
						 (object_bglt) (new1477_2771);
					      OBJECT_WIDENING_SET(aux_4516, BFALSE);
					   }
					   ((((catom_bglt) CREF(new1477_2771))->loc) = ((obj_t) arg2048_1690), BUNSPEC);
					   ((((catom_bglt) CREF(new1477_2771))->value) = ((obj_t) arg2049_1691), BUNSPEC);
					   res2565_2777 = new1477_2771;
					}
					arg2047_1689 = res2565_2777;
				     }
				  }
				  aux_4506 =
				     PROCEDURE_ENTRY(kont_27) (kont_27,
				     (obj_t) (arg2047_1689), BEOA);
			       }
			    }
			    break;
			 case ((long) 1):

			    {	/* Cgen/cgen.scm 251 */
			       obj_t arg2052_1696;
			       {	/* Cgen/cgen.scm 251 */
				  obj_t aux_4524;
				  {	/* Cgen/cgen.scm 251 */
				     kwote_bglt aux_4525;
				     aux_4525 =
					(kwote_bglt) (node_26);
				     aux_4524 =
					(obj_t) (aux_4525);
				  }
				  arg2052_1696 =
				     shape_tools_shape(aux_4524);
			       }
			       aux_4506 =
				  internal_error_43_tools_error(string2667_cgen_cgen, string2668_cgen_cgen, arg2052_1696);
			    }
			    break;
			 case ((long) 2):

			    {	/* Cgen/cgen.scm 232 */
			       var_bglt node_1697;
			       node_1697 =
				  (var_bglt) (node_26);
			       {	/* Cgen/cgen.scm 260 */
				  varc_bglt arg2053_1700;
				  {	/* Cgen/cgen.scm 260 */
				     obj_t arg2054_1701;
				     variable_bglt arg2055_1702;
				     arg2054_1701 =
					(((var_bglt) CREF(node_1697))->loc);
				     arg2055_1702 =
					(((var_bglt) CREF(node_1697))->variable);
				     {	/* Cgen/cgen.scm 260 */
					varc_bglt res2566_2788;
					{	/* ./Cgen/cop.scm 1964 */
					   varc_bglt new1483_2782;
					   new1483_2782 =
					      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
					   {	/* ./Cgen/cop.scm 1964 */
					      long arg1946_2783;
					      arg1946_2783 =
						 class_num_218___object(varc_cgen_cop);
					      {		/* ./Cgen/cop.scm 1964 */
						 obj_t obj_2786;
						 obj_2786 =
						    (obj_t) (new1483_2782);
						 (((obj_t) CREF(obj_2786))->header = MAKE_HEADER(arg1946_2783, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1964 */
					      object_bglt aux_4537;
					      aux_4537 =
						 (object_bglt) (new1483_2782);
					      OBJECT_WIDENING_SET(aux_4537, BFALSE);
					   }
					   ((((varc_bglt) CREF(new1483_2782))->loc) = ((obj_t) arg2054_1701), BUNSPEC);
					   ((((varc_bglt) CREF(new1483_2782))->variable) = ((variable_bglt) arg2055_1702), BUNSPEC);
					   res2566_2788 = new1483_2782;
					}
					arg2053_1700 = res2566_2788;
				     }
				  }
				  aux_4506 =
				     PROCEDURE_ENTRY(kont_27) (kont_27,
				     (obj_t) (arg2053_1700), BEOA);
			       }
			    }
			    break;
			 case ((long) 3):

			    {	/* Cgen/cgen.scm 270 */
			       obj_t arg2058_1707;
			       {	/* Cgen/cgen.scm 270 */
				  obj_t aux_4545;
				  {	/* Cgen/cgen.scm 270 */
				     closure_bglt aux_4546;
				     aux_4546 =
					(closure_bglt) (node_26);
				     aux_4545 =
					(obj_t) (aux_4546);
				  }
				  arg2058_1707 =
				     shape_tools_shape(aux_4545);
			       }
			       aux_4506 =
				  internal_error_43_tools_error(string2667_cgen_cgen, string2669_cgen_cgen, arg2058_1707);
			    }
			    break;
			 case ((long) 4):

			    {	/* Cgen/cgen.scm 232 */
			       sequence_bglt node_1708;
			       node_1708 =
				  (sequence_bglt) (node_26);
			       {	/* Cgen/cgen.scm 279 */
				  obj_t exp_1711;
				  exp_1711 =
				     (((sequence_bglt) CREF(node_1708))->nodes);
				  if (
				     NULLP(exp_1711))
				    {	/* Cgen/cgen.scm 281 */
				       {	/* Cgen/cgen.scm 282 */
					  nop_bglt arg2060_1713;
					  {	/* Cgen/cgen.scm 282 */
					     obj_t arg2061_1714;
					     arg2061_1714 =
						(((sequence_bglt) CREF(node_1708))->loc);
					     {	/* Cgen/cgen.scm 282 */
						nop_bglt res2567_2798;
						{	/* ./Cgen/cop.scm 1979 */
						   nop_bglt new1510_2793;
						   new1510_2793 =
						      ((nop_bglt) BREF(GC_MALLOC(sizeof(struct nop))));
						   {	/* ./Cgen/cop.scm 1979 */
						      long arg1938_2794;
						      arg1938_2794 =
							 class_num_218___object(nop_cgen_cop);
						      {		/* ./Cgen/cop.scm 1979 */
							 obj_t obj_2796;
							 obj_2796 =
							    (obj_t) (new1510_2793);
							 (((obj_t) CREF(obj_2796))->header = MAKE_HEADER(arg1938_2794, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Cgen/cop.scm 1979 */
						      object_bglt aux_4560;
						      aux_4560 =
							 (object_bglt) (new1510_2793);
						      OBJECT_WIDENING_SET(aux_4560, BFALSE);
						   }
						   ((((nop_bglt) CREF(new1510_2793))->loc) = ((obj_t) arg2061_1714), BUNSPEC);
						   res2567_2798 = new1510_2793;
						}
						arg2060_1713 = res2567_2798;
					     }
					  }
					  aux_4506 =
					     PROCEDURE_ENTRY(kont_27) (kont_27,
					     (obj_t) (arg2060_1713), BEOA);
				       }
				    }
				  else
				    {	/* Cgen/cgen.scm 284 */
				       bool_t test_4567;
				       {	/* ./Ieee/pair-list.scm 5912 */
					  obj_t aux_4568;
					  aux_4568 =
					     CDR(exp_1711);
					  test_4567 =
					     NULLP(aux_4568);
				       }
				       if (test_4567)
					 {	/* Cgen/cgen.scm 284 */
					    {	/* Cgen/cgen.scm 285 */
					       cop_bglt cop_1716;
					       {	/* Cgen/cgen.scm 285 */
						  node_bglt aux_4571;
						  {	/* Cgen/cgen.scm 285 */
						     obj_t aux_4572;
						     aux_4572 =
							CAR(exp_1711);
						     aux_4571 =
							(node_bglt) (aux_4572);
						  }
						  cop_1716 =
						     node__cop_142_cgen_cgen(aux_4571, kont_27);
					       }
					       {	/* Cgen/cgen.scm 286 */
						  stop_bglt res2568_2810;
						  {	/* Cgen/cgen.scm 286 */
						     obj_t loc_2802;
						     loc_2802 = BFALSE;
						     {	/* ./Cgen/cop.scm 1981 */
							stop_bglt new1515_2804;
							new1515_2804 =
							   ((stop_bglt) BREF(GC_MALLOC(sizeof(struct stop))));
							{	/* ./Cgen/cop.scm 1981 */
							   long arg1936_2805;
							   arg1936_2805 =
							      class_num_218___object(stop_cgen_cop);
							   {	/* ./Cgen/cop.scm 1981 */
							      obj_t obj_2808;
							      obj_2808 =
								 (obj_t) (new1515_2804);
							      (((obj_t) CREF(obj_2808))->header = MAKE_HEADER(arg1936_2805, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1981 */
							   object_bglt aux_4580;
							   aux_4580 =
							      (object_bglt) (new1515_2804);
							   OBJECT_WIDENING_SET(aux_4580, loc_2802);
							}
							((((stop_bglt) CREF(new1515_2804))->loc) = ((obj_t) loc_2802), BUNSPEC);
							((((stop_bglt) CREF(new1515_2804))->value) = ((cop_bglt) cop_1716), BUNSPEC);
							res2568_2810 = new1515_2804;
						     }
						  }
						  aux_4506 =
						     (obj_t) (res2568_2810);
					       }
					    }
					 }
				       else
					 {	/* Cgen/cgen.scm 284 */
					    {
					       obj_t exp_1719;
					       obj_t new_1720;
					       {	/* Cgen/cgen.scm 288 */
						  csequence_bglt aux_4586;
						  exp_1719 = exp_1711;
						  new_1720 = BNIL;
						loop_1721:
						  {	/* Cgen/cgen.scm 290 */
						     bool_t test_4587;
						     {	/* ./Ieee/pair-list.scm 5912 */
							obj_t aux_4588;
							aux_4588 =
							   CDR(exp_1719);
							test_4587 =
							   NULLP(aux_4588);
						     }
						     if (test_4587)
						       {	/* Cgen/cgen.scm 291 */
							  cop_bglt cop_1723;
							  {	/* Cgen/cgen.scm 291 */
							     node_bglt aux_4591;
							     {	/* Cgen/cgen.scm 291 */
								obj_t aux_4592;
								aux_4592 =
								   CAR(exp_1719);
								aux_4591 =
								   (node_bglt) (aux_4592);
							     }
							     cop_1723 =
								node__cop_142_cgen_cgen(aux_4591, kont_27);
							  }
							  {	/* Cgen/cgen.scm 293 */
							     obj_t arg2066_1724;
							     obj_t arg2067_1725;
							     arg2066_1724 =
								(((cop_bglt) CREF(cop_1723))->loc);
							     {	/* Cgen/cgen.scm 294 */
								obj_t arg2068_1726;
								{	/* ./Ieee/pair-list.scm 5689 */
								   obj_t aux_4597;
								   aux_4597 =
								      (obj_t) (cop_1723);
								   arg2068_1726 =
								      MAKE_PAIR(aux_4597, new_1720);
								}
								arg2067_1725 =
								   reverse__39___r4_pairs_and_lists_6_3(arg2068_1726);
							     }
							     {	/* Cgen/cgen.scm 292 */
								csequence_bglt res2569_2827;
								{	/* ./Cgen/cop.scm 1975 */
								   csequence_bglt new1503_2820;
								   new1503_2820 =
								      ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
								   {	/* ./Cgen/cop.scm 1975 */
								      long arg1940_2821;
								      arg1940_2821 =
									 class_num_218___object(csequence_cgen_cop);
								      {		/* ./Cgen/cop.scm 1975 */
									 obj_t obj_2825;
									 obj_2825 =
									    (obj_t) (new1503_2820);
									 (((obj_t) CREF(obj_2825))->header = MAKE_HEADER(arg1940_2821, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Cgen/cop.scm 1975 */
								      object_bglt aux_4605;
								      aux_4605 =
									 (object_bglt) (new1503_2820);
								      OBJECT_WIDENING_SET(aux_4605, BFALSE);
								   }
								   ((((csequence_bglt) CREF(new1503_2820))->loc) = ((obj_t) arg2066_1724), BUNSPEC);
								   ((((csequence_bglt) CREF(new1503_2820))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
								   ((((csequence_bglt) CREF(new1503_2820))->cops) = ((obj_t) arg2067_1725), BUNSPEC);
								   res2569_2827 = new1503_2820;
								}
								aux_4586 = res2569_2827;
							     }
							  }
						       }
						     else
						       {	/* Cgen/cgen.scm 290 */
							  {	/* Cgen/cgen.scm 296 */
							     bool_t test2070_1728;
							     {	/* Cgen/cgen.scm 296 */
								node_bglt aux_4611;
								{	/* Cgen/cgen.scm 296 */
								   obj_t aux_4612;
								   aux_4612 =
								      CAR(exp_1719);
								   aux_4611 =
								      (node_bglt) (aux_4612);
								}
								test2070_1728 =
								   side_effect__165_effect_effect(aux_4611);
							     }
							     if (test2070_1728)
							       {	/* Cgen/cgen.scm 298 */
								  obj_t arg2071_1729;
								  obj_t arg2072_1730;
								  arg2071_1729 =
								     CDR(exp_1719);
								  {	/* Cgen/cgen.scm 299 */
								     cop_bglt arg2073_1731;
								     {	/* Cgen/cgen.scm 299 */
									node_bglt aux_4618;
									{	/* Cgen/cgen.scm 299 */
									   obj_t aux_4619;
									   aux_4619 =
									      CAR(exp_1719);
									   aux_4618 =
									      (node_bglt) (aux_4619);
									}
									arg2073_1731 =
									   node__cop_142_cgen_cgen(aux_4618, _stop_kont__121_cgen_cgen);
								     }
								     {	/* ./Ieee/pair-list.scm 5689 */
									obj_t aux_4623;
									aux_4623 =
									   (obj_t) (arg2073_1731);
									arg2072_1730 =
									   MAKE_PAIR(aux_4623, new_1720);
								     }
								  }
								  {
								     obj_t new_4627;
								     obj_t exp_4626;
								     exp_4626 = arg2071_1729;
								     new_4627 = arg2072_1730;
								     new_1720 = new_4627;
								     exp_1719 = exp_4626;
								     goto loop_1721;
								  }
							       }
							     else
							       {
								  obj_t exp_4628;
								  exp_4628 =
								     CDR(exp_1719);
								  exp_1719 = exp_4628;
								  goto loop_1721;
							       }
							  }
						       }
						  }
						  aux_4506 =
						     (obj_t) (aux_4586);
					       }
					    }
					 }
				    }
			       }
			    }
			    break;
			 case ((long) 5):

			    {	/* Cgen/cgen.scm 232 */
			       pragma_bglt node_1737;
			       node_1737 =
				  (pragma_bglt) (node_26);
			       {
				  obj_t old_actuals_174_1740;
				  obj_t new_actuals_73_1741;
				  local_bglt aux_1742;
				  obj_t auxs_1743;
				  obj_t exps_1744;
				  {	/* Cgen/cgen.scm 309 */
				     obj_t arg2080_1746;
				     local_bglt arg2082_1748;
				     arg2080_1746 =
					(((pragma_bglt) CREF(node_1737))->args);
				     arg2082_1748 =
					make_local_svar_name_219_cgen_cgen(
					CNST_TABLE_REF(((long) 6)),
					(type_bglt) (_obj__252_type_cache));
				     old_actuals_174_1740 = arg2080_1746;
				     new_actuals_73_1741 = BNIL;
				     aux_1742 = arg2082_1748;
				     auxs_1743 = BNIL;
				     exps_1744 = BNIL;
				   loop_1745:
				     if (
					NULLP(old_actuals_174_1740))
				       {	/* Cgen/cgen.scm 314 */
					  if (
					     NULLP(auxs_1743))
					    {	/* Cgen/cgen.scm 316 */
					       cpragma_bglt arg2087_1753;
					       {	/* Cgen/cgen.scm 316 */
						  obj_t arg2088_1754;
						  obj_t arg2090_1755;
						  obj_t arg2091_1756;
						  arg2088_1754 =
						     (((pragma_bglt) CREF(node_1737))->loc);
						  arg2090_1755 =
						     (((pragma_bglt) CREF(node_1737))->format);
						  arg2091_1756 =
						     reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1741);
						  {	/* Cgen/cgen.scm 316 */
						     cpragma_bglt res2570_2849;
						     {	/* ./Cgen/cop.scm 1967 */
							cpragma_bglt new1489_2842;
							new1489_2842 =
							   ((cpragma_bglt) BREF(GC_MALLOC(sizeof(struct cpragma))));
							{	/* ./Cgen/cop.scm 1967 */
							   long arg1944_2843;
							   arg1944_2843 =
							      class_num_218___object(cpragma_cgen_cop);
							   {	/* ./Cgen/cop.scm 1967 */
							      obj_t obj_2847;
							      obj_2847 =
								 (obj_t) (new1489_2842);
							      (((obj_t) CREF(obj_2847))->header = MAKE_HEADER(arg1944_2843, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1967 */
							   object_bglt aux_4647;
							   aux_4647 =
							      (object_bglt) (new1489_2842);
							   OBJECT_WIDENING_SET(aux_4647, BFALSE);
							}
							((((cpragma_bglt) CREF(new1489_2842))->loc) = ((obj_t) arg2088_1754), BUNSPEC);
							((((cpragma_bglt) CREF(new1489_2842))->format) = ((obj_t) arg2090_1755), BUNSPEC);
							((((cpragma_bglt) CREF(new1489_2842))->args) = ((obj_t) arg2091_1756), BUNSPEC);
							res2570_2849 = new1489_2842;
						     }
						     arg2087_1753 = res2570_2849;
						  }
					       }
					       aux_4506 =
						  PROCEDURE_ENTRY(kont_27) (kont_27,
						  (obj_t) (arg2087_1753), BEOA);
					    }
					  else
					    {	/* Cgen/cgen.scm 321 */
					       csequence_bglt arg2092_1757;
					       {	/* Cgen/cgen.scm 321 */
						  obj_t arg2093_1758;
						  obj_t arg2094_1759;
						  arg2093_1758 =
						     (((pragma_bglt) CREF(node_1737))->loc);
						  {	/* Cgen/cgen.scm 325 */
						     local_var_164_bglt arg2095_1760;
						     csequence_bglt arg2096_1761;
						     obj_t arg2098_1762;
						     {	/* Cgen/cgen.scm 325 */
							obj_t arg2103_1766;
							arg2103_1766 =
							   (((pragma_bglt) CREF(node_1737))->loc);
							{	/* Cgen/cgen.scm 325 */
							   local_var_164_bglt res2571_2860;
							   {	/* ./Cgen/cop.scm 1993 */
							      local_var_164_bglt new1536_2854;
							      new1536_2854 =
								 ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							      {		/* ./Cgen/cop.scm 1993 */
								 long arg1930_2855;
								 arg1930_2855 =
								    class_num_218___object(local_var_164_cgen_cop);
								 {	/* ./Cgen/cop.scm 1993 */
								    obj_t obj_2858;
								    obj_2858 =
								       (obj_t) (new1536_2854);
								    (((obj_t) CREF(obj_2858))->header = MAKE_HEADER(arg1930_2855, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Cgen/cop.scm 1993 */
								 object_bglt aux_4662;
								 aux_4662 =
								    (object_bglt) (new1536_2854);
								 OBJECT_WIDENING_SET(aux_4662, BFALSE);
							      }
							      ((((local_var_164_bglt) CREF(new1536_2854))->loc) = ((obj_t) arg2103_1766), BUNSPEC);
							      ((((local_var_164_bglt) CREF(new1536_2854))->vars) = ((obj_t) auxs_1743), BUNSPEC);
							      res2571_2860 = new1536_2854;
							   }
							   arg2095_1760 = res2571_2860;
							}
						     }
						     {	/* Cgen/cgen.scm 328 */
							csequence_bglt res2572_2871;
							{	/* Cgen/cgen.scm 328 */
							   obj_t loc_2861;
							   loc_2861 = BFALSE;
							   {	/* ./Cgen/cop.scm 1975 */
							      csequence_bglt new1503_2864;
							      new1503_2864 =
								 ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							      {		/* ./Cgen/cop.scm 1975 */
								 long arg1940_2865;
								 arg1940_2865 =
								    class_num_218___object(csequence_cgen_cop);
								 {	/* ./Cgen/cop.scm 1975 */
								    obj_t obj_2869;
								    obj_2869 =
								       (obj_t) (new1503_2864);
								    (((obj_t) CREF(obj_2869))->header = MAKE_HEADER(arg1940_2865, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Cgen/cop.scm 1975 */
								 object_bglt aux_4671;
								 aux_4671 =
								    (object_bglt) (new1503_2864);
								 OBJECT_WIDENING_SET(aux_4671, loc_2861);
							      }
							      ((((csequence_bglt) CREF(new1503_2864))->loc) = ((obj_t) loc_2861), BUNSPEC);
							      ((((csequence_bglt) CREF(new1503_2864))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      ((((csequence_bglt) CREF(new1503_2864))->cops) = ((obj_t) exps_1744), BUNSPEC);
							      res2572_2871 = new1503_2864;
							   }
							}
							arg2096_1761 = res2572_2871;
						     }
						     {	/* Cgen/cgen.scm 329 */
							cpragma_bglt arg2106_1769;
							{	/* Cgen/cgen.scm 329 */
							   obj_t arg2107_1770;
							   obj_t arg2108_1771;
							   obj_t arg2109_1772;
							   arg2107_1770 =
							      (((pragma_bglt) CREF(node_1737))->loc);
							   arg2108_1771 =
							      (((pragma_bglt) CREF(node_1737))->format);
							   arg2109_1772 =
							      reverse__39___r4_pairs_and_lists_6_3(new_actuals_73_1741);
							   {	/* Cgen/cgen.scm 329 */
							      cpragma_bglt res2573_2884;
							      {		/* ./Cgen/cop.scm 1967 */
								 cpragma_bglt new1489_2877;
								 new1489_2877 =
								    ((cpragma_bglt) BREF(GC_MALLOC(sizeof(struct cpragma))));
								 {	/* ./Cgen/cop.scm 1967 */
								    long arg1944_2878;
								    arg1944_2878 =
								       class_num_218___object(cpragma_cgen_cop);
								    {	/* ./Cgen/cop.scm 1967 */
								       obj_t obj_2882;
								       obj_2882 =
									  (obj_t) (new1489_2877);
								       (((obj_t) CREF(obj_2882))->header = MAKE_HEADER(arg1944_2878, 0), BUNSPEC);
								    }
								 }
								 {	/* ./Cgen/cop.scm 1967 */
								    object_bglt aux_4684;
								    aux_4684 =
								       (object_bglt) (new1489_2877);
								    OBJECT_WIDENING_SET(aux_4684, BFALSE);
								 }
								 ((((cpragma_bglt) CREF(new1489_2877))->loc) = ((obj_t) arg2107_1770), BUNSPEC);
								 ((((cpragma_bglt) CREF(new1489_2877))->format) = ((obj_t) arg2108_1771), BUNSPEC);
								 ((((cpragma_bglt) CREF(new1489_2877))->args) = ((obj_t) arg2109_1772), BUNSPEC);
								 res2573_2884 = new1489_2877;
							      }
							      arg2106_1769 = res2573_2884;
							   }
							}
							arg2098_1762 =
							   PROCEDURE_ENTRY(kont_27) (kont_27,
							   (obj_t) (arg2106_1769), BEOA);
						     }
						     {	/* Cgen/cgen.scm 323 */
							obj_t list2099_1763;
							{	/* Cgen/cgen.scm 323 */
							   obj_t arg2100_1764;
							   {	/* Cgen/cgen.scm 323 */
							      obj_t arg2101_1765;
							      arg2101_1765 =
								 MAKE_PAIR(arg2098_1762, BNIL);
							      {		/* Cgen/cgen.scm 323 */
								 obj_t aux_4694;
								 aux_4694 =
								    (obj_t) (arg2096_1761);
								 arg2100_1764 =
								    MAKE_PAIR(aux_4694, arg2101_1765);
							      }
							   }
							   {	/* Cgen/cgen.scm 323 */
							      obj_t aux_4697;
							      aux_4697 =
								 (obj_t) (arg2095_1760);
							      list2099_1763 =
								 MAKE_PAIR(aux_4697, arg2100_1764);
							   }
							}
							arg2094_1759 = list2099_1763;
						     }
						  }
						  {	/* Cgen/cgen.scm 321 */
						     csequence_bglt res2574_2896;
						     {	/* ./Cgen/cop.scm 1975 */
							csequence_bglt new1503_2889;
							new1503_2889 =
							   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							{	/* ./Cgen/cop.scm 1975 */
							   long arg1940_2890;
							   arg1940_2890 =
							      class_num_218___object(csequence_cgen_cop);
							   {	/* ./Cgen/cop.scm 1975 */
							      obj_t obj_2894;
							      obj_2894 =
								 (obj_t) (new1503_2889);
							      (((obj_t) CREF(obj_2894))->header = MAKE_HEADER(arg1940_2890, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1975 */
							   object_bglt aux_4704;
							   aux_4704 =
							      (object_bglt) (new1503_2889);
							   OBJECT_WIDENING_SET(aux_4704, BFALSE);
							}
							((((csequence_bglt) CREF(new1503_2889))->loc) = ((obj_t) arg2093_1758), BUNSPEC);
							((((csequence_bglt) CREF(new1503_2889))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							((((csequence_bglt) CREF(new1503_2889))->cops) = ((obj_t) arg2094_1759), BUNSPEC);
							res2574_2896 = new1503_2889;
						     }
						     arg2092_1757 = res2574_2896;
						  }
					       }
					       {	/* Cgen/cgen.scm 320 */
						  block_bglt res2575_2905;
						  {	/* Cgen/cgen.scm 320 */
						     obj_t loc_2897;
						     cop_bglt body_2898;
						     loc_2897 = BFALSE;
						     body_2898 =
							(cop_bglt) (arg2092_1757);
						     {	/* ./Cgen/cop.scm 1952 */
							block_bglt new1459_2899;
							new1459_2899 =
							   ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							{	/* ./Cgen/cop.scm 1952 */
							   long arg1955_2900;
							   arg1955_2900 =
							      class_num_218___object(block_cgen_cop);
							   {	/* ./Cgen/cop.scm 1952 */
							      obj_t obj_2903;
							      obj_2903 =
								 (obj_t) (new1459_2899);
							      (((obj_t) CREF(obj_2903))->header = MAKE_HEADER(arg1955_2900, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1952 */
							   object_bglt aux_4715;
							   aux_4715 =
							      (object_bglt) (new1459_2899);
							   OBJECT_WIDENING_SET(aux_4715, loc_2897);
							}
							((((block_bglt) CREF(new1459_2899))->loc) = ((obj_t) loc_2897), BUNSPEC);
							((((block_bglt) CREF(new1459_2899))->body) = ((cop_bglt) body_2898), BUNSPEC);
							res2575_2905 = new1459_2899;
						     }
						  }
						  aux_4506 =
						     (obj_t) (res2575_2905);
					       }
					    }
				       }
				     else
				       {	/* Cgen/cgen.scm 333 */
					  cop_bglt cop_1773;
					  {	/* Cgen/cgen.scm 333 */
					     setq_bglt arg2133_1797;
					     {	/* Cgen/cgen.scm 333 */
						node_bglt aux_4721;
						{	/* Cgen/cgen.scm 333 */
						   obj_t aux_4723;
						   aux_4723 =
						      CAR(old_actuals_174_1740);
						   aux_4721 =
						      (node_bglt) (aux_4723);
						}
						arg2133_1797 =
						   node_setq_243_cgen_cgen(
						   (variable_bglt) (aux_1742), aux_4721);
					     }
					     cop_1773 =
						node__cop_142_cgen_cgen(
						(node_bglt) (arg2133_1797), _id_kont__126_cgen_cgen);
					  }
					  {	/* Cgen/cgen.scm 335 */
					     bool_t test2110_1774;
					     {	/* Cgen/cgen.scm 335 */
						bool_t test2125_1788;
						test2125_1788 =
						   is_a__118___object(
						   (obj_t) (cop_1773), csetq_cgen_cop);
						if (test2125_1788)
						  {	/* Cgen/cgen.scm 336 */
						     bool_t test_4732;
						     {	/* ./Ieee/equiv.scm 5508 */
							obj_t aux_4739;
							obj_t aux_4733;
							aux_4739 =
							   (obj_t) (aux_1742);
							{	/* Cgen/cgen.scm 336 */
							   variable_bglt aux_4734;
							   {	/* Cgen/cgen.scm 336 */
							      varc_bglt arg2132_1796;
							      {		/* Cgen/cgen.scm 336 */
								 csetq_bglt obj_2908;
								 obj_2908 =
								    (csetq_bglt) (cop_1773);
								 arg2132_1796 =
								    (((csetq_bglt) CREF(obj_2908))->var);
							      }
							      aux_4734 =
								 (((varc_bglt) CREF(arg2132_1796))->variable);
							   }
							   aux_4733 =
							      (obj_t) (aux_4734);
							}
							test_4732 =
							   (aux_4733 == aux_4739);
						     }
						     if (test_4732)
						       {	/* Cgen/cgen.scm 337 */
							  bool_t _ortest_1668_1790;
							  {	/* ./Cgen/cop.scm 1961 */
							     obj_t aux_4742;
							     {	/* Cgen/cgen.scm 337 */
								cop_bglt aux_4743;
								{	/* Cgen/cgen.scm 337 */
								   csetq_bglt obj_2912;
								   obj_2912 =
								      (csetq_bglt) (cop_1773);
								   aux_4743 =
								      (((csetq_bglt) CREF(obj_2912))->value);
								}
								aux_4742 =
								   (obj_t) (aux_4743);
							     }
							     _ortest_1668_1790 =
								is_a__118___object(aux_4742, catom_cgen_cop);
							  }
							  if (_ortest_1668_1790)
							    {	/* Cgen/cgen.scm 337 */
							       test2110_1774 = _ortest_1668_1790;
							    }
							  else
							    {	/* Cgen/cgen.scm 338 */
							       bool_t _ortest_1669_1791;
							       {	/* ./Cgen/cop.scm 1964 */
								  obj_t aux_4749;
								  {	/* Cgen/cgen.scm 338 */
								     cop_bglt aux_4750;
								     {	/* Cgen/cgen.scm 338 */
									csetq_bglt obj_2914;
									obj_2914 =
									   (csetq_bglt) (cop_1773);
									aux_4750 =
									   (((csetq_bglt) CREF(obj_2914))->value);
								     }
								     aux_4749 =
									(obj_t) (aux_4750);
								  }
								  _ortest_1669_1791 =
								     is_a__118___object(aux_4749, varc_cgen_cop);
							       }
							       if (_ortest_1669_1791)
								 {	/* Cgen/cgen.scm 338 */
								    test2110_1774 = _ortest_1669_1791;
								 }
							       else
								 {	/* ./Cgen/cop.scm 1967 */
								    obj_t aux_4756;
								    {	/* Cgen/cgen.scm 339 */
								       cop_bglt aux_4757;
								       {	/* Cgen/cgen.scm 339 */
									  csetq_bglt obj_2916;
									  obj_2916 =
									     (csetq_bglt) (cop_1773);
									  aux_4757 =
									     (((csetq_bglt) CREF(obj_2916))->value);
								       }
								       aux_4756 =
									  (obj_t) (aux_4757);
								    }
								    test2110_1774 =
								       is_a__118___object(aux_4756, cpragma_cgen_cop);
								 }
							    }
						       }
						     else
						       {	/* Cgen/cgen.scm 336 */
							  test2110_1774 = ((bool_t) 0);
						       }
						  }
						else
						  {	/* Cgen/cgen.scm 335 */
						     test2110_1774 = ((bool_t) 0);
						  }
					     }
					     if (test2110_1774)
					       {	/* Cgen/cgen.scm 340 */
						  obj_t arg2111_1775;
						  obj_t arg2112_1776;
						  arg2111_1775 =
						     CDR(old_actuals_174_1740);
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_4764;
						     {	/* Cgen/cgen.scm 341 */
							cop_bglt aux_4765;
							{	/* Cgen/cgen.scm 341 */
							   csetq_bglt obj_2919;
							   obj_2919 =
							      (csetq_bglt) (cop_1773);
							   aux_4765 =
							      (((csetq_bglt) CREF(obj_2919))->value);
							}
							aux_4764 =
							   (obj_t) (aux_4765);
						     }
						     arg2112_1776 =
							MAKE_PAIR(aux_4764, new_actuals_73_1741);
						  }
						  {
						     obj_t new_actuals_73_4771;
						     obj_t old_actuals_174_4770;
						     old_actuals_174_4770 = arg2111_1775;
						     new_actuals_73_4771 = arg2112_1776;
						     new_actuals_73_1741 = new_actuals_73_4771;
						     old_actuals_174_1740 = old_actuals_174_4770;
						     goto loop_1745;
						  }
					       }
					     else
					       {	/* Cgen/cgen.scm 335 */
						  {	/* Cgen/cgen.scm 346 */
						     type_bglt arg2114_1778;
						     {	/* Cgen/cgen.scm 346 */
							node_bglt aux_4772;
							{	/* Cgen/cgen.scm 346 */
							   obj_t aux_4773;
							   aux_4773 =
							      CAR(old_actuals_174_1740);
							   aux_4772 =
							      (node_bglt) (aux_4773);
							}
							arg2114_1778 =
							   typeof_coerce_typeof(aux_4772);
						     }
						     ((((local_bglt) CREF(aux_1742))->type) = ((type_bglt) arg2114_1778), BUNSPEC);
						  }
						  {	/* Cgen/cgen.scm 347 */
						     obj_t arg2116_1780;
						     obj_t arg2117_1781;
						     local_bglt arg2118_1782;
						     obj_t arg2119_1783;
						     obj_t arg2120_1784;
						     arg2116_1780 =
							CDR(old_actuals_174_1740);
						     {	/* Cgen/cgen.scm 348 */
							varc_bglt arg2122_1785;
							{	/* Cgen/cgen.scm 348 */
							   obj_t arg2123_1786;
							   arg2123_1786 =
							      (((pragma_bglt) CREF(node_1737))->loc);
							   {	/* Cgen/cgen.scm 348 */
							      varc_bglt res2576_2935;
							      {		/* Cgen/cgen.scm 348 */
								 variable_bglt variable_2928;
								 variable_2928 =
								    (variable_bglt) (aux_1742);
								 {	/* ./Cgen/cop.scm 1964 */
								    varc_bglt new1483_2929;
								    new1483_2929 =
								       ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
								    {	/* ./Cgen/cop.scm 1964 */
								       long arg1946_2930;
								       arg1946_2930 =
									  class_num_218___object(varc_cgen_cop);
								       {	/* ./Cgen/cop.scm 1964 */
									  obj_t obj_2933;
									  obj_2933 =
									     (obj_t) (new1483_2929);
									  (((obj_t) CREF(obj_2933))->header = MAKE_HEADER(arg1946_2930, 0), BUNSPEC);
								       }
								    }
								    {	/* ./Cgen/cop.scm 1964 */
								       object_bglt aux_4785;
								       aux_4785 =
									  (object_bglt) (new1483_2929);
								       OBJECT_WIDENING_SET(aux_4785, BFALSE);
								    }
								    ((((varc_bglt) CREF(new1483_2929))->loc) = ((obj_t) arg2123_1786), BUNSPEC);
								    ((((varc_bglt) CREF(new1483_2929))->variable) = ((variable_bglt) variable_2928), BUNSPEC);
								    res2576_2935 = new1483_2929;
								 }
							      }
							      arg2122_1785 = res2576_2935;
							   }
							}
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_4790;
							   aux_4790 =
							      (obj_t) (arg2122_1785);
							   arg2117_1781 =
							      MAKE_PAIR(aux_4790, new_actuals_73_1741);
							}
						     }
						     arg2118_1782 =
							make_local_svar_name_219_cgen_cgen(
							CNST_TABLE_REF(((long) 6)),
							(type_bglt) (_obj__252_type_cache));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_4796;
							aux_4796 =
							   (obj_t) (aux_1742);
							arg2119_1783 =
							   MAKE_PAIR(aux_4796, auxs_1743);
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_4799;
							aux_4799 =
							   (obj_t) (cop_1773);
							arg2120_1784 =
							   MAKE_PAIR(aux_4799, exps_1744);
						     }
						     {
							obj_t exps_4806;
							obj_t auxs_4805;
							local_bglt aux_4804;
							obj_t new_actuals_73_4803;
							obj_t old_actuals_174_4802;
							old_actuals_174_4802 = arg2116_1780;
							new_actuals_73_4803 = arg2117_1781;
							aux_4804 = arg2118_1782;
							auxs_4805 = arg2119_1783;
							exps_4806 = arg2120_1784;
							exps_1744 = exps_4806;
							auxs_1743 = auxs_4805;
							aux_1742 = aux_4804;
							new_actuals_73_1741 = new_actuals_73_4803;
							old_actuals_174_1740 = old_actuals_174_4802;
							goto loop_1745;
						     }
						  }
					       }
					  }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 6):

			    {	/* Cgen/cgen.scm 232 */
			       cast_bglt node_1799;
			       node_1799 =
				  (cast_bglt) (node_26);
			       {	/* Cgen/cgen.scm 363 */
				  ccast_bglt arg2135_1802;
				  {	/* Cgen/cgen.scm 363 */
				     obj_t arg2136_1803;
				     type_bglt arg2137_1804;
				     cop_bglt arg2138_1805;
				     arg2136_1803 =
					(((cast_bglt) CREF(node_1799))->loc);
				     arg2137_1804 =
					(((cast_bglt) CREF(node_1799))->type);
				     arg2138_1805 =
					node__cop_142_cgen_cgen(
					(((cast_bglt) CREF(node_1799))->arg), _id_kont__126_cgen_cgen);
				     {	/* Cgen/cgen.scm 363 */
					ccast_bglt res2577_2955;
					{	/* ./Cgen/cop.scm 1971 */
					   ccast_bglt new1496_2948;
					   new1496_2948 =
					      ((ccast_bglt) BREF(GC_MALLOC(sizeof(struct ccast))));
					   {	/* ./Cgen/cop.scm 1971 */
					      long arg1942_2949;
					      arg1942_2949 =
						 class_num_218___object(ccast_cgen_cop);
					      {		/* ./Cgen/cop.scm 1971 */
						 obj_t obj_2953;
						 obj_2953 =
						    (obj_t) (new1496_2948);
						 (((obj_t) CREF(obj_2953))->header = MAKE_HEADER(arg1942_2949, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1971 */
					      object_bglt aux_4816;
					      aux_4816 =
						 (object_bglt) (new1496_2948);
					      OBJECT_WIDENING_SET(aux_4816, BFALSE);
					   }
					   ((((ccast_bglt) CREF(new1496_2948))->loc) = ((obj_t) arg2136_1803), BUNSPEC);
					   ((((ccast_bglt) CREF(new1496_2948))->type) = ((type_bglt) arg2137_1804), BUNSPEC);
					   ((((ccast_bglt) CREF(new1496_2948))->arg) = ((cop_bglt) arg2138_1805), BUNSPEC);
					   res2577_2955 = new1496_2948;
					}
					arg2135_1802 = res2577_2955;
				     }
				  }
				  aux_4506 =
				     PROCEDURE_ENTRY(kont_27) (kont_27,
				     (obj_t) (arg2135_1802), BEOA);
			       }
			    }
			    break;
			 case ((long) 7):

			    {	/* Cgen/cgen.scm 232 */
			       setq_bglt node_1807;
			       node_1807 =
				  (setq_bglt) (node_26);
			       {	/* Cgen/cgen.scm 375 */
				  variable_bglt var_1810;
				  {	/* Cgen/cgen.scm 375 */
				     var_bglt arg2156_1823;
				     arg2156_1823 =
					(((setq_bglt) CREF(node_1807))->var);
				     var_1810 =
					(((var_bglt) CREF(arg2156_1823))->variable);
				  }
				  {	/* Cgen/cgen.scm 376 */
				     bool_t test2140_1811;
				     {	/* Cgen/cgen.scm 376 */
					bool_t test2151_1819;
					{	/* ./Ast/node.scm 1678 */
					   obj_t aux_4828;
					   {	/* Cgen/cgen.scm 376 */
					      node_bglt aux_4829;
					      aux_4829 =
						 (((setq_bglt) CREF(node_1807))->value);
					      aux_4828 =
						 (obj_t) (aux_4829);
					   }
					   test2151_1819 =
					      is_a__118___object(aux_4828, var_ast_node);
					}
					if (test2151_1819)
					  {	/* ./Ieee/equiv.scm 5508 */
					     obj_t aux_4836;
					     obj_t aux_4834;
					     {	/* Cgen/cgen.scm 376 */
						variable_bglt aux_4837;
						{	/* Cgen/cgen.scm 376 */
						   var_bglt obj_2961;
						   {	/* Cgen/cgen.scm 376 */
						      node_bglt aux_4838;
						      aux_4838 =
							 (((setq_bglt) CREF(node_1807))->value);
						      obj_2961 =
							 (var_bglt) (aux_4838);
						   }
						   aux_4837 =
						      (((var_bglt) CREF(obj_2961))->variable);
						}
						aux_4836 =
						   (obj_t) (aux_4837);
					     }
					     aux_4834 =
						(obj_t) (var_1810);
					     test2140_1811 =
						(aux_4834 == aux_4836);
					  }
					else
					  {	/* Cgen/cgen.scm 376 */
					     test2140_1811 = ((bool_t) 0);
					  }
				     }
				     if (test2140_1811)
				       {	/* Cgen/cgen.scm 377 */
					  cvoid_bglt arg2141_1812;
					  {	/* Cgen/cgen.scm 377 */
					     catom_bglt arg2144_1813;
					     {	/* Cgen/cgen.scm 377 */
						obj_t arg2145_1814;
						arg2145_1814 =
						   (((setq_bglt) CREF(node_1807))->loc);
						{	/* Cgen/cgen.scm 377 */
						   catom_bglt res2578_2973;
						   {	/* ./Cgen/cop.scm 1961 */
						      catom_bglt new1477_2967;
						      new1477_2967 =
							 ((catom_bglt) BREF(GC_MALLOC(sizeof(struct catom))));
						      {		/* ./Cgen/cop.scm 1961 */
							 long arg1949_2968;
							 arg1949_2968 =
							    class_num_218___object(catom_cgen_cop);
							 {	/* ./Cgen/cop.scm 1961 */
							    obj_t obj_2971;
							    obj_2971 =
							       (obj_t) (new1477_2967);
							    (((obj_t) CREF(obj_2971))->header = MAKE_HEADER(arg1949_2968, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Cgen/cop.scm 1961 */
							 object_bglt aux_4850;
							 aux_4850 =
							    (object_bglt) (new1477_2967);
							 OBJECT_WIDENING_SET(aux_4850, BFALSE);
						      }
						      ((((catom_bglt) CREF(new1477_2967))->loc) = ((obj_t) arg2145_1814), BUNSPEC);
						      ((((catom_bglt) CREF(new1477_2967))->value) = ((obj_t) BUNSPEC), BUNSPEC);
						      res2578_2973 = new1477_2967;
						   }
						   arg2144_1813 = res2578_2973;
						}
					     }
					     {	/* Cgen/cgen.scm 176 */
						cvoid_bglt res2579_2984;
						{	/* Cgen/cgen.scm 176 */
						   obj_t loc_2976;
						   cop_bglt value_2977;
						   loc_2976 = BFALSE;
						   value_2977 =
						      (cop_bglt) (arg2144_1813);
						   {	/* ./Cgen/cop.scm 1958 */
						      cvoid_bglt new1471_2978;
						      new1471_2978 =
							 ((cvoid_bglt) BREF(GC_MALLOC(sizeof(struct cvoid))));
						      {		/* ./Cgen/cop.scm 1958 */
							 long arg1951_2979;
							 arg1951_2979 =
							    class_num_218___object(cvoid_cgen_cop);
							 {	/* ./Cgen/cop.scm 1958 */
							    obj_t obj_2982;
							    obj_2982 =
							       (obj_t) (new1471_2978);
							    (((obj_t) CREF(obj_2982))->header = MAKE_HEADER(arg1951_2979, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Cgen/cop.scm 1958 */
							 object_bglt aux_4860;
							 aux_4860 =
							    (object_bglt) (new1471_2978);
							 OBJECT_WIDENING_SET(aux_4860, loc_2976);
						      }
						      ((((cvoid_bglt) CREF(new1471_2978))->loc) = ((obj_t) loc_2976), BUNSPEC);
						      ((((cvoid_bglt) CREF(new1471_2978))->value) = ((cop_bglt) value_2977), BUNSPEC);
						      res2579_2984 = new1471_2978;
						   }
						}
						arg2141_1812 = res2579_2984;
					     }
					  }
					  aux_4506 =
					     PROCEDURE_ENTRY(kont_27) (kont_27,
					     (obj_t) (arg2141_1812), BEOA);
				       }
				     else
				       {	/* Cgen/cgen.scm 380 */
					  node_bglt arg2148_1816;
					  obj_t arg2149_1817;
					  arg2148_1816 =
					     (((setq_bglt) CREF(node_1807))->value);
					  arg2149_1817 =
					     make_setq_kont_65_cgen_cgen(var_1810,
					     (((setq_bglt) CREF(node_1807))->loc), kont_27);
					  {	/* Cgen/cgen.scm 380 */
					     cop_bglt aux_4871;
					     aux_4871 =
						node__cop_142_cgen_cgen(arg2148_1816, arg2149_1817);
					     aux_4506 =
						(obj_t) (aux_4871);
					  }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 8):

			    {	/* Cgen/cgen.scm 232 */
			       conditional_bglt node_1824;
			       node_1824 =
				  (conditional_bglt) (node_26);
			       {	/* Cgen/cgen.scm 391 */
				  local_bglt aux_1827;
				  aux_1827 =
				     make_local_svar_name_219_cgen_cgen(
				     CNST_TABLE_REF(((long) 7)),
				     (type_bglt) (_bool__149_type_cache));
				  {	/* Cgen/cgen.scm 391 */
				     cop_bglt ctest_1828;
				     {	/* Cgen/cgen.scm 392 */
					setq_bglt arg2199_1867;
					arg2199_1867 =
					   node_setq_243_cgen_cgen(
					   (variable_bglt) (aux_1827),
					   (((conditional_bglt) CREF(node_1824))->test));
					ctest_1828 =
					   node__cop_142_cgen_cgen(
					   (node_bglt) (arg2199_1867), _id_kont__126_cgen_cgen);
				     }
				     {	/* Cgen/cgen.scm 392 */

					{	/* Cgen/cgen.scm 393 */
					   bool_t test2157_1829;
					   {	/* Cgen/cgen.scm 393 */
					      bool_t test2196_1864;
					      test2196_1864 =
						 is_a__118___object(
						 (obj_t) (ctest_1828), csetq_cgen_cop);
					      if (test2196_1864)
						{	/* ./Ieee/equiv.scm 5508 */
						   obj_t aux_4892;
						   obj_t aux_4886;
						   aux_4892 =
						      (obj_t) (aux_1827);
						   {	/* Cgen/cgen.scm 393 */
						      variable_bglt aux_4887;
						      {		/* Cgen/cgen.scm 393 */
							 varc_bglt arg2198_1866;
							 {	/* Cgen/cgen.scm 393 */
							    csetq_bglt obj_2989;
							    obj_2989 =
							       (csetq_bglt) (ctest_1828);
							    arg2198_1866 =
							       (((csetq_bglt) CREF(obj_2989))->var);
							 }
							 aux_4887 =
							    (((varc_bglt) CREF(arg2198_1866))->variable);
						      }
						      aux_4886 =
							 (obj_t) (aux_4887);
						   }
						   test2157_1829 =
						      (aux_4886 == aux_4892);
						}
					      else
						{	/* Cgen/cgen.scm 393 */
						   test2157_1829 = ((bool_t) 0);
						}
					   }
					   if (test2157_1829)
					     {	/* Cgen/cgen.scm 394 */
						obj_t arg2158_1830;
						cop_bglt arg2159_1831;
						obj_t arg2160_1832;
						obj_t arg2162_1833;
						arg2158_1830 =
						   (((conditional_bglt) CREF(node_1824))->loc);
						{	/* Cgen/cgen.scm 395 */
						   csetq_bglt obj_2994;
						   obj_2994 =
						      (csetq_bglt) (ctest_1828);
						   arg2159_1831 =
						      (((csetq_bglt) CREF(obj_2994))->value);
						}
						{	/* Cgen/cgen.scm 396 */
						   cop_bglt arg2163_1834;
						   obj_t arg2164_1835;
						   arg2163_1834 =
						      node__cop_142_cgen_cgen(
						      (((conditional_bglt) CREF(node_1824))->true), kont_27);
						   arg2164_1835 =
						      (((conditional_bglt) CREF(node_1824))->loc);
						   {	/* Cgen/cgen.scm 396 */
						      obj_t cop_2997;
						      cop_2997 =
							 (obj_t) (arg2163_1834);
						      {		/* Cgen/cgen.scm 190 */
							 bool_t test1868_2999;
							 test1868_2999 =
							    is_a__118___object(cop_2997, block_cgen_cop);
							 if (test1868_2999)
							   {	/* Cgen/cgen.scm 190 */
							      arg2160_1832 = cop_2997;
							   }
							 else
							   {	/* Cgen/cgen.scm 190 */
							      {		/* Cgen/cgen.scm 193 */
								 block_bglt res2580_3011;
								 {	/* Cgen/cgen.scm 193 */
								    cop_bglt body_3004;
								    body_3004 =
								       (cop_bglt) (cop_2997);
								    {	/* ./Cgen/cop.scm 1952 */
								       block_bglt new1459_3005;
								       new1459_3005 =
									  ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
								       {	/* ./Cgen/cop.scm 1952 */
									  long arg1955_3006;
									  arg1955_3006 =
									     class_num_218___object(block_cgen_cop);
									  {	/* ./Cgen/cop.scm 1952 */
									     obj_t obj_3009;
									     obj_3009 =
										(obj_t) (new1459_3005);
									     (((obj_t) CREF(obj_3009))->header = MAKE_HEADER(arg1955_3006, 0), BUNSPEC);
									  }
								       }
								       {	/* ./Cgen/cop.scm 1952 */
									  object_bglt aux_4910;
									  aux_4910 =
									     (object_bglt) (new1459_3005);
									  OBJECT_WIDENING_SET(aux_4910, BFALSE);
								       }
								       ((((block_bglt) CREF(new1459_3005))->loc) = ((obj_t) arg2164_1835), BUNSPEC);
								       ((((block_bglt) CREF(new1459_3005))->body) = ((cop_bglt) body_3004), BUNSPEC);
								       res2580_3011 = new1459_3005;
								    }
								 }
								 arg2160_1832 =
								    (obj_t) (res2580_3011);
							      }
							   }
						      }
						   }
						}
						{	/* Cgen/cgen.scm 397 */
						   cop_bglt arg2166_1837;
						   obj_t arg2167_1838;
						   arg2166_1837 =
						      node__cop_142_cgen_cgen(
						      (((conditional_bglt) CREF(node_1824))->false), kont_27);
						   arg2167_1838 =
						      (((conditional_bglt) CREF(node_1824))->loc);
						   {	/* Cgen/cgen.scm 397 */
						      obj_t cop_3014;
						      cop_3014 =
							 (obj_t) (arg2166_1837);
						      {		/* Cgen/cgen.scm 190 */
							 bool_t test1868_3016;
							 test1868_3016 =
							    is_a__118___object(cop_3014, block_cgen_cop);
							 if (test1868_3016)
							   {	/* Cgen/cgen.scm 190 */
							      arg2162_1833 = cop_3014;
							   }
							 else
							   {	/* Cgen/cgen.scm 190 */
							      {		/* Cgen/cgen.scm 193 */
								 block_bglt res2581_3028;
								 {	/* Cgen/cgen.scm 193 */
								    cop_bglt body_3021;
								    body_3021 =
								       (cop_bglt) (cop_3014);
								    {	/* ./Cgen/cop.scm 1952 */
								       block_bglt new1459_3022;
								       new1459_3022 =
									  ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
								       {	/* ./Cgen/cop.scm 1952 */
									  long arg1955_3023;
									  arg1955_3023 =
									     class_num_218___object(block_cgen_cop);
									  {	/* ./Cgen/cop.scm 1952 */
									     obj_t obj_3026;
									     obj_3026 =
										(obj_t) (new1459_3022);
									     (((obj_t) CREF(obj_3026))->header = MAKE_HEADER(arg1955_3023, 0), BUNSPEC);
									  }
								       }
								       {	/* ./Cgen/cop.scm 1952 */
									  object_bglt aux_4927;
									  aux_4927 =
									     (object_bglt) (new1459_3022);
									  OBJECT_WIDENING_SET(aux_4927, BFALSE);
								       }
								       ((((block_bglt) CREF(new1459_3022))->loc) = ((obj_t) arg2167_1838), BUNSPEC);
								       ((((block_bglt) CREF(new1459_3022))->body) = ((cop_bglt) body_3021), BUNSPEC);
								       res2581_3028 = new1459_3022;
								    }
								 }
								 arg2162_1833 =
								    (obj_t) (res2581_3028);
							      }
							   }
						      }
						   }
						}
						{	/* Cgen/cgen.scm 394 */
						   cif_bglt res2582_3041;
						   {	/* Cgen/cgen.scm 394 */
						      cop_bglt true_3031;
						      cop_bglt false_3032;
						      true_3031 =
							 (cop_bglt) (arg2160_1832);
						      false_3032 =
							 (cop_bglt) (arg2162_1833);
						      {		/* ./Cgen/cop.scm 1988 */
							 cif_bglt new1528_3033;
							 new1528_3033 =
							    ((cif_bglt) BREF(GC_MALLOC(sizeof(struct cif))));
							 {	/* ./Cgen/cop.scm 1988 */
							    long arg1932_3034;
							    arg1932_3034 =
							       class_num_218___object(cif_cgen_cop);
							    {	/* ./Cgen/cop.scm 1988 */
							       obj_t obj_3039;
							       obj_3039 =
								  (obj_t) (new1528_3033);
							       (((obj_t) CREF(obj_3039))->header = MAKE_HEADER(arg1932_3034, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1988 */
							    object_bglt aux_4939;
							    aux_4939 =
							       (object_bglt) (new1528_3033);
							    OBJECT_WIDENING_SET(aux_4939, BFALSE);
							 }
							 ((((cif_bglt) CREF(new1528_3033))->loc) = ((obj_t) arg2158_1830), BUNSPEC);
							 ((((cif_bglt) CREF(new1528_3033))->test) = ((cop_bglt) arg2159_1831), BUNSPEC);
							 ((((cif_bglt) CREF(new1528_3033))->true) = ((cop_bglt) true_3031), BUNSPEC);
							 ((((cif_bglt) CREF(new1528_3033))->false) = ((cop_bglt) false_3032), BUNSPEC);
							 res2582_3041 = new1528_3033;
						      }
						   }
						   aux_4506 =
						      (obj_t) (res2582_3041);
						}
					     }
					   else
					     {	/* Cgen/cgen.scm 399 */
						obj_t arg2169_1840;
						csequence_bglt arg2170_1841;
						arg2169_1840 =
						   (((conditional_bglt) CREF(node_1824))->loc);
						{	/* Cgen/cgen.scm 401 */
						   obj_t arg2171_1842;
						   obj_t arg2172_1843;
						   arg2171_1842 =
						      (((conditional_bglt) CREF(node_1824))->loc);
						   {	/* Cgen/cgen.scm 406 */
						      local_var_164_bglt arg2173_1844;
						      cif_bglt arg2174_1845;
						      {		/* Cgen/cgen.scm 406 */
							 obj_t arg2178_1849;
							 obj_t arg2179_1850;
							 arg2178_1849 =
							    (((conditional_bglt) CREF(node_1824))->loc);
							 {	/* Cgen/cgen.scm 407 */
							    obj_t list2180_1851;
							    {	/* Cgen/cgen.scm 407 */
							       obj_t aux_4950;
							       aux_4950 =
								  (obj_t) (aux_1827);
							       list2180_1851 =
								  MAKE_PAIR(aux_4950, BNIL);
							    }
							    arg2179_1850 = list2180_1851;
							 }
							 {	/* Cgen/cgen.scm 406 */
							    local_var_164_bglt res2583_3054;
							    {	/* ./Cgen/cop.scm 1993 */
							       local_var_164_bglt new1536_3048;
							       new1536_3048 =
								  ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							       {	/* ./Cgen/cop.scm 1993 */
								  long arg1930_3049;
								  arg1930_3049 =
								     class_num_218___object(local_var_164_cgen_cop);
								  {	/* ./Cgen/cop.scm 1993 */
								     obj_t obj_3052;
								     obj_3052 =
									(obj_t) (new1536_3048);
								     (((obj_t) CREF(obj_3052))->header = MAKE_HEADER(arg1930_3049, 0), BUNSPEC);
								  }
							       }
							       {	/* ./Cgen/cop.scm 1993 */
								  object_bglt aux_4957;
								  aux_4957 =
								     (object_bglt) (new1536_3048);
								  OBJECT_WIDENING_SET(aux_4957, BFALSE);
							       }
							       ((((local_var_164_bglt) CREF(new1536_3048))->loc) = ((obj_t) arg2178_1849), BUNSPEC);
							       ((((local_var_164_bglt) CREF(new1536_3048))->vars) = ((obj_t) arg2179_1850), BUNSPEC);
							       res2583_3054 = new1536_3048;
							    }
							    arg2173_1844 = res2583_3054;
							 }
						      }
						      {		/* Cgen/cgen.scm 410 */
							 obj_t arg2181_1852;
							 varc_bglt arg2183_1853;
							 obj_t arg2184_1854;
							 obj_t arg2185_1855;
							 arg2181_1852 =
							    (((conditional_bglt) CREF(node_1824))->loc);
							 {	/* Cgen/cgen.scm 411 */
							    obj_t arg2187_1856;
							    arg2187_1856 =
							       (((conditional_bglt) CREF(node_1824))->loc);
							    {	/* Cgen/cgen.scm 411 */
							       varc_bglt res2584_3065;
							       {	/* Cgen/cgen.scm 411 */
								  variable_bglt variable_3058;
								  variable_3058 =
								     (variable_bglt) (aux_1827);
								  {	/* ./Cgen/cop.scm 1964 */
								     varc_bglt new1483_3059;
								     new1483_3059 =
									((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
								     {	/* ./Cgen/cop.scm 1964 */
									long arg1946_3060;
									arg1946_3060 =
									   class_num_218___object(varc_cgen_cop);
									{	/* ./Cgen/cop.scm 1964 */
									   obj_t obj_3063;
									   obj_3063 =
									      (obj_t) (new1483_3059);
									   (((obj_t) CREF(obj_3063))->header = MAKE_HEADER(arg1946_3060, 0), BUNSPEC);
									}
								     }
								     {	/* ./Cgen/cop.scm 1964 */
									object_bglt aux_4969;
									aux_4969 =
									   (object_bglt) (new1483_3059);
									OBJECT_WIDENING_SET(aux_4969, BFALSE);
								     }
								     ((((varc_bglt) CREF(new1483_3059))->loc) = ((obj_t) arg2187_1856), BUNSPEC);
								     ((((varc_bglt) CREF(new1483_3059))->variable) = ((variable_bglt) variable_3058), BUNSPEC);
								     res2584_3065 = new1483_3059;
								  }
							       }
							       arg2183_1853 = res2584_3065;
							    }
							 }
							 {	/* Cgen/cgen.scm 415 */
							    cop_bglt arg2189_1858;
							    obj_t arg2190_1859;
							    arg2189_1858 =
							       node__cop_142_cgen_cgen(
							       (((conditional_bglt) CREF(node_1824))->true), kont_27);
							    arg2190_1859 =
							       (((conditional_bglt) CREF(node_1824))->loc);
							    {	/* Cgen/cgen.scm 415 */
							       obj_t cop_3068;
							       cop_3068 =
								  (obj_t) (arg2189_1858);
							       {	/* Cgen/cgen.scm 190 */
								  bool_t test1868_3070;
								  test1868_3070 =
								     is_a__118___object(cop_3068, block_cgen_cop);
								  if (test1868_3070)
								    {	/* Cgen/cgen.scm 190 */
								       arg2184_1854 = cop_3068;
								    }
								  else
								    {	/* Cgen/cgen.scm 190 */
								       {	/* Cgen/cgen.scm 193 */
									  block_bglt res2585_3082;
									  {	/* Cgen/cgen.scm 193 */
									     cop_bglt body_3075;
									     body_3075 =
										(cop_bglt) (cop_3068);
									     {	/* ./Cgen/cop.scm 1952 */
										block_bglt new1459_3076;
										new1459_3076 =
										   ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
										{	/* ./Cgen/cop.scm 1952 */
										   long arg1955_3077;
										   arg1955_3077 =
										      class_num_218___object(block_cgen_cop);
										   {	/* ./Cgen/cop.scm 1952 */
										      obj_t obj_3080;
										      obj_3080 =
											 (obj_t) (new1459_3076);
										      (((obj_t) CREF(obj_3080))->header = MAKE_HEADER(arg1955_3077, 0), BUNSPEC);
										   }
										}
										{	/* ./Cgen/cop.scm 1952 */
										   object_bglt aux_4985;
										   aux_4985 =
										      (object_bglt) (new1459_3076);
										   OBJECT_WIDENING_SET(aux_4985, BFALSE);
										}
										((((block_bglt) CREF(new1459_3076))->loc) = ((obj_t) arg2190_1859), BUNSPEC);
										((((block_bglt) CREF(new1459_3076))->body) = ((cop_bglt) body_3075), BUNSPEC);
										res2585_3082 = new1459_3076;
									     }
									  }
									  arg2184_1854 =
									     (obj_t) (res2585_3082);
								       }
								    }
							       }
							    }
							 }
							 {	/* Cgen/cgen.scm 414 */
							    cop_bglt arg2192_1861;
							    obj_t arg2193_1862;
							    arg2192_1861 =
							       node__cop_142_cgen_cgen(
							       (((conditional_bglt) CREF(node_1824))->false), kont_27);
							    arg2193_1862 =
							       (((conditional_bglt) CREF(node_1824))->loc);
							    {	/* Cgen/cgen.scm 414 */
							       obj_t cop_3085;
							       cop_3085 =
								  (obj_t) (arg2192_1861);
							       {	/* Cgen/cgen.scm 190 */
								  bool_t test1868_3087;
								  test1868_3087 =
								     is_a__118___object(cop_3085, block_cgen_cop);
								  if (test1868_3087)
								    {	/* Cgen/cgen.scm 190 */
								       arg2185_1855 = cop_3085;
								    }
								  else
								    {	/* Cgen/cgen.scm 190 */
								       {	/* Cgen/cgen.scm 193 */
									  block_bglt res2586_3099;
									  {	/* Cgen/cgen.scm 193 */
									     cop_bglt body_3092;
									     body_3092 =
										(cop_bglt) (cop_3085);
									     {	/* ./Cgen/cop.scm 1952 */
										block_bglt new1459_3093;
										new1459_3093 =
										   ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
										{	/* ./Cgen/cop.scm 1952 */
										   long arg1955_3094;
										   arg1955_3094 =
										      class_num_218___object(block_cgen_cop);
										   {	/* ./Cgen/cop.scm 1952 */
										      obj_t obj_3097;
										      obj_3097 =
											 (obj_t) (new1459_3093);
										      (((obj_t) CREF(obj_3097))->header = MAKE_HEADER(arg1955_3094, 0), BUNSPEC);
										   }
										}
										{	/* ./Cgen/cop.scm 1952 */
										   object_bglt aux_5002;
										   aux_5002 =
										      (object_bglt) (new1459_3093);
										   OBJECT_WIDENING_SET(aux_5002, BFALSE);
										}
										((((block_bglt) CREF(new1459_3093))->loc) = ((obj_t) arg2193_1862), BUNSPEC);
										((((block_bglt) CREF(new1459_3093))->body) = ((cop_bglt) body_3092), BUNSPEC);
										res2586_3099 = new1459_3093;
									     }
									  }
									  arg2185_1855 =
									     (obj_t) (res2586_3099);
								       }
								    }
							       }
							    }
							 }
							 {	/* Cgen/cgen.scm 410 */
							    cif_bglt res2587_3112;
							    {	/* Cgen/cgen.scm 410 */
							       cop_bglt test_3101;
							       cop_bglt true_3102;
							       cop_bglt false_3103;
							       test_3101 =
								  (cop_bglt) (arg2183_1853);
							       true_3102 =
								  (cop_bglt) (arg2184_1854);
							       false_3103 =
								  (cop_bglt) (arg2185_1855);
							       {	/* ./Cgen/cop.scm 1988 */
								  cif_bglt new1528_3104;
								  new1528_3104 =
								     ((cif_bglt) BREF(GC_MALLOC(sizeof(struct cif))));
								  {	/* ./Cgen/cop.scm 1988 */
								     long arg1932_3105;
								     arg1932_3105 =
									class_num_218___object(cif_cgen_cop);
								     {	/* ./Cgen/cop.scm 1988 */
									obj_t obj_3110;
									obj_3110 =
									   (obj_t) (new1528_3104);
									(((obj_t) CREF(obj_3110))->header = MAKE_HEADER(arg1932_3105, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Cgen/cop.scm 1988 */
								     object_bglt aux_5015;
								     aux_5015 =
									(object_bglt) (new1528_3104);
								     OBJECT_WIDENING_SET(aux_5015, BFALSE);
								  }
								  ((((cif_bglt) CREF(new1528_3104))->loc) = ((obj_t) arg2181_1852), BUNSPEC);
								  ((((cif_bglt) CREF(new1528_3104))->test) = ((cop_bglt) test_3101), BUNSPEC);
								  ((((cif_bglt) CREF(new1528_3104))->true) = ((cop_bglt) true_3102), BUNSPEC);
								  ((((cif_bglt) CREF(new1528_3104))->false) = ((cop_bglt) false_3103), BUNSPEC);
								  res2587_3112 = new1528_3104;
							       }
							    }
							    arg2174_1845 = res2587_3112;
							 }
						      }
						      {		/* Cgen/cgen.scm 404 */
							 obj_t list2175_1846;
							 {	/* Cgen/cgen.scm 404 */
							    obj_t arg2176_1847;
							    {	/* Cgen/cgen.scm 404 */
							       obj_t arg2177_1848;
							       {	/* Cgen/cgen.scm 404 */
								  obj_t aux_5022;
								  aux_5022 =
								     (obj_t) (arg2174_1845);
								  arg2177_1848 =
								     MAKE_PAIR(aux_5022, BNIL);
							       }
							       {	/* Cgen/cgen.scm 404 */
								  obj_t aux_5025;
								  aux_5025 =
								     (obj_t) (ctest_1828);
								  arg2176_1847 =
								     MAKE_PAIR(aux_5025, arg2177_1848);
							       }
							    }
							    {	/* Cgen/cgen.scm 404 */
							       obj_t aux_5028;
							       aux_5028 =
								  (obj_t) (arg2173_1844);
							       list2175_1846 =
								  MAKE_PAIR(aux_5028, arg2176_1847);
							    }
							 }
							 arg2172_1843 = list2175_1846;
						      }
						   }
						   {	/* Cgen/cgen.scm 401 */
						      csequence_bglt res2588_3124;
						      {		/* ./Cgen/cop.scm 1975 */
							 csequence_bglt new1503_3117;
							 new1503_3117 =
							    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							 {	/* ./Cgen/cop.scm 1975 */
							    long arg1940_3118;
							    arg1940_3118 =
							       class_num_218___object(csequence_cgen_cop);
							    {	/* ./Cgen/cop.scm 1975 */
							       obj_t obj_3122;
							       obj_3122 =
								  (obj_t) (new1503_3117);
							       (((obj_t) CREF(obj_3122))->header = MAKE_HEADER(arg1940_3118, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1975 */
							    object_bglt aux_5035;
							    aux_5035 =
							       (object_bglt) (new1503_3117);
							    OBJECT_WIDENING_SET(aux_5035, BFALSE);
							 }
							 ((((csequence_bglt) CREF(new1503_3117))->loc) = ((obj_t) arg2171_1842), BUNSPEC);
							 ((((csequence_bglt) CREF(new1503_3117))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((csequence_bglt) CREF(new1503_3117))->cops) = ((obj_t) arg2172_1843), BUNSPEC);
							 res2588_3124 = new1503_3117;
						      }
						      arg2170_1841 = res2588_3124;
						   }
						}
						{	/* Cgen/cgen.scm 399 */
						   block_bglt res2589_3133;
						   {	/* Cgen/cgen.scm 399 */
						      cop_bglt body_3126;
						      body_3126 =
							 (cop_bglt) (arg2170_1841);
						      {		/* ./Cgen/cop.scm 1952 */
							 block_bglt new1459_3127;
							 new1459_3127 =
							    ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							 {	/* ./Cgen/cop.scm 1952 */
							    long arg1955_3128;
							    arg1955_3128 =
							       class_num_218___object(block_cgen_cop);
							    {	/* ./Cgen/cop.scm 1952 */
							       obj_t obj_3131;
							       obj_3131 =
								  (obj_t) (new1459_3127);
							       (((obj_t) CREF(obj_3131))->header = MAKE_HEADER(arg1955_3128, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1952 */
							    object_bglt aux_5046;
							    aux_5046 =
							       (object_bglt) (new1459_3127);
							    OBJECT_WIDENING_SET(aux_5046, BFALSE);
							 }
							 ((((block_bglt) CREF(new1459_3127))->loc) = ((obj_t) arg2169_1840), BUNSPEC);
							 ((((block_bglt) CREF(new1459_3127))->body) = ((cop_bglt) body_3126), BUNSPEC);
							 res2589_3133 = new1459_3127;
						      }
						   }
						   aux_4506 =
						      (obj_t) (res2589_3133);
						}
					     }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 9):

			    {	/* Cgen/cgen.scm 232 */
			       fail_bglt node_1869;
			       node_1869 =
				  (fail_bglt) (node_26);
			       {
				  obj_t old_actuals_174_1872;
				  obj_t new_actuals_73_1873;
				  local_bglt aux_1874;
				  obj_t auxs_1875;
				  obj_t exps_1876;
				  {	/* Cgen/cgen.scm 425 */
				     obj_t arg2201_1878;
				     local_bglt arg2203_1880;
				     {	/* Cgen/cgen.scm 425 */
					node_bglt arg2207_1883;
					node_bglt arg2208_1884;
					arg2207_1883 =
					   (((fail_bglt) CREF(node_1869))->proc);
					arg2208_1884 =
					   (((fail_bglt) CREF(node_1869))->msg);
					{	/* Cgen/cgen.scm 425 */
					   obj_t list2210_1886;
					   {	/* Cgen/cgen.scm 425 */
					      obj_t arg2211_1887;
					      {		/* Cgen/cgen.scm 425 */
						 obj_t arg2212_1888;
						 {	/* Cgen/cgen.scm 425 */
						    obj_t aux_5055;
						    {	/* Cgen/cgen.scm 425 */
						       node_bglt aux_5056;
						       aux_5056 =
							  (((fail_bglt) CREF(node_1869))->obj);
						       aux_5055 =
							  (obj_t) (aux_5056);
						    }
						    arg2212_1888 =
						       MAKE_PAIR(aux_5055, BNIL);
						 }
						 {	/* Cgen/cgen.scm 425 */
						    obj_t aux_5060;
						    aux_5060 =
						       (obj_t) (arg2208_1884);
						    arg2211_1887 =
						       MAKE_PAIR(aux_5060, arg2212_1888);
						 }
					      }
					      {		/* Cgen/cgen.scm 425 */
						 obj_t aux_5063;
						 aux_5063 =
						    (obj_t) (arg2207_1883);
						 list2210_1886 =
						    MAKE_PAIR(aux_5063, arg2211_1887);
					      }
					   }
					   arg2201_1878 = list2210_1886;
					}
				     }
				     arg2203_1880 =
					make_local_svar_name_219_cgen_cgen(
					CNST_TABLE_REF(((long) 6)),
					(type_bglt) (_obj__252_type_cache));
				     old_actuals_174_1872 = arg2201_1878;
				     new_actuals_73_1873 = BNIL;
				     aux_1874 = arg2203_1880;
				     auxs_1875 = BNIL;
				     exps_1876 = BNIL;
				   loop_1877:
				     if (
					NULLP(old_actuals_174_1872))
				       {	/* Cgen/cgen.scm 430 */
					  if (
					     NULLP(auxs_1875))
					    {	/* Cgen/cgen.scm 432 */
					       cfail_bglt arg2215_1891;
					       {	/* Cgen/cgen.scm 432 */
						  obj_t arg2216_1892;
						  arg2216_1892 =
						     (((fail_bglt) CREF(node_1869))->loc);
						  {	/* Cgen/cgen.scm 432 */
						     cfail_bglt res2590_3164;
						     {	/* Cgen/cgen.scm 432 */
							cop_bglt proc_3153;
							cop_bglt msg_3154;
							cop_bglt obj_3155;
							{	/* Cgen/cgen.scm 432 */
							   obj_t aux_5074;
							   {	/* ./Ieee/pair-list.scm 5701 */
							      obj_t aux_5075;
							      {		/* ./Ieee/pair-list.scm 5707 */
								 obj_t aux_5076;
								 aux_5076 =
								    CDR(new_actuals_73_1873);
								 aux_5075 =
								    CDR(aux_5076);
							      }
							      aux_5074 =
								 CAR(aux_5075);
							   }
							   proc_3153 =
							      (cop_bglt) (aux_5074);
							}
							{	/* Cgen/cgen.scm 432 */
							   obj_t aux_5081;
							   {	/* ./Ieee/pair-list.scm 5701 */
							      obj_t aux_5082;
							      aux_5082 =
								 CDR(new_actuals_73_1873);
							      aux_5081 =
								 CAR(aux_5082);
							   }
							   msg_3154 =
							      (cop_bglt) (aux_5081);
							}
							{	/* Cgen/cgen.scm 432 */
							   obj_t aux_5086;
							   aux_5086 =
							      CAR(new_actuals_73_1873);
							   obj_3155 =
							      (cop_bglt) (aux_5086);
							}
							{	/* ./Cgen/cop.scm 2009 */
							   cfail_bglt new1564_3156;
							   new1564_3156 =
							      ((cfail_bglt) BREF(GC_MALLOC(sizeof(struct cfail))));
							   {	/* ./Cgen/cop.scm 2009 */
							      long arg1922_3157;
							      arg1922_3157 =
								 class_num_218___object(cfail_cgen_cop);
							      {		/* ./Cgen/cop.scm 2009 */
								 obj_t obj_3162;
								 obj_3162 =
								    (obj_t) (new1564_3156);
								 (((obj_t) CREF(obj_3162))->header = MAKE_HEADER(arg1922_3157, 0), BUNSPEC);
							      }
							   }
							   {	/* ./Cgen/cop.scm 2009 */
							      object_bglt aux_5093;
							      aux_5093 =
								 (object_bglt) (new1564_3156);
							      OBJECT_WIDENING_SET(aux_5093, BFALSE);
							   }
							   ((((cfail_bglt) CREF(new1564_3156))->loc) = ((obj_t) arg2216_1892), BUNSPEC);
							   ((((cfail_bglt) CREF(new1564_3156))->proc) = ((cop_bglt) proc_3153), BUNSPEC);
							   ((((cfail_bglt) CREF(new1564_3156))->msg) = ((cop_bglt) msg_3154), BUNSPEC);
							   ((((cfail_bglt) CREF(new1564_3156))->obj) = ((cop_bglt) obj_3155), BUNSPEC);
							   res2590_3164 = new1564_3156;
							}
						     }
						     arg2215_1891 = res2590_3164;
						  }
					       }
					       aux_4506 =
						  (obj_t) (arg2215_1891);
					    }
					  else
					    {	/* Cgen/cgen.scm 437 */
					       obj_t arg2221_1896;
					       csequence_bglt arg2223_1897;
					       arg2221_1896 =
						  (((fail_bglt) CREF(node_1869))->loc);
					       {	/* Cgen/cgen.scm 439 */
						  obj_t arg2224_1898;
						  obj_t arg2225_1899;
						  arg2224_1898 =
						     (((fail_bglt) CREF(node_1869))->loc);
						  {	/* Cgen/cgen.scm 441 */
						     local_var_164_bglt arg2226_1900;
						     csequence_bglt arg2227_1901;
						     cfail_bglt arg2228_1902;
						     {	/* Cgen/cgen.scm 441 */
							obj_t arg2232_1906;
							arg2232_1906 =
							   (((fail_bglt) CREF(node_1869))->loc);
							{	/* Cgen/cgen.scm 441 */
							   local_var_164_bglt res2591_3177;
							   {	/* ./Cgen/cop.scm 1993 */
							      local_var_164_bglt new1536_3171;
							      new1536_3171 =
								 ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							      {		/* ./Cgen/cop.scm 1993 */
								 long arg1930_3172;
								 arg1930_3172 =
								    class_num_218___object(local_var_164_cgen_cop);
								 {	/* ./Cgen/cop.scm 1993 */
								    obj_t obj_3175;
								    obj_3175 =
								       (obj_t) (new1536_3171);
								    (((obj_t) CREF(obj_3175))->header = MAKE_HEADER(arg1930_3172, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Cgen/cop.scm 1993 */
								 object_bglt aux_5108;
								 aux_5108 =
								    (object_bglt) (new1536_3171);
								 OBJECT_WIDENING_SET(aux_5108, BFALSE);
							      }
							      ((((local_var_164_bglt) CREF(new1536_3171))->loc) = ((obj_t) arg2232_1906), BUNSPEC);
							      ((((local_var_164_bglt) CREF(new1536_3171))->vars) = ((obj_t) auxs_1875), BUNSPEC);
							      res2591_3177 = new1536_3171;
							   }
							   arg2226_1900 = res2591_3177;
							}
						     }
						     {	/* Cgen/cgen.scm 444 */
							obj_t arg2234_1908;
							arg2234_1908 =
							   (((fail_bglt) CREF(node_1869))->loc);
							{	/* Cgen/cgen.scm 444 */
							   csequence_bglt res2592_3189;
							   {	/* ./Cgen/cop.scm 1975 */
							      csequence_bglt new1503_3182;
							      new1503_3182 =
								 ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							      {		/* ./Cgen/cop.scm 1975 */
								 long arg1940_3183;
								 arg1940_3183 =
								    class_num_218___object(csequence_cgen_cop);
								 {	/* ./Cgen/cop.scm 1975 */
								    obj_t obj_3187;
								    obj_3187 =
								       (obj_t) (new1503_3182);
								    (((obj_t) CREF(obj_3187))->header = MAKE_HEADER(arg1940_3183, 0), BUNSPEC);
								 }
							      }
							      {		/* ./Cgen/cop.scm 1975 */
								 object_bglt aux_5118;
								 aux_5118 =
								    (object_bglt) (new1503_3182);
								 OBJECT_WIDENING_SET(aux_5118, BFALSE);
							      }
							      ((((csequence_bglt) CREF(new1503_3182))->loc) = ((obj_t) arg2234_1908), BUNSPEC);
							      ((((csequence_bglt) CREF(new1503_3182))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							      ((((csequence_bglt) CREF(new1503_3182))->cops) = ((obj_t) exps_1876), BUNSPEC);
							      res2592_3189 = new1503_3182;
							   }
							   arg2227_1901 = res2592_3189;
							}
						     }
						     {	/* Cgen/cgen.scm 448 */
							cfail_bglt arg2237_1910;
							{	/* Cgen/cgen.scm 448 */
							   obj_t arg2239_1911;
							   arg2239_1911 =
							      (((fail_bglt) CREF(node_1869))->loc);
							   {	/* Cgen/cgen.scm 448 */
							      cfail_bglt res2593_3214;
							      {		/* Cgen/cgen.scm 448 */
								 cop_bglt proc_3203;
								 cop_bglt msg_3204;
								 cop_bglt obj_3205;
								 {	/* Cgen/cgen.scm 448 */
								    obj_t aux_5125;
								    {	/* ./Ieee/pair-list.scm 5701 */
								       obj_t aux_5126;
								       {	/* ./Ieee/pair-list.scm 5707 */
									  obj_t aux_5127;
									  aux_5127 =
									     CDR(new_actuals_73_1873);
									  aux_5126 =
									     CDR(aux_5127);
								       }
								       aux_5125 =
									  CAR(aux_5126);
								    }
								    proc_3203 =
								       (cop_bglt) (aux_5125);
								 }
								 {	/* Cgen/cgen.scm 448 */
								    obj_t aux_5132;
								    {	/* ./Ieee/pair-list.scm 5701 */
								       obj_t aux_5133;
								       aux_5133 =
									  CDR(new_actuals_73_1873);
								       aux_5132 =
									  CAR(aux_5133);
								    }
								    msg_3204 =
								       (cop_bglt) (aux_5132);
								 }
								 {	/* Cgen/cgen.scm 448 */
								    obj_t aux_5137;
								    aux_5137 =
								       CAR(new_actuals_73_1873);
								    obj_3205 =
								       (cop_bglt) (aux_5137);
								 }
								 {	/* ./Cgen/cop.scm 2009 */
								    cfail_bglt new1564_3206;
								    new1564_3206 =
								       ((cfail_bglt) BREF(GC_MALLOC(sizeof(struct cfail))));
								    {	/* ./Cgen/cop.scm 2009 */
								       long arg1922_3207;
								       arg1922_3207 =
									  class_num_218___object(cfail_cgen_cop);
								       {	/* ./Cgen/cop.scm 2009 */
									  obj_t obj_3212;
									  obj_3212 =
									     (obj_t) (new1564_3206);
									  (((obj_t) CREF(obj_3212))->header = MAKE_HEADER(arg1922_3207, 0), BUNSPEC);
								       }
								    }
								    {	/* ./Cgen/cop.scm 2009 */
								       object_bglt aux_5144;
								       aux_5144 =
									  (object_bglt) (new1564_3206);
								       OBJECT_WIDENING_SET(aux_5144, BFALSE);
								    }
								    ((((cfail_bglt) CREF(new1564_3206))->loc) = ((obj_t) arg2239_1911), BUNSPEC);
								    ((((cfail_bglt) CREF(new1564_3206))->proc) = ((cop_bglt) proc_3203), BUNSPEC);
								    ((((cfail_bglt) CREF(new1564_3206))->msg) = ((cop_bglt) msg_3204), BUNSPEC);
								    ((((cfail_bglt) CREF(new1564_3206))->obj) = ((cop_bglt) obj_3205), BUNSPEC);
								    res2593_3214 = new1564_3206;
								 }
							      }
							      arg2237_1910 = res2593_3214;
							   }
							}
							arg2228_1902 = arg2237_1910;
						     }
						     {	/* Cgen/cgen.scm 441 */
							obj_t list2229_1903;
							{	/* Cgen/cgen.scm 441 */
							   obj_t arg2230_1904;
							   {	/* Cgen/cgen.scm 441 */
							      obj_t arg2231_1905;
							      {		/* Cgen/cgen.scm 441 */
								 obj_t aux_5151;
								 aux_5151 =
								    (obj_t) (arg2228_1902);
								 arg2231_1905 =
								    MAKE_PAIR(aux_5151, BNIL);
							      }
							      {		/* Cgen/cgen.scm 441 */
								 obj_t aux_5154;
								 aux_5154 =
								    (obj_t) (arg2227_1901);
								 arg2230_1904 =
								    MAKE_PAIR(aux_5154, arg2231_1905);
							      }
							   }
							   {	/* Cgen/cgen.scm 441 */
							      obj_t aux_5157;
							      aux_5157 =
								 (obj_t) (arg2226_1900);
							      list2229_1903 =
								 MAKE_PAIR(aux_5157, arg2230_1904);
							   }
							}
							arg2225_1899 = list2229_1903;
						     }
						  }
						  {	/* Cgen/cgen.scm 439 */
						     csequence_bglt res2594_3227;
						     {	/* ./Cgen/cop.scm 1975 */
							csequence_bglt new1503_3220;
							new1503_3220 =
							   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							{	/* ./Cgen/cop.scm 1975 */
							   long arg1940_3221;
							   arg1940_3221 =
							      class_num_218___object(csequence_cgen_cop);
							   {	/* ./Cgen/cop.scm 1975 */
							      obj_t obj_3225;
							      obj_3225 =
								 (obj_t) (new1503_3220);
							      (((obj_t) CREF(obj_3225))->header = MAKE_HEADER(arg1940_3221, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1975 */
							   object_bglt aux_5164;
							   aux_5164 =
							      (object_bglt) (new1503_3220);
							   OBJECT_WIDENING_SET(aux_5164, BFALSE);
							}
							((((csequence_bglt) CREF(new1503_3220))->loc) = ((obj_t) arg2224_1898), BUNSPEC);
							((((csequence_bglt) CREF(new1503_3220))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							((((csequence_bglt) CREF(new1503_3220))->cops) = ((obj_t) arg2225_1899), BUNSPEC);
							res2594_3227 = new1503_3220;
						     }
						     arg2223_1897 = res2594_3227;
						  }
					       }
					       {	/* Cgen/cgen.scm 437 */
						  block_bglt res2595_3236;
						  {	/* Cgen/cgen.scm 437 */
						     cop_bglt body_3229;
						     body_3229 =
							(cop_bglt) (arg2223_1897);
						     {	/* ./Cgen/cop.scm 1952 */
							block_bglt new1459_3230;
							new1459_3230 =
							   ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							{	/* ./Cgen/cop.scm 1952 */
							   long arg1955_3231;
							   arg1955_3231 =
							      class_num_218___object(block_cgen_cop);
							   {	/* ./Cgen/cop.scm 1952 */
							      obj_t obj_3234;
							      obj_3234 =
								 (obj_t) (new1459_3230);
							      (((obj_t) CREF(obj_3234))->header = MAKE_HEADER(arg1955_3231, 0), BUNSPEC);
							   }
							}
							{	/* ./Cgen/cop.scm 1952 */
							   object_bglt aux_5175;
							   aux_5175 =
							      (object_bglt) (new1459_3230);
							   OBJECT_WIDENING_SET(aux_5175, BFALSE);
							}
							((((block_bglt) CREF(new1459_3230))->loc) = ((obj_t) arg2221_1896), BUNSPEC);
							((((block_bglt) CREF(new1459_3230))->body) = ((cop_bglt) body_3229), BUNSPEC);
							res2595_3236 = new1459_3230;
						     }
						  }
						  aux_4506 =
						     (obj_t) (res2595_3236);
					       }
					    }
				       }
				     else
				       {	/* Cgen/cgen.scm 453 */
					  cop_bglt cop_1915;
					  {	/* Cgen/cgen.scm 453 */
					     setq_bglt arg2259_1931;
					     {	/* Cgen/cgen.scm 453 */
						node_bglt aux_5181;
						{	/* Cgen/cgen.scm 453 */
						   obj_t aux_5183;
						   aux_5183 =
						      CAR(old_actuals_174_1872);
						   aux_5181 =
						      (node_bglt) (aux_5183);
						}
						arg2259_1931 =
						   node_setq_243_cgen_cgen(
						   (variable_bglt) (aux_1874), aux_5181);
					     }
					     cop_1915 =
						node__cop_142_cgen_cgen(
						(node_bglt) (arg2259_1931), _id_kont__126_cgen_cgen);
					  }
					  {	/* Cgen/cgen.scm 455 */
					     bool_t test2243_1916;
					     {	/* Cgen/cgen.scm 455 */
						bool_t test2256_1928;
						test2256_1928 =
						   is_a__118___object(
						   (obj_t) (cop_1915), csetq_cgen_cop);
						if (test2256_1928)
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_5198;
						     obj_t aux_5192;
						     aux_5198 =
							(obj_t) (aux_1874);
						     {	/* Cgen/cgen.scm 456 */
							variable_bglt aux_5193;
							{	/* Cgen/cgen.scm 456 */
							   varc_bglt arg2258_1930;
							   {	/* Cgen/cgen.scm 456 */
							      csetq_bglt obj_3239;
							      obj_3239 =
								 (csetq_bglt) (cop_1915);
							      arg2258_1930 =
								 (((csetq_bglt) CREF(obj_3239))->var);
							   }
							   aux_5193 =
							      (((varc_bglt) CREF(arg2258_1930))->variable);
							}
							aux_5192 =
							   (obj_t) (aux_5193);
						     }
						     test2243_1916 =
							(aux_5192 == aux_5198);
						  }
						else
						  {	/* Cgen/cgen.scm 455 */
						     test2243_1916 = ((bool_t) 0);
						  }
					     }
					     if (test2243_1916)
					       {	/* Cgen/cgen.scm 458 */
						  obj_t arg2244_1917;
						  obj_t arg2245_1918;
						  arg2244_1917 =
						     CDR(old_actuals_174_1872);
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_5203;
						     {	/* Cgen/cgen.scm 459 */
							cop_bglt aux_5204;
							{	/* Cgen/cgen.scm 459 */
							   csetq_bglt obj_3244;
							   obj_3244 =
							      (csetq_bglt) (cop_1915);
							   aux_5204 =
							      (((csetq_bglt) CREF(obj_3244))->value);
							}
							aux_5203 =
							   (obj_t) (aux_5204);
						     }
						     arg2245_1918 =
							MAKE_PAIR(aux_5203, new_actuals_73_1873);
						  }
						  {
						     obj_t new_actuals_73_5210;
						     obj_t old_actuals_174_5209;
						     old_actuals_174_5209 = arg2244_1917;
						     new_actuals_73_5210 = arg2245_1918;
						     new_actuals_73_1873 = new_actuals_73_5210;
						     old_actuals_174_1872 = old_actuals_174_5209;
						     goto loop_1877;
						  }
					       }
					     else
					       {	/* Cgen/cgen.scm 455 */
						  {	/* Cgen/cgen.scm 464 */
						     type_bglt val1082_3248;
						     val1082_3248 =
							(type_bglt) (_obj__252_type_cache);
						     ((((local_bglt) CREF(aux_1874))->type) = ((type_bglt) val1082_3248), BUNSPEC);
						  }
						  {	/* Cgen/cgen.scm 465 */
						     obj_t arg2247_1920;
						     obj_t arg2248_1921;
						     local_bglt arg2249_1922;
						     obj_t arg2250_1923;
						     obj_t arg2251_1924;
						     arg2247_1920 =
							CDR(old_actuals_174_1872);
						     {	/* Cgen/cgen.scm 466 */
							varc_bglt arg2253_1925;
							{	/* Cgen/cgen.scm 466 */
							   obj_t arg2254_1926;
							   arg2254_1926 =
							      (((fail_bglt) CREF(node_1869))->loc);
							   {	/* Cgen/cgen.scm 466 */
							      varc_bglt res2596_3259;
							      {		/* Cgen/cgen.scm 466 */
								 variable_bglt variable_3252;
								 variable_3252 =
								    (variable_bglt) (aux_1874);
								 {	/* ./Cgen/cop.scm 1964 */
								    varc_bglt new1483_3253;
								    new1483_3253 =
								       ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
								    {	/* ./Cgen/cop.scm 1964 */
								       long arg1946_3254;
								       arg1946_3254 =
									  class_num_218___object(varc_cgen_cop);
								       {	/* ./Cgen/cop.scm 1964 */
									  obj_t obj_3257;
									  obj_3257 =
									     (obj_t) (new1483_3253);
									  (((obj_t) CREF(obj_3257))->header = MAKE_HEADER(arg1946_3254, 0), BUNSPEC);
								       }
								    }
								    {	/* ./Cgen/cop.scm 1964 */
								       object_bglt aux_5220;
								       aux_5220 =
									  (object_bglt) (new1483_3253);
								       OBJECT_WIDENING_SET(aux_5220, BFALSE);
								    }
								    ((((varc_bglt) CREF(new1483_3253))->loc) = ((obj_t) arg2254_1926), BUNSPEC);
								    ((((varc_bglt) CREF(new1483_3253))->variable) = ((variable_bglt) variable_3252), BUNSPEC);
								    res2596_3259 = new1483_3253;
								 }
							      }
							      arg2253_1925 = res2596_3259;
							   }
							}
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_5225;
							   aux_5225 =
							      (obj_t) (arg2253_1925);
							   arg2248_1921 =
							      MAKE_PAIR(aux_5225, new_actuals_73_1873);
							}
						     }
						     arg2249_1922 =
							make_local_svar_name_219_cgen_cgen(
							CNST_TABLE_REF(((long) 6)),
							(type_bglt) (_obj__252_type_cache));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_5231;
							aux_5231 =
							   (obj_t) (aux_1874);
							arg2250_1923 =
							   MAKE_PAIR(aux_5231, auxs_1875);
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_5234;
							aux_5234 =
							   (obj_t) (cop_1915);
							arg2251_1924 =
							   MAKE_PAIR(aux_5234, exps_1876);
						     }
						     {
							obj_t exps_5241;
							obj_t auxs_5240;
							local_bglt aux_5239;
							obj_t new_actuals_73_5238;
							obj_t old_actuals_174_5237;
							old_actuals_174_5237 = arg2247_1920;
							new_actuals_73_5238 = arg2248_1921;
							aux_5239 = arg2249_1922;
							auxs_5240 = arg2250_1923;
							exps_5241 = arg2251_1924;
							exps_1876 = exps_5241;
							auxs_1875 = auxs_5240;
							aux_1874 = aux_5239;
							new_actuals_73_1873 = new_actuals_73_5238;
							old_actuals_174_1872 = old_actuals_174_5237;
							goto loop_1877;
						     }
						  }
					       }
					  }
				       }
				  }
			       }
			    }
			    break;
			 case ((long) 10):

			    {	/* Cgen/cgen.scm 232 */
			       select_bglt node_1933;
			       node_1933 =
				  (select_bglt) (node_26);
			       {
				  obj_t l1691_1936;
				  l1691_1936 =
				     (((select_bglt) CREF(node_1933))->clauses);
				lname1692_1937:
				  if (
				     PAIRP(l1691_1936))
				    {	/* Cgen/cgen.scm 481 */
				       {	/* Cgen/cgen.scm 482 */
					  obj_t clause_1940;
					  clause_1940 =
					     CAR(l1691_1936);
					  {	/* Cgen/cgen.scm 482 */
					     cop_bglt arg2263_1941;
					     {	/* Cgen/cgen.scm 482 */
						node_bglt aux_5246;
						{	/* Cgen/cgen.scm 482 */
						   obj_t aux_5247;
						   aux_5247 =
						      CDR(clause_1940);
						   aux_5246 =
						      (node_bglt) (aux_5247);
						}
						arg2263_1941 =
						   node__cop_142_cgen_cgen(aux_5246, kont_27);
					     }
					     {	/* ./Ieee/pair-list.scm 5896 */
						obj_t aux_5251;
						aux_5251 =
						   (obj_t) (arg2263_1941);
						SET_CDR(clause_1940, aux_5251);
					     }
					  }
				       }
				       {
					  obj_t l1691_5254;
					  l1691_5254 =
					     CDR(l1691_1936);
					  l1691_1936 = l1691_5254;
					  goto lname1692_1937;
				       }
				    }
				  else
				    {	/* Cgen/cgen.scm 481 */
				       ((bool_t) 1);
				    }
			       }
			       {	/* Cgen/cgen.scm 484 */
				  local_bglt aux_1944;
				  aux_1944 =
				     make_local_svar_name_219_cgen_cgen(
				     CNST_TABLE_REF(((long) 6)),
				     (((select_bglt) CREF(node_1933))->item_type_130));
				  {	/* Cgen/cgen.scm 485 */
				     cop_bglt cop_1945;
				     {	/* Cgen/cgen.scm 485 */
					setq_bglt arg2292_1970;
					arg2292_1970 =
					   node_setq_243_cgen_cgen(
					   (variable_bglt) (aux_1944),
					   (((select_bglt) CREF(node_1933))->test));
					cop_1945 =
					   node__cop_142_cgen_cgen(
					   (node_bglt) (arg2292_1970), _id_kont__126_cgen_cgen);
				     }
				     {	/* Cgen/cgen.scm 486 */
					bool_t test2266_1946;
					{	/* Cgen/cgen.scm 486 */
					   bool_t test2289_1967;
					   test2289_1967 =
					      is_a__118___object(
					      (obj_t) (cop_1945), csetq_cgen_cop);
					   if (test2289_1967)
					     {	/* ./Ieee/equiv.scm 5508 */
						obj_t aux_5274;
						obj_t aux_5268;
						aux_5274 =
						   (obj_t) (aux_1944);
						{	/* Cgen/cgen.scm 487 */
						   variable_bglt aux_5269;
						   {	/* Cgen/cgen.scm 487 */
						      varc_bglt arg2291_1969;
						      {		/* Cgen/cgen.scm 487 */
							 csetq_bglt obj_3276;
							 obj_3276 =
							    (csetq_bglt) (cop_1945);
							 arg2291_1969 =
							    (((csetq_bglt) CREF(obj_3276))->var);
						      }
						      aux_5269 =
							 (((varc_bglt) CREF(arg2291_1969))->variable);
						   }
						   aux_5268 =
						      (obj_t) (aux_5269);
						}
						test2266_1946 =
						   (aux_5268 == aux_5274);
					     }
					   else
					     {	/* Cgen/cgen.scm 486 */
						test2266_1946 = ((bool_t) 0);
					     }
					}
					if (test2266_1946)
					  {	/* Cgen/cgen.scm 488 */
					     obj_t arg2267_1947;
					     cop_bglt arg2268_1948;
					     obj_t arg2269_1949;
					     arg2267_1947 =
						(((select_bglt) CREF(node_1933))->loc);
					     {	/* Cgen/cgen.scm 490 */
						csetq_bglt obj_3281;
						obj_3281 =
						   (csetq_bglt) (cop_1945);
						arg2268_1948 =
						   (((csetq_bglt) CREF(obj_3281))->value);
					     }
					     arg2269_1949 =
						(((select_bglt) CREF(node_1933))->clauses);
					     {	/* Cgen/cgen.scm 488 */
						cswitch_bglt res2597_3293;
						{	/* ./Cgen/cop.scm 2014 */
						   cswitch_bglt new1572_3286;
						   new1572_3286 =
						      ((cswitch_bglt) BREF(GC_MALLOC(sizeof(struct cswitch))));
						   {	/* ./Cgen/cop.scm 2014 */
						      long arg1920_3287;
						      arg1920_3287 =
							 class_num_218___object(cswitch_cgen_cop);
						      {		/* ./Cgen/cop.scm 2014 */
							 obj_t obj_3291;
							 obj_3291 =
							    (obj_t) (new1572_3286);
							 (((obj_t) CREF(obj_3291))->header = MAKE_HEADER(arg1920_3287, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Cgen/cop.scm 2014 */
						      object_bglt aux_5286;
						      aux_5286 =
							 (object_bglt) (new1572_3286);
						      OBJECT_WIDENING_SET(aux_5286, BFALSE);
						   }
						   ((((cswitch_bglt) CREF(new1572_3286))->loc) = ((obj_t) arg2267_1947), BUNSPEC);
						   ((((cswitch_bglt) CREF(new1572_3286))->test) = ((cop_bglt) arg2268_1948), BUNSPEC);
						   ((((cswitch_bglt) CREF(new1572_3286))->clauses) = ((obj_t) arg2269_1949), BUNSPEC);
						   res2597_3293 = new1572_3286;
						}
						aux_4506 =
						   (obj_t) (res2597_3293);
					     }
					  }
					else
					  {	/* Cgen/cgen.scm 492 */
					     obj_t arg2270_1950;
					     csequence_bglt arg2271_1951;
					     arg2270_1950 =
						(((select_bglt) CREF(node_1933))->loc);
					     {	/* Cgen/cgen.scm 494 */
						obj_t arg2272_1952;
						obj_t arg2273_1953;
						arg2272_1952 =
						   (((select_bglt) CREF(node_1933))->loc);
						{	/* Cgen/cgen.scm 496 */
						   local_var_164_bglt arg2274_1954;
						   cswitch_bglt arg2276_1955;
						   {	/* Cgen/cgen.scm 496 */
						      obj_t arg2281_1959;
						      obj_t arg2282_1960;
						      arg2281_1959 =
							 (((select_bglt) CREF(node_1933))->loc);
						      {		/* Cgen/cgen.scm 498 */
							 obj_t list2283_1961;
							 {	/* Cgen/cgen.scm 498 */
							    obj_t aux_5296;
							    aux_5296 =
							       (obj_t) (aux_1944);
							    list2283_1961 =
							       MAKE_PAIR(aux_5296, BNIL);
							 }
							 arg2282_1960 = list2283_1961;
						      }
						      {		/* Cgen/cgen.scm 496 */
							 local_var_164_bglt res2598_3306;
							 {	/* ./Cgen/cop.scm 1993 */
							    local_var_164_bglt new1536_3300;
							    new1536_3300 =
							       ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							    {	/* ./Cgen/cop.scm 1993 */
							       long arg1930_3301;
							       arg1930_3301 =
								  class_num_218___object(local_var_164_cgen_cop);
							       {	/* ./Cgen/cop.scm 1993 */
								  obj_t obj_3304;
								  obj_3304 =
								     (obj_t) (new1536_3300);
								  (((obj_t) CREF(obj_3304))->header = MAKE_HEADER(arg1930_3301, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Cgen/cop.scm 1993 */
							       object_bglt aux_5303;
							       aux_5303 =
								  (object_bglt) (new1536_3300);
							       OBJECT_WIDENING_SET(aux_5303, BFALSE);
							    }
							    ((((local_var_164_bglt) CREF(new1536_3300))->loc) = ((obj_t) arg2281_1959), BUNSPEC);
							    ((((local_var_164_bglt) CREF(new1536_3300))->vars) = ((obj_t) arg2282_1960), BUNSPEC);
							    res2598_3306 = new1536_3300;
							 }
							 arg2274_1954 = res2598_3306;
						      }
						   }
						   {	/* Cgen/cgen.scm 500 */
						      obj_t arg2284_1962;
						      varc_bglt arg2285_1963;
						      obj_t arg2286_1964;
						      arg2284_1962 =
							 (((select_bglt) CREF(node_1933))->loc);
						      {		/* Cgen/cgen.scm 502 */
							 obj_t arg2287_1965;
							 arg2287_1965 =
							    (((select_bglt) CREF(node_1933))->loc);
							 {	/* Cgen/cgen.scm 502 */
							    varc_bglt res2599_3317;
							    {	/* Cgen/cgen.scm 502 */
							       variable_bglt variable_3310;
							       variable_3310 =
								  (variable_bglt) (aux_1944);
							       {	/* ./Cgen/cop.scm 1964 */
								  varc_bglt new1483_3311;
								  new1483_3311 =
								     ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
								  {	/* ./Cgen/cop.scm 1964 */
								     long arg1946_3312;
								     arg1946_3312 =
									class_num_218___object(varc_cgen_cop);
								     {	/* ./Cgen/cop.scm 1964 */
									obj_t obj_3315;
									obj_3315 =
									   (obj_t) (new1483_3311);
									(((obj_t) CREF(obj_3315))->header = MAKE_HEADER(arg1946_3312, 0), BUNSPEC);
								     }
								  }
								  {	/* ./Cgen/cop.scm 1964 */
								     object_bglt aux_5315;
								     aux_5315 =
									(object_bglt) (new1483_3311);
								     OBJECT_WIDENING_SET(aux_5315, BFALSE);
								  }
								  ((((varc_bglt) CREF(new1483_3311))->loc) = ((obj_t) arg2287_1965), BUNSPEC);
								  ((((varc_bglt) CREF(new1483_3311))->variable) = ((variable_bglt) variable_3310), BUNSPEC);
								  res2599_3317 = new1483_3311;
							       }
							    }
							    arg2285_1963 = res2599_3317;
							 }
						      }
						      arg2286_1964 =
							 (((select_bglt) CREF(node_1933))->clauses);
						      {		/* Cgen/cgen.scm 500 */
							 cswitch_bglt res2600_3329;
							 {	/* Cgen/cgen.scm 500 */
							    cop_bglt test_3320;
							    test_3320 =
							       (cop_bglt) (arg2285_1963);
							    {	/* ./Cgen/cop.scm 2014 */
							       cswitch_bglt new1572_3322;
							       new1572_3322 =
								  ((cswitch_bglt) BREF(GC_MALLOC(sizeof(struct cswitch))));
							       {	/* ./Cgen/cop.scm 2014 */
								  long arg1920_3323;
								  arg1920_3323 =
								     class_num_218___object(cswitch_cgen_cop);
								  {	/* ./Cgen/cop.scm 2014 */
								     obj_t obj_3327;
								     obj_3327 =
									(obj_t) (new1572_3322);
								     (((obj_t) CREF(obj_3327))->header = MAKE_HEADER(arg1920_3323, 0), BUNSPEC);
								  }
							       }
							       {	/* ./Cgen/cop.scm 2014 */
								  object_bglt aux_5326;
								  aux_5326 =
								     (object_bglt) (new1572_3322);
								  OBJECT_WIDENING_SET(aux_5326, BFALSE);
							       }
							       ((((cswitch_bglt) CREF(new1572_3322))->loc) = ((obj_t) arg2284_1962), BUNSPEC);
							       ((((cswitch_bglt) CREF(new1572_3322))->test) = ((cop_bglt) test_3320), BUNSPEC);
							       ((((cswitch_bglt) CREF(new1572_3322))->clauses) = ((obj_t) arg2286_1964), BUNSPEC);
							       res2600_3329 = new1572_3322;
							    }
							 }
							 arg2276_1955 = res2600_3329;
						      }
						   }
						   {	/* Cgen/cgen.scm 496 */
						      obj_t list2277_1956;
						      {		/* Cgen/cgen.scm 496 */
							 obj_t arg2279_1957;
							 {	/* Cgen/cgen.scm 496 */
							    obj_t arg2280_1958;
							    {	/* Cgen/cgen.scm 496 */
							       obj_t aux_5332;
							       aux_5332 =
								  (obj_t) (arg2276_1955);
							       arg2280_1958 =
								  MAKE_PAIR(aux_5332, BNIL);
							    }
							    {	/* Cgen/cgen.scm 496 */
							       obj_t aux_5335;
							       aux_5335 =
								  (obj_t) (cop_1945);
							       arg2279_1957 =
								  MAKE_PAIR(aux_5335, arg2280_1958);
							    }
							 }
							 {	/* Cgen/cgen.scm 496 */
							    obj_t aux_5338;
							    aux_5338 =
							       (obj_t) (arg2274_1954);
							    list2277_1956 =
							       MAKE_PAIR(aux_5338, arg2279_1957);
							 }
						      }
						      arg2273_1953 = list2277_1956;
						   }
						}
						{	/* Cgen/cgen.scm 494 */
						   csequence_bglt res2601_3341;
						   {	/* ./Cgen/cop.scm 1975 */
						      csequence_bglt new1503_3334;
						      new1503_3334 =
							 ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						      {		/* ./Cgen/cop.scm 1975 */
							 long arg1940_3335;
							 arg1940_3335 =
							    class_num_218___object(csequence_cgen_cop);
							 {	/* ./Cgen/cop.scm 1975 */
							    obj_t obj_3339;
							    obj_3339 =
							       (obj_t) (new1503_3334);
							    (((obj_t) CREF(obj_3339))->header = MAKE_HEADER(arg1940_3335, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Cgen/cop.scm 1975 */
							 object_bglt aux_5345;
							 aux_5345 =
							    (object_bglt) (new1503_3334);
							 OBJECT_WIDENING_SET(aux_5345, BFALSE);
						      }
						      ((((csequence_bglt) CREF(new1503_3334))->loc) = ((obj_t) arg2272_1952), BUNSPEC);
						      ((((csequence_bglt) CREF(new1503_3334))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						      ((((csequence_bglt) CREF(new1503_3334))->cops) = ((obj_t) arg2273_1953), BUNSPEC);
						      res2601_3341 = new1503_3334;
						   }
						   arg2271_1951 = res2601_3341;
						}
					     }
					     {	/* Cgen/cgen.scm 492 */
						block_bglt res2602_3350;
						{	/* Cgen/cgen.scm 492 */
						   cop_bglt body_3343;
						   body_3343 =
						      (cop_bglt) (arg2271_1951);
						   {	/* ./Cgen/cop.scm 1952 */
						      block_bglt new1459_3344;
						      new1459_3344 =
							 ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
						      {		/* ./Cgen/cop.scm 1952 */
							 long arg1955_3345;
							 arg1955_3345 =
							    class_num_218___object(block_cgen_cop);
							 {	/* ./Cgen/cop.scm 1952 */
							    obj_t obj_3348;
							    obj_3348 =
							       (obj_t) (new1459_3344);
							    (((obj_t) CREF(obj_3348))->header = MAKE_HEADER(arg1955_3345, 0), BUNSPEC);
							 }
						      }
						      {		/* ./Cgen/cop.scm 1952 */
							 object_bglt aux_5356;
							 aux_5356 =
							    (object_bglt) (new1459_3344);
							 OBJECT_WIDENING_SET(aux_5356, BFALSE);
						      }
						      ((((block_bglt) CREF(new1459_3344))->loc) = ((obj_t) arg2270_1950), BUNSPEC);
						      ((((block_bglt) CREF(new1459_3344))->body) = ((cop_bglt) body_3343), BUNSPEC);
						      res2602_3350 = new1459_3344;
						   }
						}
						aux_4506 =
						   (obj_t) (res2602_3350);
					     }
					  }
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 11):

			    {	/* Cgen/cgen.scm 232 */
			       let_fun_218_bglt node_1974;
			       node_1974 =
				  (let_fun_218_bglt) (node_26);
			       {
				  obj_t locals_1977;
				  obj_t all_formals_186_1978;
				  locals_1977 =
				     (((let_fun_218_bglt) CREF(node_1974))->locals);
				  all_formals_186_1978 = BNIL;
				loop_1979:
				  if (
				     NULLP(locals_1977))
				    {	/* Cgen/cgen.scm 524 */
				       cop_bglt arg2299_1983;
				       {	/* Cgen/cgen.scm 524 */
					  csequence_bglt arg2300_1984;
					  obj_t arg2301_1985;
					  {	/* Cgen/cgen.scm 524 */
					     obj_t arg2302_1986;
					     obj_t arg2303_1987;
					     arg2302_1986 =
						(((let_fun_218_bglt) CREF(node_1974))->loc);
					     {	/* Cgen/cgen.scm 526 */
						local_var_164_bglt arg2304_1988;
						cop_bglt arg2305_1989;
						{	/* Cgen/cgen.scm 526 */
						   obj_t arg2308_1992;
						   arg2308_1992 =
						      (((let_fun_218_bglt) CREF(node_1974))->loc);
						   {	/* Cgen/cgen.scm 526 */
						      local_var_164_bglt res2603_3363;
						      {		/* ./Cgen/cop.scm 1993 */
							 local_var_164_bglt new1536_3357;
							 new1536_3357 =
							    ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							 {	/* ./Cgen/cop.scm 1993 */
							    long arg1930_3358;
							    arg1930_3358 =
							       class_num_218___object(local_var_164_cgen_cop);
							    {	/* ./Cgen/cop.scm 1993 */
							       obj_t obj_3361;
							       obj_3361 =
								  (obj_t) (new1536_3357);
							       (((obj_t) CREF(obj_3361))->header = MAKE_HEADER(arg1930_3358, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1993 */
							    object_bglt aux_5371;
							    aux_5371 =
							       (object_bglt) (new1536_3357);
							    OBJECT_WIDENING_SET(aux_5371, BFALSE);
							 }
							 ((((local_var_164_bglt) CREF(new1536_3357))->loc) = ((obj_t) arg2308_1992), BUNSPEC);
							 ((((local_var_164_bglt) CREF(new1536_3357))->vars) = ((obj_t) all_formals_186_1978), BUNSPEC);
							 res2603_3363 = new1536_3357;
						      }
						      arg2304_1988 = res2603_3363;
						   }
						}
						arg2305_1989 =
						   node__cop_142_cgen_cgen(
						   (((let_fun_218_bglt) CREF(node_1974))->body), kont_27);
						{	/* Cgen/cgen.scm 526 */
						   obj_t list2306_1990;
						   {	/* Cgen/cgen.scm 526 */
						      obj_t arg2307_1991;
						      {		/* Cgen/cgen.scm 526 */
							 obj_t aux_5378;
							 aux_5378 =
							    (obj_t) (arg2305_1989);
							 arg2307_1991 =
							    MAKE_PAIR(aux_5378, BNIL);
						      }
						      {		/* Cgen/cgen.scm 526 */
							 obj_t aux_5381;
							 aux_5381 =
							    (obj_t) (arg2304_1988);
							 list2306_1990 =
							    MAKE_PAIR(aux_5381, arg2307_1991);
						      }
						   }
						   arg2303_1987 = list2306_1990;
						}
					     }
					     {	/* Cgen/cgen.scm 524 */
						csequence_bglt res2604_3376;
						{	/* ./Cgen/cop.scm 1975 */
						   csequence_bglt new1503_3369;
						   new1503_3369 =
						      ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						   {	/* ./Cgen/cop.scm 1975 */
						      long arg1940_3370;
						      arg1940_3370 =
							 class_num_218___object(csequence_cgen_cop);
						      {		/* ./Cgen/cop.scm 1975 */
							 obj_t obj_3374;
							 obj_3374 =
							    (obj_t) (new1503_3369);
							 (((obj_t) CREF(obj_3374))->header = MAKE_HEADER(arg1940_3370, 0), BUNSPEC);
						      }
						   }
						   {	/* ./Cgen/cop.scm 1975 */
						      object_bglt aux_5388;
						      aux_5388 =
							 (object_bglt) (new1503_3369);
						      OBJECT_WIDENING_SET(aux_5388, BFALSE);
						   }
						   ((((csequence_bglt) CREF(new1503_3369))->loc) = ((obj_t) arg2302_1986), BUNSPEC);
						   ((((csequence_bglt) CREF(new1503_3369))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						   ((((csequence_bglt) CREF(new1503_3369))->cops) = ((obj_t) arg2303_1987), BUNSPEC);
						   res2604_3376 = new1503_3369;
						}
						arg2300_1984 = res2604_3376;
					     }
					  }
					  arg2301_1985 =
					     (((let_fun_218_bglt) CREF(node_1974))->loc);
					  arg2299_1983 =
					     bdb_let_var_254_cgen_cgen(
					     (cop_bglt) (arg2300_1984), arg2301_1985);
				       }
				       {	/* Cgen/cgen.scm 522 */
					  obj_t cop_3378;
					  obj_t loc_3379;
					  cop_3378 =
					     (obj_t) (arg2299_1983);
					  loc_3379 = BFALSE;
					  {	/* Cgen/cgen.scm 190 */
					     bool_t test1868_3380;
					     test1868_3380 =
						is_a__118___object(cop_3378, block_cgen_cop);
					     if (test1868_3380)
					       {	/* Cgen/cgen.scm 190 */
						  aux_4506 = cop_3378;
					       }
					     else
					       {	/* Cgen/cgen.scm 190 */
						  {	/* Cgen/cgen.scm 193 */
						     block_bglt res2605_3392;
						     {	/* Cgen/cgen.scm 193 */
							cop_bglt body_3385;
							body_3385 =
							   (cop_bglt) (cop_3378);
							{	/* ./Cgen/cop.scm 1952 */
							   block_bglt new1459_3386;
							   new1459_3386 =
							      ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							   {	/* ./Cgen/cop.scm 1952 */
							      long arg1955_3387;
							      arg1955_3387 =
								 class_num_218___object(block_cgen_cop);
							      {		/* ./Cgen/cop.scm 1952 */
								 obj_t obj_3390;
								 obj_3390 =
								    (obj_t) (new1459_3386);
								 (((obj_t) CREF(obj_3390))->header = MAKE_HEADER(arg1955_3387, 0), BUNSPEC);
							      }
							   }
							   {	/* ./Cgen/cop.scm 1952 */
							      object_bglt aux_5405;
							      aux_5405 =
								 (object_bglt) (new1459_3386);
							      OBJECT_WIDENING_SET(aux_5405, loc_3379);
							   }
							   ((((block_bglt) CREF(new1459_3386))->loc) = ((obj_t) loc_3379), BUNSPEC);
							   ((((block_bglt) CREF(new1459_3386))->body) = ((cop_bglt) body_3385), BUNSPEC);
							   res2605_3392 = new1459_3386;
							}
						     }
						     aux_4506 =
							(obj_t) (res2605_3392);
						  }
					       }
					  }
				       }
				    }
				  else
				    {	/* Cgen/cgen.scm 532 */
				       obj_t local_1995;
				       local_1995 =
					  CAR(locals_1977);
				       set_variable_name__102_cgen_prototype(local_1995);
				       {	/* Cgen/cgen.scm 534 */
					  sfun_c_188_bglt fun_1996;
					  {	/* Cgen/cgen.scm 534 */
					     sfun_c_188_bglt obj1702_2005;
					     {
						value_bglt aux_5413;
						{	/* Cgen/cgen.scm 534 */
						   local_bglt obj_3394;
						   obj_3394 =
						      (local_bglt) (local_1995);
						   aux_5413 =
						      (((local_bglt) CREF(obj_3394))->value);
						}
						obj1702_2005 =
						   ((sfun_c_188_bglt) (aux_5413));
					     }
					     {	/* Cgen/cgen.scm 536 */
						sfun_c_188_bglt arg2316_2006;
						{	/* Cgen/cgen.scm 536 */
						   clabel_bglt arg2317_2007;
						   {	/* Cgen/cgen.scm 536 */
						      obj_t arg2319_2009;
						      obj_t arg2320_2010;
						      {		/* Cgen/cgen.scm 536 */
							 sfun_bglt obj_3396;
							 {	/* Cgen/cgen.scm 536 */
							    value_bglt aux_5417;
							    {	/* Cgen/cgen.scm 536 */
							       local_bglt obj_3395;
							       obj_3395 =
								  (local_bglt) (local_1995);
							       aux_5417 =
								  (((local_bglt) CREF(obj_3395))->value);
							    }
							    obj_3396 =
							       (sfun_bglt) (aux_5417);
							 }
							 arg2319_2009 =
							    (((sfun_bglt) CREF(obj_3396))->loc);
						      }
						      {		/* Cgen/cgen.scm 537 */
							 local_bglt obj_3397;
							 obj_3397 =
							    (local_bglt) (local_1995);
							 arg2320_2010 =
							    (((local_bglt) CREF(obj_3397))->name);
						      }
						      {		/* Cgen/cgen.scm 535 */
							 clabel_bglt res2606_3410;
							 {	/* ./Cgen/cop.scm 1944 */
							    clabel_bglt new1445_3402;
							    new1445_3402 =
							       ((clabel_bglt) BREF(GC_MALLOC(sizeof(struct clabel))));
							    {	/* ./Cgen/cop.scm 1944 */
							       long arg1959_3403;
							       arg1959_3403 =
								  class_num_218___object(clabel_cgen_cop);
							       {	/* ./Cgen/cop.scm 1944 */
								  obj_t obj_3408;
								  obj_3408 =
								     (obj_t) (new1445_3402);
								  (((obj_t) CREF(obj_3408))->header = MAKE_HEADER(arg1959_3403, 0), BUNSPEC);
							       }
							    }
							    {	/* ./Cgen/cop.scm 1944 */
							       object_bglt aux_5428;
							       aux_5428 =
								  (object_bglt) (new1445_3402);
							       OBJECT_WIDENING_SET(aux_5428, BFALSE);
							    }
							    ((((clabel_bglt) CREF(new1445_3402))->loc) = ((obj_t) arg2319_2009), BUNSPEC);
							    ((((clabel_bglt) CREF(new1445_3402))->name) = ((obj_t) arg2320_2010), BUNSPEC);
							    ((((clabel_bglt) CREF(new1445_3402))->used__226) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							    ((((clabel_bglt) CREF(new1445_3402))->body) = ((obj_t) BUNSPEC), BUNSPEC);
							    res2606_3410 = new1445_3402;
							 }
							 arg2317_2007 = res2606_3410;
						      }
						   }
						   {	/* Cgen/cgen.scm 534 */
						      sfun_c_188_bglt res2607_3416;
						      {		/* ./Cgen/cop.scm 2037 */
							 sfun_c_188_bglt new1624_3413;
							 new1624_3413 =
							    ((sfun_c_188_bglt) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
							 ((((sfun_c_188_bglt) CREF(new1624_3413))->label) = ((clabel_bglt) arg2317_2007), BUNSPEC);
							 ((((sfun_c_188_bglt) CREF(new1624_3413))->integrated) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 res2607_3416 = new1624_3413;
						      }
						      arg2316_2006 = res2607_3416;
						   }
						}
						{	/* Cgen/cgen.scm 534 */
						   obj_t aux_5440;
						   object_bglt aux_5438;
						   aux_5440 =
						      (obj_t) (arg2316_2006);
						   aux_5438 =
						      (object_bglt) (obj1702_2005);
						   OBJECT_WIDENING_SET(aux_5438, aux_5440);
						}
					     }
					     {	/* Cgen/cgen.scm 534 */
						long arg2322_2012;
						arg2322_2012 =
						   class_num_218___object(sfun_c_188_cgen_cop);
						{	/* Cgen/cgen.scm 534 */
						   obj_t obj_3417;
						   obj_3417 =
						      (obj_t) (obj1702_2005);
						   (((obj_t) CREF(obj_3417))->header = MAKE_HEADER(arg2322_2012, 0), BUNSPEC);
						}
					     }
					     fun_1996 = obj1702_2005;
					  }
					  {	/* Cgen/cgen.scm 534 */
					     obj_t formals_1997;
					     {	/* Cgen/cgen.scm 539 */
						sfun_bglt obj_3419;
						obj_3419 =
						   (sfun_bglt) (fun_1996);
						formals_1997 =
						   (((sfun_bglt) CREF(obj_3419))->args);
					     }
					     {	/* Cgen/cgen.scm 539 */

						{
						   obj_t l1704_1998;
						   l1704_1998 = formals_1997;
						 lname1705_1999:
						   if (
						      PAIRP(l1704_1998))
						     {	/* Cgen/cgen.scm 540 */
							set_variable_name__102_cgen_prototype(
							   CAR(l1704_1998));
							{
							   obj_t l1704_5452;
							   l1704_5452 =
							      CDR(l1704_1998);
							   l1704_1998 = l1704_5452;
							   goto lname1705_1999;
							}
						     }
						   else
						     {	/* Cgen/cgen.scm 540 */
							((bool_t) 1);
						     }
						}
						{
						   obj_t all_formals_186_5456;
						   obj_t locals_5454;
						   locals_5454 =
						      CDR(locals_1977);
						   all_formals_186_5456 =
						      append_2_18___r4_pairs_and_lists_6_3(formals_1997, all_formals_186_1978);
						   all_formals_186_1978 = all_formals_186_5456;
						   locals_1977 = locals_5454;
						   goto loop_1979;
						}
					     }
					  }
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 12):

			    {	/* Cgen/cgen.scm 232 */
			       let_var_6_bglt node_2013;
			       node_2013 =
				  (let_var_6_bglt) (node_26);
			       {	/* Cgen/cgen.scm 550 */
				  local_var_164_bglt decls_2016;
				  obj_t sets_2017;
				  stop_bglt body_2018;
				  {	/* Cgen/cgen.scm 550 */
				     obj_t arg2332_2028;
				     obj_t arg2333_2029;
				     arg2332_2028 =
					(((let_var_6_bglt) CREF(node_2013))->loc);
				     {	/* Cgen/cgen.scm 552 */
					obj_t l1708_2030;
					l1708_2030 =
					   (((let_var_6_bglt) CREF(node_2013))->bindings);
					if (
					   NULLP(l1708_2030))
					  {	/* Cgen/cgen.scm 552 */
					     arg2333_2029 = BNIL;
					  }
					else
					  {	/* Cgen/cgen.scm 552 */
					     obj_t head1710_2032;
					     {	/* ./Ieee/pair-list.scm 5689 */
						obj_t aux_5464;
						{	/* ./Ieee/pair-list.scm 5701 */
						   obj_t aux_5465;
						   aux_5465 =
						      CAR(l1708_2030);
						   aux_5464 =
						      CAR(aux_5465);
						}
						head1710_2032 =
						   MAKE_PAIR(aux_5464, BNIL);
					     }
					     {
						obj_t l1708_2033;
						obj_t tail1711_2034;
						l1708_2033 =
						   CDR(l1708_2030);
						tail1711_2034 = head1710_2032;
					      lname1709_2035:
						if (
						   NULLP(l1708_2033))
						  {	/* Cgen/cgen.scm 552 */
						     arg2333_2029 = head1710_2032;
						  }
						else
						  {	/* Cgen/cgen.scm 552 */
						     obj_t newtail1712_2038;
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_5471;
							{	/* ./Ieee/pair-list.scm 5701 */
							   obj_t aux_5472;
							   aux_5472 =
							      CAR(l1708_2033);
							   aux_5471 =
							      CAR(aux_5472);
							}
							newtail1712_2038 =
							   MAKE_PAIR(aux_5471, BNIL);
						     }
						     SET_CDR(tail1711_2034, newtail1712_2038);
						     {
							obj_t tail1711_5479;
							obj_t l1708_5477;
							l1708_5477 =
							   CDR(l1708_2033);
							tail1711_5479 = newtail1712_2038;
							tail1711_2034 = tail1711_5479;
							l1708_2033 = l1708_5477;
							goto lname1709_2035;
						     }
						  }
					     }
					  }
				     }
				     {	/* Cgen/cgen.scm 550 */
					local_var_164_bglt res2608_3448;
					{	/* ./Cgen/cop.scm 1993 */
					   local_var_164_bglt new1536_3442;
					   new1536_3442 =
					      ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
					   {	/* ./Cgen/cop.scm 1993 */
					      long arg1930_3443;
					      arg1930_3443 =
						 class_num_218___object(local_var_164_cgen_cop);
					      {		/* ./Cgen/cop.scm 1993 */
						 obj_t obj_3446;
						 obj_3446 =
						    (obj_t) (new1536_3442);
						 (((obj_t) CREF(obj_3446))->header = MAKE_HEADER(arg1930_3443, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1993 */
					      object_bglt aux_5485;
					      aux_5485 =
						 (object_bglt) (new1536_3442);
					      OBJECT_WIDENING_SET(aux_5485, BFALSE);
					   }
					   ((((local_var_164_bglt) CREF(new1536_3442))->loc) = ((obj_t) arg2332_2028), BUNSPEC);
					   ((((local_var_164_bglt) CREF(new1536_3442))->vars) = ((obj_t) arg2333_2029), BUNSPEC);
					   res2608_3448 = new1536_3442;
					}
					decls_2016 = res2608_3448;
				     }
				  }
				  {	/* Cgen/cgen.scm 553 */
				     obj_t l1713_2046;
				     l1713_2046 =
					(((let_var_6_bglt) CREF(node_2013))->bindings);
				     if (
					NULLP(l1713_2046))
				       {	/* Cgen/cgen.scm 553 */
					  sets_2017 = BNIL;
				       }
				     else
				       {	/* Cgen/cgen.scm 553 */
					  obj_t head1715_2048;
					  head1715_2048 =
					     MAKE_PAIR(BNIL, BNIL);
					  {
					     obj_t l1713_2049;
					     obj_t tail1716_2050;
					     l1713_2049 = l1713_2046;
					     tail1716_2050 = head1715_2048;
					   lname1714_2051:
					     if (
						NULLP(l1713_2049))
					       {	/* Cgen/cgen.scm 553 */
						  sets_2017 =
						     CDR(head1715_2048);
					       }
					     else
					       {	/* Cgen/cgen.scm 553 */
						  obj_t newtail1717_2053;
						  {	/* Cgen/cgen.scm 553 */
						     cop_bglt arg2347_2055;
						     {	/* Cgen/cgen.scm 553 */
							obj_t x_2057;
							x_2057 =
							   CAR(l1713_2049);
							set_variable_name__102_cgen_prototype(
							   CAR(x_2057));
							{	/* Cgen/cgen.scm 555 */
							   setq_bglt arg2350_2059;
							   {	/* Cgen/cgen.scm 555 */
							      node_bglt aux_5504;
							      variable_bglt aux_5500;
							      {		/* Cgen/cgen.scm 555 */
								 obj_t aux_5505;
								 aux_5505 =
								    CDR(x_2057);
								 aux_5504 =
								    (node_bglt) (aux_5505);
							      }
							      {		/* Cgen/cgen.scm 555 */
								 obj_t aux_5501;
								 aux_5501 =
								    CAR(x_2057);
								 aux_5500 =
								    (variable_bglt) (aux_5501);
							      }
							      arg2350_2059 =
								 node_setq_243_cgen_cgen(aux_5500, aux_5504);
							   }
							   arg2347_2055 =
							      node__cop_142_cgen_cgen(
							      (node_bglt) (arg2350_2059), _stop_kont__121_cgen_cgen);
							}
						     }
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_5511;
							aux_5511 =
							   (obj_t) (arg2347_2055);
							newtail1717_2053 =
							   MAKE_PAIR(aux_5511, BNIL);
						     }
						  }
						  SET_CDR(tail1716_2050, newtail1717_2053);
						  {
						     obj_t tail1716_5517;
						     obj_t l1713_5515;
						     l1713_5515 =
							CDR(l1713_2049);
						     tail1716_5517 = newtail1717_2053;
						     tail1716_2050 = tail1716_5517;
						     l1713_2049 = l1713_5515;
						     goto lname1714_2051;
						  }
					       }
					  }
				       }
				  }
				  {	/* Cgen/cgen.scm 557 */
				     cop_bglt cop_2062;
				     cop_2062 =
					node__cop_142_cgen_cgen(
					(((let_var_6_bglt) CREF(node_2013))->body), kont_27);
				     {	/* Cgen/cgen.scm 558 */
					stop_bglt res2609_3473;
					{	/* Cgen/cgen.scm 558 */
					   obj_t loc_3465;
					   loc_3465 = BFALSE;
					   {	/* ./Cgen/cop.scm 1981 */
					      stop_bglt new1515_3467;
					      new1515_3467 =
						 ((stop_bglt) BREF(GC_MALLOC(sizeof(struct stop))));
					      {		/* ./Cgen/cop.scm 1981 */
						 long arg1936_3468;
						 arg1936_3468 =
						    class_num_218___object(stop_cgen_cop);
						 {	/* ./Cgen/cop.scm 1981 */
						    obj_t obj_3471;
						    obj_3471 =
						       (obj_t) (new1515_3467);
						    (((obj_t) CREF(obj_3471))->header = MAKE_HEADER(arg1936_3468, 0), BUNSPEC);
						 }
					      }
					      {		/* ./Cgen/cop.scm 1981 */
						 object_bglt aux_5524;
						 aux_5524 =
						    (object_bglt) (new1515_3467);
						 OBJECT_WIDENING_SET(aux_5524, loc_3465);
					      }
					      ((((stop_bglt) CREF(new1515_3467))->loc) = ((obj_t) loc_3465), BUNSPEC);
					      ((((stop_bglt) CREF(new1515_3467))->value) = ((cop_bglt) cop_2062), BUNSPEC);
					      res2609_3473 = new1515_3467;
					   }
					}
					body_2018 = res2609_3473;
				     }
				  }
				  {	/* Cgen/cgen.scm 562 */
				     cop_bglt arg2323_2019;
				     obj_t arg2324_2020;
				     {	/* Cgen/cgen.scm 562 */
					csequence_bglt arg2325_2021;
					obj_t arg2326_2022;
					{	/* Cgen/cgen.scm 562 */
					   obj_t arg2327_2023;
					   obj_t arg2328_2024;
					   arg2327_2023 =
					      (((let_var_6_bglt) CREF(node_2013))->loc);
					   {	/* Cgen/cgen.scm 564 */
					      obj_t arg2329_2025;
					      {		/* Cgen/cgen.scm 564 */
						 obj_t arg2330_2026;
						 {	/* Cgen/cgen.scm 564 */
						    obj_t list2331_2027;
						    {	/* Cgen/cgen.scm 564 */
						       obj_t aux_5530;
						       aux_5530 =
							  (obj_t) (body_2018);
						       list2331_2027 =
							  MAKE_PAIR(aux_5530, BNIL);
						    }
						    arg2330_2026 = list2331_2027;
						 }
						 arg2329_2025 =
						    append_2_18___r4_pairs_and_lists_6_3(sets_2017, arg2330_2026);
					      }
					      {		/* ./Ieee/pair-list.scm 5689 */
						 obj_t aux_5534;
						 aux_5534 =
						    (obj_t) (decls_2016);
						 arg2328_2024 =
						    MAKE_PAIR(aux_5534, arg2329_2025);
					      }
					   }
					   {	/* Cgen/cgen.scm 562 */
					      csequence_bglt res2610_3488;
					      {		/* ./Cgen/cop.scm 1975 */
						 csequence_bglt new1503_3481;
						 new1503_3481 =
						    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						 {	/* ./Cgen/cop.scm 1975 */
						    long arg1940_3482;
						    arg1940_3482 =
						       class_num_218___object(csequence_cgen_cop);
						    {	/* ./Cgen/cop.scm 1975 */
						       obj_t obj_3486;
						       obj_3486 =
							  (obj_t) (new1503_3481);
						       (((obj_t) CREF(obj_3486))->header = MAKE_HEADER(arg1940_3482, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1975 */
						    object_bglt aux_5541;
						    aux_5541 =
						       (object_bglt) (new1503_3481);
						    OBJECT_WIDENING_SET(aux_5541, BFALSE);
						 }
						 ((((csequence_bglt) CREF(new1503_3481))->loc) = ((obj_t) arg2327_2023), BUNSPEC);
						 ((((csequence_bglt) CREF(new1503_3481))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						 ((((csequence_bglt) CREF(new1503_3481))->cops) = ((obj_t) arg2328_2024), BUNSPEC);
						 res2610_3488 = new1503_3481;
					      }
					      arg2325_2021 = res2610_3488;
					   }
					}
					arg2326_2022 =
					   (((let_var_6_bglt) CREF(node_2013))->loc);
					arg2323_2019 =
					   bdb_let_var_254_cgen_cgen(
					   (cop_bglt) (arg2325_2021), arg2326_2022);
				     }
				     arg2324_2020 =
					(((let_var_6_bglt) CREF(node_2013))->loc);
				     {	/* Cgen/cgen.scm 560 */
					obj_t cop_3491;
					cop_3491 =
					   (obj_t) (arg2323_2019);
					{	/* Cgen/cgen.scm 190 */
					   bool_t test1868_3493;
					   test1868_3493 =
					      is_a__118___object(cop_3491, block_cgen_cop);
					   if (test1868_3493)
					     {	/* Cgen/cgen.scm 190 */
						aux_4506 = cop_3491;
					     }
					   else
					     {	/* Cgen/cgen.scm 190 */
						{	/* Cgen/cgen.scm 193 */
						   block_bglt res2611_3505;
						   {	/* Cgen/cgen.scm 193 */
						      cop_bglt body_3498;
						      body_3498 =
							 (cop_bglt) (cop_3491);
						      {		/* ./Cgen/cop.scm 1952 */
							 block_bglt new1459_3499;
							 new1459_3499 =
							    ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							 {	/* ./Cgen/cop.scm 1952 */
							    long arg1955_3500;
							    arg1955_3500 =
							       class_num_218___object(block_cgen_cop);
							    {	/* ./Cgen/cop.scm 1952 */
							       obj_t obj_3503;
							       obj_3503 =
								  (obj_t) (new1459_3499);
							       (((obj_t) CREF(obj_3503))->header = MAKE_HEADER(arg1955_3500, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1952 */
							    object_bglt aux_5559;
							    aux_5559 =
							       (object_bglt) (new1459_3499);
							    OBJECT_WIDENING_SET(aux_5559, BFALSE);
							 }
							 ((((block_bglt) CREF(new1459_3499))->loc) = ((obj_t) arg2324_2020), BUNSPEC);
							 ((((block_bglt) CREF(new1459_3499))->body) = ((cop_bglt) body_3498), BUNSPEC);
							 res2611_3505 = new1459_3499;
						      }
						   }
						   aux_4506 =
						      (obj_t) (res2611_3505);
						}
					     }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 13):

			    {	/* Cgen/cgen.scm 232 */
			       set_ex_it_116_bglt node_2065;
			       node_2065 =
				  (set_ex_it_116_bglt) (node_26);
			       {	/* Cgen/cgen.scm 585 */
				  variable_bglt exit_2068;
				  {	/* Cgen/cgen.scm 585 */
				     var_bglt arg2403_2117;
				     arg2403_2117 =
					(((set_ex_it_116_bglt) CREF(node_2065))->var);
				     exit_2068 =
					(((var_bglt) CREF(arg2403_2117))->variable);
				  }
				  set_variable_name__102_cgen_prototype(
				     (obj_t) (exit_2068));
				  {	/* Cgen/cgen.scm 587 */
				     obj_t arg2355_2069;
				     obj_t arg2356_2070;
				     arg2355_2069 =
					(((set_ex_it_116_bglt) CREF(node_2065))->loc);
				     {	/* Cgen/cgen.scm 590 */
					cpragma_bglt arg2357_2071;
					local_var_164_bglt arg2358_2072;
					cset_ex_it_123_bglt arg2359_2073;
					{	/* Cgen/cgen.scm 590 */
					   obj_t arg2363_2077;
					   arg2363_2077 =
					      (((set_ex_it_116_bglt) CREF(node_2065))->loc);
					   {	/* Cgen/cgen.scm 590 */
					      cpragma_bglt res2612_3520;
					      {		/* Cgen/cgen.scm 590 */
						 obj_t format_3511;
						 format_3511 = string2670_cgen_cgen;
						 {	/* ./Cgen/cop.scm 1967 */
						    cpragma_bglt new1489_3513;
						    new1489_3513 =
						       ((cpragma_bglt) BREF(GC_MALLOC(sizeof(struct cpragma))));
						    {	/* ./Cgen/cop.scm 1967 */
						       long arg1944_3514;
						       arg1944_3514 =
							  class_num_218___object(cpragma_cgen_cop);
						       {	/* ./Cgen/cop.scm 1967 */
							  obj_t obj_3518;
							  obj_3518 =
							     (obj_t) (new1489_3513);
							  (((obj_t) CREF(obj_3518))->header = MAKE_HEADER(arg1944_3514, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Cgen/cop.scm 1967 */
						       object_bglt aux_5576;
						       aux_5576 =
							  (object_bglt) (new1489_3513);
						       OBJECT_WIDENING_SET(aux_5576, BFALSE);
						    }
						    ((((cpragma_bglt) CREF(new1489_3513))->loc) = ((obj_t) arg2363_2077), BUNSPEC);
						    ((((cpragma_bglt) CREF(new1489_3513))->format) = ((obj_t) format_3511), BUNSPEC);
						    ((((cpragma_bglt) CREF(new1489_3513))->args) = ((obj_t) BNIL), BUNSPEC);
						    res2612_3520 = new1489_3513;
						 }
					      }
					      arg2357_2071 = res2612_3520;
					   }
					}
					{	/* Cgen/cgen.scm 594 */
					   obj_t arg2366_2080;
					   obj_t arg2367_2081;
					   arg2366_2080 =
					      (((set_ex_it_116_bglt) CREF(node_2065))->loc);
					   {	/* Cgen/cgen.scm 596 */
					      obj_t list2369_2083;
					      {		/* Cgen/cgen.scm 596 */
						 obj_t aux_5583;
						 {	/* Cgen/cgen.scm 596 */
						    variable_bglt aux_5584;
						    {	/* Cgen/cgen.scm 596 */
						       var_bglt arg2370_2084;
						       arg2370_2084 =
							  (((set_ex_it_116_bglt) CREF(node_2065))->var);
						       aux_5584 =
							  (((var_bglt) CREF(arg2370_2084))->variable);
						    }
						    aux_5583 =
						       (obj_t) (aux_5584);
						 }
						 list2369_2083 =
						    MAKE_PAIR(aux_5583, BNIL);
					      }
					      arg2367_2081 = list2369_2083;
					   }
					   {	/* Cgen/cgen.scm 594 */
					      local_var_164_bglt res2613_3533;
					      {		/* ./Cgen/cop.scm 1993 */
						 local_var_164_bglt new1536_3527;
						 new1536_3527 =
						    ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
						 {	/* ./Cgen/cop.scm 1993 */
						    long arg1930_3528;
						    arg1930_3528 =
						       class_num_218___object(local_var_164_cgen_cop);
						    {	/* ./Cgen/cop.scm 1993 */
						       obj_t obj_3531;
						       obj_3531 =
							  (obj_t) (new1536_3527);
						       (((obj_t) CREF(obj_3531))->header = MAKE_HEADER(arg1930_3528, 0), BUNSPEC);
						    }
						 }
						 {	/* ./Cgen/cop.scm 1993 */
						    object_bglt aux_5593;
						    aux_5593 =
						       (object_bglt) (new1536_3527);
						    OBJECT_WIDENING_SET(aux_5593, BFALSE);
						 }
						 ((((local_var_164_bglt) CREF(new1536_3527))->loc) = ((obj_t) arg2366_2080), BUNSPEC);
						 ((((local_var_164_bglt) CREF(new1536_3527))->vars) = ((obj_t) arg2367_2081), BUNSPEC);
						 res2613_3533 = new1536_3527;
					      }
					      arg2358_2072 = res2613_3533;
					   }
					}
					{	/* Cgen/cgen.scm 597 */
					   obj_t arg2371_2085;
					   varc_bglt arg2372_2086;
					   cop_bglt arg2373_2087;
					   csequence_bglt arg2374_2088;
					   arg2371_2085 =
					      (((set_ex_it_116_bglt) CREF(node_2065))->loc);
					   {	/* Cgen/cgen.scm 599 */
					      obj_t arg2375_2089;
					      arg2375_2089 =
						 (((set_ex_it_116_bglt) CREF(node_2065))->loc);
					      {		/* Cgen/cgen.scm 599 */
						 varc_bglt res2614_3544;
						 {	/* ./Cgen/cop.scm 1964 */
						    varc_bglt new1483_3538;
						    new1483_3538 =
						       ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
						    {	/* ./Cgen/cop.scm 1964 */
						       long arg1946_3539;
						       arg1946_3539 =
							  class_num_218___object(varc_cgen_cop);
						       {	/* ./Cgen/cop.scm 1964 */
							  obj_t obj_3542;
							  obj_3542 =
							     (obj_t) (new1483_3538);
							  (((obj_t) CREF(obj_3542))->header = MAKE_HEADER(arg1946_3539, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Cgen/cop.scm 1964 */
						       object_bglt aux_5604;
						       aux_5604 =
							  (object_bglt) (new1483_3538);
						       OBJECT_WIDENING_SET(aux_5604, BFALSE);
						    }
						    ((((varc_bglt) CREF(new1483_3538))->loc) = ((obj_t) arg2375_2089), BUNSPEC);
						    ((((varc_bglt) CREF(new1483_3538))->variable) = ((variable_bglt) exit_2068), BUNSPEC);
						    res2614_3544 = new1483_3538;
						 }
						 arg2372_2086 = res2614_3544;
					      }
					   }
					   {	/* Cgen/cgen.scm 602 */
					      pragma_bglt arg2377_2091;
					      {		/* Cgen/cgen.scm 602 */
						 obj_t arg2378_2092;
						 obj_t arg2379_2093;
						 arg2378_2092 =
						    (((set_ex_it_116_bglt) CREF(node_2065))->loc);
						 arg2379_2093 = ____74_type_cache;
						 {	/* Cgen/cgen.scm 602 */
						    pragma_bglt res2615_3562;
						    {	/* Cgen/cgen.scm 602 */
						       type_bglt type_3547;
						       obj_t key_3549;
						       obj_t format_3550;
						       type_3547 =
							  (type_bglt) (arg2379_2093);
						       key_3549 =
							  BINT(((long) -1));
						       format_3550 = string2671_cgen_cgen;
						       {	/* ./Ast/node.scm 1722 */
							  pragma_bglt new1284_3552;
							  new1284_3552 =
							     ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
							  {	/* ./Ast/node.scm 1722 */
							     long arg1989_3553;
							     arg1989_3553 =
								class_num_218___object(pragma_ast_node);
							     {	/* ./Ast/node.scm 1722 */
								obj_t obj_3560;
								obj_3560 =
								   (obj_t) (new1284_3552);
								(((obj_t) CREF(obj_3560))->header = MAKE_HEADER(arg1989_3553, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Ast/node.scm 1722 */
							     object_bglt aux_5616;
							     aux_5616 =
								(object_bglt) (new1284_3552);
							     OBJECT_WIDENING_SET(aux_5616, BFALSE);
							  }
							  ((((pragma_bglt) CREF(new1284_3552))->loc) = ((obj_t) arg2378_2092), BUNSPEC);
							  ((((pragma_bglt) CREF(new1284_3552))->type) = ((type_bglt) type_3547), BUNSPEC);
							  ((((pragma_bglt) CREF(new1284_3552))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							  ((((pragma_bglt) CREF(new1284_3552))->key) = ((obj_t) key_3549), BUNSPEC);
							  ((((pragma_bglt) CREF(new1284_3552))->format) = ((obj_t) format_3550), BUNSPEC);
							  ((((pragma_bglt) CREF(new1284_3552))->args) = ((obj_t) BNIL), BUNSPEC);
							  res2615_3562 = new1284_3552;
						       }
						    }
						    arg2377_2091 = res2615_3562;
						 }
					      }
					      arg2373_2087 =
						 node__cop_142_cgen_cgen(
						 (node_bglt) (arg2377_2091), kont_27);
					   }
					   {	/* Cgen/cgen.scm 608 */
					      obj_t arg2383_2097;
					      obj_t arg2384_2098;
					      arg2383_2097 =
						 (((set_ex_it_116_bglt) CREF(node_2065))->loc);
					      {		/* Cgen/cgen.scm 615 */
						 cop_bglt arg2385_2099;
						 cop_bglt arg2386_2100;
						 {	/* Cgen/cgen.scm 615 */
						    setq_bglt arg2389_2103;
						    {	/* Cgen/cgen.scm 615 */
						       pragma_bglt arg2390_2104;
						       {	/* Cgen/cgen.scm 615 */
							  obj_t arg2391_2105;
							  obj_t arg2392_2106;
							  obj_t arg2394_2108;
							  arg2391_2105 =
							     (((set_ex_it_116_bglt) CREF(node_2065))->loc);
							  arg2392_2106 = ____74_type_cache;
							  {	/* Cgen/cgen.scm 618 */
							     obj_t arg2397_2111;
							     {	/* Cgen/cgen.scm 622 */
								obj_t arg2398_2112;
								{	/* Cgen/cgen.scm 621 */
								   obj_t aux_5629;
								   {	/* Cgen/cgen.scm 622 */
								      type_bglt arg2401_2115;
								      {		/* Cgen/cgen.scm 622 */
									 local_bglt obj_3565;
									 obj_3565 =
									    (local_bglt) (exit_2068);
									 arg2401_2115 =
									    (((local_bglt) CREF(obj_3565))->type);
								      }
								      aux_5629 =
									 (((type_bglt) CREF(arg2401_2115))->name);
								   }
								   arg2398_2112 =
								      string_sans___40_type_tools(aux_5629);
								}
								arg2397_2111 =
								   string_append(arg2398_2112, string2672_cgen_cgen);
							     }
							     arg2394_2108 =
								string_append(string2673_cgen_cgen, arg2397_2111);
							  }
							  {	/* Cgen/cgen.scm 615 */
							     pragma_bglt res2616_3583;
							     {	/* Cgen/cgen.scm 615 */
								type_bglt type_3568;
								obj_t key_3570;
								type_3568 =
								   (type_bglt) (arg2392_2106);
								key_3570 =
								   BINT(((long) -1));
								{	/* ./Ast/node.scm 1722 */
								   pragma_bglt new1284_3573;
								   new1284_3573 =
								      ((pragma_bglt) BREF(GC_MALLOC(sizeof(struct pragma))));
								   {	/* ./Ast/node.scm 1722 */
								      long arg1989_3574;
								      arg1989_3574 =
									 class_num_218___object(pragma_ast_node);
								      {		/* ./Ast/node.scm 1722 */
									 obj_t obj_3581;
									 obj_3581 =
									    (obj_t) (new1284_3573);
									 (((obj_t) CREF(obj_3581))->header = MAKE_HEADER(arg1989_3574, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Ast/node.scm 1722 */
								      object_bglt aux_5642;
								      aux_5642 =
									 (object_bglt) (new1284_3573);
								      OBJECT_WIDENING_SET(aux_5642, BFALSE);
								   }
								   ((((pragma_bglt) CREF(new1284_3573))->loc) = ((obj_t) arg2391_2105), BUNSPEC);
								   ((((pragma_bglt) CREF(new1284_3573))->type) = ((type_bglt) type_3568), BUNSPEC);
								   ((((pragma_bglt) CREF(new1284_3573))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								   ((((pragma_bglt) CREF(new1284_3573))->key) = ((obj_t) key_3570), BUNSPEC);
								   ((((pragma_bglt) CREF(new1284_3573))->format) = ((obj_t) arg2394_2108), BUNSPEC);
								   ((((pragma_bglt) CREF(new1284_3573))->args) = ((obj_t) BNIL), BUNSPEC);
								   res2616_3583 = new1284_3573;
								}
							     }
							     arg2390_2104 = res2616_3583;
							  }
						       }
						       arg2389_2103 =
							  node_setq_243_cgen_cgen(exit_2068,
							  (node_bglt) (arg2390_2104));
						    }
						    arg2385_2099 =
						       node__cop_142_cgen_cgen(
						       (node_bglt) (arg2389_2103), _id_kont__126_cgen_cgen);
						 }
						 arg2386_2100 =
						    node__cop_142_cgen_cgen(
						    (((set_ex_it_116_bglt) CREF(node_2065))->body), kont_27);
						 {	/* Cgen/cgen.scm 610 */
						    obj_t list2387_2101;
						    {	/* Cgen/cgen.scm 610 */
						       obj_t arg2388_2102;
						       {	/* Cgen/cgen.scm 610 */
							  obj_t aux_5657;
							  aux_5657 =
							     (obj_t) (arg2386_2100);
							  arg2388_2102 =
							     MAKE_PAIR(aux_5657, BNIL);
						       }
						       {	/* Cgen/cgen.scm 610 */
							  obj_t aux_5660;
							  aux_5660 =
							     (obj_t) (arg2385_2099);
							  list2387_2101 =
							     MAKE_PAIR(aux_5660, arg2388_2102);
						       }
						    }
						    arg2384_2098 = list2387_2101;
						 }
					      }
					      {		/* Cgen/cgen.scm 608 */
						 csequence_bglt res2617_3596;
						 {	/* ./Cgen/cop.scm 1975 */
						    csequence_bglt new1503_3589;
						    new1503_3589 =
						       ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
						    {	/* ./Cgen/cop.scm 1975 */
						       long arg1940_3590;
						       arg1940_3590 =
							  class_num_218___object(csequence_cgen_cop);
						       {	/* ./Cgen/cop.scm 1975 */
							  obj_t obj_3594;
							  obj_3594 =
							     (obj_t) (new1503_3589);
							  (((obj_t) CREF(obj_3594))->header = MAKE_HEADER(arg1940_3590, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Cgen/cop.scm 1975 */
						       object_bglt aux_5667;
						       aux_5667 =
							  (object_bglt) (new1503_3589);
						       OBJECT_WIDENING_SET(aux_5667, BFALSE);
						    }
						    ((((csequence_bglt) CREF(new1503_3589))->loc) = ((obj_t) arg2383_2097), BUNSPEC);
						    ((((csequence_bglt) CREF(new1503_3589))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						    ((((csequence_bglt) CREF(new1503_3589))->cops) = ((obj_t) arg2384_2098), BUNSPEC);
						    res2617_3596 = new1503_3589;
						 }
						 arg2374_2088 = res2617_3596;
					      }
					   }
					   {	/* Cgen/cgen.scm 597 */
					      cset_ex_it_123_bglt res2618_3609;
					      {		/* Cgen/cgen.scm 597 */
						 cop_bglt exit_3598;
						 cop_bglt body_3600;
						 exit_3598 =
						    (cop_bglt) (arg2372_2086);
						 body_3600 =
						    (cop_bglt) (arg2374_2088);
						 {	/* ./Cgen/cop.scm 2028 */
						    cset_ex_it_123_bglt new1598_3601;
						    new1598_3601 =
						       ((cset_ex_it_123_bglt) BREF(GC_MALLOC(sizeof(struct cset_ex_it_123))));
						    {	/* ./Cgen/cop.scm 2028 */
						       long arg1910_3602;
						       arg1910_3602 =
							  class_num_218___object(cset_ex_it_123_cgen_cop);
						       {	/* ./Cgen/cop.scm 2028 */
							  obj_t obj_3607;
							  obj_3607 =
							     (obj_t) (new1598_3601);
							  (((obj_t) CREF(obj_3607))->header = MAKE_HEADER(arg1910_3602, 0), BUNSPEC);
						       }
						    }
						    {	/* ./Cgen/cop.scm 2028 */
						       object_bglt aux_5679;
						       aux_5679 =
							  (object_bglt) (new1598_3601);
						       OBJECT_WIDENING_SET(aux_5679, BFALSE);
						    }
						    ((((cset_ex_it_123_bglt) CREF(new1598_3601))->loc) = ((obj_t) arg2371_2085), BUNSPEC);
						    ((((cset_ex_it_123_bglt) CREF(new1598_3601))->exit) = ((cop_bglt) exit_3598), BUNSPEC);
						    ((((cset_ex_it_123_bglt) CREF(new1598_3601))->jump_value_221) = ((cop_bglt) arg2373_2087), BUNSPEC);
						    ((((cset_ex_it_123_bglt) CREF(new1598_3601))->body) = ((cop_bglt) body_3600), BUNSPEC);
						    res2618_3609 = new1598_3601;
						 }
					      }
					      arg2359_2073 = res2618_3609;
					   }
					}
					{	/* Cgen/cgen.scm 589 */
					   obj_t list2360_2074;
					   {	/* Cgen/cgen.scm 589 */
					      obj_t arg2361_2075;
					      {		/* Cgen/cgen.scm 589 */
						 obj_t arg2362_2076;
						 {	/* Cgen/cgen.scm 589 */
						    obj_t aux_5686;
						    aux_5686 =
						       (obj_t) (arg2359_2073);
						    arg2362_2076 =
						       MAKE_PAIR(aux_5686, BNIL);
						 }
						 {	/* Cgen/cgen.scm 589 */
						    obj_t aux_5689;
						    aux_5689 =
						       (obj_t) (arg2358_2072);
						    arg2361_2075 =
						       MAKE_PAIR(aux_5689, arg2362_2076);
						 }
					      }
					      {		/* Cgen/cgen.scm 589 */
						 obj_t aux_5692;
						 aux_5692 =
						    (obj_t) (arg2357_2071);
						 list2360_2074 =
						    MAKE_PAIR(aux_5692, arg2361_2075);
					      }
					   }
					   arg2356_2070 = list2360_2074;
					}
				     }
				     {	/* Cgen/cgen.scm 587 */
					csequence_bglt res2619_3621;
					{	/* ./Cgen/cop.scm 1975 */
					   csequence_bglt new1503_3614;
					   new1503_3614 =
					      ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
					   {	/* ./Cgen/cop.scm 1975 */
					      long arg1940_3615;
					      arg1940_3615 =
						 class_num_218___object(csequence_cgen_cop);
					      {		/* ./Cgen/cop.scm 1975 */
						 obj_t obj_3619;
						 obj_3619 =
						    (obj_t) (new1503_3614);
						 (((obj_t) CREF(obj_3619))->header = MAKE_HEADER(arg1940_3615, 0), BUNSPEC);
					      }
					   }
					   {	/* ./Cgen/cop.scm 1975 */
					      object_bglt aux_5699;
					      aux_5699 =
						 (object_bglt) (new1503_3614);
					      OBJECT_WIDENING_SET(aux_5699, BFALSE);
					   }
					   ((((csequence_bglt) CREF(new1503_3614))->loc) = ((obj_t) arg2355_2069), BUNSPEC);
					   ((((csequence_bglt) CREF(new1503_3614))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
					   ((((csequence_bglt) CREF(new1503_3614))->cops) = ((obj_t) arg2356_2070), BUNSPEC);
					   res2619_3621 = new1503_3614;
					}
					aux_4506 =
					   (obj_t) (res2619_3621);
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 14):

			    {	/* Cgen/cgen.scm 232 */
			       jump_ex_it_184_bglt node_2118;
			       node_2118 =
				  (jump_ex_it_184_bglt) (node_26);
			       {	/* Cgen/cgen.scm 635 */
				  local_bglt vaux_2121;
				  vaux_2121 =
				     make_local_svar_name_219_cgen_cgen(
				     CNST_TABLE_REF(((long) 6)),
				     (type_bglt) (_obj__252_type_cache));
				  {	/* Cgen/cgen.scm 635 */
				     cop_bglt vcop_2122;
				     {	/* Cgen/cgen.scm 636 */
					setq_bglt arg2493_2215;
					arg2493_2215 =
					   node_setq_243_cgen_cgen(
					   (variable_bglt) (vaux_2121),
					   (((jump_ex_it_184_bglt) CREF(node_2118))->value));
					vcop_2122 =
					   node__cop_142_cgen_cgen(
					   (node_bglt) (arg2493_2215), _id_kont__126_cgen_cgen);
				     }
				     {	/* Cgen/cgen.scm 636 */
					node_bglt exit_2123;
					exit_2123 =
					   (((jump_ex_it_184_bglt) CREF(node_2118))->exit);
					{	/* Cgen/cgen.scm 637 */
					   local_bglt eaux_2124;
					   eaux_2124 =
					      make_local_svar_name_219_cgen_cgen(
					      CNST_TABLE_REF(((long) 8)),
					      (type_bglt) (_procedure__226_type_cache));
					   {	/* Cgen/cgen.scm 638 */
					      cop_bglt ecop_2125;
					      {		/* Cgen/cgen.scm 639 */
						 setq_bglt arg2492_2214;
						 arg2492_2214 =
						    node_setq_243_cgen_cgen(
						    (variable_bglt) (eaux_2124), exit_2123);
						 ecop_2125 =
						    node__cop_142_cgen_cgen(
						    (node_bglt) (arg2492_2214), _id_kont__126_cgen_cgen);
					      }
					      {		/* Cgen/cgen.scm 639 */

						 {	/* Cgen/cgen.scm 641 */
						    bool_t test2404_2126;
						    {	/* Cgen/cgen.scm 641 */
						       bool_t test2485_2207;
						       test2485_2207 =
							  is_a__118___object(
							  (obj_t) (vcop_2122), csetq_cgen_cop);
						       if (test2485_2207)
							 {	/* Cgen/cgen.scm 641 */
							    bool_t test_5726;
							    {	/* ./Ieee/equiv.scm 5508 */
							       obj_t aux_5733;
							       obj_t aux_5727;
							       aux_5733 =
								  (obj_t) (vaux_2121);
							       {	/* Cgen/cgen.scm 641 */
								  variable_bglt aux_5728;
								  {	/* Cgen/cgen.scm 641 */
								     varc_bglt arg2491_2213;
								     {	/* Cgen/cgen.scm 641 */
									csetq_bglt obj_3625;
									obj_3625 =
									   (csetq_bglt) (vcop_2122);
									arg2491_2213 =
									   (((csetq_bglt) CREF(obj_3625))->var);
								     }
								     aux_5728 =
									(((varc_bglt) CREF(arg2491_2213))->variable);
								  }
								  aux_5727 =
								     (obj_t) (aux_5728);
							       }
							       test_5726 =
								  (aux_5727 == aux_5733);
							    }
							    if (test_5726)
							      {		/* Cgen/cgen.scm 642 */
								 bool_t test2487_2209;
								 test2487_2209 =
								    is_a__118___object(
								    (obj_t) (ecop_2125), csetq_cgen_cop);
								 if (test2487_2209)
								   {	/* ./Ieee/equiv.scm 5508 */
								      obj_t aux_5745;
								      obj_t aux_5739;
								      aux_5745 =
									 (obj_t) (eaux_2124);
								      {		/* Cgen/cgen.scm 642 */
									 variable_bglt aux_5740;
									 {	/* Cgen/cgen.scm 642 */
									    varc_bglt arg2489_2211;
									    {	/* Cgen/cgen.scm 642 */
									       csetq_bglt obj_3630;
									       obj_3630 =
										  (csetq_bglt) (ecop_2125);
									       arg2489_2211 =
										  (((csetq_bglt) CREF(obj_3630))->var);
									    }
									    aux_5740 =
									       (((varc_bglt) CREF(arg2489_2211))->variable);
									 }
									 aux_5739 =
									    (obj_t) (aux_5740);
								      }
								      test2404_2126 =
									 (aux_5739 == aux_5745);
								   }
								 else
								   {	/* Cgen/cgen.scm 642 */
								      test2404_2126 = ((bool_t) 0);
								   }
							      }
							    else
							      {		/* Cgen/cgen.scm 641 */
								 test2404_2126 = ((bool_t) 0);
							      }
							 }
						       else
							 {	/* Cgen/cgen.scm 641 */
							    test2404_2126 = ((bool_t) 0);
							 }
						    }
						    if (test2404_2126)
						      {		/* Cgen/cgen.scm 641 */
							 {	/* Cgen/cgen.scm 644 */
							    cjump_ex_it_131_bglt arg2405_2127;
							    {	/* Cgen/cgen.scm 644 */
							       obj_t arg2406_2128;
							       cop_bglt arg2407_2129;
							       cop_bglt arg2408_2130;
							       arg2406_2128 =
								  (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
							       {	/* Cgen/cgen.scm 646 */
								  csetq_bglt obj_3635;
								  obj_3635 =
								     (csetq_bglt) (ecop_2125);
								  arg2407_2129 =
								     (((csetq_bglt) CREF(obj_3635))->value);
							       }
							       {	/* Cgen/cgen.scm 647 */
								  csetq_bglt obj_3636;
								  obj_3636 =
								     (csetq_bglt) (vcop_2122);
								  arg2408_2130 =
								     (((csetq_bglt) CREF(obj_3636))->value);
							       }
							       {	/* Cgen/cgen.scm 644 */
								  cjump_ex_it_131_bglt res2620_3647;
								  {	/* ./Cgen/cop.scm 2033 */
								     cjump_ex_it_131_bglt new1606_3640;
								     new1606_3640 =
									((cjump_ex_it_131_bglt) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
								     {	/* ./Cgen/cop.scm 2033 */
									long arg1907_3641;
									arg1907_3641 =
									   class_num_218___object(cjump_ex_it_131_cgen_cop);
									{	/* ./Cgen/cop.scm 2033 */
									   obj_t obj_3645;
									   obj_3645 =
									      (obj_t) (new1606_3640);
									   (((obj_t) CREF(obj_3645))->header = MAKE_HEADER(arg1907_3641, 0), BUNSPEC);
									}
								     }
								     {	/* ./Cgen/cop.scm 2033 */
									object_bglt aux_5758;
									aux_5758 =
									   (object_bglt) (new1606_3640);
									OBJECT_WIDENING_SET(aux_5758, BFALSE);
								     }
								     ((((cjump_ex_it_131_bglt) CREF(new1606_3640))->loc) = ((obj_t) arg2406_2128), BUNSPEC);
								     ((((cjump_ex_it_131_bglt) CREF(new1606_3640))->exit) = ((cop_bglt) arg2407_2129), BUNSPEC);
								     ((((cjump_ex_it_131_bglt) CREF(new1606_3640))->value) = ((cop_bglt) arg2408_2130), BUNSPEC);
								     res2620_3647 = new1606_3640;
								  }
								  arg2405_2127 = res2620_3647;
							       }
							    }
							    aux_4506 =
							       (obj_t) (arg2405_2127);
							 }
						      }
						    else
						      {		/* Cgen/cgen.scm 648 */
							 bool_t test2409_2131;
							 {	/* Cgen/cgen.scm 648 */
							    bool_t test2482_2204;
							    test2482_2204 =
							       is_a__118___object(
							       (obj_t) (vcop_2122), csetq_cgen_cop);
							    if (test2482_2204)
							      {		/* ./Ieee/equiv.scm 5508 */
								 obj_t aux_5774;
								 obj_t aux_5768;
								 aux_5774 =
								    (obj_t) (vaux_2121);
								 {	/* Cgen/cgen.scm 648 */
								    variable_bglt aux_5769;
								    {	/* Cgen/cgen.scm 648 */
								       varc_bglt arg2484_2206;
								       {	/* Cgen/cgen.scm 648 */
									  csetq_bglt obj_3650;
									  obj_3650 =
									     (csetq_bglt) (vcop_2122);
									  arg2484_2206 =
									     (((csetq_bglt) CREF(obj_3650))->var);
								       }
								       aux_5769 =
									  (((varc_bglt) CREF(arg2484_2206))->variable);
								    }
								    aux_5768 =
								       (obj_t) (aux_5769);
								 }
								 test2409_2131 =
								    (aux_5768 == aux_5774);
							      }
							    else
							      {		/* Cgen/cgen.scm 648 */
								 test2409_2131 = ((bool_t) 0);
							      }
							 }
							 if (test2409_2131)
							   {	/* Cgen/cgen.scm 648 */
							      {		/* Cgen/cgen.scm 649 */
								 obj_t arg2410_2132;
								 csequence_bglt arg2411_2133;
								 arg2410_2132 =
								    (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
								 {	/* Cgen/cgen.scm 651 */
								    obj_t arg2412_2134;
								    obj_t arg2413_2135;
								    arg2412_2134 =
								       (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
								    {	/* Cgen/cgen.scm 653 */
								       local_var_164_bglt arg2414_2136;
								       csequence_bglt arg2415_2137;
								       cjump_ex_it_131_bglt arg2416_2138;
								       {	/* Cgen/cgen.scm 653 */
									  obj_t arg2420_2142;
									  obj_t arg2421_2143;
									  arg2420_2142 =
									     (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									  {	/* Cgen/cgen.scm 655 */
									     obj_t list2422_2144;
									     {	/* Cgen/cgen.scm 655 */
										obj_t aux_5781;
										aux_5781 =
										   (obj_t) (eaux_2124);
										list2422_2144 =
										   MAKE_PAIR(aux_5781, BNIL);
									     }
									     arg2421_2143 = list2422_2144;
									  }
									  {	/* Cgen/cgen.scm 653 */
									     local_var_164_bglt res2621_3666;
									     {	/* ./Cgen/cop.scm 1993 */
										local_var_164_bglt new1536_3660;
										new1536_3660 =
										   ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
										{	/* ./Cgen/cop.scm 1993 */
										   long arg1930_3661;
										   arg1930_3661 =
										      class_num_218___object(local_var_164_cgen_cop);
										   {	/* ./Cgen/cop.scm 1993 */
										      obj_t obj_3664;
										      obj_3664 =
											 (obj_t) (new1536_3660);
										      (((obj_t) CREF(obj_3664))->header = MAKE_HEADER(arg1930_3661, 0), BUNSPEC);
										   }
										}
										{	/* ./Cgen/cop.scm 1993 */
										   object_bglt aux_5788;
										   aux_5788 =
										      (object_bglt) (new1536_3660);
										   OBJECT_WIDENING_SET(aux_5788, BFALSE);
										}
										((((local_var_164_bglt) CREF(new1536_3660))->loc) = ((obj_t) arg2420_2142), BUNSPEC);
										((((local_var_164_bglt) CREF(new1536_3660))->vars) = ((obj_t) arg2421_2143), BUNSPEC);
										res2621_3666 = new1536_3660;
									     }
									     arg2414_2136 = res2621_3666;
									  }
								       }
								       {	/* Cgen/cgen.scm 656 */
									  obj_t arg2423_2145;
									  obj_t arg2424_2146;
									  arg2423_2145 =
									     (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									  {	/* Cgen/cgen.scm 658 */
									     obj_t list2425_2147;
									     {	/* Cgen/cgen.scm 658 */
										obj_t aux_5794;
										aux_5794 =
										   (obj_t) (ecop_2125);
										list2425_2147 =
										   MAKE_PAIR(aux_5794, BNIL);
									     }
									     arg2424_2146 = list2425_2147;
									  }
									  {	/* Cgen/cgen.scm 656 */
									     csequence_bglt res2622_3679;
									     {	/* ./Cgen/cop.scm 1975 */
										csequence_bglt new1503_3672;
										new1503_3672 =
										   ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
										{	/* ./Cgen/cop.scm 1975 */
										   long arg1940_3673;
										   arg1940_3673 =
										      class_num_218___object(csequence_cgen_cop);
										   {	/* ./Cgen/cop.scm 1975 */
										      obj_t obj_3677;
										      obj_3677 =
											 (obj_t) (new1503_3672);
										      (((obj_t) CREF(obj_3677))->header = MAKE_HEADER(arg1940_3673, 0), BUNSPEC);
										   }
										}
										{	/* ./Cgen/cop.scm 1975 */
										   object_bglt aux_5801;
										   aux_5801 =
										      (object_bglt) (new1503_3672);
										   OBJECT_WIDENING_SET(aux_5801, BFALSE);
										}
										((((csequence_bglt) CREF(new1503_3672))->loc) = ((obj_t) arg2423_2145), BUNSPEC);
										((((csequence_bglt) CREF(new1503_3672))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
										((((csequence_bglt) CREF(new1503_3672))->cops) = ((obj_t) arg2424_2146), BUNSPEC);
										res2622_3679 = new1503_3672;
									     }
									     arg2415_2137 = res2622_3679;
									  }
								       }
								       {	/* Cgen/cgen.scm 660 */
									  cjump_ex_it_131_bglt arg2426_2148;
									  {	/* Cgen/cgen.scm 660 */
									     obj_t arg2427_2149;
									     varc_bglt arg2428_2150;
									     cop_bglt arg2429_2151;
									     arg2427_2149 =
										(((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									     {	/* Cgen/cgen.scm 662 */
										obj_t arg2430_2152;
										arg2430_2152 =
										   (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
										{	/* Cgen/cgen.scm 662 */
										   varc_bglt res2623_3690;
										   {	/* Cgen/cgen.scm 662 */
										      variable_bglt variable_3683;
										      variable_3683 =
											 (variable_bglt) (eaux_2124);
										      {		/* ./Cgen/cop.scm 1964 */
											 varc_bglt new1483_3684;
											 new1483_3684 =
											    ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
											 {	/* ./Cgen/cop.scm 1964 */
											    long arg1946_3685;
											    arg1946_3685 =
											       class_num_218___object(varc_cgen_cop);
											    {	/* ./Cgen/cop.scm 1964 */
											       obj_t obj_3688;
											       obj_3688 =
												  (obj_t) (new1483_3684);
											       (((obj_t) CREF(obj_3688))->header = MAKE_HEADER(arg1946_3685, 0), BUNSPEC);
											    }
											 }
											 {	/* ./Cgen/cop.scm 1964 */
											    object_bglt aux_5814;
											    aux_5814 =
											       (object_bglt) (new1483_3684);
											    OBJECT_WIDENING_SET(aux_5814, BFALSE);
											 }
											 ((((varc_bglt) CREF(new1483_3684))->loc) = ((obj_t) arg2430_2152), BUNSPEC);
											 ((((varc_bglt) CREF(new1483_3684))->variable) = ((variable_bglt) variable_3683), BUNSPEC);
											 res2623_3690 = new1483_3684;
										      }
										   }
										   arg2428_2150 = res2623_3690;
										}
									     }
									     {	/* Cgen/cgen.scm 665 */
										csetq_bglt obj_3691;
										obj_3691 =
										   (csetq_bglt) (vcop_2122);
										arg2429_2151 =
										   (((csetq_bglt) CREF(obj_3691))->value);
									     }
									     {	/* Cgen/cgen.scm 660 */
										cjump_ex_it_131_bglt res2624_3702;
										{	/* Cgen/cgen.scm 660 */
										   cop_bglt exit_3693;
										   exit_3693 =
										      (cop_bglt) (arg2428_2150);
										   {	/* ./Cgen/cop.scm 2033 */
										      cjump_ex_it_131_bglt new1606_3695;
										      new1606_3695 =
											 ((cjump_ex_it_131_bglt) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
										      {		/* ./Cgen/cop.scm 2033 */
											 long arg1907_3696;
											 arg1907_3696 =
											    class_num_218___object(cjump_ex_it_131_cgen_cop);
											 {	/* ./Cgen/cop.scm 2033 */
											    obj_t obj_3700;
											    obj_3700 =
											       (obj_t) (new1606_3695);
											    (((obj_t) CREF(obj_3700))->header = MAKE_HEADER(arg1907_3696, 0), BUNSPEC);
											 }
										      }
										      {		/* ./Cgen/cop.scm 2033 */
											 object_bglt aux_5826;
											 aux_5826 =
											    (object_bglt) (new1606_3695);
											 OBJECT_WIDENING_SET(aux_5826, BFALSE);
										      }
										      ((((cjump_ex_it_131_bglt) CREF(new1606_3695))->loc) = ((obj_t) arg2427_2149), BUNSPEC);
										      ((((cjump_ex_it_131_bglt) CREF(new1606_3695))->exit) = ((cop_bglt) exit_3693), BUNSPEC);
										      ((((cjump_ex_it_131_bglt) CREF(new1606_3695))->value) = ((cop_bglt) arg2429_2151), BUNSPEC);
										      res2624_3702 = new1606_3695;
										   }
										}
										arg2426_2148 = res2624_3702;
									     }
									  }
									  arg2416_2138 = arg2426_2148;
								       }
								       {	/* Cgen/cgen.scm 653 */
									  obj_t list2417_2139;
									  {	/* Cgen/cgen.scm 653 */
									     obj_t arg2418_2140;
									     {	/* Cgen/cgen.scm 653 */
										obj_t arg2419_2141;
										{	/* Cgen/cgen.scm 653 */
										   obj_t aux_5832;
										   aux_5832 =
										      (obj_t) (arg2416_2138);
										   arg2419_2141 =
										      MAKE_PAIR(aux_5832, BNIL);
										}
										{	/* Cgen/cgen.scm 653 */
										   obj_t aux_5835;
										   aux_5835 =
										      (obj_t) (arg2415_2137);
										   arg2418_2140 =
										      MAKE_PAIR(aux_5835, arg2419_2141);
										}
									     }
									     {	/* Cgen/cgen.scm 653 */
										obj_t aux_5838;
										aux_5838 =
										   (obj_t) (arg2414_2136);
										list2417_2139 =
										   MAKE_PAIR(aux_5838, arg2418_2140);
									     }
									  }
									  arg2413_2135 = list2417_2139;
								       }
								    }
								    {	/* Cgen/cgen.scm 651 */
								       csequence_bglt res2625_3715;
								       {	/* ./Cgen/cop.scm 1975 */
									  csequence_bglt new1503_3708;
									  new1503_3708 =
									     ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
									  {	/* ./Cgen/cop.scm 1975 */
									     long arg1940_3709;
									     arg1940_3709 =
										class_num_218___object(csequence_cgen_cop);
									     {	/* ./Cgen/cop.scm 1975 */
										obj_t obj_3713;
										obj_3713 =
										   (obj_t) (new1503_3708);
										(((obj_t) CREF(obj_3713))->header = MAKE_HEADER(arg1940_3709, 0), BUNSPEC);
									     }
									  }
									  {	/* ./Cgen/cop.scm 1975 */
									     object_bglt aux_5845;
									     aux_5845 =
										(object_bglt) (new1503_3708);
									     OBJECT_WIDENING_SET(aux_5845, BFALSE);
									  }
									  ((((csequence_bglt) CREF(new1503_3708))->loc) = ((obj_t) arg2412_2134), BUNSPEC);
									  ((((csequence_bglt) CREF(new1503_3708))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									  ((((csequence_bglt) CREF(new1503_3708))->cops) = ((obj_t) arg2413_2135), BUNSPEC);
									  res2625_3715 = new1503_3708;
								       }
								       arg2411_2133 = res2625_3715;
								    }
								 }
								 {	/* Cgen/cgen.scm 649 */
								    block_bglt res2626_3724;
								    {	/* Cgen/cgen.scm 649 */
								       cop_bglt body_3717;
								       body_3717 =
									  (cop_bglt) (arg2411_2133);
								       {	/* ./Cgen/cop.scm 1952 */
									  block_bglt new1459_3718;
									  new1459_3718 =
									     ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
									  {	/* ./Cgen/cop.scm 1952 */
									     long arg1955_3719;
									     arg1955_3719 =
										class_num_218___object(block_cgen_cop);
									     {	/* ./Cgen/cop.scm 1952 */
										obj_t obj_3722;
										obj_3722 =
										   (obj_t) (new1459_3718);
										(((obj_t) CREF(obj_3722))->header = MAKE_HEADER(arg1955_3719, 0), BUNSPEC);
									     }
									  }
									  {	/* ./Cgen/cop.scm 1952 */
									     object_bglt aux_5856;
									     aux_5856 =
										(object_bglt) (new1459_3718);
									     OBJECT_WIDENING_SET(aux_5856, BFALSE);
									  }
									  ((((block_bglt) CREF(new1459_3718))->loc) = ((obj_t) arg2410_2132), BUNSPEC);
									  ((((block_bglt) CREF(new1459_3718))->body) = ((cop_bglt) body_3717), BUNSPEC);
									  res2626_3724 = new1459_3718;
								       }
								    }
								    aux_4506 =
								       (obj_t) (res2626_3724);
								 }
							      }
							   }
							 else
							   {	/* Cgen/cgen.scm 666 */
							      bool_t test2432_2154;
							      {		/* Cgen/cgen.scm 666 */
								 bool_t test2479_2201;
								 test2479_2201 =
								    is_a__118___object(
								    (obj_t) (ecop_2125), csetq_cgen_cop);
								 if (test2479_2201)
								   {	/* ./Ieee/equiv.scm 5508 */
								      obj_t aux_5871;
								      obj_t aux_5865;
								      aux_5871 =
									 (obj_t) (eaux_2124);
								      {		/* Cgen/cgen.scm 666 */
									 variable_bglt aux_5866;
									 {	/* Cgen/cgen.scm 666 */
									    varc_bglt arg2481_2203;
									    {	/* Cgen/cgen.scm 666 */
									       csetq_bglt obj_3726;
									       obj_3726 =
										  (csetq_bglt) (ecop_2125);
									       arg2481_2203 =
										  (((csetq_bglt) CREF(obj_3726))->var);
									    }
									    aux_5866 =
									       (((varc_bglt) CREF(arg2481_2203))->variable);
									 }
									 aux_5865 =
									    (obj_t) (aux_5866);
								      }
								      test2432_2154 =
									 (aux_5865 == aux_5871);
								   }
								 else
								   {	/* Cgen/cgen.scm 666 */
								      test2432_2154 = ((bool_t) 0);
								   }
							      }
							      if (test2432_2154)
								{	/* Cgen/cgen.scm 666 */
								   {	/* Cgen/cgen.scm 667 */
								      obj_t arg2433_2155;
								      csequence_bglt arg2434_2156;
								      arg2433_2155 =
									 (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
								      {		/* Cgen/cgen.scm 669 */
									 obj_t arg2435_2157;
									 obj_t arg2436_2158;
									 arg2435_2157 =
									    (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									 {	/* Cgen/cgen.scm 671 */
									    local_var_164_bglt arg2437_2159;
									    csequence_bglt arg2438_2160;
									    cjump_ex_it_131_bglt arg2439_2161;
									    {	/* Cgen/cgen.scm 671 */
									       obj_t arg2443_2165;
									       obj_t arg2444_2166;
									       arg2443_2165 =
										  (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									       {	/* Cgen/cgen.scm 673 */
										  obj_t list2445_2167;
										  {	/* Cgen/cgen.scm 673 */
										     obj_t aux_5878;
										     aux_5878 =
											(obj_t) (vaux_2121);
										     list2445_2167 =
											MAKE_PAIR(aux_5878, BNIL);
										  }
										  arg2444_2166 = list2445_2167;
									       }
									       {	/* Cgen/cgen.scm 671 */
										  local_var_164_bglt res2627_3742;
										  {	/* ./Cgen/cop.scm 1993 */
										     local_var_164_bglt new1536_3736;
										     new1536_3736 =
											((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
										     {	/* ./Cgen/cop.scm 1993 */
											long arg1930_3737;
											arg1930_3737 =
											   class_num_218___object(local_var_164_cgen_cop);
											{	/* ./Cgen/cop.scm 1993 */
											   obj_t obj_3740;
											   obj_3740 =
											      (obj_t) (new1536_3736);
											   (((obj_t) CREF(obj_3740))->header = MAKE_HEADER(arg1930_3737, 0), BUNSPEC);
											}
										     }
										     {	/* ./Cgen/cop.scm 1993 */
											object_bglt aux_5885;
											aux_5885 =
											   (object_bglt) (new1536_3736);
											OBJECT_WIDENING_SET(aux_5885, BFALSE);
										     }
										     ((((local_var_164_bglt) CREF(new1536_3736))->loc) = ((obj_t) arg2443_2165), BUNSPEC);
										     ((((local_var_164_bglt) CREF(new1536_3736))->vars) = ((obj_t) arg2444_2166), BUNSPEC);
										     res2627_3742 = new1536_3736;
										  }
										  arg2437_2159 = res2627_3742;
									       }
									    }
									    {	/* Cgen/cgen.scm 674 */
									       obj_t arg2446_2168;
									       obj_t arg2447_2169;
									       arg2446_2168 =
										  (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									       {	/* Cgen/cgen.scm 676 */
										  obj_t list2448_2170;
										  {	/* Cgen/cgen.scm 676 */
										     obj_t aux_5891;
										     aux_5891 =
											(obj_t) (vcop_2122);
										     list2448_2170 =
											MAKE_PAIR(aux_5891, BNIL);
										  }
										  arg2447_2169 = list2448_2170;
									       }
									       {	/* Cgen/cgen.scm 674 */
										  csequence_bglt res2628_3755;
										  {	/* ./Cgen/cop.scm 1975 */
										     csequence_bglt new1503_3748;
										     new1503_3748 =
											((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
										     {	/* ./Cgen/cop.scm 1975 */
											long arg1940_3749;
											arg1940_3749 =
											   class_num_218___object(csequence_cgen_cop);
											{	/* ./Cgen/cop.scm 1975 */
											   obj_t obj_3753;
											   obj_3753 =
											      (obj_t) (new1503_3748);
											   (((obj_t) CREF(obj_3753))->header = MAKE_HEADER(arg1940_3749, 0), BUNSPEC);
											}
										     }
										     {	/* ./Cgen/cop.scm 1975 */
											object_bglt aux_5898;
											aux_5898 =
											   (object_bglt) (new1503_3748);
											OBJECT_WIDENING_SET(aux_5898, BFALSE);
										     }
										     ((((csequence_bglt) CREF(new1503_3748))->loc) = ((obj_t) arg2446_2168), BUNSPEC);
										     ((((csequence_bglt) CREF(new1503_3748))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
										     ((((csequence_bglt) CREF(new1503_3748))->cops) = ((obj_t) arg2447_2169), BUNSPEC);
										     res2628_3755 = new1503_3748;
										  }
										  arg2438_2160 = res2628_3755;
									       }
									    }
									    {	/* Cgen/cgen.scm 678 */
									       cjump_ex_it_131_bglt arg2449_2171;
									       {	/* Cgen/cgen.scm 678 */
										  obj_t arg2450_2172;
										  cop_bglt arg2451_2173;
										  varc_bglt arg2452_2174;
										  arg2450_2172 =
										     (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
										  {	/* Cgen/cgen.scm 680 */
										     csetq_bglt obj_3757;
										     obj_3757 =
											(csetq_bglt) (ecop_2125);
										     arg2451_2173 =
											(((csetq_bglt) CREF(obj_3757))->value);
										  }
										  {	/* Cgen/cgen.scm 681 */
										     obj_t arg2453_2175;
										     arg2453_2175 =
											(((jump_ex_it_184_bglt) CREF(node_2118))->loc);
										     {	/* Cgen/cgen.scm 681 */
											varc_bglt res2629_3767;
											{	/* Cgen/cgen.scm 681 */
											   variable_bglt variable_3760;
											   variable_3760 =
											      (variable_bglt) (vaux_2121);
											   {	/* ./Cgen/cop.scm 1964 */
											      varc_bglt new1483_3761;
											      new1483_3761 =
												 ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
											      {		/* ./Cgen/cop.scm 1964 */
												 long arg1946_3762;
												 arg1946_3762 =
												    class_num_218___object(varc_cgen_cop);
												 {	/* ./Cgen/cop.scm 1964 */
												    obj_t obj_3765;
												    obj_3765 =
												       (obj_t) (new1483_3761);
												    (((obj_t) CREF(obj_3765))->header = MAKE_HEADER(arg1946_3762, 0), BUNSPEC);
												 }
											      }
											      {		/* ./Cgen/cop.scm 1964 */
												 object_bglt aux_5913;
												 aux_5913 =
												    (object_bglt) (new1483_3761);
												 OBJECT_WIDENING_SET(aux_5913, BFALSE);
											      }
											      ((((varc_bglt) CREF(new1483_3761))->loc) = ((obj_t) arg2453_2175), BUNSPEC);
											      ((((varc_bglt) CREF(new1483_3761))->variable) = ((variable_bglt) variable_3760), BUNSPEC);
											      res2629_3767 = new1483_3761;
											   }
											}
											arg2452_2174 = res2629_3767;
										     }
										  }
										  {	/* Cgen/cgen.scm 678 */
										     cjump_ex_it_131_bglt res2630_3778;
										     {	/* Cgen/cgen.scm 678 */
											cop_bglt value_3770;
											value_3770 =
											   (cop_bglt) (arg2452_2174);
											{	/* ./Cgen/cop.scm 2033 */
											   cjump_ex_it_131_bglt new1606_3771;
											   new1606_3771 =
											      ((cjump_ex_it_131_bglt) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
											   {	/* ./Cgen/cop.scm 2033 */
											      long arg1907_3772;
											      arg1907_3772 =
												 class_num_218___object(cjump_ex_it_131_cgen_cop);
											      {		/* ./Cgen/cop.scm 2033 */
												 obj_t obj_3776;
												 obj_3776 =
												    (obj_t) (new1606_3771);
												 (((obj_t) CREF(obj_3776))->header = MAKE_HEADER(arg1907_3772, 0), BUNSPEC);
											      }
											   }
											   {	/* ./Cgen/cop.scm 2033 */
											      object_bglt aux_5923;
											      aux_5923 =
												 (object_bglt) (new1606_3771);
											      OBJECT_WIDENING_SET(aux_5923, BFALSE);
											   }
											   ((((cjump_ex_it_131_bglt) CREF(new1606_3771))->loc) = ((obj_t) arg2450_2172), BUNSPEC);
											   ((((cjump_ex_it_131_bglt) CREF(new1606_3771))->exit) = ((cop_bglt) arg2451_2173), BUNSPEC);
											   ((((cjump_ex_it_131_bglt) CREF(new1606_3771))->value) = ((cop_bglt) value_3770), BUNSPEC);
											   res2630_3778 = new1606_3771;
											}
										     }
										     arg2449_2171 = res2630_3778;
										  }
									       }
									       arg2439_2161 = arg2449_2171;
									    }
									    {	/* Cgen/cgen.scm 671 */
									       obj_t list2440_2162;
									       {	/* Cgen/cgen.scm 671 */
										  obj_t arg2441_2163;
										  {	/* Cgen/cgen.scm 671 */
										     obj_t arg2442_2164;
										     {	/* Cgen/cgen.scm 671 */
											obj_t aux_5929;
											aux_5929 =
											   (obj_t) (arg2439_2161);
											arg2442_2164 =
											   MAKE_PAIR(aux_5929, BNIL);
										     }
										     {	/* Cgen/cgen.scm 671 */
											obj_t aux_5932;
											aux_5932 =
											   (obj_t) (arg2438_2160);
											arg2441_2163 =
											   MAKE_PAIR(aux_5932, arg2442_2164);
										     }
										  }
										  {	/* Cgen/cgen.scm 671 */
										     obj_t aux_5935;
										     aux_5935 =
											(obj_t) (arg2437_2159);
										     list2440_2162 =
											MAKE_PAIR(aux_5935, arg2441_2163);
										  }
									       }
									       arg2436_2158 = list2440_2162;
									    }
									 }
									 {	/* Cgen/cgen.scm 669 */
									    csequence_bglt res2631_3791;
									    {	/* ./Cgen/cop.scm 1975 */
									       csequence_bglt new1503_3784;
									       new1503_3784 =
										  ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
									       {	/* ./Cgen/cop.scm 1975 */
										  long arg1940_3785;
										  arg1940_3785 =
										     class_num_218___object(csequence_cgen_cop);
										  {	/* ./Cgen/cop.scm 1975 */
										     obj_t obj_3789;
										     obj_3789 =
											(obj_t) (new1503_3784);
										     (((obj_t) CREF(obj_3789))->header = MAKE_HEADER(arg1940_3785, 0), BUNSPEC);
										  }
									       }
									       {	/* ./Cgen/cop.scm 1975 */
										  object_bglt aux_5942;
										  aux_5942 =
										     (object_bglt) (new1503_3784);
										  OBJECT_WIDENING_SET(aux_5942, BFALSE);
									       }
									       ((((csequence_bglt) CREF(new1503_3784))->loc) = ((obj_t) arg2435_2157), BUNSPEC);
									       ((((csequence_bglt) CREF(new1503_3784))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									       ((((csequence_bglt) CREF(new1503_3784))->cops) = ((obj_t) arg2436_2158), BUNSPEC);
									       res2631_3791 = new1503_3784;
									    }
									    arg2434_2156 = res2631_3791;
									 }
								      }
								      {		/* Cgen/cgen.scm 667 */
									 block_bglt res2632_3800;
									 {	/* Cgen/cgen.scm 667 */
									    cop_bglt body_3793;
									    body_3793 =
									       (cop_bglt) (arg2434_2156);
									    {	/* ./Cgen/cop.scm 1952 */
									       block_bglt new1459_3794;
									       new1459_3794 =
										  ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
									       {	/* ./Cgen/cop.scm 1952 */
										  long arg1955_3795;
										  arg1955_3795 =
										     class_num_218___object(block_cgen_cop);
										  {	/* ./Cgen/cop.scm 1952 */
										     obj_t obj_3798;
										     obj_3798 =
											(obj_t) (new1459_3794);
										     (((obj_t) CREF(obj_3798))->header = MAKE_HEADER(arg1955_3795, 0), BUNSPEC);
										  }
									       }
									       {	/* ./Cgen/cop.scm 1952 */
										  object_bglt aux_5953;
										  aux_5953 =
										     (object_bglt) (new1459_3794);
										  OBJECT_WIDENING_SET(aux_5953, BFALSE);
									       }
									       ((((block_bglt) CREF(new1459_3794))->loc) = ((obj_t) arg2433_2155), BUNSPEC);
									       ((((block_bglt) CREF(new1459_3794))->body) = ((cop_bglt) body_3793), BUNSPEC);
									       res2632_3800 = new1459_3794;
									    }
									 }
									 aux_4506 =
									    (obj_t) (res2632_3800);
								      }
								   }
								}
							      else
								{	/* Cgen/cgen.scm 666 */
								   {	/* Cgen/cgen.scm 685 */
								      obj_t arg2455_2177;
								      csequence_bglt arg2456_2178;
								      arg2455_2177 =
									 (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
								      {		/* Cgen/cgen.scm 687 */
									 obj_t arg2457_2179;
									 obj_t arg2458_2180;
									 arg2457_2179 =
									    (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									 {	/* Cgen/cgen.scm 691 */
									    local_var_164_bglt arg2459_2181;
									    csequence_bglt arg2460_2182;
									    cjump_ex_it_131_bglt arg2461_2183;
									    {	/* Cgen/cgen.scm 691 */
									       obj_t arg2465_2187;
									       obj_t arg2466_2188;
									       arg2465_2187 =
										  (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									       {	/* Cgen/cgen.scm 693 */
										  obj_t list2467_2189;
										  {	/* Cgen/cgen.scm 693 */
										     obj_t arg2468_2190;
										     {	/* Cgen/cgen.scm 693 */
											obj_t aux_5962;
											aux_5962 =
											   (obj_t) (vaux_2121);
											arg2468_2190 =
											   MAKE_PAIR(aux_5962, BNIL);
										     }
										     {	/* Cgen/cgen.scm 693 */
											obj_t aux_5965;
											aux_5965 =
											   (obj_t) (eaux_2124);
											list2467_2189 =
											   MAKE_PAIR(aux_5965, arg2468_2190);
										     }
										  }
										  arg2466_2188 = list2467_2189;
									       }
									       {	/* Cgen/cgen.scm 691 */
										  local_var_164_bglt res2633_3813;
										  {	/* ./Cgen/cop.scm 1993 */
										     local_var_164_bglt new1536_3807;
										     new1536_3807 =
											((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
										     {	/* ./Cgen/cop.scm 1993 */
											long arg1930_3808;
											arg1930_3808 =
											   class_num_218___object(local_var_164_cgen_cop);
											{	/* ./Cgen/cop.scm 1993 */
											   obj_t obj_3811;
											   obj_3811 =
											      (obj_t) (new1536_3807);
											   (((obj_t) CREF(obj_3811))->header = MAKE_HEADER(arg1930_3808, 0), BUNSPEC);
											}
										     }
										     {	/* ./Cgen/cop.scm 1993 */
											object_bglt aux_5972;
											aux_5972 =
											   (object_bglt) (new1536_3807);
											OBJECT_WIDENING_SET(aux_5972, BFALSE);
										     }
										     ((((local_var_164_bglt) CREF(new1536_3807))->loc) = ((obj_t) arg2465_2187), BUNSPEC);
										     ((((local_var_164_bglt) CREF(new1536_3807))->vars) = ((obj_t) arg2466_2188), BUNSPEC);
										     res2633_3813 = new1536_3807;
										  }
										  arg2459_2181 = res2633_3813;
									       }
									    }
									    {	/* Cgen/cgen.scm 694 */
									       obj_t arg2469_2191;
									       obj_t arg2470_2192;
									       arg2469_2191 =
										  (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
									       {	/* Cgen/cgen.scm 696 */
										  obj_t list2471_2193;
										  {	/* Cgen/cgen.scm 696 */
										     obj_t arg2472_2194;
										     {	/* Cgen/cgen.scm 696 */
											obj_t aux_5978;
											aux_5978 =
											   (obj_t) (vcop_2122);
											arg2472_2194 =
											   MAKE_PAIR(aux_5978, BNIL);
										     }
										     {	/* Cgen/cgen.scm 696 */
											obj_t aux_5981;
											aux_5981 =
											   (obj_t) (ecop_2125);
											list2471_2193 =
											   MAKE_PAIR(aux_5981, arg2472_2194);
										     }
										  }
										  arg2470_2192 = list2471_2193;
									       }
									       {	/* Cgen/cgen.scm 694 */
										  csequence_bglt res2634_3826;
										  {	/* ./Cgen/cop.scm 1975 */
										     csequence_bglt new1503_3819;
										     new1503_3819 =
											((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
										     {	/* ./Cgen/cop.scm 1975 */
											long arg1940_3820;
											arg1940_3820 =
											   class_num_218___object(csequence_cgen_cop);
											{	/* ./Cgen/cop.scm 1975 */
											   obj_t obj_3824;
											   obj_3824 =
											      (obj_t) (new1503_3819);
											   (((obj_t) CREF(obj_3824))->header = MAKE_HEADER(arg1940_3820, 0), BUNSPEC);
											}
										     }
										     {	/* ./Cgen/cop.scm 1975 */
											object_bglt aux_5988;
											aux_5988 =
											   (object_bglt) (new1503_3819);
											OBJECT_WIDENING_SET(aux_5988, BFALSE);
										     }
										     ((((csequence_bglt) CREF(new1503_3819))->loc) = ((obj_t) arg2469_2191), BUNSPEC);
										     ((((csequence_bglt) CREF(new1503_3819))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
										     ((((csequence_bglt) CREF(new1503_3819))->cops) = ((obj_t) arg2470_2192), BUNSPEC);
										     res2634_3826 = new1503_3819;
										  }
										  arg2460_2182 = res2634_3826;
									       }
									    }
									    {	/* Cgen/cgen.scm 698 */
									       cjump_ex_it_131_bglt arg2473_2195;
									       {	/* Cgen/cgen.scm 698 */
										  obj_t arg2474_2196;
										  varc_bglt arg2475_2197;
										  varc_bglt arg2476_2198;
										  arg2474_2196 =
										     (((jump_ex_it_184_bglt) CREF(node_2118))->loc);
										  {	/* Cgen/cgen.scm 700 */
										     varc_bglt res2635_3836;
										     {	/* Cgen/cgen.scm 700 */
											obj_t loc_3828;
											variable_bglt variable_3829;
											loc_3828 = BFALSE;
											variable_3829 =
											   (variable_bglt) (eaux_2124);
											{	/* ./Cgen/cop.scm 1964 */
											   varc_bglt new1483_3830;
											   new1483_3830 =
											      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
											   {	/* ./Cgen/cop.scm 1964 */
											      long arg1946_3831;
											      arg1946_3831 =
												 class_num_218___object(varc_cgen_cop);
											      {		/* ./Cgen/cop.scm 1964 */
												 obj_t obj_3834;
												 obj_3834 =
												    (obj_t) (new1483_3830);
												 (((obj_t) CREF(obj_3834))->header = MAKE_HEADER(arg1946_3831, 0), BUNSPEC);
											      }
											   }
											   {	/* ./Cgen/cop.scm 1964 */
											      object_bglt aux_6000;
											      aux_6000 =
												 (object_bglt) (new1483_3830);
											      OBJECT_WIDENING_SET(aux_6000, loc_3828);
											   }
											   ((((varc_bglt) CREF(new1483_3830))->loc) = ((obj_t) loc_3828), BUNSPEC);
											   ((((varc_bglt) CREF(new1483_3830))->variable) = ((variable_bglt) variable_3829), BUNSPEC);
											   res2635_3836 = new1483_3830;
											}
										     }
										     arg2475_2197 = res2635_3836;
										  }
										  {	/* Cgen/cgen.scm 702 */
										     varc_bglt res2636_3845;
										     {	/* Cgen/cgen.scm 702 */
											obj_t loc_3837;
											variable_bglt variable_3838;
											loc_3837 = BFALSE;
											variable_3838 =
											   (variable_bglt) (vaux_2121);
											{	/* ./Cgen/cop.scm 1964 */
											   varc_bglt new1483_3839;
											   new1483_3839 =
											      ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
											   {	/* ./Cgen/cop.scm 1964 */
											      long arg1946_3840;
											      arg1946_3840 =
												 class_num_218___object(varc_cgen_cop);
											      {		/* ./Cgen/cop.scm 1964 */
												 obj_t obj_3843;
												 obj_3843 =
												    (obj_t) (new1483_3839);
												 (((obj_t) CREF(obj_3843))->header = MAKE_HEADER(arg1946_3840, 0), BUNSPEC);
											      }
											   }
											   {	/* ./Cgen/cop.scm 1964 */
											      object_bglt aux_6010;
											      aux_6010 =
												 (object_bglt) (new1483_3839);
											      OBJECT_WIDENING_SET(aux_6010, loc_3837);
											   }
											   ((((varc_bglt) CREF(new1483_3839))->loc) = ((obj_t) loc_3837), BUNSPEC);
											   ((((varc_bglt) CREF(new1483_3839))->variable) = ((variable_bglt) variable_3838), BUNSPEC);
											   res2636_3845 = new1483_3839;
											}
										     }
										     arg2476_2198 = res2636_3845;
										  }
										  {	/* Cgen/cgen.scm 698 */
										     cjump_ex_it_131_bglt res2637_3856;
										     {	/* Cgen/cgen.scm 698 */
											cop_bglt exit_3847;
											cop_bglt value_3848;
											exit_3847 =
											   (cop_bglt) (arg2475_2197);
											value_3848 =
											   (cop_bglt) (arg2476_2198);
											{	/* ./Cgen/cop.scm 2033 */
											   cjump_ex_it_131_bglt new1606_3849;
											   new1606_3849 =
											      ((cjump_ex_it_131_bglt) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
											   {	/* ./Cgen/cop.scm 2033 */
											      long arg1907_3850;
											      arg1907_3850 =
												 class_num_218___object(cjump_ex_it_131_cgen_cop);
											      {		/* ./Cgen/cop.scm 2033 */
												 obj_t obj_3854;
												 obj_3854 =
												    (obj_t) (new1606_3849);
												 (((obj_t) CREF(obj_3854))->header = MAKE_HEADER(arg1907_3850, 0), BUNSPEC);
											      }
											   }
											   {	/* ./Cgen/cop.scm 2033 */
											      object_bglt aux_6021;
											      aux_6021 =
												 (object_bglt) (new1606_3849);
											      OBJECT_WIDENING_SET(aux_6021, BFALSE);
											   }
											   ((((cjump_ex_it_131_bglt) CREF(new1606_3849))->loc) = ((obj_t) arg2474_2196), BUNSPEC);
											   ((((cjump_ex_it_131_bglt) CREF(new1606_3849))->exit) = ((cop_bglt) exit_3847), BUNSPEC);
											   ((((cjump_ex_it_131_bglt) CREF(new1606_3849))->value) = ((cop_bglt) value_3848), BUNSPEC);
											   res2637_3856 = new1606_3849;
											}
										     }
										     arg2473_2195 = res2637_3856;
										  }
									       }
									       arg2461_2183 = arg2473_2195;
									    }
									    {	/* Cgen/cgen.scm 689 */
									       obj_t list2462_2184;
									       {	/* Cgen/cgen.scm 689 */
										  obj_t arg2463_2185;
										  {	/* Cgen/cgen.scm 689 */
										     obj_t arg2464_2186;
										     {	/* Cgen/cgen.scm 689 */
											obj_t aux_6027;
											aux_6027 =
											   (obj_t) (arg2461_2183);
											arg2464_2186 =
											   MAKE_PAIR(aux_6027, BNIL);
										     }
										     {	/* Cgen/cgen.scm 689 */
											obj_t aux_6030;
											aux_6030 =
											   (obj_t) (arg2460_2182);
											arg2463_2185 =
											   MAKE_PAIR(aux_6030, arg2464_2186);
										     }
										  }
										  {	/* Cgen/cgen.scm 689 */
										     obj_t aux_6033;
										     aux_6033 =
											(obj_t) (arg2459_2181);
										     list2462_2184 =
											MAKE_PAIR(aux_6033, arg2463_2185);
										  }
									       }
									       arg2458_2180 = list2462_2184;
									    }
									 }
									 {	/* Cgen/cgen.scm 687 */
									    csequence_bglt res2638_3869;
									    {	/* ./Cgen/cop.scm 1975 */
									       csequence_bglt new1503_3862;
									       new1503_3862 =
										  ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
									       {	/* ./Cgen/cop.scm 1975 */
										  long arg1940_3863;
										  arg1940_3863 =
										     class_num_218___object(csequence_cgen_cop);
										  {	/* ./Cgen/cop.scm 1975 */
										     obj_t obj_3867;
										     obj_3867 =
											(obj_t) (new1503_3862);
										     (((obj_t) CREF(obj_3867))->header = MAKE_HEADER(arg1940_3863, 0), BUNSPEC);
										  }
									       }
									       {	/* ./Cgen/cop.scm 1975 */
										  object_bglt aux_6040;
										  aux_6040 =
										     (object_bglt) (new1503_3862);
										  OBJECT_WIDENING_SET(aux_6040, BFALSE);
									       }
									       ((((csequence_bglt) CREF(new1503_3862))->loc) = ((obj_t) arg2457_2179), BUNSPEC);
									       ((((csequence_bglt) CREF(new1503_3862))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									       ((((csequence_bglt) CREF(new1503_3862))->cops) = ((obj_t) arg2458_2180), BUNSPEC);
									       res2638_3869 = new1503_3862;
									    }
									    arg2456_2178 = res2638_3869;
									 }
								      }
								      {		/* Cgen/cgen.scm 685 */
									 block_bglt res2639_3878;
									 {	/* Cgen/cgen.scm 685 */
									    cop_bglt body_3871;
									    body_3871 =
									       (cop_bglt) (arg2456_2178);
									    {	/* ./Cgen/cop.scm 1952 */
									       block_bglt new1459_3872;
									       new1459_3872 =
										  ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
									       {	/* ./Cgen/cop.scm 1952 */
										  long arg1955_3873;
										  arg1955_3873 =
										     class_num_218___object(block_cgen_cop);
										  {	/* ./Cgen/cop.scm 1952 */
										     obj_t obj_3876;
										     obj_3876 =
											(obj_t) (new1459_3872);
										     (((obj_t) CREF(obj_3876))->header = MAKE_HEADER(arg1955_3873, 0), BUNSPEC);
										  }
									       }
									       {	/* ./Cgen/cop.scm 1952 */
										  object_bglt aux_6051;
										  aux_6051 =
										     (object_bglt) (new1459_3872);
										  OBJECT_WIDENING_SET(aux_6051, BFALSE);
									       }
									       ((((block_bglt) CREF(new1459_3872))->loc) = ((obj_t) arg2455_2177), BUNSPEC);
									       ((((block_bglt) CREF(new1459_3872))->body) = ((cop_bglt) body_3871), BUNSPEC);
									       res2639_3878 = new1459_3872;
									    }
									 }
									 aux_4506 =
									    (obj_t) (res2639_3878);
								      }
								   }
								}
							   }
						      }
						 }
					      }
					   }
					}
				     }
				  }
			       }
			    }
			    break;
			 case ((long) 15):

			    {	/* Cgen/cgen.scm 232 */
			       make_box_202_bglt node_2217;
			       node_2217 =
				  (make_box_202_bglt) (node_26);
			       {	/* Cgen/cgen.scm 712 */
				  bool_t test2495_2220;
				  {	/* Cgen/cgen.scm 712 */
				     bool_t test2521_2250;
				     {	/* ./Ast/node.scm 1678 */
					obj_t aux_6058;
					{	/* Cgen/cgen.scm 712 */
					   node_bglt aux_6059;
					   aux_6059 =
					      (((make_box_202_bglt) CREF(node_2217))->value);
					   aux_6058 =
					      (obj_t) (aux_6059);
					}
					test2521_2250 =
					   is_a__118___object(aux_6058, var_ast_node);
				     }
				     if (test2521_2250)
				       {	/* Cgen/cgen.scm 712 */
					  test2495_2220 = ((bool_t) 1);
				       }
				     else
				       {	/* Cgen/cgen.scm 712 */
					  bool_t test2522_2251;
					  {	/* ./Ast/node.scm 1673 */
					     obj_t aux_6064;
					     {	/* Cgen/cgen.scm 712 */
						node_bglt aux_6065;
						aux_6065 =
						   (((make_box_202_bglt) CREF(node_2217))->value);
						aux_6064 =
						   (obj_t) (aux_6065);
					     }
					     test2522_2251 =
						is_a__118___object(aux_6064, atom_ast_node);
					  }
					  if (test2522_2251)
					    {	/* Cgen/cgen.scm 712 */
					       test2495_2220 = ((bool_t) 1);
					    }
					  else
					    {	/* ./Ast/node.scm 1686 */
					       obj_t aux_6070;
					       {	/* Cgen/cgen.scm 712 */
						  node_bglt aux_6071;
						  aux_6071 =
						     (((make_box_202_bglt) CREF(node_2217))->value);
						  aux_6070 =
						     (obj_t) (aux_6071);
					       }
					       test2495_2220 =
						  is_a__118___object(aux_6070, kwote_ast_node);
					    }
				       }
				  }
				  if (test2495_2220)
				    {	/* Cgen/cgen.scm 713 */
				       node_bglt arg2496_2221;
				       arg2496_2221 =
					  (((make_box_202_bglt) CREF(node_2217))->value);
				       {	/* Cgen/cgen.scm 714 */
					  obj_t _anonymous_2498__115_4033;
					  _anonymous_2498__115_4033 =
					     make_fx_procedure(_anonymous_2498__115_cgen_cgen, ((long) 1), ((long) 2));
					  {	/* Cgen/cgen.scm 714 */
					     obj_t aux_6078;
					     aux_6078 =
						(obj_t) (node_2217);
					     PROCEDURE_SET(_anonymous_2498__115_4033, ((long) 0), aux_6078);
					  }
					  PROCEDURE_SET(_anonymous_2498__115_4033, ((long) 1), kont_27);
					  {	/* Cgen/cgen.scm 713 */
					     cop_bglt aux_6082;
					     aux_6082 =
						node__cop_142_cgen_cgen(arg2496_2221, _anonymous_2498__115_4033);
					     aux_4506 =
						(obj_t) (aux_6082);
					  }
				       }
				    }
				  else
				    {	/* Cgen/cgen.scm 717 */
				       local_bglt aux_2229;
				       aux_2229 =
					  make_local_svar_name_219_cgen_cgen(
					  CNST_TABLE_REF(((long) 9)),
					  (type_bglt) (_obj__252_type_cache));
				       {	/* Cgen/cgen.scm 717 */
					  cop_bglt cval_2230;
					  {	/* Cgen/cgen.scm 718 */
					     setq_bglt arg2519_2248;
					     arg2519_2248 =
						node_setq_243_cgen_cgen(
						(variable_bglt) (aux_2229),
						(((make_box_202_bglt) CREF(node_2217))->value));
					     cval_2230 =
						node__cop_142_cgen_cgen(
						(node_bglt) (arg2519_2248), _id_kont__126_cgen_cgen);
					  }
					  {	/* Cgen/cgen.scm 718 */

					     {	/* Cgen/cgen.scm 719 */
						obj_t arg2502_2231;
						csequence_bglt arg2503_2232;
						arg2502_2231 =
						   (((make_box_202_bglt) CREF(node_2217))->loc);
						{	/* Cgen/cgen.scm 721 */
						   obj_t arg2504_2233;
						   obj_t arg2505_2234;
						   arg2504_2233 =
						      (((make_box_202_bglt) CREF(node_2217))->loc);
						   {	/* Cgen/cgen.scm 724 */
						      local_var_164_bglt arg2506_2235;
						      obj_t arg2507_2236;
						      {		/* Cgen/cgen.scm 724 */
							 obj_t arg2511_2240;
							 obj_t arg2512_2241;
							 arg2511_2240 =
							    (((make_box_202_bglt) CREF(node_2217))->loc);
							 {	/* Cgen/cgen.scm 726 */
							    obj_t list2513_2242;
							    {	/* Cgen/cgen.scm 726 */
							       obj_t aux_6096;
							       aux_6096 =
								  (obj_t) (aux_2229);
							       list2513_2242 =
								  MAKE_PAIR(aux_6096, BNIL);
							    }
							    arg2512_2241 = list2513_2242;
							 }
							 {	/* Cgen/cgen.scm 724 */
							    local_var_164_bglt res2641_3909;
							    {	/* ./Cgen/cop.scm 1993 */
							       local_var_164_bglt new1536_3903;
							       new1536_3903 =
								  ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
							       {	/* ./Cgen/cop.scm 1993 */
								  long arg1930_3904;
								  arg1930_3904 =
								     class_num_218___object(local_var_164_cgen_cop);
								  {	/* ./Cgen/cop.scm 1993 */
								     obj_t obj_3907;
								     obj_3907 =
									(obj_t) (new1536_3903);
								     (((obj_t) CREF(obj_3907))->header = MAKE_HEADER(arg1930_3904, 0), BUNSPEC);
								  }
							       }
							       {	/* ./Cgen/cop.scm 1993 */
								  object_bglt aux_6103;
								  aux_6103 =
								     (object_bglt) (new1536_3903);
								  OBJECT_WIDENING_SET(aux_6103, BFALSE);
							       }
							       ((((local_var_164_bglt) CREF(new1536_3903))->loc) = ((obj_t) arg2511_2240), BUNSPEC);
							       ((((local_var_164_bglt) CREF(new1536_3903))->vars) = ((obj_t) arg2512_2241), BUNSPEC);
							       res2641_3909 = new1536_3903;
							    }
							    arg2506_2235 = res2641_3909;
							 }
						      }
						      {		/* Cgen/cgen.scm 729 */
							 cmake_box_177_bglt arg2514_2243;
							 {	/* Cgen/cgen.scm 729 */
							    obj_t arg2515_2244;
							    varc_bglt arg2516_2245;
							    arg2515_2244 =
							       (((make_box_202_bglt) CREF(node_2217))->loc);
							    {	/* Cgen/cgen.scm 731 */
							       obj_t arg2517_2246;
							       arg2517_2246 =
								  (((make_box_202_bglt) CREF(node_2217))->loc);
							       {	/* Cgen/cgen.scm 731 */
								  varc_bglt res2642_3920;
								  {	/* Cgen/cgen.scm 731 */
								     variable_bglt variable_3913;
								     variable_3913 =
									(variable_bglt) (aux_2229);
								     {	/* ./Cgen/cop.scm 1964 */
									varc_bglt new1483_3914;
									new1483_3914 =
									   ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
									{	/* ./Cgen/cop.scm 1964 */
									   long arg1946_3915;
									   arg1946_3915 =
									      class_num_218___object(varc_cgen_cop);
									   {	/* ./Cgen/cop.scm 1964 */
									      obj_t obj_3918;
									      obj_3918 =
										 (obj_t) (new1483_3914);
									      (((obj_t) CREF(obj_3918))->header = MAKE_HEADER(arg1946_3915, 0), BUNSPEC);
									   }
									}
									{	/* ./Cgen/cop.scm 1964 */
									   object_bglt aux_6115;
									   aux_6115 =
									      (object_bglt) (new1483_3914);
									   OBJECT_WIDENING_SET(aux_6115, BFALSE);
									}
									((((varc_bglt) CREF(new1483_3914))->loc) = ((obj_t) arg2517_2246), BUNSPEC);
									((((varc_bglt) CREF(new1483_3914))->variable) = ((variable_bglt) variable_3913), BUNSPEC);
									res2642_3920 = new1483_3914;
								     }
								  }
								  arg2516_2245 = res2642_3920;
							       }
							    }
							    {	/* Cgen/cgen.scm 729 */
							       cmake_box_177_bglt res2643_3929;
							       {	/* Cgen/cgen.scm 729 */
								  cop_bglt value_3922;
								  value_3922 =
								     (cop_bglt) (arg2516_2245);
								  {	/* ./Cgen/cop.scm 2018 */
								     cmake_box_177_bglt new1579_3923;
								     new1579_3923 =
									((cmake_box_177_bglt) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
								     {	/* ./Cgen/cop.scm 2018 */
									long arg1917_3924;
									arg1917_3924 =
									   class_num_218___object(cmake_box_177_cgen_cop);
									{	/* ./Cgen/cop.scm 2018 */
									   obj_t obj_3927;
									   obj_3927 =
									      (obj_t) (new1579_3923);
									   (((obj_t) CREF(obj_3927))->header = MAKE_HEADER(arg1917_3924, 0), BUNSPEC);
									}
								     }
								     {	/* ./Cgen/cop.scm 2018 */
									object_bglt aux_6125;
									aux_6125 =
									   (object_bglt) (new1579_3923);
									OBJECT_WIDENING_SET(aux_6125, BFALSE);
								     }
								     ((((cmake_box_177_bglt) CREF(new1579_3923))->loc) = ((obj_t) arg2515_2244), BUNSPEC);
								     ((((cmake_box_177_bglt) CREF(new1579_3923))->value) = ((cop_bglt) value_3922), BUNSPEC);
								     res2643_3929 = new1579_3923;
								  }
							       }
							       arg2514_2243 = res2643_3929;
							    }
							 }
							 arg2507_2236 =
							    PROCEDURE_ENTRY(kont_27) (kont_27,
							    (obj_t) (arg2514_2243), BEOA);
						      }
						      {		/* Cgen/cgen.scm 723 */
							 obj_t list2508_2237;
							 {	/* Cgen/cgen.scm 723 */
							    obj_t arg2509_2238;
							    {	/* Cgen/cgen.scm 723 */
							       obj_t arg2510_2239;
							       arg2510_2239 =
								  MAKE_PAIR(arg2507_2236, BNIL);
							       {	/* Cgen/cgen.scm 723 */
								  obj_t aux_6134;
								  aux_6134 =
								     (obj_t) (cval_2230);
								  arg2509_2238 =
								     MAKE_PAIR(aux_6134, arg2510_2239);
							       }
							    }
							    {	/* Cgen/cgen.scm 723 */
							       obj_t aux_6137;
							       aux_6137 =
								  (obj_t) (arg2506_2235);
							       list2508_2237 =
								  MAKE_PAIR(aux_6137, arg2509_2238);
							    }
							 }
							 arg2505_2234 = list2508_2237;
						      }
						   }
						   {	/* Cgen/cgen.scm 721 */
						      csequence_bglt res2644_3941;
						      {		/* ./Cgen/cop.scm 1975 */
							 csequence_bglt new1503_3934;
							 new1503_3934 =
							    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
							 {	/* ./Cgen/cop.scm 1975 */
							    long arg1940_3935;
							    arg1940_3935 =
							       class_num_218___object(csequence_cgen_cop);
							    {	/* ./Cgen/cop.scm 1975 */
							       obj_t obj_3939;
							       obj_3939 =
								  (obj_t) (new1503_3934);
							       (((obj_t) CREF(obj_3939))->header = MAKE_HEADER(arg1940_3935, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1975 */
							    object_bglt aux_6144;
							    aux_6144 =
							       (object_bglt) (new1503_3934);
							    OBJECT_WIDENING_SET(aux_6144, BFALSE);
							 }
							 ((((csequence_bglt) CREF(new1503_3934))->loc) = ((obj_t) arg2504_2233), BUNSPEC);
							 ((((csequence_bglt) CREF(new1503_3934))->c_exp__163) = ((bool_t) ((bool_t) 0)), BUNSPEC);
							 ((((csequence_bglt) CREF(new1503_3934))->cops) = ((obj_t) arg2505_2234), BUNSPEC);
							 res2644_3941 = new1503_3934;
						      }
						      arg2503_2232 = res2644_3941;
						   }
						}
						{	/* Cgen/cgen.scm 719 */
						   block_bglt res2645_3950;
						   {	/* Cgen/cgen.scm 719 */
						      cop_bglt body_3943;
						      body_3943 =
							 (cop_bglt) (arg2503_2232);
						      {		/* ./Cgen/cop.scm 1952 */
							 block_bglt new1459_3944;
							 new1459_3944 =
							    ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
							 {	/* ./Cgen/cop.scm 1952 */
							    long arg1955_3945;
							    arg1955_3945 =
							       class_num_218___object(block_cgen_cop);
							    {	/* ./Cgen/cop.scm 1952 */
							       obj_t obj_3948;
							       obj_3948 =
								  (obj_t) (new1459_3944);
							       (((obj_t) CREF(obj_3948))->header = MAKE_HEADER(arg1955_3945, 0), BUNSPEC);
							    }
							 }
							 {	/* ./Cgen/cop.scm 1952 */
							    object_bglt aux_6155;
							    aux_6155 =
							       (object_bglt) (new1459_3944);
							    OBJECT_WIDENING_SET(aux_6155, BFALSE);
							 }
							 ((((block_bglt) CREF(new1459_3944))->loc) = ((obj_t) arg2502_2231), BUNSPEC);
							 ((((block_bglt) CREF(new1459_3944))->body) = ((cop_bglt) body_3943), BUNSPEC);
							 res2645_3950 = new1459_3944;
						      }
						   }
						   aux_4506 =
						      (obj_t) (res2645_3950);
						}
					     }
					  }
				       }
				    }
			       }
			    }
			    break;
			 case ((long) 16):

			    {	/* Cgen/cgen.scm 232 */
			       box_ref_242_bglt node_2255;
			       node_2255 =
				  (box_ref_242_bglt) (node_26);
			       {	/* Cgen/cgen.scm 742 */
				  cop_bglt arg2527_2258;
				  {	/* Cgen/cgen.scm 742 */
				     var_bglt arg2528_2259;
				     arg2528_2259 =
					(((box_ref_242_bglt) CREF(node_2255))->var);
				     {	/* Cgen/cgen.scm 742 */
					obj_t _anonymous_2530__1_4032;
					_anonymous_2530__1_4032 =
					   make_fx_procedure(_anonymous_2530__1_cgen_cgen, ((long) 1), ((long) 1));
					{	/* Cgen/cgen.scm 742 */
					   obj_t aux_6164;
					   aux_6164 =
					      (obj_t) (node_2255);
					   PROCEDURE_SET(_anonymous_2530__1_4032, ((long) 0), aux_6164);
					}
					arg2527_2258 =
					   node__cop_142_cgen_cgen(
					   (node_bglt) (arg2528_2259), _anonymous_2530__1_4032);
				     }
				  }
				  aux_4506 =
				     PROCEDURE_ENTRY(kont_27) (kont_27,
				     (obj_t) (arg2527_2258), BEOA);
			       }
			    }
			    break;
			 case ((long) 17):

			    {	/* Cgen/cgen.scm 232 */
			       box_set__221_bglt node_2266;
			       node_2266 =
				  (box_set__221_bglt) (node_26);
			       {	/* Cgen/cgen.scm 753 */
				  variable_bglt v_2269;
				  {	/* Cgen/cgen.scm 753 */
				     var_bglt arg2542_2281;
				     arg2542_2281 =
					(((box_set__221_bglt) CREF(node_2266))->var);
				     v_2269 =
					(((var_bglt) CREF(arg2542_2281))->variable);
				  }
				  {	/* Cgen/cgen.scm 754 */
				     node_bglt arg2533_2270;
				     arg2533_2270 =
					(((box_set__221_bglt) CREF(node_2266))->value);
				     {	/* Cgen/cgen.scm 755 */
					obj_t _anonymous_2535__84_4031;
					_anonymous_2535__84_4031 =
					   make_fx_procedure(_anonymous_2535__84_cgen_cgen, ((long) 1), ((long) 3));
					{	/* Cgen/cgen.scm 755 */
					   obj_t aux_6177;
					   aux_6177 =
					      (obj_t) (node_2266);
					   PROCEDURE_SET(_anonymous_2535__84_4031, ((long) 0), aux_6177);
					}
					{	/* Cgen/cgen.scm 755 */
					   obj_t aux_6180;
					   aux_6180 =
					      (obj_t) (v_2269);
					   PROCEDURE_SET(_anonymous_2535__84_4031, ((long) 1), aux_6180);
					}
					PROCEDURE_SET(_anonymous_2535__84_4031, ((long) 2), kont_27);
					{	/* Cgen/cgen.scm 754 */
					   cop_bglt aux_6184;
					   aux_6184 =
					      node__cop_142_cgen_cgen(arg2533_2270, _anonymous_2535__84_4031);
					   aux_4506 =
					      (obj_t) (aux_6184);
					}
				     }
				  }
			       }
			    }
			    break;
			 default:
			  case_else2041_1683:
			    if (
			       PROCEDUREP(method2035_1679))
			      {		/* Cgen/cgen.scm 232 */
				 aux_4506 =
				    PROCEDURE_ENTRY(method2035_1679) (method2035_1679,
				    (obj_t) (node_26), kont_27, BEOA)
				    ;
			      }
			    else
			      {		/* Cgen/cgen.scm 232 */
				 obj_t fun2034_1675;
				 fun2034_1675 =
				    PROCEDURE_REF(node__cop_env_160_cgen_cgen, ((long) 0));
				 aux_4506 =
				    PROCEDURE_ENTRY(fun2034_1675) (fun2034_1675,
				    (obj_t) (node_26), kont_27, BEOA);
			      }
			 }
		    }
		  else
		    {	/* Cgen/cgen.scm 232 */
		       goto case_else2041_1683;
		    }
	       }
	       return
		  (cop_bglt) (aux_4506);
	    }
	 }
      }
   }
}



/* _node->cop2654 */
obj_t 
_node__cop2654_244_cgen_cgen(obj_t env_4025, obj_t node_4026, obj_t kont_4027)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 232 */
      {		/* Cgen/cgen.scm 232 */
	 cop_bglt aux_6199;
	 aux_6199 =
	    node__cop_142_cgen_cgen(
	    (node_bglt) (node_4026), kont_4027);
	 return
	    (obj_t) (aux_6199);
      }
   }
}



/* <anonymous:2535> */
obj_t 
_anonymous_2535__84_cgen_cgen(obj_t env_4034, obj_t vl_4038)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 755 */
      {		/* Cgen/cgen.scm 755 */
	 obj_t instance1760_4035;
	 obj_t v_4036;
	 obj_t kont_4037;
	 instance1760_4035 =
	    PROCEDURE_REF(env_4034, ((long) 0));
	 v_4036 =
	    PROCEDURE_REF(env_4034, ((long) 1));
	 kont_4037 =
	    PROCEDURE_REF(env_4034, ((long) 2));
	 {
	    obj_t vl_2272;
	    vl_2272 = vl_4038;
	    {	/* Cgen/cgen.scm 755 */
	       cbox_set__132_bglt arg2536_2274;
	       {	/* Cgen/cgen.scm 755 */
		  obj_t arg2537_2275;
		  varc_bglt arg2538_2276;
		  {	/* Cgen/cgen.scm 755 */
		     box_set__221_bglt obj_3967;
		     obj_3967 =
			(box_set__221_bglt) (instance1760_4035);
		     arg2537_2275 =
			(((box_set__221_bglt) CREF(obj_3967))->loc);
		  }
		  {	/* Cgen/cgen.scm 757 */
		     obj_t arg2540_2278;
		     {	/* Cgen/cgen.scm 757 */
			box_set__221_bglt obj_3968;
			obj_3968 =
			   (box_set__221_bglt) (instance1760_4035);
			arg2540_2278 =
			   (((box_set__221_bglt) CREF(obj_3968))->loc);
		     }
		     {	/* Cgen/cgen.scm 757 */
			varc_bglt res2647_3977;
			{	/* Cgen/cgen.scm 757 */
			   variable_bglt variable_3970;
			   variable_3970 =
			      (variable_bglt) (v_4036);
			   {	/* ./Cgen/cop.scm 1964 */
			      varc_bglt new1483_3971;
			      new1483_3971 =
				 ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
			      {		/* ./Cgen/cop.scm 1964 */
				 long arg1946_3972;
				 arg1946_3972 =
				    class_num_218___object(varc_cgen_cop);
				 {	/* ./Cgen/cop.scm 1964 */
				    obj_t obj_3975;
				    obj_3975 =
				       (obj_t) (new1483_3971);
				    (((obj_t) CREF(obj_3975))->header = MAKE_HEADER(arg1946_3972, 0), BUNSPEC);
				 }
			      }
			      {		/* ./Cgen/cop.scm 1964 */
				 object_bglt aux_6215;
				 aux_6215 =
				    (object_bglt) (new1483_3971);
				 OBJECT_WIDENING_SET(aux_6215, BFALSE);
			      }
			      ((((varc_bglt) CREF(new1483_3971))->loc) = ((obj_t) arg2540_2278), BUNSPEC);
			      ((((varc_bglt) CREF(new1483_3971))->variable) = ((variable_bglt) variable_3970), BUNSPEC);
			      res2647_3977 = new1483_3971;
			   }
			}
			arg2538_2276 = res2647_3977;
		     }
		  }
		  {	/* Cgen/cgen.scm 755 */
		     cbox_set__132_bglt res2648_3988;
		     {	/* Cgen/cgen.scm 755 */
			cop_bglt var_3979;
			cop_bglt value_3980;
			var_3979 =
			   (cop_bglt) (arg2538_2276);
			value_3980 =
			   (cop_bglt) (vl_2272);
			{	/* ./Cgen/cop.scm 2024 */
			   cbox_set__132_bglt new1591_3981;
			   new1591_3981 =
			      ((cbox_set__132_bglt) BREF(GC_MALLOC(sizeof(struct cbox_set__132))));
			   {	/* ./Cgen/cop.scm 2024 */
			      long arg1913_3982;
			      arg1913_3982 =
				 class_num_218___object(cbox_set__132_cgen_cop);
			      {		/* ./Cgen/cop.scm 2024 */
				 obj_t obj_3986;
				 obj_3986 =
				    (obj_t) (new1591_3981);
				 (((obj_t) CREF(obj_3986))->header = MAKE_HEADER(arg1913_3982, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Cgen/cop.scm 2024 */
			      object_bglt aux_6226;
			      aux_6226 =
				 (object_bglt) (new1591_3981);
			      OBJECT_WIDENING_SET(aux_6226, BFALSE);
			   }
			   ((((cbox_set__132_bglt) CREF(new1591_3981))->loc) = ((obj_t) arg2537_2275), BUNSPEC);
			   ((((cbox_set__132_bglt) CREF(new1591_3981))->var) = ((cop_bglt) var_3979), BUNSPEC);
			   ((((cbox_set__132_bglt) CREF(new1591_3981))->value) = ((cop_bglt) value_3980), BUNSPEC);
			   res2648_3988 = new1591_3981;
			}
		     }
		     arg2536_2274 = res2648_3988;
		  }
	       }
	       return
		  PROCEDURE_ENTRY(kont_4037) (kont_4037,
		  (obj_t) (arg2536_2274), BEOA);
	    }
	 }
      }
   }
}



/* <anonymous:2530> */
obj_t 
_anonymous_2530__1_cgen_cgen(obj_t env_4039, obj_t v_4041)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 742 */
      {		/* Cgen/cgen.scm 742 */
	 obj_t instance1758_4040;
	 instance1758_4040 =
	    PROCEDURE_REF(env_4039, ((long) 0));
	 {
	    obj_t v_2261;
	    {	/* Cgen/cgen.scm 742 */
	       cbox_ref_44_bglt aux_6236;
	       v_2261 = v_4041;
	       {	/* Cgen/cgen.scm 742 */
		  obj_t arg2531_3952;
		  {	/* Cgen/cgen.scm 742 */
		     box_ref_242_bglt obj_3954;
		     obj_3954 =
			(box_ref_242_bglt) (instance1758_4040);
		     arg2531_3952 =
			(((box_ref_242_bglt) CREF(obj_3954))->loc);
		  }
		  {	/* Cgen/cgen.scm 742 */
		     cbox_ref_44_bglt res2646_3963;
		     {	/* Cgen/cgen.scm 742 */
			cop_bglt var_3956;
			var_3956 =
			   (cop_bglt) (v_2261);
			{	/* ./Cgen/cop.scm 2021 */
			   cbox_ref_44_bglt new1585_3957;
			   new1585_3957 =
			      ((cbox_ref_44_bglt) BREF(GC_MALLOC(sizeof(struct cbox_ref_44))));
			   {	/* ./Cgen/cop.scm 2021 */
			      long arg1915_3958;
			      arg1915_3958 =
				 class_num_218___object(cbox_ref_44_cgen_cop);
			      {		/* ./Cgen/cop.scm 2021 */
				 obj_t obj_3961;
				 obj_3961 =
				    (obj_t) (new1585_3957);
				 (((obj_t) CREF(obj_3961))->header = MAKE_HEADER(arg1915_3958, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Cgen/cop.scm 2021 */
			      object_bglt aux_6244;
			      aux_6244 =
				 (object_bglt) (new1585_3957);
			      OBJECT_WIDENING_SET(aux_6244, BFALSE);
			   }
			   ((((cbox_ref_44_bglt) CREF(new1585_3957))->loc) = ((obj_t) arg2531_3952), BUNSPEC);
			   ((((cbox_ref_44_bglt) CREF(new1585_3957))->var) = ((cop_bglt) var_3956), BUNSPEC);
			   res2646_3963 = new1585_3957;
			}
		     }
		     aux_6236 = res2646_3963;
		  }
	       }
	       return
		  (obj_t) (aux_6236);
	    }
	 }
      }
   }
}



/* <anonymous:2498> */
obj_t 
_anonymous_2498__115_cgen_cgen(obj_t env_4042, obj_t v_4045)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 714 */
      {		/* Cgen/cgen.scm 714 */
	 obj_t instance1751_4043;
	 obj_t kont_4044;
	 instance1751_4043 =
	    PROCEDURE_REF(env_4042, ((long) 0));
	 kont_4044 =
	    PROCEDURE_REF(env_4042, ((long) 1));
	 {
	    obj_t v_2223;
	    v_2223 = v_4045;
	    {	/* Cgen/cgen.scm 714 */
	       cmake_box_177_bglt arg2499_2225;
	       {	/* Cgen/cgen.scm 714 */
		  obj_t arg2500_2226;
		  {	/* Cgen/cgen.scm 714 */
		     make_box_202_bglt obj_3886;
		     obj_3886 =
			(make_box_202_bglt) (instance1751_4043);
		     arg2500_2226 =
			(((make_box_202_bglt) CREF(obj_3886))->loc);
		  }
		  {	/* Cgen/cgen.scm 714 */
		     cmake_box_177_bglt res2640_3895;
		     {	/* Cgen/cgen.scm 714 */
			cop_bglt value_3888;
			value_3888 =
			   (cop_bglt) (v_2223);
			{	/* ./Cgen/cop.scm 2018 */
			   cmake_box_177_bglt new1579_3889;
			   new1579_3889 =
			      ((cmake_box_177_bglt) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
			   {	/* ./Cgen/cop.scm 2018 */
			      long arg1917_3890;
			      arg1917_3890 =
				 class_num_218___object(cmake_box_177_cgen_cop);
			      {		/* ./Cgen/cop.scm 2018 */
				 obj_t obj_3893;
				 obj_3893 =
				    (obj_t) (new1579_3889);
				 (((obj_t) CREF(obj_3893))->header = MAKE_HEADER(arg1917_3890, 0), BUNSPEC);
			      }
			   }
			   {	/* ./Cgen/cop.scm 2018 */
			      object_bglt aux_6259;
			      aux_6259 =
				 (object_bglt) (new1579_3889);
			      OBJECT_WIDENING_SET(aux_6259, BFALSE);
			   }
			   ((((cmake_box_177_bglt) CREF(new1579_3889))->loc) = ((obj_t) arg2500_2226), BUNSPEC);
			   ((((cmake_box_177_bglt) CREF(new1579_3889))->value) = ((cop_bglt) value_3888), BUNSPEC);
			   res2640_3895 = new1579_3889;
			}
		     }
		     arg2499_2225 = res2640_3895;
		  }
	       }
	       return
		  PROCEDURE_ENTRY(kont_4044) (kont_4044,
		  (obj_t) (arg2499_2225), BEOA);
	    }
	 }
      }
   }
}



/* node->cop-default1765 */
cop_bglt 
node__cop_default1765_254_cgen_cgen(node_bglt node_28, obj_t kont_29)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      FAILURE(
	 CNST_TABLE_REF(((long) 10)), string2674_cgen_cgen,
	 (obj_t) (node_28));
   }
}



/* _node->cop-default1765 */
obj_t 
_node__cop_default1765_105_cgen_cgen(obj_t env_4028, obj_t node_4029, obj_t kont_4030)
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      {		/* Cgen/cgen.scm 14 */
	 cop_bglt aux_6270;
	 aux_6270 =
	    node__cop_default1765_254_cgen_cgen(
	    (node_bglt) (node_4029), kont_4030);
	 return
	    (obj_t) (aux_6270);
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_cgen()
{
   AN_OBJECT;
   {	/* Cgen/cgen.scm 14 */
      module_initialization_70_tools_trace(((long) 0), "CGEN_CGEN");
      module_initialization_70_tools_error(((long) 0), "CGEN_CGEN");
      module_initialization_70_tools_shape(((long) 0), "CGEN_CGEN");
      module_initialization_70_engine_param(((long) 0), "CGEN_CGEN");
      module_initialization_70_type_type(((long) 0), "CGEN_CGEN");
      module_initialization_70_type_tools(((long) 0), "CGEN_CGEN");
      module_initialization_70_type_cache(((long) 0), "CGEN_CGEN");
      module_initialization_70_ast_var(((long) 0), "CGEN_CGEN");
      module_initialization_70_ast_node(((long) 0), "CGEN_CGEN");
      module_initialization_70_ast_local(((long) 0), "CGEN_CGEN");
      module_initialization_70_effect_effect(((long) 0), "CGEN_CGEN");
      module_initialization_70_coerce_typeof(((long) 0), "CGEN_CGEN");
      module_initialization_70_cgen_emit(((long) 0), "CGEN_CGEN");
      module_initialization_70_cgen_cop(((long) 0), "CGEN_CGEN");
      module_initialization_70_cgen_emit_cop_239(((long) 0), "CGEN_CGEN");
      module_initialization_70_cgen_prototype(((long) 0), "CGEN_CGEN");
      return
	 module_initialization_70_cgen_capp(((long) 0), "CGEN_CGEN");
   }
}
