/*===========================================================================*/
/*   (Cgen/cop.scm)                                                          */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct cop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *cop_bglt;

typedef struct clabel
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t name;
     bool_t used__226;
     obj_t body;
  }
      *clabel_bglt;

typedef struct cgoto
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct clabel *label;
  }
     *cgoto_bglt;

typedef struct block
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
     *block_bglt;

typedef struct creturn
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
       *creturn_bglt;

typedef struct cvoid
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
     *cvoid_bglt;

typedef struct catom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t value;
  }
     *catom_bglt;

typedef struct varc
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct variable *variable;
  }
    *varc_bglt;

typedef struct cpragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t format;
     obj_t args;
  }
       *cpragma_bglt;

typedef struct ccast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct cop *arg;
  }
     *ccast_bglt;

typedef struct csequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     bool_t c_exp__163;
     obj_t cops;
  }
         *csequence_bglt;

typedef struct nop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
   *nop_bglt;

typedef struct stop
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
    *stop_bglt;

typedef struct csetq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct varc *var;
     struct cop *value;
  }
     *csetq_bglt;

typedef struct cif
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     struct cop *true;
     struct cop *false;
  }
   *cif_bglt;

typedef struct local_var_164
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     obj_t vars;
  }
             *local_var_164_bglt;

typedef struct cfuncall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
     obj_t strength;
  }
        *cfuncall_bglt;

typedef struct capply
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     struct cop *arg;
  }
      *capply_bglt;

typedef struct capp
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *fun;
     obj_t args;
  }
    *capp_bglt;

typedef struct cfail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *proc;
     struct cop *msg;
     struct cop *obj;
  }
     *cfail_bglt;

typedef struct cswitch
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *test;
     obj_t clauses;
  }
       *cswitch_bglt;

typedef struct cmake_box_177
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *value;
  }
             *cmake_box_177_bglt;

typedef struct cbox_ref_44
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
  }
           *cbox_ref_44_bglt;

typedef struct cbox_set__132
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *var;
     struct cop *value;
  }
             *cbox_set__132_bglt;

typedef struct cset_ex_it_123
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *jump_value_221;
     struct cop *body;
  }
              *cset_ex_it_123_bglt;

typedef struct cjump_ex_it_131
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *exit;
     struct cop *value;
  }
               *cjump_ex_it_131_bglt;

typedef struct sfun_c_188
  {
     struct clabel *label;
     bool_t integrated;
  }
          *sfun_c_188_bglt;

typedef struct bdb_block_21
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct cop *body;
  }
            *bdb_block_21_bglt;


extern cop_bglt make_cop_70_cgen_cop(obj_t);
static obj_t struct_object__object_cswitch2046_213_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t csetq_loc_set__106_cgen_cop(csetq_bglt, obj_t);
static obj_t _cbox_ref_var2703_234_cgen_cop(obj_t, obj_t);
static obj_t _cgoto_label2791_242_cgen_cop(obj_t, obj_t);
extern cset_ex_it_123_bglt make_cset_ex_it_102_cgen_cop(obj_t, cop_bglt, cop_bglt, cop_bglt);
extern variable_bglt varc_variable_146_cgen_cop(varc_bglt);
static obj_t _clabel_name2795_220_cgen_cop(obj_t, obj_t);
extern cif_bglt make_cif_3_cgen_cop(obj_t, cop_bglt, cop_bglt, cop_bglt);
static obj_t method_init_76_cgen_cop();
extern bdb_block_21_bglt allocate_bdb_block_152_cgen_cop();
extern bool_t local_var__228_cgen_cop(obj_t);
static obj_t _local_var_loc_set_2735_25_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _csetq_var2747_23_cgen_cop(obj_t, obj_t);
extern cop_bglt cfail_proc_96_cgen_cop(cfail_bglt);
extern bool_t csetq__161_cgen_cop(obj_t);
obj_t block_cgen_cop = BUNSPEC;
extern varc_bglt csetq_var_122_cgen_cop(csetq_bglt);
static obj_t _cbox_ref_loc_set_2701_66_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _capply_loc2726_188_cgen_cop(obj_t, obj_t);
static obj_t object__struct_ccast2088_11_cgen_cop(obj_t, obj_t);
static obj_t object__struct_local_var2064_249_cgen_cop(obj_t, obj_t);
extern capply_bglt make_capply_101_cgen_cop(obj_t, cop_bglt, cop_bglt);
static obj_t _make_cjump_ex_it2684_14_cgen_cop(obj_t, obj_t, obj_t, obj_t);
static obj_t struct_object__object_cop2126_239_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t nop_loc_175_cgen_cop(nop_bglt);
obj_t cbox_ref_44_cgen_cop = BUNSPEC;
extern cop_bglt cfail_obj_133_cgen_cop(cfail_bglt);
extern obj_t stop_loc_69_cgen_cop(stop_bglt);
extern cfail_bglt allocate_cfail_187_cgen_cop();
extern cop_bglt cfail_msg_43_cgen_cop(cfail_bglt);
static obj_t struct_object__object_cset_ex_it2030_206_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _bdb_block_loc_set_2653_71_cgen_cop(obj_t, obj_t, obj_t);
extern cswitch_bglt allocate_cswitch_92_cgen_cop();
static obj_t struct_object__object_cvoid2106_78_cgen_cop(obj_t, obj_t, obj_t);
extern stop_bglt allocate_stop_49_cgen_cop();
extern obj_t cjump_ex_it_loc_set__72_cgen_cop(cjump_ex_it_131_bglt, obj_t);
static obj_t _stop_loc_set_2750_0_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _clabel_loc2794_244_cgen_cop(obj_t, obj_t);
extern stop_bglt make_stop_166_cgen_cop(obj_t, cop_bglt);
extern cop_bglt cset_ex_it_exit_130_cgen_cop(cset_ex_it_123_bglt);
extern obj_t csequence_loc_21_cgen_cop(csequence_bglt);
extern clabel_bglt allocate_clabel_48_cgen_cop();
extern cjump_ex_it_131_bglt allocate_cjump_ex_it_67_cgen_cop();
static obj_t _sfun_c_the_closure2668_84_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_varc2098_186_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t cfail_loc_182_cgen_cop(cfail_bglt);
extern cfail_bglt make_cfail_76_cgen_cop(obj_t, cop_bglt, cop_bglt, cop_bglt);
extern obj_t clabel_name_59_cgen_cop(clabel_bglt);
static obj_t object__struct_cop2124_240_cgen_cop(obj_t, obj_t);
static obj_t _csequence__120_cgen_cop(obj_t, obj_t);
static obj_t _make_clabel2792_242_cgen_cop(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _cpragma_loc_set_2765_183_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _csequence_cops2758_78_cgen_cop(obj_t, obj_t);
extern obj_t sfun_c_property_set__116_cgen_cop(sfun_bglt, obj_t);
static obj_t _make_cif2738_107_cgen_cop(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t cbox_ref_loc_81_cgen_cop(cbox_ref_44_bglt);
static obj_t struct_object__object_csequence2086_115_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _csetq__142_cgen_cop(obj_t, obj_t);
static obj_t _ccast_loc_set_2760_174_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cif_true2742_157_cgen_cop(obj_t, obj_t);
extern cop_bglt cbox_set__var_213_cgen_cop(cbox_set__132_bglt);
static obj_t _allocate_cfuncall_49_cgen_cop(obj_t);
static obj_t _cmake_box__210_cgen_cop(obj_t, obj_t);
static obj_t _allocate_block_150_cgen_cop(obj_t);
extern cop_bglt stop_value_3_cgen_cop(stop_bglt);
extern obj_t clabel_loc_12_cgen_cop(clabel_bglt);
extern local_var_164_bglt make_local_var_50_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_body2674_249_cgen_cop(obj_t, obj_t);
static obj_t _cpragma_args2768_95_cgen_cop(obj_t, obj_t);
static obj_t object__struct_capp2052_146_cgen_cop(obj_t, obj_t);
static obj_t _cjump_ex_it_loc2686_74_cgen_cop(obj_t, obj_t);
static obj_t _cset_ex_it_loc_set_2690_33_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cop__234_cgen_cop(obj_t, obj_t);
static obj_t _make_cbox_set_2695_140_cgen_cop(obj_t, obj_t, obj_t, obj_t);
static obj_t _sfun_c_arity2658_139_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_clabel2122_160_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t sfun_c_top__135_cgen_cop(sfun_bglt);
static obj_t _cif_loc_set_2739_85_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_catom2100_63_cgen_cop(obj_t, obj_t);
static obj_t _catom_loc2774_25_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_stack_allocator_set_2663_15_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _make_capply2724_166_cgen_cop(obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_cbox_set_2032_23_cgen_cop(obj_t, obj_t);
extern cop_bglt csetq_value_168_cgen_cop(csetq_bglt);
static obj_t _sfun_c_side_effect_2660_98_cgen_cop(obj_t, obj_t);
extern obj_t local_var_loc_15_cgen_cop(local_var_164_bglt);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
static obj_t _cvoid_value2779_187_cgen_cop(obj_t, obj_t);
obj_t cjump_ex_it_131_cgen_cop = BUNSPEC;
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
static obj_t _make_cfuncall2729_117_cgen_cop(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_c_side_effect__set__242_cgen_cop(sfun_bglt, obj_t);
extern obj_t capply_loc_38_cgen_cop(capply_bglt);
extern cfuncall_bglt allocate_cfuncall_37_cgen_cop();
extern bool_t bdb_block__15_cgen_cop(obj_t);
static obj_t _make_block2784_82_cgen_cop(obj_t, obj_t, obj_t);
static obj_t struct_object__object_cfail2050_83_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_creturn_205_cgen_cop(obj_t);
static obj_t _cbox_set__var2698_92_cgen_cop(obj_t, obj_t);
obj_t cpragma_cgen_cop = BUNSPEC;
static obj_t _allocate_cbox_ref_237_cgen_cop(obj_t);
static obj_t _nop__15_cgen_cop(obj_t, obj_t);
extern obj_t clabel_loc_set__72_cgen_cop(clabel_bglt, obj_t);
extern obj_t csetq_loc_189_cgen_cop(csetq_bglt);
extern obj_t csequence_loc_set__134_cgen_cop(csequence_bglt, obj_t);
extern cop_bglt cswitch_test_204_cgen_cop(cswitch_bglt);
static obj_t _sfun_c_loc_set_2679_82_cgen_cop(obj_t, obj_t, obj_t);
extern cbox_set__132_bglt make_cbox_set__218_cgen_cop(obj_t, cop_bglt, cop_bglt);
extern cfuncall_bglt make_cfuncall_230_cgen_cop(obj_t, cop_bglt, obj_t, obj_t);
obj_t varc_cgen_cop = BUNSPEC;
static obj_t _local_var_vars2737_24_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_capply2058_20_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _sfun_c_side_effect__set_2659_80_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _sfun_c_property_set_2669_147_cgen_cop(obj_t, obj_t, obj_t);
static obj_t struct_object__object_local_var2066_83_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern bool_t block__82_cgen_cop(obj_t);
obj_t local_var_164_cgen_cop = BUNSPEC;
static obj_t _clabel_used__set_2796_69_cgen_cop(obj_t, obj_t, obj_t);
extern cbox_ref_44_bglt allocate_cbox_ref_60_cgen_cop();
static obj_t _cswitch_loc_set_2709_251_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t creturn_loc_120_cgen_cop(creturn_bglt);
obj_t catom_cgen_cop = BUNSPEC;
static obj_t _sfun_c_body_set_2673_171_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_clabel2120_136_cgen_cop(obj_t, obj_t);
obj_t nop_cgen_cop = BUNSPEC;
extern obj_t cop_loc_231_cgen_cop(cop_bglt);
extern bdb_block_21_bglt make_bdb_block_176_cgen_cop(obj_t, cop_bglt);
obj_t ccast_cgen_cop = BUNSPEC;
extern obj_t ccast_loc_144_cgen_cop(ccast_bglt);
static obj_t _sfun_c_the_closure_set_2667_98_cgen_cop(obj_t, obj_t, obj_t);
extern cbox_ref_44_bglt make_cbox_ref_208_cgen_cop(obj_t, cop_bglt);
obj_t cswitch_cgen_cop = BUNSPEC;
static obj_t _cfail_obj2718_3_cgen_cop(obj_t, obj_t);
obj_t cgoto_cgen_cop = BUNSPEC;
extern cop_bglt cbox_set__value_106_cgen_cop(cbox_set__132_bglt);
static obj_t _make_cvoid2776_254_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t cvoid_loc_set__124_cgen_cop(cvoid_bglt, obj_t);
extern obj_t module_initialization_70_cgen_cop(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _cfail_proc2716_134_cgen_cop(obj_t, obj_t);
extern cop_bglt capply_fun_1_cgen_cop(capply_bglt);
extern obj_t sfun_c_dsssl_keywords_96_cgen_cop(sfun_bglt);
static obj_t struct_object__object_csetq2074_47_cgen_cop(obj_t, obj_t, obj_t);
extern cop_bglt cmake_box_value_135_cgen_cop(cmake_box_177_bglt);
extern sfun_bglt allocate_sfun_c_74_cgen_cop();
static obj_t _cif__54_cgen_cop(obj_t, obj_t);
static obj_t _allocate_clabel_4_cgen_cop(obj_t);
static obj_t _cbox_set__value2699_198_cgen_cop(obj_t, obj_t);
extern capp_bglt allocate_capp_109_cgen_cop();
extern bool_t catom__16_cgen_cop(obj_t);
obj_t cbox_set__132_cgen_cop = BUNSPEC;
extern obj_t sfun_c_predicate_of_188_cgen_cop(sfun_bglt);
extern obj_t cbox_set__loc_125_cgen_cop(cbox_set__132_bglt);
extern obj_t capp_loc_231_cgen_cop(capp_bglt);
extern capp_bglt make_capp_159_cgen_cop(obj_t, cop_bglt, obj_t);
extern obj_t local_var_loc_set__93_cgen_cop(local_var_164_bglt, obj_t);
static obj_t object__struct_cgoto2116_4_cgen_cop(obj_t, obj_t);
extern creturn_bglt allocate_creturn_170_cgen_cop();
static obj_t object__struct_cbox_ref2036_107_cgen_cop(obj_t, obj_t);
extern obj_t csequence_cops_198_cgen_cop(csequence_bglt);
extern cmake_box_177_bglt allocate_cmake_box_148_cgen_cop();
static obj_t _cfail_loc2715_124_cgen_cop(obj_t, obj_t);
static obj_t object__struct_capply2056_93_cgen_cop(obj_t, obj_t);
static obj_t _cfuncall__70_cgen_cop(obj_t, obj_t);
extern obj_t cpragma_args_115_cgen_cop(cpragma_bglt);
extern bool_t cop__160_cgen_cop(obj_t);
static obj_t _block__12_cgen_cop(obj_t, obj_t);
extern bool_t csequence_c_exp__44_cgen_cop(csequence_bglt);
static obj_t struct_object__object_cjump_ex_it2026_24_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cfuncall_loc2731_133_cgen_cop(obj_t, obj_t);
obj_t clabel_cgen_cop = BUNSPEC;
extern block_bglt allocate_block_20_cgen_cop();
extern cop_bglt cjump_ex_it_value_92_cgen_cop(cjump_ex_it_131_bglt);
static obj_t _catom_loc_set_2773_146_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t capp__160_cgen_cop(obj_t);
obj_t csetq_cgen_cop = BUNSPEC;
static obj_t _make_cmake_box2704_246_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t cset_ex_it_loc_set__45_cgen_cop(cset_ex_it_123_bglt, obj_t);
extern clabel_bglt cgoto_label_241_cgen_cop(cgoto_bglt);
extern obj_t catom_loc_set__236_cgen_cop(catom_bglt, obj_t);
static obj_t _local_var__240_cgen_cop(obj_t, obj_t);
extern bool_t stop__17_cgen_cop(obj_t);
static obj_t _cswitch__47_cgen_cop(obj_t, obj_t);
static obj_t _varc__28_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_cbox_set_2034_241_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cpragma_loc2766_89_cgen_cop(obj_t, obj_t);
static obj_t object__struct_cmake_box2040_139_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_ccast2090_43_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _ccast_type2762_222_cgen_cop(obj_t, obj_t);
obj_t bdb_block_21_cgen_cop = BUNSPEC;
static obj_t _cmake_box_loc_set_2705_128_cgen_cop(obj_t, obj_t, obj_t);
extern long class_num_218___object(obj_t);
static obj_t _make_cset_ex_it2689_144_cgen_cop(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _allocate_catom_138_cgen_cop(obj_t);
static obj_t _sfun_c_integrated_set_2682_246_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t nop__205_cgen_cop(obj_t);
extern obj_t sfun_c_dsssl_keywords_set__154_cgen_cop(sfun_bglt, obj_t);
extern block_bglt make_block_156_cgen_cop(obj_t, cop_bglt);
static obj_t _cjump_ex_it_exit2687_31_cgen_cop(obj_t, obj_t);
static obj_t _allocate_ccast_222_cgen_cop(obj_t);
obj_t stop_cgen_cop = BUNSPEC;
static obj_t _capp_args2723_194_cgen_cop(obj_t, obj_t);
static obj_t _make_creturn2780_6_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t ccast__115_cgen_cop(obj_t);
extern clabel_bglt make_clabel_15_cgen_cop(obj_t, obj_t, bool_t, obj_t);
extern cop_bglt creturn_value_251_cgen_cop(creturn_bglt);
extern obj_t sfun_c_body_138_cgen_cop(sfun_bglt);
static obj_t _allocate_cgoto_159_cgen_cop(obj_t);
extern obj_t catom_value_103_cgen_cop(catom_bglt);
static obj_t _capp_loc2721_212_cgen_cop(obj_t, obj_t);
static obj_t _cset_ex_it__255_cgen_cop(obj_t, obj_t);
static obj_t _capply_fun2727_255_cgen_cop(obj_t, obj_t);
extern cop_bglt capply_arg_66_cgen_cop(capply_bglt);
static obj_t _make_bdb_block2652_227_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t ccast_loc_set__38_cgen_cop(ccast_bglt, obj_t);
static obj_t _catom__202_cgen_cop(obj_t, obj_t);
static obj_t _cbox_set__loc_set_2696_111_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _ccast_loc2761_79_cgen_cop(obj_t, obj_t);
static obj_t _make_stop2749_252_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t sfun_c_side_effect__183_cgen_cop(sfun_bglt);
extern obj_t cop_loc_set__54_cgen_cop(cop_bglt, obj_t);
extern obj_t catom_loc_164_cgen_cop(catom_bglt);
static obj_t _make_cfail2713_227_cgen_cop(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_bdb_block2016_247_cgen_cop(obj_t, obj_t);
extern long sfun_c_arity_65_cgen_cop(sfun_bglt);
extern cop_bglt capp_fun_71_cgen_cop(capp_bglt);
extern obj_t sfun_c_the_closure_51_cgen_cop(sfun_bglt);
extern bool_t cswitch__75_cgen_cop(obj_t);
static obj_t _allocate_local_var_109_cgen_cop(obj_t);
extern csequence_bglt allocate_csequence_231_cgen_cop();
static obj_t _sfun_c_integrated2683_188_cgen_cop(obj_t, obj_t);
static obj_t _cfuncall_loc_set_2730_247_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t sfun_c_loc_set__123_cgen_cop(sfun_bglt, obj_t);
extern obj_t sfun_c_class_37_cgen_cop(sfun_bglt);
static obj_t struct_object__object_cfuncall2062_66_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t sfun_c_args_set__112_cgen_cop(sfun_bglt, obj_t);
static obj_t _cgoto_loc2790_57_cgen_cop(obj_t, obj_t);
static obj_t imported_modules_init_94_cgen_cop();
static obj_t object__struct_cset_ex_it2028_156_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_predicate_of2662_16_cgen_cop(obj_t, obj_t);
static obj_t _allocate_csetq_62_cgen_cop(obj_t);
static obj_t _allocate_varc_172_cgen_cop(obj_t);
static obj_t _creturn_value2783_240_cgen_cop(obj_t, obj_t);
extern obj_t cset_ex_it_loc_150_cgen_cop(cset_ex_it_123_bglt);
extern nop_bglt allocate_nop_42_cgen_cop();
static obj_t _csequence_loc2756_240_cgen_cop(obj_t, obj_t);
extern obj_t sfun_c_class_set__22_cgen_cop(sfun_bglt, obj_t);
static obj_t _cswitch_test2711_95_cgen_cop(obj_t, obj_t);
extern bool_t cif__209_cgen_cop(obj_t);
static obj_t _make_csequence_138_cgen_cop(obj_t, obj_t, obj_t, obj_t);
extern bool_t cset_ex_it__60_cgen_cop(obj_t);
extern bool_t cgoto__160_cgen_cop(obj_t);
static obj_t _csetq_loc_set_2745_245_cgen_cop(obj_t, obj_t, obj_t);
extern cop_bglt ccast_arg_212_cgen_cop(ccast_bglt);
static obj_t _ccast__188_cgen_cop(obj_t, obj_t);
static obj_t _creturn__112_cgen_cop(obj_t, obj_t);
extern cop_bglt cif_true_58_cgen_cop(cif_bglt);
obj_t cop_cgen_cop = BUNSPEC;
extern obj_t sfun_c_property_208_cgen_cop(sfun_bglt);
static obj_t struct_object__object_catom2102_83_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t cmake_box_loc_203_cgen_cop(cmake_box_177_bglt);
static obj_t struct_object__object_stop2078_236_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_cbox_set__70_cgen_cop(obj_t);
static obj_t _varc_loc2771_104_cgen_cop(obj_t, obj_t);
extern obj_t cpragma_loc_96_cgen_cop(cpragma_bglt);
extern obj_t sfun_c_args_197_cgen_cop(sfun_bglt);
static obj_t _cjump_ex_it_loc_set_2685_80_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cfail_msg2717_136_cgen_cop(obj_t, obj_t);
static obj_t _make_csetq2744_182_cgen_cop(obj_t, obj_t, obj_t, obj_t);
obj_t cif_cgen_cop = BUNSPEC;
static obj_t object__struct_varc2096_185_cgen_cop(obj_t, obj_t);
extern obj_t cswitch_loc_193_cgen_cop(cswitch_bglt);
static obj_t _allocate_sfun_c_103_cgen_cop(obj_t);
extern bool_t cbox_ref__107_cgen_cop(obj_t);
extern cop_bglt cjump_ex_it_exit_93_cgen_cop(cjump_ex_it_131_bglt);
obj_t creturn_cgen_cop = BUNSPEC;
extern obj_t capp_loc_set__54_cgen_cop(capp_bglt, obj_t);
static obj_t _bdb_block__112_cgen_cop(obj_t, obj_t);
static obj_t _cop_loc_set_2800_164_cgen_cop(obj_t, obj_t, obj_t);
extern cop_bglt bdb_block_body_146_cgen_cop(bdb_block_21_bglt);
static obj_t _nop_loc_set_2753_138_cgen_cop(obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_cgen_cop();
extern obj_t bdb_block_loc_147_cgen_cop(bdb_block_21_bglt);
static obj_t struct_object__object_cmake_box2042_109_cgen_cop(obj_t, obj_t, obj_t);
obj_t sfun_c_188_cgen_cop = BUNSPEC;
static obj_t _clabel_body_set_2798_179_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t cif_loc_set__209_cgen_cop(cif_bglt, obj_t);
static obj_t _creturn_loc2782_164_cgen_cop(obj_t, obj_t);
extern obj_t cgoto_loc_231_cgen_cop(cgoto_bglt);
static obj_t _sfun_c_class2676_18_cgen_cop(obj_t, obj_t);
extern bool_t creturn__207_cgen_cop(obj_t);
static obj_t _allocate_bdb_block_200_cgen_cop(obj_t);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _cop_loc2801_253_cgen_cop(obj_t, obj_t);
extern cmake_box_177_bglt make_cmake_box_87_cgen_cop(obj_t, cop_bglt);
extern bool_t sfun_c_integrated_120_cgen_cop(sfun_c_188_bglt);
extern obj_t cfuncall_loc_set__107_cgen_cop(cfuncall_bglt, obj_t);
extern obj_t capp_args_148_cgen_cop(capp_bglt);
extern obj_t varc_loc_set__52_cgen_cop(varc_bglt, obj_t);
static obj_t _make_ccast2759_63_cgen_cop(obj_t, obj_t, obj_t, obj_t);
extern catom_bglt allocate_catom_78_cgen_cop();
static obj_t _clabel_used_2797_160_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cset_ex_it_129_cgen_cop(obj_t);
static obj_t _cgoto__255_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_loc2680_171_cgen_cop(obj_t, obj_t);
extern ccast_bglt allocate_ccast_96_cgen_cop();
extern obj_t sfun_c_top__set__31_cgen_cop(sfun_bglt, bool_t);
extern sfun_c_188_bglt widening_sfun_c_140_cgen_cop(clabel_bglt, bool_t);
extern bool_t cjump_ex_it__247_cgen_cop(obj_t);
static obj_t _cif_loc2740_106_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_cif2070_34_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _capply_arg2728_51_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_bdb_block2018_62_cgen_cop(obj_t, obj_t, obj_t);
extern cgoto_bglt allocate_cgoto_58_cgen_cop();
extern sfun_c_188_bglt make_sfun_c_65_cgen_cop(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, clabel_bglt, bool_t);
static obj_t _cset_ex_it_body2694_67_cgen_cop(obj_t, obj_t);
static obj_t toplevel_init_63_cgen_cop();
static obj_t _cset_ex_it_jump_value2693_133_cgen_cop(obj_t, obj_t);
extern cop_bglt cset_ex_it_jump_value_128_cgen_cop(cset_ex_it_123_bglt);
extern obj_t sfun_c_predicate_of_set__140_cgen_cop(sfun_bglt, obj_t);
obj_t capp_cgen_cop = BUNSPEC;
extern catom_bglt make_catom_185_cgen_cop(obj_t, obj_t);
extern obj_t block_loc_set__28_cgen_cop(block_bglt, obj_t);
extern obj_t cfail_loc_set__82_cgen_cop(cfail_bglt, obj_t);
static obj_t _cswitch_clauses2712_208_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_dsssl_keywords_set_2677_173_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t sfun_c_stack_allocator_34_cgen_cop(sfun_bglt);
extern ccast_bglt make_ccast_74_cgen_cop(obj_t, type_bglt, cop_bglt);
static obj_t _allocate_stop_67_cgen_cop(obj_t);
extern obj_t cjump_ex_it_loc_12_cgen_cop(cjump_ex_it_131_bglt);
static obj_t _nop_loc2754_83_cgen_cop(obj_t, obj_t);
extern obj_t create_vector(long);
static obj_t _sfun_c_args_set_2671_36_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cpragma__0_cgen_cop(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern cgoto_bglt make_cgoto_92_cgen_cop(obj_t, clabel_bglt);
extern obj_t cmake_box_loc_set__105_cgen_cop(cmake_box_177_bglt, obj_t);
extern obj_t capply_loc_set__0_cgen_cop(capply_bglt, obj_t);
extern bool_t clabel_used__102_cgen_cop(clabel_bglt);
static obj_t _cmake_box_loc2706_234_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_cgoto2118_221_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _make_cpragma2764_6_cgen_cop(obj_t, obj_t, obj_t, obj_t);
static obj_t object__struct_cif2068_57_cgen_cop(obj_t, obj_t);
static obj_t _stop_loc2751_225_cgen_cop(obj_t, obj_t);
static obj_t _block_loc_set_2785_74_cgen_cop(obj_t, obj_t, obj_t);
obj_t cvoid_cgen_cop = BUNSPEC;
static obj_t _cif_test2741_154_cgen_cop(obj_t, obj_t);
static obj_t _block_loc2786_224_cgen_cop(obj_t, obj_t);
static obj_t _make_cbox_ref2700_166_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t sfun_ast_var;
extern obj_t cbox_ref_loc_set__77_cgen_cop(cbox_ref_44_bglt, obj_t);
static obj_t _make_capp2719_29_cgen_cop(obj_t, obj_t, obj_t, obj_t);
static obj_t _make_cswitch2708_95_cgen_cop(obj_t, obj_t, obj_t, obj_t);
extern csetq_bglt allocate_csetq_141_cgen_cop();
static obj_t _sfun_c_label2681_74_cgen_cop(obj_t, obj_t);
obj_t cmake_box_177_cgen_cop = BUNSPEC;
static obj_t _cset_ex_it_exit2692_1_cgen_cop(obj_t, obj_t);
static obj_t object__struct_cjump_ex_it2024_207_cgen_cop(obj_t, obj_t);
static obj_t object__struct_block2112_230_cgen_cop(obj_t, obj_t);
extern cpragma_bglt make_cpragma_16_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t cbox_set___212_cgen_cop(obj_t);
extern csequence_bglt make_csequence_181_cgen_cop(obj_t, bool_t, obj_t);
extern obj_t varc_loc_177_cgen_cop(varc_bglt);
static obj_t _sfun_c__160_cgen_cop(obj_t, obj_t);
extern obj_t cfuncall_loc_128_cgen_cop(cfuncall_bglt);
static obj_t _cvoid_loc_set_2777_42_cgen_cop(obj_t, obj_t, obj_t);
extern cop_bglt allocate_cop_141_cgen_cop();
extern obj_t creturn_loc_set__24_cgen_cop(creturn_bglt, obj_t);
static obj_t _cbox_ref_loc2702_21_cgen_cop(obj_t, obj_t);
extern obj_t cbox_set__loc_set__99_cgen_cop(cbox_set__132_bglt, obj_t);
extern csetq_bglt make_csetq_177_cgen_cop(obj_t, varc_bglt, cop_bglt);
extern bool_t cpragma__50_cgen_cop(obj_t);
static obj_t object__struct_creturn2108_68_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_predicate_of_set_2661_112_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cfuncall_fun2732_6_cgen_cop(obj_t, obj_t);
extern bool_t cvoid__191_cgen_cop(obj_t);
extern cif_bglt allocate_cif_90_cgen_cop();
static obj_t _sfun_c_top__set_2665_186_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _csetq_loc2746_104_cgen_cop(obj_t, obj_t);
extern obj_t object___object;
static obj_t _cvoid_loc2778_160_cgen_cop(obj_t, obj_t);
static obj_t _make_nop_127_cgen_cop(obj_t, obj_t);
static obj_t _capply__134_cgen_cop(obj_t, obj_t);
extern obj_t cpragma_format_90_cgen_cop(cpragma_bglt);
extern obj_t sfun_c_the_closure_set__169_cgen_cop(sfun_bglt, obj_t);
static obj_t struct_object__object_capp2054_65_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _sfun_c_dsssl_keywords2678_80_cgen_cop(obj_t, obj_t);
static obj_t _allocate_nop_142_cgen_cop(obj_t);
extern obj_t stop_loc_set__39_cgen_cop(stop_bglt, obj_t);
extern cswitch_bglt make_cswitch_250_cgen_cop(obj_t, cop_bglt, obj_t);
extern cop_bglt cif_test_82_cgen_cop(cif_bglt);
extern type_bglt ccast_type_180_cgen_cop(ccast_bglt);
extern capply_bglt allocate_capply_99_cgen_cop();
static obj_t _catom_value2775_242_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cvoid_169_cgen_cop(obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t _capp_fun2722_220_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_creturn2110_254_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cvoid2104_241_cgen_cop(obj_t, obj_t);
static obj_t _csetq_value2748_111_cgen_cop(obj_t, obj_t);
obj_t csequence_cgen_cop = BUNSPEC;
obj_t cfail_cgen_cop = BUNSPEC;
extern obj_t cswitch_loc_set__163_cgen_cop(cswitch_bglt, obj_t);
static obj_t _varc_variable2772_52_cgen_cop(obj_t, obj_t);
static obj_t _bdb_block_loc2654_6_cgen_cop(obj_t, obj_t);
static obj_t _cmake_box_value2707_209_cgen_cop(obj_t, obj_t);
extern obj_t cgoto_loc_set__54_cgen_cop(cgoto_bglt, obj_t);
static obj_t _cjump_ex_it_value2688_243_cgen_cop(obj_t, obj_t);
extern cop_bglt cfuncall_fun_206_cgen_cop(cfuncall_bglt);
extern bool_t csequence__124_cgen_cop(obj_t);
extern obj_t cif_loc_54_cgen_cop(cif_bglt);
static obj_t _cpragma_format2767_81_cgen_cop(obj_t, obj_t);
static obj_t _cvoid__92_cgen_cop(obj_t, obj_t);
static obj_t _creturn_loc_set_2781_243_cgen_cop(obj_t, obj_t, obj_t);
extern nop_bglt make_nop_193_cgen_cop(obj_t);
extern bool_t sfun_c__72_cgen_cop(obj_t);
static obj_t _cswitch_loc2710_128_cgen_cop(obj_t, obj_t);
static obj_t _varc_loc_set_2770_179_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t cfail__244_cgen_cop(obj_t);
extern obj_t bdb_block_loc_set__89_cgen_cop(bdb_block_21_bglt, obj_t);
static obj_t _capp__47_cgen_cop(obj_t, obj_t);
static obj_t object_init_111_cgen_cop();
extern obj_t clabel_body_set__90_cgen_cop(clabel_bglt, obj_t);
static obj_t _stop__237_cgen_cop(obj_t, obj_t);
extern cop_bglt cset_ex_it_body_210_cgen_cop(cset_ex_it_123_bglt);
static obj_t _cfuncall_strength2734_93_cgen_cop(obj_t, obj_t);
extern bool_t cmake_box__185_cgen_cop(obj_t);
static obj_t _csequence_c_exp_2757_5_cgen_cop(obj_t, obj_t);
extern cop_bglt block_body_21_cgen_cop(block_bglt);
static obj_t _sfun_c_property2670_114_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cjump_ex_it_10_cgen_cop(obj_t);
extern cset_ex_it_123_bglt allocate_cset_ex_it_68_cgen_cop();
static obj_t _bdb_block_body2655_240_cgen_cop(obj_t, obj_t);
static obj_t _allocate_capp_243_cgen_cop(obj_t);
extern obj_t sfun_c_integrated_set__24_cgen_cop(sfun_c_188_bglt, bool_t);
static obj_t _clabel__209_cgen_cop(obj_t, obj_t);
obj_t cset_ex_it_123_cgen_cop = BUNSPEC;
extern obj_t nop_loc_set__235_cgen_cop(nop_bglt, obj_t);
static obj_t _make_cgoto2788_157_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cfuncall_args2733_53_cgen_cop(obj_t, obj_t);
static obj_t _capply_loc_set_2725_48_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_cmake_box_154_cgen_cop(obj_t);
extern cjump_ex_it_131_bglt make_cjump_ex_it_216_cgen_cop(obj_t, cop_bglt, cop_bglt);
extern bool_t capply__56_cgen_cop(obj_t);
static obj_t _make_sfun_c2657_207_cgen_cop(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_c_loc_247_cgen_cop(sfun_bglt);
static obj_t _cbox_set__loc2697_223_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_nop2082_201_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cfuncall2060_199_cgen_cop(obj_t, obj_t);
static obj_t _cjump_ex_it__240_cgen_cop(obj_t, obj_t);
static obj_t _csequence_loc_set_2755_122_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _allocate_cfail_114_cgen_cop(obj_t);
static obj_t _cfail_loc_set_2714_227_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cfail2048_158_cgen_cop(obj_t, obj_t);
static obj_t _cbox_ref__77_cgen_cop(obj_t, obj_t);
extern obj_t sfun_c_body_set__172_cgen_cop(sfun_bglt, obj_t);
static obj_t _allocate_cpragma_102_cgen_cop(obj_t);
static obj_t _block_body2787_79_cgen_cop(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _cgoto_loc_set_2789_63_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _stop_value2752_82_cgen_cop(obj_t, obj_t);
static obj_t _clabel_loc_set_2793_140_cgen_cop(obj_t, obj_t, obj_t);
extern obj_t clabel_used__set__46_cgen_cop(clabel_bglt, bool_t);
static obj_t struct_object__object_cbox_ref2038_171_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _clabel_body2799_64_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_top_2666_201_cgen_cop(obj_t, obj_t);
static obj_t _cfail__212_cgen_cop(obj_t, obj_t);
static obj_t struct_object__object_sfun_c2022_82_cgen_cop(obj_t, obj_t, obj_t);
extern bool_t varc__41_cgen_cop(obj_t);
extern local_var_164_bglt allocate_local_var_218_cgen_cop();
extern obj_t cfuncall_args_216_cgen_cop(cfuncall_bglt);
extern obj_t block_loc_240_cgen_cop(block_bglt);
static obj_t object__struct_nop2080_60_cgen_cop(obj_t, obj_t);
static obj_t object__struct_stop2076_25_cgen_cop(obj_t, obj_t);
static obj_t _sfun_c_stack_allocator2664_150_cgen_cop(obj_t, obj_t);
extern cop_bglt cif_false_61_cgen_cop(cif_bglt);
extern varc_bglt allocate_varc_53_cgen_cop();
extern obj_t cswitch_clauses_50_cgen_cop(cswitch_bglt);
static obj_t _local_var_loc2736_238_cgen_cop(obj_t, obj_t);
static obj_t _widening_sfun_c2656_62_cgen_cop(obj_t, obj_t, obj_t);
extern varc_bglt make_varc_148_cgen_cop(obj_t, variable_bglt);
static obj_t _sfun_c_class_set_2675_156_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _make_catom_20_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_cpragma2092_215_cgen_cop(obj_t, obj_t);
extern obj_t cpragma_loc_set__154_cgen_cop(cpragma_bglt, obj_t);
static obj_t _make_cop_194_cgen_cop(obj_t, obj_t);
static obj_t _make_local_var_232_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _cif_false2743_174_cgen_cop(obj_t, obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern cvoid_bglt allocate_cvoid_159_cgen_cop();
static obj_t object__struct_csequence2084_122_cgen_cop(obj_t, obj_t);
static obj_t object__struct_cswitch2044_70_cgen_cop(obj_t, obj_t);
static obj_t _ccast_arg2763_63_cgen_cop(obj_t, obj_t);
static obj_t _allocate_csequence_87_cgen_cop(obj_t);
extern bool_t clabel__247_cgen_cop(obj_t);
static obj_t _allocate_capply_222_cgen_cop(obj_t);
extern bool_t cfuncall__223_cgen_cop(obj_t);
extern cop_bglt cbox_ref_var_149_cgen_cop(cbox_ref_44_bglt);
static obj_t require_initialization_114_cgen_cop = BUNSPEC;
static obj_t _cset_ex_it_loc2691_182_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cswitch_108_cgen_cop(obj_t);
static obj_t _allocate_cop_129_cgen_cop(obj_t);
extern obj_t cfuncall_strength_61_cgen_cop(cfuncall_bglt);
extern cbox_set__132_bglt allocate_cbox_set__13_cgen_cop();
static obj_t object__struct_csetq2072_83_cgen_cop(obj_t, obj_t);
static obj_t _allocate_cif_80_cgen_cop(obj_t);
extern cvoid_bglt make_cvoid_194_cgen_cop(obj_t, cop_bglt);
extern obj_t clabel_body_114_cgen_cop(clabel_bglt);
extern creturn_bglt make_creturn_204_cgen_cop(obj_t, cop_bglt);
static obj_t struct_object__object_block2114_163_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _sfun_c_args2672_223_cgen_cop(obj_t, obj_t);
extern clabel_bglt sfun_c_label_89_cgen_cop(sfun_c_188_bglt);
obj_t capply_cgen_cop = BUNSPEC;
extern cop_bglt cvoid_value_152_cgen_cop(cvoid_bglt);
static obj_t _cbox_set___248_cgen_cop(obj_t, obj_t);
static obj_t cnst_init_137_cgen_cop();
extern obj_t cvoid_loc_83_cgen_cop(cvoid_bglt);
extern cpragma_bglt allocate_cpragma_231_cgen_cop();
static obj_t struct_object__object_cpragma2094_86_cgen_cop(obj_t, obj_t, obj_t);
static obj_t object__struct_sfun_c2020_144_cgen_cop(obj_t, obj_t);
static obj_t _make_varc2769_34_cgen_cop(obj_t, obj_t, obj_t);
static obj_t _capp_loc_set_2720_91_cgen_cop(obj_t, obj_t, obj_t);
obj_t cfuncall_cgen_cop = BUNSPEC;
extern obj_t local_var_vars_243_cgen_cop(local_var_164_bglt);
extern obj_t sfun_c_stack_allocator_set__151_cgen_cop(sfun_bglt, obj_t);
static obj_t __cnst[28];

DEFINE_EXPORT_PROCEDURE(capp_fun_env_136_cgen_cop, _capp_fun2722_220_cgen_cop2866, _capp_fun2722_220_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_varc_env_82_cgen_cop, _make_varc2769_34_cgen_cop2867, _make_varc2769_34_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfail_proc_env_158_cgen_cop, _cfail_proc2716_134_cgen_cop2868, _cfail_proc2716_134_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_predicate_of_set__env_143_cgen_cop, _sfun_c_predicate_of_set_2661_112_cgen_cop2869, _sfun_c_predicate_of_set_2661_112_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cvoid_env_246_cgen_cop, _make_cvoid2776_254_cgen_cop2870, _make_cvoid2776_254_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_local_var_env_210_cgen_cop, _make_local_var_232_cgen_cop2871, _make_local_var_232_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(csetq_var_env_238_cgen_cop, _csetq_var2747_23_cgen_cop2872, _csetq_var2747_23_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_creturn_env_236_cgen_cop, _make_creturn2780_6_cgen_cop2873, _make_creturn2780_6_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cswitch_loc_set__env_255_cgen_cop, _cswitch_loc_set_2709_251_cgen_cop2874, _cswitch_loc_set_2709_251_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(clabel__env_62_cgen_cop, _clabel__209_cgen_cop2875, _clabel__209_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csequence_loc_env_123_cgen_cop, _csequence_loc2756_240_cgen_cop2876, _csequence_loc2756_240_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(creturn_value_env_173_cgen_cop, _creturn_value2783_240_cgen_cop2877, _creturn_value2783_240_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_body_set__env_224_cgen_cop, _sfun_c_body_set_2673_171_cgen_cop2878, _sfun_c_body_set_2673_171_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_var_loc_set__env_209_cgen_cop, _local_var_loc_set_2735_25_cgen_cop2879, _local_var_loc_set_2735_25_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_ccast_env_158_cgen_cop, _allocate_ccast_222_cgen_cop2880, _allocate_ccast_222_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(catom_value_env_21_cgen_cop, _catom_value2775_242_cgen_cop2881, _catom_value2775_242_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cbox_set__value_env_17_cgen_cop, _cbox_set__value2699_198_cgen_cop2882, _cbox_set__value2699_198_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csetq_value_env_132_cgen_cop, _csetq_value2748_111_cgen_cop2883, _csetq_value2748_111_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(creturn__env_8_cgen_cop, _creturn__112_cgen_cop2884, _creturn__112_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(bdb_block_loc_set__env_133_cgen_cop, _bdb_block_loc_set_2653_71_cgen_cop2885, _bdb_block_loc_set_2653_71_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2859_cgen_cop, object__struct_cop2124_240_cgen_cop2886, object__struct_cop2124_240_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2860_cgen_cop, struct_object__object_cop2126_239_cgen_cop2887, struct_object__object_cop2126_239_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2858_cgen_cop, struct_object__object_clabel2122_160_cgen_cop2888, struct_object__object_clabel2122_160_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2857_cgen_cop, object__struct_clabel2120_136_cgen_cop2889, object__struct_clabel2120_136_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2856_cgen_cop, struct_object__object_cgoto2118_221_cgen_cop2890, struct_object__object_cgoto2118_221_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2855_cgen_cop, object__struct_cgoto2116_4_cgen_cop2891, object__struct_cgoto2116_4_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2854_cgen_cop, struct_object__object_block2114_163_cgen_cop2892, struct_object__object_block2114_163_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2853_cgen_cop, object__struct_block2112_230_cgen_cop2893, object__struct_block2112_230_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2852_cgen_cop, struct_object__object_creturn2110_254_cgen_cop2894, struct_object__object_creturn2110_254_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2851_cgen_cop, object__struct_creturn2108_68_cgen_cop2895, object__struct_creturn2108_68_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2849_cgen_cop, object__struct_cvoid2104_241_cgen_cop2896, object__struct_cvoid2104_241_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2850_cgen_cop, struct_object__object_cvoid2106_78_cgen_cop2897, struct_object__object_cvoid2106_78_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2848_cgen_cop, struct_object__object_catom2102_83_cgen_cop2898, struct_object__object_catom2102_83_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2847_cgen_cop, object__struct_catom2100_63_cgen_cop2899, object__struct_catom2100_63_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2846_cgen_cop, struct_object__object_varc2098_186_cgen_cop2900, struct_object__object_varc2098_186_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2845_cgen_cop, object__struct_varc2096_185_cgen_cop2901, object__struct_varc2096_185_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2844_cgen_cop, struct_object__object_cpragma2094_86_cgen_cop2902, struct_object__object_cpragma2094_86_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2843_cgen_cop, object__struct_cpragma2092_215_cgen_cop2903, object__struct_cpragma2092_215_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2842_cgen_cop, struct_object__object_ccast2090_43_cgen_cop2904, struct_object__object_ccast2090_43_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2841_cgen_cop, object__struct_ccast2088_11_cgen_cop2905, object__struct_ccast2088_11_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2839_cgen_cop, object__struct_csequence2084_122_cgen_cop2906, object__struct_csequence2084_122_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2840_cgen_cop, struct_object__object_csequence2086_115_cgen_cop2907, struct_object__object_csequence2086_115_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2838_cgen_cop, struct_object__object_nop2082_201_cgen_cop2908, struct_object__object_nop2082_201_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2837_cgen_cop, object__struct_nop2080_60_cgen_cop2909, object__struct_nop2080_60_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2836_cgen_cop, struct_object__object_stop2078_236_cgen_cop2910, struct_object__object_stop2078_236_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2835_cgen_cop, object__struct_stop2076_25_cgen_cop2911, object__struct_stop2076_25_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2834_cgen_cop, struct_object__object_csetq2074_47_cgen_cop2912, struct_object__object_csetq2074_47_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2833_cgen_cop, object__struct_csetq2072_83_cgen_cop2913, object__struct_csetq2072_83_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2832_cgen_cop, struct_object__object_cif2070_34_cgen_cop2914, struct_object__object_cif2070_34_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2831_cgen_cop, object__struct_cif2068_57_cgen_cop2915, object__struct_cif2068_57_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2829_cgen_cop, object__struct_local_var2064_249_cgen_cop2916, object__struct_local_var2064_249_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2830_cgen_cop, struct_object__object_local_var2066_83_cgen_cop2917, struct_object__object_local_var2066_83_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2828_cgen_cop, struct_object__object_cfuncall2062_66_cgen_cop2918, struct_object__object_cfuncall2062_66_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2827_cgen_cop, object__struct_cfuncall2060_199_cgen_cop2919, object__struct_cfuncall2060_199_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2826_cgen_cop, struct_object__object_capply2058_20_cgen_cop2920, struct_object__object_capply2058_20_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2825_cgen_cop, object__struct_capply2056_93_cgen_cop2921, object__struct_capply2056_93_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2824_cgen_cop, struct_object__object_capp2054_65_cgen_cop2922, struct_object__object_capp2054_65_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(ccast_type_env_154_cgen_cop, _ccast_type2762_222_cgen_cop2923, _ccast_type2762_222_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2823_cgen_cop, object__struct_capp2052_146_cgen_cop2924, object__struct_capp2052_146_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2822_cgen_cop, struct_object__object_cfail2050_83_cgen_cop2925, struct_object__object_cfail2050_83_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2821_cgen_cop, object__struct_cfail2048_158_cgen_cop2926, object__struct_cfail2048_158_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2819_cgen_cop, object__struct_cswitch2044_70_cgen_cop2927, object__struct_cswitch2044_70_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2820_cgen_cop, struct_object__object_cswitch2046_213_cgen_cop2928, struct_object__object_cswitch2046_213_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2818_cgen_cop, struct_object__object_cmake_box2042_109_cgen_cop2929, struct_object__object_cmake_box2042_109_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2817_cgen_cop, object__struct_cmake_box2040_139_cgen_cop2930, object__struct_cmake_box2040_139_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2816_cgen_cop, struct_object__object_cbox_ref2038_171_cgen_cop2931, struct_object__object_cbox_ref2038_171_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2815_cgen_cop, object__struct_cbox_ref2036_107_cgen_cop2932, object__struct_cbox_ref2036_107_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2814_cgen_cop, struct_object__object_cbox_set_2034_241_cgen_cop2933, struct_object__object_cbox_set_2034_241_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2813_cgen_cop, object__struct_cbox_set_2032_23_cgen_cop2934, object__struct_cbox_set_2032_23_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2812_cgen_cop, struct_object__object_cset_ex_it2030_206_cgen_cop2935, struct_object__object_cset_ex_it2030_206_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2811_cgen_cop, object__struct_cset_ex_it2028_156_cgen_cop2936, object__struct_cset_ex_it2028_156_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2809_cgen_cop, object__struct_cjump_ex_it2024_207_cgen_cop2937, object__struct_cjump_ex_it2024_207_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2810_cgen_cop, struct_object__object_cjump_ex_it2026_24_cgen_cop2938, struct_object__object_cjump_ex_it2026_24_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2808_cgen_cop, struct_object__object_sfun_c2022_82_cgen_cop2939, struct_object__object_sfun_c2022_82_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2807_cgen_cop, object__struct_sfun_c2020_144_cgen_cop2940, object__struct_sfun_c2020_144_cgen_cop, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2806_cgen_cop, struct_object__object_bdb_block2018_62_cgen_cop2941, struct_object__object_bdb_block2018_62_cgen_cop, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc2805_cgen_cop, object__struct_bdb_block2016_247_cgen_cop2942, object__struct_bdb_block2016_247_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_the_closure_env_181_cgen_cop, _sfun_c_the_closure2668_84_cgen_cop2943, _sfun_c_the_closure2668_84_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cswitch_test_env_236_cgen_cop, _cswitch_test2711_95_cgen_cop2944, _cswitch_test2711_95_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cswitch_loc_env_149_cgen_cop, _cswitch_loc2710_128_cgen_cop2945, _cswitch_loc2710_128_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(capply_fun_env_233_cgen_cop, _capply_fun2727_255_cgen_cop2946, _capply_fun2727_255_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csequence_cops_env_207_cgen_cop, _csequence_cops2758_78_cgen_cop2947, _csequence_cops2758_78_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_cfail_env_22_cgen_cop, _make_cfail2713_227_cgen_cop2948, _make_cfail2713_227_cgen_cop, 0L, 4);
DEFINE_EXPORT_PROCEDURE(allocate_cmake_box_env_82_cgen_cop, _allocate_cmake_box_154_cgen_cop2949, _allocate_cmake_box_154_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(ccast_loc_set__env_162_cgen_cop, _ccast_loc_set_2760_174_cgen_cop2950, _ccast_loc_set_2760_174_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cset_ex_it_loc_set__env_125_cgen_cop, _cset_ex_it_loc_set_2690_33_cgen_cop2951, _cset_ex_it_loc_set_2690_33_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cset_ex_it_env_153_cgen_cop, _make_cset_ex_it2689_144_cgen_cop2952, _make_cset_ex_it2689_144_cgen_cop, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_cbox_set__env_12_cgen_cop, _make_cbox_set_2695_140_cgen_cop2953, _make_cbox_set_2695_140_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(sfun_c_side_effect__env_122_cgen_cop, _sfun_c_side_effect_2660_98_cgen_cop2954, _sfun_c_side_effect_2660_98_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_sfun_c_env_32_cgen_cop, _make_sfun_c2657_207_cgen_cop2955, _make_sfun_c2657_207_cgen_cop, 0L, 14);
DEFINE_EXPORT_PROCEDURE(sfun_c_integrated_set__env_6_cgen_cop, _sfun_c_integrated_set_2682_246_cgen_cop2956, _sfun_c_integrated_set_2682_246_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cjump_ex_it_exit_env_209_cgen_cop, _cjump_ex_it_exit2687_31_cgen_cop2957, _cjump_ex_it_exit2687_31_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(clabel_used__set__env_28_cgen_cop, _clabel_used__set_2796_69_cgen_cop2958, _clabel_used__set_2796_69_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(catom_loc_env_208_cgen_cop, _catom_loc2774_25_cgen_cop2959, _catom_loc2774_25_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cop_loc_set__env_19_cgen_cop, _cop_loc_set_2800_164_cgen_cop2960, _cop_loc_set_2800_164_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(nop_loc_set__env_201_cgen_cop, _nop_loc_set_2753_138_cgen_cop2961, _nop_loc_set_2753_138_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_bdb_block_env_114_cgen_cop, _allocate_bdb_block_200_cgen_cop2962, _allocate_bdb_block_200_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cop_loc_env_198_cgen_cop, _cop_loc2801_253_cgen_cop2963, _cop_loc2801_253_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cmake_box__env_203_cgen_cop, _cmake_box__210_cgen_cop2964, _cmake_box__210_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_class_env_121_cgen_cop, _sfun_c_class2676_18_cgen_cop2965, _sfun_c_class2676_18_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cjump_ex_it_loc_set__env_13_cgen_cop, _cjump_ex_it_loc_set_2685_80_cgen_cop2966, _cjump_ex_it_loc_set_2685_80_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_cop_env_232_cgen_cop, _allocate_cop_129_cgen_cop2967, _allocate_cop_129_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_catom_env_249_cgen_cop, _allocate_catom_138_cgen_cop2968, _allocate_catom_138_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cif_loc_env_19_cgen_cop, _cif_loc2740_106_cgen_cop2969, _cif_loc2740_106_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_top__env_18_cgen_cop, _sfun_c_top_2666_201_cgen_cop2970, _sfun_c_top_2666_201_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cmake_box_loc_env_223_cgen_cop, _cmake_box_loc2706_234_cgen_cop2971, _cmake_box_loc2706_234_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cop__env_157_cgen_cop, _cop__234_cgen_cop2972, _cop__234_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_the_closure_set__env_182_cgen_cop, _sfun_c_the_closure_set_2667_98_cgen_cop2973, _sfun_c_the_closure_set_2667_98_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cbox_ref_env_54_cgen_cop, _make_cbox_ref2700_166_cgen_cop2974, _make_cbox_ref2700_166_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_var_vars_env_20_cgen_cop, _local_var_vars2737_24_cgen_cop2975, _local_var_vars2737_24_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(clabel_body_env_16_cgen_cop, _clabel_body2799_64_cgen_cop2976, _clabel_body2799_64_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(nop_loc_env_176_cgen_cop, _nop_loc2754_83_cgen_cop2977, _nop_loc2754_83_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(ccast__env_172_cgen_cop, _ccast__188_cgen_cop2978, _ccast__188_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_csetq_env_7_cgen_cop, _make_csetq2744_182_cgen_cop2979, _make_csetq2744_182_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(clabel_used__env_153_cgen_cop, _clabel_used_2797_160_cgen_cop2980, _clabel_used_2797_160_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_clabel_env_164_cgen_cop, _allocate_clabel_4_cgen_cop2981, _allocate_clabel_4_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_cjump_ex_it_env_109_cgen_cop, _allocate_cjump_ex_it_10_cgen_cop2982, _allocate_cjump_ex_it_10_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfail_obj_env_248_cgen_cop, _cfail_obj2718_3_cgen_cop2983, _cfail_obj2718_3_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cpragma__env_210_cgen_cop, _cpragma__0_cgen_cop2984, _cpragma__0_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_cpragma_env_165_cgen_cop, _make_cpragma2764_6_cgen_cop2985, _make_cpragma2764_6_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(allocate_creturn_env_89_cgen_cop, _allocate_creturn_205_cgen_cop2986, _allocate_creturn_205_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_cswitch_env_150_cgen_cop, _make_cswitch2708_95_cgen_cop2987, _make_cswitch2708_95_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(sfun_c_label_env_133_cgen_cop, _sfun_c_label2681_74_cgen_cop2988, _sfun_c_label2681_74_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_loc_env_62_cgen_cop, _sfun_c_loc2680_171_cgen_cop2989, _sfun_c_loc2680_171_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_args_env_244_cgen_cop, _sfun_c_args2672_223_cgen_cop2990, _sfun_c_args2672_223_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_capply_env_184_cgen_cop, _allocate_capply_222_cgen_cop2991, _allocate_capply_222_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cjump_ex_it__env_62_cgen_cop, _cjump_ex_it__240_cgen_cop2992, _cjump_ex_it__240_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cset_ex_it_env_179_cgen_cop, _allocate_cset_ex_it_129_cgen_cop2993, _allocate_cset_ex_it_129_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_ccast_env_52_cgen_cop, _make_ccast2759_63_cgen_cop2994, _make_ccast2759_63_cgen_cop, 0L, 3);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(cswitch__env_163_cgen_cop, _cswitch__47_cgen_cop2995, _cswitch__47_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfail_loc_env_127_cgen_cop, _cfail_loc2715_124_cgen_cop2996, _cfail_loc2715_124_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(capply_arg_env_86_cgen_cop, _capply_arg2728_51_cgen_cop2997, _capply_arg2728_51_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cbox_ref_loc_env_226_cgen_cop, _cbox_ref_loc2702_21_cgen_cop2998, _cbox_ref_loc2702_21_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(nop__env_76_cgen_cop, _nop__15_cgen_cop2999, _nop__15_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cgoto_env_81_cgen_cop, _allocate_cgoto_159_cgen_cop3000, _allocate_cgoto_159_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(bdb_block_loc_env_177_cgen_cop, _bdb_block_loc2654_6_cgen_cop3001, _bdb_block_loc2654_6_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfuncall_fun_env_227_cgen_cop, _cfuncall_fun2732_6_cgen_cop3002, _cfuncall_fun2732_6_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_integrated_env_192_cgen_cop, _sfun_c_integrated2683_188_cgen_cop3003, _sfun_c_integrated2683_188_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_cmake_box_env_234_cgen_cop, _make_cmake_box2704_246_cgen_cop3004, _make_cmake_box2704_246_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cfuncall_loc_set__env_23_cgen_cop, _cfuncall_loc_set_2730_247_cgen_cop3005, _cfuncall_loc_set_2730_247_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(clabel_body_set__env_237_cgen_cop, _clabel_body_set_2798_179_cgen_cop3006, _clabel_body_set_2798_179_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(catom_loc_set__env_94_cgen_cop, _catom_loc_set_2773_146_cgen_cop3007, _catom_loc_set_2773_146_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cgoto_label_env_180_cgen_cop, _cgoto_label2791_242_cgen_cop3008, _cgoto_label2791_242_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(varc_variable_env_211_cgen_cop, _varc_variable2772_52_cgen_cop3009, _varc_variable2772_52_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(clabel_name_env_119_cgen_cop, _clabel_name2795_220_cgen_cop3010, _clabel_name2795_220_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cset_ex_it_body_env_38_cgen_cop, _cset_ex_it_body2694_67_cgen_cop3011, _cset_ex_it_body2694_67_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_stop_env_110_cgen_cop, _allocate_stop_67_cgen_cop3012, _allocate_stop_67_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(make_cif_env_221_cgen_cop, _make_cif2738_107_cgen_cop3013, _make_cif2738_107_cgen_cop, 0L, 4);
DEFINE_EXPORT_PROCEDURE(capp_args_env_82_cgen_cop, _capp_args2723_194_cgen_cop3014, _capp_args2723_194_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cif_true_env_81_cgen_cop, _cif_true2742_157_cgen_cop3015, _cif_true2742_157_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_var__env_140_cgen_cop, _local_var__240_cgen_cop3016, _local_var__240_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cmake_box_loc_set__env_166_cgen_cop, _cmake_box_loc_set_2705_128_cgen_cop3017, _cmake_box_loc_set_2705_128_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_bdb_block_env_239_cgen_cop, _make_bdb_block2652_227_cgen_cop3018, _make_bdb_block2652_227_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cswitch_clauses_env_210_cgen_cop, _cswitch_clauses2712_208_cgen_cop3019, _cswitch_clauses2712_208_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(varc_loc_set__env_59_cgen_cop, _varc_loc_set_2770_179_cgen_cop3020, _varc_loc_set_2770_179_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(stop__env_195_cgen_cop, _stop__237_cgen_cop3021, _stop__237_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_args_set__env_202_cgen_cop, _sfun_c_args_set_2671_36_cgen_cop3022, _sfun_c_args_set_2671_36_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_stop_env_242_cgen_cop, _make_stop2749_252_cgen_cop3023, _make_stop2749_252_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(ccast_loc_env_243_cgen_cop, _ccast_loc2761_79_cgen_cop3024, _ccast_loc2761_79_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(catom__env_165_cgen_cop, _catom__202_cgen_cop3025, _catom__202_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cbox_ref_env_46_cgen_cop, _allocate_cbox_ref_237_cgen_cop3026, _allocate_cbox_ref_237_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cbox_set__loc_set__env_184_cgen_cop, _cbox_set__loc_set_2696_111_cgen_cop3027, _cbox_set__loc_set_2696_111_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_c_predicate_of_env_14_cgen_cop, _sfun_c_predicate_of2662_16_cgen_cop3028, _sfun_c_predicate_of2662_16_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfuncall_args_env_213_cgen_cop, _cfuncall_args2733_53_cgen_cop3029, _cfuncall_args2733_53_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cset_ex_it_exit_env_120_cgen_cop, _cset_ex_it_exit2692_1_cgen_cop3030, _cset_ex_it_exit2692_1_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cbox_set__loc_env_217_cgen_cop, _cbox_set__loc2697_223_cgen_cop3031, _cbox_set__loc2697_223_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_catom_env_203_cgen_cop, _make_catom_20_cgen_cop3032, _make_catom_20_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cgoto_loc_env_198_cgen_cop, _cgoto_loc2790_57_cgen_cop3033, _cgoto_loc2790_57_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_clabel_env_27_cgen_cop, _make_clabel2792_242_cgen_cop3034, _make_clabel2792_242_cgen_cop, 0L, 4);
DEFINE_EXPORT_PROCEDURE(capply__env_88_cgen_cop, _capply__134_cgen_cop3035, _capply__134_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c__env_13_cgen_cop, _sfun_c__160_cgen_cop3036, _sfun_c__160_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_body_env_67_cgen_cop, _sfun_c_body2674_249_cgen_cop3037, _sfun_c_body2674_249_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_top__set__env_99_cgen_cop, _sfun_c_top__set_2665_186_cgen_cop3038, _sfun_c_top__set_2665_186_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(csetq_loc_set__env_17_cgen_cop, _csetq_loc_set_2745_245_cgen_cop3039, _csetq_loc_set_2745_245_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_capply_env_25_cgen_cop, _make_capply2724_166_cgen_cop3040, _make_capply2724_166_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(cfail_msg_env_37_cgen_cop, _cfail_msg2717_136_cgen_cop3041, _cfail_msg2717_136_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_var_loc_env_27_cgen_cop, _local_var_loc2736_238_cgen_cop3042, _local_var_loc2736_238_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvoid_value_env_114_cgen_cop, _cvoid_value2779_187_cgen_cop3043, _cvoid_value2779_187_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cbox_set___env_145_cgen_cop, _cbox_set___248_cgen_cop3044, _cbox_set___248_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(capp__env_157_cgen_cop, _capp__47_cgen_cop3045, _capp__47_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cpragma_env_198_cgen_cop, _allocate_cpragma_102_cgen_cop3046, _allocate_cpragma_102_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_cswitch_env_29_cgen_cop, _allocate_cswitch_108_cgen_cop3047, _allocate_cswitch_108_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cmake_box_value_env_18_cgen_cop, _cmake_box_value2707_209_cgen_cop3048, _cmake_box_value2707_209_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_side_effect__set__env_200_cgen_cop, _sfun_c_side_effect__set_2659_80_cgen_cop3049, _sfun_c_side_effect__set_2659_80_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cgoto_env_29_cgen_cop, _make_cgoto2788_157_cgen_cop3050, _make_cgoto2788_157_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(capp_loc_set__env_19_cgen_cop, _capp_loc_set_2720_91_cgen_cop3051, _capp_loc_set_2720_91_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(bdb_block__env_27_cgen_cop, _bdb_block__112_cgen_cop3052, _bdb_block__112_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csequence__env_55_cgen_cop, _csequence__120_cgen_cop3053, _csequence__120_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cset_ex_it_jump_value_env_80_cgen_cop, _cset_ex_it_jump_value2693_133_cgen_cop3054, _cset_ex_it_jump_value2693_133_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_property_env_54_cgen_cop, _sfun_c_property2670_114_cgen_cop3055, _sfun_c_property2670_114_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(creturn_loc_set__env_6_cgen_cop, _creturn_loc_set_2781_243_cgen_cop3056, _creturn_loc_set_2781_243_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_capp_env_45_cgen_cop, _allocate_capp_243_cgen_cop3057, _allocate_capp_243_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(csetq__env_53_cgen_cop, _csetq__142_cgen_cop3058, _csetq__142_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csequence_c_exp__env_43_cgen_cop, _csequence_c_exp_2757_5_cgen_cop3059, _csequence_c_exp_2757_5_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(stop_value_env_221_cgen_cop, _stop_value2752_82_cgen_cop3060, _stop_value2752_82_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(capply_loc_set__env_93_cgen_cop, _capply_loc_set_2725_48_cgen_cop3061, _capply_loc_set_2725_48_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(block_body_env_123_cgen_cop, _block_body2787_79_cgen_cop3062, _block_body2787_79_cgen_cop, 0L, 1);
DEFINE_STRING(string2861_cgen_cop, string2861_cgen_cop3063, "BDB-BLOCK SFUN/C CJUMP-EX-IT CSET-EX-IT CBOX-SET! CBOX-REF CMAKE-BOX CSWITCH CFAIL CAPP CAPPLY CFUNCALL LOCAL-VAR CIF CSETQ STOP NOP CSEQUENCE CCAST CPRAGMA VARC CATOM CVOID CRETURN BLOCK CGOTO CLABEL COP ", 205);
DEFINE_EXPORT_PROCEDURE(make_capp_env_139_cgen_cop, _make_capp2719_29_cgen_cop3064, _make_capp2719_29_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(capp_loc_env_198_cgen_cop, _capp_loc2721_212_cgen_cop3065, _capp_loc2721_212_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(block_loc_set__env_131_cgen_cop, _block_loc_set_2785_74_cgen_cop3066, _block_loc_set_2785_74_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(block_loc_env_95_cgen_cop, _block_loc2786_224_cgen_cop3067, _block_loc2786_224_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_nop_env_149_cgen_cop, _make_nop_127_cgen_cop3068, _make_nop_127_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cbox_ref_var_env_191_cgen_cop, _cbox_ref_var2703_234_cgen_cop3069, _cbox_ref_var2703_234_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfail__env_212_cgen_cop, _cfail__212_cgen_cop3070, _cfail__212_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(stop_loc_set__env_230_cgen_cop, _stop_loc_set_2750_0_cgen_cop3071, _stop_loc_set_2750_0_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(clabel_loc_set__env_13_cgen_cop, _clabel_loc_set_2793_140_cgen_cop3072, _clabel_loc_set_2793_140_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cpragma_loc_env_158_cgen_cop, _cpragma_loc2766_89_cgen_cop3073, _cpragma_loc2766_89_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_block_env_49_cgen_cop, _allocate_block_150_cgen_cop3074, _allocate_block_150_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cjump_ex_it_value_env_29_cgen_cop, _cjump_ex_it_value2688_243_cgen_cop3075, _cjump_ex_it_value2688_243_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvoid_loc_set__env_55_cgen_cop, _cvoid_loc_set_2777_42_cgen_cop3076, _cvoid_loc_set_2777_42_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_sfun_c_env_143_cgen_cop, _widening_sfun_c2656_62_cgen_cop3077, _widening_sfun_c2656_62_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_c_stack_allocator_env_70_cgen_cop, _sfun_c_stack_allocator2664_150_cgen_cop3078, _sfun_c_stack_allocator2664_150_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csetq_loc_env_214_cgen_cop, _csetq_loc2746_104_cgen_cop3079, _csetq_loc2746_104_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cif_env_237_cgen_cop, _allocate_cif_80_cgen_cop3080, _allocate_cif_80_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cvoid__env_2_cgen_cop, _cvoid__92_cgen_cop3081, _cvoid__92_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cgoto__env_157_cgen_cop, _cgoto__255_cgen_cop3082, _cgoto__255_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cvoid_loc_env_245_cgen_cop, _cvoid_loc2778_160_cgen_cop3083, _cvoid_loc2778_160_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfuncall_strength_env_205_cgen_cop, _cfuncall_strength2734_93_cgen_cop3084, _cfuncall_strength2734_93_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_dsssl_keywords_env_158_cgen_cop, _sfun_c_dsssl_keywords2678_80_cgen_cop3085, _sfun_c_dsssl_keywords2678_80_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_csequence_env_198_cgen_cop, _allocate_csequence_87_cgen_cop3086, _allocate_csequence_87_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(varc_loc_env_7_cgen_cop, _varc_loc2771_104_cgen_cop3087, _varc_loc2771_104_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(capply_loc_env_162_cgen_cop, _capply_loc2726_188_cgen_cop3088, _capply_loc2726_188_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_cfuncall_env_253_cgen_cop, _make_cfuncall2729_117_cgen_cop3089, _make_cfuncall2729_117_cgen_cop, 0L, 4);
DEFINE_EXPORT_PROCEDURE(cbox_set__var_env_36_cgen_cop, _cbox_set__var2698_92_cgen_cop3090, _cbox_set__var2698_92_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cvoid_env_139_cgen_cop, _allocate_cvoid_169_cgen_cop3091, _allocate_cvoid_169_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_c_arity_env_32_cgen_cop, _sfun_c_arity2658_139_cgen_cop3092, _sfun_c_arity2658_139_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cpragma_format_env_237_cgen_cop, _cpragma_format2767_81_cgen_cop3093, _cpragma_format2767_81_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cpragma_args_env_172_cgen_cop, _cpragma_args2768_95_cgen_cop3094, _cpragma_args2768_95_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cif_loc_set__env_78_cgen_cop, _cif_loc_set_2739_85_cgen_cop3095, _cif_loc_set_2739_85_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(bdb_block_body_env_211_cgen_cop, _bdb_block_body2655_240_cgen_cop3096, _bdb_block_body2655_240_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_stack_allocator_set__env_101_cgen_cop, _sfun_c_stack_allocator_set_2663_15_cgen_cop3097, _sfun_c_stack_allocator_set_2663_15_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_local_var_env_12_cgen_cop, _allocate_local_var_109_cgen_cop3098, _allocate_local_var_109_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(varc__env_66_cgen_cop, _varc__28_cgen_cop3099, _varc__28_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(clabel_loc_env_74_cgen_cop, _clabel_loc2794_244_cgen_cop3100, _clabel_loc2794_244_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_c_class_set__env_98_cgen_cop, _sfun_c_class_set_2675_156_cgen_cop3101, _sfun_c_class_set_2675_156_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_cjump_ex_it_env_213_cgen_cop, _make_cjump_ex_it2684_14_cgen_cop3102, _make_cjump_ex_it2684_14_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(cif__env_78_cgen_cop, _cif__54_cgen_cop3103, _cif__54_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfuncall__env_126_cgen_cop, _cfuncall__70_cgen_cop3104, _cfuncall__70_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_cop_env_79_cgen_cop, _make_cop_194_cgen_cop3105, _make_cop_194_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cfail_loc_set__env_106_cgen_cop, _cfail_loc_set_2714_227_cgen_cop3106, _cfail_loc_set_2714_227_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cset_ex_it__env_46_cgen_cop, _cset_ex_it__255_cgen_cop3107, _cset_ex_it__255_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(creturn_loc_env_192_cgen_cop, _creturn_loc2782_164_cgen_cop3108, _creturn_loc2782_164_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(block__env_106_cgen_cop, _block__12_cgen_cop3109, _block__12_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_cfail_env_151_cgen_cop, _allocate_cfail_114_cgen_cop3110, _allocate_cfail_114_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(stop_loc_env_84_cgen_cop, _stop_loc2751_225_cgen_cop3111, _stop_loc2751_225_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cif_test_env_106_cgen_cop, _cif_test2741_154_cgen_cop3112, _cif_test2741_154_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(csequence_loc_set__env_199_cgen_cop, _csequence_loc_set_2755_122_cgen_cop3113, _csequence_loc_set_2755_122_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_c_property_set__env_159_cgen_cop, _sfun_c_property_set_2669_147_cgen_cop3114, _sfun_c_property_set_2669_147_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cgoto_loc_set__env_19_cgen_cop, _cgoto_loc_set_2789_63_cgen_cop3115, _cgoto_loc_set_2789_63_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cbox_ref__env_23_cgen_cop, _cbox_ref__77_cgen_cop3116, _cbox_ref__77_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cpragma_loc_set__env_58_cgen_cop, _cpragma_loc_set_2765_183_cgen_cop3117, _cpragma_loc_set_2765_183_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_c_dsssl_keywords_set__env_58_cgen_cop, _sfun_c_dsssl_keywords_set_2677_173_cgen_cop3118, _sfun_c_dsssl_keywords_set_2677_173_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cjump_ex_it_loc_env_74_cgen_cop, _cjump_ex_it_loc2686_74_cgen_cop3119, _cjump_ex_it_loc2686_74_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_block_env_108_cgen_cop, _make_block2784_82_cgen_cop3120, _make_block2784_82_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_csequence_env_60_cgen_cop, _make_csequence_138_cgen_cop3121, _make_csequence_138_cgen_cop, 0L, 3);
DEFINE_EXPORT_PROCEDURE(cif_false_env_205_cgen_cop, _cif_false2743_174_cgen_cop3122, _cif_false2743_174_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cbox_ref_loc_set__env_169_cgen_cop, _cbox_ref_loc_set_2701_66_cgen_cop3123, _cbox_ref_loc_set_2701_66_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_cbox_set__env_34_cgen_cop, _allocate_cbox_set__70_cgen_cop3124, _allocate_cbox_set__70_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cset_ex_it_loc_env_9_cgen_cop, _cset_ex_it_loc2691_182_cgen_cop3125, _cset_ex_it_loc2691_182_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(ccast_arg_env_145_cgen_cop, _ccast_arg2763_63_cgen_cop3126, _ccast_arg2763_63_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_sfun_c_env_52_cgen_cop, _allocate_sfun_c_103_cgen_cop3127, _allocate_sfun_c_103_cgen_cop, 0L, 0);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(allocate_cfuncall_env_121_cgen_cop, _allocate_cfuncall_49_cgen_cop3128, _allocate_cfuncall_49_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cfuncall_loc_env_80_cgen_cop, _cfuncall_loc2731_133_cgen_cop3129, _cfuncall_loc2731_133_cgen_cop, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_varc_env_92_cgen_cop, _allocate_varc_172_cgen_cop3130, _allocate_varc_172_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(allocate_nop_env_73_cgen_cop, _allocate_nop_142_cgen_cop3131, _allocate_nop_142_cgen_cop, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_c_loc_set__env_229_cgen_cop, _sfun_c_loc_set_2679_82_cgen_cop3132, _sfun_c_loc_set_2679_82_cgen_cop, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_csetq_env_232_cgen_cop, _allocate_csetq_62_cgen_cop3133, _allocate_csetq_62_cgen_cop, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_cgen_cop(long checksum_4008, char *from_4009)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cgen_cop))
	{
	   require_initialization_114_cgen_cop =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cgen_cop();
	   cnst_init_137_cgen_cop();
	   imported_modules_init_94_cgen_cop();
	   object_init_111_cgen_cop();
	   method_init_76_cgen_cop();
	   toplevel_init_63_cgen_cop();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 14 */
      module_initialization_70___object(((long) 0), "CGEN_COP");
      module_initialization_70___reader(((long) 0), "CGEN_COP");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 14 */
      {		/* Cgen/cop.scm 14 */
	 obj_t cnst_port_138_4001;
	 cnst_port_138_4001 =
	    open_input_string(string2861_cgen_cop);
	 {
	    long i_4002;
	    i_4002 = ((long) 27);
	  loop_4003:
	    {	/* Cgen/cop.scm 14 */
	       bool_t test2862_4004;
	       test2862_4004 =
		  (i_4002 == ((long) -1));
	       if (test2862_4004)
		 {	/* Cgen/cop.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cgen/cop.scm 14 */
		    {	/* Cgen/cop.scm 14 */
		       obj_t arg2863_4005;
		       {	/* Cgen/cop.scm 14 */
			  obj_t list2864_4006;
			  list2864_4006 =
			     MAKE_PAIR(cnst_port_138_4001, BNIL);
			  arg2863_4005 =
			     read___reader(list2864_4006);
		       }
		       CNST_TABLE_SET(i_4002, arg2863_4005);
		    }
		    {	/* Cgen/cop.scm 14 */
		       int aux_4007;
		       {	/* Cgen/cop.scm 14 */
			  long aux_4027;
			  aux_4027 =
			     (i_4002 - ((long) 1));
			  aux_4007 =
			     (int) (aux_4027);
		       }
		       {
			  long i_4030;
			  i_4030 =
			     (long) (aux_4007);
			  i_4002 = i_4030;
			  goto loop_4003;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 14 */
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2127_1062;
	 obj_t arg2128_1063;
	 obj_t arg2132_1066;
	 arg2127_1062 =
	    CNST_TABLE_REF(((long) 0));
	 arg2128_1063 = object___object;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1986_1067;
	    v1986_1067 =
	       create_vector(((long) 0));
	    arg2132_1066 = v1986_1067;
	 }
	 cop_cgen_cop =
	    register_class__225___object(arg2127_1062, arg2128_1063, allocate_cop_env_232_cgen_cop, ((long) 11407), BUNSPEC, BFALSE, arg2132_1066);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2133_1068;
	 obj_t arg2134_1069;
	 obj_t arg2137_1072;
	 arg2133_1068 =
	    CNST_TABLE_REF(((long) 1));
	 arg2134_1069 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1987_1073;
	    v1987_1073 =
	       create_vector(((long) 0));
	    arg2137_1072 = v1987_1073;
	 }
	 clabel_cgen_cop =
	    register_class__225___object(arg2133_1068, arg2134_1069, allocate_clabel_env_164_cgen_cop, ((long) 11059), BUNSPEC, BFALSE, arg2137_1072);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2138_1074;
	 obj_t arg2139_1075;
	 obj_t arg2144_1078;
	 arg2138_1074 =
	    CNST_TABLE_REF(((long) 2));
	 arg2139_1075 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1988_1079;
	    v1988_1079 =
	       create_vector(((long) 0));
	    arg2144_1078 = v1988_1079;
	 }
	 cgoto_cgen_cop =
	    register_class__225___object(arg2138_1074, arg2139_1075, allocate_cgoto_env_81_cgen_cop, ((long) 48811), BUNSPEC, BFALSE, arg2144_1078);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2145_1080;
	 obj_t arg2146_1081;
	 obj_t arg2150_1084;
	 arg2145_1080 =
	    CNST_TABLE_REF(((long) 3));
	 arg2146_1081 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1989_1085;
	    v1989_1085 =
	       create_vector(((long) 0));
	    arg2150_1084 = v1989_1085;
	 }
	 block_cgen_cop =
	    register_class__225___object(arg2145_1080, arg2146_1081, allocate_block_env_49_cgen_cop, ((long) 52831), BUNSPEC, BFALSE, arg2150_1084);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2151_1086;
	 obj_t arg2153_1087;
	 obj_t arg2156_1090;
	 arg2151_1086 =
	    CNST_TABLE_REF(((long) 4));
	 arg2153_1087 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1990_1091;
	    v1990_1091 =
	       create_vector(((long) 0));
	    arg2156_1090 = v1990_1091;
	 }
	 creturn_cgen_cop =
	    register_class__225___object(arg2151_1086, arg2153_1087, allocate_creturn_env_89_cgen_cop, ((long) 15248), BUNSPEC, BFALSE, arg2156_1090);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2157_1092;
	 obj_t arg2158_1093;
	 obj_t arg2162_1096;
	 arg2157_1092 =
	    CNST_TABLE_REF(((long) 5));
	 arg2158_1093 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1991_1097;
	    v1991_1097 =
	       create_vector(((long) 0));
	    arg2162_1096 = v1991_1097;
	 }
	 cvoid_cgen_cop =
	    register_class__225___object(arg2157_1092, arg2158_1093, allocate_cvoid_env_139_cgen_cop, ((long) 55726), BUNSPEC, BFALSE, arg2162_1096);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2163_1098;
	 obj_t arg2164_1099;
	 obj_t arg2167_1102;
	 arg2163_1098 =
	    CNST_TABLE_REF(((long) 6));
	 arg2164_1099 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1992_1103;
	    v1992_1103 =
	       create_vector(((long) 0));
	    arg2167_1102 = v1992_1103;
	 }
	 catom_cgen_cop =
	    register_class__225___object(arg2163_1098, arg2164_1099, allocate_catom_env_249_cgen_cop, ((long) 64409), BUNSPEC, BFALSE, arg2167_1102);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2168_1104;
	 obj_t arg2169_1105;
	 obj_t arg2172_1108;
	 arg2168_1104 =
	    CNST_TABLE_REF(((long) 7));
	 arg2169_1105 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1993_1109;
	    v1993_1109 =
	       create_vector(((long) 0));
	    arg2172_1108 = v1993_1109;
	 }
	 varc_cgen_cop =
	    register_class__225___object(arg2168_1104, arg2169_1105, allocate_varc_env_92_cgen_cop, ((long) 19036), BUNSPEC, BFALSE, arg2172_1108);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2173_1110;
	 obj_t arg2174_1111;
	 obj_t arg2177_1114;
	 arg2173_1110 =
	    CNST_TABLE_REF(((long) 8));
	 arg2174_1111 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1994_1115;
	    v1994_1115 =
	       create_vector(((long) 0));
	    arg2177_1114 = v1994_1115;
	 }
	 cpragma_cgen_cop =
	    register_class__225___object(arg2173_1110, arg2174_1111, allocate_cpragma_env_198_cgen_cop, ((long) 21000), BUNSPEC, BFALSE, arg2177_1114);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2178_1116;
	 obj_t arg2179_1117;
	 obj_t arg2183_1120;
	 arg2178_1116 =
	    CNST_TABLE_REF(((long) 9));
	 arg2179_1117 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1995_1121;
	    v1995_1121 =
	       create_vector(((long) 0));
	    arg2183_1120 = v1995_1121;
	 }
	 ccast_cgen_cop =
	    register_class__225___object(arg2178_1116, arg2179_1117, allocate_ccast_env_158_cgen_cop, ((long) 25742), BUNSPEC, BFALSE, arg2183_1120);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2184_1122;
	 obj_t arg2185_1123;
	 obj_t arg2189_1126;
	 arg2184_1122 =
	    CNST_TABLE_REF(((long) 10));
	 arg2185_1123 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1996_1127;
	    v1996_1127 =
	       create_vector(((long) 0));
	    arg2189_1126 = v1996_1127;
	 }
	 csequence_cgen_cop =
	    register_class__225___object(arg2184_1122, arg2185_1123, allocate_csequence_env_198_cgen_cop, ((long) 22005), BUNSPEC, BFALSE, arg2189_1126);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2190_1128;
	 obj_t arg2191_1129;
	 obj_t arg2195_1132;
	 arg2190_1128 =
	    CNST_TABLE_REF(((long) 11));
	 arg2191_1129 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1997_1133;
	    v1997_1133 =
	       create_vector(((long) 0));
	    arg2195_1132 = v1997_1133;
	 }
	 nop_cgen_cop =
	    register_class__225___object(arg2190_1128, arg2191_1129, allocate_nop_env_73_cgen_cop, ((long) 7109), BUNSPEC, BFALSE, arg2195_1132);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2197_1134;
	 obj_t arg2198_1135;
	 obj_t arg2201_1138;
	 arg2197_1134 =
	    CNST_TABLE_REF(((long) 12));
	 arg2198_1135 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1998_1139;
	    v1998_1139 =
	       create_vector(((long) 0));
	    arg2201_1138 = v1998_1139;
	 }
	 stop_cgen_cop =
	    register_class__225___object(arg2197_1134, arg2198_1135, allocate_stop_env_110_cgen_cop, ((long) 5749), BUNSPEC, BFALSE, arg2201_1138);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2202_1140;
	 obj_t arg2203_1141;
	 obj_t arg2207_1144;
	 arg2202_1140 =
	    CNST_TABLE_REF(((long) 13));
	 arg2203_1141 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v1999_1145;
	    v1999_1145 =
	       create_vector(((long) 0));
	    arg2207_1144 = v1999_1145;
	 }
	 csetq_cgen_cop =
	    register_class__225___object(arg2202_1140, arg2203_1141, allocate_csetq_env_232_cgen_cop, ((long) 40138), BUNSPEC, BFALSE, arg2207_1144);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2208_1146;
	 obj_t arg2209_1147;
	 obj_t arg2212_1150;
	 arg2208_1146 =
	    CNST_TABLE_REF(((long) 14));
	 arg2209_1147 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2000_1151;
	    v2000_1151 =
	       create_vector(((long) 0));
	    arg2212_1150 = v2000_1151;
	 }
	 cif_cgen_cop =
	    register_class__225___object(arg2208_1146, arg2209_1147, allocate_cif_env_237_cgen_cop, ((long) 22507), BUNSPEC, BFALSE, arg2212_1150);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2213_1152;
	 obj_t arg2214_1153;
	 obj_t arg2217_1156;
	 arg2213_1152 =
	    CNST_TABLE_REF(((long) 15));
	 arg2214_1153 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2001_1157;
	    v2001_1157 =
	       create_vector(((long) 0));
	    arg2217_1156 = v2001_1157;
	 }
	 local_var_164_cgen_cop =
	    register_class__225___object(arg2213_1152, arg2214_1153, allocate_local_var_env_12_cgen_cop, ((long) 37069), BUNSPEC, BFALSE, arg2217_1156);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2219_1158;
	 obj_t arg2220_1159;
	 obj_t arg2224_1162;
	 arg2219_1158 =
	    CNST_TABLE_REF(((long) 16));
	 arg2220_1159 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2002_1163;
	    v2002_1163 =
	       create_vector(((long) 0));
	    arg2224_1162 = v2002_1163;
	 }
	 cfuncall_cgen_cop =
	    register_class__225___object(arg2219_1158, arg2220_1159, allocate_cfuncall_env_121_cgen_cop, ((long) 43811), BUNSPEC, BFALSE, arg2224_1162);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2225_1164;
	 obj_t arg2226_1165;
	 obj_t arg2229_1168;
	 arg2225_1164 =
	    CNST_TABLE_REF(((long) 17));
	 arg2226_1165 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2003_1169;
	    v2003_1169 =
	       create_vector(((long) 0));
	    arg2229_1168 = v2003_1169;
	 }
	 capply_cgen_cop =
	    register_class__225___object(arg2225_1164, arg2226_1165, allocate_capply_env_184_cgen_cop, ((long) 27774), BUNSPEC, BFALSE, arg2229_1168);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2230_1170;
	 obj_t arg2231_1171;
	 obj_t arg2234_1174;
	 arg2230_1170 =
	    CNST_TABLE_REF(((long) 18));
	 arg2231_1171 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2004_1175;
	    v2004_1175 =
	       create_vector(((long) 0));
	    arg2234_1174 = v2004_1175;
	 }
	 capp_cgen_cop =
	    register_class__225___object(arg2230_1170, arg2231_1171, allocate_capp_env_45_cgen_cop, ((long) 56870), BUNSPEC, BFALSE, arg2234_1174);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2236_1176;
	 obj_t arg2237_1177;
	 obj_t arg2241_1180;
	 arg2236_1176 =
	    CNST_TABLE_REF(((long) 19));
	 arg2237_1177 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2005_1181;
	    v2005_1181 =
	       create_vector(((long) 0));
	    arg2241_1180 = v2005_1181;
	 }
	 cfail_cgen_cop =
	    register_class__225___object(arg2236_1176, arg2237_1177, allocate_cfail_env_151_cgen_cop, ((long) 63849), BUNSPEC, BFALSE, arg2241_1180);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2242_1182;
	 obj_t arg2243_1183;
	 obj_t arg2246_1186;
	 arg2242_1182 =
	    CNST_TABLE_REF(((long) 20));
	 arg2243_1183 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2006_1187;
	    v2006_1187 =
	       create_vector(((long) 0));
	    arg2246_1186 = v2006_1187;
	 }
	 cswitch_cgen_cop =
	    register_class__225___object(arg2242_1182, arg2243_1183, allocate_cswitch_env_29_cgen_cop, ((long) 21483), BUNSPEC, BFALSE, arg2246_1186);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2247_1188;
	 obj_t arg2248_1189;
	 obj_t arg2251_1192;
	 arg2247_1188 =
	    CNST_TABLE_REF(((long) 21));
	 arg2248_1189 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2007_1193;
	    v2007_1193 =
	       create_vector(((long) 0));
	    arg2251_1192 = v2007_1193;
	 }
	 cmake_box_177_cgen_cop =
	    register_class__225___object(arg2247_1188, arg2248_1189, allocate_cmake_box_env_82_cgen_cop, ((long) 14804), BUNSPEC, BFALSE, arg2251_1192);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2253_1194;
	 obj_t arg2254_1195;
	 obj_t arg2257_1198;
	 arg2253_1194 =
	    CNST_TABLE_REF(((long) 22));
	 arg2254_1195 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2008_1199;
	    v2008_1199 =
	       create_vector(((long) 0));
	    arg2257_1198 = v2008_1199;
	 }
	 cbox_ref_44_cgen_cop =
	    register_class__225___object(arg2253_1194, arg2254_1195, allocate_cbox_ref_env_46_cgen_cop, ((long) 40945), BUNSPEC, BFALSE, arg2257_1198);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2258_1200;
	 obj_t arg2259_1201;
	 obj_t arg2263_1204;
	 arg2258_1200 =
	    CNST_TABLE_REF(((long) 23));
	 arg2259_1201 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2009_1205;
	    v2009_1205 =
	       create_vector(((long) 0));
	    arg2263_1204 = v2009_1205;
	 }
	 cbox_set__132_cgen_cop =
	    register_class__225___object(arg2258_1200, arg2259_1201, allocate_cbox_set__env_34_cgen_cop, ((long) 34730), BUNSPEC, BFALSE, arg2263_1204);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2264_1206;
	 obj_t arg2265_1207;
	 obj_t arg2268_1210;
	 arg2264_1206 =
	    CNST_TABLE_REF(((long) 24));
	 arg2265_1207 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2010_1211;
	    v2010_1211 =
	       create_vector(((long) 0));
	    arg2268_1210 = v2010_1211;
	 }
	 cset_ex_it_123_cgen_cop =
	    register_class__225___object(arg2264_1206, arg2265_1207, allocate_cset_ex_it_env_179_cgen_cop, ((long) 65203), BUNSPEC, BFALSE, arg2268_1210);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2269_1212;
	 obj_t arg2270_1213;
	 obj_t arg2273_1216;
	 arg2269_1212 =
	    CNST_TABLE_REF(((long) 25));
	 arg2270_1213 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2011_1217;
	    v2011_1217 =
	       create_vector(((long) 0));
	    arg2273_1216 = v2011_1217;
	 }
	 cjump_ex_it_131_cgen_cop =
	    register_class__225___object(arg2269_1212, arg2270_1213, allocate_cjump_ex_it_env_109_cgen_cop, ((long) 14432), BUNSPEC, BFALSE, arg2273_1216);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2274_1218;
	 obj_t arg2276_1219;
	 obj_t arg2280_1222;
	 arg2274_1218 =
	    CNST_TABLE_REF(((long) 26));
	 arg2276_1219 = sfun_ast_var;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2012_1223;
	    v2012_1223 =
	       create_vector(((long) 0));
	    arg2280_1222 = v2012_1223;
	 }
	 sfun_c_188_cgen_cop =
	    register_class__225___object(arg2274_1218, arg2276_1219, allocate_sfun_c_env_52_cgen_cop, ((long) 52518), BUNSPEC, BFALSE, arg2280_1222);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t arg2281_1224;
	 obj_t arg2282_1225;
	 obj_t arg2285_1228;
	 arg2281_1224 =
	    CNST_TABLE_REF(((long) 27));
	 arg2282_1225 = cop_cgen_cop;
	 {	/* Cgen/cop.scm 14 */
	    obj_t v2013_1229;
	    v2013_1229 =
	       create_vector(((long) 0));
	    arg2285_1228 = v2013_1229;
	 }
	 bdb_block_21_cgen_cop =
	    register_class__225___object(arg2281_1224, arg2282_1225, allocate_bdb_block_env_114_cgen_cop, ((long) 56220), BUNSPEC, BFALSE, arg2285_1228);
      }
      return BUNSPEC;
   }
}



/* allocate-bdb-block */
bdb_block_21_bglt 
allocate_bdb_block_152_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {		/* Cgen/cop.scm 121 */
	 bdb_block_21_bglt new1975_1230;
	 new1975_1230 =
	    ((bdb_block_21_bglt) BREF(GC_MALLOC(sizeof(struct bdb_block_21))));
	 {	/* Cgen/cop.scm 121 */
	    long arg2286_1231;
	    arg2286_1231 =
	       class_num_218___object(bdb_block_21_cgen_cop);
	    {	/* Cgen/cop.scm 121 */
	       obj_t obj_2333;
	       obj_2333 =
		  (obj_t) (new1975_1230);
	       (((obj_t) CREF(obj_2333))->header = MAKE_HEADER(arg2286_1231, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 121 */
	    object_bglt aux_4120;
	    aux_4120 =
	       (object_bglt) (new1975_1230);
	    OBJECT_WIDENING_SET(aux_4120, BFALSE);
	 }
	 return new1975_1230;
      }
   }
}



/* _allocate-bdb-block */
obj_t 
_allocate_bdb_block_200_cgen_cop(obj_t env_3334)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {		/* Cgen/cop.scm 121 */
	 bdb_block_21_bglt aux_4123;
	 aux_4123 =
	    allocate_bdb_block_152_cgen_cop();
	 return
	    (obj_t) (aux_4123);
      }
   }
}



/* bdb-block? */
bool_t 
bdb_block__15_cgen_cop(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      return
	 is_a__118___object(obj_4, bdb_block_21_cgen_cop);
   }
}



/* _bdb-block? */
obj_t 
_bdb_block__112_cgen_cop(obj_t env_3335, obj_t obj_3336)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {		/* Cgen/cop.scm 121 */
	 bool_t aux_4127;
	 aux_4127 =
	    bdb_block__15_cgen_cop(obj_3336);
	 return
	    BBOOL(aux_4127);
      }
   }
}



/* make-bdb-block */
bdb_block_21_bglt 
make_bdb_block_176_cgen_cop(obj_t loc_5, cop_bglt body_6)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {		/* Cgen/cop.scm 121 */
	 bdb_block_21_bglt new1971_2335;
	 new1971_2335 =
	    ((bdb_block_21_bglt) BREF(GC_MALLOC(sizeof(struct bdb_block_21))));
	 {	/* Cgen/cop.scm 121 */
	    long arg2287_2336;
	    arg2287_2336 =
	       class_num_218___object(bdb_block_21_cgen_cop);
	    {	/* Cgen/cop.scm 121 */
	       obj_t obj_2339;
	       obj_2339 =
		  (obj_t) (new1971_2335);
	       (((obj_t) CREF(obj_2339))->header = MAKE_HEADER(arg2287_2336, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 121 */
	    object_bglt aux_4134;
	    aux_4134 =
	       (object_bglt) (new1971_2335);
	    OBJECT_WIDENING_SET(aux_4134, BFALSE);
	 }
	 ((((bdb_block_21_bglt) CREF(new1971_2335))->loc) = ((obj_t) loc_5), BUNSPEC);
	 ((((bdb_block_21_bglt) CREF(new1971_2335))->body) = ((cop_bglt) body_6), BUNSPEC);
	 return new1971_2335;
      }
   }
}



/* _make-bdb-block2652 */
obj_t 
_make_bdb_block2652_227_cgen_cop(obj_t env_3337, obj_t loc_3338, obj_t body_3339)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {		/* Cgen/cop.scm 121 */
	 bdb_block_21_bglt aux_4139;
	 aux_4139 =
	    make_bdb_block_176_cgen_cop(loc_3338,
	    (cop_bglt) (body_3339));
	 return
	    (obj_t) (aux_4139);
      }
   }
}



/* bdb-block-loc-set! */
obj_t 
bdb_block_loc_set__89_cgen_cop(bdb_block_21_bglt obj_7, obj_t val1970_8)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((bdb_block_21_bglt) CREF(obj_7))->loc) = ((obj_t) val1970_8), BUNSPEC);
   }
}



/* _bdb-block-loc-set!2653 */
obj_t 
_bdb_block_loc_set_2653_71_cgen_cop(obj_t env_3340, obj_t obj_3341, obj_t val1970_3342)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 bdb_block_loc_set__89_cgen_cop(
	 (bdb_block_21_bglt) (obj_3341), val1970_3342);
   }
}



/* bdb-block-loc */
obj_t 
bdb_block_loc_147_cgen_cop(bdb_block_21_bglt obj_9)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((bdb_block_21_bglt) CREF(obj_9))->loc);
   }
}



/* _bdb-block-loc2654 */
obj_t 
_bdb_block_loc2654_6_cgen_cop(obj_t env_3343, obj_t obj_3344)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 bdb_block_loc_147_cgen_cop(
	 (bdb_block_21_bglt) (obj_3344));
   }
}



/* bdb-block-body */
cop_bglt 
bdb_block_body_146_cgen_cop(bdb_block_21_bglt obj_10)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 122 */
      return
	 (((bdb_block_21_bglt) CREF(obj_10))->body);
   }
}



/* _bdb-block-body2655 */
obj_t 
_bdb_block_body2655_240_cgen_cop(obj_t env_3345, obj_t obj_3346)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 122 */
      {		/* Cgen/cop.scm 122 */
	 cop_bglt aux_4150;
	 aux_4150 =
	    bdb_block_body_146_cgen_cop(
	    (bdb_block_21_bglt) (obj_3346));
	 return
	    (obj_t) (aux_4150);
      }
   }
}



/* allocate-sfun/c */
sfun_bglt 
allocate_sfun_c_74_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 sfun_bglt new1963_1236;
	 new1963_1236 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Cgen/cop.scm 117 */
	    long arg2288_1237;
	    arg2288_1237 =
	       class_num_218___object(sfun_c_188_cgen_cop);
	    {	/* Cgen/cop.scm 117 */
	       obj_t obj_2341;
	       obj_2341 =
		  (obj_t) (new1963_1236);
	       (((obj_t) CREF(obj_2341))->header = MAKE_HEADER(arg2288_1237, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 117 */
	    object_bglt aux_4158;
	    aux_4158 =
	       (object_bglt) (new1963_1236);
	    OBJECT_WIDENING_SET(aux_4158, BFALSE);
	 }
	 return new1963_1236;
      }
   }
}



/* _allocate-sfun/c */
obj_t 
_allocate_sfun_c_103_cgen_cop(obj_t env_3333)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 sfun_bglt aux_4161;
	 aux_4161 =
	    allocate_sfun_c_74_cgen_cop();
	 return
	    (obj_t) (aux_4161);
      }
   }
}



/* sfun/c? */
bool_t 
sfun_c__72_cgen_cop(obj_t obj_14)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      return
	 is_a__118___object(obj_14, sfun_c_188_cgen_cop);
   }
}



/* _sfun/c? */
obj_t 
_sfun_c__160_cgen_cop(obj_t env_3347, obj_t obj_3348)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 bool_t aux_4165;
	 aux_4165 =
	    sfun_c__72_cgen_cop(obj_3348);
	 return
	    BBOOL(aux_4165);
      }
   }
}



/* widening-sfun/c */
sfun_c_188_bglt 
widening_sfun_c_140_cgen_cop(clabel_bglt label_15, bool_t integrated_16)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 sfun_c_188_bglt new1957_2343;
	 new1957_2343 =
	    ((sfun_c_188_bglt) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
	 ((((sfun_c_188_bglt) CREF(new1957_2343))->label) = ((clabel_bglt) label_15), BUNSPEC);
	 ((((sfun_c_188_bglt) CREF(new1957_2343))->integrated) = ((bool_t) integrated_16), BUNSPEC);
	 return new1957_2343;
      }
   }
}



/* _widening-sfun/c2656 */
obj_t 
_widening_sfun_c2656_62_cgen_cop(obj_t env_3349, obj_t label_3350, obj_t integrated_3351)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 sfun_c_188_bglt aux_4171;
	 aux_4171 =
	    widening_sfun_c_140_cgen_cop(
	    (clabel_bglt) (label_3350),
	    CBOOL(integrated_3351));
	 return
	    (obj_t) (aux_4171);
      }
   }
}



/* make-sfun/c */
sfun_c_188_bglt 
make_sfun_c_65_cgen_cop(long arity_17, obj_t side_effect__165_18, obj_t predicate_of_78_19, obj_t stack_allocator_172_20, bool_t top__138_21, obj_t the_closure_238_22, obj_t property_23, obj_t args_24, obj_t body_25, obj_t class_26, obj_t dsssl_keywords_243_27, obj_t loc_28, clabel_bglt label_29, bool_t integrated_30)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 sfun_bglt aux1961_2346;
	 {	/* Cgen/cop.scm 117 */
	    sfun_bglt res2649_2378;
	    {	/* ./Ast/var.scm 504 */
	       sfun_bglt new1127_2362;
	       new1127_2362 =
		  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	       {	/* ./Ast/var.scm 504 */
		  long arg2400_2363;
		  arg2400_2363 =
		     class_num_218___object(sfun_ast_var);
		  {	/* ./Ast/var.scm 504 */
		     obj_t obj_2376;
		     obj_2376 =
			(obj_t) (new1127_2362);
		     (((obj_t) CREF(obj_2376))->header = MAKE_HEADER(arg2400_2363, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 504 */
		  object_bglt aux_4180;
		  aux_4180 =
		     (object_bglt) (new1127_2362);
		  OBJECT_WIDENING_SET(aux_4180, BFALSE);
	       }
	       ((((sfun_bglt) CREF(new1127_2362))->arity) = ((long) arity_17), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->side_effect__165) = ((obj_t) side_effect__165_18), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->predicate_of_78) = ((obj_t) predicate_of_78_19), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->stack_allocator_172) = ((obj_t) stack_allocator_172_20), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->top__138) = ((bool_t) top__138_21), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->the_closure_238) = ((obj_t) the_closure_238_22), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->property) = ((obj_t) property_23), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->args) = ((obj_t) args_24), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->body) = ((obj_t) body_25), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->class) = ((obj_t) class_26), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_27), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_2362))->loc) = ((obj_t) loc_28), BUNSPEC);
	       res2649_2378 = new1127_2362;
	    }
	    aux1961_2346 = res2649_2378;
	 }
	 {	/* Cgen/cop.scm 117 */
	    sfun_c_188_bglt new1962_2347;
	    new1962_2347 =
	       ((sfun_c_188_bglt) (aux1961_2346));
	    {	/* Cgen/cop.scm 117 */
	       long arg2289_2348;
	       arg2289_2348 =
		  class_num_218___object(sfun_c_188_cgen_cop);
	       {	/* Cgen/cop.scm 117 */
		  obj_t obj_2379;
		  obj_2379 =
		     (obj_t) (new1962_2347);
		  (((obj_t) CREF(obj_2379))->header = MAKE_HEADER(arg2289_2348, 0), BUNSPEC);
	       }
	    }
	    {	/* Cgen/cop.scm 117 */
	       sfun_c_188_bglt arg2290_2349;
	       {	/* Cgen/cop.scm 117 */
		  sfun_c_188_bglt res2650_2386;
		  {	/* Cgen/cop.scm 117 */
		     sfun_c_188_bglt new1957_2383;
		     new1957_2383 =
			((sfun_c_188_bglt) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
		     ((((sfun_c_188_bglt) CREF(new1957_2383))->label) = ((clabel_bglt) label_29), BUNSPEC);
		     ((((sfun_c_188_bglt) CREF(new1957_2383))->integrated) = ((bool_t) integrated_30), BUNSPEC);
		     res2650_2386 = new1957_2383;
		  }
		  arg2290_2349 = res2650_2386;
	       }
	       {	/* Cgen/cop.scm 117 */
		  obj_t aux_4204;
		  object_bglt aux_4202;
		  aux_4204 =
		     (obj_t) (arg2290_2349);
		  aux_4202 =
		     (object_bglt) (new1962_2347);
		  OBJECT_WIDENING_SET(aux_4202, aux_4204);
	       }
	    }
	    return new1962_2347;
	 }
      }
   }
}



/* _make-sfun/c2657 */
obj_t 
_make_sfun_c2657_207_cgen_cop(obj_t env_3352, obj_t arity_3353, obj_t side_effect__165_3354, obj_t predicate_of_78_3355, obj_t stack_allocator_172_3356, obj_t top__138_3357, obj_t the_closure_238_3358, obj_t property_3359, obj_t args_3360, obj_t body_3361, obj_t class_3362, obj_t dsssl_keywords_243_3363, obj_t loc_3364, obj_t label_3365, obj_t integrated_3366)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 sfun_c_188_bglt aux_4207;
	 aux_4207 =
	    make_sfun_c_65_cgen_cop(
	    (long) CINT(arity_3353), side_effect__165_3354, predicate_of_78_3355, stack_allocator_172_3356,
	    CBOOL(top__138_3357), the_closure_238_3358, property_3359, args_3360, body_3361, class_3362, dsssl_keywords_243_3363, loc_3364,
	    (clabel_bglt) (label_3365),
	    CBOOL(integrated_3366));
	 return
	    (obj_t) (aux_4207);
      }
   }
}



/* sfun/c-arity */
long 
sfun_c_arity_65_cgen_cop(sfun_bglt obj_31)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 492 */
      return
	 (((sfun_bglt) CREF(obj_31))->arity);
   }
}



/* _sfun/c-arity2658 */
obj_t 
_sfun_c_arity2658_139_cgen_cop(obj_t env_3367, obj_t obj_3368)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 492 */
      {		/* ./Ast/var.scm 492 */
	 long aux_4215;
	 aux_4215 =
	    sfun_c_arity_65_cgen_cop(
	    (sfun_bglt) (obj_3368));
	 return
	    BINT(aux_4215);
      }
   }
}



/* sfun/c-side-effect?-set! */
obj_t 
sfun_c_side_effect__set__242_cgen_cop(sfun_bglt obj_32, obj_t val1945_33)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 494 */
      return
	 ((((sfun_bglt) CREF(obj_32))->side_effect__165) = ((obj_t) val1945_33), BUNSPEC);
   }
}



/* _sfun/c-side-effect?-set!2659 */
obj_t 
_sfun_c_side_effect__set_2659_80_cgen_cop(obj_t env_3369, obj_t obj_3370, obj_t val1945_3371)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 494 */
      return
	 sfun_c_side_effect__set__242_cgen_cop(
	 (sfun_bglt) (obj_3370), val1945_3371);
   }
}



/* sfun/c-side-effect? */
obj_t 
sfun_c_side_effect__183_cgen_cop(sfun_bglt obj_34)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 494 */
      return
	 (((sfun_bglt) CREF(obj_34))->side_effect__165);
   }
}



/* _sfun/c-side-effect?2660 */
obj_t 
_sfun_c_side_effect_2660_98_cgen_cop(obj_t env_3372, obj_t obj_3373)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 494 */
      return
	 sfun_c_side_effect__183_cgen_cop(
	 (sfun_bglt) (obj_3373));
   }
}



/* sfun/c-predicate-of-set! */
obj_t 
sfun_c_predicate_of_set__140_cgen_cop(sfun_bglt obj_35, obj_t val1946_36)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 496 */
      return
	 ((((sfun_bglt) CREF(obj_35))->predicate_of_78) = ((obj_t) val1946_36), BUNSPEC);
   }
}



/* _sfun/c-predicate-of-set!2661 */
obj_t 
_sfun_c_predicate_of_set_2661_112_cgen_cop(obj_t env_3374, obj_t obj_3375, obj_t val1946_3376)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 496 */
      return
	 sfun_c_predicate_of_set__140_cgen_cop(
	 (sfun_bglt) (obj_3375), val1946_3376);
   }
}



/* sfun/c-predicate-of */
obj_t 
sfun_c_predicate_of_188_cgen_cop(sfun_bglt obj_37)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 496 */
      return
	 (((sfun_bglt) CREF(obj_37))->predicate_of_78);
   }
}



/* _sfun/c-predicate-of2662 */
obj_t 
_sfun_c_predicate_of2662_16_cgen_cop(obj_t env_3377, obj_t obj_3378)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 496 */
      return
	 sfun_c_predicate_of_188_cgen_cop(
	 (sfun_bglt) (obj_3378));
   }
}



/* sfun/c-stack-allocator-set! */
obj_t 
sfun_c_stack_allocator_set__151_cgen_cop(sfun_bglt obj_38, obj_t val1947_39)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 498 */
      return
	 ((((sfun_bglt) CREF(obj_38))->stack_allocator_172) = ((obj_t) val1947_39), BUNSPEC);
   }
}



/* _sfun/c-stack-allocator-set!2663 */
obj_t 
_sfun_c_stack_allocator_set_2663_15_cgen_cop(obj_t env_3379, obj_t obj_3380, obj_t val1947_3381)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 498 */
      return
	 sfun_c_stack_allocator_set__151_cgen_cop(
	 (sfun_bglt) (obj_3380), val1947_3381);
   }
}



/* sfun/c-stack-allocator */
obj_t 
sfun_c_stack_allocator_34_cgen_cop(sfun_bglt obj_40)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 498 */
      return
	 (((sfun_bglt) CREF(obj_40))->stack_allocator_172);
   }
}



/* _sfun/c-stack-allocator2664 */
obj_t 
_sfun_c_stack_allocator2664_150_cgen_cop(obj_t env_3382, obj_t obj_3383)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 498 */
      return
	 sfun_c_stack_allocator_34_cgen_cop(
	 (sfun_bglt) (obj_3383));
   }
}



/* sfun/c-top?-set! */
obj_t 
sfun_c_top__set__31_cgen_cop(sfun_bglt obj_41, bool_t val1948_42)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 500 */
      return
	 ((((sfun_bglt) CREF(obj_41))->top__138) = ((bool_t) val1948_42), BUNSPEC);
   }
}



/* _sfun/c-top?-set!2665 */
obj_t 
_sfun_c_top__set_2665_186_cgen_cop(obj_t env_3384, obj_t obj_3385, obj_t val1948_3386)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 500 */
      return
	 sfun_c_top__set__31_cgen_cop(
	 (sfun_bglt) (obj_3385),
	 CBOOL(val1948_3386));
   }
}



/* sfun/c-top? */
bool_t 
sfun_c_top__135_cgen_cop(sfun_bglt obj_43)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 500 */
      return
	 (((sfun_bglt) CREF(obj_43))->top__138);
   }
}



/* _sfun/c-top?2666 */
obj_t 
_sfun_c_top_2666_201_cgen_cop(obj_t env_3387, obj_t obj_3388)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 500 */
      {		/* ./Ast/var.scm 500 */
	 bool_t aux_4242;
	 aux_4242 =
	    sfun_c_top__135_cgen_cop(
	    (sfun_bglt) (obj_3388));
	 return
	    BBOOL(aux_4242);
      }
   }
}



/* sfun/c-the-closure-set! */
obj_t 
sfun_c_the_closure_set__169_cgen_cop(sfun_bglt obj_44, obj_t val1949_45)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 502 */
      return
	 ((((sfun_bglt) CREF(obj_44))->the_closure_238) = ((obj_t) val1949_45), BUNSPEC);
   }
}



/* _sfun/c-the-closure-set!2667 */
obj_t 
_sfun_c_the_closure_set_2667_98_cgen_cop(obj_t env_3389, obj_t obj_3390, obj_t val1949_3391)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 502 */
      return
	 sfun_c_the_closure_set__169_cgen_cop(
	 (sfun_bglt) (obj_3390), val1949_3391);
   }
}



/* sfun/c-the-closure */
obj_t 
sfun_c_the_closure_51_cgen_cop(sfun_bglt obj_46)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 502 */
      return
	 (((sfun_bglt) CREF(obj_46))->the_closure_238);
   }
}



/* _sfun/c-the-closure2668 */
obj_t 
_sfun_c_the_closure2668_84_cgen_cop(obj_t env_3392, obj_t obj_3393)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 502 */
      return
	 sfun_c_the_closure_51_cgen_cop(
	 (sfun_bglt) (obj_3393));
   }
}



/* sfun/c-property-set! */
obj_t 
sfun_c_property_set__116_cgen_cop(sfun_bglt obj_47, obj_t val1950_48)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 ((((sfun_bglt) CREF(obj_47))->property) = ((obj_t) val1950_48), BUNSPEC);
   }
}



/* _sfun/c-property-set!2669 */
obj_t 
_sfun_c_property_set_2669_147_cgen_cop(obj_t env_3394, obj_t obj_3395, obj_t val1950_3396)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 sfun_c_property_set__116_cgen_cop(
	 (sfun_bglt) (obj_3395), val1950_3396);
   }
}



/* sfun/c-property */
obj_t 
sfun_c_property_208_cgen_cop(sfun_bglt obj_49)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 (((sfun_bglt) CREF(obj_49))->property);
   }
}



/* _sfun/c-property2670 */
obj_t 
_sfun_c_property2670_114_cgen_cop(obj_t env_3397, obj_t obj_3398)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 sfun_c_property_208_cgen_cop(
	 (sfun_bglt) (obj_3398));
   }
}



/* sfun/c-args-set! */
obj_t 
sfun_c_args_set__112_cgen_cop(sfun_bglt obj_50, obj_t val1951_51)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 ((((sfun_bglt) CREF(obj_50))->args) = ((obj_t) val1951_51), BUNSPEC);
   }
}



/* _sfun/c-args-set!2671 */
obj_t 
_sfun_c_args_set_2671_36_cgen_cop(obj_t env_3399, obj_t obj_3400, obj_t val1951_3401)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 sfun_c_args_set__112_cgen_cop(
	 (sfun_bglt) (obj_3400), val1951_3401);
   }
}



/* sfun/c-args */
obj_t 
sfun_c_args_197_cgen_cop(sfun_bglt obj_52)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 (((sfun_bglt) CREF(obj_52))->args);
   }
}



/* _sfun/c-args2672 */
obj_t 
_sfun_c_args2672_223_cgen_cop(obj_t env_3402, obj_t obj_3403)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 508 */
      return
	 sfun_c_args_197_cgen_cop(
	 (sfun_bglt) (obj_3403));
   }
}



/* sfun/c-body-set! */
obj_t 
sfun_c_body_set__172_cgen_cop(sfun_bglt obj_53, obj_t val1952_54)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 510 */
      return
	 ((((sfun_bglt) CREF(obj_53))->body) = ((obj_t) val1952_54), BUNSPEC);
   }
}



/* _sfun/c-body-set!2673 */
obj_t 
_sfun_c_body_set_2673_171_cgen_cop(obj_t env_3404, obj_t obj_3405, obj_t val1952_3406)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 510 */
      return
	 sfun_c_body_set__172_cgen_cop(
	 (sfun_bglt) (obj_3405), val1952_3406);
   }
}



/* sfun/c-body */
obj_t 
sfun_c_body_138_cgen_cop(sfun_bglt obj_55)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 510 */
      return
	 (((sfun_bglt) CREF(obj_55))->body);
   }
}



/* _sfun/c-body2674 */
obj_t 
_sfun_c_body2674_249_cgen_cop(obj_t env_3407, obj_t obj_3408)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 510 */
      return
	 sfun_c_body_138_cgen_cop(
	 (sfun_bglt) (obj_3408));
   }
}



/* sfun/c-class-set! */
obj_t 
sfun_c_class_set__22_cgen_cop(sfun_bglt obj_56, obj_t val1953_57)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 512 */
      return
	 ((((sfun_bglt) CREF(obj_56))->class) = ((obj_t) val1953_57), BUNSPEC);
   }
}



/* _sfun/c-class-set!2675 */
obj_t 
_sfun_c_class_set_2675_156_cgen_cop(obj_t env_3409, obj_t obj_3410, obj_t val1953_3411)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 512 */
      return
	 sfun_c_class_set__22_cgen_cop(
	 (sfun_bglt) (obj_3410), val1953_3411);
   }
}



/* sfun/c-class */
obj_t 
sfun_c_class_37_cgen_cop(sfun_bglt obj_58)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 512 */
      return
	 (((sfun_bglt) CREF(obj_58))->class);
   }
}



/* _sfun/c-class2676 */
obj_t 
_sfun_c_class2676_18_cgen_cop(obj_t env_3412, obj_t obj_3413)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 512 */
      return
	 sfun_c_class_37_cgen_cop(
	 (sfun_bglt) (obj_3413));
   }
}



/* sfun/c-dsssl-keywords-set! */
obj_t 
sfun_c_dsssl_keywords_set__154_cgen_cop(sfun_bglt obj_59, obj_t val1954_60)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 518 */
      return
	 ((((sfun_bglt) CREF(obj_59))->dsssl_keywords_243) = ((obj_t) val1954_60), BUNSPEC);
   }
}



/* _sfun/c-dsssl-keywords-set!2677 */
obj_t 
_sfun_c_dsssl_keywords_set_2677_173_cgen_cop(obj_t env_3414, obj_t obj_3415, obj_t val1954_3416)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 518 */
      return
	 sfun_c_dsssl_keywords_set__154_cgen_cop(
	 (sfun_bglt) (obj_3415), val1954_3416);
   }
}



/* sfun/c-dsssl-keywords */
obj_t 
sfun_c_dsssl_keywords_96_cgen_cop(sfun_bglt obj_61)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 518 */
      return
	 (((sfun_bglt) CREF(obj_61))->dsssl_keywords_243);
   }
}



/* _sfun/c-dsssl-keywords2678 */
obj_t 
_sfun_c_dsssl_keywords2678_80_cgen_cop(obj_t env_3417, obj_t obj_3418)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 518 */
      return
	 sfun_c_dsssl_keywords_96_cgen_cop(
	 (sfun_bglt) (obj_3418));
   }
}



/* sfun/c-loc-set! */
obj_t 
sfun_c_loc_set__123_cgen_cop(sfun_bglt obj_62, obj_t val1955_63)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 523 */
      return
	 ((((sfun_bglt) CREF(obj_62))->loc) = ((obj_t) val1955_63), BUNSPEC);
   }
}



/* _sfun/c-loc-set!2679 */
obj_t 
_sfun_c_loc_set_2679_82_cgen_cop(obj_t env_3419, obj_t obj_3420, obj_t val1955_3421)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 523 */
      return
	 sfun_c_loc_set__123_cgen_cop(
	 (sfun_bglt) (obj_3420), val1955_3421);
   }
}



/* sfun/c-loc */
obj_t 
sfun_c_loc_247_cgen_cop(sfun_bglt obj_64)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 523 */
      return
	 (((sfun_bglt) CREF(obj_64))->loc);
   }
}



/* _sfun/c-loc2680 */
obj_t 
_sfun_c_loc2680_171_cgen_cop(obj_t env_3422, obj_t obj_3423)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 523 */
      return
	 sfun_c_loc_247_cgen_cop(
	 (sfun_bglt) (obj_3423));
   }
}



/* sfun/c-label */
clabel_bglt 
sfun_c_label_89_cgen_cop(sfun_c_188_bglt obj_65)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 118 */
      {
	 obj_t aux_4288;
	 {	/* Cgen/cop.scm 118 */
	    object_bglt aux_4289;
	    aux_4289 =
	       (object_bglt) (obj_65);
	    aux_4288 =
	       OBJECT_WIDENING(aux_4289);
	 }
	 return
	    (((sfun_c_188_bglt) CREF(aux_4288))->label);
      }
   }
}



/* _sfun/c-label2681 */
obj_t 
_sfun_c_label2681_74_cgen_cop(obj_t env_3424, obj_t obj_3425)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 118 */
      {		/* Cgen/cop.scm 118 */
	 clabel_bglt aux_4293;
	 aux_4293 =
	    sfun_c_label_89_cgen_cop(
	    (sfun_c_188_bglt) (obj_3425));
	 return
	    (obj_t) (aux_4293);
      }
   }
}



/* sfun/c-integrated-set! */
obj_t 
sfun_c_integrated_set__24_cgen_cop(sfun_c_188_bglt obj_66, bool_t val1956_67)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {
	 obj_t aux_4297;
	 {	/* Cgen/cop.scm 117 */
	    object_bglt aux_4298;
	    aux_4298 =
	       (object_bglt) (obj_66);
	    aux_4297 =
	       OBJECT_WIDENING(aux_4298);
	 }
	 return
	    ((((sfun_c_188_bglt) CREF(aux_4297))->integrated) = ((bool_t) val1956_67), BUNSPEC);
      }
   }
}



/* _sfun/c-integrated-set!2682 */
obj_t 
_sfun_c_integrated_set_2682_246_cgen_cop(obj_t env_3426, obj_t obj_3427, obj_t val1956_3428)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      return
	 sfun_c_integrated_set__24_cgen_cop(
	 (sfun_c_188_bglt) (obj_3427),
	 CBOOL(val1956_3428));
   }
}



/* sfun/c-integrated */
bool_t 
sfun_c_integrated_120_cgen_cop(sfun_c_188_bglt obj_68)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {
	 obj_t aux_4305;
	 {	/* Cgen/cop.scm 117 */
	    object_bglt aux_4306;
	    aux_4306 =
	       (object_bglt) (obj_68);
	    aux_4305 =
	       OBJECT_WIDENING(aux_4306);
	 }
	 return
	    (((sfun_c_188_bglt) CREF(aux_4305))->integrated);
      }
   }
}



/* _sfun/c-integrated2683 */
obj_t 
_sfun_c_integrated2683_188_cgen_cop(obj_t env_3429, obj_t obj_3430)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {		/* Cgen/cop.scm 117 */
	 bool_t aux_4310;
	 aux_4310 =
	    sfun_c_integrated_120_cgen_cop(
	    (sfun_c_188_bglt) (obj_3430));
	 return
	    BBOOL(aux_4310);
      }
   }
}



/* allocate-cjump-ex-it */
cjump_ex_it_131_bglt 
allocate_cjump_ex_it_67_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {		/* Cgen/cop.scm 113 */
	 cjump_ex_it_131_bglt new1930_1245;
	 new1930_1245 =
	    ((cjump_ex_it_131_bglt) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
	 {	/* Cgen/cop.scm 113 */
	    long arg2291_1246;
	    arg2291_1246 =
	       class_num_218___object(cjump_ex_it_131_cgen_cop);
	    {	/* Cgen/cop.scm 113 */
	       obj_t obj_2387;
	       obj_2387 =
		  (obj_t) (new1930_1245);
	       (((obj_t) CREF(obj_2387))->header = MAKE_HEADER(arg2291_1246, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 113 */
	    object_bglt aux_4318;
	    aux_4318 =
	       (object_bglt) (new1930_1245);
	    OBJECT_WIDENING_SET(aux_4318, BFALSE);
	 }
	 return new1930_1245;
      }
   }
}



/* _allocate-cjump-ex-it */
obj_t 
_allocate_cjump_ex_it_10_cgen_cop(obj_t env_3332)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {		/* Cgen/cop.scm 113 */
	 cjump_ex_it_131_bglt aux_4321;
	 aux_4321 =
	    allocate_cjump_ex_it_67_cgen_cop();
	 return
	    (obj_t) (aux_4321);
      }
   }
}



/* cjump-ex-it? */
bool_t 
cjump_ex_it__247_cgen_cop(obj_t obj_72)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      return
	 is_a__118___object(obj_72, cjump_ex_it_131_cgen_cop);
   }
}



/* _cjump-ex-it? */
obj_t 
_cjump_ex_it__240_cgen_cop(obj_t env_3431, obj_t obj_3432)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {		/* Cgen/cop.scm 113 */
	 bool_t aux_4325;
	 aux_4325 =
	    cjump_ex_it__247_cgen_cop(obj_3432);
	 return
	    BBOOL(aux_4325);
      }
   }
}



/* make-cjump-ex-it */
cjump_ex_it_131_bglt 
make_cjump_ex_it_216_cgen_cop(obj_t loc_73, cop_bglt exit_74, cop_bglt value_75)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {		/* Cgen/cop.scm 113 */
	 cjump_ex_it_131_bglt new1925_2389;
	 new1925_2389 =
	    ((cjump_ex_it_131_bglt) BREF(GC_MALLOC(sizeof(struct cjump_ex_it_131))));
	 {	/* Cgen/cop.scm 113 */
	    long arg2292_2390;
	    arg2292_2390 =
	       class_num_218___object(cjump_ex_it_131_cgen_cop);
	    {	/* Cgen/cop.scm 113 */
	       obj_t obj_2394;
	       obj_2394 =
		  (obj_t) (new1925_2389);
	       (((obj_t) CREF(obj_2394))->header = MAKE_HEADER(arg2292_2390, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 113 */
	    object_bglt aux_4332;
	    aux_4332 =
	       (object_bglt) (new1925_2389);
	    OBJECT_WIDENING_SET(aux_4332, BFALSE);
	 }
	 ((((cjump_ex_it_131_bglt) CREF(new1925_2389))->loc) = ((obj_t) loc_73), BUNSPEC);
	 ((((cjump_ex_it_131_bglt) CREF(new1925_2389))->exit) = ((cop_bglt) exit_74), BUNSPEC);
	 ((((cjump_ex_it_131_bglt) CREF(new1925_2389))->value) = ((cop_bglt) value_75), BUNSPEC);
	 return new1925_2389;
      }
   }
}



/* _make-cjump-ex-it2684 */
obj_t 
_make_cjump_ex_it2684_14_cgen_cop(obj_t env_3433, obj_t loc_3434, obj_t exit_3435, obj_t value_3436)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {		/* Cgen/cop.scm 113 */
	 cjump_ex_it_131_bglt aux_4338;
	 aux_4338 =
	    make_cjump_ex_it_216_cgen_cop(loc_3434,
	    (cop_bglt) (exit_3435),
	    (cop_bglt) (value_3436));
	 return
	    (obj_t) (aux_4338);
      }
   }
}



/* cjump-ex-it-loc-set! */
obj_t 
cjump_ex_it_loc_set__72_cgen_cop(cjump_ex_it_131_bglt obj_76, obj_t val1924_77)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cjump_ex_it_131_bglt) CREF(obj_76))->loc) = ((obj_t) val1924_77), BUNSPEC);
   }
}



/* _cjump-ex-it-loc-set!2685 */
obj_t 
_cjump_ex_it_loc_set_2685_80_cgen_cop(obj_t env_3437, obj_t obj_3438, obj_t val1924_3439)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cjump_ex_it_loc_set__72_cgen_cop(
	 (cjump_ex_it_131_bglt) (obj_3438), val1924_3439);
   }
}



/* cjump-ex-it-loc */
obj_t 
cjump_ex_it_loc_12_cgen_cop(cjump_ex_it_131_bglt obj_78)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cjump_ex_it_131_bglt) CREF(obj_78))->loc);
   }
}



/* _cjump-ex-it-loc2686 */
obj_t 
_cjump_ex_it_loc2686_74_cgen_cop(obj_t env_3440, obj_t obj_3441)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cjump_ex_it_loc_12_cgen_cop(
	 (cjump_ex_it_131_bglt) (obj_3441));
   }
}



/* cjump-ex-it-exit */
cop_bglt 
cjump_ex_it_exit_93_cgen_cop(cjump_ex_it_131_bglt obj_79)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 114 */
      return
	 (((cjump_ex_it_131_bglt) CREF(obj_79))->exit);
   }
}



/* _cjump-ex-it-exit2687 */
obj_t 
_cjump_ex_it_exit2687_31_cgen_cop(obj_t env_3442, obj_t obj_3443)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 114 */
      {		/* Cgen/cop.scm 114 */
	 cop_bglt aux_4350;
	 aux_4350 =
	    cjump_ex_it_exit_93_cgen_cop(
	    (cjump_ex_it_131_bglt) (obj_3443));
	 return
	    (obj_t) (aux_4350);
      }
   }
}



/* cjump-ex-it-value */
cop_bglt 
cjump_ex_it_value_92_cgen_cop(cjump_ex_it_131_bglt obj_80)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 115 */
      return
	 (((cjump_ex_it_131_bglt) CREF(obj_80))->value);
   }
}



/* _cjump-ex-it-value2688 */
obj_t 
_cjump_ex_it_value2688_243_cgen_cop(obj_t env_3444, obj_t obj_3445)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 115 */
      {		/* Cgen/cop.scm 115 */
	 cop_bglt aux_4355;
	 aux_4355 =
	    cjump_ex_it_value_92_cgen_cop(
	    (cjump_ex_it_131_bglt) (obj_3445));
	 return
	    (obj_t) (aux_4355);
      }
   }
}



/* allocate-cset-ex-it */
cset_ex_it_123_bglt 
allocate_cset_ex_it_68_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {		/* Cgen/cop.scm 108 */
	 cset_ex_it_123_bglt new1904_1252;
	 new1904_1252 =
	    ((cset_ex_it_123_bglt) BREF(GC_MALLOC(sizeof(struct cset_ex_it_123))));
	 {	/* Cgen/cop.scm 108 */
	    long arg2293_1253;
	    arg2293_1253 =
	       class_num_218___object(cset_ex_it_123_cgen_cop);
	    {	/* Cgen/cop.scm 108 */
	       obj_t obj_2396;
	       obj_2396 =
		  (obj_t) (new1904_1252);
	       (((obj_t) CREF(obj_2396))->header = MAKE_HEADER(arg2293_1253, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 108 */
	    object_bglt aux_4363;
	    aux_4363 =
	       (object_bglt) (new1904_1252);
	    OBJECT_WIDENING_SET(aux_4363, BFALSE);
	 }
	 return new1904_1252;
      }
   }
}



/* _allocate-cset-ex-it */
obj_t 
_allocate_cset_ex_it_129_cgen_cop(obj_t env_3331)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {		/* Cgen/cop.scm 108 */
	 cset_ex_it_123_bglt aux_4366;
	 aux_4366 =
	    allocate_cset_ex_it_68_cgen_cop();
	 return
	    (obj_t) (aux_4366);
      }
   }
}



/* cset-ex-it? */
bool_t 
cset_ex_it__60_cgen_cop(obj_t obj_84)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      return
	 is_a__118___object(obj_84, cset_ex_it_123_cgen_cop);
   }
}



/* _cset-ex-it? */
obj_t 
_cset_ex_it__255_cgen_cop(obj_t env_3446, obj_t obj_3447)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {		/* Cgen/cop.scm 108 */
	 bool_t aux_4370;
	 aux_4370 =
	    cset_ex_it__60_cgen_cop(obj_3447);
	 return
	    BBOOL(aux_4370);
      }
   }
}



/* make-cset-ex-it */
cset_ex_it_123_bglt 
make_cset_ex_it_102_cgen_cop(obj_t loc_85, cop_bglt exit_86, cop_bglt jump_value_221_87, cop_bglt body_88)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {		/* Cgen/cop.scm 108 */
	 cset_ex_it_123_bglt new1898_2398;
	 new1898_2398 =
	    ((cset_ex_it_123_bglt) BREF(GC_MALLOC(sizeof(struct cset_ex_it_123))));
	 {	/* Cgen/cop.scm 108 */
	    long arg2294_2399;
	    arg2294_2399 =
	       class_num_218___object(cset_ex_it_123_cgen_cop);
	    {	/* Cgen/cop.scm 108 */
	       obj_t obj_2404;
	       obj_2404 =
		  (obj_t) (new1898_2398);
	       (((obj_t) CREF(obj_2404))->header = MAKE_HEADER(arg2294_2399, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 108 */
	    object_bglt aux_4377;
	    aux_4377 =
	       (object_bglt) (new1898_2398);
	    OBJECT_WIDENING_SET(aux_4377, BFALSE);
	 }
	 ((((cset_ex_it_123_bglt) CREF(new1898_2398))->loc) = ((obj_t) loc_85), BUNSPEC);
	 ((((cset_ex_it_123_bglt) CREF(new1898_2398))->exit) = ((cop_bglt) exit_86), BUNSPEC);
	 ((((cset_ex_it_123_bglt) CREF(new1898_2398))->jump_value_221) = ((cop_bglt) jump_value_221_87), BUNSPEC);
	 ((((cset_ex_it_123_bglt) CREF(new1898_2398))->body) = ((cop_bglt) body_88), BUNSPEC);
	 return new1898_2398;
      }
   }
}



/* _make-cset-ex-it2689 */
obj_t 
_make_cset_ex_it2689_144_cgen_cop(obj_t env_3448, obj_t loc_3449, obj_t exit_3450, obj_t jump_value_221_3451, obj_t body_3452)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {		/* Cgen/cop.scm 108 */
	 cset_ex_it_123_bglt aux_4384;
	 aux_4384 =
	    make_cset_ex_it_102_cgen_cop(loc_3449,
	    (cop_bglt) (exit_3450),
	    (cop_bglt) (jump_value_221_3451),
	    (cop_bglt) (body_3452));
	 return
	    (obj_t) (aux_4384);
      }
   }
}



/* cset-ex-it-loc-set! */
obj_t 
cset_ex_it_loc_set__45_cgen_cop(cset_ex_it_123_bglt obj_89, obj_t val1897_90)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cset_ex_it_123_bglt) CREF(obj_89))->loc) = ((obj_t) val1897_90), BUNSPEC);
   }
}



/* _cset-ex-it-loc-set!2690 */
obj_t 
_cset_ex_it_loc_set_2690_33_cgen_cop(obj_t env_3453, obj_t obj_3454, obj_t val1897_3455)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cset_ex_it_loc_set__45_cgen_cop(
	 (cset_ex_it_123_bglt) (obj_3454), val1897_3455);
   }
}



/* cset-ex-it-loc */
obj_t 
cset_ex_it_loc_150_cgen_cop(cset_ex_it_123_bglt obj_91)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cset_ex_it_123_bglt) CREF(obj_91))->loc);
   }
}



/* _cset-ex-it-loc2691 */
obj_t 
_cset_ex_it_loc2691_182_cgen_cop(obj_t env_3456, obj_t obj_3457)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cset_ex_it_loc_150_cgen_cop(
	 (cset_ex_it_123_bglt) (obj_3457));
   }
}



/* cset-ex-it-exit */
cop_bglt 
cset_ex_it_exit_130_cgen_cop(cset_ex_it_123_bglt obj_92)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 109 */
      return
	 (((cset_ex_it_123_bglt) CREF(obj_92))->exit);
   }
}



/* _cset-ex-it-exit2692 */
obj_t 
_cset_ex_it_exit2692_1_cgen_cop(obj_t env_3458, obj_t obj_3459)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 109 */
      {		/* Cgen/cop.scm 109 */
	 cop_bglt aux_4397;
	 aux_4397 =
	    cset_ex_it_exit_130_cgen_cop(
	    (cset_ex_it_123_bglt) (obj_3459));
	 return
	    (obj_t) (aux_4397);
      }
   }
}



/* cset-ex-it-jump-value */
cop_bglt 
cset_ex_it_jump_value_128_cgen_cop(cset_ex_it_123_bglt obj_93)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 110 */
      return
	 (((cset_ex_it_123_bglt) CREF(obj_93))->jump_value_221);
   }
}



/* _cset-ex-it-jump-value2693 */
obj_t 
_cset_ex_it_jump_value2693_133_cgen_cop(obj_t env_3460, obj_t obj_3461)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 110 */
      {		/* Cgen/cop.scm 110 */
	 cop_bglt aux_4402;
	 aux_4402 =
	    cset_ex_it_jump_value_128_cgen_cop(
	    (cset_ex_it_123_bglt) (obj_3461));
	 return
	    (obj_t) (aux_4402);
      }
   }
}



/* cset-ex-it-body */
cop_bglt 
cset_ex_it_body_210_cgen_cop(cset_ex_it_123_bglt obj_94)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 111 */
      return
	 (((cset_ex_it_123_bglt) CREF(obj_94))->body);
   }
}



/* _cset-ex-it-body2694 */
obj_t 
_cset_ex_it_body2694_67_cgen_cop(obj_t env_3462, obj_t obj_3463)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 111 */
      {		/* Cgen/cop.scm 111 */
	 cop_bglt aux_4407;
	 aux_4407 =
	    cset_ex_it_body_210_cgen_cop(
	    (cset_ex_it_123_bglt) (obj_3463));
	 return
	    (obj_t) (aux_4407);
      }
   }
}



/* allocate-cbox-set! */
cbox_set__132_bglt 
allocate_cbox_set__13_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {		/* Cgen/cop.scm 104 */
	 cbox_set__132_bglt new1882_1260;
	 new1882_1260 =
	    ((cbox_set__132_bglt) BREF(GC_MALLOC(sizeof(struct cbox_set__132))));
	 {	/* Cgen/cop.scm 104 */
	    long arg2295_1261;
	    arg2295_1261 =
	       class_num_218___object(cbox_set__132_cgen_cop);
	    {	/* Cgen/cop.scm 104 */
	       obj_t obj_2406;
	       obj_2406 =
		  (obj_t) (new1882_1260);
	       (((obj_t) CREF(obj_2406))->header = MAKE_HEADER(arg2295_1261, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 104 */
	    object_bglt aux_4415;
	    aux_4415 =
	       (object_bglt) (new1882_1260);
	    OBJECT_WIDENING_SET(aux_4415, BFALSE);
	 }
	 return new1882_1260;
      }
   }
}



/* _allocate-cbox-set! */
obj_t 
_allocate_cbox_set__70_cgen_cop(obj_t env_3330)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {		/* Cgen/cop.scm 104 */
	 cbox_set__132_bglt aux_4418;
	 aux_4418 =
	    allocate_cbox_set__13_cgen_cop();
	 return
	    (obj_t) (aux_4418);
      }
   }
}



/* cbox-set!? */
bool_t 
cbox_set___212_cgen_cop(obj_t obj_98)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      return
	 is_a__118___object(obj_98, cbox_set__132_cgen_cop);
   }
}



/* _cbox-set!? */
obj_t 
_cbox_set___248_cgen_cop(obj_t env_3464, obj_t obj_3465)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {		/* Cgen/cop.scm 104 */
	 bool_t aux_4422;
	 aux_4422 =
	    cbox_set___212_cgen_cop(obj_3465);
	 return
	    BBOOL(aux_4422);
      }
   }
}



/* make-cbox-set! */
cbox_set__132_bglt 
make_cbox_set__218_cgen_cop(obj_t loc_99, cop_bglt var_100, cop_bglt value_101)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {		/* Cgen/cop.scm 104 */
	 cbox_set__132_bglt new1877_2408;
	 new1877_2408 =
	    ((cbox_set__132_bglt) BREF(GC_MALLOC(sizeof(struct cbox_set__132))));
	 {	/* Cgen/cop.scm 104 */
	    long arg2296_2409;
	    arg2296_2409 =
	       class_num_218___object(cbox_set__132_cgen_cop);
	    {	/* Cgen/cop.scm 104 */
	       obj_t obj_2413;
	       obj_2413 =
		  (obj_t) (new1877_2408);
	       (((obj_t) CREF(obj_2413))->header = MAKE_HEADER(arg2296_2409, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 104 */
	    object_bglt aux_4429;
	    aux_4429 =
	       (object_bglt) (new1877_2408);
	    OBJECT_WIDENING_SET(aux_4429, BFALSE);
	 }
	 ((((cbox_set__132_bglt) CREF(new1877_2408))->loc) = ((obj_t) loc_99), BUNSPEC);
	 ((((cbox_set__132_bglt) CREF(new1877_2408))->var) = ((cop_bglt) var_100), BUNSPEC);
	 ((((cbox_set__132_bglt) CREF(new1877_2408))->value) = ((cop_bglt) value_101), BUNSPEC);
	 return new1877_2408;
      }
   }
}



/* _make-cbox-set!2695 */
obj_t 
_make_cbox_set_2695_140_cgen_cop(obj_t env_3466, obj_t loc_3467, obj_t var_3468, obj_t value_3469)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {		/* Cgen/cop.scm 104 */
	 cbox_set__132_bglt aux_4435;
	 aux_4435 =
	    make_cbox_set__218_cgen_cop(loc_3467,
	    (cop_bglt) (var_3468),
	    (cop_bglt) (value_3469));
	 return
	    (obj_t) (aux_4435);
      }
   }
}



/* cbox-set!-loc-set! */
obj_t 
cbox_set__loc_set__99_cgen_cop(cbox_set__132_bglt obj_102, obj_t val1876_103)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cbox_set__132_bglt) CREF(obj_102))->loc) = ((obj_t) val1876_103), BUNSPEC);
   }
}



/* _cbox-set!-loc-set!2696 */
obj_t 
_cbox_set__loc_set_2696_111_cgen_cop(obj_t env_3470, obj_t obj_3471, obj_t val1876_3472)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cbox_set__loc_set__99_cgen_cop(
	 (cbox_set__132_bglt) (obj_3471), val1876_3472);
   }
}



/* cbox-set!-loc */
obj_t 
cbox_set__loc_125_cgen_cop(cbox_set__132_bglt obj_104)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cbox_set__132_bglt) CREF(obj_104))->loc);
   }
}



/* _cbox-set!-loc2697 */
obj_t 
_cbox_set__loc2697_223_cgen_cop(obj_t env_3473, obj_t obj_3474)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cbox_set__loc_125_cgen_cop(
	 (cbox_set__132_bglt) (obj_3474));
   }
}



/* cbox-set!-var */
cop_bglt 
cbox_set__var_213_cgen_cop(cbox_set__132_bglt obj_105)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 105 */
      return
	 (((cbox_set__132_bglt) CREF(obj_105))->var);
   }
}



/* _cbox-set!-var2698 */
obj_t 
_cbox_set__var2698_92_cgen_cop(obj_t env_3475, obj_t obj_3476)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 105 */
      {		/* Cgen/cop.scm 105 */
	 cop_bglt aux_4447;
	 aux_4447 =
	    cbox_set__var_213_cgen_cop(
	    (cbox_set__132_bglt) (obj_3476));
	 return
	    (obj_t) (aux_4447);
      }
   }
}



/* cbox-set!-value */
cop_bglt 
cbox_set__value_106_cgen_cop(cbox_set__132_bglt obj_106)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 106 */
      return
	 (((cbox_set__132_bglt) CREF(obj_106))->value);
   }
}



/* _cbox-set!-value2699 */
obj_t 
_cbox_set__value2699_198_cgen_cop(obj_t env_3477, obj_t obj_3478)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 106 */
      {		/* Cgen/cop.scm 106 */
	 cop_bglt aux_4452;
	 aux_4452 =
	    cbox_set__value_106_cgen_cop(
	    (cbox_set__132_bglt) (obj_3478));
	 return
	    (obj_t) (aux_4452);
      }
   }
}



/* allocate-cbox-ref */
cbox_ref_44_bglt 
allocate_cbox_ref_60_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {		/* Cgen/cop.scm 101 */
	 cbox_ref_44_bglt new1865_1267;
	 new1865_1267 =
	    ((cbox_ref_44_bglt) BREF(GC_MALLOC(sizeof(struct cbox_ref_44))));
	 {	/* Cgen/cop.scm 101 */
	    long arg2297_1268;
	    arg2297_1268 =
	       class_num_218___object(cbox_ref_44_cgen_cop);
	    {	/* Cgen/cop.scm 101 */
	       obj_t obj_2415;
	       obj_2415 =
		  (obj_t) (new1865_1267);
	       (((obj_t) CREF(obj_2415))->header = MAKE_HEADER(arg2297_1268, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 101 */
	    object_bglt aux_4460;
	    aux_4460 =
	       (object_bglt) (new1865_1267);
	    OBJECT_WIDENING_SET(aux_4460, BFALSE);
	 }
	 return new1865_1267;
      }
   }
}



/* _allocate-cbox-ref */
obj_t 
_allocate_cbox_ref_237_cgen_cop(obj_t env_3329)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {		/* Cgen/cop.scm 101 */
	 cbox_ref_44_bglt aux_4463;
	 aux_4463 =
	    allocate_cbox_ref_60_cgen_cop();
	 return
	    (obj_t) (aux_4463);
      }
   }
}



/* cbox-ref? */
bool_t 
cbox_ref__107_cgen_cop(obj_t obj_110)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      return
	 is_a__118___object(obj_110, cbox_ref_44_cgen_cop);
   }
}



/* _cbox-ref? */
obj_t 
_cbox_ref__77_cgen_cop(obj_t env_3479, obj_t obj_3480)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {		/* Cgen/cop.scm 101 */
	 bool_t aux_4467;
	 aux_4467 =
	    cbox_ref__107_cgen_cop(obj_3480);
	 return
	    BBOOL(aux_4467);
      }
   }
}



/* make-cbox-ref */
cbox_ref_44_bglt 
make_cbox_ref_208_cgen_cop(obj_t loc_111, cop_bglt var_112)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {		/* Cgen/cop.scm 101 */
	 cbox_ref_44_bglt new1861_2417;
	 new1861_2417 =
	    ((cbox_ref_44_bglt) BREF(GC_MALLOC(sizeof(struct cbox_ref_44))));
	 {	/* Cgen/cop.scm 101 */
	    long arg2298_2418;
	    arg2298_2418 =
	       class_num_218___object(cbox_ref_44_cgen_cop);
	    {	/* Cgen/cop.scm 101 */
	       obj_t obj_2421;
	       obj_2421 =
		  (obj_t) (new1861_2417);
	       (((obj_t) CREF(obj_2421))->header = MAKE_HEADER(arg2298_2418, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 101 */
	    object_bglt aux_4474;
	    aux_4474 =
	       (object_bglt) (new1861_2417);
	    OBJECT_WIDENING_SET(aux_4474, BFALSE);
	 }
	 ((((cbox_ref_44_bglt) CREF(new1861_2417))->loc) = ((obj_t) loc_111), BUNSPEC);
	 ((((cbox_ref_44_bglt) CREF(new1861_2417))->var) = ((cop_bglt) var_112), BUNSPEC);
	 return new1861_2417;
      }
   }
}



/* _make-cbox-ref2700 */
obj_t 
_make_cbox_ref2700_166_cgen_cop(obj_t env_3481, obj_t loc_3482, obj_t var_3483)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {		/* Cgen/cop.scm 101 */
	 cbox_ref_44_bglt aux_4479;
	 aux_4479 =
	    make_cbox_ref_208_cgen_cop(loc_3482,
	    (cop_bglt) (var_3483));
	 return
	    (obj_t) (aux_4479);
      }
   }
}



/* cbox-ref-loc-set! */
obj_t 
cbox_ref_loc_set__77_cgen_cop(cbox_ref_44_bglt obj_113, obj_t val1860_114)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cbox_ref_44_bglt) CREF(obj_113))->loc) = ((obj_t) val1860_114), BUNSPEC);
   }
}



/* _cbox-ref-loc-set!2701 */
obj_t 
_cbox_ref_loc_set_2701_66_cgen_cop(obj_t env_3484, obj_t obj_3485, obj_t val1860_3486)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cbox_ref_loc_set__77_cgen_cop(
	 (cbox_ref_44_bglt) (obj_3485), val1860_3486);
   }
}



/* cbox-ref-loc */
obj_t 
cbox_ref_loc_81_cgen_cop(cbox_ref_44_bglt obj_115)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cbox_ref_44_bglt) CREF(obj_115))->loc);
   }
}



/* _cbox-ref-loc2702 */
obj_t 
_cbox_ref_loc2702_21_cgen_cop(obj_t env_3487, obj_t obj_3488)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cbox_ref_loc_81_cgen_cop(
	 (cbox_ref_44_bglt) (obj_3488));
   }
}



/* cbox-ref-var */
cop_bglt 
cbox_ref_var_149_cgen_cop(cbox_ref_44_bglt obj_116)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 102 */
      return
	 (((cbox_ref_44_bglt) CREF(obj_116))->var);
   }
}



/* _cbox-ref-var2703 */
obj_t 
_cbox_ref_var2703_234_cgen_cop(obj_t env_3489, obj_t obj_3490)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 102 */
      {		/* Cgen/cop.scm 102 */
	 cop_bglt aux_4490;
	 aux_4490 =
	    cbox_ref_var_149_cgen_cop(
	    (cbox_ref_44_bglt) (obj_3490));
	 return
	    (obj_t) (aux_4490);
      }
   }
}



/* allocate-cmake-box */
cmake_box_177_bglt 
allocate_cmake_box_148_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {		/* Cgen/cop.scm 98 */
	 cmake_box_177_bglt new1849_1273;
	 new1849_1273 =
	    ((cmake_box_177_bglt) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
	 {	/* Cgen/cop.scm 98 */
	    long arg2299_1274;
	    arg2299_1274 =
	       class_num_218___object(cmake_box_177_cgen_cop);
	    {	/* Cgen/cop.scm 98 */
	       obj_t obj_2423;
	       obj_2423 =
		  (obj_t) (new1849_1273);
	       (((obj_t) CREF(obj_2423))->header = MAKE_HEADER(arg2299_1274, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 98 */
	    object_bglt aux_4498;
	    aux_4498 =
	       (object_bglt) (new1849_1273);
	    OBJECT_WIDENING_SET(aux_4498, BFALSE);
	 }
	 return new1849_1273;
      }
   }
}



/* _allocate-cmake-box */
obj_t 
_allocate_cmake_box_154_cgen_cop(obj_t env_3328)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {		/* Cgen/cop.scm 98 */
	 cmake_box_177_bglt aux_4501;
	 aux_4501 =
	    allocate_cmake_box_148_cgen_cop();
	 return
	    (obj_t) (aux_4501);
      }
   }
}



/* cmake-box? */
bool_t 
cmake_box__185_cgen_cop(obj_t obj_120)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      return
	 is_a__118___object(obj_120, cmake_box_177_cgen_cop);
   }
}



/* _cmake-box? */
obj_t 
_cmake_box__210_cgen_cop(obj_t env_3491, obj_t obj_3492)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {		/* Cgen/cop.scm 98 */
	 bool_t aux_4505;
	 aux_4505 =
	    cmake_box__185_cgen_cop(obj_3492);
	 return
	    BBOOL(aux_4505);
      }
   }
}



/* make-cmake-box */
cmake_box_177_bglt 
make_cmake_box_87_cgen_cop(obj_t loc_121, cop_bglt value_122)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {		/* Cgen/cop.scm 98 */
	 cmake_box_177_bglt new1845_2425;
	 new1845_2425 =
	    ((cmake_box_177_bglt) BREF(GC_MALLOC(sizeof(struct cmake_box_177))));
	 {	/* Cgen/cop.scm 98 */
	    long arg2300_2426;
	    arg2300_2426 =
	       class_num_218___object(cmake_box_177_cgen_cop);
	    {	/* Cgen/cop.scm 98 */
	       obj_t obj_2429;
	       obj_2429 =
		  (obj_t) (new1845_2425);
	       (((obj_t) CREF(obj_2429))->header = MAKE_HEADER(arg2300_2426, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 98 */
	    object_bglt aux_4512;
	    aux_4512 =
	       (object_bglt) (new1845_2425);
	    OBJECT_WIDENING_SET(aux_4512, BFALSE);
	 }
	 ((((cmake_box_177_bglt) CREF(new1845_2425))->loc) = ((obj_t) loc_121), BUNSPEC);
	 ((((cmake_box_177_bglt) CREF(new1845_2425))->value) = ((cop_bglt) value_122), BUNSPEC);
	 return new1845_2425;
      }
   }
}



/* _make-cmake-box2704 */
obj_t 
_make_cmake_box2704_246_cgen_cop(obj_t env_3493, obj_t loc_3494, obj_t value_3495)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {		/* Cgen/cop.scm 98 */
	 cmake_box_177_bglt aux_4517;
	 aux_4517 =
	    make_cmake_box_87_cgen_cop(loc_3494,
	    (cop_bglt) (value_3495));
	 return
	    (obj_t) (aux_4517);
      }
   }
}



/* cmake-box-loc-set! */
obj_t 
cmake_box_loc_set__105_cgen_cop(cmake_box_177_bglt obj_123, obj_t val1844_124)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cmake_box_177_bglt) CREF(obj_123))->loc) = ((obj_t) val1844_124), BUNSPEC);
   }
}



/* _cmake-box-loc-set!2705 */
obj_t 
_cmake_box_loc_set_2705_128_cgen_cop(obj_t env_3496, obj_t obj_3497, obj_t val1844_3498)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cmake_box_loc_set__105_cgen_cop(
	 (cmake_box_177_bglt) (obj_3497), val1844_3498);
   }
}



/* cmake-box-loc */
obj_t 
cmake_box_loc_203_cgen_cop(cmake_box_177_bglt obj_125)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cmake_box_177_bglt) CREF(obj_125))->loc);
   }
}



/* _cmake-box-loc2706 */
obj_t 
_cmake_box_loc2706_234_cgen_cop(obj_t env_3499, obj_t obj_3500)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cmake_box_loc_203_cgen_cop(
	 (cmake_box_177_bglt) (obj_3500));
   }
}



/* cmake-box-value */
cop_bglt 
cmake_box_value_135_cgen_cop(cmake_box_177_bglt obj_126)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 99 */
      return
	 (((cmake_box_177_bglt) CREF(obj_126))->value);
   }
}



/* _cmake-box-value2707 */
obj_t 
_cmake_box_value2707_209_cgen_cop(obj_t env_3501, obj_t obj_3502)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 99 */
      {		/* Cgen/cop.scm 99 */
	 cop_bglt aux_4528;
	 aux_4528 =
	    cmake_box_value_135_cgen_cop(
	    (cmake_box_177_bglt) (obj_3502));
	 return
	    (obj_t) (aux_4528);
      }
   }
}



/* allocate-cswitch */
cswitch_bglt 
allocate_cswitch_92_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {		/* Cgen/cop.scm 94 */
	 cswitch_bglt new1828_1279;
	 new1828_1279 =
	    ((cswitch_bglt) BREF(GC_MALLOC(sizeof(struct cswitch))));
	 {	/* Cgen/cop.scm 94 */
	    long arg2301_1280;
	    arg2301_1280 =
	       class_num_218___object(cswitch_cgen_cop);
	    {	/* Cgen/cop.scm 94 */
	       obj_t obj_2431;
	       obj_2431 =
		  (obj_t) (new1828_1279);
	       (((obj_t) CREF(obj_2431))->header = MAKE_HEADER(arg2301_1280, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 94 */
	    object_bglt aux_4536;
	    aux_4536 =
	       (object_bglt) (new1828_1279);
	    OBJECT_WIDENING_SET(aux_4536, BFALSE);
	 }
	 return new1828_1279;
      }
   }
}



/* _allocate-cswitch */
obj_t 
_allocate_cswitch_108_cgen_cop(obj_t env_3327)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {		/* Cgen/cop.scm 94 */
	 cswitch_bglt aux_4539;
	 aux_4539 =
	    allocate_cswitch_92_cgen_cop();
	 return
	    (obj_t) (aux_4539);
      }
   }
}



/* cswitch? */
bool_t 
cswitch__75_cgen_cop(obj_t obj_130)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      return
	 is_a__118___object(obj_130, cswitch_cgen_cop);
   }
}



/* _cswitch? */
obj_t 
_cswitch__47_cgen_cop(obj_t env_3503, obj_t obj_3504)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {		/* Cgen/cop.scm 94 */
	 bool_t aux_4543;
	 aux_4543 =
	    cswitch__75_cgen_cop(obj_3504);
	 return
	    BBOOL(aux_4543);
      }
   }
}



/* make-cswitch */
cswitch_bglt 
make_cswitch_250_cgen_cop(obj_t loc_131, cop_bglt test_132, obj_t clauses_133)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {		/* Cgen/cop.scm 94 */
	 cswitch_bglt new1823_2433;
	 new1823_2433 =
	    ((cswitch_bglt) BREF(GC_MALLOC(sizeof(struct cswitch))));
	 {	/* Cgen/cop.scm 94 */
	    long arg2302_2434;
	    arg2302_2434 =
	       class_num_218___object(cswitch_cgen_cop);
	    {	/* Cgen/cop.scm 94 */
	       obj_t obj_2438;
	       obj_2438 =
		  (obj_t) (new1823_2433);
	       (((obj_t) CREF(obj_2438))->header = MAKE_HEADER(arg2302_2434, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 94 */
	    object_bglt aux_4550;
	    aux_4550 =
	       (object_bglt) (new1823_2433);
	    OBJECT_WIDENING_SET(aux_4550, BFALSE);
	 }
	 ((((cswitch_bglt) CREF(new1823_2433))->loc) = ((obj_t) loc_131), BUNSPEC);
	 ((((cswitch_bglt) CREF(new1823_2433))->test) = ((cop_bglt) test_132), BUNSPEC);
	 ((((cswitch_bglt) CREF(new1823_2433))->clauses) = ((obj_t) clauses_133), BUNSPEC);
	 return new1823_2433;
      }
   }
}



/* _make-cswitch2708 */
obj_t 
_make_cswitch2708_95_cgen_cop(obj_t env_3505, obj_t loc_3506, obj_t test_3507, obj_t clauses_3508)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {		/* Cgen/cop.scm 94 */
	 cswitch_bglt aux_4556;
	 aux_4556 =
	    make_cswitch_250_cgen_cop(loc_3506,
	    (cop_bglt) (test_3507), clauses_3508);
	 return
	    (obj_t) (aux_4556);
      }
   }
}



/* cswitch-loc-set! */
obj_t 
cswitch_loc_set__163_cgen_cop(cswitch_bglt obj_134, obj_t val1822_135)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cswitch_bglt) CREF(obj_134))->loc) = ((obj_t) val1822_135), BUNSPEC);
   }
}



/* _cswitch-loc-set!2709 */
obj_t 
_cswitch_loc_set_2709_251_cgen_cop(obj_t env_3509, obj_t obj_3510, obj_t val1822_3511)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cswitch_loc_set__163_cgen_cop(
	 (cswitch_bglt) (obj_3510), val1822_3511);
   }
}



/* cswitch-loc */
obj_t 
cswitch_loc_193_cgen_cop(cswitch_bglt obj_136)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cswitch_bglt) CREF(obj_136))->loc);
   }
}



/* _cswitch-loc2710 */
obj_t 
_cswitch_loc2710_128_cgen_cop(obj_t env_3512, obj_t obj_3513)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cswitch_loc_193_cgen_cop(
	 (cswitch_bglt) (obj_3513));
   }
}



/* cswitch-test */
cop_bglt 
cswitch_test_204_cgen_cop(cswitch_bglt obj_137)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 95 */
      return
	 (((cswitch_bglt) CREF(obj_137))->test);
   }
}



/* _cswitch-test2711 */
obj_t 
_cswitch_test2711_95_cgen_cop(obj_t env_3514, obj_t obj_3515)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 95 */
      {		/* Cgen/cop.scm 95 */
	 cop_bglt aux_4567;
	 aux_4567 =
	    cswitch_test_204_cgen_cop(
	    (cswitch_bglt) (obj_3515));
	 return
	    (obj_t) (aux_4567);
      }
   }
}



/* cswitch-clauses */
obj_t 
cswitch_clauses_50_cgen_cop(cswitch_bglt obj_138)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 96 */
      return
	 (((cswitch_bglt) CREF(obj_138))->clauses);
   }
}



/* _cswitch-clauses2712 */
obj_t 
_cswitch_clauses2712_208_cgen_cop(obj_t env_3516, obj_t obj_3517)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 96 */
      return
	 cswitch_clauses_50_cgen_cop(
	 (cswitch_bglt) (obj_3517));
   }
}



/* allocate-cfail */
cfail_bglt 
allocate_cfail_187_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {		/* Cgen/cop.scm 89 */
	 cfail_bglt new1803_1286;
	 new1803_1286 =
	    ((cfail_bglt) BREF(GC_MALLOC(sizeof(struct cfail))));
	 {	/* Cgen/cop.scm 89 */
	    long arg2303_1287;
	    arg2303_1287 =
	       class_num_218___object(cfail_cgen_cop);
	    {	/* Cgen/cop.scm 89 */
	       obj_t obj_2440;
	       obj_2440 =
		  (obj_t) (new1803_1286);
	       (((obj_t) CREF(obj_2440))->header = MAKE_HEADER(arg2303_1287, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 89 */
	    object_bglt aux_4578;
	    aux_4578 =
	       (object_bglt) (new1803_1286);
	    OBJECT_WIDENING_SET(aux_4578, BFALSE);
	 }
	 return new1803_1286;
      }
   }
}



/* _allocate-cfail */
obj_t 
_allocate_cfail_114_cgen_cop(obj_t env_3326)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {		/* Cgen/cop.scm 89 */
	 cfail_bglt aux_4581;
	 aux_4581 =
	    allocate_cfail_187_cgen_cop();
	 return
	    (obj_t) (aux_4581);
      }
   }
}



/* cfail? */
bool_t 
cfail__244_cgen_cop(obj_t obj_142)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      return
	 is_a__118___object(obj_142, cfail_cgen_cop);
   }
}



/* _cfail? */
obj_t 
_cfail__212_cgen_cop(obj_t env_3518, obj_t obj_3519)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {		/* Cgen/cop.scm 89 */
	 bool_t aux_4585;
	 aux_4585 =
	    cfail__244_cgen_cop(obj_3519);
	 return
	    BBOOL(aux_4585);
      }
   }
}



/* make-cfail */
cfail_bglt 
make_cfail_76_cgen_cop(obj_t loc_143, cop_bglt proc_144, cop_bglt msg_145, cop_bglt obj_146)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {		/* Cgen/cop.scm 89 */
	 cfail_bglt new1797_2442;
	 new1797_2442 =
	    ((cfail_bglt) BREF(GC_MALLOC(sizeof(struct cfail))));
	 {	/* Cgen/cop.scm 89 */
	    long arg2304_2443;
	    arg2304_2443 =
	       class_num_218___object(cfail_cgen_cop);
	    {	/* Cgen/cop.scm 89 */
	       obj_t obj_2448;
	       obj_2448 =
		  (obj_t) (new1797_2442);
	       (((obj_t) CREF(obj_2448))->header = MAKE_HEADER(arg2304_2443, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 89 */
	    object_bglt aux_4592;
	    aux_4592 =
	       (object_bglt) (new1797_2442);
	    OBJECT_WIDENING_SET(aux_4592, BFALSE);
	 }
	 ((((cfail_bglt) CREF(new1797_2442))->loc) = ((obj_t) loc_143), BUNSPEC);
	 ((((cfail_bglt) CREF(new1797_2442))->proc) = ((cop_bglt) proc_144), BUNSPEC);
	 ((((cfail_bglt) CREF(new1797_2442))->msg) = ((cop_bglt) msg_145), BUNSPEC);
	 ((((cfail_bglt) CREF(new1797_2442))->obj) = ((cop_bglt) obj_146), BUNSPEC);
	 return new1797_2442;
      }
   }
}



/* _make-cfail2713 */
obj_t 
_make_cfail2713_227_cgen_cop(obj_t env_3520, obj_t loc_3521, obj_t proc_3522, obj_t msg_3523, obj_t obj_3524)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {		/* Cgen/cop.scm 89 */
	 cfail_bglt aux_4599;
	 aux_4599 =
	    make_cfail_76_cgen_cop(loc_3521,
	    (cop_bglt) (proc_3522),
	    (cop_bglt) (msg_3523),
	    (cop_bglt) (obj_3524));
	 return
	    (obj_t) (aux_4599);
      }
   }
}



/* cfail-loc-set! */
obj_t 
cfail_loc_set__82_cgen_cop(cfail_bglt obj_147, obj_t val1796_148)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cfail_bglt) CREF(obj_147))->loc) = ((obj_t) val1796_148), BUNSPEC);
   }
}



/* _cfail-loc-set!2714 */
obj_t 
_cfail_loc_set_2714_227_cgen_cop(obj_t env_3525, obj_t obj_3526, obj_t val1796_3527)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cfail_loc_set__82_cgen_cop(
	 (cfail_bglt) (obj_3526), val1796_3527);
   }
}



/* cfail-loc */
obj_t 
cfail_loc_182_cgen_cop(cfail_bglt obj_149)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cfail_bglt) CREF(obj_149))->loc);
   }
}



/* _cfail-loc2715 */
obj_t 
_cfail_loc2715_124_cgen_cop(obj_t env_3528, obj_t obj_3529)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cfail_loc_182_cgen_cop(
	 (cfail_bglt) (obj_3529));
   }
}



/* cfail-proc */
cop_bglt 
cfail_proc_96_cgen_cop(cfail_bglt obj_150)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 90 */
      return
	 (((cfail_bglt) CREF(obj_150))->proc);
   }
}



/* _cfail-proc2716 */
obj_t 
_cfail_proc2716_134_cgen_cop(obj_t env_3530, obj_t obj_3531)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 90 */
      {		/* Cgen/cop.scm 90 */
	 cop_bglt aux_4612;
	 aux_4612 =
	    cfail_proc_96_cgen_cop(
	    (cfail_bglt) (obj_3531));
	 return
	    (obj_t) (aux_4612);
      }
   }
}



/* cfail-msg */
cop_bglt 
cfail_msg_43_cgen_cop(cfail_bglt obj_151)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 91 */
      return
	 (((cfail_bglt) CREF(obj_151))->msg);
   }
}



/* _cfail-msg2717 */
obj_t 
_cfail_msg2717_136_cgen_cop(obj_t env_3532, obj_t obj_3533)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 91 */
      {		/* Cgen/cop.scm 91 */
	 cop_bglt aux_4617;
	 aux_4617 =
	    cfail_msg_43_cgen_cop(
	    (cfail_bglt) (obj_3533));
	 return
	    (obj_t) (aux_4617);
      }
   }
}



/* cfail-obj */
cop_bglt 
cfail_obj_133_cgen_cop(cfail_bglt obj_152)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 92 */
      return
	 (((cfail_bglt) CREF(obj_152))->obj);
   }
}



/* _cfail-obj2718 */
obj_t 
_cfail_obj2718_3_cgen_cop(obj_t env_3534, obj_t obj_3535)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 92 */
      {		/* Cgen/cop.scm 92 */
	 cop_bglt aux_4622;
	 aux_4622 =
	    cfail_obj_133_cgen_cop(
	    (cfail_bglt) (obj_3535));
	 return
	    (obj_t) (aux_4622);
      }
   }
}



/* allocate-capp */
capp_bglt 
allocate_capp_109_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {		/* Cgen/cop.scm 85 */
	 capp_bglt new1781_1294;
	 new1781_1294 =
	    ((capp_bglt) BREF(GC_MALLOC(sizeof(struct capp))));
	 {	/* Cgen/cop.scm 85 */
	    long arg2305_1295;
	    arg2305_1295 =
	       class_num_218___object(capp_cgen_cop);
	    {	/* Cgen/cop.scm 85 */
	       obj_t obj_2450;
	       obj_2450 =
		  (obj_t) (new1781_1294);
	       (((obj_t) CREF(obj_2450))->header = MAKE_HEADER(arg2305_1295, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 85 */
	    object_bglt aux_4630;
	    aux_4630 =
	       (object_bglt) (new1781_1294);
	    OBJECT_WIDENING_SET(aux_4630, BFALSE);
	 }
	 return new1781_1294;
      }
   }
}



/* _allocate-capp */
obj_t 
_allocate_capp_243_cgen_cop(obj_t env_3325)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {		/* Cgen/cop.scm 85 */
	 capp_bglt aux_4633;
	 aux_4633 =
	    allocate_capp_109_cgen_cop();
	 return
	    (obj_t) (aux_4633);
      }
   }
}



/* capp? */
bool_t 
capp__160_cgen_cop(obj_t obj_156)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      return
	 is_a__118___object(obj_156, capp_cgen_cop);
   }
}



/* _capp? */
obj_t 
_capp__47_cgen_cop(obj_t env_3536, obj_t obj_3537)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {		/* Cgen/cop.scm 85 */
	 bool_t aux_4637;
	 aux_4637 =
	    capp__160_cgen_cop(obj_3537);
	 return
	    BBOOL(aux_4637);
      }
   }
}



/* make-capp */
capp_bglt 
make_capp_159_cgen_cop(obj_t loc_157, cop_bglt fun_158, obj_t args_159)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {		/* Cgen/cop.scm 85 */
	 capp_bglt new1776_2452;
	 new1776_2452 =
	    ((capp_bglt) BREF(GC_MALLOC(sizeof(struct capp))));
	 {	/* Cgen/cop.scm 85 */
	    long arg2306_2453;
	    arg2306_2453 =
	       class_num_218___object(capp_cgen_cop);
	    {	/* Cgen/cop.scm 85 */
	       obj_t obj_2457;
	       obj_2457 =
		  (obj_t) (new1776_2452);
	       (((obj_t) CREF(obj_2457))->header = MAKE_HEADER(arg2306_2453, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 85 */
	    object_bglt aux_4644;
	    aux_4644 =
	       (object_bglt) (new1776_2452);
	    OBJECT_WIDENING_SET(aux_4644, BFALSE);
	 }
	 ((((capp_bglt) CREF(new1776_2452))->loc) = ((obj_t) loc_157), BUNSPEC);
	 ((((capp_bglt) CREF(new1776_2452))->fun) = ((cop_bglt) fun_158), BUNSPEC);
	 ((((capp_bglt) CREF(new1776_2452))->args) = ((obj_t) args_159), BUNSPEC);
	 return new1776_2452;
      }
   }
}



/* _make-capp2719 */
obj_t 
_make_capp2719_29_cgen_cop(obj_t env_3538, obj_t loc_3539, obj_t fun_3540, obj_t args_3541)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {		/* Cgen/cop.scm 85 */
	 capp_bglt aux_4650;
	 aux_4650 =
	    make_capp_159_cgen_cop(loc_3539,
	    (cop_bglt) (fun_3540), args_3541);
	 return
	    (obj_t) (aux_4650);
      }
   }
}



/* capp-loc-set! */
obj_t 
capp_loc_set__54_cgen_cop(capp_bglt obj_160, obj_t val1775_161)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((capp_bglt) CREF(obj_160))->loc) = ((obj_t) val1775_161), BUNSPEC);
   }
}



/* _capp-loc-set!2720 */
obj_t 
_capp_loc_set_2720_91_cgen_cop(obj_t env_3542, obj_t obj_3543, obj_t val1775_3544)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 capp_loc_set__54_cgen_cop(
	 (capp_bglt) (obj_3543), val1775_3544);
   }
}



/* capp-loc */
obj_t 
capp_loc_231_cgen_cop(capp_bglt obj_162)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((capp_bglt) CREF(obj_162))->loc);
   }
}



/* _capp-loc2721 */
obj_t 
_capp_loc2721_212_cgen_cop(obj_t env_3545, obj_t obj_3546)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 capp_loc_231_cgen_cop(
	 (capp_bglt) (obj_3546));
   }
}



/* capp-fun */
cop_bglt 
capp_fun_71_cgen_cop(capp_bglt obj_163)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 86 */
      return
	 (((capp_bglt) CREF(obj_163))->fun);
   }
}



/* _capp-fun2722 */
obj_t 
_capp_fun2722_220_cgen_cop(obj_t env_3547, obj_t obj_3548)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 86 */
      {		/* Cgen/cop.scm 86 */
	 cop_bglt aux_4661;
	 aux_4661 =
	    capp_fun_71_cgen_cop(
	    (capp_bglt) (obj_3548));
	 return
	    (obj_t) (aux_4661);
      }
   }
}



/* capp-args */
obj_t 
capp_args_148_cgen_cop(capp_bglt obj_164)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 87 */
      return
	 (((capp_bglt) CREF(obj_164))->args);
   }
}



/* _capp-args2723 */
obj_t 
_capp_args2723_194_cgen_cop(obj_t env_3549, obj_t obj_3550)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 87 */
      return
	 capp_args_148_cgen_cop(
	 (capp_bglt) (obj_3550));
   }
}



/* allocate-capply */
capply_bglt 
allocate_capply_99_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {		/* Cgen/cop.scm 81 */
	 capply_bglt new1760_1301;
	 new1760_1301 =
	    ((capply_bglt) BREF(GC_MALLOC(sizeof(struct capply))));
	 {	/* Cgen/cop.scm 81 */
	    long arg2307_1302;
	    arg2307_1302 =
	       class_num_218___object(capply_cgen_cop);
	    {	/* Cgen/cop.scm 81 */
	       obj_t obj_2459;
	       obj_2459 =
		  (obj_t) (new1760_1301);
	       (((obj_t) CREF(obj_2459))->header = MAKE_HEADER(arg2307_1302, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 81 */
	    object_bglt aux_4672;
	    aux_4672 =
	       (object_bglt) (new1760_1301);
	    OBJECT_WIDENING_SET(aux_4672, BFALSE);
	 }
	 return new1760_1301;
      }
   }
}



/* _allocate-capply */
obj_t 
_allocate_capply_222_cgen_cop(obj_t env_3324)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {		/* Cgen/cop.scm 81 */
	 capply_bglt aux_4675;
	 aux_4675 =
	    allocate_capply_99_cgen_cop();
	 return
	    (obj_t) (aux_4675);
      }
   }
}



/* capply? */
bool_t 
capply__56_cgen_cop(obj_t obj_168)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      return
	 is_a__118___object(obj_168, capply_cgen_cop);
   }
}



/* _capply? */
obj_t 
_capply__134_cgen_cop(obj_t env_3551, obj_t obj_3552)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {		/* Cgen/cop.scm 81 */
	 bool_t aux_4679;
	 aux_4679 =
	    capply__56_cgen_cop(obj_3552);
	 return
	    BBOOL(aux_4679);
      }
   }
}



/* make-capply */
capply_bglt 
make_capply_101_cgen_cop(obj_t loc_169, cop_bglt fun_170, cop_bglt arg_171)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {		/* Cgen/cop.scm 81 */
	 capply_bglt new1755_2461;
	 new1755_2461 =
	    ((capply_bglt) BREF(GC_MALLOC(sizeof(struct capply))));
	 {	/* Cgen/cop.scm 81 */
	    long arg2308_2462;
	    arg2308_2462 =
	       class_num_218___object(capply_cgen_cop);
	    {	/* Cgen/cop.scm 81 */
	       obj_t obj_2466;
	       obj_2466 =
		  (obj_t) (new1755_2461);
	       (((obj_t) CREF(obj_2466))->header = MAKE_HEADER(arg2308_2462, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 81 */
	    object_bglt aux_4686;
	    aux_4686 =
	       (object_bglt) (new1755_2461);
	    OBJECT_WIDENING_SET(aux_4686, BFALSE);
	 }
	 ((((capply_bglt) CREF(new1755_2461))->loc) = ((obj_t) loc_169), BUNSPEC);
	 ((((capply_bglt) CREF(new1755_2461))->fun) = ((cop_bglt) fun_170), BUNSPEC);
	 ((((capply_bglt) CREF(new1755_2461))->arg) = ((cop_bglt) arg_171), BUNSPEC);
	 return new1755_2461;
      }
   }
}



/* _make-capply2724 */
obj_t 
_make_capply2724_166_cgen_cop(obj_t env_3553, obj_t loc_3554, obj_t fun_3555, obj_t arg_3556)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {		/* Cgen/cop.scm 81 */
	 capply_bglt aux_4692;
	 aux_4692 =
	    make_capply_101_cgen_cop(loc_3554,
	    (cop_bglt) (fun_3555),
	    (cop_bglt) (arg_3556));
	 return
	    (obj_t) (aux_4692);
      }
   }
}



/* capply-loc-set! */
obj_t 
capply_loc_set__0_cgen_cop(capply_bglt obj_172, obj_t val1754_173)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((capply_bglt) CREF(obj_172))->loc) = ((obj_t) val1754_173), BUNSPEC);
   }
}



/* _capply-loc-set!2725 */
obj_t 
_capply_loc_set_2725_48_cgen_cop(obj_t env_3557, obj_t obj_3558, obj_t val1754_3559)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 capply_loc_set__0_cgen_cop(
	 (capply_bglt) (obj_3558), val1754_3559);
   }
}



/* capply-loc */
obj_t 
capply_loc_38_cgen_cop(capply_bglt obj_174)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((capply_bglt) CREF(obj_174))->loc);
   }
}



/* _capply-loc2726 */
obj_t 
_capply_loc2726_188_cgen_cop(obj_t env_3560, obj_t obj_3561)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 capply_loc_38_cgen_cop(
	 (capply_bglt) (obj_3561));
   }
}



/* capply-fun */
cop_bglt 
capply_fun_1_cgen_cop(capply_bglt obj_175)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 82 */
      return
	 (((capply_bglt) CREF(obj_175))->fun);
   }
}



/* _capply-fun2727 */
obj_t 
_capply_fun2727_255_cgen_cop(obj_t env_3562, obj_t obj_3563)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 82 */
      {		/* Cgen/cop.scm 82 */
	 cop_bglt aux_4704;
	 aux_4704 =
	    capply_fun_1_cgen_cop(
	    (capply_bglt) (obj_3563));
	 return
	    (obj_t) (aux_4704);
      }
   }
}



/* capply-arg */
cop_bglt 
capply_arg_66_cgen_cop(capply_bglt obj_176)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 83 */
      return
	 (((capply_bglt) CREF(obj_176))->arg);
   }
}



/* _capply-arg2728 */
obj_t 
_capply_arg2728_51_cgen_cop(obj_t env_3564, obj_t obj_3565)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 83 */
      {		/* Cgen/cop.scm 83 */
	 cop_bglt aux_4709;
	 aux_4709 =
	    capply_arg_66_cgen_cop(
	    (capply_bglt) (obj_3565));
	 return
	    (obj_t) (aux_4709);
      }
   }
}



/* allocate-cfuncall */
cfuncall_bglt 
allocate_cfuncall_37_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {		/* Cgen/cop.scm 76 */
	 cfuncall_bglt new1735_1308;
	 new1735_1308 =
	    ((cfuncall_bglt) BREF(GC_MALLOC(sizeof(struct cfuncall))));
	 {	/* Cgen/cop.scm 76 */
	    long arg2309_1309;
	    arg2309_1309 =
	       class_num_218___object(cfuncall_cgen_cop);
	    {	/* Cgen/cop.scm 76 */
	       obj_t obj_2468;
	       obj_2468 =
		  (obj_t) (new1735_1308);
	       (((obj_t) CREF(obj_2468))->header = MAKE_HEADER(arg2309_1309, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 76 */
	    object_bglt aux_4717;
	    aux_4717 =
	       (object_bglt) (new1735_1308);
	    OBJECT_WIDENING_SET(aux_4717, BFALSE);
	 }
	 return new1735_1308;
      }
   }
}



/* _allocate-cfuncall */
obj_t 
_allocate_cfuncall_49_cgen_cop(obj_t env_3323)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {		/* Cgen/cop.scm 76 */
	 cfuncall_bglt aux_4720;
	 aux_4720 =
	    allocate_cfuncall_37_cgen_cop();
	 return
	    (obj_t) (aux_4720);
      }
   }
}



/* cfuncall? */
bool_t 
cfuncall__223_cgen_cop(obj_t obj_180)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      return
	 is_a__118___object(obj_180, cfuncall_cgen_cop);
   }
}



/* _cfuncall? */
obj_t 
_cfuncall__70_cgen_cop(obj_t env_3566, obj_t obj_3567)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {		/* Cgen/cop.scm 76 */
	 bool_t aux_4724;
	 aux_4724 =
	    cfuncall__223_cgen_cop(obj_3567);
	 return
	    BBOOL(aux_4724);
      }
   }
}



/* make-cfuncall */
cfuncall_bglt 
make_cfuncall_230_cgen_cop(obj_t loc_181, cop_bglt fun_182, obj_t args_183, obj_t strength_184)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {		/* Cgen/cop.scm 76 */
	 cfuncall_bglt new1729_2470;
	 new1729_2470 =
	    ((cfuncall_bglt) BREF(GC_MALLOC(sizeof(struct cfuncall))));
	 {	/* Cgen/cop.scm 76 */
	    long arg2310_2471;
	    arg2310_2471 =
	       class_num_218___object(cfuncall_cgen_cop);
	    {	/* Cgen/cop.scm 76 */
	       obj_t obj_2476;
	       obj_2476 =
		  (obj_t) (new1729_2470);
	       (((obj_t) CREF(obj_2476))->header = MAKE_HEADER(arg2310_2471, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 76 */
	    object_bglt aux_4731;
	    aux_4731 =
	       (object_bglt) (new1729_2470);
	    OBJECT_WIDENING_SET(aux_4731, BFALSE);
	 }
	 ((((cfuncall_bglt) CREF(new1729_2470))->loc) = ((obj_t) loc_181), BUNSPEC);
	 ((((cfuncall_bglt) CREF(new1729_2470))->fun) = ((cop_bglt) fun_182), BUNSPEC);
	 ((((cfuncall_bglt) CREF(new1729_2470))->args) = ((obj_t) args_183), BUNSPEC);
	 ((((cfuncall_bglt) CREF(new1729_2470))->strength) = ((obj_t) strength_184), BUNSPEC);
	 return new1729_2470;
      }
   }
}



/* _make-cfuncall2729 */
obj_t 
_make_cfuncall2729_117_cgen_cop(obj_t env_3568, obj_t loc_3569, obj_t fun_3570, obj_t args_3571, obj_t strength_3572)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {		/* Cgen/cop.scm 76 */
	 cfuncall_bglt aux_4738;
	 aux_4738 =
	    make_cfuncall_230_cgen_cop(loc_3569,
	    (cop_bglt) (fun_3570), args_3571, strength_3572);
	 return
	    (obj_t) (aux_4738);
      }
   }
}



/* cfuncall-loc-set! */
obj_t 
cfuncall_loc_set__107_cgen_cop(cfuncall_bglt obj_185, obj_t val1728_186)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cfuncall_bglt) CREF(obj_185))->loc) = ((obj_t) val1728_186), BUNSPEC);
   }
}



/* _cfuncall-loc-set!2730 */
obj_t 
_cfuncall_loc_set_2730_247_cgen_cop(obj_t env_3573, obj_t obj_3574, obj_t val1728_3575)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cfuncall_loc_set__107_cgen_cop(
	 (cfuncall_bglt) (obj_3574), val1728_3575);
   }
}



/* cfuncall-loc */
obj_t 
cfuncall_loc_128_cgen_cop(cfuncall_bglt obj_187)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cfuncall_bglt) CREF(obj_187))->loc);
   }
}



/* _cfuncall-loc2731 */
obj_t 
_cfuncall_loc2731_133_cgen_cop(obj_t env_3576, obj_t obj_3577)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cfuncall_loc_128_cgen_cop(
	 (cfuncall_bglt) (obj_3577));
   }
}



/* cfuncall-fun */
cop_bglt 
cfuncall_fun_206_cgen_cop(cfuncall_bglt obj_188)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 77 */
      return
	 (((cfuncall_bglt) CREF(obj_188))->fun);
   }
}



/* _cfuncall-fun2732 */
obj_t 
_cfuncall_fun2732_6_cgen_cop(obj_t env_3578, obj_t obj_3579)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 77 */
      {		/* Cgen/cop.scm 77 */
	 cop_bglt aux_4749;
	 aux_4749 =
	    cfuncall_fun_206_cgen_cop(
	    (cfuncall_bglt) (obj_3579));
	 return
	    (obj_t) (aux_4749);
      }
   }
}



/* cfuncall-args */
obj_t 
cfuncall_args_216_cgen_cop(cfuncall_bglt obj_189)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 78 */
      return
	 (((cfuncall_bglt) CREF(obj_189))->args);
   }
}



/* _cfuncall-args2733 */
obj_t 
_cfuncall_args2733_53_cgen_cop(obj_t env_3580, obj_t obj_3581)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 78 */
      return
	 cfuncall_args_216_cgen_cop(
	 (cfuncall_bglt) (obj_3581));
   }
}



/* cfuncall-strength */
obj_t 
cfuncall_strength_61_cgen_cop(cfuncall_bglt obj_190)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 79 */
      return
	 (((cfuncall_bglt) CREF(obj_190))->strength);
   }
}



/* _cfuncall-strength2734 */
obj_t 
_cfuncall_strength2734_93_cgen_cop(obj_t env_3582, obj_t obj_3583)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 79 */
      return
	 cfuncall_strength_61_cgen_cop(
	 (cfuncall_bglt) (obj_3583));
   }
}



/* allocate-local-var */
local_var_164_bglt 
allocate_local_var_218_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {		/* Cgen/cop.scm 73 */
	 local_var_164_bglt new1717_1316;
	 new1717_1316 =
	    ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
	 {	/* Cgen/cop.scm 73 */
	    long arg2311_1317;
	    arg2311_1317 =
	       class_num_218___object(local_var_164_cgen_cop);
	    {	/* Cgen/cop.scm 73 */
	       obj_t obj_2478;
	       obj_2478 =
		  (obj_t) (new1717_1316);
	       (((obj_t) CREF(obj_2478))->header = MAKE_HEADER(arg2311_1317, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 73 */
	    object_bglt aux_4763;
	    aux_4763 =
	       (object_bglt) (new1717_1316);
	    OBJECT_WIDENING_SET(aux_4763, BFALSE);
	 }
	 return new1717_1316;
      }
   }
}



/* _allocate-local-var */
obj_t 
_allocate_local_var_109_cgen_cop(obj_t env_3322)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {		/* Cgen/cop.scm 73 */
	 local_var_164_bglt aux_4766;
	 aux_4766 =
	    allocate_local_var_218_cgen_cop();
	 return
	    (obj_t) (aux_4766);
      }
   }
}



/* local-var? */
bool_t 
local_var__228_cgen_cop(obj_t obj_194)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      return
	 is_a__118___object(obj_194, local_var_164_cgen_cop);
   }
}



/* _local-var? */
obj_t 
_local_var__240_cgen_cop(obj_t env_3584, obj_t obj_3585)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {		/* Cgen/cop.scm 73 */
	 bool_t aux_4770;
	 aux_4770 =
	    local_var__228_cgen_cop(obj_3585);
	 return
	    BBOOL(aux_4770);
      }
   }
}



/* make-local-var */
local_var_164_bglt 
make_local_var_50_cgen_cop(obj_t loc_195, obj_t vars_196)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {		/* Cgen/cop.scm 73 */
	 local_var_164_bglt new1713_2480;
	 new1713_2480 =
	    ((local_var_164_bglt) BREF(GC_MALLOC(sizeof(struct local_var_164))));
	 {	/* Cgen/cop.scm 73 */
	    long arg2312_2481;
	    arg2312_2481 =
	       class_num_218___object(local_var_164_cgen_cop);
	    {	/* Cgen/cop.scm 73 */
	       obj_t obj_2484;
	       obj_2484 =
		  (obj_t) (new1713_2480);
	       (((obj_t) CREF(obj_2484))->header = MAKE_HEADER(arg2312_2481, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 73 */
	    object_bglt aux_4777;
	    aux_4777 =
	       (object_bglt) (new1713_2480);
	    OBJECT_WIDENING_SET(aux_4777, BFALSE);
	 }
	 ((((local_var_164_bglt) CREF(new1713_2480))->loc) = ((obj_t) loc_195), BUNSPEC);
	 ((((local_var_164_bglt) CREF(new1713_2480))->vars) = ((obj_t) vars_196), BUNSPEC);
	 return new1713_2480;
      }
   }
}



/* _make-local-var */
obj_t 
_make_local_var_232_cgen_cop(obj_t env_3586, obj_t loc_3587, obj_t vars_3588)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {		/* Cgen/cop.scm 73 */
	 local_var_164_bglt aux_4782;
	 aux_4782 =
	    make_local_var_50_cgen_cop(loc_3587, vars_3588);
	 return
	    (obj_t) (aux_4782);
      }
   }
}



/* local-var-loc-set! */
obj_t 
local_var_loc_set__93_cgen_cop(local_var_164_bglt obj_197, obj_t val1712_198)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((local_var_164_bglt) CREF(obj_197))->loc) = ((obj_t) val1712_198), BUNSPEC);
   }
}



/* _local-var-loc-set!2735 */
obj_t 
_local_var_loc_set_2735_25_cgen_cop(obj_t env_3589, obj_t obj_3590, obj_t val1712_3591)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 local_var_loc_set__93_cgen_cop(
	 (local_var_164_bglt) (obj_3590), val1712_3591);
   }
}



/* local-var-loc */
obj_t 
local_var_loc_15_cgen_cop(local_var_164_bglt obj_199)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((local_var_164_bglt) CREF(obj_199))->loc);
   }
}



/* _local-var-loc2736 */
obj_t 
_local_var_loc2736_238_cgen_cop(obj_t env_3592, obj_t obj_3593)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 local_var_loc_15_cgen_cop(
	 (local_var_164_bglt) (obj_3593));
   }
}



/* local-var-vars */
obj_t 
local_var_vars_243_cgen_cop(local_var_164_bglt obj_200)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 74 */
      return
	 (((local_var_164_bglt) CREF(obj_200))->vars);
   }
}



/* _local-var-vars2737 */
obj_t 
_local_var_vars2737_24_cgen_cop(obj_t env_3594, obj_t obj_3595)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 74 */
      return
	 local_var_vars_243_cgen_cop(
	 (local_var_164_bglt) (obj_3595));
   }
}



/* allocate-cif */
cif_bglt 
allocate_cif_90_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {		/* Cgen/cop.scm 68 */
	 cif_bglt new1693_1322;
	 new1693_1322 =
	    ((cif_bglt) BREF(GC_MALLOC(sizeof(struct cif))));
	 {	/* Cgen/cop.scm 68 */
	    long arg2313_1323;
	    arg2313_1323 =
	       class_num_218___object(cif_cgen_cop);
	    {	/* Cgen/cop.scm 68 */
	       obj_t obj_2486;
	       obj_2486 =
		  (obj_t) (new1693_1322);
	       (((obj_t) CREF(obj_2486))->header = MAKE_HEADER(arg2313_1323, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 68 */
	    object_bglt aux_4798;
	    aux_4798 =
	       (object_bglt) (new1693_1322);
	    OBJECT_WIDENING_SET(aux_4798, BFALSE);
	 }
	 return new1693_1322;
      }
   }
}



/* _allocate-cif */
obj_t 
_allocate_cif_80_cgen_cop(obj_t env_3321)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {		/* Cgen/cop.scm 68 */
	 cif_bglt aux_4801;
	 aux_4801 =
	    allocate_cif_90_cgen_cop();
	 return
	    (obj_t) (aux_4801);
      }
   }
}



/* cif? */
bool_t 
cif__209_cgen_cop(obj_t obj_204)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      return
	 is_a__118___object(obj_204, cif_cgen_cop);
   }
}



/* _cif? */
obj_t 
_cif__54_cgen_cop(obj_t env_3596, obj_t obj_3597)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {		/* Cgen/cop.scm 68 */
	 bool_t aux_4805;
	 aux_4805 =
	    cif__209_cgen_cop(obj_3597);
	 return
	    BBOOL(aux_4805);
      }
   }
}



/* make-cif */
cif_bglt 
make_cif_3_cgen_cop(obj_t loc_205, cop_bglt test_206, cop_bglt true_207, cop_bglt false_208)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {		/* Cgen/cop.scm 68 */
	 cif_bglt new1687_2488;
	 new1687_2488 =
	    ((cif_bglt) BREF(GC_MALLOC(sizeof(struct cif))));
	 {	/* Cgen/cop.scm 68 */
	    long arg2314_2489;
	    arg2314_2489 =
	       class_num_218___object(cif_cgen_cop);
	    {	/* Cgen/cop.scm 68 */
	       obj_t obj_2494;
	       obj_2494 =
		  (obj_t) (new1687_2488);
	       (((obj_t) CREF(obj_2494))->header = MAKE_HEADER(arg2314_2489, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 68 */
	    object_bglt aux_4812;
	    aux_4812 =
	       (object_bglt) (new1687_2488);
	    OBJECT_WIDENING_SET(aux_4812, BFALSE);
	 }
	 ((((cif_bglt) CREF(new1687_2488))->loc) = ((obj_t) loc_205), BUNSPEC);
	 ((((cif_bglt) CREF(new1687_2488))->test) = ((cop_bglt) test_206), BUNSPEC);
	 ((((cif_bglt) CREF(new1687_2488))->true) = ((cop_bglt) true_207), BUNSPEC);
	 ((((cif_bglt) CREF(new1687_2488))->false) = ((cop_bglt) false_208), BUNSPEC);
	 return new1687_2488;
      }
   }
}



/* _make-cif2738 */
obj_t 
_make_cif2738_107_cgen_cop(obj_t env_3598, obj_t loc_3599, obj_t test_3600, obj_t true_3601, obj_t false_3602)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {		/* Cgen/cop.scm 68 */
	 cif_bglt aux_4819;
	 aux_4819 =
	    make_cif_3_cgen_cop(loc_3599,
	    (cop_bglt) (test_3600),
	    (cop_bglt) (true_3601),
	    (cop_bglt) (false_3602));
	 return
	    (obj_t) (aux_4819);
      }
   }
}



/* cif-loc-set! */
obj_t 
cif_loc_set__209_cgen_cop(cif_bglt obj_209, obj_t val1686_210)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cif_bglt) CREF(obj_209))->loc) = ((obj_t) val1686_210), BUNSPEC);
   }
}



/* _cif-loc-set!2739 */
obj_t 
_cif_loc_set_2739_85_cgen_cop(obj_t env_3603, obj_t obj_3604, obj_t val1686_3605)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cif_loc_set__209_cgen_cop(
	 (cif_bglt) (obj_3604), val1686_3605);
   }
}



/* cif-loc */
obj_t 
cif_loc_54_cgen_cop(cif_bglt obj_211)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cif_bglt) CREF(obj_211))->loc);
   }
}



/* _cif-loc2740 */
obj_t 
_cif_loc2740_106_cgen_cop(obj_t env_3606, obj_t obj_3607)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cif_loc_54_cgen_cop(
	 (cif_bglt) (obj_3607));
   }
}



/* cif-test */
cop_bglt 
cif_test_82_cgen_cop(cif_bglt obj_212)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 69 */
      return
	 (((cif_bglt) CREF(obj_212))->test);
   }
}



/* _cif-test2741 */
obj_t 
_cif_test2741_154_cgen_cop(obj_t env_3608, obj_t obj_3609)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 69 */
      {		/* Cgen/cop.scm 69 */
	 cop_bglt aux_4832;
	 aux_4832 =
	    cif_test_82_cgen_cop(
	    (cif_bglt) (obj_3609));
	 return
	    (obj_t) (aux_4832);
      }
   }
}



/* cif-true */
cop_bglt 
cif_true_58_cgen_cop(cif_bglt obj_213)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 70 */
      return
	 (((cif_bglt) CREF(obj_213))->true);
   }
}



/* _cif-true2742 */
obj_t 
_cif_true2742_157_cgen_cop(obj_t env_3610, obj_t obj_3611)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 70 */
      {		/* Cgen/cop.scm 70 */
	 cop_bglt aux_4837;
	 aux_4837 =
	    cif_true_58_cgen_cop(
	    (cif_bglt) (obj_3611));
	 return
	    (obj_t) (aux_4837);
      }
   }
}



/* cif-false */
cop_bglt 
cif_false_61_cgen_cop(cif_bglt obj_214)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 71 */
      return
	 (((cif_bglt) CREF(obj_214))->false);
   }
}



/* _cif-false2743 */
obj_t 
_cif_false2743_174_cgen_cop(obj_t env_3612, obj_t obj_3613)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 71 */
      {		/* Cgen/cop.scm 71 */
	 cop_bglt aux_4842;
	 aux_4842 =
	    cif_false_61_cgen_cop(
	    (cif_bglt) (obj_3613));
	 return
	    (obj_t) (aux_4842);
      }
   }
}



/* allocate-csetq */
csetq_bglt 
allocate_csetq_141_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {		/* Cgen/cop.scm 64 */
	 csetq_bglt new1671_1330;
	 new1671_1330 =
	    ((csetq_bglt) BREF(GC_MALLOC(sizeof(struct csetq))));
	 {	/* Cgen/cop.scm 64 */
	    long arg2315_1331;
	    arg2315_1331 =
	       class_num_218___object(csetq_cgen_cop);
	    {	/* Cgen/cop.scm 64 */
	       obj_t obj_2496;
	       obj_2496 =
		  (obj_t) (new1671_1330);
	       (((obj_t) CREF(obj_2496))->header = MAKE_HEADER(arg2315_1331, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 64 */
	    object_bglt aux_4850;
	    aux_4850 =
	       (object_bglt) (new1671_1330);
	    OBJECT_WIDENING_SET(aux_4850, BFALSE);
	 }
	 return new1671_1330;
      }
   }
}



/* _allocate-csetq */
obj_t 
_allocate_csetq_62_cgen_cop(obj_t env_3320)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {		/* Cgen/cop.scm 64 */
	 csetq_bglt aux_4853;
	 aux_4853 =
	    allocate_csetq_141_cgen_cop();
	 return
	    (obj_t) (aux_4853);
      }
   }
}



/* csetq? */
bool_t 
csetq__161_cgen_cop(obj_t obj_218)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      return
	 is_a__118___object(obj_218, csetq_cgen_cop);
   }
}



/* _csetq? */
obj_t 
_csetq__142_cgen_cop(obj_t env_3614, obj_t obj_3615)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {		/* Cgen/cop.scm 64 */
	 bool_t aux_4857;
	 aux_4857 =
	    csetq__161_cgen_cop(obj_3615);
	 return
	    BBOOL(aux_4857);
      }
   }
}



/* make-csetq */
csetq_bglt 
make_csetq_177_cgen_cop(obj_t loc_219, varc_bglt var_220, cop_bglt value_221)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {		/* Cgen/cop.scm 64 */
	 csetq_bglt new1666_2498;
	 new1666_2498 =
	    ((csetq_bglt) BREF(GC_MALLOC(sizeof(struct csetq))));
	 {	/* Cgen/cop.scm 64 */
	    long arg2316_2499;
	    arg2316_2499 =
	       class_num_218___object(csetq_cgen_cop);
	    {	/* Cgen/cop.scm 64 */
	       obj_t obj_2503;
	       obj_2503 =
		  (obj_t) (new1666_2498);
	       (((obj_t) CREF(obj_2503))->header = MAKE_HEADER(arg2316_2499, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 64 */
	    object_bglt aux_4864;
	    aux_4864 =
	       (object_bglt) (new1666_2498);
	    OBJECT_WIDENING_SET(aux_4864, BFALSE);
	 }
	 ((((csetq_bglt) CREF(new1666_2498))->loc) = ((obj_t) loc_219), BUNSPEC);
	 ((((csetq_bglt) CREF(new1666_2498))->var) = ((varc_bglt) var_220), BUNSPEC);
	 ((((csetq_bglt) CREF(new1666_2498))->value) = ((cop_bglt) value_221), BUNSPEC);
	 return new1666_2498;
      }
   }
}



/* _make-csetq2744 */
obj_t 
_make_csetq2744_182_cgen_cop(obj_t env_3616, obj_t loc_3617, obj_t var_3618, obj_t value_3619)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {		/* Cgen/cop.scm 64 */
	 csetq_bglt aux_4870;
	 aux_4870 =
	    make_csetq_177_cgen_cop(loc_3617,
	    (varc_bglt) (var_3618),
	    (cop_bglt) (value_3619));
	 return
	    (obj_t) (aux_4870);
      }
   }
}



/* csetq-loc-set! */
obj_t 
csetq_loc_set__106_cgen_cop(csetq_bglt obj_222, obj_t val1665_223)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((csetq_bglt) CREF(obj_222))->loc) = ((obj_t) val1665_223), BUNSPEC);
   }
}



/* _csetq-loc-set!2745 */
obj_t 
_csetq_loc_set_2745_245_cgen_cop(obj_t env_3620, obj_t obj_3621, obj_t val1665_3622)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 csetq_loc_set__106_cgen_cop(
	 (csetq_bglt) (obj_3621), val1665_3622);
   }
}



/* csetq-loc */
obj_t 
csetq_loc_189_cgen_cop(csetq_bglt obj_224)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((csetq_bglt) CREF(obj_224))->loc);
   }
}



/* _csetq-loc2746 */
obj_t 
_csetq_loc2746_104_cgen_cop(obj_t env_3623, obj_t obj_3624)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 csetq_loc_189_cgen_cop(
	 (csetq_bglt) (obj_3624));
   }
}



/* csetq-var */
varc_bglt 
csetq_var_122_cgen_cop(csetq_bglt obj_225)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 65 */
      return
	 (((csetq_bglt) CREF(obj_225))->var);
   }
}



/* _csetq-var2747 */
obj_t 
_csetq_var2747_23_cgen_cop(obj_t env_3625, obj_t obj_3626)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 65 */
      {		/* Cgen/cop.scm 65 */
	 varc_bglt aux_4882;
	 aux_4882 =
	    csetq_var_122_cgen_cop(
	    (csetq_bglt) (obj_3626));
	 return
	    (obj_t) (aux_4882);
      }
   }
}



/* csetq-value */
cop_bglt 
csetq_value_168_cgen_cop(csetq_bglt obj_226)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 66 */
      return
	 (((csetq_bglt) CREF(obj_226))->value);
   }
}



/* _csetq-value2748 */
obj_t 
_csetq_value2748_111_cgen_cop(obj_t env_3627, obj_t obj_3628)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 66 */
      {		/* Cgen/cop.scm 66 */
	 cop_bglt aux_4887;
	 aux_4887 =
	    csetq_value_168_cgen_cop(
	    (csetq_bglt) (obj_3628));
	 return
	    (obj_t) (aux_4887);
      }
   }
}



/* allocate-stop */
stop_bglt 
allocate_stop_49_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {		/* Cgen/cop.scm 61 */
	 stop_bglt new1654_1337;
	 new1654_1337 =
	    ((stop_bglt) BREF(GC_MALLOC(sizeof(struct stop))));
	 {	/* Cgen/cop.scm 61 */
	    long arg2317_1338;
	    arg2317_1338 =
	       class_num_218___object(stop_cgen_cop);
	    {	/* Cgen/cop.scm 61 */
	       obj_t obj_2505;
	       obj_2505 =
		  (obj_t) (new1654_1337);
	       (((obj_t) CREF(obj_2505))->header = MAKE_HEADER(arg2317_1338, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 61 */
	    object_bglt aux_4895;
	    aux_4895 =
	       (object_bglt) (new1654_1337);
	    OBJECT_WIDENING_SET(aux_4895, BFALSE);
	 }
	 return new1654_1337;
      }
   }
}



/* _allocate-stop */
obj_t 
_allocate_stop_67_cgen_cop(obj_t env_3319)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {		/* Cgen/cop.scm 61 */
	 stop_bglt aux_4898;
	 aux_4898 =
	    allocate_stop_49_cgen_cop();
	 return
	    (obj_t) (aux_4898);
      }
   }
}



/* stop? */
bool_t 
stop__17_cgen_cop(obj_t obj_230)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      return
	 is_a__118___object(obj_230, stop_cgen_cop);
   }
}



/* _stop? */
obj_t 
_stop__237_cgen_cop(obj_t env_3629, obj_t obj_3630)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {		/* Cgen/cop.scm 61 */
	 bool_t aux_4902;
	 aux_4902 =
	    stop__17_cgen_cop(obj_3630);
	 return
	    BBOOL(aux_4902);
      }
   }
}



/* make-stop */
stop_bglt 
make_stop_166_cgen_cop(obj_t loc_231, cop_bglt value_232)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {		/* Cgen/cop.scm 61 */
	 stop_bglt new1650_2507;
	 new1650_2507 =
	    ((stop_bglt) BREF(GC_MALLOC(sizeof(struct stop))));
	 {	/* Cgen/cop.scm 61 */
	    long arg2318_2508;
	    arg2318_2508 =
	       class_num_218___object(stop_cgen_cop);
	    {	/* Cgen/cop.scm 61 */
	       obj_t obj_2511;
	       obj_2511 =
		  (obj_t) (new1650_2507);
	       (((obj_t) CREF(obj_2511))->header = MAKE_HEADER(arg2318_2508, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 61 */
	    object_bglt aux_4909;
	    aux_4909 =
	       (object_bglt) (new1650_2507);
	    OBJECT_WIDENING_SET(aux_4909, BFALSE);
	 }
	 ((((stop_bglt) CREF(new1650_2507))->loc) = ((obj_t) loc_231), BUNSPEC);
	 ((((stop_bglt) CREF(new1650_2507))->value) = ((cop_bglt) value_232), BUNSPEC);
	 return new1650_2507;
      }
   }
}



/* _make-stop2749 */
obj_t 
_make_stop2749_252_cgen_cop(obj_t env_3631, obj_t loc_3632, obj_t value_3633)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {		/* Cgen/cop.scm 61 */
	 stop_bglt aux_4914;
	 aux_4914 =
	    make_stop_166_cgen_cop(loc_3632,
	    (cop_bglt) (value_3633));
	 return
	    (obj_t) (aux_4914);
      }
   }
}



/* stop-loc-set! */
obj_t 
stop_loc_set__39_cgen_cop(stop_bglt obj_233, obj_t val1649_234)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((stop_bglt) CREF(obj_233))->loc) = ((obj_t) val1649_234), BUNSPEC);
   }
}



/* _stop-loc-set!2750 */
obj_t 
_stop_loc_set_2750_0_cgen_cop(obj_t env_3634, obj_t obj_3635, obj_t val1649_3636)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 stop_loc_set__39_cgen_cop(
	 (stop_bglt) (obj_3635), val1649_3636);
   }
}



/* stop-loc */
obj_t 
stop_loc_69_cgen_cop(stop_bglt obj_235)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((stop_bglt) CREF(obj_235))->loc);
   }
}



/* _stop-loc2751 */
obj_t 
_stop_loc2751_225_cgen_cop(obj_t env_3637, obj_t obj_3638)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 stop_loc_69_cgen_cop(
	 (stop_bglt) (obj_3638));
   }
}



/* stop-value */
cop_bglt 
stop_value_3_cgen_cop(stop_bglt obj_236)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 62 */
      return
	 (((stop_bglt) CREF(obj_236))->value);
   }
}



/* _stop-value2752 */
obj_t 
_stop_value2752_82_cgen_cop(obj_t env_3639, obj_t obj_3640)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 62 */
      {		/* Cgen/cop.scm 62 */
	 cop_bglt aux_4925;
	 aux_4925 =
	    stop_value_3_cgen_cop(
	    (stop_bglt) (obj_3640));
	 return
	    (obj_t) (aux_4925);
      }
   }
}



/* allocate-nop */
nop_bglt 
allocate_nop_42_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {		/* Cgen/cop.scm 59 */
	 nop_bglt new1642_1343;
	 new1642_1343 =
	    ((nop_bglt) BREF(GC_MALLOC(sizeof(struct nop))));
	 {	/* Cgen/cop.scm 59 */
	    long arg2319_1344;
	    arg2319_1344 =
	       class_num_218___object(nop_cgen_cop);
	    {	/* Cgen/cop.scm 59 */
	       obj_t obj_2513;
	       obj_2513 =
		  (obj_t) (new1642_1343);
	       (((obj_t) CREF(obj_2513))->header = MAKE_HEADER(arg2319_1344, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 59 */
	    object_bglt aux_4933;
	    aux_4933 =
	       (object_bglt) (new1642_1343);
	    OBJECT_WIDENING_SET(aux_4933, BFALSE);
	 }
	 return new1642_1343;
      }
   }
}



/* _allocate-nop */
obj_t 
_allocate_nop_142_cgen_cop(obj_t env_3318)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {		/* Cgen/cop.scm 59 */
	 nop_bglt aux_4936;
	 aux_4936 =
	    allocate_nop_42_cgen_cop();
	 return
	    (obj_t) (aux_4936);
      }
   }
}



/* nop? */
bool_t 
nop__205_cgen_cop(obj_t obj_240)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      return
	 is_a__118___object(obj_240, nop_cgen_cop);
   }
}



/* _nop? */
obj_t 
_nop__15_cgen_cop(obj_t env_3641, obj_t obj_3642)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {		/* Cgen/cop.scm 59 */
	 bool_t aux_4940;
	 aux_4940 =
	    nop__205_cgen_cop(obj_3642);
	 return
	    BBOOL(aux_4940);
      }
   }
}



/* make-nop */
nop_bglt 
make_nop_193_cgen_cop(obj_t loc_241)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {		/* Cgen/cop.scm 59 */
	 nop_bglt new1639_2515;
	 new1639_2515 =
	    ((nop_bglt) BREF(GC_MALLOC(sizeof(struct nop))));
	 {	/* Cgen/cop.scm 59 */
	    long arg2320_2516;
	    arg2320_2516 =
	       class_num_218___object(nop_cgen_cop);
	    {	/* Cgen/cop.scm 59 */
	       obj_t obj_2518;
	       obj_2518 =
		  (obj_t) (new1639_2515);
	       (((obj_t) CREF(obj_2518))->header = MAKE_HEADER(arg2320_2516, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 59 */
	    object_bglt aux_4947;
	    aux_4947 =
	       (object_bglt) (new1639_2515);
	    OBJECT_WIDENING_SET(aux_4947, BFALSE);
	 }
	 ((((nop_bglt) CREF(new1639_2515))->loc) = ((obj_t) loc_241), BUNSPEC);
	 return new1639_2515;
      }
   }
}



/* _make-nop */
obj_t 
_make_nop_127_cgen_cop(obj_t env_3643, obj_t loc_3644)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {		/* Cgen/cop.scm 59 */
	 nop_bglt aux_4951;
	 aux_4951 =
	    make_nop_193_cgen_cop(loc_3644);
	 return
	    (obj_t) (aux_4951);
      }
   }
}



/* nop-loc-set! */
obj_t 
nop_loc_set__235_cgen_cop(nop_bglt obj_242, obj_t val1638_243)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((nop_bglt) CREF(obj_242))->loc) = ((obj_t) val1638_243), BUNSPEC);
   }
}



/* _nop-loc-set!2753 */
obj_t 
_nop_loc_set_2753_138_cgen_cop(obj_t env_3645, obj_t obj_3646, obj_t val1638_3647)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 nop_loc_set__235_cgen_cop(
	 (nop_bglt) (obj_3646), val1638_3647);
   }
}



/* nop-loc */
obj_t 
nop_loc_175_cgen_cop(nop_bglt obj_244)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((nop_bglt) CREF(obj_244))->loc);
   }
}



/* _nop-loc2754 */
obj_t 
_nop_loc2754_83_cgen_cop(obj_t env_3648, obj_t obj_3649)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 nop_loc_175_cgen_cop(
	 (nop_bglt) (obj_3649));
   }
}



/* allocate-csequence */
csequence_bglt 
allocate_csequence_231_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {		/* Cgen/cop.scm 55 */
	 csequence_bglt new1623_1348;
	 new1623_1348 =
	    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
	 {	/* Cgen/cop.scm 55 */
	    long arg2321_1349;
	    arg2321_1349 =
	       class_num_218___object(csequence_cgen_cop);
	    {	/* Cgen/cop.scm 55 */
	       obj_t obj_2520;
	       obj_2520 =
		  (obj_t) (new1623_1348);
	       (((obj_t) CREF(obj_2520))->header = MAKE_HEADER(arg2321_1349, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 55 */
	    object_bglt aux_4964;
	    aux_4964 =
	       (object_bglt) (new1623_1348);
	    OBJECT_WIDENING_SET(aux_4964, BFALSE);
	 }
	 return new1623_1348;
      }
   }
}



/* _allocate-csequence */
obj_t 
_allocate_csequence_87_cgen_cop(obj_t env_3317)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {		/* Cgen/cop.scm 55 */
	 csequence_bglt aux_4967;
	 aux_4967 =
	    allocate_csequence_231_cgen_cop();
	 return
	    (obj_t) (aux_4967);
      }
   }
}



/* csequence? */
bool_t 
csequence__124_cgen_cop(obj_t obj_248)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      return
	 is_a__118___object(obj_248, csequence_cgen_cop);
   }
}



/* _csequence? */
obj_t 
_csequence__120_cgen_cop(obj_t env_3650, obj_t obj_3651)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {		/* Cgen/cop.scm 55 */
	 bool_t aux_4971;
	 aux_4971 =
	    csequence__124_cgen_cop(obj_3651);
	 return
	    BBOOL(aux_4971);
      }
   }
}



/* make-csequence */
csequence_bglt 
make_csequence_181_cgen_cop(obj_t loc_249, bool_t c_exp__163_250, obj_t cops_251)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {		/* Cgen/cop.scm 55 */
	 csequence_bglt new1618_2522;
	 new1618_2522 =
	    ((csequence_bglt) BREF(GC_MALLOC(sizeof(struct csequence))));
	 {	/* Cgen/cop.scm 55 */
	    long arg2322_2523;
	    arg2322_2523 =
	       class_num_218___object(csequence_cgen_cop);
	    {	/* Cgen/cop.scm 55 */
	       obj_t obj_2527;
	       obj_2527 =
		  (obj_t) (new1618_2522);
	       (((obj_t) CREF(obj_2527))->header = MAKE_HEADER(arg2322_2523, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 55 */
	    object_bglt aux_4978;
	    aux_4978 =
	       (object_bglt) (new1618_2522);
	    OBJECT_WIDENING_SET(aux_4978, BFALSE);
	 }
	 ((((csequence_bglt) CREF(new1618_2522))->loc) = ((obj_t) loc_249), BUNSPEC);
	 ((((csequence_bglt) CREF(new1618_2522))->c_exp__163) = ((bool_t) c_exp__163_250), BUNSPEC);
	 ((((csequence_bglt) CREF(new1618_2522))->cops) = ((obj_t) cops_251), BUNSPEC);
	 return new1618_2522;
      }
   }
}



/* _make-csequence */
obj_t 
_make_csequence_138_cgen_cop(obj_t env_3652, obj_t loc_3653, obj_t c_exp__163_3654, obj_t cops_3655)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {		/* Cgen/cop.scm 55 */
	 csequence_bglt aux_4984;
	 aux_4984 =
	    make_csequence_181_cgen_cop(loc_3653,
	    CBOOL(c_exp__163_3654), cops_3655);
	 return
	    (obj_t) (aux_4984);
      }
   }
}



/* csequence-loc-set! */
obj_t 
csequence_loc_set__134_cgen_cop(csequence_bglt obj_252, obj_t val1617_253)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((csequence_bglt) CREF(obj_252))->loc) = ((obj_t) val1617_253), BUNSPEC);
   }
}



/* _csequence-loc-set!2755 */
obj_t 
_csequence_loc_set_2755_122_cgen_cop(obj_t env_3656, obj_t obj_3657, obj_t val1617_3658)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 csequence_loc_set__134_cgen_cop(
	 (csequence_bglt) (obj_3657), val1617_3658);
   }
}



/* csequence-loc */
obj_t 
csequence_loc_21_cgen_cop(csequence_bglt obj_254)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((csequence_bglt) CREF(obj_254))->loc);
   }
}



/* _csequence-loc2756 */
obj_t 
_csequence_loc2756_240_cgen_cop(obj_t env_3659, obj_t obj_3660)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 csequence_loc_21_cgen_cop(
	 (csequence_bglt) (obj_3660));
   }
}



/* csequence-c-exp? */
bool_t 
csequence_c_exp__44_cgen_cop(csequence_bglt obj_255)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 56 */
      return
	 (((csequence_bglt) CREF(obj_255))->c_exp__163);
   }
}



/* _csequence-c-exp?2757 */
obj_t 
_csequence_c_exp_2757_5_cgen_cop(obj_t env_3661, obj_t obj_3662)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 56 */
      {		/* Cgen/cop.scm 56 */
	 bool_t aux_4995;
	 aux_4995 =
	    csequence_c_exp__44_cgen_cop(
	    (csequence_bglt) (obj_3662));
	 return
	    BBOOL(aux_4995);
      }
   }
}



/* csequence-cops */
obj_t 
csequence_cops_198_cgen_cop(csequence_bglt obj_256)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 57 */
      return
	 (((csequence_bglt) CREF(obj_256))->cops);
   }
}



/* _csequence-cops2758 */
obj_t 
_csequence_cops2758_78_cgen_cop(obj_t env_3663, obj_t obj_3664)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 57 */
      return
	 csequence_cops_198_cgen_cop(
	 (csequence_bglt) (obj_3664));
   }
}



/* allocate-ccast */
ccast_bglt 
allocate_ccast_96_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {		/* Cgen/cop.scm 51 */
	 ccast_bglt new1602_1355;
	 new1602_1355 =
	    ((ccast_bglt) BREF(GC_MALLOC(sizeof(struct ccast))));
	 {	/* Cgen/cop.scm 51 */
	    long arg2323_1356;
	    arg2323_1356 =
	       class_num_218___object(ccast_cgen_cop);
	    {	/* Cgen/cop.scm 51 */
	       obj_t obj_2529;
	       obj_2529 =
		  (obj_t) (new1602_1355);
	       (((obj_t) CREF(obj_2529))->header = MAKE_HEADER(arg2323_1356, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 51 */
	    object_bglt aux_5006;
	    aux_5006 =
	       (object_bglt) (new1602_1355);
	    OBJECT_WIDENING_SET(aux_5006, BFALSE);
	 }
	 return new1602_1355;
      }
   }
}



/* _allocate-ccast */
obj_t 
_allocate_ccast_222_cgen_cop(obj_t env_3316)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {		/* Cgen/cop.scm 51 */
	 ccast_bglt aux_5009;
	 aux_5009 =
	    allocate_ccast_96_cgen_cop();
	 return
	    (obj_t) (aux_5009);
      }
   }
}



/* ccast? */
bool_t 
ccast__115_cgen_cop(obj_t obj_260)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      return
	 is_a__118___object(obj_260, ccast_cgen_cop);
   }
}



/* _ccast? */
obj_t 
_ccast__188_cgen_cop(obj_t env_3665, obj_t obj_3666)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {		/* Cgen/cop.scm 51 */
	 bool_t aux_5013;
	 aux_5013 =
	    ccast__115_cgen_cop(obj_3666);
	 return
	    BBOOL(aux_5013);
      }
   }
}



/* make-ccast */
ccast_bglt 
make_ccast_74_cgen_cop(obj_t loc_261, type_bglt type_262, cop_bglt arg_263)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {		/* Cgen/cop.scm 51 */
	 ccast_bglt new1597_2531;
	 new1597_2531 =
	    ((ccast_bglt) BREF(GC_MALLOC(sizeof(struct ccast))));
	 {	/* Cgen/cop.scm 51 */
	    long arg2324_2532;
	    arg2324_2532 =
	       class_num_218___object(ccast_cgen_cop);
	    {	/* Cgen/cop.scm 51 */
	       obj_t obj_2536;
	       obj_2536 =
		  (obj_t) (new1597_2531);
	       (((obj_t) CREF(obj_2536))->header = MAKE_HEADER(arg2324_2532, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 51 */
	    object_bglt aux_5020;
	    aux_5020 =
	       (object_bglt) (new1597_2531);
	    OBJECT_WIDENING_SET(aux_5020, BFALSE);
	 }
	 ((((ccast_bglt) CREF(new1597_2531))->loc) = ((obj_t) loc_261), BUNSPEC);
	 ((((ccast_bglt) CREF(new1597_2531))->type) = ((type_bglt) type_262), BUNSPEC);
	 ((((ccast_bglt) CREF(new1597_2531))->arg) = ((cop_bglt) arg_263), BUNSPEC);
	 return new1597_2531;
      }
   }
}



/* _make-ccast2759 */
obj_t 
_make_ccast2759_63_cgen_cop(obj_t env_3667, obj_t loc_3668, obj_t type_3669, obj_t arg_3670)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {		/* Cgen/cop.scm 51 */
	 ccast_bglt aux_5026;
	 aux_5026 =
	    make_ccast_74_cgen_cop(loc_3668,
	    (type_bglt) (type_3669),
	    (cop_bglt) (arg_3670));
	 return
	    (obj_t) (aux_5026);
      }
   }
}



/* ccast-loc-set! */
obj_t 
ccast_loc_set__38_cgen_cop(ccast_bglt obj_264, obj_t val1596_265)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((ccast_bglt) CREF(obj_264))->loc) = ((obj_t) val1596_265), BUNSPEC);
   }
}



/* _ccast-loc-set!2760 */
obj_t 
_ccast_loc_set_2760_174_cgen_cop(obj_t env_3671, obj_t obj_3672, obj_t val1596_3673)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ccast_loc_set__38_cgen_cop(
	 (ccast_bglt) (obj_3672), val1596_3673);
   }
}



/* ccast-loc */
obj_t 
ccast_loc_144_cgen_cop(ccast_bglt obj_266)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((ccast_bglt) CREF(obj_266))->loc);
   }
}



/* _ccast-loc2761 */
obj_t 
_ccast_loc2761_79_cgen_cop(obj_t env_3674, obj_t obj_3675)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ccast_loc_144_cgen_cop(
	 (ccast_bglt) (obj_3675));
   }
}



/* ccast-type */
type_bglt 
ccast_type_180_cgen_cop(ccast_bglt obj_267)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 52 */
      return
	 (((ccast_bglt) CREF(obj_267))->type);
   }
}



/* _ccast-type2762 */
obj_t 
_ccast_type2762_222_cgen_cop(obj_t env_3676, obj_t obj_3677)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 52 */
      {		/* Cgen/cop.scm 52 */
	 type_bglt aux_5038;
	 aux_5038 =
	    ccast_type_180_cgen_cop(
	    (ccast_bglt) (obj_3677));
	 return
	    (obj_t) (aux_5038);
      }
   }
}



/* ccast-arg */
cop_bglt 
ccast_arg_212_cgen_cop(ccast_bglt obj_268)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 53 */
      return
	 (((ccast_bglt) CREF(obj_268))->arg);
   }
}



/* _ccast-arg2763 */
obj_t 
_ccast_arg2763_63_cgen_cop(obj_t env_3678, obj_t obj_3679)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 53 */
      {		/* Cgen/cop.scm 53 */
	 cop_bglt aux_5043;
	 aux_5043 =
	    ccast_arg_212_cgen_cop(
	    (ccast_bglt) (obj_3679));
	 return
	    (obj_t) (aux_5043);
      }
   }
}



/* allocate-cpragma */
cpragma_bglt 
allocate_cpragma_231_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {		/* Cgen/cop.scm 47 */
	 cpragma_bglt new1580_1362;
	 new1580_1362 =
	    ((cpragma_bglt) BREF(GC_MALLOC(sizeof(struct cpragma))));
	 {	/* Cgen/cop.scm 47 */
	    long arg2325_1363;
	    arg2325_1363 =
	       class_num_218___object(cpragma_cgen_cop);
	    {	/* Cgen/cop.scm 47 */
	       obj_t obj_2538;
	       obj_2538 =
		  (obj_t) (new1580_1362);
	       (((obj_t) CREF(obj_2538))->header = MAKE_HEADER(arg2325_1363, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 47 */
	    object_bglt aux_5051;
	    aux_5051 =
	       (object_bglt) (new1580_1362);
	    OBJECT_WIDENING_SET(aux_5051, BFALSE);
	 }
	 return new1580_1362;
      }
   }
}



/* _allocate-cpragma */
obj_t 
_allocate_cpragma_102_cgen_cop(obj_t env_3315)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {		/* Cgen/cop.scm 47 */
	 cpragma_bglt aux_5054;
	 aux_5054 =
	    allocate_cpragma_231_cgen_cop();
	 return
	    (obj_t) (aux_5054);
      }
   }
}



/* cpragma? */
bool_t 
cpragma__50_cgen_cop(obj_t obj_272)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      return
	 is_a__118___object(obj_272, cpragma_cgen_cop);
   }
}



/* _cpragma? */
obj_t 
_cpragma__0_cgen_cop(obj_t env_3680, obj_t obj_3681)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {		/* Cgen/cop.scm 47 */
	 bool_t aux_5058;
	 aux_5058 =
	    cpragma__50_cgen_cop(obj_3681);
	 return
	    BBOOL(aux_5058);
      }
   }
}



/* make-cpragma */
cpragma_bglt 
make_cpragma_16_cgen_cop(obj_t loc_273, obj_t format_274, obj_t args_275)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {		/* Cgen/cop.scm 47 */
	 cpragma_bglt new1575_2540;
	 new1575_2540 =
	    ((cpragma_bglt) BREF(GC_MALLOC(sizeof(struct cpragma))));
	 {	/* Cgen/cop.scm 47 */
	    long arg2326_2541;
	    arg2326_2541 =
	       class_num_218___object(cpragma_cgen_cop);
	    {	/* Cgen/cop.scm 47 */
	       obj_t obj_2545;
	       obj_2545 =
		  (obj_t) (new1575_2540);
	       (((obj_t) CREF(obj_2545))->header = MAKE_HEADER(arg2326_2541, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 47 */
	    object_bglt aux_5065;
	    aux_5065 =
	       (object_bglt) (new1575_2540);
	    OBJECT_WIDENING_SET(aux_5065, BFALSE);
	 }
	 ((((cpragma_bglt) CREF(new1575_2540))->loc) = ((obj_t) loc_273), BUNSPEC);
	 ((((cpragma_bglt) CREF(new1575_2540))->format) = ((obj_t) format_274), BUNSPEC);
	 ((((cpragma_bglt) CREF(new1575_2540))->args) = ((obj_t) args_275), BUNSPEC);
	 return new1575_2540;
      }
   }
}



/* _make-cpragma2764 */
obj_t 
_make_cpragma2764_6_cgen_cop(obj_t env_3682, obj_t loc_3683, obj_t format_3684, obj_t args_3685)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {		/* Cgen/cop.scm 47 */
	 cpragma_bglt aux_5071;
	 aux_5071 =
	    make_cpragma_16_cgen_cop(loc_3683, format_3684, args_3685);
	 return
	    (obj_t) (aux_5071);
      }
   }
}



/* cpragma-loc-set! */
obj_t 
cpragma_loc_set__154_cgen_cop(cpragma_bglt obj_276, obj_t val1574_277)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cpragma_bglt) CREF(obj_276))->loc) = ((obj_t) val1574_277), BUNSPEC);
   }
}



/* _cpragma-loc-set!2765 */
obj_t 
_cpragma_loc_set_2765_183_cgen_cop(obj_t env_3686, obj_t obj_3687, obj_t val1574_3688)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cpragma_loc_set__154_cgen_cop(
	 (cpragma_bglt) (obj_3687), val1574_3688);
   }
}



/* cpragma-loc */
obj_t 
cpragma_loc_96_cgen_cop(cpragma_bglt obj_278)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cpragma_bglt) CREF(obj_278))->loc);
   }
}



/* _cpragma-loc2766 */
obj_t 
_cpragma_loc2766_89_cgen_cop(obj_t env_3689, obj_t obj_3690)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cpragma_loc_96_cgen_cop(
	 (cpragma_bglt) (obj_3690));
   }
}



/* cpragma-format */
obj_t 
cpragma_format_90_cgen_cop(cpragma_bglt obj_279)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 48 */
      return
	 (((cpragma_bglt) CREF(obj_279))->format);
   }
}



/* _cpragma-format2767 */
obj_t 
_cpragma_format2767_81_cgen_cop(obj_t env_3691, obj_t obj_3692)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 48 */
      return
	 cpragma_format_90_cgen_cop(
	 (cpragma_bglt) (obj_3692));
   }
}



/* cpragma-args */
obj_t 
cpragma_args_115_cgen_cop(cpragma_bglt obj_280)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 49 */
      return
	 (((cpragma_bglt) CREF(obj_280))->args);
   }
}



/* _cpragma-args2768 */
obj_t 
_cpragma_args2768_95_cgen_cop(obj_t env_3693, obj_t obj_3694)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 49 */
      return
	 cpragma_args_115_cgen_cop(
	 (cpragma_bglt) (obj_3694));
   }
}



/* allocate-varc */
varc_bglt 
allocate_varc_53_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {		/* Cgen/cop.scm 44 */
	 varc_bglt new1562_1369;
	 new1562_1369 =
	    ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
	 {	/* Cgen/cop.scm 44 */
	    long arg2327_1370;
	    arg2327_1370 =
	       class_num_218___object(varc_cgen_cop);
	    {	/* Cgen/cop.scm 44 */
	       obj_t obj_2547;
	       obj_2547 =
		  (obj_t) (new1562_1369);
	       (((obj_t) CREF(obj_2547))->header = MAKE_HEADER(arg2327_1370, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 44 */
	    object_bglt aux_5090;
	    aux_5090 =
	       (object_bglt) (new1562_1369);
	    OBJECT_WIDENING_SET(aux_5090, BFALSE);
	 }
	 return new1562_1369;
      }
   }
}



/* _allocate-varc */
obj_t 
_allocate_varc_172_cgen_cop(obj_t env_3314)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {		/* Cgen/cop.scm 44 */
	 varc_bglt aux_5093;
	 aux_5093 =
	    allocate_varc_53_cgen_cop();
	 return
	    (obj_t) (aux_5093);
      }
   }
}



/* varc? */
bool_t 
varc__41_cgen_cop(obj_t obj_284)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      return
	 is_a__118___object(obj_284, varc_cgen_cop);
   }
}



/* _varc? */
obj_t 
_varc__28_cgen_cop(obj_t env_3695, obj_t obj_3696)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {		/* Cgen/cop.scm 44 */
	 bool_t aux_5097;
	 aux_5097 =
	    varc__41_cgen_cop(obj_3696);
	 return
	    BBOOL(aux_5097);
      }
   }
}



/* make-varc */
varc_bglt 
make_varc_148_cgen_cop(obj_t loc_285, variable_bglt variable_286)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {		/* Cgen/cop.scm 44 */
	 varc_bglt new1558_2549;
	 new1558_2549 =
	    ((varc_bglt) BREF(GC_MALLOC(sizeof(struct varc))));
	 {	/* Cgen/cop.scm 44 */
	    long arg2328_2550;
	    arg2328_2550 =
	       class_num_218___object(varc_cgen_cop);
	    {	/* Cgen/cop.scm 44 */
	       obj_t obj_2553;
	       obj_2553 =
		  (obj_t) (new1558_2549);
	       (((obj_t) CREF(obj_2553))->header = MAKE_HEADER(arg2328_2550, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 44 */
	    object_bglt aux_5104;
	    aux_5104 =
	       (object_bglt) (new1558_2549);
	    OBJECT_WIDENING_SET(aux_5104, BFALSE);
	 }
	 ((((varc_bglt) CREF(new1558_2549))->loc) = ((obj_t) loc_285), BUNSPEC);
	 ((((varc_bglt) CREF(new1558_2549))->variable) = ((variable_bglt) variable_286), BUNSPEC);
	 return new1558_2549;
      }
   }
}



/* _make-varc2769 */
obj_t 
_make_varc2769_34_cgen_cop(obj_t env_3697, obj_t loc_3698, obj_t variable_3699)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {		/* Cgen/cop.scm 44 */
	 varc_bglt aux_5109;
	 aux_5109 =
	    make_varc_148_cgen_cop(loc_3698,
	    (variable_bglt) (variable_3699));
	 return
	    (obj_t) (aux_5109);
      }
   }
}



/* varc-loc-set! */
obj_t 
varc_loc_set__52_cgen_cop(varc_bglt obj_287, obj_t val1557_288)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((varc_bglt) CREF(obj_287))->loc) = ((obj_t) val1557_288), BUNSPEC);
   }
}



/* _varc-loc-set!2770 */
obj_t 
_varc_loc_set_2770_179_cgen_cop(obj_t env_3700, obj_t obj_3701, obj_t val1557_3702)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 varc_loc_set__52_cgen_cop(
	 (varc_bglt) (obj_3701), val1557_3702);
   }
}



/* varc-loc */
obj_t 
varc_loc_177_cgen_cop(varc_bglt obj_289)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((varc_bglt) CREF(obj_289))->loc);
   }
}



/* _varc-loc2771 */
obj_t 
_varc_loc2771_104_cgen_cop(obj_t env_3703, obj_t obj_3704)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 varc_loc_177_cgen_cop(
	 (varc_bglt) (obj_3704));
   }
}



/* varc-variable */
variable_bglt 
varc_variable_146_cgen_cop(varc_bglt obj_290)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 45 */
      return
	 (((varc_bglt) CREF(obj_290))->variable);
   }
}



/* _varc-variable2772 */
obj_t 
_varc_variable2772_52_cgen_cop(obj_t env_3705, obj_t obj_3706)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 45 */
      {		/* Cgen/cop.scm 45 */
	 variable_bglt aux_5120;
	 aux_5120 =
	    varc_variable_146_cgen_cop(
	    (varc_bglt) (obj_3706));
	 return
	    (obj_t) (aux_5120);
      }
   }
}



/* allocate-catom */
catom_bglt 
allocate_catom_78_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {		/* Cgen/cop.scm 41 */
	 catom_bglt new1546_1375;
	 new1546_1375 =
	    ((catom_bglt) BREF(GC_MALLOC(sizeof(struct catom))));
	 {	/* Cgen/cop.scm 41 */
	    long arg2329_1376;
	    arg2329_1376 =
	       class_num_218___object(catom_cgen_cop);
	    {	/* Cgen/cop.scm 41 */
	       obj_t obj_2555;
	       obj_2555 =
		  (obj_t) (new1546_1375);
	       (((obj_t) CREF(obj_2555))->header = MAKE_HEADER(arg2329_1376, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 41 */
	    object_bglt aux_5128;
	    aux_5128 =
	       (object_bglt) (new1546_1375);
	    OBJECT_WIDENING_SET(aux_5128, BFALSE);
	 }
	 return new1546_1375;
      }
   }
}



/* _allocate-catom */
obj_t 
_allocate_catom_138_cgen_cop(obj_t env_3313)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {		/* Cgen/cop.scm 41 */
	 catom_bglt aux_5131;
	 aux_5131 =
	    allocate_catom_78_cgen_cop();
	 return
	    (obj_t) (aux_5131);
      }
   }
}



/* catom? */
bool_t 
catom__16_cgen_cop(obj_t obj_294)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      return
	 is_a__118___object(obj_294, catom_cgen_cop);
   }
}



/* _catom? */
obj_t 
_catom__202_cgen_cop(obj_t env_3707, obj_t obj_3708)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {		/* Cgen/cop.scm 41 */
	 bool_t aux_5135;
	 aux_5135 =
	    catom__16_cgen_cop(obj_3708);
	 return
	    BBOOL(aux_5135);
      }
   }
}



/* make-catom */
catom_bglt 
make_catom_185_cgen_cop(obj_t loc_295, obj_t value_296)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {		/* Cgen/cop.scm 41 */
	 catom_bglt new1542_2557;
	 new1542_2557 =
	    ((catom_bglt) BREF(GC_MALLOC(sizeof(struct catom))));
	 {	/* Cgen/cop.scm 41 */
	    long arg2330_2558;
	    arg2330_2558 =
	       class_num_218___object(catom_cgen_cop);
	    {	/* Cgen/cop.scm 41 */
	       obj_t obj_2561;
	       obj_2561 =
		  (obj_t) (new1542_2557);
	       (((obj_t) CREF(obj_2561))->header = MAKE_HEADER(arg2330_2558, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 41 */
	    object_bglt aux_5142;
	    aux_5142 =
	       (object_bglt) (new1542_2557);
	    OBJECT_WIDENING_SET(aux_5142, BFALSE);
	 }
	 ((((catom_bglt) CREF(new1542_2557))->loc) = ((obj_t) loc_295), BUNSPEC);
	 ((((catom_bglt) CREF(new1542_2557))->value) = ((obj_t) value_296), BUNSPEC);
	 return new1542_2557;
      }
   }
}



/* _make-catom */
obj_t 
_make_catom_20_cgen_cop(obj_t env_3709, obj_t loc_3710, obj_t value_3711)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {		/* Cgen/cop.scm 41 */
	 catom_bglt aux_5147;
	 aux_5147 =
	    make_catom_185_cgen_cop(loc_3710, value_3711);
	 return
	    (obj_t) (aux_5147);
      }
   }
}



/* catom-loc-set! */
obj_t 
catom_loc_set__236_cgen_cop(catom_bglt obj_297, obj_t val1541_298)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((catom_bglt) CREF(obj_297))->loc) = ((obj_t) val1541_298), BUNSPEC);
   }
}



/* _catom-loc-set!2773 */
obj_t 
_catom_loc_set_2773_146_cgen_cop(obj_t env_3712, obj_t obj_3713, obj_t val1541_3714)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 catom_loc_set__236_cgen_cop(
	 (catom_bglt) (obj_3713), val1541_3714);
   }
}



/* catom-loc */
obj_t 
catom_loc_164_cgen_cop(catom_bglt obj_299)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((catom_bglt) CREF(obj_299))->loc);
   }
}



/* _catom-loc2774 */
obj_t 
_catom_loc2774_25_cgen_cop(obj_t env_3715, obj_t obj_3716)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 catom_loc_164_cgen_cop(
	 (catom_bglt) (obj_3716));
   }
}



/* catom-value */
obj_t 
catom_value_103_cgen_cop(catom_bglt obj_300)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 42 */
      return
	 (((catom_bglt) CREF(obj_300))->value);
   }
}



/* _catom-value2775 */
obj_t 
_catom_value2775_242_cgen_cop(obj_t env_3717, obj_t obj_3718)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 42 */
      return
	 catom_value_103_cgen_cop(
	 (catom_bglt) (obj_3718));
   }
}



/* allocate-cvoid */
cvoid_bglt 
allocate_cvoid_159_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {		/* Cgen/cop.scm 38 */
	 cvoid_bglt new1530_1381;
	 new1530_1381 =
	    ((cvoid_bglt) BREF(GC_MALLOC(sizeof(struct cvoid))));
	 {	/* Cgen/cop.scm 38 */
	    long arg2331_1382;
	    arg2331_1382 =
	       class_num_218___object(cvoid_cgen_cop);
	    {	/* Cgen/cop.scm 38 */
	       obj_t obj_2563;
	       obj_2563 =
		  (obj_t) (new1530_1381);
	       (((obj_t) CREF(obj_2563))->header = MAKE_HEADER(arg2331_1382, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 38 */
	    object_bglt aux_5163;
	    aux_5163 =
	       (object_bglt) (new1530_1381);
	    OBJECT_WIDENING_SET(aux_5163, BFALSE);
	 }
	 return new1530_1381;
      }
   }
}



/* _allocate-cvoid */
obj_t 
_allocate_cvoid_169_cgen_cop(obj_t env_3312)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {		/* Cgen/cop.scm 38 */
	 cvoid_bglt aux_5166;
	 aux_5166 =
	    allocate_cvoid_159_cgen_cop();
	 return
	    (obj_t) (aux_5166);
      }
   }
}



/* cvoid? */
bool_t 
cvoid__191_cgen_cop(obj_t obj_304)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      return
	 is_a__118___object(obj_304, cvoid_cgen_cop);
   }
}



/* _cvoid? */
obj_t 
_cvoid__92_cgen_cop(obj_t env_3719, obj_t obj_3720)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {		/* Cgen/cop.scm 38 */
	 bool_t aux_5170;
	 aux_5170 =
	    cvoid__191_cgen_cop(obj_3720);
	 return
	    BBOOL(aux_5170);
      }
   }
}



/* make-cvoid */
cvoid_bglt 
make_cvoid_194_cgen_cop(obj_t loc_305, cop_bglt value_306)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {		/* Cgen/cop.scm 38 */
	 cvoid_bglt new1526_2565;
	 new1526_2565 =
	    ((cvoid_bglt) BREF(GC_MALLOC(sizeof(struct cvoid))));
	 {	/* Cgen/cop.scm 38 */
	    long arg2332_2566;
	    arg2332_2566 =
	       class_num_218___object(cvoid_cgen_cop);
	    {	/* Cgen/cop.scm 38 */
	       obj_t obj_2569;
	       obj_2569 =
		  (obj_t) (new1526_2565);
	       (((obj_t) CREF(obj_2569))->header = MAKE_HEADER(arg2332_2566, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 38 */
	    object_bglt aux_5177;
	    aux_5177 =
	       (object_bglt) (new1526_2565);
	    OBJECT_WIDENING_SET(aux_5177, BFALSE);
	 }
	 ((((cvoid_bglt) CREF(new1526_2565))->loc) = ((obj_t) loc_305), BUNSPEC);
	 ((((cvoid_bglt) CREF(new1526_2565))->value) = ((cop_bglt) value_306), BUNSPEC);
	 return new1526_2565;
      }
   }
}



/* _make-cvoid2776 */
obj_t 
_make_cvoid2776_254_cgen_cop(obj_t env_3721, obj_t loc_3722, obj_t value_3723)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {		/* Cgen/cop.scm 38 */
	 cvoid_bglt aux_5182;
	 aux_5182 =
	    make_cvoid_194_cgen_cop(loc_3722,
	    (cop_bglt) (value_3723));
	 return
	    (obj_t) (aux_5182);
      }
   }
}



/* cvoid-loc-set! */
obj_t 
cvoid_loc_set__124_cgen_cop(cvoid_bglt obj_307, obj_t val1525_308)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cvoid_bglt) CREF(obj_307))->loc) = ((obj_t) val1525_308), BUNSPEC);
   }
}



/* _cvoid-loc-set!2777 */
obj_t 
_cvoid_loc_set_2777_42_cgen_cop(obj_t env_3724, obj_t obj_3725, obj_t val1525_3726)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cvoid_loc_set__124_cgen_cop(
	 (cvoid_bglt) (obj_3725), val1525_3726);
   }
}



/* cvoid-loc */
obj_t 
cvoid_loc_83_cgen_cop(cvoid_bglt obj_309)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cvoid_bglt) CREF(obj_309))->loc);
   }
}



/* _cvoid-loc2778 */
obj_t 
_cvoid_loc2778_160_cgen_cop(obj_t env_3727, obj_t obj_3728)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cvoid_loc_83_cgen_cop(
	 (cvoid_bglt) (obj_3728));
   }
}



/* cvoid-value */
cop_bglt 
cvoid_value_152_cgen_cop(cvoid_bglt obj_310)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 39 */
      return
	 (((cvoid_bglt) CREF(obj_310))->value);
   }
}



/* _cvoid-value2779 */
obj_t 
_cvoid_value2779_187_cgen_cop(obj_t env_3729, obj_t obj_3730)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 39 */
      {		/* Cgen/cop.scm 39 */
	 cop_bglt aux_5193;
	 aux_5193 =
	    cvoid_value_152_cgen_cop(
	    (cvoid_bglt) (obj_3730));
	 return
	    (obj_t) (aux_5193);
      }
   }
}



/* allocate-creturn */
creturn_bglt 
allocate_creturn_170_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {		/* Cgen/cop.scm 35 */
	 creturn_bglt new1514_1387;
	 new1514_1387 =
	    ((creturn_bglt) BREF(GC_MALLOC(sizeof(struct creturn))));
	 {	/* Cgen/cop.scm 35 */
	    long arg2333_1388;
	    arg2333_1388 =
	       class_num_218___object(creturn_cgen_cop);
	    {	/* Cgen/cop.scm 35 */
	       obj_t obj_2571;
	       obj_2571 =
		  (obj_t) (new1514_1387);
	       (((obj_t) CREF(obj_2571))->header = MAKE_HEADER(arg2333_1388, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 35 */
	    object_bglt aux_5201;
	    aux_5201 =
	       (object_bglt) (new1514_1387);
	    OBJECT_WIDENING_SET(aux_5201, BFALSE);
	 }
	 return new1514_1387;
      }
   }
}



/* _allocate-creturn */
obj_t 
_allocate_creturn_205_cgen_cop(obj_t env_3311)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {		/* Cgen/cop.scm 35 */
	 creturn_bglt aux_5204;
	 aux_5204 =
	    allocate_creturn_170_cgen_cop();
	 return
	    (obj_t) (aux_5204);
      }
   }
}



/* creturn? */
bool_t 
creturn__207_cgen_cop(obj_t obj_314)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      return
	 is_a__118___object(obj_314, creturn_cgen_cop);
   }
}



/* _creturn? */
obj_t 
_creturn__112_cgen_cop(obj_t env_3731, obj_t obj_3732)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {		/* Cgen/cop.scm 35 */
	 bool_t aux_5208;
	 aux_5208 =
	    creturn__207_cgen_cop(obj_3732);
	 return
	    BBOOL(aux_5208);
      }
   }
}



/* make-creturn */
creturn_bglt 
make_creturn_204_cgen_cop(obj_t loc_315, cop_bglt value_316)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {		/* Cgen/cop.scm 35 */
	 creturn_bglt new1510_2573;
	 new1510_2573 =
	    ((creturn_bglt) BREF(GC_MALLOC(sizeof(struct creturn))));
	 {	/* Cgen/cop.scm 35 */
	    long arg2334_2574;
	    arg2334_2574 =
	       class_num_218___object(creturn_cgen_cop);
	    {	/* Cgen/cop.scm 35 */
	       obj_t obj_2577;
	       obj_2577 =
		  (obj_t) (new1510_2573);
	       (((obj_t) CREF(obj_2577))->header = MAKE_HEADER(arg2334_2574, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 35 */
	    object_bglt aux_5215;
	    aux_5215 =
	       (object_bglt) (new1510_2573);
	    OBJECT_WIDENING_SET(aux_5215, BFALSE);
	 }
	 ((((creturn_bglt) CREF(new1510_2573))->loc) = ((obj_t) loc_315), BUNSPEC);
	 ((((creturn_bglt) CREF(new1510_2573))->value) = ((cop_bglt) value_316), BUNSPEC);
	 return new1510_2573;
      }
   }
}



/* _make-creturn2780 */
obj_t 
_make_creturn2780_6_cgen_cop(obj_t env_3733, obj_t loc_3734, obj_t value_3735)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {		/* Cgen/cop.scm 35 */
	 creturn_bglt aux_5220;
	 aux_5220 =
	    make_creturn_204_cgen_cop(loc_3734,
	    (cop_bglt) (value_3735));
	 return
	    (obj_t) (aux_5220);
      }
   }
}



/* creturn-loc-set! */
obj_t 
creturn_loc_set__24_cgen_cop(creturn_bglt obj_317, obj_t val1509_318)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((creturn_bglt) CREF(obj_317))->loc) = ((obj_t) val1509_318), BUNSPEC);
   }
}



/* _creturn-loc-set!2781 */
obj_t 
_creturn_loc_set_2781_243_cgen_cop(obj_t env_3736, obj_t obj_3737, obj_t val1509_3738)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 creturn_loc_set__24_cgen_cop(
	 (creturn_bglt) (obj_3737), val1509_3738);
   }
}



/* creturn-loc */
obj_t 
creturn_loc_120_cgen_cop(creturn_bglt obj_319)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((creturn_bglt) CREF(obj_319))->loc);
   }
}



/* _creturn-loc2782 */
obj_t 
_creturn_loc2782_164_cgen_cop(obj_t env_3739, obj_t obj_3740)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 creturn_loc_120_cgen_cop(
	 (creturn_bglt) (obj_3740));
   }
}



/* creturn-value */
cop_bglt 
creturn_value_251_cgen_cop(creturn_bglt obj_320)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 36 */
      return
	 (((creturn_bglt) CREF(obj_320))->value);
   }
}



/* _creturn-value2783 */
obj_t 
_creturn_value2783_240_cgen_cop(obj_t env_3741, obj_t obj_3742)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 36 */
      {		/* Cgen/cop.scm 36 */
	 cop_bglt aux_5231;
	 aux_5231 =
	    creturn_value_251_cgen_cop(
	    (creturn_bglt) (obj_3742));
	 return
	    (obj_t) (aux_5231);
      }
   }
}



/* allocate-block */
block_bglt 
allocate_block_20_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {		/* Cgen/cop.scm 32 */
	 block_bglt new1498_1393;
	 new1498_1393 =
	    ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
	 {	/* Cgen/cop.scm 32 */
	    long arg2335_1394;
	    arg2335_1394 =
	       class_num_218___object(block_cgen_cop);
	    {	/* Cgen/cop.scm 32 */
	       obj_t obj_2579;
	       obj_2579 =
		  (obj_t) (new1498_1393);
	       (((obj_t) CREF(obj_2579))->header = MAKE_HEADER(arg2335_1394, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 32 */
	    object_bglt aux_5239;
	    aux_5239 =
	       (object_bglt) (new1498_1393);
	    OBJECT_WIDENING_SET(aux_5239, BFALSE);
	 }
	 return new1498_1393;
      }
   }
}



/* _allocate-block */
obj_t 
_allocate_block_150_cgen_cop(obj_t env_3310)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {		/* Cgen/cop.scm 32 */
	 block_bglt aux_5242;
	 aux_5242 =
	    allocate_block_20_cgen_cop();
	 return
	    (obj_t) (aux_5242);
      }
   }
}



/* block? */
bool_t 
block__82_cgen_cop(obj_t obj_324)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      return
	 is_a__118___object(obj_324, block_cgen_cop);
   }
}



/* _block? */
obj_t 
_block__12_cgen_cop(obj_t env_3743, obj_t obj_3744)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {		/* Cgen/cop.scm 32 */
	 bool_t aux_5246;
	 aux_5246 =
	    block__82_cgen_cop(obj_3744);
	 return
	    BBOOL(aux_5246);
      }
   }
}



/* make-block */
block_bglt 
make_block_156_cgen_cop(obj_t loc_325, cop_bglt body_326)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {		/* Cgen/cop.scm 32 */
	 block_bglt new1494_2581;
	 new1494_2581 =
	    ((block_bglt) BREF(GC_MALLOC(sizeof(struct block))));
	 {	/* Cgen/cop.scm 32 */
	    long arg2336_2582;
	    arg2336_2582 =
	       class_num_218___object(block_cgen_cop);
	    {	/* Cgen/cop.scm 32 */
	       obj_t obj_2585;
	       obj_2585 =
		  (obj_t) (new1494_2581);
	       (((obj_t) CREF(obj_2585))->header = MAKE_HEADER(arg2336_2582, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 32 */
	    object_bglt aux_5253;
	    aux_5253 =
	       (object_bglt) (new1494_2581);
	    OBJECT_WIDENING_SET(aux_5253, BFALSE);
	 }
	 ((((block_bglt) CREF(new1494_2581))->loc) = ((obj_t) loc_325), BUNSPEC);
	 ((((block_bglt) CREF(new1494_2581))->body) = ((cop_bglt) body_326), BUNSPEC);
	 return new1494_2581;
      }
   }
}



/* _make-block2784 */
obj_t 
_make_block2784_82_cgen_cop(obj_t env_3745, obj_t loc_3746, obj_t body_3747)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {		/* Cgen/cop.scm 32 */
	 block_bglt aux_5258;
	 aux_5258 =
	    make_block_156_cgen_cop(loc_3746,
	    (cop_bglt) (body_3747));
	 return
	    (obj_t) (aux_5258);
      }
   }
}



/* block-loc-set! */
obj_t 
block_loc_set__28_cgen_cop(block_bglt obj_327, obj_t val1493_328)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((block_bglt) CREF(obj_327))->loc) = ((obj_t) val1493_328), BUNSPEC);
   }
}



/* _block-loc-set!2785 */
obj_t 
_block_loc_set_2785_74_cgen_cop(obj_t env_3748, obj_t obj_3749, obj_t val1493_3750)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 block_loc_set__28_cgen_cop(
	 (block_bglt) (obj_3749), val1493_3750);
   }
}



/* block-loc */
obj_t 
block_loc_240_cgen_cop(block_bglt obj_329)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((block_bglt) CREF(obj_329))->loc);
   }
}



/* _block-loc2786 */
obj_t 
_block_loc2786_224_cgen_cop(obj_t env_3751, obj_t obj_3752)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 block_loc_240_cgen_cop(
	 (block_bglt) (obj_3752));
   }
}



/* block-body */
cop_bglt 
block_body_21_cgen_cop(block_bglt obj_330)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 33 */
      return
	 (((block_bglt) CREF(obj_330))->body);
   }
}



/* _block-body2787 */
obj_t 
_block_body2787_79_cgen_cop(obj_t env_3753, obj_t obj_3754)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 33 */
      {		/* Cgen/cop.scm 33 */
	 cop_bglt aux_5269;
	 aux_5269 =
	    block_body_21_cgen_cop(
	    (block_bglt) (obj_3754));
	 return
	    (obj_t) (aux_5269);
      }
   }
}



/* allocate-cgoto */
cgoto_bglt 
allocate_cgoto_58_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {		/* Cgen/cop.scm 29 */
	 cgoto_bglt new1481_1399;
	 new1481_1399 =
	    ((cgoto_bglt) BREF(GC_MALLOC(sizeof(struct cgoto))));
	 {	/* Cgen/cop.scm 29 */
	    long arg2337_1400;
	    arg2337_1400 =
	       class_num_218___object(cgoto_cgen_cop);
	    {	/* Cgen/cop.scm 29 */
	       obj_t obj_2587;
	       obj_2587 =
		  (obj_t) (new1481_1399);
	       (((obj_t) CREF(obj_2587))->header = MAKE_HEADER(arg2337_1400, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 29 */
	    object_bglt aux_5277;
	    aux_5277 =
	       (object_bglt) (new1481_1399);
	    OBJECT_WIDENING_SET(aux_5277, BFALSE);
	 }
	 return new1481_1399;
      }
   }
}



/* _allocate-cgoto */
obj_t 
_allocate_cgoto_159_cgen_cop(obj_t env_3309)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {		/* Cgen/cop.scm 29 */
	 cgoto_bglt aux_5280;
	 aux_5280 =
	    allocate_cgoto_58_cgen_cop();
	 return
	    (obj_t) (aux_5280);
      }
   }
}



/* cgoto? */
bool_t 
cgoto__160_cgen_cop(obj_t obj_334)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      return
	 is_a__118___object(obj_334, cgoto_cgen_cop);
   }
}



/* _cgoto? */
obj_t 
_cgoto__255_cgen_cop(obj_t env_3755, obj_t obj_3756)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {		/* Cgen/cop.scm 29 */
	 bool_t aux_5284;
	 aux_5284 =
	    cgoto__160_cgen_cop(obj_3756);
	 return
	    BBOOL(aux_5284);
      }
   }
}



/* make-cgoto */
cgoto_bglt 
make_cgoto_92_cgen_cop(obj_t loc_335, clabel_bglt label_336)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {		/* Cgen/cop.scm 29 */
	 cgoto_bglt new1477_2589;
	 new1477_2589 =
	    ((cgoto_bglt) BREF(GC_MALLOC(sizeof(struct cgoto))));
	 {	/* Cgen/cop.scm 29 */
	    long arg2338_2590;
	    arg2338_2590 =
	       class_num_218___object(cgoto_cgen_cop);
	    {	/* Cgen/cop.scm 29 */
	       obj_t obj_2593;
	       obj_2593 =
		  (obj_t) (new1477_2589);
	       (((obj_t) CREF(obj_2593))->header = MAKE_HEADER(arg2338_2590, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 29 */
	    object_bglt aux_5291;
	    aux_5291 =
	       (object_bglt) (new1477_2589);
	    OBJECT_WIDENING_SET(aux_5291, BFALSE);
	 }
	 ((((cgoto_bglt) CREF(new1477_2589))->loc) = ((obj_t) loc_335), BUNSPEC);
	 ((((cgoto_bglt) CREF(new1477_2589))->label) = ((clabel_bglt) label_336), BUNSPEC);
	 return new1477_2589;
      }
   }
}



/* _make-cgoto2788 */
obj_t 
_make_cgoto2788_157_cgen_cop(obj_t env_3757, obj_t loc_3758, obj_t label_3759)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {		/* Cgen/cop.scm 29 */
	 cgoto_bglt aux_5296;
	 aux_5296 =
	    make_cgoto_92_cgen_cop(loc_3758,
	    (clabel_bglt) (label_3759));
	 return
	    (obj_t) (aux_5296);
      }
   }
}



/* cgoto-loc-set! */
obj_t 
cgoto_loc_set__54_cgen_cop(cgoto_bglt obj_337, obj_t val1476_338)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cgoto_bglt) CREF(obj_337))->loc) = ((obj_t) val1476_338), BUNSPEC);
   }
}



/* _cgoto-loc-set!2789 */
obj_t 
_cgoto_loc_set_2789_63_cgen_cop(obj_t env_3760, obj_t obj_3761, obj_t val1476_3762)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cgoto_loc_set__54_cgen_cop(
	 (cgoto_bglt) (obj_3761), val1476_3762);
   }
}



/* cgoto-loc */
obj_t 
cgoto_loc_231_cgen_cop(cgoto_bglt obj_339)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cgoto_bglt) CREF(obj_339))->loc);
   }
}



/* _cgoto-loc2790 */
obj_t 
_cgoto_loc2790_57_cgen_cop(obj_t env_3763, obj_t obj_3764)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cgoto_loc_231_cgen_cop(
	 (cgoto_bglt) (obj_3764));
   }
}



/* cgoto-label */
clabel_bglt 
cgoto_label_241_cgen_cop(cgoto_bglt obj_340)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 30 */
      return
	 (((cgoto_bglt) CREF(obj_340))->label);
   }
}



/* _cgoto-label2791 */
obj_t 
_cgoto_label2791_242_cgen_cop(obj_t env_3765, obj_t obj_3766)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 30 */
      {		/* Cgen/cop.scm 30 */
	 clabel_bglt aux_5307;
	 aux_5307 =
	    cgoto_label_241_cgen_cop(
	    (cgoto_bglt) (obj_3766));
	 return
	    (obj_t) (aux_5307);
      }
   }
}



/* allocate-clabel */
clabel_bglt 
allocate_clabel_48_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {		/* Cgen/cop.scm 24 */
	 clabel_bglt new1457_1405;
	 new1457_1405 =
	    ((clabel_bglt) BREF(GC_MALLOC(sizeof(struct clabel))));
	 {	/* Cgen/cop.scm 24 */
	    long arg2339_1406;
	    arg2339_1406 =
	       class_num_218___object(clabel_cgen_cop);
	    {	/* Cgen/cop.scm 24 */
	       obj_t obj_2595;
	       obj_2595 =
		  (obj_t) (new1457_1405);
	       (((obj_t) CREF(obj_2595))->header = MAKE_HEADER(arg2339_1406, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 24 */
	    object_bglt aux_5315;
	    aux_5315 =
	       (object_bglt) (new1457_1405);
	    OBJECT_WIDENING_SET(aux_5315, BFALSE);
	 }
	 return new1457_1405;
      }
   }
}



/* _allocate-clabel */
obj_t 
_allocate_clabel_4_cgen_cop(obj_t env_3308)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {		/* Cgen/cop.scm 24 */
	 clabel_bglt aux_5318;
	 aux_5318 =
	    allocate_clabel_48_cgen_cop();
	 return
	    (obj_t) (aux_5318);
      }
   }
}



/* clabel? */
bool_t 
clabel__247_cgen_cop(obj_t obj_344)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      return
	 is_a__118___object(obj_344, clabel_cgen_cop);
   }
}



/* _clabel? */
obj_t 
_clabel__209_cgen_cop(obj_t env_3767, obj_t obj_3768)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {		/* Cgen/cop.scm 24 */
	 bool_t aux_5322;
	 aux_5322 =
	    clabel__247_cgen_cop(obj_3768);
	 return
	    BBOOL(aux_5322);
      }
   }
}



/* make-clabel */
clabel_bglt 
make_clabel_15_cgen_cop(obj_t loc_345, obj_t name_346, bool_t used__226_347, obj_t body_348)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {		/* Cgen/cop.scm 24 */
	 clabel_bglt new1451_2597;
	 new1451_2597 =
	    ((clabel_bglt) BREF(GC_MALLOC(sizeof(struct clabel))));
	 {	/* Cgen/cop.scm 24 */
	    long arg2340_2598;
	    arg2340_2598 =
	       class_num_218___object(clabel_cgen_cop);
	    {	/* Cgen/cop.scm 24 */
	       obj_t obj_2603;
	       obj_2603 =
		  (obj_t) (new1451_2597);
	       (((obj_t) CREF(obj_2603))->header = MAKE_HEADER(arg2340_2598, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 24 */
	    object_bglt aux_5329;
	    aux_5329 =
	       (object_bglt) (new1451_2597);
	    OBJECT_WIDENING_SET(aux_5329, BFALSE);
	 }
	 ((((clabel_bglt) CREF(new1451_2597))->loc) = ((obj_t) loc_345), BUNSPEC);
	 ((((clabel_bglt) CREF(new1451_2597))->name) = ((obj_t) name_346), BUNSPEC);
	 ((((clabel_bglt) CREF(new1451_2597))->used__226) = ((bool_t) used__226_347), BUNSPEC);
	 ((((clabel_bglt) CREF(new1451_2597))->body) = ((obj_t) body_348), BUNSPEC);
	 return new1451_2597;
      }
   }
}



/* _make-clabel2792 */
obj_t 
_make_clabel2792_242_cgen_cop(obj_t env_3769, obj_t loc_3770, obj_t name_3771, obj_t used__226_3772, obj_t body_3773)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {		/* Cgen/cop.scm 24 */
	 clabel_bglt aux_5336;
	 aux_5336 =
	    make_clabel_15_cgen_cop(loc_3770, name_3771,
	    CBOOL(used__226_3772), body_3773);
	 return
	    (obj_t) (aux_5336);
      }
   }
}



/* clabel-loc-set! */
obj_t 
clabel_loc_set__72_cgen_cop(clabel_bglt obj_349, obj_t val1448_350)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((clabel_bglt) CREF(obj_349))->loc) = ((obj_t) val1448_350), BUNSPEC);
   }
}



/* _clabel-loc-set!2793 */
obj_t 
_clabel_loc_set_2793_140_cgen_cop(obj_t env_3774, obj_t obj_3775, obj_t val1448_3776)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 clabel_loc_set__72_cgen_cop(
	 (clabel_bglt) (obj_3775), val1448_3776);
   }
}



/* clabel-loc */
obj_t 
clabel_loc_12_cgen_cop(clabel_bglt obj_351)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((clabel_bglt) CREF(obj_351))->loc);
   }
}



/* _clabel-loc2794 */
obj_t 
_clabel_loc2794_244_cgen_cop(obj_t env_3777, obj_t obj_3778)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 clabel_loc_12_cgen_cop(
	 (clabel_bglt) (obj_3778));
   }
}



/* clabel-name */
obj_t 
clabel_name_59_cgen_cop(clabel_bglt obj_352)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 25 */
      return
	 (((clabel_bglt) CREF(obj_352))->name);
   }
}



/* _clabel-name2795 */
obj_t 
_clabel_name2795_220_cgen_cop(obj_t env_3779, obj_t obj_3780)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 25 */
      return
	 clabel_name_59_cgen_cop(
	 (clabel_bglt) (obj_3780));
   }
}



/* clabel-used?-set! */
obj_t 
clabel_used__set__46_cgen_cop(clabel_bglt obj_353, bool_t val1449_354)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 26 */
      return
	 ((((clabel_bglt) CREF(obj_353))->used__226) = ((bool_t) val1449_354), BUNSPEC);
   }
}



/* _clabel-used?-set!2796 */
obj_t 
_clabel_used__set_2796_69_cgen_cop(obj_t env_3781, obj_t obj_3782, obj_t val1449_3783)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 26 */
      return
	 clabel_used__set__46_cgen_cop(
	 (clabel_bglt) (obj_3782),
	 CBOOL(val1449_3783));
   }
}



/* clabel-used? */
bool_t 
clabel_used__102_cgen_cop(clabel_bglt obj_355)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 26 */
      return
	 (((clabel_bglt) CREF(obj_355))->used__226);
   }
}



/* _clabel-used?2797 */
obj_t 
_clabel_used_2797_160_cgen_cop(obj_t env_3784, obj_t obj_3785)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 26 */
      {		/* Cgen/cop.scm 26 */
	 bool_t aux_5354;
	 aux_5354 =
	    clabel_used__102_cgen_cop(
	    (clabel_bglt) (obj_3785));
	 return
	    BBOOL(aux_5354);
      }
   }
}



/* clabel-body-set! */
obj_t 
clabel_body_set__90_cgen_cop(clabel_bglt obj_356, obj_t val1450_357)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 27 */
      return
	 ((((clabel_bglt) CREF(obj_356))->body) = ((obj_t) val1450_357), BUNSPEC);
   }
}



/* _clabel-body-set!2798 */
obj_t 
_clabel_body_set_2798_179_cgen_cop(obj_t env_3786, obj_t obj_3787, obj_t val1450_3788)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 27 */
      return
	 clabel_body_set__90_cgen_cop(
	 (clabel_bglt) (obj_3787), val1450_3788);
   }
}



/* clabel-body */
obj_t 
clabel_body_114_cgen_cop(clabel_bglt obj_358)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 27 */
      return
	 (((clabel_bglt) CREF(obj_358))->body);
   }
}



/* _clabel-body2799 */
obj_t 
_clabel_body2799_64_cgen_cop(obj_t env_3789, obj_t obj_3790)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 27 */
      return
	 clabel_body_114_cgen_cop(
	 (clabel_bglt) (obj_3790));
   }
}



/* allocate-cop */
cop_bglt 
allocate_cop_141_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {		/* Cgen/cop.scm 20 */
	 cop_bglt new1441_1413;
	 new1441_1413 =
	    ((cop_bglt) BREF(GC_MALLOC(sizeof(struct cop))));
	 {	/* Cgen/cop.scm 20 */
	    long arg2341_1414;
	    arg2341_1414 =
	       class_num_218___object(cop_cgen_cop);
	    {	/* Cgen/cop.scm 20 */
	       obj_t obj_2605;
	       obj_2605 =
		  (obj_t) (new1441_1413);
	       (((obj_t) CREF(obj_2605))->header = MAKE_HEADER(arg2341_1414, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 20 */
	    object_bglt aux_5368;
	    aux_5368 =
	       (object_bglt) (new1441_1413);
	    OBJECT_WIDENING_SET(aux_5368, BFALSE);
	 }
	 return new1441_1413;
      }
   }
}



/* _allocate-cop */
obj_t 
_allocate_cop_129_cgen_cop(obj_t env_3307)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {		/* Cgen/cop.scm 20 */
	 cop_bglt aux_5371;
	 aux_5371 =
	    allocate_cop_141_cgen_cop();
	 return
	    (obj_t) (aux_5371);
      }
   }
}



/* cop? */
bool_t 
cop__160_cgen_cop(obj_t obj_362)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      return
	 is_a__118___object(obj_362, cop_cgen_cop);
   }
}



/* _cop? */
obj_t 
_cop__234_cgen_cop(obj_t env_3791, obj_t obj_3792)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {		/* Cgen/cop.scm 20 */
	 bool_t aux_5375;
	 aux_5375 =
	    cop__160_cgen_cop(obj_3792);
	 return
	    BBOOL(aux_5375);
      }
   }
}



/* make-cop */
cop_bglt 
make_cop_70_cgen_cop(obj_t loc_363)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {		/* Cgen/cop.scm 20 */
	 cop_bglt new1438_2607;
	 new1438_2607 =
	    ((cop_bglt) BREF(GC_MALLOC(sizeof(struct cop))));
	 {	/* Cgen/cop.scm 20 */
	    long arg2342_2608;
	    arg2342_2608 =
	       class_num_218___object(cop_cgen_cop);
	    {	/* Cgen/cop.scm 20 */
	       obj_t obj_2610;
	       obj_2610 =
		  (obj_t) (new1438_2607);
	       (((obj_t) CREF(obj_2610))->header = MAKE_HEADER(arg2342_2608, 0), BUNSPEC);
	    }
	 }
	 {	/* Cgen/cop.scm 20 */
	    object_bglt aux_5382;
	    aux_5382 =
	       (object_bglt) (new1438_2607);
	    OBJECT_WIDENING_SET(aux_5382, BFALSE);
	 }
	 ((((cop_bglt) CREF(new1438_2607))->loc) = ((obj_t) loc_363), BUNSPEC);
	 return new1438_2607;
      }
   }
}



/* _make-cop */
obj_t 
_make_cop_194_cgen_cop(obj_t env_3793, obj_t loc_3794)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {		/* Cgen/cop.scm 20 */
	 cop_bglt aux_5386;
	 aux_5386 =
	    make_cop_70_cgen_cop(loc_3794);
	 return
	    (obj_t) (aux_5386);
      }
   }
}



/* cop-loc-set! */
obj_t 
cop_loc_set__54_cgen_cop(cop_bglt obj_364, obj_t val1437_365)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 ((((cop_bglt) CREF(obj_364))->loc) = ((obj_t) val1437_365), BUNSPEC);
   }
}



/* _cop-loc-set!2800 */
obj_t 
_cop_loc_set_2800_164_cgen_cop(obj_t env_3795, obj_t obj_3796, obj_t val1437_3797)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cop_loc_set__54_cgen_cop(
	 (cop_bglt) (obj_3796), val1437_3797);
   }
}



/* cop-loc */
obj_t 
cop_loc_231_cgen_cop(cop_bglt obj_366)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 (((cop_bglt) CREF(obj_366))->loc);
   }
}



/* _cop-loc2801 */
obj_t 
_cop_loc2801_253_cgen_cop(obj_t env_3798, obj_t obj_3799)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 22 */
      return
	 cop_loc_231_cgen_cop(
	 (cop_bglt) (obj_3799));
   }
}



/* method-init */
obj_t 
method_init_76_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 14 */
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_bdb_block2016_247_3860;
	 object__struct_bdb_block2016_247_3860 = proc2805_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, bdb_block_21_cgen_cop, object__struct_bdb_block2016_247_3860);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_bdb_block2018_62_3859;
	 struct_object__object_bdb_block2018_62_3859 = proc2806_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, bdb_block_21_cgen_cop, struct_object__object_bdb_block2018_62_3859);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_sfun_c2020_144_3856;
	 object__struct_sfun_c2020_144_3856 = proc2807_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, sfun_c_188_cgen_cop, object__struct_sfun_c2020_144_3856);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_sfun_c2022_82_3852;
	 struct_object__object_sfun_c2022_82_3852 = proc2808_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, sfun_c_188_cgen_cop, struct_object__object_sfun_c2022_82_3852);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cjump_ex_it2024_207_3851;
	 object__struct_cjump_ex_it2024_207_3851 = proc2809_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cjump_ex_it_131_cgen_cop, object__struct_cjump_ex_it2024_207_3851);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cjump_ex_it2026_24_3850;
	 struct_object__object_cjump_ex_it2026_24_3850 = proc2810_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cjump_ex_it_131_cgen_cop, struct_object__object_cjump_ex_it2026_24_3850);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cset_ex_it2028_156_3849;
	 object__struct_cset_ex_it2028_156_3849 = proc2811_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cset_ex_it_123_cgen_cop, object__struct_cset_ex_it2028_156_3849);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cset_ex_it2030_206_3848;
	 struct_object__object_cset_ex_it2030_206_3848 = proc2812_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cset_ex_it_123_cgen_cop, struct_object__object_cset_ex_it2030_206_3848);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cbox_set_2032_23_3847;
	 object__struct_cbox_set_2032_23_3847 = proc2813_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cbox_set__132_cgen_cop, object__struct_cbox_set_2032_23_3847);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cbox_set_2034_241_3846;
	 struct_object__object_cbox_set_2034_241_3846 = proc2814_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cbox_set__132_cgen_cop, struct_object__object_cbox_set_2034_241_3846);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cbox_ref2036_107_3845;
	 object__struct_cbox_ref2036_107_3845 = proc2815_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cbox_ref_44_cgen_cop, object__struct_cbox_ref2036_107_3845);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cbox_ref2038_171_3844;
	 struct_object__object_cbox_ref2038_171_3844 = proc2816_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cbox_ref_44_cgen_cop, struct_object__object_cbox_ref2038_171_3844);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cmake_box2040_139_3843;
	 object__struct_cmake_box2040_139_3843 = proc2817_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cmake_box_177_cgen_cop, object__struct_cmake_box2040_139_3843);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cmake_box2042_109_3842;
	 struct_object__object_cmake_box2042_109_3842 = proc2818_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cmake_box_177_cgen_cop, struct_object__object_cmake_box2042_109_3842);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cswitch2044_70_3841;
	 object__struct_cswitch2044_70_3841 = proc2819_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cswitch_cgen_cop, object__struct_cswitch2044_70_3841);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cswitch2046_213_3840;
	 struct_object__object_cswitch2046_213_3840 = proc2820_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cswitch_cgen_cop, struct_object__object_cswitch2046_213_3840);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cfail2048_158_3839;
	 object__struct_cfail2048_158_3839 = proc2821_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cfail_cgen_cop, object__struct_cfail2048_158_3839);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cfail2050_83_3838;
	 struct_object__object_cfail2050_83_3838 = proc2822_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cfail_cgen_cop, struct_object__object_cfail2050_83_3838);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_capp2052_146_3837;
	 object__struct_capp2052_146_3837 = proc2823_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, capp_cgen_cop, object__struct_capp2052_146_3837);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_capp2054_65_3836;
	 struct_object__object_capp2054_65_3836 = proc2824_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, capp_cgen_cop, struct_object__object_capp2054_65_3836);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_capply2056_93_3835;
	 object__struct_capply2056_93_3835 = proc2825_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, capply_cgen_cop, object__struct_capply2056_93_3835);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_capply2058_20_3834;
	 struct_object__object_capply2058_20_3834 = proc2826_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, capply_cgen_cop, struct_object__object_capply2058_20_3834);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cfuncall2060_199_3833;
	 object__struct_cfuncall2060_199_3833 = proc2827_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cfuncall_cgen_cop, object__struct_cfuncall2060_199_3833);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cfuncall2062_66_3832;
	 struct_object__object_cfuncall2062_66_3832 = proc2828_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cfuncall_cgen_cop, struct_object__object_cfuncall2062_66_3832);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_local_var2064_249_3831;
	 object__struct_local_var2064_249_3831 = proc2829_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, local_var_164_cgen_cop, object__struct_local_var2064_249_3831);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_local_var2066_83_3830;
	 struct_object__object_local_var2066_83_3830 = proc2830_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, local_var_164_cgen_cop, struct_object__object_local_var2066_83_3830);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cif2068_57_3829;
	 object__struct_cif2068_57_3829 = proc2831_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cif_cgen_cop, object__struct_cif2068_57_3829);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cif2070_34_3828;
	 struct_object__object_cif2070_34_3828 = proc2832_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cif_cgen_cop, struct_object__object_cif2070_34_3828);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_csetq2072_83_3827;
	 object__struct_csetq2072_83_3827 = proc2833_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, csetq_cgen_cop, object__struct_csetq2072_83_3827);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_csetq2074_47_3826;
	 struct_object__object_csetq2074_47_3826 = proc2834_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, csetq_cgen_cop, struct_object__object_csetq2074_47_3826);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_stop2076_25_3825;
	 object__struct_stop2076_25_3825 = proc2835_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, stop_cgen_cop, object__struct_stop2076_25_3825);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_stop2078_236_3824;
	 struct_object__object_stop2078_236_3824 = proc2836_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, stop_cgen_cop, struct_object__object_stop2078_236_3824);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_nop2080_60_3823;
	 object__struct_nop2080_60_3823 = proc2837_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, nop_cgen_cop, object__struct_nop2080_60_3823);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_nop2082_201_3822;
	 struct_object__object_nop2082_201_3822 = proc2838_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, nop_cgen_cop, struct_object__object_nop2082_201_3822);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_csequence2084_122_3821;
	 object__struct_csequence2084_122_3821 = proc2839_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, csequence_cgen_cop, object__struct_csequence2084_122_3821);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_csequence2086_115_3820;
	 struct_object__object_csequence2086_115_3820 = proc2840_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, csequence_cgen_cop, struct_object__object_csequence2086_115_3820);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_ccast2088_11_3819;
	 object__struct_ccast2088_11_3819 = proc2841_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, ccast_cgen_cop, object__struct_ccast2088_11_3819);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_ccast2090_43_3818;
	 struct_object__object_ccast2090_43_3818 = proc2842_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, ccast_cgen_cop, struct_object__object_ccast2090_43_3818);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cpragma2092_215_3817;
	 object__struct_cpragma2092_215_3817 = proc2843_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cpragma_cgen_cop, object__struct_cpragma2092_215_3817);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cpragma2094_86_3816;
	 struct_object__object_cpragma2094_86_3816 = proc2844_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cpragma_cgen_cop, struct_object__object_cpragma2094_86_3816);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_varc2096_185_3815;
	 object__struct_varc2096_185_3815 = proc2845_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, varc_cgen_cop, object__struct_varc2096_185_3815);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_varc2098_186_3814;
	 struct_object__object_varc2098_186_3814 = proc2846_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, varc_cgen_cop, struct_object__object_varc2098_186_3814);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_catom2100_63_3813;
	 object__struct_catom2100_63_3813 = proc2847_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, catom_cgen_cop, object__struct_catom2100_63_3813);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_catom2102_83_3812;
	 struct_object__object_catom2102_83_3812 = proc2848_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, catom_cgen_cop, struct_object__object_catom2102_83_3812);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cvoid2104_241_3811;
	 object__struct_cvoid2104_241_3811 = proc2849_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cvoid_cgen_cop, object__struct_cvoid2104_241_3811);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cvoid2106_78_3810;
	 struct_object__object_cvoid2106_78_3810 = proc2850_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cvoid_cgen_cop, struct_object__object_cvoid2106_78_3810);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_creturn2108_68_3809;
	 object__struct_creturn2108_68_3809 = proc2851_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, creturn_cgen_cop, object__struct_creturn2108_68_3809);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_creturn2110_254_3808;
	 struct_object__object_creturn2110_254_3808 = proc2852_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, creturn_cgen_cop, struct_object__object_creturn2110_254_3808);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_block2112_230_3807;
	 object__struct_block2112_230_3807 = proc2853_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, block_cgen_cop, object__struct_block2112_230_3807);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_block2114_163_3806;
	 struct_object__object_block2114_163_3806 = proc2854_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, block_cgen_cop, struct_object__object_block2114_163_3806);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cgoto2116_4_3805;
	 object__struct_cgoto2116_4_3805 = proc2855_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cgoto_cgen_cop, object__struct_cgoto2116_4_3805);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cgoto2118_221_3804;
	 struct_object__object_cgoto2118_221_3804 = proc2856_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, cgoto_cgen_cop, struct_object__object_cgoto2118_221_3804);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_clabel2120_136_3803;
	 object__struct_clabel2120_136_3803 = proc2857_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, clabel_cgen_cop, object__struct_clabel2120_136_3803);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_clabel2122_160_3802;
	 struct_object__object_clabel2122_160_3802 = proc2858_cgen_cop;
	 add_method__1___object(struct_object__object_env_209___object, clabel_cgen_cop, struct_object__object_clabel2122_160_3802);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t object__struct_cop2124_240_3801;
	 object__struct_cop2124_240_3801 = proc2859_cgen_cop;
	 add_method__1___object(object__struct_env_210___object, cop_cgen_cop, object__struct_cop2124_240_3801);
      }
      {		/* Cgen/cop.scm 14 */
	 obj_t struct_object__object_cop2126_239_3800;
	 struct_object__object_cop2126_239_3800 = proc2860_cgen_cop;
	 return
	    add_method__1___object(struct_object__object_env_209___object, cop_cgen_cop, struct_object__object_cop2126_239_3800);
      }
   }
}



/* struct+object->object-cop2126 */
obj_t 
struct_object__object_cop2126_239_cgen_cop(obj_t env_3861, obj_t o_3862, obj_t s_3863)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {
	 cop_bglt o_2325;
	 obj_t s_2326;
	 {	/* Cgen/cop.scm 20 */
	    cop_bglt aux_5451;
	    o_2325 =
	       (cop_bglt) (o_3862);
	    s_2326 = s_3863;
	    {	/* Cgen/cop.scm 20 */
	       obj_t aux_5454;
	       object_bglt aux_5452;
	       aux_5454 =
		  STRUCT_REF(s_2326, ((long) 0));
	       aux_5452 =
		  (object_bglt) (o_2325);
	       OBJECT_WIDENING_SET(aux_5452, aux_5454);
	    }
	    {	/* Cgen/cop.scm 20 */
	       obj_t v1446_2330;
	       v1446_2330 =
		  STRUCT_REF(s_2326, ((long) 1));
	       ((((cop_bglt) CREF(o_2325))->loc) = ((obj_t) v1446_2330), BUNSPEC);
	    }
	    aux_5451 = o_2325;
	    return
	       (obj_t) (aux_5451);
	 }
      }
   }
}



/* object->struct-cop2124 */
obj_t 
object__struct_cop2124_240_cgen_cop(obj_t env_3864, obj_t obj1442_3865)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 20 */
      {
	 cop_bglt obj1442_2317;
	 obj1442_2317 =
	    (cop_bglt) (obj1442_3865);
	 {	/* Cgen/cop.scm 20 */
	    obj_t res1443_2320;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5461;
	       aux_5461 =
		  CNST_TABLE_REF(((long) 0));
	       res1443_2320 =
		  make_struct(aux_5461, ((long) 2), BUNSPEC);
	    }
	    STRUCT_SET(res1443_2320, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5465;
	       aux_5465 =
		  (((cop_bglt) CREF(obj1442_2317))->loc);
	       STRUCT_SET(res1443_2320, ((long) 1), aux_5465);
	    }
	    return res1443_2320;
	 }
      }
   }
}



/* struct+object->object-clabel2122 */
obj_t 
struct_object__object_clabel2122_160_cgen_cop(obj_t env_3866, obj_t o_3867, obj_t s_3868)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {
	 clabel_bglt o_2306;
	 obj_t s_2307;
	 {	/* Cgen/cop.scm 24 */
	    clabel_bglt aux_5469;
	    o_2306 =
	       (clabel_bglt) (o_3867);
	    s_2307 = s_3868;
	    {	/* Cgen/cop.scm 24 */
	       obj_t aux_5472;
	       object_bglt aux_5470;
	       aux_5472 =
		  STRUCT_REF(s_2307, ((long) 0));
	       aux_5470 =
		  (object_bglt) (o_2306);
	       OBJECT_WIDENING_SET(aux_5470, aux_5472);
	    }
	    {	/* Cgen/cop.scm 24 */
	       obj_t v1462_2311;
	       v1462_2311 =
		  STRUCT_REF(s_2307, ((long) 1));
	       ((((clabel_bglt) CREF(o_2306))->loc) = ((obj_t) v1462_2311), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 24 */
	       obj_t v1466_2312;
	       v1466_2312 =
		  STRUCT_REF(s_2307, ((long) 2));
	       ((((clabel_bglt) CREF(o_2306))->name) = ((obj_t) v1466_2312), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 24 */
	       bool_t v1470_2313;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5479;
		  aux_5479 =
		     STRUCT_REF(s_2307, ((long) 3));
		  v1470_2313 =
		     CBOOL(aux_5479);
	       }
	       ((((clabel_bglt) CREF(o_2306))->used__226) = ((bool_t) v1470_2313), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 24 */
	       obj_t v1474_2314;
	       v1474_2314 =
		  STRUCT_REF(s_2307, ((long) 4));
	       ((((clabel_bglt) CREF(o_2306))->body) = ((obj_t) v1474_2314), BUNSPEC);
	    }
	    aux_5469 = o_2306;
	    return
	       (obj_t) (aux_5469);
	 }
      }
   }
}



/* object->struct-clabel2120 */
obj_t 
object__struct_clabel2120_136_cgen_cop(obj_t env_3869, obj_t obj1458_3870)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 24 */
      {
	 clabel_bglt obj1458_2292;
	 obj1458_2292 =
	    (clabel_bglt) (obj1458_3870);
	 {	/* Cgen/cop.scm 24 */
	    obj_t res1459_2295;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5487;
	       aux_5487 =
		  CNST_TABLE_REF(((long) 1));
	       res1459_2295 =
		  make_struct(aux_5487, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1459_2295, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5491;
	       aux_5491 =
		  (((clabel_bglt) CREF(obj1458_2292))->loc);
	       STRUCT_SET(res1459_2295, ((long) 1), aux_5491);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5494;
	       aux_5494 =
		  (((clabel_bglt) CREF(obj1458_2292))->name);
	       STRUCT_SET(res1459_2295, ((long) 2), aux_5494);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5497;
	       {	/* Cgen/cop.scm 24 */
		  bool_t aux_5498;
		  aux_5498 =
		     (((clabel_bglt) CREF(obj1458_2292))->used__226);
		  aux_5497 =
		     BBOOL(aux_5498);
	       }
	       STRUCT_SET(res1459_2295, ((long) 3), aux_5497);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5502;
	       aux_5502 =
		  (((clabel_bglt) CREF(obj1458_2292))->body);
	       STRUCT_SET(res1459_2295, ((long) 4), aux_5502);
	    }
	    return res1459_2295;
	 }
      }
   }
}



/* struct+object->object-cgoto2118 */
obj_t 
struct_object__object_cgoto2118_221_cgen_cop(obj_t env_3871, obj_t o_3872, obj_t s_3873)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {
	 cgoto_bglt o_2283;
	 obj_t s_2284;
	 {	/* Cgen/cop.scm 29 */
	    cgoto_bglt aux_5506;
	    o_2283 =
	       (cgoto_bglt) (o_3872);
	    s_2284 = s_3873;
	    {	/* Cgen/cop.scm 29 */
	       obj_t aux_5509;
	       object_bglt aux_5507;
	       aux_5509 =
		  STRUCT_REF(s_2284, ((long) 0));
	       aux_5507 =
		  (object_bglt) (o_2283);
	       OBJECT_WIDENING_SET(aux_5507, aux_5509);
	    }
	    {	/* Cgen/cop.scm 29 */
	       obj_t v1487_2288;
	       v1487_2288 =
		  STRUCT_REF(s_2284, ((long) 1));
	       ((((cgoto_bglt) CREF(o_2283))->loc) = ((obj_t) v1487_2288), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 29 */
	       clabel_bglt v1491_2289;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5514;
		  aux_5514 =
		     STRUCT_REF(s_2284, ((long) 2));
		  v1491_2289 =
		     (clabel_bglt) (aux_5514);
	       }
	       ((((cgoto_bglt) CREF(o_2283))->label) = ((clabel_bglt) v1491_2289), BUNSPEC);
	    }
	    aux_5506 = o_2283;
	    return
	       (obj_t) (aux_5506);
	 }
      }
   }
}



/* object->struct-cgoto2116 */
obj_t 
object__struct_cgoto2116_4_cgen_cop(obj_t env_3874, obj_t obj1483_3875)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 29 */
      {
	 cgoto_bglt obj1483_2273;
	 obj1483_2273 =
	    (cgoto_bglt) (obj1483_3875);
	 {	/* Cgen/cop.scm 29 */
	    obj_t res1484_2276;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5520;
	       aux_5520 =
		  CNST_TABLE_REF(((long) 2));
	       res1484_2276 =
		  make_struct(aux_5520, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1484_2276, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5524;
	       aux_5524 =
		  (((cgoto_bglt) CREF(obj1483_2273))->loc);
	       STRUCT_SET(res1484_2276, ((long) 1), aux_5524);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5527;
	       {	/* Cgen/cop.scm 29 */
		  clabel_bglt aux_5528;
		  aux_5528 =
		     (((cgoto_bglt) CREF(obj1483_2273))->label);
		  aux_5527 =
		     (obj_t) (aux_5528);
	       }
	       STRUCT_SET(res1484_2276, ((long) 2), aux_5527);
	    }
	    return res1484_2276;
	 }
      }
   }
}



/* struct+object->object-block2114 */
obj_t 
struct_object__object_block2114_163_cgen_cop(obj_t env_3876, obj_t o_3877, obj_t s_3878)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {
	 block_bglt o_2264;
	 obj_t s_2265;
	 {	/* Cgen/cop.scm 32 */
	    block_bglt aux_5533;
	    o_2264 =
	       (block_bglt) (o_3877);
	    s_2265 = s_3878;
	    {	/* Cgen/cop.scm 32 */
	       obj_t aux_5536;
	       object_bglt aux_5534;
	       aux_5536 =
		  STRUCT_REF(s_2265, ((long) 0));
	       aux_5534 =
		  (object_bglt) (o_2264);
	       OBJECT_WIDENING_SET(aux_5534, aux_5536);
	    }
	    {	/* Cgen/cop.scm 32 */
	       obj_t v1503_2269;
	       v1503_2269 =
		  STRUCT_REF(s_2265, ((long) 1));
	       ((((block_bglt) CREF(o_2264))->loc) = ((obj_t) v1503_2269), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 32 */
	       cop_bglt v1507_2270;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5541;
		  aux_5541 =
		     STRUCT_REF(s_2265, ((long) 2));
		  v1507_2270 =
		     (cop_bglt) (aux_5541);
	       }
	       ((((block_bglt) CREF(o_2264))->body) = ((cop_bglt) v1507_2270), BUNSPEC);
	    }
	    aux_5533 = o_2264;
	    return
	       (obj_t) (aux_5533);
	 }
      }
   }
}



/* object->struct-block2112 */
obj_t 
object__struct_block2112_230_cgen_cop(obj_t env_3879, obj_t obj1499_3880)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 32 */
      {
	 block_bglt obj1499_2254;
	 obj1499_2254 =
	    (block_bglt) (obj1499_3880);
	 {	/* Cgen/cop.scm 32 */
	    obj_t res1500_2257;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5547;
	       aux_5547 =
		  CNST_TABLE_REF(((long) 3));
	       res1500_2257 =
		  make_struct(aux_5547, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1500_2257, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5551;
	       aux_5551 =
		  (((block_bglt) CREF(obj1499_2254))->loc);
	       STRUCT_SET(res1500_2257, ((long) 1), aux_5551);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5554;
	       {	/* Cgen/cop.scm 32 */
		  cop_bglt aux_5555;
		  aux_5555 =
		     (((block_bglt) CREF(obj1499_2254))->body);
		  aux_5554 =
		     (obj_t) (aux_5555);
	       }
	       STRUCT_SET(res1500_2257, ((long) 2), aux_5554);
	    }
	    return res1500_2257;
	 }
      }
   }
}



/* struct+object->object-creturn2110 */
obj_t 
struct_object__object_creturn2110_254_cgen_cop(obj_t env_3881, obj_t o_3882, obj_t s_3883)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {
	 creturn_bglt o_2245;
	 obj_t s_2246;
	 {	/* Cgen/cop.scm 35 */
	    creturn_bglt aux_5560;
	    o_2245 =
	       (creturn_bglt) (o_3882);
	    s_2246 = s_3883;
	    {	/* Cgen/cop.scm 35 */
	       obj_t aux_5563;
	       object_bglt aux_5561;
	       aux_5563 =
		  STRUCT_REF(s_2246, ((long) 0));
	       aux_5561 =
		  (object_bglt) (o_2245);
	       OBJECT_WIDENING_SET(aux_5561, aux_5563);
	    }
	    {	/* Cgen/cop.scm 35 */
	       obj_t v1519_2250;
	       v1519_2250 =
		  STRUCT_REF(s_2246, ((long) 1));
	       ((((creturn_bglt) CREF(o_2245))->loc) = ((obj_t) v1519_2250), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 35 */
	       cop_bglt v1523_2251;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5568;
		  aux_5568 =
		     STRUCT_REF(s_2246, ((long) 2));
		  v1523_2251 =
		     (cop_bglt) (aux_5568);
	       }
	       ((((creturn_bglt) CREF(o_2245))->value) = ((cop_bglt) v1523_2251), BUNSPEC);
	    }
	    aux_5560 = o_2245;
	    return
	       (obj_t) (aux_5560);
	 }
      }
   }
}



/* object->struct-creturn2108 */
obj_t 
object__struct_creturn2108_68_cgen_cop(obj_t env_3884, obj_t obj1515_3885)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 35 */
      {
	 creturn_bglt obj1515_2235;
	 obj1515_2235 =
	    (creturn_bglt) (obj1515_3885);
	 {	/* Cgen/cop.scm 35 */
	    obj_t res1516_2238;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5574;
	       aux_5574 =
		  CNST_TABLE_REF(((long) 4));
	       res1516_2238 =
		  make_struct(aux_5574, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1516_2238, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5578;
	       aux_5578 =
		  (((creturn_bglt) CREF(obj1515_2235))->loc);
	       STRUCT_SET(res1516_2238, ((long) 1), aux_5578);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5581;
	       {	/* Cgen/cop.scm 35 */
		  cop_bglt aux_5582;
		  aux_5582 =
		     (((creturn_bglt) CREF(obj1515_2235))->value);
		  aux_5581 =
		     (obj_t) (aux_5582);
	       }
	       STRUCT_SET(res1516_2238, ((long) 2), aux_5581);
	    }
	    return res1516_2238;
	 }
      }
   }
}



/* struct+object->object-cvoid2106 */
obj_t 
struct_object__object_cvoid2106_78_cgen_cop(obj_t env_3886, obj_t o_3887, obj_t s_3888)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {
	 cvoid_bglt o_2226;
	 obj_t s_2227;
	 {	/* Cgen/cop.scm 38 */
	    cvoid_bglt aux_5587;
	    o_2226 =
	       (cvoid_bglt) (o_3887);
	    s_2227 = s_3888;
	    {	/* Cgen/cop.scm 38 */
	       obj_t aux_5590;
	       object_bglt aux_5588;
	       aux_5590 =
		  STRUCT_REF(s_2227, ((long) 0));
	       aux_5588 =
		  (object_bglt) (o_2226);
	       OBJECT_WIDENING_SET(aux_5588, aux_5590);
	    }
	    {	/* Cgen/cop.scm 38 */
	       obj_t v1535_2231;
	       v1535_2231 =
		  STRUCT_REF(s_2227, ((long) 1));
	       ((((cvoid_bglt) CREF(o_2226))->loc) = ((obj_t) v1535_2231), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 38 */
	       cop_bglt v1539_2232;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5595;
		  aux_5595 =
		     STRUCT_REF(s_2227, ((long) 2));
		  v1539_2232 =
		     (cop_bglt) (aux_5595);
	       }
	       ((((cvoid_bglt) CREF(o_2226))->value) = ((cop_bglt) v1539_2232), BUNSPEC);
	    }
	    aux_5587 = o_2226;
	    return
	       (obj_t) (aux_5587);
	 }
      }
   }
}



/* object->struct-cvoid2104 */
obj_t 
object__struct_cvoid2104_241_cgen_cop(obj_t env_3889, obj_t obj1531_3890)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 38 */
      {
	 cvoid_bglt obj1531_2216;
	 obj1531_2216 =
	    (cvoid_bglt) (obj1531_3890);
	 {	/* Cgen/cop.scm 38 */
	    obj_t res1532_2219;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5601;
	       aux_5601 =
		  CNST_TABLE_REF(((long) 5));
	       res1532_2219 =
		  make_struct(aux_5601, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1532_2219, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5605;
	       aux_5605 =
		  (((cvoid_bglt) CREF(obj1531_2216))->loc);
	       STRUCT_SET(res1532_2219, ((long) 1), aux_5605);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5608;
	       {	/* Cgen/cop.scm 38 */
		  cop_bglt aux_5609;
		  aux_5609 =
		     (((cvoid_bglt) CREF(obj1531_2216))->value);
		  aux_5608 =
		     (obj_t) (aux_5609);
	       }
	       STRUCT_SET(res1532_2219, ((long) 2), aux_5608);
	    }
	    return res1532_2219;
	 }
      }
   }
}



/* struct+object->object-catom2102 */
obj_t 
struct_object__object_catom2102_83_cgen_cop(obj_t env_3891, obj_t o_3892, obj_t s_3893)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {
	 catom_bglt o_2207;
	 obj_t s_2208;
	 {	/* Cgen/cop.scm 41 */
	    catom_bglt aux_5614;
	    o_2207 =
	       (catom_bglt) (o_3892);
	    s_2208 = s_3893;
	    {	/* Cgen/cop.scm 41 */
	       obj_t aux_5617;
	       object_bglt aux_5615;
	       aux_5617 =
		  STRUCT_REF(s_2208, ((long) 0));
	       aux_5615 =
		  (object_bglt) (o_2207);
	       OBJECT_WIDENING_SET(aux_5615, aux_5617);
	    }
	    {	/* Cgen/cop.scm 41 */
	       obj_t v1551_2212;
	       v1551_2212 =
		  STRUCT_REF(s_2208, ((long) 1));
	       ((((catom_bglt) CREF(o_2207))->loc) = ((obj_t) v1551_2212), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 41 */
	       obj_t v1555_2213;
	       v1555_2213 =
		  STRUCT_REF(s_2208, ((long) 2));
	       ((((catom_bglt) CREF(o_2207))->value) = ((obj_t) v1555_2213), BUNSPEC);
	    }
	    aux_5614 = o_2207;
	    return
	       (obj_t) (aux_5614);
	 }
      }
   }
}



/* object->struct-catom2100 */
obj_t 
object__struct_catom2100_63_cgen_cop(obj_t env_3894, obj_t obj1547_3895)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 41 */
      {
	 catom_bglt obj1547_2197;
	 obj1547_2197 =
	    (catom_bglt) (obj1547_3895);
	 {	/* Cgen/cop.scm 41 */
	    obj_t res1548_2200;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5626;
	       aux_5626 =
		  CNST_TABLE_REF(((long) 6));
	       res1548_2200 =
		  make_struct(aux_5626, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1548_2200, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5630;
	       aux_5630 =
		  (((catom_bglt) CREF(obj1547_2197))->loc);
	       STRUCT_SET(res1548_2200, ((long) 1), aux_5630);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5633;
	       aux_5633 =
		  (((catom_bglt) CREF(obj1547_2197))->value);
	       STRUCT_SET(res1548_2200, ((long) 2), aux_5633);
	    }
	    return res1548_2200;
	 }
      }
   }
}



/* struct+object->object-varc2098 */
obj_t 
struct_object__object_varc2098_186_cgen_cop(obj_t env_3896, obj_t o_3897, obj_t s_3898)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {
	 varc_bglt o_2188;
	 obj_t s_2189;
	 {	/* Cgen/cop.scm 44 */
	    varc_bglt aux_5637;
	    o_2188 =
	       (varc_bglt) (o_3897);
	    s_2189 = s_3898;
	    {	/* Cgen/cop.scm 44 */
	       obj_t aux_5640;
	       object_bglt aux_5638;
	       aux_5640 =
		  STRUCT_REF(s_2189, ((long) 0));
	       aux_5638 =
		  (object_bglt) (o_2188);
	       OBJECT_WIDENING_SET(aux_5638, aux_5640);
	    }
	    {	/* Cgen/cop.scm 44 */
	       obj_t v1568_2193;
	       v1568_2193 =
		  STRUCT_REF(s_2189, ((long) 1));
	       ((((varc_bglt) CREF(o_2188))->loc) = ((obj_t) v1568_2193), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 44 */
	       variable_bglt v1572_2194;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5645;
		  aux_5645 =
		     STRUCT_REF(s_2189, ((long) 2));
		  v1572_2194 =
		     (variable_bglt) (aux_5645);
	       }
	       ((((varc_bglt) CREF(o_2188))->variable) = ((variable_bglt) v1572_2194), BUNSPEC);
	    }
	    aux_5637 = o_2188;
	    return
	       (obj_t) (aux_5637);
	 }
      }
   }
}



/* object->struct-varc2096 */
obj_t 
object__struct_varc2096_185_cgen_cop(obj_t env_3899, obj_t obj1564_3900)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 44 */
      {
	 varc_bglt obj1564_2178;
	 obj1564_2178 =
	    (varc_bglt) (obj1564_3900);
	 {	/* Cgen/cop.scm 44 */
	    obj_t res1565_2181;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5651;
	       aux_5651 =
		  CNST_TABLE_REF(((long) 7));
	       res1565_2181 =
		  make_struct(aux_5651, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1565_2181, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5655;
	       aux_5655 =
		  (((varc_bglt) CREF(obj1564_2178))->loc);
	       STRUCT_SET(res1565_2181, ((long) 1), aux_5655);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5658;
	       {	/* Cgen/cop.scm 44 */
		  variable_bglt aux_5659;
		  aux_5659 =
		     (((varc_bglt) CREF(obj1564_2178))->variable);
		  aux_5658 =
		     (obj_t) (aux_5659);
	       }
	       STRUCT_SET(res1565_2181, ((long) 2), aux_5658);
	    }
	    return res1565_2181;
	 }
      }
   }
}



/* struct+object->object-cpragma2094 */
obj_t 
struct_object__object_cpragma2094_86_cgen_cop(obj_t env_3901, obj_t o_3902, obj_t s_3903)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {
	 cpragma_bglt o_2168;
	 obj_t s_2169;
	 {	/* Cgen/cop.scm 47 */
	    cpragma_bglt aux_5664;
	    o_2168 =
	       (cpragma_bglt) (o_3902);
	    s_2169 = s_3903;
	    {	/* Cgen/cop.scm 47 */
	       obj_t aux_5667;
	       object_bglt aux_5665;
	       aux_5667 =
		  STRUCT_REF(s_2169, ((long) 0));
	       aux_5665 =
		  (object_bglt) (o_2168);
	       OBJECT_WIDENING_SET(aux_5665, aux_5667);
	    }
	    {	/* Cgen/cop.scm 47 */
	       obj_t v1586_2173;
	       v1586_2173 =
		  STRUCT_REF(s_2169, ((long) 1));
	       ((((cpragma_bglt) CREF(o_2168))->loc) = ((obj_t) v1586_2173), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 47 */
	       obj_t v1590_2174;
	       v1590_2174 =
		  STRUCT_REF(s_2169, ((long) 2));
	       ((((cpragma_bglt) CREF(o_2168))->format) = ((obj_t) v1590_2174), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 47 */
	       obj_t v1594_2175;
	       v1594_2175 =
		  STRUCT_REF(s_2169, ((long) 3));
	       ((((cpragma_bglt) CREF(o_2168))->args) = ((obj_t) v1594_2175), BUNSPEC);
	    }
	    aux_5664 = o_2168;
	    return
	       (obj_t) (aux_5664);
	 }
      }
   }
}



/* object->struct-cpragma2092 */
obj_t 
object__struct_cpragma2092_215_cgen_cop(obj_t env_3904, obj_t obj1582_3905)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 47 */
      {
	 cpragma_bglt obj1582_2156;
	 obj1582_2156 =
	    (cpragma_bglt) (obj1582_3905);
	 {	/* Cgen/cop.scm 47 */
	    obj_t res1583_2159;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5678;
	       aux_5678 =
		  CNST_TABLE_REF(((long) 8));
	       res1583_2159 =
		  make_struct(aux_5678, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1583_2159, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5682;
	       aux_5682 =
		  (((cpragma_bglt) CREF(obj1582_2156))->loc);
	       STRUCT_SET(res1583_2159, ((long) 1), aux_5682);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5685;
	       aux_5685 =
		  (((cpragma_bglt) CREF(obj1582_2156))->format);
	       STRUCT_SET(res1583_2159, ((long) 2), aux_5685);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5688;
	       aux_5688 =
		  (((cpragma_bglt) CREF(obj1582_2156))->args);
	       STRUCT_SET(res1583_2159, ((long) 3), aux_5688);
	    }
	    return res1583_2159;
	 }
      }
   }
}



/* struct+object->object-ccast2090 */
obj_t 
struct_object__object_ccast2090_43_cgen_cop(obj_t env_3906, obj_t o_3907, obj_t s_3908)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {
	 ccast_bglt o_2146;
	 obj_t s_2147;
	 {	/* Cgen/cop.scm 51 */
	    ccast_bglt aux_5692;
	    o_2146 =
	       (ccast_bglt) (o_3907);
	    s_2147 = s_3908;
	    {	/* Cgen/cop.scm 51 */
	       obj_t aux_5695;
	       object_bglt aux_5693;
	       aux_5695 =
		  STRUCT_REF(s_2147, ((long) 0));
	       aux_5693 =
		  (object_bglt) (o_2146);
	       OBJECT_WIDENING_SET(aux_5693, aux_5695);
	    }
	    {	/* Cgen/cop.scm 51 */
	       obj_t v1607_2151;
	       v1607_2151 =
		  STRUCT_REF(s_2147, ((long) 1));
	       ((((ccast_bglt) CREF(o_2146))->loc) = ((obj_t) v1607_2151), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 51 */
	       type_bglt v1611_2152;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5700;
		  aux_5700 =
		     STRUCT_REF(s_2147, ((long) 2));
		  v1611_2152 =
		     (type_bglt) (aux_5700);
	       }
	       ((((ccast_bglt) CREF(o_2146))->type) = ((type_bglt) v1611_2152), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 51 */
	       cop_bglt v1615_2153;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5704;
		  aux_5704 =
		     STRUCT_REF(s_2147, ((long) 3));
		  v1615_2153 =
		     (cop_bglt) (aux_5704);
	       }
	       ((((ccast_bglt) CREF(o_2146))->arg) = ((cop_bglt) v1615_2153), BUNSPEC);
	    }
	    aux_5692 = o_2146;
	    return
	       (obj_t) (aux_5692);
	 }
      }
   }
}



/* object->struct-ccast2088 */
obj_t 
object__struct_ccast2088_11_cgen_cop(obj_t env_3909, obj_t obj1603_3910)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 51 */
      {
	 ccast_bglt obj1603_2134;
	 obj1603_2134 =
	    (ccast_bglt) (obj1603_3910);
	 {	/* Cgen/cop.scm 51 */
	    obj_t res1604_2137;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5710;
	       aux_5710 =
		  CNST_TABLE_REF(((long) 9));
	       res1604_2137 =
		  make_struct(aux_5710, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1604_2137, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5714;
	       aux_5714 =
		  (((ccast_bglt) CREF(obj1603_2134))->loc);
	       STRUCT_SET(res1604_2137, ((long) 1), aux_5714);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5717;
	       {	/* Cgen/cop.scm 51 */
		  type_bglt aux_5718;
		  aux_5718 =
		     (((ccast_bglt) CREF(obj1603_2134))->type);
		  aux_5717 =
		     (obj_t) (aux_5718);
	       }
	       STRUCT_SET(res1604_2137, ((long) 2), aux_5717);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5722;
	       {	/* Cgen/cop.scm 51 */
		  cop_bglt aux_5723;
		  aux_5723 =
		     (((ccast_bglt) CREF(obj1603_2134))->arg);
		  aux_5722 =
		     (obj_t) (aux_5723);
	       }
	       STRUCT_SET(res1604_2137, ((long) 3), aux_5722);
	    }
	    return res1604_2137;
	 }
      }
   }
}



/* struct+object->object-csequence2086 */
obj_t 
struct_object__object_csequence2086_115_cgen_cop(obj_t env_3911, obj_t o_3912, obj_t s_3913)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {
	 csequence_bglt o_2124;
	 obj_t s_2125;
	 {	/* Cgen/cop.scm 55 */
	    csequence_bglt aux_5728;
	    o_2124 =
	       (csequence_bglt) (o_3912);
	    s_2125 = s_3913;
	    {	/* Cgen/cop.scm 55 */
	       obj_t aux_5731;
	       object_bglt aux_5729;
	       aux_5731 =
		  STRUCT_REF(s_2125, ((long) 0));
	       aux_5729 =
		  (object_bglt) (o_2124);
	       OBJECT_WIDENING_SET(aux_5729, aux_5731);
	    }
	    {	/* Cgen/cop.scm 55 */
	       obj_t v1628_2129;
	       v1628_2129 =
		  STRUCT_REF(s_2125, ((long) 1));
	       ((((csequence_bglt) CREF(o_2124))->loc) = ((obj_t) v1628_2129), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 55 */
	       bool_t v1632_2130;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5736;
		  aux_5736 =
		     STRUCT_REF(s_2125, ((long) 2));
		  v1632_2130 =
		     CBOOL(aux_5736);
	       }
	       ((((csequence_bglt) CREF(o_2124))->c_exp__163) = ((bool_t) v1632_2130), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 55 */
	       obj_t v1636_2131;
	       v1636_2131 =
		  STRUCT_REF(s_2125, ((long) 3));
	       ((((csequence_bglt) CREF(o_2124))->cops) = ((obj_t) v1636_2131), BUNSPEC);
	    }
	    aux_5728 = o_2124;
	    return
	       (obj_t) (aux_5728);
	 }
      }
   }
}



/* object->struct-csequence2084 */
obj_t 
object__struct_csequence2084_122_cgen_cop(obj_t env_3914, obj_t obj1624_3915)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 55 */
      {
	 csequence_bglt obj1624_2112;
	 obj1624_2112 =
	    (csequence_bglt) (obj1624_3915);
	 {	/* Cgen/cop.scm 55 */
	    obj_t res1625_2115;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5744;
	       aux_5744 =
		  CNST_TABLE_REF(((long) 10));
	       res1625_2115 =
		  make_struct(aux_5744, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1625_2115, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5748;
	       aux_5748 =
		  (((csequence_bglt) CREF(obj1624_2112))->loc);
	       STRUCT_SET(res1625_2115, ((long) 1), aux_5748);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5751;
	       {	/* Cgen/cop.scm 55 */
		  bool_t aux_5752;
		  aux_5752 =
		     (((csequence_bglt) CREF(obj1624_2112))->c_exp__163);
		  aux_5751 =
		     BBOOL(aux_5752);
	       }
	       STRUCT_SET(res1625_2115, ((long) 2), aux_5751);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5756;
	       aux_5756 =
		  (((csequence_bglt) CREF(obj1624_2112))->cops);
	       STRUCT_SET(res1625_2115, ((long) 3), aux_5756);
	    }
	    return res1625_2115;
	 }
      }
   }
}



/* struct+object->object-nop2082 */
obj_t 
struct_object__object_nop2082_201_cgen_cop(obj_t env_3916, obj_t o_3917, obj_t s_3918)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {
	 nop_bglt o_2104;
	 obj_t s_2105;
	 {	/* Cgen/cop.scm 59 */
	    nop_bglt aux_5760;
	    o_2104 =
	       (nop_bglt) (o_3917);
	    s_2105 = s_3918;
	    {	/* Cgen/cop.scm 59 */
	       obj_t aux_5763;
	       object_bglt aux_5761;
	       aux_5763 =
		  STRUCT_REF(s_2105, ((long) 0));
	       aux_5761 =
		  (object_bglt) (o_2104);
	       OBJECT_WIDENING_SET(aux_5761, aux_5763);
	    }
	    {	/* Cgen/cop.scm 59 */
	       obj_t v1647_2109;
	       v1647_2109 =
		  STRUCT_REF(s_2105, ((long) 1));
	       ((((nop_bglt) CREF(o_2104))->loc) = ((obj_t) v1647_2109), BUNSPEC);
	    }
	    aux_5760 = o_2104;
	    return
	       (obj_t) (aux_5760);
	 }
      }
   }
}



/* object->struct-nop2080 */
obj_t 
object__struct_nop2080_60_cgen_cop(obj_t env_3919, obj_t obj1643_3920)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 59 */
      {
	 nop_bglt obj1643_2096;
	 obj1643_2096 =
	    (nop_bglt) (obj1643_3920);
	 {	/* Cgen/cop.scm 59 */
	    obj_t res1644_2099;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5770;
	       aux_5770 =
		  CNST_TABLE_REF(((long) 11));
	       res1644_2099 =
		  make_struct(aux_5770, ((long) 2), BUNSPEC);
	    }
	    STRUCT_SET(res1644_2099, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5774;
	       aux_5774 =
		  (((nop_bglt) CREF(obj1643_2096))->loc);
	       STRUCT_SET(res1644_2099, ((long) 1), aux_5774);
	    }
	    return res1644_2099;
	 }
      }
   }
}



/* struct+object->object-stop2078 */
obj_t 
struct_object__object_stop2078_236_cgen_cop(obj_t env_3921, obj_t o_3922, obj_t s_3923)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {
	 stop_bglt o_2087;
	 obj_t s_2088;
	 {	/* Cgen/cop.scm 61 */
	    stop_bglt aux_5778;
	    o_2087 =
	       (stop_bglt) (o_3922);
	    s_2088 = s_3923;
	    {	/* Cgen/cop.scm 61 */
	       obj_t aux_5781;
	       object_bglt aux_5779;
	       aux_5781 =
		  STRUCT_REF(s_2088, ((long) 0));
	       aux_5779 =
		  (object_bglt) (o_2087);
	       OBJECT_WIDENING_SET(aux_5779, aux_5781);
	    }
	    {	/* Cgen/cop.scm 61 */
	       obj_t v1659_2092;
	       v1659_2092 =
		  STRUCT_REF(s_2088, ((long) 1));
	       ((((stop_bglt) CREF(o_2087))->loc) = ((obj_t) v1659_2092), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 61 */
	       cop_bglt v1663_2093;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5786;
		  aux_5786 =
		     STRUCT_REF(s_2088, ((long) 2));
		  v1663_2093 =
		     (cop_bglt) (aux_5786);
	       }
	       ((((stop_bglt) CREF(o_2087))->value) = ((cop_bglt) v1663_2093), BUNSPEC);
	    }
	    aux_5778 = o_2087;
	    return
	       (obj_t) (aux_5778);
	 }
      }
   }
}



/* object->struct-stop2076 */
obj_t 
object__struct_stop2076_25_cgen_cop(obj_t env_3924, obj_t obj1655_3925)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 61 */
      {
	 stop_bglt obj1655_2077;
	 obj1655_2077 =
	    (stop_bglt) (obj1655_3925);
	 {	/* Cgen/cop.scm 61 */
	    obj_t res1656_2080;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5792;
	       aux_5792 =
		  CNST_TABLE_REF(((long) 12));
	       res1656_2080 =
		  make_struct(aux_5792, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1656_2080, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5796;
	       aux_5796 =
		  (((stop_bglt) CREF(obj1655_2077))->loc);
	       STRUCT_SET(res1656_2080, ((long) 1), aux_5796);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5799;
	       {	/* Cgen/cop.scm 61 */
		  cop_bglt aux_5800;
		  aux_5800 =
		     (((stop_bglt) CREF(obj1655_2077))->value);
		  aux_5799 =
		     (obj_t) (aux_5800);
	       }
	       STRUCT_SET(res1656_2080, ((long) 2), aux_5799);
	    }
	    return res1656_2080;
	 }
      }
   }
}



/* struct+object->object-csetq2074 */
obj_t 
struct_object__object_csetq2074_47_cgen_cop(obj_t env_3926, obj_t o_3927, obj_t s_3928)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {
	 csetq_bglt o_2067;
	 obj_t s_2068;
	 {	/* Cgen/cop.scm 64 */
	    csetq_bglt aux_5805;
	    o_2067 =
	       (csetq_bglt) (o_3927);
	    s_2068 = s_3928;
	    {	/* Cgen/cop.scm 64 */
	       obj_t aux_5808;
	       object_bglt aux_5806;
	       aux_5808 =
		  STRUCT_REF(s_2068, ((long) 0));
	       aux_5806 =
		  (object_bglt) (o_2067);
	       OBJECT_WIDENING_SET(aux_5806, aux_5808);
	    }
	    {	/* Cgen/cop.scm 64 */
	       obj_t v1676_2072;
	       v1676_2072 =
		  STRUCT_REF(s_2068, ((long) 1));
	       ((((csetq_bglt) CREF(o_2067))->loc) = ((obj_t) v1676_2072), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 64 */
	       varc_bglt v1680_2073;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5813;
		  aux_5813 =
		     STRUCT_REF(s_2068, ((long) 2));
		  v1680_2073 =
		     (varc_bglt) (aux_5813);
	       }
	       ((((csetq_bglt) CREF(o_2067))->var) = ((varc_bglt) v1680_2073), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 64 */
	       cop_bglt v1684_2074;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5817;
		  aux_5817 =
		     STRUCT_REF(s_2068, ((long) 3));
		  v1684_2074 =
		     (cop_bglt) (aux_5817);
	       }
	       ((((csetq_bglt) CREF(o_2067))->value) = ((cop_bglt) v1684_2074), BUNSPEC);
	    }
	    aux_5805 = o_2067;
	    return
	       (obj_t) (aux_5805);
	 }
      }
   }
}



/* object->struct-csetq2072 */
obj_t 
object__struct_csetq2072_83_cgen_cop(obj_t env_3929, obj_t obj1672_3930)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 64 */
      {
	 csetq_bglt obj1672_2055;
	 obj1672_2055 =
	    (csetq_bglt) (obj1672_3930);
	 {	/* Cgen/cop.scm 64 */
	    obj_t res1673_2058;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5823;
	       aux_5823 =
		  CNST_TABLE_REF(((long) 13));
	       res1673_2058 =
		  make_struct(aux_5823, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1673_2058, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5827;
	       aux_5827 =
		  (((csetq_bglt) CREF(obj1672_2055))->loc);
	       STRUCT_SET(res1673_2058, ((long) 1), aux_5827);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5830;
	       {	/* Cgen/cop.scm 64 */
		  varc_bglt aux_5831;
		  aux_5831 =
		     (((csetq_bglt) CREF(obj1672_2055))->var);
		  aux_5830 =
		     (obj_t) (aux_5831);
	       }
	       STRUCT_SET(res1673_2058, ((long) 2), aux_5830);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5835;
	       {	/* Cgen/cop.scm 64 */
		  cop_bglt aux_5836;
		  aux_5836 =
		     (((csetq_bglt) CREF(obj1672_2055))->value);
		  aux_5835 =
		     (obj_t) (aux_5836);
	       }
	       STRUCT_SET(res1673_2058, ((long) 3), aux_5835);
	    }
	    return res1673_2058;
	 }
      }
   }
}



/* struct+object->object-cif2070 */
obj_t 
struct_object__object_cif2070_34_cgen_cop(obj_t env_3931, obj_t o_3932, obj_t s_3933)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {
	 cif_bglt o_2044;
	 obj_t s_2045;
	 {	/* Cgen/cop.scm 68 */
	    cif_bglt aux_5841;
	    o_2044 =
	       (cif_bglt) (o_3932);
	    s_2045 = s_3933;
	    {	/* Cgen/cop.scm 68 */
	       obj_t aux_5844;
	       object_bglt aux_5842;
	       aux_5844 =
		  STRUCT_REF(s_2045, ((long) 0));
	       aux_5842 =
		  (object_bglt) (o_2044);
	       OBJECT_WIDENING_SET(aux_5842, aux_5844);
	    }
	    {	/* Cgen/cop.scm 68 */
	       obj_t v1698_2049;
	       v1698_2049 =
		  STRUCT_REF(s_2045, ((long) 1));
	       ((((cif_bglt) CREF(o_2044))->loc) = ((obj_t) v1698_2049), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 68 */
	       cop_bglt v1702_2050;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5849;
		  aux_5849 =
		     STRUCT_REF(s_2045, ((long) 2));
		  v1702_2050 =
		     (cop_bglt) (aux_5849);
	       }
	       ((((cif_bglt) CREF(o_2044))->test) = ((cop_bglt) v1702_2050), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 68 */
	       cop_bglt v1706_2051;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5853;
		  aux_5853 =
		     STRUCT_REF(s_2045, ((long) 3));
		  v1706_2051 =
		     (cop_bglt) (aux_5853);
	       }
	       ((((cif_bglt) CREF(o_2044))->true) = ((cop_bglt) v1706_2051), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 68 */
	       cop_bglt v1710_2052;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5857;
		  aux_5857 =
		     STRUCT_REF(s_2045, ((long) 4));
		  v1710_2052 =
		     (cop_bglt) (aux_5857);
	       }
	       ((((cif_bglt) CREF(o_2044))->false) = ((cop_bglt) v1710_2052), BUNSPEC);
	    }
	    aux_5841 = o_2044;
	    return
	       (obj_t) (aux_5841);
	 }
      }
   }
}



/* object->struct-cif2068 */
obj_t 
object__struct_cif2068_57_cgen_cop(obj_t env_3934, obj_t obj1694_3935)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 68 */
      {
	 cif_bglt obj1694_2030;
	 obj1694_2030 =
	    (cif_bglt) (obj1694_3935);
	 {	/* Cgen/cop.scm 68 */
	    obj_t res1695_2033;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5863;
	       aux_5863 =
		  CNST_TABLE_REF(((long) 14));
	       res1695_2033 =
		  make_struct(aux_5863, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1695_2033, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5867;
	       aux_5867 =
		  (((cif_bglt) CREF(obj1694_2030))->loc);
	       STRUCT_SET(res1695_2033, ((long) 1), aux_5867);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5870;
	       {	/* Cgen/cop.scm 68 */
		  cop_bglt aux_5871;
		  aux_5871 =
		     (((cif_bglt) CREF(obj1694_2030))->test);
		  aux_5870 =
		     (obj_t) (aux_5871);
	       }
	       STRUCT_SET(res1695_2033, ((long) 2), aux_5870);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5875;
	       {	/* Cgen/cop.scm 68 */
		  cop_bglt aux_5876;
		  aux_5876 =
		     (((cif_bglt) CREF(obj1694_2030))->true);
		  aux_5875 =
		     (obj_t) (aux_5876);
	       }
	       STRUCT_SET(res1695_2033, ((long) 3), aux_5875);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5880;
	       {	/* Cgen/cop.scm 68 */
		  cop_bglt aux_5881;
		  aux_5881 =
		     (((cif_bglt) CREF(obj1694_2030))->false);
		  aux_5880 =
		     (obj_t) (aux_5881);
	       }
	       STRUCT_SET(res1695_2033, ((long) 4), aux_5880);
	    }
	    return res1695_2033;
	 }
      }
   }
}



/* struct+object->object-local-var2066 */
obj_t 
struct_object__object_local_var2066_83_cgen_cop(obj_t env_3936, obj_t o_3937, obj_t s_3938)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {
	 local_var_164_bglt o_2021;
	 obj_t s_2022;
	 {	/* Cgen/cop.scm 73 */
	    local_var_164_bglt aux_5886;
	    o_2021 =
	       (local_var_164_bglt) (o_3937);
	    s_2022 = s_3938;
	    {	/* Cgen/cop.scm 73 */
	       obj_t aux_5889;
	       object_bglt aux_5887;
	       aux_5889 =
		  STRUCT_REF(s_2022, ((long) 0));
	       aux_5887 =
		  (object_bglt) (o_2021);
	       OBJECT_WIDENING_SET(aux_5887, aux_5889);
	    }
	    {	/* Cgen/cop.scm 73 */
	       obj_t v1722_2026;
	       v1722_2026 =
		  STRUCT_REF(s_2022, ((long) 1));
	       ((((local_var_164_bglt) CREF(o_2021))->loc) = ((obj_t) v1722_2026), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 73 */
	       obj_t v1726_2027;
	       v1726_2027 =
		  STRUCT_REF(s_2022, ((long) 2));
	       ((((local_var_164_bglt) CREF(o_2021))->vars) = ((obj_t) v1726_2027), BUNSPEC);
	    }
	    aux_5886 = o_2021;
	    return
	       (obj_t) (aux_5886);
	 }
      }
   }
}



/* object->struct-local-var2064 */
obj_t 
object__struct_local_var2064_249_cgen_cop(obj_t env_3939, obj_t obj1718_3940)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 73 */
      {
	 local_var_164_bglt obj1718_2011;
	 obj1718_2011 =
	    (local_var_164_bglt) (obj1718_3940);
	 {	/* Cgen/cop.scm 73 */
	    obj_t res1719_2014;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5898;
	       aux_5898 =
		  CNST_TABLE_REF(((long) 15));
	       res1719_2014 =
		  make_struct(aux_5898, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1719_2014, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5902;
	       aux_5902 =
		  (((local_var_164_bglt) CREF(obj1718_2011))->loc);
	       STRUCT_SET(res1719_2014, ((long) 1), aux_5902);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5905;
	       aux_5905 =
		  (((local_var_164_bglt) CREF(obj1718_2011))->vars);
	       STRUCT_SET(res1719_2014, ((long) 2), aux_5905);
	    }
	    return res1719_2014;
	 }
      }
   }
}



/* struct+object->object-cfuncall2062 */
obj_t 
struct_object__object_cfuncall2062_66_cgen_cop(obj_t env_3941, obj_t o_3942, obj_t s_3943)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {
	 cfuncall_bglt o_2000;
	 obj_t s_2001;
	 {	/* Cgen/cop.scm 76 */
	    cfuncall_bglt aux_5909;
	    o_2000 =
	       (cfuncall_bglt) (o_3942);
	    s_2001 = s_3943;
	    {	/* Cgen/cop.scm 76 */
	       obj_t aux_5912;
	       object_bglt aux_5910;
	       aux_5912 =
		  STRUCT_REF(s_2001, ((long) 0));
	       aux_5910 =
		  (object_bglt) (o_2000);
	       OBJECT_WIDENING_SET(aux_5910, aux_5912);
	    }
	    {	/* Cgen/cop.scm 76 */
	       obj_t v1740_2005;
	       v1740_2005 =
		  STRUCT_REF(s_2001, ((long) 1));
	       ((((cfuncall_bglt) CREF(o_2000))->loc) = ((obj_t) v1740_2005), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 76 */
	       cop_bglt v1744_2006;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5917;
		  aux_5917 =
		     STRUCT_REF(s_2001, ((long) 2));
		  v1744_2006 =
		     (cop_bglt) (aux_5917);
	       }
	       ((((cfuncall_bglt) CREF(o_2000))->fun) = ((cop_bglt) v1744_2006), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 76 */
	       obj_t v1748_2007;
	       v1748_2007 =
		  STRUCT_REF(s_2001, ((long) 3));
	       ((((cfuncall_bglt) CREF(o_2000))->args) = ((obj_t) v1748_2007), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 76 */
	       obj_t v1752_2008;
	       v1752_2008 =
		  STRUCT_REF(s_2001, ((long) 4));
	       ((((cfuncall_bglt) CREF(o_2000))->strength) = ((obj_t) v1752_2008), BUNSPEC);
	    }
	    aux_5909 = o_2000;
	    return
	       (obj_t) (aux_5909);
	 }
      }
   }
}



/* object->struct-cfuncall2060 */
obj_t 
object__struct_cfuncall2060_199_cgen_cop(obj_t env_3944, obj_t obj1736_3945)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 76 */
      {
	 cfuncall_bglt obj1736_1986;
	 obj1736_1986 =
	    (cfuncall_bglt) (obj1736_3945);
	 {	/* Cgen/cop.scm 76 */
	    obj_t res1737_1989;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5927;
	       aux_5927 =
		  CNST_TABLE_REF(((long) 16));
	       res1737_1989 =
		  make_struct(aux_5927, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1737_1989, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5931;
	       aux_5931 =
		  (((cfuncall_bglt) CREF(obj1736_1986))->loc);
	       STRUCT_SET(res1737_1989, ((long) 1), aux_5931);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5934;
	       {	/* Cgen/cop.scm 76 */
		  cop_bglt aux_5935;
		  aux_5935 =
		     (((cfuncall_bglt) CREF(obj1736_1986))->fun);
		  aux_5934 =
		     (obj_t) (aux_5935);
	       }
	       STRUCT_SET(res1737_1989, ((long) 2), aux_5934);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5939;
	       aux_5939 =
		  (((cfuncall_bglt) CREF(obj1736_1986))->args);
	       STRUCT_SET(res1737_1989, ((long) 3), aux_5939);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5942;
	       aux_5942 =
		  (((cfuncall_bglt) CREF(obj1736_1986))->strength);
	       STRUCT_SET(res1737_1989, ((long) 4), aux_5942);
	    }
	    return res1737_1989;
	 }
      }
   }
}



/* struct+object->object-capply2058 */
obj_t 
struct_object__object_capply2058_20_cgen_cop(obj_t env_3946, obj_t o_3947, obj_t s_3948)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {
	 capply_bglt o_1976;
	 obj_t s_1977;
	 {	/* Cgen/cop.scm 81 */
	    capply_bglt aux_5946;
	    o_1976 =
	       (capply_bglt) (o_3947);
	    s_1977 = s_3948;
	    {	/* Cgen/cop.scm 81 */
	       obj_t aux_5949;
	       object_bglt aux_5947;
	       aux_5949 =
		  STRUCT_REF(s_1977, ((long) 0));
	       aux_5947 =
		  (object_bglt) (o_1976);
	       OBJECT_WIDENING_SET(aux_5947, aux_5949);
	    }
	    {	/* Cgen/cop.scm 81 */
	       obj_t v1765_1981;
	       v1765_1981 =
		  STRUCT_REF(s_1977, ((long) 1));
	       ((((capply_bglt) CREF(o_1976))->loc) = ((obj_t) v1765_1981), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 81 */
	       cop_bglt v1769_1982;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5954;
		  aux_5954 =
		     STRUCT_REF(s_1977, ((long) 2));
		  v1769_1982 =
		     (cop_bglt) (aux_5954);
	       }
	       ((((capply_bglt) CREF(o_1976))->fun) = ((cop_bglt) v1769_1982), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 81 */
	       cop_bglt v1773_1983;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5958;
		  aux_5958 =
		     STRUCT_REF(s_1977, ((long) 3));
		  v1773_1983 =
		     (cop_bglt) (aux_5958);
	       }
	       ((((capply_bglt) CREF(o_1976))->arg) = ((cop_bglt) v1773_1983), BUNSPEC);
	    }
	    aux_5946 = o_1976;
	    return
	       (obj_t) (aux_5946);
	 }
      }
   }
}



/* object->struct-capply2056 */
obj_t 
object__struct_capply2056_93_cgen_cop(obj_t env_3949, obj_t obj1761_3950)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 81 */
      {
	 capply_bglt obj1761_1964;
	 obj1761_1964 =
	    (capply_bglt) (obj1761_3950);
	 {	/* Cgen/cop.scm 81 */
	    obj_t res1762_1967;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5964;
	       aux_5964 =
		  CNST_TABLE_REF(((long) 17));
	       res1762_1967 =
		  make_struct(aux_5964, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1762_1967, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5968;
	       aux_5968 =
		  (((capply_bglt) CREF(obj1761_1964))->loc);
	       STRUCT_SET(res1762_1967, ((long) 1), aux_5968);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5971;
	       {	/* Cgen/cop.scm 81 */
		  cop_bglt aux_5972;
		  aux_5972 =
		     (((capply_bglt) CREF(obj1761_1964))->fun);
		  aux_5971 =
		     (obj_t) (aux_5972);
	       }
	       STRUCT_SET(res1762_1967, ((long) 2), aux_5971);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_5976;
	       {	/* Cgen/cop.scm 81 */
		  cop_bglt aux_5977;
		  aux_5977 =
		     (((capply_bglt) CREF(obj1761_1964))->arg);
		  aux_5976 =
		     (obj_t) (aux_5977);
	       }
	       STRUCT_SET(res1762_1967, ((long) 3), aux_5976);
	    }
	    return res1762_1967;
	 }
      }
   }
}



/* struct+object->object-capp2054 */
obj_t 
struct_object__object_capp2054_65_cgen_cop(obj_t env_3951, obj_t o_3952, obj_t s_3953)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {
	 capp_bglt o_1954;
	 obj_t s_1955;
	 {	/* Cgen/cop.scm 85 */
	    capp_bglt aux_5982;
	    o_1954 =
	       (capp_bglt) (o_3952);
	    s_1955 = s_3953;
	    {	/* Cgen/cop.scm 85 */
	       obj_t aux_5985;
	       object_bglt aux_5983;
	       aux_5985 =
		  STRUCT_REF(s_1955, ((long) 0));
	       aux_5983 =
		  (object_bglt) (o_1954);
	       OBJECT_WIDENING_SET(aux_5983, aux_5985);
	    }
	    {	/* Cgen/cop.scm 85 */
	       obj_t v1786_1959;
	       v1786_1959 =
		  STRUCT_REF(s_1955, ((long) 1));
	       ((((capp_bglt) CREF(o_1954))->loc) = ((obj_t) v1786_1959), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 85 */
	       cop_bglt v1790_1960;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_5990;
		  aux_5990 =
		     STRUCT_REF(s_1955, ((long) 2));
		  v1790_1960 =
		     (cop_bglt) (aux_5990);
	       }
	       ((((capp_bglt) CREF(o_1954))->fun) = ((cop_bglt) v1790_1960), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 85 */
	       obj_t v1794_1961;
	       v1794_1961 =
		  STRUCT_REF(s_1955, ((long) 3));
	       ((((capp_bglt) CREF(o_1954))->args) = ((obj_t) v1794_1961), BUNSPEC);
	    }
	    aux_5982 = o_1954;
	    return
	       (obj_t) (aux_5982);
	 }
      }
   }
}



/* object->struct-capp2052 */
obj_t 
object__struct_capp2052_146_cgen_cop(obj_t env_3954, obj_t obj1782_3955)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 85 */
      {
	 capp_bglt obj1782_1942;
	 obj1782_1942 =
	    (capp_bglt) (obj1782_3955);
	 {	/* Cgen/cop.scm 85 */
	    obj_t res1783_1945;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_5998;
	       aux_5998 =
		  CNST_TABLE_REF(((long) 18));
	       res1783_1945 =
		  make_struct(aux_5998, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1783_1945, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6002;
	       aux_6002 =
		  (((capp_bglt) CREF(obj1782_1942))->loc);
	       STRUCT_SET(res1783_1945, ((long) 1), aux_6002);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6005;
	       {	/* Cgen/cop.scm 85 */
		  cop_bglt aux_6006;
		  aux_6006 =
		     (((capp_bglt) CREF(obj1782_1942))->fun);
		  aux_6005 =
		     (obj_t) (aux_6006);
	       }
	       STRUCT_SET(res1783_1945, ((long) 2), aux_6005);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6010;
	       aux_6010 =
		  (((capp_bglt) CREF(obj1782_1942))->args);
	       STRUCT_SET(res1783_1945, ((long) 3), aux_6010);
	    }
	    return res1783_1945;
	 }
      }
   }
}



/* struct+object->object-cfail2050 */
obj_t 
struct_object__object_cfail2050_83_cgen_cop(obj_t env_3956, obj_t o_3957, obj_t s_3958)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {
	 cfail_bglt o_1931;
	 obj_t s_1932;
	 {	/* Cgen/cop.scm 89 */
	    cfail_bglt aux_6014;
	    o_1931 =
	       (cfail_bglt) (o_3957);
	    s_1932 = s_3958;
	    {	/* Cgen/cop.scm 89 */
	       obj_t aux_6017;
	       object_bglt aux_6015;
	       aux_6017 =
		  STRUCT_REF(s_1932, ((long) 0));
	       aux_6015 =
		  (object_bglt) (o_1931);
	       OBJECT_WIDENING_SET(aux_6015, aux_6017);
	    }
	    {	/* Cgen/cop.scm 89 */
	       obj_t v1808_1936;
	       v1808_1936 =
		  STRUCT_REF(s_1932, ((long) 1));
	       ((((cfail_bglt) CREF(o_1931))->loc) = ((obj_t) v1808_1936), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 89 */
	       cop_bglt v1812_1937;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6022;
		  aux_6022 =
		     STRUCT_REF(s_1932, ((long) 2));
		  v1812_1937 =
		     (cop_bglt) (aux_6022);
	       }
	       ((((cfail_bglt) CREF(o_1931))->proc) = ((cop_bglt) v1812_1937), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 89 */
	       cop_bglt v1816_1938;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6026;
		  aux_6026 =
		     STRUCT_REF(s_1932, ((long) 3));
		  v1816_1938 =
		     (cop_bglt) (aux_6026);
	       }
	       ((((cfail_bglt) CREF(o_1931))->msg) = ((cop_bglt) v1816_1938), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 89 */
	       cop_bglt v1820_1939;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6030;
		  aux_6030 =
		     STRUCT_REF(s_1932, ((long) 4));
		  v1820_1939 =
		     (cop_bglt) (aux_6030);
	       }
	       ((((cfail_bglt) CREF(o_1931))->obj) = ((cop_bglt) v1820_1939), BUNSPEC);
	    }
	    aux_6014 = o_1931;
	    return
	       (obj_t) (aux_6014);
	 }
      }
   }
}



/* object->struct-cfail2048 */
obj_t 
object__struct_cfail2048_158_cgen_cop(obj_t env_3959, obj_t obj1804_3960)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 89 */
      {
	 cfail_bglt obj1804_1917;
	 obj1804_1917 =
	    (cfail_bglt) (obj1804_3960);
	 {	/* Cgen/cop.scm 89 */
	    obj_t res1805_1920;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6036;
	       aux_6036 =
		  CNST_TABLE_REF(((long) 19));
	       res1805_1920 =
		  make_struct(aux_6036, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1805_1920, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6040;
	       aux_6040 =
		  (((cfail_bglt) CREF(obj1804_1917))->loc);
	       STRUCT_SET(res1805_1920, ((long) 1), aux_6040);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6043;
	       {	/* Cgen/cop.scm 89 */
		  cop_bglt aux_6044;
		  aux_6044 =
		     (((cfail_bglt) CREF(obj1804_1917))->proc);
		  aux_6043 =
		     (obj_t) (aux_6044);
	       }
	       STRUCT_SET(res1805_1920, ((long) 2), aux_6043);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6048;
	       {	/* Cgen/cop.scm 89 */
		  cop_bglt aux_6049;
		  aux_6049 =
		     (((cfail_bglt) CREF(obj1804_1917))->msg);
		  aux_6048 =
		     (obj_t) (aux_6049);
	       }
	       STRUCT_SET(res1805_1920, ((long) 3), aux_6048);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6053;
	       {	/* Cgen/cop.scm 89 */
		  cop_bglt aux_6054;
		  aux_6054 =
		     (((cfail_bglt) CREF(obj1804_1917))->obj);
		  aux_6053 =
		     (obj_t) (aux_6054);
	       }
	       STRUCT_SET(res1805_1920, ((long) 4), aux_6053);
	    }
	    return res1805_1920;
	 }
      }
   }
}



/* struct+object->object-cswitch2046 */
obj_t 
struct_object__object_cswitch2046_213_cgen_cop(obj_t env_3961, obj_t o_3962, obj_t s_3963)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {
	 cswitch_bglt o_1907;
	 obj_t s_1908;
	 {	/* Cgen/cop.scm 94 */
	    cswitch_bglt aux_6059;
	    o_1907 =
	       (cswitch_bglt) (o_3962);
	    s_1908 = s_3963;
	    {	/* Cgen/cop.scm 94 */
	       obj_t aux_6062;
	       object_bglt aux_6060;
	       aux_6062 =
		  STRUCT_REF(s_1908, ((long) 0));
	       aux_6060 =
		  (object_bglt) (o_1907);
	       OBJECT_WIDENING_SET(aux_6060, aux_6062);
	    }
	    {	/* Cgen/cop.scm 94 */
	       obj_t v1834_1912;
	       v1834_1912 =
		  STRUCT_REF(s_1908, ((long) 1));
	       ((((cswitch_bglt) CREF(o_1907))->loc) = ((obj_t) v1834_1912), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 94 */
	       cop_bglt v1838_1913;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6067;
		  aux_6067 =
		     STRUCT_REF(s_1908, ((long) 2));
		  v1838_1913 =
		     (cop_bglt) (aux_6067);
	       }
	       ((((cswitch_bglt) CREF(o_1907))->test) = ((cop_bglt) v1838_1913), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 94 */
	       obj_t v1842_1914;
	       v1842_1914 =
		  STRUCT_REF(s_1908, ((long) 3));
	       ((((cswitch_bglt) CREF(o_1907))->clauses) = ((obj_t) v1842_1914), BUNSPEC);
	    }
	    aux_6059 = o_1907;
	    return
	       (obj_t) (aux_6059);
	 }
      }
   }
}



/* object->struct-cswitch2044 */
obj_t 
object__struct_cswitch2044_70_cgen_cop(obj_t env_3964, obj_t obj1830_3965)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 94 */
      {
	 cswitch_bglt obj1830_1895;
	 obj1830_1895 =
	    (cswitch_bglt) (obj1830_3965);
	 {	/* Cgen/cop.scm 94 */
	    obj_t res1831_1898;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6075;
	       aux_6075 =
		  CNST_TABLE_REF(((long) 20));
	       res1831_1898 =
		  make_struct(aux_6075, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1831_1898, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6079;
	       aux_6079 =
		  (((cswitch_bglt) CREF(obj1830_1895))->loc);
	       STRUCT_SET(res1831_1898, ((long) 1), aux_6079);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6082;
	       {	/* Cgen/cop.scm 94 */
		  cop_bglt aux_6083;
		  aux_6083 =
		     (((cswitch_bglt) CREF(obj1830_1895))->test);
		  aux_6082 =
		     (obj_t) (aux_6083);
	       }
	       STRUCT_SET(res1831_1898, ((long) 2), aux_6082);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6087;
	       aux_6087 =
		  (((cswitch_bglt) CREF(obj1830_1895))->clauses);
	       STRUCT_SET(res1831_1898, ((long) 3), aux_6087);
	    }
	    return res1831_1898;
	 }
      }
   }
}



/* struct+object->object-cmake-box2042 */
obj_t 
struct_object__object_cmake_box2042_109_cgen_cop(obj_t env_3966, obj_t o_3967, obj_t s_3968)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {
	 cmake_box_177_bglt o_1886;
	 obj_t s_1887;
	 {	/* Cgen/cop.scm 98 */
	    cmake_box_177_bglt aux_6091;
	    o_1886 =
	       (cmake_box_177_bglt) (o_3967);
	    s_1887 = s_3968;
	    {	/* Cgen/cop.scm 98 */
	       obj_t aux_6094;
	       object_bglt aux_6092;
	       aux_6094 =
		  STRUCT_REF(s_1887, ((long) 0));
	       aux_6092 =
		  (object_bglt) (o_1886);
	       OBJECT_WIDENING_SET(aux_6092, aux_6094);
	    }
	    {	/* Cgen/cop.scm 98 */
	       obj_t v1854_1891;
	       v1854_1891 =
		  STRUCT_REF(s_1887, ((long) 1));
	       ((((cmake_box_177_bglt) CREF(o_1886))->loc) = ((obj_t) v1854_1891), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 98 */
	       cop_bglt v1858_1892;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6099;
		  aux_6099 =
		     STRUCT_REF(s_1887, ((long) 2));
		  v1858_1892 =
		     (cop_bglt) (aux_6099);
	       }
	       ((((cmake_box_177_bglt) CREF(o_1886))->value) = ((cop_bglt) v1858_1892), BUNSPEC);
	    }
	    aux_6091 = o_1886;
	    return
	       (obj_t) (aux_6091);
	 }
      }
   }
}



/* object->struct-cmake-box2040 */
obj_t 
object__struct_cmake_box2040_139_cgen_cop(obj_t env_3969, obj_t obj1850_3970)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 98 */
      {
	 cmake_box_177_bglt obj1850_1876;
	 obj1850_1876 =
	    (cmake_box_177_bglt) (obj1850_3970);
	 {	/* Cgen/cop.scm 98 */
	    obj_t res1851_1879;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6105;
	       aux_6105 =
		  CNST_TABLE_REF(((long) 21));
	       res1851_1879 =
		  make_struct(aux_6105, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1851_1879, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6109;
	       aux_6109 =
		  (((cmake_box_177_bglt) CREF(obj1850_1876))->loc);
	       STRUCT_SET(res1851_1879, ((long) 1), aux_6109);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6112;
	       {	/* Cgen/cop.scm 98 */
		  cop_bglt aux_6113;
		  aux_6113 =
		     (((cmake_box_177_bglt) CREF(obj1850_1876))->value);
		  aux_6112 =
		     (obj_t) (aux_6113);
	       }
	       STRUCT_SET(res1851_1879, ((long) 2), aux_6112);
	    }
	    return res1851_1879;
	 }
      }
   }
}



/* struct+object->object-cbox-ref2038 */
obj_t 
struct_object__object_cbox_ref2038_171_cgen_cop(obj_t env_3971, obj_t o_3972, obj_t s_3973)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {
	 cbox_ref_44_bglt o_1867;
	 obj_t s_1868;
	 {	/* Cgen/cop.scm 101 */
	    cbox_ref_44_bglt aux_6118;
	    o_1867 =
	       (cbox_ref_44_bglt) (o_3972);
	    s_1868 = s_3973;
	    {	/* Cgen/cop.scm 101 */
	       obj_t aux_6121;
	       object_bglt aux_6119;
	       aux_6121 =
		  STRUCT_REF(s_1868, ((long) 0));
	       aux_6119 =
		  (object_bglt) (o_1867);
	       OBJECT_WIDENING_SET(aux_6119, aux_6121);
	    }
	    {	/* Cgen/cop.scm 101 */
	       obj_t v1870_1872;
	       v1870_1872 =
		  STRUCT_REF(s_1868, ((long) 1));
	       ((((cbox_ref_44_bglt) CREF(o_1867))->loc) = ((obj_t) v1870_1872), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 101 */
	       cop_bglt v1874_1873;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6126;
		  aux_6126 =
		     STRUCT_REF(s_1868, ((long) 2));
		  v1874_1873 =
		     (cop_bglt) (aux_6126);
	       }
	       ((((cbox_ref_44_bglt) CREF(o_1867))->var) = ((cop_bglt) v1874_1873), BUNSPEC);
	    }
	    aux_6118 = o_1867;
	    return
	       (obj_t) (aux_6118);
	 }
      }
   }
}



/* object->struct-cbox-ref2036 */
obj_t 
object__struct_cbox_ref2036_107_cgen_cop(obj_t env_3974, obj_t obj1866_3975)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 101 */
      {
	 cbox_ref_44_bglt obj1866_1857;
	 obj1866_1857 =
	    (cbox_ref_44_bglt) (obj1866_3975);
	 {	/* Cgen/cop.scm 101 */
	    obj_t res1867_1860;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6132;
	       aux_6132 =
		  CNST_TABLE_REF(((long) 22));
	       res1867_1860 =
		  make_struct(aux_6132, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1867_1860, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6136;
	       aux_6136 =
		  (((cbox_ref_44_bglt) CREF(obj1866_1857))->loc);
	       STRUCT_SET(res1867_1860, ((long) 1), aux_6136);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6139;
	       {	/* Cgen/cop.scm 101 */
		  cop_bglt aux_6140;
		  aux_6140 =
		     (((cbox_ref_44_bglt) CREF(obj1866_1857))->var);
		  aux_6139 =
		     (obj_t) (aux_6140);
	       }
	       STRUCT_SET(res1867_1860, ((long) 2), aux_6139);
	    }
	    return res1867_1860;
	 }
      }
   }
}



/* struct+object->object-cbox-set!2034 */
obj_t 
struct_object__object_cbox_set_2034_241_cgen_cop(obj_t env_3976, obj_t o_3977, obj_t s_3978)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {
	 cbox_set__132_bglt o_1847;
	 obj_t s_1848;
	 {	/* Cgen/cop.scm 104 */
	    cbox_set__132_bglt aux_6145;
	    o_1847 =
	       (cbox_set__132_bglt) (o_3977);
	    s_1848 = s_3978;
	    {	/* Cgen/cop.scm 104 */
	       obj_t aux_6148;
	       object_bglt aux_6146;
	       aux_6148 =
		  STRUCT_REF(s_1848, ((long) 0));
	       aux_6146 =
		  (object_bglt) (o_1847);
	       OBJECT_WIDENING_SET(aux_6146, aux_6148);
	    }
	    {	/* Cgen/cop.scm 104 */
	       obj_t v1887_1852;
	       v1887_1852 =
		  STRUCT_REF(s_1848, ((long) 1));
	       ((((cbox_set__132_bglt) CREF(o_1847))->loc) = ((obj_t) v1887_1852), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 104 */
	       cop_bglt v1891_1853;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6153;
		  aux_6153 =
		     STRUCT_REF(s_1848, ((long) 2));
		  v1891_1853 =
		     (cop_bglt) (aux_6153);
	       }
	       ((((cbox_set__132_bglt) CREF(o_1847))->var) = ((cop_bglt) v1891_1853), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 104 */
	       cop_bglt v1895_1854;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6157;
		  aux_6157 =
		     STRUCT_REF(s_1848, ((long) 3));
		  v1895_1854 =
		     (cop_bglt) (aux_6157);
	       }
	       ((((cbox_set__132_bglt) CREF(o_1847))->value) = ((cop_bglt) v1895_1854), BUNSPEC);
	    }
	    aux_6145 = o_1847;
	    return
	       (obj_t) (aux_6145);
	 }
      }
   }
}



/* object->struct-cbox-set!2032 */
obj_t 
object__struct_cbox_set_2032_23_cgen_cop(obj_t env_3979, obj_t obj1883_3980)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 104 */
      {
	 cbox_set__132_bglt obj1883_1835;
	 obj1883_1835 =
	    (cbox_set__132_bglt) (obj1883_3980);
	 {	/* Cgen/cop.scm 104 */
	    obj_t res1884_1838;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6163;
	       aux_6163 =
		  CNST_TABLE_REF(((long) 23));
	       res1884_1838 =
		  make_struct(aux_6163, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1884_1838, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6167;
	       aux_6167 =
		  (((cbox_set__132_bglt) CREF(obj1883_1835))->loc);
	       STRUCT_SET(res1884_1838, ((long) 1), aux_6167);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6170;
	       {	/* Cgen/cop.scm 104 */
		  cop_bglt aux_6171;
		  aux_6171 =
		     (((cbox_set__132_bglt) CREF(obj1883_1835))->var);
		  aux_6170 =
		     (obj_t) (aux_6171);
	       }
	       STRUCT_SET(res1884_1838, ((long) 2), aux_6170);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6175;
	       {	/* Cgen/cop.scm 104 */
		  cop_bglt aux_6176;
		  aux_6176 =
		     (((cbox_set__132_bglt) CREF(obj1883_1835))->value);
		  aux_6175 =
		     (obj_t) (aux_6176);
	       }
	       STRUCT_SET(res1884_1838, ((long) 3), aux_6175);
	    }
	    return res1884_1838;
	 }
      }
   }
}



/* struct+object->object-cset-ex-it2030 */
obj_t 
struct_object__object_cset_ex_it2030_206_cgen_cop(obj_t env_3981, obj_t o_3982, obj_t s_3983)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {
	 cset_ex_it_123_bglt o_1824;
	 obj_t s_1825;
	 {	/* Cgen/cop.scm 108 */
	    cset_ex_it_123_bglt aux_6181;
	    o_1824 =
	       (cset_ex_it_123_bglt) (o_3982);
	    s_1825 = s_3983;
	    {	/* Cgen/cop.scm 108 */
	       obj_t aux_6184;
	       object_bglt aux_6182;
	       aux_6184 =
		  STRUCT_REF(s_1825, ((long) 0));
	       aux_6182 =
		  (object_bglt) (o_1824);
	       OBJECT_WIDENING_SET(aux_6182, aux_6184);
	    }
	    {	/* Cgen/cop.scm 108 */
	       obj_t v1910_1829;
	       v1910_1829 =
		  STRUCT_REF(s_1825, ((long) 1));
	       ((((cset_ex_it_123_bglt) CREF(o_1824))->loc) = ((obj_t) v1910_1829), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 108 */
	       cop_bglt v1914_1830;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6189;
		  aux_6189 =
		     STRUCT_REF(s_1825, ((long) 2));
		  v1914_1830 =
		     (cop_bglt) (aux_6189);
	       }
	       ((((cset_ex_it_123_bglt) CREF(o_1824))->exit) = ((cop_bglt) v1914_1830), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 108 */
	       cop_bglt v1918_1831;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6193;
		  aux_6193 =
		     STRUCT_REF(s_1825, ((long) 3));
		  v1918_1831 =
		     (cop_bglt) (aux_6193);
	       }
	       ((((cset_ex_it_123_bglt) CREF(o_1824))->jump_value_221) = ((cop_bglt) v1918_1831), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 108 */
	       cop_bglt v1922_1832;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6197;
		  aux_6197 =
		     STRUCT_REF(s_1825, ((long) 4));
		  v1922_1832 =
		     (cop_bglt) (aux_6197);
	       }
	       ((((cset_ex_it_123_bglt) CREF(o_1824))->body) = ((cop_bglt) v1922_1832), BUNSPEC);
	    }
	    aux_6181 = o_1824;
	    return
	       (obj_t) (aux_6181);
	 }
      }
   }
}



/* object->struct-cset-ex-it2028 */
obj_t 
object__struct_cset_ex_it2028_156_cgen_cop(obj_t env_3984, obj_t obj1906_3985)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 108 */
      {
	 cset_ex_it_123_bglt obj1906_1810;
	 obj1906_1810 =
	    (cset_ex_it_123_bglt) (obj1906_3985);
	 {	/* Cgen/cop.scm 108 */
	    obj_t res1907_1813;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6203;
	       aux_6203 =
		  CNST_TABLE_REF(((long) 24));
	       res1907_1813 =
		  make_struct(aux_6203, ((long) 5), BUNSPEC);
	    }
	    STRUCT_SET(res1907_1813, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6207;
	       aux_6207 =
		  (((cset_ex_it_123_bglt) CREF(obj1906_1810))->loc);
	       STRUCT_SET(res1907_1813, ((long) 1), aux_6207);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6210;
	       {	/* Cgen/cop.scm 108 */
		  cop_bglt aux_6211;
		  aux_6211 =
		     (((cset_ex_it_123_bglt) CREF(obj1906_1810))->exit);
		  aux_6210 =
		     (obj_t) (aux_6211);
	       }
	       STRUCT_SET(res1907_1813, ((long) 2), aux_6210);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6215;
	       {	/* Cgen/cop.scm 108 */
		  cop_bglt aux_6216;
		  aux_6216 =
		     (((cset_ex_it_123_bglt) CREF(obj1906_1810))->jump_value_221);
		  aux_6215 =
		     (obj_t) (aux_6216);
	       }
	       STRUCT_SET(res1907_1813, ((long) 3), aux_6215);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6220;
	       {	/* Cgen/cop.scm 108 */
		  cop_bglt aux_6221;
		  aux_6221 =
		     (((cset_ex_it_123_bglt) CREF(obj1906_1810))->body);
		  aux_6220 =
		     (obj_t) (aux_6221);
	       }
	       STRUCT_SET(res1907_1813, ((long) 4), aux_6220);
	    }
	    return res1907_1813;
	 }
      }
   }
}



/* struct+object->object-cjump-ex-it2026 */
obj_t 
struct_object__object_cjump_ex_it2026_24_cgen_cop(obj_t env_3986, obj_t o_3987, obj_t s_3988)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {
	 cjump_ex_it_131_bglt o_1800;
	 obj_t s_1801;
	 {	/* Cgen/cop.scm 113 */
	    cjump_ex_it_131_bglt aux_6226;
	    o_1800 =
	       (cjump_ex_it_131_bglt) (o_3987);
	    s_1801 = s_3988;
	    {	/* Cgen/cop.scm 113 */
	       obj_t aux_6229;
	       object_bglt aux_6227;
	       aux_6229 =
		  STRUCT_REF(s_1801, ((long) 0));
	       aux_6227 =
		  (object_bglt) (o_1800);
	       OBJECT_WIDENING_SET(aux_6227, aux_6229);
	    }
	    {	/* Cgen/cop.scm 113 */
	       obj_t v1935_1805;
	       v1935_1805 =
		  STRUCT_REF(s_1801, ((long) 1));
	       ((((cjump_ex_it_131_bglt) CREF(o_1800))->loc) = ((obj_t) v1935_1805), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 113 */
	       cop_bglt v1939_1806;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6234;
		  aux_6234 =
		     STRUCT_REF(s_1801, ((long) 2));
		  v1939_1806 =
		     (cop_bglt) (aux_6234);
	       }
	       ((((cjump_ex_it_131_bglt) CREF(o_1800))->exit) = ((cop_bglt) v1939_1806), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 113 */
	       cop_bglt v1943_1807;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6238;
		  aux_6238 =
		     STRUCT_REF(s_1801, ((long) 3));
		  v1943_1807 =
		     (cop_bglt) (aux_6238);
	       }
	       ((((cjump_ex_it_131_bglt) CREF(o_1800))->value) = ((cop_bglt) v1943_1807), BUNSPEC);
	    }
	    aux_6226 = o_1800;
	    return
	       (obj_t) (aux_6226);
	 }
      }
   }
}



/* object->struct-cjump-ex-it2024 */
obj_t 
object__struct_cjump_ex_it2024_207_cgen_cop(obj_t env_3989, obj_t obj1931_3990)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 113 */
      {
	 cjump_ex_it_131_bglt obj1931_1788;
	 obj1931_1788 =
	    (cjump_ex_it_131_bglt) (obj1931_3990);
	 {	/* Cgen/cop.scm 113 */
	    obj_t res1932_1791;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6244;
	       aux_6244 =
		  CNST_TABLE_REF(((long) 25));
	       res1932_1791 =
		  make_struct(aux_6244, ((long) 4), BUNSPEC);
	    }
	    STRUCT_SET(res1932_1791, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6248;
	       aux_6248 =
		  (((cjump_ex_it_131_bglt) CREF(obj1931_1788))->loc);
	       STRUCT_SET(res1932_1791, ((long) 1), aux_6248);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6251;
	       {	/* Cgen/cop.scm 113 */
		  cop_bglt aux_6252;
		  aux_6252 =
		     (((cjump_ex_it_131_bglt) CREF(obj1931_1788))->exit);
		  aux_6251 =
		     (obj_t) (aux_6252);
	       }
	       STRUCT_SET(res1932_1791, ((long) 2), aux_6251);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6256;
	       {	/* Cgen/cop.scm 113 */
		  cop_bglt aux_6257;
		  aux_6257 =
		     (((cjump_ex_it_131_bglt) CREF(obj1931_1788))->value);
		  aux_6256 =
		     (obj_t) (aux_6257);
	       }
	       STRUCT_SET(res1932_1791, ((long) 3), aux_6256);
	    }
	    return res1932_1791;
	 }
      }
   }
}



/* struct+object->object-sfun/c2022 */
obj_t 
struct_object__object_sfun_c2022_82_cgen_cop(obj_t env_3991, obj_t o_3992, obj_t s_3993)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {
	 sfun_c_188_bglt o_1775;
	 obj_t s_1776;
	 {	/* Cgen/cop.scm 117 */
	    sfun_c_188_bglt aux_6262;
	    o_1775 =
	       (sfun_c_188_bglt) (o_3992);
	    s_1776 = s_3993;
	    {

	       {	/* Cgen/cop.scm 117 */
		  obj_t old1967_1779;
		  obj_t aux1968_1780;
		  {	/* Cgen/cop.scm 117 */
		     obj_t next_method2021_251_1786;
		     next_method2021_251_1786 =
			find_super_class_method_167___object(
			(object_bglt) (o_1775), struct_object__object_env_209___object, sfun_c_188_cgen_cop);
		     if (
			PROCEDUREP(next_method2021_251_1786))
		       {	/* Cgen/cop.scm 117 */
			  old1967_1779 =
			     PROCEDURE_ENTRY(next_method2021_251_1786) (next_method2021_251_1786,
			     (obj_t) (o_1775), s_1776, BEOA);
		       }
		     else
		       {	/* Cgen/cop.scm 117 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method2021_251_1786);
			  {	/* Cgen/cop.scm 117 */
			     object_bglt aux_6271;
			     aux_6271 =
				struct_object__object_93___object(
				(object_bglt) (o_1775), s_1776);
			     old1967_1779 =
				(obj_t) (aux_6271);
			  }
		       }
		  }
		  aux1968_1780 =
		     STRUCT_REF(s_1776, ((long) 0));
		  {	/* Cgen/cop.scm 117 */
		     sfun_c_188_bglt new1969_1781;
		     new1969_1781 =
			((sfun_c_188_bglt) (old1967_1779));
		     {	/* Cgen/cop.scm 117 */
			long arg2426_1782;
			arg2426_1782 =
			   class_num_218___object(sfun_c_188_cgen_cop);
			{	/* Cgen/cop.scm 117 */
			   obj_t obj_2671;
			   obj_2671 =
			      (obj_t) (new1969_1781);
			   (((obj_t) CREF(obj_2671))->header = MAKE_HEADER(arg2426_1782, 0), BUNSPEC);
			}
		     }
		     {	/* Cgen/cop.scm 117 */
			sfun_c_188_bglt arg2427_1783;
			{	/* Cgen/cop.scm 117 */
			   sfun_c_188_bglt res2651_2682;
			   {	/* Cgen/cop.scm 117 */
			      clabel_bglt label_2677;
			      bool_t integrated_2678;
			      {		/* Cgen/cop.scm 117 */
				 obj_t aux_6280;
				 aux_6280 =
				    STRUCT_REF(aux1968_1780, ((long) 0));
				 label_2677 =
				    (clabel_bglt) (aux_6280);
			      }
			      {		/* Cgen/cop.scm 117 */
				 obj_t aux_6283;
				 aux_6283 =
				    STRUCT_REF(aux1968_1780, ((long) 1));
				 integrated_2678 =
				    CBOOL(aux_6283);
			      }
			      {		/* Cgen/cop.scm 117 */
				 sfun_c_188_bglt new1957_2679;
				 new1957_2679 =
				    ((sfun_c_188_bglt) BREF(GC_MALLOC(sizeof(struct sfun_c_188))));
				 ((((sfun_c_188_bglt) CREF(new1957_2679))->label) = ((clabel_bglt) label_2677), BUNSPEC);
				 ((((sfun_c_188_bglt) CREF(new1957_2679))->integrated) = ((bool_t) integrated_2678), BUNSPEC);
				 res2651_2682 = new1957_2679;
			      }
			   }
			   arg2427_1783 = res2651_2682;
			}
			{	/* Cgen/cop.scm 117 */
			   obj_t aux_6291;
			   object_bglt aux_6289;
			   aux_6291 =
			      (obj_t) (arg2427_1783);
			   aux_6289 =
			      (object_bglt) (new1969_1781);
			   OBJECT_WIDENING_SET(aux_6289, aux_6291);
			}
		     }
		     aux_6262 = new1969_1781;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_6262);
	 }
      }
   }
}



/* object->struct-sfun/c2020 */
obj_t 
object__struct_sfun_c2020_144_cgen_cop(obj_t env_3994, obj_t obj1964_3995)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 117 */
      {
	 sfun_c_188_bglt obj1964_1763;
	 obj1964_1763 =
	    (sfun_c_188_bglt) (obj1964_3995);
	 {

	    {	/* Cgen/cop.scm 117 */
	       obj_t res1965_1766;
	       {	/* Cgen/cop.scm 117 */
		  obj_t next_method2019_194_1773;
		  next_method2019_194_1773 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1964_1763), object__struct_env_210___object, sfun_c_188_cgen_cop);
		  if (
		     PROCEDUREP(next_method2019_194_1773))
		    {	/* Cgen/cop.scm 117 */
		       res1965_1766 =
			  PROCEDURE_ENTRY(next_method2019_194_1773) (next_method2019_194_1773,
			  (obj_t) (obj1964_1763), BEOA);
		    }
		  else
		    {	/* Cgen/cop.scm 117 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method2019_194_1773);
		       res1965_1766 =
			  object__struct_50___object(
			  (object_bglt) (obj1964_1763));
		    }
	       }
	       {	/* Cgen/cop.scm 117 */
		  obj_t aux1966_1767;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_6306;
		     aux_6306 =
			CNST_TABLE_REF(((long) 26));
		     aux1966_1767 =
			make_struct(aux_6306, ((long) 2), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_6309;
		     {	/* Cgen/cop.scm 117 */
			clabel_bglt aux_6310;
			{
			   obj_t aux_6311;
			   {	/* Cgen/cop.scm 118 */
			      object_bglt aux_6312;
			      aux_6312 =
				 (object_bglt) (obj1964_1763);
			      aux_6311 =
				 OBJECT_WIDENING(aux_6312);
			   }
			   aux_6310 =
			      (((sfun_c_188_bglt) CREF(aux_6311))->label);
			}
			aux_6309 =
			   (obj_t) (aux_6310);
		     }
		     STRUCT_SET(aux1966_1767, ((long) 0), aux_6309);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_6318;
		     {	/* Cgen/cop.scm 117 */
			bool_t aux_6319;
			{
			   obj_t aux_6320;
			   {	/* Cgen/cop.scm 117 */
			      object_bglt aux_6321;
			      aux_6321 =
				 (object_bglt) (obj1964_1763);
			      aux_6320 =
				 OBJECT_WIDENING(aux_6321);
			   }
			   aux_6319 =
			      (((sfun_c_188_bglt) CREF(aux_6320))->integrated);
			}
			aux_6318 =
			   BBOOL(aux_6319);
		     }
		     STRUCT_SET(aux1966_1767, ((long) 1), aux_6318);
		  }
		  STRUCT_SET(res1965_1766, ((long) 0), aux1966_1767);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_6328;
		     aux_6328 =
			STRUCT_KEY(res1965_1766);
		     STRUCT_KEY_SET(aux1966_1767, aux_6328);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_6331;
		     aux_6331 =
			CNST_TABLE_REF(((long) 26));
		     STRUCT_KEY_SET(res1965_1766, aux_6331);
		  }
		  return res1965_1766;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-bdb-block2018 */
obj_t 
struct_object__object_bdb_block2018_62_cgen_cop(obj_t env_3996, obj_t o_3997, obj_t s_3998)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {
	 bdb_block_21_bglt o_1754;
	 obj_t s_1755;
	 {	/* Cgen/cop.scm 121 */
	    bdb_block_21_bglt aux_6335;
	    o_1754 =
	       (bdb_block_21_bglt) (o_3997);
	    s_1755 = s_3998;
	    {	/* Cgen/cop.scm 121 */
	       obj_t aux_6338;
	       object_bglt aux_6336;
	       aux_6338 =
		  STRUCT_REF(s_1755, ((long) 0));
	       aux_6336 =
		  (object_bglt) (o_1754);
	       OBJECT_WIDENING_SET(aux_6336, aux_6338);
	    }
	    {	/* Cgen/cop.scm 121 */
	       obj_t v1980_1759;
	       v1980_1759 =
		  STRUCT_REF(s_1755, ((long) 1));
	       ((((bdb_block_21_bglt) CREF(o_1754))->loc) = ((obj_t) v1980_1759), BUNSPEC);
	    }
	    {	/* Cgen/cop.scm 121 */
	       cop_bglt v1984_1760;
	       {	/* ./Llib/struct.scm 1457 */
		  obj_t aux_6343;
		  aux_6343 =
		     STRUCT_REF(s_1755, ((long) 2));
		  v1984_1760 =
		     (cop_bglt) (aux_6343);
	       }
	       ((((bdb_block_21_bglt) CREF(o_1754))->body) = ((cop_bglt) v1984_1760), BUNSPEC);
	    }
	    aux_6335 = o_1754;
	    return
	       (obj_t) (aux_6335);
	 }
      }
   }
}



/* object->struct-bdb-block2016 */
obj_t 
object__struct_bdb_block2016_247_cgen_cop(obj_t env_3999, obj_t obj1976_4000)
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 121 */
      {
	 bdb_block_21_bglt obj1976_1744;
	 obj1976_1744 =
	    (bdb_block_21_bglt) (obj1976_4000);
	 {	/* Cgen/cop.scm 121 */
	    obj_t res1977_1747;
	    {	/* ./Llib/struct.scm 1415 */
	       obj_t aux_6349;
	       aux_6349 =
		  CNST_TABLE_REF(((long) 27));
	       res1977_1747 =
		  make_struct(aux_6349, ((long) 3), BUNSPEC);
	    }
	    STRUCT_SET(res1977_1747, ((long) 0), BFALSE);
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6353;
	       aux_6353 =
		  (((bdb_block_21_bglt) CREF(obj1976_1744))->loc);
	       STRUCT_SET(res1977_1747, ((long) 1), aux_6353);
	    }
	    {	/* ./Llib/struct.scm 1463 */
	       obj_t aux_6356;
	       {	/* Cgen/cop.scm 121 */
		  cop_bglt aux_6357;
		  aux_6357 =
		     (((bdb_block_21_bglt) CREF(obj1976_1744))->body);
		  aux_6356 =
		     (obj_t) (aux_6357);
	       }
	       STRUCT_SET(res1977_1747, ((long) 2), aux_6356);
	    }
	    return res1977_1747;
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cgen_cop()
{
   AN_OBJECT;
   {	/* Cgen/cop.scm 14 */
      module_initialization_70_type_type(((long) 0), "CGEN_COP");
      module_initialization_70_ast_var(((long) 0), "CGEN_COP");
      return
	 module_initialization_70_ast_node(((long) 0), "CGEN_COP");
   }
}
