/*===========================================================================*/
/*   (Cnst/alloc.scm)                                                        */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;

typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct tvec
  {
     struct type *item_type_130;
  }
    *tvec_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;


static obj_t _keyword_env__205_cnst_alloc = BUNSPEC;
static obj_t method_init_76_cnst_alloc();
extern obj_t _vector_tag_set___225_cnst_cache;
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t _symbol__163_type_cache;
extern obj_t vector__list_155___r4_vectors_6_8(obj_t);
static obj_t _old_debug__29_cnst_alloc = BUNSPEC;
extern obj_t stop_cnst_alloc__36_cnst_alloc();
static obj_t _start_cnst_alloc__241_cnst_alloc(obj_t);
static obj_t _cnst_table__103_cnst_alloc = BUNSPEC;
extern bool_t tvector_c_static__211_tvector_cnst(obj_t);
extern global_bglt def_global_scnst__93_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _shared_cnst___67_engine_param;
extern obj_t sequence_ast_node;
extern node_bglt cnst_alloc_procedure_240_cnst_alloc(node_bglt, obj_t);
extern obj_t let_var_6_ast_node;
extern obj_t var_ast_node;
static obj_t _get_cnst_set_97_cnst_alloc(obj_t);
extern obj_t start_cnst_alloc__206_cnst_alloc();
extern obj_t get_cnst_offset_21_cnst_alloc();
extern obj_t create_struct(obj_t, long);
extern obj_t _pair__244_type_cache;
extern obj_t _bdb_debug__1_engine_param;
extern obj_t gensym___r4_symbols_6_4;
extern obj_t _obj__252_type_cache;
static obj_t _cnst_alloc_tvector_13_cnst_alloc(obj_t, obj_t, obj_t);
static obj_t _anonymous_1560__239_cnst_alloc(obj_t, obj_t);
static obj_t _anonymous_1554__197_cnst_alloc(obj_t, obj_t);
static obj_t _get_cnst_sexp_123_cnst_alloc(obj_t);
static obj_t _vector_env__150_cnst_alloc = BUNSPEC;
static obj_t _anonymous_1550__232_cnst_alloc(obj_t, obj_t);
extern obj_t get_hash_29___hash(obj_t, obj_t);
extern type_bglt get_default_type_181_type_cache();
extern obj_t module_initialization_70_cnst_alloc(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_tools_shape(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_tvector_tvector(long, char *);
extern obj_t module_initialization_70_tvector_cnst(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70_ast_sexp(long, char *);
extern obj_t module_initialization_70_ast_local(long, char *);
extern obj_t module_initialization_70_ast_glo_def_117(long, char *);
extern obj_t module_initialization_70_coerce_coerce(long, char *);
extern obj_t module_initialization_70_cnst_cache(long, char *);
extern obj_t module_initialization_70_cnst_node(long, char *);
extern obj_t module_initialization_70___hash(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_equivalence_6_2(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r4_strings_6_7(long, char *);
extern obj_t module_initialization_70___r4_vectors_6_8(long, char *);
extern obj_t _bnil__15_type_cache;
static obj_t _global_sexp__67_cnst_alloc = BUNSPEC;
extern long get_hash_power_number(char *, long);
extern obj_t make_hash_table_174___hash(long, obj_t, obj_t, obj_t, obj_t);
extern local_bglt make_local_svar_140_ast_local(obj_t, type_bglt);
extern long class_num_218___object(obj_t);
static obj_t _get_cnst_offset_51_cnst_alloc(obj_t);
static obj_t _cnst_alloc_string2050_187_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t _cons__148_cnst_cache;
static app_bglt make_cnst_table_ref_93_cnst_alloc(obj_t, obj_t);
static obj_t _cnst_table_id_95_cnst_alloc(obj_t);
static obj_t imported_modules_init_94_cnst_alloc();
extern obj_t _keyword__63_type_cache;
extern node_bglt cnst_alloc_list_56_cnst_alloc(obj_t, obj_t);
static obj_t _cnst_alloc_vector2055_94_cnst_alloc(obj_t, obj_t, obj_t);
extern node_bglt cnst_alloc_real_118_cnst_alloc(obj_t, obj_t);
extern node_bglt coerce__182_coerce_coerce(node_bglt, type_bglt);
static obj_t _cnst_alloc_symbol2051_34_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t app_ast_node;
static obj_t library_modules_init_112_cnst_alloc();
static obj_t cnst_list_66_cnst_alloc(obj_t, obj_t);
extern obj_t _string__symbol__115_cnst_cache;
static obj_t typed_cnst_table_id_34_cnst_alloc();
static obj_t _get_cnst_table_79_cnst_alloc(obj_t);
extern obj_t atom_ast_node;
extern obj_t _list__vector__161_cnst_cache;
static obj_t toplevel_init_63_cnst_alloc();
static obj_t _string_env__83_cnst_alloc = BUNSPEC;
static obj_t _global_set__17_cnst_alloc = BUNSPEC;
extern obj_t open_input_string(obj_t);
extern obj_t kwote_ast_node;
static obj_t _cnst_alloc_procedure2053_227_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t _cnst_table_ref__15_cnst_cache;
static obj_t _cnst_info_cnst_76_cnst_alloc(obj_t, obj_t);
extern obj_t put_hash__129___hash(obj_t, obj_t);
static obj_t _cnst_alloc_list_46_cnst_alloc(obj_t, obj_t, obj_t);
static obj_t _symbol_env__148_cnst_alloc = BUNSPEC;
extern node_bglt cnst_alloc_tvector_190_cnst_alloc(obj_t, obj_t);
extern obj_t _bstring__127_type_cache;
extern obj_t get_cnst_sexp_197_cnst_alloc();
static obj_t loop_cnst_alloc(obj_t, obj_t);
static obj_t _real_env__85_cnst_alloc = BUNSPEC;
extern node_bglt cnst_alloc_string_41_cnst_alloc(obj_t, obj_t);
extern obj_t _init_mode__183_engine_param;
extern node_bglt cnst_alloc_symbol_123_cnst_alloc(obj_t, obj_t);
extern obj_t _compiler_debug__134_engine_param;
extern obj_t get_cnst_table_42_cnst_alloc();
extern obj_t internal_error_43_tools_error(obj_t, obj_t, obj_t);
static obj_t _list_env__66_cnst_alloc = BUNSPEC;
extern obj_t _module__166_module_module;
static long _cnst_offset__211_cnst_alloc;
extern obj_t _string__keyword__251_cnst_cache;
static obj_t cnst_info_cnst_73_cnst_alloc(obj_t);
static obj_t _cnst_alloc_keyword2052_16_cnst_alloc(obj_t, obj_t, obj_t);
static obj_t _cnst_alloc_real2054_136_cnst_alloc(obj_t, obj_t, obj_t);
extern obj_t get_cnst_set_138_cnst_alloc();
extern obj_t read___reader(obj_t);
extern obj_t cnst_table_id_232_cnst_alloc();
extern global_bglt def_global_svar__184_ast_glo_def_117(obj_t, obj_t, obj_t, obj_t);
extern obj_t _string__3_type_cache;
extern bool_t equal__25___r4_equivalence_6_2(obj_t, obj_t);
extern node_bglt cnst_alloc_vector_65_cnst_alloc(obj_t, obj_t);
static obj_t require_initialization_114_cnst_alloc = BUNSPEC;
extern obj_t _vector__240_type_cache;
extern node_bglt cnst_alloc_keyword_47_cnst_alloc(obj_t, obj_t);
extern node_bglt cnst__44_cnst_node(node_bglt);
static obj_t _stop_cnst_alloc__84_cnst_alloc(obj_t);
static obj_t cnst_init_137_cnst_alloc();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t __cnst[35];

DEFINE_EXPORT_PROCEDURE(get_cnst_set_env_67_cnst_alloc, _get_cnst_set_97_cnst_alloc2066, _get_cnst_set_97_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_string_env_66_cnst_alloc, _cnst_alloc_string2050_187_cnst_alloc2067, _cnst_alloc_string2050_187_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_procedure_env_95_cnst_alloc, _cnst_alloc_procedure2053_227_cnst_alloc2068, _cnst_alloc_procedure2053_227_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_table_id_env_96_cnst_alloc, _cnst_table_id_95_cnst_alloc2069, _cnst_table_id_95_cnst_alloc, 0L, 0);
DEFINE_STATIC_PROCEDURE(proc2058_cnst_alloc, _anonymous_1560__239_cnst_alloc2070, _anonymous_1560__239_cnst_alloc, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2057_cnst_alloc, _anonymous_1554__197_cnst_alloc2071, _anonymous_1554__197_cnst_alloc, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc2056_cnst_alloc, _anonymous_1550__232_cnst_alloc2072, _anonymous_1550__232_cnst_alloc, 0L, 1);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_vector_env_32_cnst_alloc, _cnst_alloc_vector2055_94_cnst_alloc2073, _cnst_alloc_vector2055_94_cnst_alloc, 0L, 2);
extern obj_t eq__env_189___r4_equivalence_6_2;
DEFINE_EXPORT_PROCEDURE(cnst_alloc_symbol_env_229_cnst_alloc, _cnst_alloc_symbol2051_34_cnst_alloc2074, _cnst_alloc_symbol2051_34_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(get_cnst_sexp_env_244_cnst_alloc, _get_cnst_sexp_123_cnst_alloc2075, _get_cnst_sexp_123_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_tvector_env_188_cnst_alloc, _cnst_alloc_tvector_13_cnst_alloc2076, _cnst_alloc_tvector_13_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_real_env_220_cnst_alloc, _cnst_alloc_real2054_136_cnst_alloc2077, _cnst_alloc_real2054_136_cnst_alloc, 0L, 2);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_list_env_88_cnst_alloc, _cnst_alloc_list_46_cnst_alloc2078, _cnst_alloc_list_46_cnst_alloc, 0L, 2);
DEFINE_STATIC_PROCEDURE(cnst_info_cnst_env_83_cnst_alloc, _cnst_info_cnst_76_cnst_alloc2079, _cnst_info_cnst_76_cnst_alloc, 0L, 1);
DEFINE_EXPORT_PROCEDURE(start_cnst_alloc__env_227_cnst_alloc, _start_cnst_alloc__241_cnst_alloc2080, _start_cnst_alloc__241_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(stop_cnst_alloc__env_174_cnst_alloc, _stop_cnst_alloc__84_cnst_alloc2081, _stop_cnst_alloc__84_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(get_cnst_table_env_73_cnst_alloc, _get_cnst_table_79_cnst_alloc2082, _get_cnst_table_79_cnst_alloc, 0L, 0);
DEFINE_EXPORT_PROCEDURE(cnst_alloc_keyword_env_61_cnst_alloc, _cnst_alloc_keyword2052_16_cnst_alloc2083, _cnst_alloc_keyword2052_16_cnst_alloc, 0L, 2);
DEFINE_STRING(string2061_cnst_alloc, string2061_cnst_alloc2084, "GET-TVECTOR-DESCRIPTOR TVECTOR-DESCR-SET! STVECTOR ::TVECTOR TVEC VAR ::VECTOR VECTOR CNST-LIST ::PAIR LIST SREAL ::REAL REAL SFUN ::PROCEDURE PROC A-KEYWORD ::KEYWORD KEYWORD LIB @ SET! A-SYMBOL ::SYMBOL SYMBOL CNST-INFO SSTRING ::BSTRING STRING STATIC NOW CNST-VECTOR ::CNST* __CNSTS_TABLE ", 292);
DEFINE_STRING(string2059_cnst_alloc, string2059_cnst_alloc2085, "read-alloc-tvector", 18);
DEFINE_STRING(string2060_cnst_alloc, string2060_cnst_alloc2086, "Unimplementable until bootstrap", 31);
extern obj_t string___env_211___r4_strings_6_7;
DEFINE_EXPORT_PROCEDURE(get_cnst_offset_env_123_cnst_alloc, _get_cnst_offset_51_cnst_alloc2087, _get_cnst_offset_51_cnst_alloc, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_cnst_alloc(long checksum_2688, char *from_2689)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_cnst_alloc))
	{
	   require_initialization_114_cnst_alloc =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_cnst_alloc();
	   cnst_init_137_cnst_alloc();
	   imported_modules_init_94_cnst_alloc();
	   method_init_76_cnst_alloc();
	   toplevel_init_63_cnst_alloc();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "CNST_ALLOC");
      module_initialization_70___r4_vectors_6_8(((long) 0), "CNST_ALLOC");
      module_initialization_70___hash(((long) 0), "CNST_ALLOC");
      module_initialization_70___r4_equivalence_6_2(((long) 0), "CNST_ALLOC");
      module_initialization_70___object(((long) 0), "CNST_ALLOC");
      module_initialization_70___r4_strings_6_7(((long) 0), "CNST_ALLOC");
      module_initialization_70___reader(((long) 0), "CNST_ALLOC");
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "CNST_ALLOC");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 14 */
      {		/* Cnst/alloc.scm 14 */
	 obj_t cnst_port_138_2681;
	 cnst_port_138_2681 =
	    open_input_string(string2061_cnst_alloc);
	 {
	    long i_2682;
	    i_2682 = ((long) 34);
	  loop_2683:
	    {	/* Cnst/alloc.scm 14 */
	       bool_t test2062_2684;
	       test2062_2684 =
		  (i_2682 == ((long) -1));
	       if (test2062_2684)
		 {	/* Cnst/alloc.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Cnst/alloc.scm 14 */
		    {	/* Cnst/alloc.scm 14 */
		       obj_t arg2063_2685;
		       {	/* Cnst/alloc.scm 14 */
			  obj_t list2064_2686;
			  list2064_2686 =
			     MAKE_PAIR(cnst_port_138_2681, BNIL);
			  arg2063_2685 =
			     read___reader(list2064_2686);
		       }
		       CNST_TABLE_SET(i_2682, arg2063_2685);
		    }
		    {	/* Cnst/alloc.scm 14 */
		       int aux_2687;
		       {	/* Cnst/alloc.scm 14 */
			  long aux_2712;
			  aux_2712 =
			     (i_2682 - ((long) 1));
			  aux_2687 =
			     (int) (aux_2712);
		       }
		       {
			  long i_2715;
			  i_2715 =
			     (long) (aux_2687);
			  i_2682 = i_2715;
			  goto loop_2683;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 14 */
      _cnst_table__103_cnst_alloc = BUNSPEC;
      _cnst_offset__211_cnst_alloc = ((long) -1);
      _string_env__83_cnst_alloc = BNIL;
      _real_env__85_cnst_alloc = BNIL;
      _symbol_env__148_cnst_alloc = BNIL;
      _keyword_env__205_cnst_alloc = BNIL;
      _list_env__66_cnst_alloc = BNIL;
      _vector_env__150_cnst_alloc = BNIL;
      _global_set__17_cnst_alloc = BNIL;
      _global_sexp__67_cnst_alloc = BNIL;
      return (
	 _old_debug__29_cnst_alloc = BUNSPEC, BUNSPEC);
   }
}



/* cnst-info-cnst */
obj_t 
cnst_info_cnst_73_cnst_alloc(obj_t s_18)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 51 */
      return
	 STRUCT_REF(s_18, ((long) 0));
   }
}



/* _cnst-info-cnst */
obj_t 
_cnst_info_cnst_76_cnst_alloc(obj_t env_2628, obj_t s_2629)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 51 */
      return
	 cnst_info_cnst_73_cnst_alloc(s_2629);
   }
}



/* get-cnst-offset */
obj_t 
get_cnst_offset_21_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 63 */
      return
	 BINT(_cnst_offset__211_cnst_alloc);
   }
}



/* _get-cnst-offset */
obj_t 
_get_cnst_offset_51_cnst_alloc(obj_t env_2630)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 63 */
      return
	 get_cnst_offset_21_cnst_alloc();
   }
}



/* get-cnst-set */
obj_t 
get_cnst_set_138_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 69 */
      return _global_set__17_cnst_alloc;
   }
}



/* _get-cnst-set */
obj_t 
_get_cnst_set_97_cnst_alloc(obj_t env_2631)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 69 */
      return
	 get_cnst_set_138_cnst_alloc();
   }
}



/* get-cnst-table */
obj_t 
get_cnst_table_42_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 75 */
      return _cnst_table__103_cnst_alloc;
   }
}



/* _get-cnst-table */
obj_t 
_get_cnst_table_79_cnst_alloc(obj_t env_2632)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 75 */
      return
	 get_cnst_table_42_cnst_alloc();
   }
}



/* get-cnst-sexp */
obj_t 
get_cnst_sexp_197_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 81 */
      return
	 reverse__39___r4_pairs_and_lists_6_3(_global_sexp__67_cnst_alloc);
   }
}



/* _get-cnst-sexp */
obj_t 
_get_cnst_sexp_123_cnst_alloc(obj_t env_2633)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 81 */
      return
	 get_cnst_sexp_197_cnst_alloc();
   }
}



/* cnst-table-id */
obj_t 
cnst_table_id_232_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 118 */
      return
	 CNST_TABLE_REF(((long) 0));
   }
}



/* _cnst-table-id */
obj_t 
_cnst_table_id_95_cnst_alloc(obj_t env_2634)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 118 */
      return
	 cnst_table_id_232_cnst_alloc();
   }
}



/* typed-cnst-table-id */
obj_t 
typed_cnst_table_id_34_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 124 */
      {		/* Cnst/alloc.scm 125 */
	 obj_t arg1537_843;
	 arg1537_843 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* Cnst/alloc.scm 125 */
	    obj_t list1540_845;
	    {	/* Cnst/alloc.scm 125 */
	       obj_t arg1541_846;
	       {	/* Cnst/alloc.scm 125 */
		  obj_t aux_2728;
		  aux_2728 =
		     CNST_TABLE_REF(((long) 1));
		  arg1541_846 =
		     MAKE_PAIR(aux_2728, BNIL);
	       }
	       list1540_845 =
		  MAKE_PAIR(arg1537_843, arg1541_846);
	    }
	    return
	       symbol_append_197___r4_symbols_6_4(list1540_845);
	 }
      }
   }
}



/* start-cnst-alloc! */
obj_t 
start_cnst_alloc__206_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 130 */
      _old_debug__29_cnst_alloc = _compiler_debug__134_engine_param;
      _compiler_debug__134_engine_param =
	 BINT(((long) 0));
      {		/* Cnst/alloc.scm 136 */
	 obj_t arg1543_847;
	 obj_t arg1544_848;
	 obj_t arg1545_849;
	 arg1543_847 =
	    typed_cnst_table_id_34_cnst_alloc();
	 arg1544_848 =
	    CNST_TABLE_REF(((long) 2));
	 arg1545_849 =
	    CNST_TABLE_REF(((long) 3));
	 {	/* Cnst/alloc.scm 136 */
	    global_bglt aux_2737;
	    aux_2737 =
	       def_global_svar__184_ast_glo_def_117(arg1543_847, _module__166_module_module, arg1544_848, arg1545_849);
	    _cnst_table__103_cnst_alloc =
	       (obj_t) (aux_2737);
	 }
      }
      {		/* Cnst/alloc.scm 143 */
	 bool_t test1546_850;
	 {	/* Cnst/alloc.scm 143 */
	    long n1_1694;
	    n1_1694 =
	       (long) CINT(_bdb_debug__1_engine_param);
	    test1546_850 =
	       (n1_1694 >= ((long) 3));
	 }
	 if (test1546_850)
	   {	/* Cnst/alloc.scm 144 */
	      global_bglt obj_1696;
	      obj_t val1084_1697;
	      obj_1696 =
		 (global_bglt) (_cnst_table__103_cnst_alloc);
	      val1084_1697 =
		 CNST_TABLE_REF(((long) 4));
	      ((((global_bglt) CREF(obj_1696))->import) = ((obj_t) val1084_1697), BUNSPEC);
	   }
	 else
	   {	/* Cnst/alloc.scm 143 */
	      BUNSPEC;
	   }
      }
      _cnst_offset__211_cnst_alloc = ((long) 0);
      {		/* Cnst/alloc.scm 147 */
	 obj_t _anonymous_1550__232_2637;
	 _anonymous_1550__232_2637 = proc2056_cnst_alloc;
	 _string_env__83_cnst_alloc =
	    make_hash_table_174___hash(((long) 1024), _anonymous_1550__232_2637, cnst_info_cnst_env_83_cnst_alloc, string___env_211___r4_strings_6_7, BNIL);
      }
      _real_env__85_cnst_alloc = BNIL;
      {		/* Cnst/alloc.scm 153 */
	 obj_t _anonymous_1554__197_2636;
	 _anonymous_1554__197_2636 = proc2057_cnst_alloc;
	 _symbol_env__148_cnst_alloc =
	    make_hash_table_174___hash(((long) 1024), _anonymous_1554__197_2636, cnst_info_cnst_env_83_cnst_alloc, eq__env_189___r4_equivalence_6_2, BNIL);
      }
      {		/* Cnst/alloc.scm 159 */
	 obj_t _anonymous_1560__239_2635;
	 _anonymous_1560__239_2635 = proc2058_cnst_alloc;
	 _keyword_env__205_cnst_alloc =
	    make_hash_table_174___hash(((long) 1024), _anonymous_1560__239_2635, cnst_info_cnst_env_83_cnst_alloc, eq__env_189___r4_equivalence_6_2, BNIL);
      }
      return BTRUE;
   }
}



/* _start-cnst-alloc! */
obj_t 
_start_cnst_alloc__241_cnst_alloc(obj_t env_2638)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 130 */
      return
	 start_cnst_alloc__206_cnst_alloc();
   }
}



/* <anonymous:1560> */
obj_t 
_anonymous_1560__239_cnst_alloc(obj_t env_2639, obj_t s_2640)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 158 */
      {
	 obj_t s_868;
	 {	/* Cnst/alloc.scm 159 */
	    long aux_2750;
	    s_868 = s_2640;
	    {	/* Cnst/alloc.scm 159 */
	       obj_t arg1561_1705;
	       arg1561_1705 =
		  KEYWORD_TO_STRING(s_868);
	       {	/* ./Llib/hash.scm 1789 */
		  char *aux_2752;
		  aux_2752 =
		     BSTRING_TO_STRING(arg1561_1705);
		  aux_2750 =
		     get_hash_power_number(aux_2752, ((long) 10));
	       }
	    }
	    return
	       BINT(aux_2750);
	 }
      }
   }
}



/* <anonymous:1554> */
obj_t 
_anonymous_1554__197_cnst_alloc(obj_t env_2641, obj_t s_2642)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 152 */
      {
	 obj_t s_860;
	 {	/* Cnst/alloc.scm 153 */
	    long aux_2756;
	    s_860 = s_2642;
	    {	/* Cnst/alloc.scm 153 */
	       obj_t arg1555_1700;
	       arg1555_1700 =
		  SYMBOL_TO_STRING(s_860);
	       {	/* ./Llib/hash.scm 1789 */
		  char *aux_2758;
		  aux_2758 =
		     BSTRING_TO_STRING(arg1555_1700);
		  aux_2756 =
		     get_hash_power_number(aux_2758, ((long) 10));
	       }
	    }
	    return
	       BINT(aux_2756);
	 }
      }
   }
}



/* <anonymous:1550> */
obj_t 
_anonymous_1550__232_cnst_alloc(obj_t env_2643, obj_t s_2644)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 147 */
      {
	 obj_t s_854;
	 {	/* Cnst/alloc.scm 147 */
	    long aux_2762;
	    s_854 = s_2644;
	    {	/* ./Llib/hash.scm 1789 */
	       char *aux_2763;
	       aux_2763 =
		  BSTRING_TO_STRING(s_854);
	       aux_2762 =
		  get_hash_power_number(aux_2763, ((long) 10));
	    }
	    return
	       BINT(aux_2762);
	 }
      }
   }
}



/* stop-cnst-alloc! */
obj_t 
stop_cnst_alloc__36_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 168 */
      _compiler_debug__134_engine_param = _old_debug__29_cnst_alloc;
      _string_env__83_cnst_alloc = BUNSPEC;
      _real_env__85_cnst_alloc = BUNSPEC;
      _symbol_env__148_cnst_alloc = BUNSPEC;
      _keyword_env__205_cnst_alloc = BUNSPEC;
      _list_env__66_cnst_alloc = BUNSPEC;
      _vector_env__150_cnst_alloc = BUNSPEC;
      return BTRUE;
   }
}



/* _stop-cnst-alloc! */
obj_t 
_stop_cnst_alloc__84_cnst_alloc(obj_t env_2651)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 168 */
      return
	 stop_cnst_alloc__36_cnst_alloc();
   }
}



/* make-cnst-table-ref */
app_bglt 
make_cnst_table_ref_93_cnst_alloc(obj_t offset_33, obj_t loc_34)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 181 */
      {		/* Cnst/alloc.scm 182 */
	 type_bglt arg1564_874;
	 var_bglt arg1566_876;
	 obj_t arg1567_877;
	 arg1564_874 =
	    get_default_type_181_type_cache();
	 {	/* Cnst/alloc.scm 185 */
	    type_bglt arg1569_879;
	    obj_t arg1571_880;
	    {	/* Cnst/alloc.scm 187 */
	       variable_bglt obj_1710;
	       obj_1710 =
		  (variable_bglt) (_cnst_table_ref__15_cnst_cache);
	       arg1569_879 =
		  (((variable_bglt) CREF(obj_1710))->type);
	    }
	    arg1571_880 = _cnst_table_ref__15_cnst_cache;
	    {	/* Cnst/alloc.scm 185 */
	       var_bglt res2010_1721;
	       {	/* Cnst/alloc.scm 185 */
		  variable_bglt variable_1713;
		  variable_1713 =
		     (variable_bglt) (arg1571_880);
		  {	/* ./Ast/node.scm 1530 */
		     var_bglt new1236_1714;
		     new1236_1714 =
			((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
		     {	/* ./Ast/node.scm 1530 */
			long arg1969_1715;
			arg1969_1715 =
			   class_num_218___object(var_ast_node);
			{	/* ./Ast/node.scm 1530 */
			   obj_t obj_1719;
			   obj_1719 =
			      (obj_t) (new1236_1714);
			   (((obj_t) CREF(obj_1719))->header = MAKE_HEADER(arg1969_1715, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1530 */
			object_bglt aux_2776;
			aux_2776 =
			   (object_bglt) (new1236_1714);
			OBJECT_WIDENING_SET(aux_2776, BFALSE);
		     }
		     ((((var_bglt) CREF(new1236_1714))->loc) = ((obj_t) loc_34), BUNSPEC);
		     ((((var_bglt) CREF(new1236_1714))->type) = ((type_bglt) arg1569_879), BUNSPEC);
		     ((((var_bglt) CREF(new1236_1714))->variable) = ((variable_bglt) variable_1713), BUNSPEC);
		     res2010_1721 = new1236_1714;
		  }
	       }
	       arg1566_876 = res2010_1721;
	    }
	 }
	 {	/* Cnst/alloc.scm 189 */
	    atom_bglt arg1572_881;
	    {	/* Cnst/alloc.scm 189 */
	       type_bglt arg1577_884;
	       arg1577_884 =
		  get_default_type_181_type_cache();
	       {	/* Cnst/alloc.scm 189 */
		  atom_bglt res2011_1732;
		  {	/* ./Ast/node.scm 1525 */
		     atom_bglt new1228_1725;
		     new1228_1725 =
			((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
		     {	/* ./Ast/node.scm 1525 */
			long arg1971_1726;
			arg1971_1726 =
			   class_num_218___object(atom_ast_node);
			{	/* ./Ast/node.scm 1525 */
			   obj_t obj_1730;
			   obj_1730 =
			      (obj_t) (new1228_1725);
			   (((obj_t) CREF(obj_1730))->header = MAKE_HEADER(arg1971_1726, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1525 */
			object_bglt aux_2787;
			aux_2787 =
			   (object_bglt) (new1228_1725);
			OBJECT_WIDENING_SET(aux_2787, BFALSE);
		     }
		     ((((atom_bglt) CREF(new1228_1725))->loc) = ((obj_t) loc_34), BUNSPEC);
		     ((((atom_bglt) CREF(new1228_1725))->type) = ((type_bglt) arg1577_884), BUNSPEC);
		     ((((atom_bglt) CREF(new1228_1725))->value) = ((obj_t) offset_33), BUNSPEC);
		     res2011_1732 = new1228_1725;
		  }
		  arg1572_881 = res2011_1732;
	       }
	    }
	    {	/* Cnst/alloc.scm 189 */
	       obj_t list1573_882;
	       {	/* Cnst/alloc.scm 189 */
		  obj_t aux_2793;
		  aux_2793 =
		     (obj_t) (arg1572_881);
		  list1573_882 =
		     MAKE_PAIR(aux_2793, BNIL);
	       }
	       arg1567_877 = list1573_882;
	    }
	 }
	 {	/* Cnst/alloc.scm 182 */
	    app_bglt res2012_1752;
	    {	/* Cnst/alloc.scm 182 */
	       obj_t key_1737;
	       key_1737 =
		  BINT(((long) -1));
	       {	/* ./Ast/node.scm 1547 */
		  app_bglt new1274_1741;
		  new1274_1741 =
		     ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
		  {	/* ./Ast/node.scm 1547 */
		     long arg1961_1742;
		     arg1961_1742 =
			class_num_218___object(app_ast_node);
		     {	/* ./Ast/node.scm 1547 */
			obj_t obj_1750;
			obj_1750 =
			   (obj_t) (new1274_1741);
			(((obj_t) CREF(obj_1750))->header = MAKE_HEADER(arg1961_1742, 0), BUNSPEC);
		     }
		  }
		  {	/* ./Ast/node.scm 1547 */
		     object_bglt aux_2801;
		     aux_2801 =
			(object_bglt) (new1274_1741);
		     OBJECT_WIDENING_SET(aux_2801, BFALSE);
		  }
		  ((((app_bglt) CREF(new1274_1741))->loc) = ((obj_t) loc_34), BUNSPEC);
		  ((((app_bglt) CREF(new1274_1741))->type) = ((type_bglt) arg1564_874), BUNSPEC);
		  ((((app_bglt) CREF(new1274_1741))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
		  ((((app_bglt) CREF(new1274_1741))->key) = ((obj_t) key_1737), BUNSPEC);
		  ((((app_bglt) CREF(new1274_1741))->fun) = ((var_bglt) arg1566_876), BUNSPEC);
		  ((((app_bglt) CREF(new1274_1741))->args) = ((obj_t) arg1567_877), BUNSPEC);
		  ((((app_bglt) CREF(new1274_1741))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
		  res2012_1752 = new1274_1741;
	       }
	    }
	    return res2012_1752;
	 }
      }
   }
}



/* cnst-alloc-string */
node_bglt 
cnst_alloc_string_41_cnst_alloc(obj_t string_35, obj_t loc_36)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 201 */
      {

	 {	/* Cnst/alloc.scm 215 */
	    obj_t old_887;
	    {	/* Cnst/alloc.scm 215 */
	       obj_t _andtest_1467_891;
	       _andtest_1467_891 = _shared_cnst___67_engine_param;
	       if (
		  CBOOL(_andtest_1467_891))
		 {	/* Cnst/alloc.scm 215 */
		    old_887 =
		       get_hash_29___hash(string_35, _string_env__83_cnst_alloc);
		 }
	       else
		 {	/* Cnst/alloc.scm 215 */
		    old_887 = BFALSE;
		 }
	    }
	    if (
	       CBOOL(old_887))
	      {		/* Cnst/alloc.scm 217 */
		 {	/* Cnst/alloc.scm 218 */
		    obj_t arg1580_889;
		    arg1580_889 = _bstring__127_type_cache;
		    {	/* Cnst/alloc.scm 218 */
		       var_bglt res2013_1766;
		       {	/* Cnst/alloc.scm 218 */
			  type_bglt type_1757;
			  variable_bglt variable_1758;
			  type_1757 =
			     (type_bglt) (arg1580_889);
			  {	/* Cnst/alloc.scm 218 */
			     obj_t aux_2817;
			     aux_2817 =
				STRUCT_REF(old_887, ((long) 1));
			     variable_1758 =
				(variable_bglt) (aux_2817);
			  }
			  {	/* ./Ast/node.scm 1530 */
			     var_bglt new1236_1759;
			     new1236_1759 =
				((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			     {	/* ./Ast/node.scm 1530 */
				long arg1969_1760;
				arg1969_1760 =
				   class_num_218___object(var_ast_node);
				{	/* ./Ast/node.scm 1530 */
				   obj_t obj_1764;
				   obj_1764 =
				      (obj_t) (new1236_1759);
				   (((obj_t) CREF(obj_1764))->header = MAKE_HEADER(arg1969_1760, 0), BUNSPEC);
				}
			     }
			     {	/* ./Ast/node.scm 1530 */
				object_bglt aux_2824;
				aux_2824 =
				   (object_bglt) (new1236_1759);
				OBJECT_WIDENING_SET(aux_2824, BFALSE);
			     }
			     ((((var_bglt) CREF(new1236_1759))->loc) = ((obj_t) loc_36), BUNSPEC);
			     ((((var_bglt) CREF(new1236_1759))->type) = ((type_bglt) type_1757), BUNSPEC);
			     ((((var_bglt) CREF(new1236_1759))->variable) = ((variable_bglt) variable_1758), BUNSPEC);
			     res2013_1766 = new1236_1759;
			  }
		       }
		       return
			  (node_bglt) (res2013_1766);
		    }
		 }
	      }
	    else
	      {		/* Cnst/alloc.scm 217 */
		 {	/* Cnst/alloc.scm 223 */
		    var_bglt aux_2831;
		    {	/* Cnst/alloc.scm 204 */
		       global_bglt var_893;
		       {	/* Cnst/alloc.scm 204 */
			  obj_t arg1587_898;
			  obj_t arg1588_899;
			  {	/* Cnst/alloc.scm 204 */
			     obj_t arg1589_900;
			     arg1589_900 =
				PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				CNST_TABLE_REF(((long) 5)), BEOA);
			     {	/* Cnst/alloc.scm 204 */
				obj_t list1591_902;
				{	/* Cnst/alloc.scm 204 */
				   obj_t arg1592_903;
				   {	/* Cnst/alloc.scm 204 */
				      obj_t aux_2835;
				      aux_2835 =
					 CNST_TABLE_REF(((long) 6));
				      arg1592_903 =
					 MAKE_PAIR(aux_2835, BNIL);
				   }
				   list1591_902 =
				      MAKE_PAIR(arg1589_900, arg1592_903);
				}
				arg1587_898 =
				   symbol_append_197___r4_symbols_6_4(list1591_902);
			     }
			  }
			  arg1588_899 =
			     CNST_TABLE_REF(((long) 7));
			  var_893 =
			     def_global_scnst__93_ast_glo_def_117(arg1587_898, _module__166_module_module, string_35, arg1588_899, loc_36);
		       }
		       if (
			  CBOOL(_shared_cnst___67_engine_param))
			 {	/* Cnst/alloc.scm 210 */
			    obj_t arg1583_894;
			    {	/* Cnst/alloc.scm 51 */
			       obj_t new_1769;
			       {	/* Cnst/alloc.scm 51 */
				  obj_t aux_2844;
				  aux_2844 =
				     CNST_TABLE_REF(((long) 8));
				  new_1769 =
				     create_struct(aux_2844, ((long) 2));
			       }
			       {	/* ./Llib/struct.scm 1463 */
				  obj_t aux_2847;
				  aux_2847 =
				     (obj_t) (var_893);
				  STRUCT_SET(new_1769, ((long) 1), aux_2847);
			       }
			       STRUCT_SET(new_1769, ((long) 0), string_35);
			       arg1583_894 = new_1769;
			    }
			    put_hash__129___hash(arg1583_894, _string_env__83_cnst_alloc);
			 }
		       else
			 {	/* Cnst/alloc.scm 209 */
			    BUNSPEC;
			 }
		       {	/* Cnst/alloc.scm 211 */
			  type_bglt arg1585_896;
			  {	/* Cnst/alloc.scm 213 */
			     variable_bglt obj_1780;
			     obj_1780 =
				(variable_bglt) (var_893);
			     arg1585_896 =
				(((variable_bglt) CREF(obj_1780))->type);
			  }
			  {	/* Cnst/alloc.scm 211 */
			     var_bglt res2014_1791;
			     {	/* Cnst/alloc.scm 211 */
				variable_bglt variable_1783;
				variable_1783 =
				   (variable_bglt) (var_893);
				{	/* ./Ast/node.scm 1530 */
				   var_bglt new1236_1784;
				   new1236_1784 =
				      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				   {	/* ./Ast/node.scm 1530 */
				      long arg1969_1785;
				      arg1969_1785 =
					 class_num_218___object(var_ast_node);
				      {		/* ./Ast/node.scm 1530 */
					 obj_t obj_1789;
					 obj_1789 =
					    (obj_t) (new1236_1784);
					 (((obj_t) CREF(obj_1789))->header = MAKE_HEADER(arg1969_1785, 0), BUNSPEC);
				      }
				   }
				   {	/* ./Ast/node.scm 1530 */
				      object_bglt aux_2859;
				      aux_2859 =
					 (object_bglt) (new1236_1784);
				      OBJECT_WIDENING_SET(aux_2859, BFALSE);
				   }
				   ((((var_bglt) CREF(new1236_1784))->loc) = ((obj_t) loc_36), BUNSPEC);
				   ((((var_bglt) CREF(new1236_1784))->type) = ((type_bglt) arg1585_896), BUNSPEC);
				   ((((var_bglt) CREF(new1236_1784))->variable) = ((variable_bglt) variable_1783), BUNSPEC);
				   res2014_1791 = new1236_1784;
				}
			     }
			     aux_2831 = res2014_1791;
			  }
		       }
		    }
		    return
		       (node_bglt) (aux_2831);
		 }
	      }
	 }
      }
   }
}



/* _cnst-alloc-string2050 */
obj_t 
_cnst_alloc_string2050_187_cnst_alloc(obj_t env_2652, obj_t string_2653, obj_t loc_2654)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 201 */
      {		/* Cnst/alloc.scm 201 */
	 node_bglt aux_2866;
	 aux_2866 =
	    cnst_alloc_string_41_cnst_alloc(string_2653, loc_2654);
	 return
	    (obj_t) (aux_2866);
      }
   }
}



/* cnst-alloc-symbol */
node_bglt 
cnst_alloc_symbol_123_cnst_alloc(obj_t symbol_37, obj_t loc_38)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 228 */
      {

	 {	/* Cnst/alloc.scm 260 */
	    obj_t old_907;
	    obj_t symbol_as_string_235_908;
	    old_907 =
	       get_hash_29___hash(symbol_37, _symbol_env__148_cnst_alloc);
	    symbol_as_string_235_908 =
	       SYMBOL_TO_STRING(symbol_37);
	    if (
	       CBOOL(old_907))
	      {		/* Cnst/alloc.scm 263 */
		 {	/* Cnst/alloc.scm 264 */
		    bool_t test1593_909;
		    {	/* Cnst/alloc.scm 264 */
		       obj_t obj1_1793;
		       obj1_1793 = _init_mode__183_engine_param;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_2873;
			  aux_2873 =
			     CNST_TABLE_REF(((long) 14));
			  test1593_909 =
			     (obj1_1793 == aux_2873);
		       }
		    }
		    if (test1593_909)
		      {		/* Cnst/alloc.scm 265 */
			 type_bglt arg1595_911;
			 obj_t arg1596_912;
			 arg1595_911 =
			    get_default_type_181_type_cache();
			 arg1596_912 =
			    STRUCT_REF(old_907, ((long) 1));
			 {	/* Cnst/alloc.scm 265 */
			    var_bglt res2015_1808;
			    {	/* Cnst/alloc.scm 265 */
			       variable_bglt variable_1800;
			       variable_1800 =
				  (variable_bglt) (arg1596_912);
			       {	/* ./Ast/node.scm 1530 */
				  var_bglt new1236_1801;
				  new1236_1801 =
				     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				  {	/* ./Ast/node.scm 1530 */
				     long arg1969_1802;
				     arg1969_1802 =
					class_num_218___object(var_ast_node);
				     {	/* ./Ast/node.scm 1530 */
					obj_t obj_1806;
					obj_1806 =
					   (obj_t) (new1236_1801);
					(((obj_t) CREF(obj_1806))->header = MAKE_HEADER(arg1969_1802, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Ast/node.scm 1530 */
				     object_bglt aux_2884;
				     aux_2884 =
					(object_bglt) (new1236_1801);
				     OBJECT_WIDENING_SET(aux_2884, BFALSE);
				  }
				  ((((var_bglt) CREF(new1236_1801))->loc) = ((obj_t) loc_38), BUNSPEC);
				  ((((var_bglt) CREF(new1236_1801))->type) = ((type_bglt) arg1595_911), BUNSPEC);
				  ((((var_bglt) CREF(new1236_1801))->variable) = ((variable_bglt) variable_1800), BUNSPEC);
				  res2015_1808 = new1236_1801;
			       }
			    }
			    return
			       (node_bglt) (res2015_1808);
			 }
		      }
		    else
		      {		/* Cnst/alloc.scm 269 */
			 app_bglt aux_2891;
			 aux_2891 =
			    make_cnst_table_ref_93_cnst_alloc(
			    STRUCT_REF(old_907, ((long) 1)), loc_38);
			 return
			    (node_bglt) (aux_2891);
		      }
		 }
	      }
	    else
	      {		/* Cnst/alloc.scm 270 */
		 bool_t test1598_914;
		 {	/* Cnst/alloc.scm 270 */
		    bool_t test1599_915;
		    {	/* Cnst/alloc.scm 270 */
		       obj_t obj1_1812;
		       obj1_1812 = _init_mode__183_engine_param;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_2895;
			  aux_2895 =
			     CNST_TABLE_REF(((long) 14));
			  test1599_915 =
			     (obj1_1812 == aux_2895);
		       }
		    }
		    if (test1599_915)
		      {		/* Cnst/alloc.scm 270 */
			 test1598_914 = ((bool_t) 1);
		      }
		    else
		      {		/* Cnst/alloc.scm 271 */
			 bool_t test_2899;
			 {	/* ./Ieee/fixnum.scm 7109 */
			    long aux_2900;
			    aux_2900 =
			       STRING_LENGTH(symbol_as_string_235_908);
			    test_2899 =
			       (aux_2900 == ((long) 0));
			 }
			 if (test_2899)
			   {	/* Cnst/alloc.scm 271 */
			      test1598_914 = ((bool_t) 1);
			   }
			 else
			   {	/* ./Ieee/char.scm 7775 */
			      unsigned char aux_2903;
			      aux_2903 =
				 STRING_REF(symbol_as_string_235_908, ((long) 0));
			      test1598_914 =
				 (aux_2903 == ((unsigned char) ';'));
			   }
		      }
		 }
		 if (test1598_914)
		   {	/* Cnst/alloc.scm 270 */
		      {		/* Cnst/alloc.scm 273 */
			 var_bglt aux_2907;
			 {	/* Cnst/alloc.scm 230 */
			    global_bglt var_924;
			    {	/* Cnst/alloc.scm 230 */
			       obj_t arg1638_956;
			       obj_t arg1639_957;
			       obj_t arg1640_958;
			       {	/* Cnst/alloc.scm 230 */
				  obj_t arg1641_959;
				  arg1641_959 =
				     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				     CNST_TABLE_REF(((long) 9)), BEOA);
				  {	/* Cnst/alloc.scm 230 */
				     obj_t list1643_961;
				     {	/* Cnst/alloc.scm 230 */
					obj_t arg1644_962;
					{	/* Cnst/alloc.scm 230 */
					   obj_t aux_2911;
					   aux_2911 =
					      CNST_TABLE_REF(((long) 10));
					   arg1644_962 =
					      MAKE_PAIR(aux_2911, BNIL);
					}
					list1643_961 =
					   MAKE_PAIR(arg1641_959, arg1644_962);
				     }
				     arg1638_956 =
					symbol_append_197___r4_symbols_6_4(list1643_961);
				  }
			       }
			       arg1639_957 =
				  CNST_TABLE_REF(((long) 11));
			       arg1640_958 =
				  CNST_TABLE_REF(((long) 3));
			       var_924 =
				  def_global_svar__184_ast_glo_def_117(arg1638_956, _module__166_module_module, arg1639_957, arg1640_958);
			    }
			    {	/* Cnst/alloc.scm 234 */
			       obj_t arg1607_925;
			       {	/* Cnst/alloc.scm 51 */
				  obj_t new_1840;
				  {	/* Cnst/alloc.scm 51 */
				     obj_t aux_2919;
				     aux_2919 =
					CNST_TABLE_REF(((long) 8));
				     new_1840 =
					create_struct(aux_2919, ((long) 2));
				  }
				  {	/* ./Llib/struct.scm 1463 */
				     obj_t aux_2922;
				     aux_2922 =
					(obj_t) (var_924);
				     STRUCT_SET(new_1840, ((long) 1), aux_2922);
				  }
				  STRUCT_SET(new_1840, ((long) 0), symbol_37);
				  arg1607_925 = new_1840;
			       }
			       put_hash__129___hash(arg1607_925, _symbol_env__148_cnst_alloc);
			    }
			    {	/* Cnst/alloc.scm 235 */
			       obj_t arg1608_926;
			       {	/* Cnst/alloc.scm 235 */
				  obj_t arg1609_927;
				  obj_t arg1610_928;
				  arg1609_927 =
				     CNST_TABLE_REF(((long) 12));
				  {	/* Cnst/alloc.scm 235 */
				     obj_t arg1611_929;
				     obj_t arg1612_930;
				     {	/* Cnst/alloc.scm 235 */
					obj_t arg1613_931;
					obj_t arg1614_932;
					arg1613_931 =
					   CNST_TABLE_REF(((long) 13));
					{	/* Cnst/alloc.scm 235 */
					   obj_t arg1615_933;
					   obj_t arg1616_934;
					   arg1615_933 =
					      (((global_bglt) CREF(var_924))->id);
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_2930;
					      aux_2930 =
						 (((global_bglt) CREF(var_924))->module);
					      arg1616_934 =
						 MAKE_PAIR(aux_2930, BNIL);
					   }
					   arg1614_932 =
					      MAKE_PAIR(arg1615_933, arg1616_934);
					}
					arg1611_929 =
					   MAKE_PAIR(arg1613_931, arg1614_932);
				     }
				     {	/* Cnst/alloc.scm 237 */
					node_bglt arg1619_937;
					{	/* Cnst/alloc.scm 237 */
					   app_bglt arg1621_939;
					   {	/* Cnst/alloc.scm 237 */
					      obj_t arg1623_941;
					      var_bglt arg1625_943;
					      obj_t arg1626_944;
					      arg1623_941 = _symbol__163_type_cache;
					      {		/* Cnst/alloc.scm 240 */
						 obj_t arg1628_946;
						 obj_t arg1629_947;
						 arg1628_946 = _symbol__163_type_cache;
						 arg1629_947 = _string__symbol__115_cnst_cache;
						 {	/* Cnst/alloc.scm 240 */
						    var_bglt res2016_1869;
						    {	/* Cnst/alloc.scm 240 */
						       type_bglt type_1860;
						       variable_bglt variable_1861;
						       type_1860 =
							  (type_bglt) (arg1628_946);
						       variable_1861 =
							  (variable_bglt) (arg1629_947);
						       {	/* ./Ast/node.scm 1530 */
							  var_bglt new1236_1862;
							  new1236_1862 =
							     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							  {	/* ./Ast/node.scm 1530 */
							     long arg1969_1863;
							     arg1969_1863 =
								class_num_218___object(var_ast_node);
							     {	/* ./Ast/node.scm 1530 */
								obj_t obj_1867;
								obj_1867 =
								   (obj_t) (new1236_1862);
								(((obj_t) CREF(obj_1867))->header = MAKE_HEADER(arg1969_1863, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Ast/node.scm 1530 */
							     object_bglt aux_2941;
							     aux_2941 =
								(object_bglt) (new1236_1862);
							     OBJECT_WIDENING_SET(aux_2941, BFALSE);
							  }
							  ((((var_bglt) CREF(new1236_1862))->loc) = ((obj_t) loc_38), BUNSPEC);
							  ((((var_bglt) CREF(new1236_1862))->type) = ((type_bglt) type_1860), BUNSPEC);
							  ((((var_bglt) CREF(new1236_1862))->variable) = ((variable_bglt) variable_1861), BUNSPEC);
							  res2016_1869 = new1236_1862;
						       }
						    }
						    arg1625_943 = res2016_1869;
						 }
					      }
					      {		/* Cnst/alloc.scm 244 */
						 atom_bglt arg1630_948;
						 {	/* Cnst/alloc.scm 244 */
						    obj_t arg1633_951;
						    obj_t arg1634_952;
						    arg1633_951 = _string__3_type_cache;
						    arg1634_952 =
						       SYMBOL_TO_STRING(symbol_37);
						    {	/* Cnst/alloc.scm 244 */
						       atom_bglt res2017_1881;
						       {	/* Cnst/alloc.scm 244 */
							  type_bglt type_1872;
							  type_1872 =
							     (type_bglt) (arg1633_951);
							  {	/* ./Ast/node.scm 1525 */
							     atom_bglt new1228_1874;
							     new1228_1874 =
								((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
							     {	/* ./Ast/node.scm 1525 */
								long arg1971_1875;
								arg1971_1875 =
								   class_num_218___object(atom_ast_node);
								{	/* ./Ast/node.scm 1525 */
								   obj_t obj_1879;
								   obj_1879 =
								      (obj_t) (new1228_1874);
								   (((obj_t) CREF(obj_1879))->header = MAKE_HEADER(arg1971_1875, 0), BUNSPEC);
								}
							     }
							     {	/* ./Ast/node.scm 1525 */
								object_bglt aux_2953;
								aux_2953 =
								   (object_bglt) (new1228_1874);
								OBJECT_WIDENING_SET(aux_2953, BFALSE);
							     }
							     ((((atom_bglt) CREF(new1228_1874))->loc) = ((obj_t) loc_38), BUNSPEC);
							     ((((atom_bglt) CREF(new1228_1874))->type) = ((type_bglt) type_1872), BUNSPEC);
							     ((((atom_bglt) CREF(new1228_1874))->value) = ((obj_t) arg1634_952), BUNSPEC);
							     res2017_1881 = new1228_1874;
							  }
						       }
						       arg1630_948 = res2017_1881;
						    }
						 }
						 {	/* Cnst/alloc.scm 244 */
						    obj_t list1631_949;
						    {	/* Cnst/alloc.scm 244 */
						       obj_t aux_2959;
						       aux_2959 =
							  (obj_t) (arg1630_948);
						       list1631_949 =
							  MAKE_PAIR(aux_2959, BNIL);
						    }
						    arg1626_944 = list1631_949;
						 }
					      }
					      {		/* Cnst/alloc.scm 237 */
						 app_bglt res2018_1901;
						 {	/* Cnst/alloc.scm 237 */
						    type_bglt type_1884;
						    obj_t key_1886;
						    type_1884 =
						       (type_bglt) (arg1623_941);
						    key_1886 =
						       BINT(((long) -1));
						    {	/* ./Ast/node.scm 1547 */
						       app_bglt new1274_1890;
						       new1274_1890 =
							  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
						       {	/* ./Ast/node.scm 1547 */
							  long arg1961_1891;
							  arg1961_1891 =
							     class_num_218___object(app_ast_node);
							  {	/* ./Ast/node.scm 1547 */
							     obj_t obj_1899;
							     obj_1899 =
								(obj_t) (new1274_1890);
							     (((obj_t) CREF(obj_1899))->header = MAKE_HEADER(arg1961_1891, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Ast/node.scm 1547 */
							  object_bglt aux_2968;
							  aux_2968 =
							     (object_bglt) (new1274_1890);
							  OBJECT_WIDENING_SET(aux_2968, BFALSE);
						       }
						       ((((app_bglt) CREF(new1274_1890))->loc) = ((obj_t) loc_38), BUNSPEC);
						       ((((app_bglt) CREF(new1274_1890))->type) = ((type_bglt) type_1884), BUNSPEC);
						       ((((app_bglt) CREF(new1274_1890))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						       ((((app_bglt) CREF(new1274_1890))->key) = ((obj_t) key_1886), BUNSPEC);
						       ((((app_bglt) CREF(new1274_1890))->fun) = ((var_bglt) arg1625_943), BUNSPEC);
						       ((((app_bglt) CREF(new1274_1890))->args) = ((obj_t) arg1626_944), BUNSPEC);
						       ((((app_bglt) CREF(new1274_1890))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
						       res2018_1901 = new1274_1890;
						    }
						 }
						 arg1621_939 = res2018_1901;
					      }
					   }
					   arg1619_937 =
					      coerce__182_coerce_coerce(
					      (node_bglt) (arg1621_939),
					      (type_bglt) (_obj__252_type_cache));
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_2981;
					   aux_2981 =
					      (obj_t) (arg1619_937);
					   arg1612_930 =
					      MAKE_PAIR(aux_2981, BNIL);
					}
				     }
				     arg1610_928 =
					MAKE_PAIR(arg1611_929, arg1612_930);
				  }
				  arg1608_926 =
				     MAKE_PAIR(arg1609_927, arg1610_928);
			       }
			       {	/* Cnst/alloc.scm 88 */
				  obj_t obj2_1910;
				  obj2_1910 = _global_sexp__67_cnst_alloc;
				  _global_sexp__67_cnst_alloc =
				     MAKE_PAIR(arg1608_926, obj2_1910);
			       }
			    }
			    {	/* Cnst/alloc.scm 250 */
			       type_bglt arg1636_954;
			       {	/* Cnst/alloc.scm 252 */
				  variable_bglt obj_1911;
				  obj_1911 =
				     (variable_bglt) (var_924);
				  arg1636_954 =
				     (((variable_bglt) CREF(obj_1911))->type);
			       }
			       {	/* Cnst/alloc.scm 250 */
				  var_bglt res2019_1922;
				  {	/* Cnst/alloc.scm 250 */
				     variable_bglt variable_1914;
				     variable_1914 =
					(variable_bglt) (var_924);
				     {	/* ./Ast/node.scm 1530 */
					var_bglt new1236_1915;
					new1236_1915 =
					   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					{	/* ./Ast/node.scm 1530 */
					   long arg1969_1916;
					   arg1969_1916 =
					      class_num_218___object(var_ast_node);
					   {	/* ./Ast/node.scm 1530 */
					      obj_t obj_1920;
					      obj_1920 =
						 (obj_t) (new1236_1915);
					      (((obj_t) CREF(obj_1920))->header = MAKE_HEADER(arg1969_1916, 0), BUNSPEC);
					   }
					}
					{	/* ./Ast/node.scm 1530 */
					   object_bglt aux_2994;
					   aux_2994 =
					      (object_bglt) (new1236_1915);
					   OBJECT_WIDENING_SET(aux_2994, BFALSE);
					}
					((((var_bglt) CREF(new1236_1915))->loc) = ((obj_t) loc_38), BUNSPEC);
					((((var_bglt) CREF(new1236_1915))->type) = ((type_bglt) arg1636_954), BUNSPEC);
					((((var_bglt) CREF(new1236_1915))->variable) = ((variable_bglt) variable_1914), BUNSPEC);
					res2019_1922 = new1236_1915;
				     }
				  }
				  aux_2907 = res2019_1922;
			       }
			    }
			 }
			 return
			    (node_bglt) (aux_2907);
		      }
		   }
		 else
		   {	/* Cnst/alloc.scm 270 */
		      {		/* Cnst/alloc.scm 275 */
			 app_bglt aux_3001;
			 {	/* Cnst/alloc.scm 255 */
			    long offset_921;
			    offset_921 = _cnst_offset__211_cnst_alloc;
			    {	/* Cnst/alloc.scm 256 */
			       long z2_1822;
			       z2_1822 = _cnst_offset__211_cnst_alloc;
			       _cnst_offset__211_cnst_alloc =
				  (((long) 1) + z2_1822);
			    }
			    {	/* Cnst/alloc.scm 257 */
			       obj_t obj2_1824;
			       obj2_1824 = _global_set__17_cnst_alloc;
			       _global_set__17_cnst_alloc =
				  MAKE_PAIR(symbol_37, obj2_1824);
			    }
			    {	/* Cnst/alloc.scm 258 */
			       obj_t arg1605_922;
			       {	/* Cnst/alloc.scm 51 */
				  obj_t new_1827;
				  {	/* Cnst/alloc.scm 51 */
				     obj_t aux_3004;
				     aux_3004 =
					CNST_TABLE_REF(((long) 8));
				     new_1827 =
					create_struct(aux_3004, ((long) 2));
				  }
				  {	/* ./Llib/struct.scm 1463 */
				     obj_t aux_3007;
				     aux_3007 =
					BINT(offset_921);
				     STRUCT_SET(new_1827, ((long) 1), aux_3007);
				  }
				  STRUCT_SET(new_1827, ((long) 0), symbol_37);
				  arg1605_922 = new_1827;
			       }
			       put_hash__129___hash(arg1605_922, _symbol_env__148_cnst_alloc);
			    }
			    aux_3001 =
			       make_cnst_table_ref_93_cnst_alloc(
			       BINT(offset_921), loc_38);
			 }
			 return
			    (node_bglt) (aux_3001);
		      }
		   }
	      }
	 }
      }
   }
}



/* _cnst-alloc-symbol2051 */
obj_t 
_cnst_alloc_symbol2051_34_cnst_alloc(obj_t env_2655, obj_t symbol_2656, obj_t loc_2657)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 228 */
      {		/* Cnst/alloc.scm 228 */
	 node_bglt aux_3015;
	 aux_3015 =
	    cnst_alloc_symbol_123_cnst_alloc(symbol_2656, loc_2657);
	 return
	    (obj_t) (aux_3015);
      }
   }
}



/* cnst-alloc-keyword */
node_bglt 
cnst_alloc_keyword_47_cnst_alloc(obj_t keyword_39, obj_t loc_40)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 280 */
      {

	 {	/* Cnst/alloc.scm 312 */
	    obj_t old_967;
	    obj_t keyword_as_string_123_968;
	    old_967 =
	       get_hash_29___hash(keyword_39, _keyword_env__205_cnst_alloc);
	    keyword_as_string_123_968 =
	       KEYWORD_TO_STRING(keyword_39);
	    if (
	       CBOOL(old_967))
	      {		/* Cnst/alloc.scm 315 */
		 {	/* Cnst/alloc.scm 316 */
		    bool_t test1645_969;
		    {	/* Cnst/alloc.scm 316 */
		       obj_t obj1_1924;
		       obj1_1924 = _init_mode__183_engine_param;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3022;
			  aux_3022 =
			     CNST_TABLE_REF(((long) 14));
			  test1645_969 =
			     (obj1_1924 == aux_3022);
		       }
		    }
		    if (test1645_969)
		      {		/* Cnst/alloc.scm 317 */
			 type_bglt arg1647_971;
			 obj_t arg1648_972;
			 arg1647_971 =
			    get_default_type_181_type_cache();
			 arg1648_972 =
			    STRUCT_REF(old_967, ((long) 1));
			 {	/* Cnst/alloc.scm 317 */
			    var_bglt res2020_1939;
			    {	/* Cnst/alloc.scm 317 */
			       variable_bglt variable_1931;
			       variable_1931 =
				  (variable_bglt) (arg1648_972);
			       {	/* ./Ast/node.scm 1530 */
				  var_bglt new1236_1932;
				  new1236_1932 =
				     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				  {	/* ./Ast/node.scm 1530 */
				     long arg1969_1933;
				     arg1969_1933 =
					class_num_218___object(var_ast_node);
				     {	/* ./Ast/node.scm 1530 */
					obj_t obj_1937;
					obj_1937 =
					   (obj_t) (new1236_1932);
					(((obj_t) CREF(obj_1937))->header = MAKE_HEADER(arg1969_1933, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Ast/node.scm 1530 */
				     object_bglt aux_3033;
				     aux_3033 =
					(object_bglt) (new1236_1932);
				     OBJECT_WIDENING_SET(aux_3033, BFALSE);
				  }
				  ((((var_bglt) CREF(new1236_1932))->loc) = ((obj_t) loc_40), BUNSPEC);
				  ((((var_bglt) CREF(new1236_1932))->type) = ((type_bglt) arg1647_971), BUNSPEC);
				  ((((var_bglt) CREF(new1236_1932))->variable) = ((variable_bglt) variable_1931), BUNSPEC);
				  res2020_1939 = new1236_1932;
			       }
			    }
			    return
			       (node_bglt) (res2020_1939);
			 }
		      }
		    else
		      {		/* Cnst/alloc.scm 321 */
			 app_bglt aux_3040;
			 aux_3040 =
			    make_cnst_table_ref_93_cnst_alloc(
			    STRUCT_REF(old_967, ((long) 1)), loc_40);
			 return
			    (node_bglt) (aux_3040);
		      }
		 }
	      }
	    else
	      {		/* Cnst/alloc.scm 322 */
		 bool_t test1650_974;
		 {	/* Cnst/alloc.scm 322 */
		    bool_t test1651_975;
		    {	/* Cnst/alloc.scm 322 */
		       obj_t obj1_1943;
		       obj1_1943 = _init_mode__183_engine_param;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3044;
			  aux_3044 =
			     CNST_TABLE_REF(((long) 14));
			  test1651_975 =
			     (obj1_1943 == aux_3044);
		       }
		    }
		    if (test1651_975)
		      {		/* Cnst/alloc.scm 322 */
			 test1650_974 = ((bool_t) 1);
		      }
		    else
		      {		/* Cnst/alloc.scm 323 */
			 bool_t test_3048;
			 {	/* ./Ieee/fixnum.scm 7109 */
			    long aux_3049;
			    aux_3049 =
			       STRING_LENGTH(keyword_as_string_123_968);
			    test_3048 =
			       (aux_3049 == ((long) 0));
			 }
			 if (test_3048)
			   {	/* Cnst/alloc.scm 323 */
			      test1650_974 = ((bool_t) 1);
			   }
			 else
			   {	/* ./Ieee/char.scm 7775 */
			      unsigned char aux_3052;
			      aux_3052 =
				 STRING_REF(keyword_as_string_123_968, ((long) 0));
			      test1650_974 =
				 (aux_3052 == ((unsigned char) ';'));
			   }
		      }
		 }
		 if (test1650_974)
		   {	/* Cnst/alloc.scm 322 */
		      {		/* Cnst/alloc.scm 325 */
			 var_bglt aux_3056;
			 {	/* Cnst/alloc.scm 282 */
			    global_bglt var_984;
			    {	/* Cnst/alloc.scm 282 */
			       obj_t arg1691_1016;
			       obj_t arg1692_1017;
			       obj_t arg1693_1018;
			       {	/* Cnst/alloc.scm 282 */
				  obj_t arg1694_1019;
				  arg1694_1019 =
				     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				     CNST_TABLE_REF(((long) 15)), BEOA);
				  {	/* Cnst/alloc.scm 282 */
				     obj_t list1696_1021;
				     {	/* Cnst/alloc.scm 282 */
					obj_t arg1697_1022;
					{	/* Cnst/alloc.scm 282 */
					   obj_t aux_3060;
					   aux_3060 =
					      CNST_TABLE_REF(((long) 16));
					   arg1697_1022 =
					      MAKE_PAIR(aux_3060, BNIL);
					}
					list1696_1021 =
					   MAKE_PAIR(arg1694_1019, arg1697_1022);
				     }
				     arg1691_1016 =
					symbol_append_197___r4_symbols_6_4(list1696_1021);
				  }
			       }
			       arg1692_1017 =
				  CNST_TABLE_REF(((long) 17));
			       arg1693_1018 =
				  CNST_TABLE_REF(((long) 3));
			       var_984 =
				  def_global_svar__184_ast_glo_def_117(arg1691_1016, _module__166_module_module, arg1692_1017, arg1693_1018);
			    }
			    {	/* Cnst/alloc.scm 286 */
			       obj_t arg1659_985;
			       {	/* Cnst/alloc.scm 51 */
				  obj_t new_1971;
				  {	/* Cnst/alloc.scm 51 */
				     obj_t aux_3068;
				     aux_3068 =
					CNST_TABLE_REF(((long) 8));
				     new_1971 =
					create_struct(aux_3068, ((long) 2));
				  }
				  {	/* ./Llib/struct.scm 1463 */
				     obj_t aux_3071;
				     aux_3071 =
					(obj_t) (var_984);
				     STRUCT_SET(new_1971, ((long) 1), aux_3071);
				  }
				  STRUCT_SET(new_1971, ((long) 0), keyword_39);
				  arg1659_985 = new_1971;
			       }
			       put_hash__129___hash(arg1659_985, _keyword_env__205_cnst_alloc);
			    }
			    {	/* Cnst/alloc.scm 287 */
			       obj_t arg1660_986;
			       {	/* Cnst/alloc.scm 287 */
				  obj_t arg1661_987;
				  obj_t arg1662_988;
				  arg1661_987 =
				     CNST_TABLE_REF(((long) 12));
				  {	/* Cnst/alloc.scm 287 */
				     obj_t arg1663_989;
				     obj_t arg1664_990;
				     {	/* Cnst/alloc.scm 287 */
					obj_t arg1665_991;
					obj_t arg1666_992;
					arg1665_991 =
					   CNST_TABLE_REF(((long) 13));
					{	/* Cnst/alloc.scm 287 */
					   obj_t arg1667_993;
					   obj_t arg1669_994;
					   arg1667_993 =
					      (((global_bglt) CREF(var_984))->id);
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_3079;
					      aux_3079 =
						 (((global_bglt) CREF(var_984))->module);
					      arg1669_994 =
						 MAKE_PAIR(aux_3079, BNIL);
					   }
					   arg1666_992 =
					      MAKE_PAIR(arg1667_993, arg1669_994);
					}
					arg1663_989 =
					   MAKE_PAIR(arg1665_991, arg1666_992);
				     }
				     {	/* Cnst/alloc.scm 289 */
					node_bglt arg1672_997;
					{	/* Cnst/alloc.scm 289 */
					   app_bglt arg1674_999;
					   {	/* Cnst/alloc.scm 289 */
					      obj_t arg1676_1001;
					      var_bglt arg1678_1003;
					      obj_t arg1679_1004;
					      arg1676_1001 = _keyword__63_type_cache;
					      {		/* Cnst/alloc.scm 292 */
						 obj_t arg1681_1006;
						 obj_t arg1682_1007;
						 arg1681_1006 = _keyword__63_type_cache;
						 arg1682_1007 = _string__keyword__251_cnst_cache;
						 {	/* Cnst/alloc.scm 292 */
						    var_bglt res2021_2000;
						    {	/* Cnst/alloc.scm 292 */
						       type_bglt type_1991;
						       variable_bglt variable_1992;
						       type_1991 =
							  (type_bglt) (arg1681_1006);
						       variable_1992 =
							  (variable_bglt) (arg1682_1007);
						       {	/* ./Ast/node.scm 1530 */
							  var_bglt new1236_1993;
							  new1236_1993 =
							     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
							  {	/* ./Ast/node.scm 1530 */
							     long arg1969_1994;
							     arg1969_1994 =
								class_num_218___object(var_ast_node);
							     {	/* ./Ast/node.scm 1530 */
								obj_t obj_1998;
								obj_1998 =
								   (obj_t) (new1236_1993);
								(((obj_t) CREF(obj_1998))->header = MAKE_HEADER(arg1969_1994, 0), BUNSPEC);
							     }
							  }
							  {	/* ./Ast/node.scm 1530 */
							     object_bglt aux_3090;
							     aux_3090 =
								(object_bglt) (new1236_1993);
							     OBJECT_WIDENING_SET(aux_3090, BFALSE);
							  }
							  ((((var_bglt) CREF(new1236_1993))->loc) = ((obj_t) loc_40), BUNSPEC);
							  ((((var_bglt) CREF(new1236_1993))->type) = ((type_bglt) type_1991), BUNSPEC);
							  ((((var_bglt) CREF(new1236_1993))->variable) = ((variable_bglt) variable_1992), BUNSPEC);
							  res2021_2000 = new1236_1993;
						       }
						    }
						    arg1678_1003 = res2021_2000;
						 }
					      }
					      {		/* Cnst/alloc.scm 296 */
						 atom_bglt arg1683_1008;
						 {	/* Cnst/alloc.scm 296 */
						    obj_t arg1686_1011;
						    obj_t arg1687_1012;
						    arg1686_1011 = _string__3_type_cache;
						    arg1687_1012 =
						       KEYWORD_TO_STRING(keyword_39);
						    {	/* Cnst/alloc.scm 296 */
						       atom_bglt res2022_2012;
						       {	/* Cnst/alloc.scm 296 */
							  type_bglt type_2003;
							  type_2003 =
							     (type_bglt) (arg1686_1011);
							  {	/* ./Ast/node.scm 1525 */
							     atom_bglt new1228_2005;
							     new1228_2005 =
								((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
							     {	/* ./Ast/node.scm 1525 */
								long arg1971_2006;
								arg1971_2006 =
								   class_num_218___object(atom_ast_node);
								{	/* ./Ast/node.scm 1525 */
								   obj_t obj_2010;
								   obj_2010 =
								      (obj_t) (new1228_2005);
								   (((obj_t) CREF(obj_2010))->header = MAKE_HEADER(arg1971_2006, 0), BUNSPEC);
								}
							     }
							     {	/* ./Ast/node.scm 1525 */
								object_bglt aux_3102;
								aux_3102 =
								   (object_bglt) (new1228_2005);
								OBJECT_WIDENING_SET(aux_3102, BFALSE);
							     }
							     ((((atom_bglt) CREF(new1228_2005))->loc) = ((obj_t) loc_40), BUNSPEC);
							     ((((atom_bglt) CREF(new1228_2005))->type) = ((type_bglt) type_2003), BUNSPEC);
							     ((((atom_bglt) CREF(new1228_2005))->value) = ((obj_t) arg1687_1012), BUNSPEC);
							     res2022_2012 = new1228_2005;
							  }
						       }
						       arg1683_1008 = res2022_2012;
						    }
						 }
						 {	/* Cnst/alloc.scm 296 */
						    obj_t list1684_1009;
						    {	/* Cnst/alloc.scm 296 */
						       obj_t aux_3108;
						       aux_3108 =
							  (obj_t) (arg1683_1008);
						       list1684_1009 =
							  MAKE_PAIR(aux_3108, BNIL);
						    }
						    arg1679_1004 = list1684_1009;
						 }
					      }
					      {		/* Cnst/alloc.scm 289 */
						 app_bglt res2023_2032;
						 {	/* Cnst/alloc.scm 289 */
						    type_bglt type_2015;
						    obj_t key_2017;
						    type_2015 =
						       (type_bglt) (arg1676_1001);
						    key_2017 =
						       BINT(((long) -1));
						    {	/* ./Ast/node.scm 1547 */
						       app_bglt new1274_2021;
						       new1274_2021 =
							  ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
						       {	/* ./Ast/node.scm 1547 */
							  long arg1961_2022;
							  arg1961_2022 =
							     class_num_218___object(app_ast_node);
							  {	/* ./Ast/node.scm 1547 */
							     obj_t obj_2030;
							     obj_2030 =
								(obj_t) (new1274_2021);
							     (((obj_t) CREF(obj_2030))->header = MAKE_HEADER(arg1961_2022, 0), BUNSPEC);
							  }
						       }
						       {	/* ./Ast/node.scm 1547 */
							  object_bglt aux_3117;
							  aux_3117 =
							     (object_bglt) (new1274_2021);
							  OBJECT_WIDENING_SET(aux_3117, BFALSE);
						       }
						       ((((app_bglt) CREF(new1274_2021))->loc) = ((obj_t) loc_40), BUNSPEC);
						       ((((app_bglt) CREF(new1274_2021))->type) = ((type_bglt) type_2015), BUNSPEC);
						       ((((app_bglt) CREF(new1274_2021))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
						       ((((app_bglt) CREF(new1274_2021))->key) = ((obj_t) key_2017), BUNSPEC);
						       ((((app_bglt) CREF(new1274_2021))->fun) = ((var_bglt) arg1678_1003), BUNSPEC);
						       ((((app_bglt) CREF(new1274_2021))->args) = ((obj_t) arg1679_1004), BUNSPEC);
						       ((((app_bglt) CREF(new1274_2021))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
						       res2023_2032 = new1274_2021;
						    }
						 }
						 arg1674_999 = res2023_2032;
					      }
					   }
					   arg1672_997 =
					      coerce__182_coerce_coerce(
					      (node_bglt) (arg1674_999),
					      (type_bglt) (_obj__252_type_cache));
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_3130;
					   aux_3130 =
					      (obj_t) (arg1672_997);
					   arg1664_990 =
					      MAKE_PAIR(aux_3130, BNIL);
					}
				     }
				     arg1662_988 =
					MAKE_PAIR(arg1663_989, arg1664_990);
				  }
				  arg1660_986 =
				     MAKE_PAIR(arg1661_987, arg1662_988);
			       }
			       {	/* Cnst/alloc.scm 88 */
				  obj_t obj2_2041;
				  obj2_2041 = _global_sexp__67_cnst_alloc;
				  _global_sexp__67_cnst_alloc =
				     MAKE_PAIR(arg1660_986, obj2_2041);
			       }
			    }
			    {	/* Cnst/alloc.scm 302 */
			       type_bglt arg1689_1014;
			       {	/* Cnst/alloc.scm 304 */
				  variable_bglt obj_2042;
				  obj_2042 =
				     (variable_bglt) (var_984);
				  arg1689_1014 =
				     (((variable_bglt) CREF(obj_2042))->type);
			       }
			       {	/* Cnst/alloc.scm 302 */
				  var_bglt res2024_2053;
				  {	/* Cnst/alloc.scm 302 */
				     variable_bglt variable_2045;
				     variable_2045 =
					(variable_bglt) (var_984);
				     {	/* ./Ast/node.scm 1530 */
					var_bglt new1236_2046;
					new1236_2046 =
					   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					{	/* ./Ast/node.scm 1530 */
					   long arg1969_2047;
					   arg1969_2047 =
					      class_num_218___object(var_ast_node);
					   {	/* ./Ast/node.scm 1530 */
					      obj_t obj_2051;
					      obj_2051 =
						 (obj_t) (new1236_2046);
					      (((obj_t) CREF(obj_2051))->header = MAKE_HEADER(arg1969_2047, 0), BUNSPEC);
					   }
					}
					{	/* ./Ast/node.scm 1530 */
					   object_bglt aux_3143;
					   aux_3143 =
					      (object_bglt) (new1236_2046);
					   OBJECT_WIDENING_SET(aux_3143, BFALSE);
					}
					((((var_bglt) CREF(new1236_2046))->loc) = ((obj_t) loc_40), BUNSPEC);
					((((var_bglt) CREF(new1236_2046))->type) = ((type_bglt) arg1689_1014), BUNSPEC);
					((((var_bglt) CREF(new1236_2046))->variable) = ((variable_bglt) variable_2045), BUNSPEC);
					res2024_2053 = new1236_2046;
				     }
				  }
				  aux_3056 = res2024_2053;
			       }
			    }
			 }
			 return
			    (node_bglt) (aux_3056);
		      }
		   }
		 else
		   {	/* Cnst/alloc.scm 322 */
		      {		/* Cnst/alloc.scm 327 */
			 app_bglt aux_3150;
			 {	/* Cnst/alloc.scm 307 */
			    long offset_981;
			    offset_981 = _cnst_offset__211_cnst_alloc;
			    {	/* Cnst/alloc.scm 308 */
			       long z2_1953;
			       z2_1953 = _cnst_offset__211_cnst_alloc;
			       _cnst_offset__211_cnst_alloc =
				  (((long) 1) + z2_1953);
			    }
			    {	/* Cnst/alloc.scm 309 */
			       obj_t obj2_1955;
			       obj2_1955 = _global_set__17_cnst_alloc;
			       _global_set__17_cnst_alloc =
				  MAKE_PAIR(keyword_39, obj2_1955);
			    }
			    {	/* Cnst/alloc.scm 310 */
			       obj_t arg1657_982;
			       {	/* Cnst/alloc.scm 51 */
				  obj_t new_1958;
				  {	/* Cnst/alloc.scm 51 */
				     obj_t aux_3153;
				     aux_3153 =
					CNST_TABLE_REF(((long) 8));
				     new_1958 =
					create_struct(aux_3153, ((long) 2));
				  }
				  {	/* ./Llib/struct.scm 1463 */
				     obj_t aux_3156;
				     aux_3156 =
					BINT(offset_981);
				     STRUCT_SET(new_1958, ((long) 1), aux_3156);
				  }
				  STRUCT_SET(new_1958, ((long) 0), keyword_39);
				  arg1657_982 = new_1958;
			       }
			       put_hash__129___hash(arg1657_982, _keyword_env__205_cnst_alloc);
			    }
			    aux_3150 =
			       make_cnst_table_ref_93_cnst_alloc(
			       BINT(offset_981), loc_40);
			 }
			 return
			    (node_bglt) (aux_3150);
		      }
		   }
	      }
	 }
      }
   }
}



/* _cnst-alloc-keyword2052 */
obj_t 
_cnst_alloc_keyword2052_16_cnst_alloc(obj_t env_2658, obj_t keyword_2659, obj_t loc_2660)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 280 */
      {		/* Cnst/alloc.scm 280 */
	 node_bglt aux_3164;
	 aux_3164 =
	    cnst_alloc_keyword_47_cnst_alloc(keyword_2659, loc_2660);
	 return
	    (obj_t) (aux_3164);
      }
   }
}



/* cnst-alloc-procedure */
node_bglt 
cnst_alloc_procedure_240_cnst_alloc(node_bglt procedure_41, obj_t loc_42)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 332 */
      {		/* Cnst/alloc.scm 333 */
	 global_bglt var_1025;
	 {	/* Cnst/alloc.scm 333 */
	    obj_t arg1701_1029;
	    obj_t arg1702_1030;
	    {	/* Cnst/alloc.scm 333 */
	       obj_t arg1703_1031;
	       arg1703_1031 =
		  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		  CNST_TABLE_REF(((long) 18)), BEOA);
	       {	/* Cnst/alloc.scm 333 */
		  obj_t list1705_1033;
		  {	/* Cnst/alloc.scm 333 */
		     obj_t arg1706_1034;
		     {	/* Cnst/alloc.scm 333 */
			obj_t aux_3170;
			aux_3170 =
			   CNST_TABLE_REF(((long) 19));
			arg1706_1034 =
			   MAKE_PAIR(aux_3170, BNIL);
		     }
		     list1705_1033 =
			MAKE_PAIR(arg1703_1031, arg1706_1034);
		  }
		  arg1701_1029 =
		     symbol_append_197___r4_symbols_6_4(list1705_1033);
	       }
	    }
	    arg1702_1030 =
	       CNST_TABLE_REF(((long) 20));
	    var_1025 =
	       def_global_scnst__93_ast_glo_def_117(arg1701_1029, _module__166_module_module,
	       (obj_t) (procedure_41), arg1702_1030, loc_42);
	 }
	 {	/* Cnst/alloc.scm 338 */
	    type_bglt arg1699_1027;
	    {	/* Cnst/alloc.scm 340 */
	       variable_bglt obj_2054;
	       obj_2054 =
		  (variable_bglt) (var_1025);
	       arg1699_1027 =
		  (((variable_bglt) CREF(obj_2054))->type);
	    }
	    {	/* Cnst/alloc.scm 338 */
	       var_bglt res2025_2065;
	       {	/* Cnst/alloc.scm 338 */
		  variable_bglt variable_2057;
		  variable_2057 =
		     (variable_bglt) (var_1025);
		  {	/* ./Ast/node.scm 1530 */
		     var_bglt new1236_2058;
		     new1236_2058 =
			((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
		     {	/* ./Ast/node.scm 1530 */
			long arg1969_2059;
			arg1969_2059 =
			   class_num_218___object(var_ast_node);
			{	/* ./Ast/node.scm 1530 */
			   obj_t obj_2063;
			   obj_2063 =
			      (obj_t) (new1236_2058);
			   (((obj_t) CREF(obj_2063))->header = MAKE_HEADER(arg1969_2059, 0), BUNSPEC);
			}
		     }
		     {	/* ./Ast/node.scm 1530 */
			object_bglt aux_3185;
			aux_3185 =
			   (object_bglt) (new1236_2058);
			OBJECT_WIDENING_SET(aux_3185, BFALSE);
		     }
		     ((((var_bglt) CREF(new1236_2058))->loc) = ((obj_t) loc_42), BUNSPEC);
		     ((((var_bglt) CREF(new1236_2058))->type) = ((type_bglt) arg1699_1027), BUNSPEC);
		     ((((var_bglt) CREF(new1236_2058))->variable) = ((variable_bglt) variable_2057), BUNSPEC);
		     res2025_2065 = new1236_2058;
		  }
	       }
	       return
		  (node_bglt) (res2025_2065);
	    }
	 }
      }
   }
}



/* _cnst-alloc-procedure2053 */
obj_t 
_cnst_alloc_procedure2053_227_cnst_alloc(obj_t env_2661, obj_t procedure_2662, obj_t loc_2663)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 332 */
      {		/* Cnst/alloc.scm 332 */
	 node_bglt aux_3192;
	 aux_3192 =
	    cnst_alloc_procedure_240_cnst_alloc(
	    (node_bglt) (procedure_2662), loc_2663);
	 return
	    (obj_t) (aux_3192);
      }
   }
}



/* cnst-alloc-real */
node_bglt 
cnst_alloc_real_118_cnst_alloc(obj_t real_43, obj_t loc_44)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 346 */
      {

	 {	/* Cnst/alloc.scm 367 */
	    obj_t old_1037;
	    {
	       obj_t list_1042;
	       list_1042 = _real_env__85_cnst_alloc;
	     loop_1043:
	       if (
		  NULLP(list_1042))
		 {	/* Cnst/alloc.scm 361 */
		    old_1037 = BFALSE;
		 }
	       else
		 {	/* Cnst/alloc.scm 363 */
		    bool_t test_3198;
		    {	/* ./Ieee/flonum.scm 7407 */
		       double aux_3205;
		       double aux_3199;
		       aux_3205 =
			  REAL_TO_DOUBLE(real_43);
		       {	/* Cnst/alloc.scm 363 */
			  obj_t aux_3200;
			  {	/* ./Ieee/pair-list.scm 5701 */
			     obj_t aux_3201;
			     aux_3201 =
				CAR(list_1042);
			     aux_3200 =
				CAR(aux_3201);
			  }
			  aux_3199 =
			     REAL_TO_DOUBLE(aux_3200);
		       }
		       test_3198 =
			  (aux_3199 == aux_3205);
		    }
		    if (test_3198)
		      {		/* Cnst/alloc.scm 363 */
			 {	/* ./Ieee/pair-list.scm 5707 */
			    obj_t aux_3208;
			    aux_3208 =
			       CAR(list_1042);
			    old_1037 =
			       CDR(aux_3208);
			 }
		      }
		    else
		      {		/* Cnst/alloc.scm 363 */
			 {
			    obj_t list_3211;
			    list_3211 =
			       CDR(list_1042);
			    list_1042 = list_3211;
			    goto loop_1043;
			 }
		      }
		 }
	    }
	    if (
	       CBOOL(old_1037))
	      {		/* Cnst/alloc.scm 369 */
		 {	/* Cnst/alloc.scm 370 */
		    type_bglt arg1708_1039;
		    {	/* Cnst/alloc.scm 372 */
		       variable_bglt obj_2066;
		       obj_2066 =
			  (variable_bglt) (old_1037);
		       arg1708_1039 =
			  (((variable_bglt) CREF(obj_2066))->type);
		    }
		    {	/* Cnst/alloc.scm 370 */
		       var_bglt res2026_2077;
		       {	/* Cnst/alloc.scm 370 */
			  variable_bglt variable_2069;
			  variable_2069 =
			     (variable_bglt) (old_1037);
			  {	/* ./Ast/node.scm 1530 */
			     var_bglt new1236_2070;
			     new1236_2070 =
				((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			     {	/* ./Ast/node.scm 1530 */
				long arg1969_2071;
				arg1969_2071 =
				   class_num_218___object(var_ast_node);
				{	/* ./Ast/node.scm 1530 */
				   obj_t obj_2075;
				   obj_2075 =
				      (obj_t) (new1236_2070);
				   (((obj_t) CREF(obj_2075))->header = MAKE_HEADER(arg1969_2071, 0), BUNSPEC);
				}
			     }
			     {	/* ./Ast/node.scm 1530 */
				object_bglt aux_3222;
				aux_3222 =
				   (object_bglt) (new1236_2070);
				OBJECT_WIDENING_SET(aux_3222, BFALSE);
			     }
			     ((((var_bglt) CREF(new1236_2070))->loc) = ((obj_t) loc_44), BUNSPEC);
			     ((((var_bglt) CREF(new1236_2070))->type) = ((type_bglt) arg1708_1039), BUNSPEC);
			     ((((var_bglt) CREF(new1236_2070))->variable) = ((variable_bglt) variable_2069), BUNSPEC);
			     res2026_2077 = new1236_2070;
			  }
		       }
		       return
			  (node_bglt) (res2026_2077);
		    }
		 }
	      }
	    else
	      {		/* Cnst/alloc.scm 369 */
		 {	/* Cnst/alloc.scm 375 */
		    var_bglt aux_3229;
		    {	/* Cnst/alloc.scm 348 */
		       global_bglt var_1051;
		       {	/* Cnst/alloc.scm 348 */
			  obj_t arg1722_1056;
			  obj_t arg1723_1057;
			  {	/* Cnst/alloc.scm 348 */
			     obj_t arg1724_1058;
			     arg1724_1058 =
				PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				CNST_TABLE_REF(((long) 21)), BEOA);
			     {	/* Cnst/alloc.scm 348 */
				obj_t list1726_1060;
				{	/* Cnst/alloc.scm 348 */
				   obj_t arg1727_1061;
				   {	/* Cnst/alloc.scm 348 */
				      obj_t aux_3233;
				      aux_3233 =
					 CNST_TABLE_REF(((long) 22));
				      arg1727_1061 =
					 MAKE_PAIR(aux_3233, BNIL);
				   }
				   list1726_1060 =
				      MAKE_PAIR(arg1724_1058, arg1727_1061);
				}
				arg1722_1056 =
				   symbol_append_197___r4_symbols_6_4(list1726_1060);
			     }
			  }
			  arg1723_1057 =
			     CNST_TABLE_REF(((long) 23));
			  var_1051 =
			     def_global_scnst__93_ast_glo_def_117(arg1722_1056, _module__166_module_module, real_43, arg1723_1057, loc_44);
		       }
		       {	/* Cnst/alloc.scm 353 */
			  obj_t arg1718_1052;
			  {	/* ./Ieee/pair-list.scm 5689 */
			     obj_t aux_3240;
			     aux_3240 =
				(obj_t) (var_1051);
			     arg1718_1052 =
				MAKE_PAIR(real_43, aux_3240);
			  }
			  {	/* Cnst/alloc.scm 353 */
			     obj_t obj2_2089;
			     obj2_2089 = _real_env__85_cnst_alloc;
			     _real_env__85_cnst_alloc =
				MAKE_PAIR(arg1718_1052, obj2_2089);
			  }
		       }
		       {	/* Cnst/alloc.scm 354 */
			  type_bglt arg1720_1054;
			  {	/* Cnst/alloc.scm 356 */
			     variable_bglt obj_2090;
			     obj_2090 =
				(variable_bglt) (var_1051);
			     arg1720_1054 =
				(((variable_bglt) CREF(obj_2090))->type);
			  }
			  {	/* Cnst/alloc.scm 354 */
			     var_bglt res2027_2101;
			     {	/* Cnst/alloc.scm 354 */
				variable_bglt variable_2093;
				variable_2093 =
				   (variable_bglt) (var_1051);
				{	/* ./Ast/node.scm 1530 */
				   var_bglt new1236_2094;
				   new1236_2094 =
				      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				   {	/* ./Ast/node.scm 1530 */
				      long arg1969_2095;
				      arg1969_2095 =
					 class_num_218___object(var_ast_node);
				      {		/* ./Ast/node.scm 1530 */
					 obj_t obj_2099;
					 obj_2099 =
					    (obj_t) (new1236_2094);
					 (((obj_t) CREF(obj_2099))->header = MAKE_HEADER(arg1969_2095, 0), BUNSPEC);
				      }
				   }
				   {	/* ./Ast/node.scm 1530 */
				      object_bglt aux_3251;
				      aux_3251 =
					 (object_bglt) (new1236_2094);
				      OBJECT_WIDENING_SET(aux_3251, BFALSE);
				   }
				   ((((var_bglt) CREF(new1236_2094))->loc) = ((obj_t) loc_44), BUNSPEC);
				   ((((var_bglt) CREF(new1236_2094))->type) = ((type_bglt) arg1720_1054), BUNSPEC);
				   ((((var_bglt) CREF(new1236_2094))->variable) = ((variable_bglt) variable_2093), BUNSPEC);
				   res2027_2101 = new1236_2094;
				}
			     }
			     aux_3229 = res2027_2101;
			  }
		       }
		    }
		    return
		       (node_bglt) (aux_3229);
		 }
	      }
	 }
      }
   }
}



/* _cnst-alloc-real2054 */
obj_t 
_cnst_alloc_real2054_136_cnst_alloc(obj_t env_2664, obj_t real_2665, obj_t loc_2666)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 346 */
      {		/* Cnst/alloc.scm 346 */
	 node_bglt aux_3258;
	 aux_3258 =
	    cnst_alloc_real_118_cnst_alloc(real_2665, loc_2666);
	 return
	    (obj_t) (aux_3258);
      }
   }
}



/* cnst-alloc-list */
node_bglt 
cnst_alloc_list_56_cnst_alloc(obj_t pair_45, obj_t loc_46)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 380 */
      {

	 {	/* Cnst/alloc.scm 424 */
	    obj_t old_1067;
	    {	/* Cnst/alloc.scm 424 */
	       obj_t _andtest_1488_1074;
	       _andtest_1488_1074 = _shared_cnst___67_engine_param;
	       if (
		  CBOOL(_andtest_1488_1074))
		 {
		    obj_t env_1075;
		    env_1075 = _list_env__66_cnst_alloc;
		  loop_1076:
		    if (
		       NULLP(env_1075))
		      {		/* Cnst/alloc.scm 427 */
			 old_1067 = BFALSE;
		      }
		    else
		      {		/* Cnst/alloc.scm 429 */
			 bool_t test_3265;
			 {	/* Cnst/alloc.scm 429 */
			    obj_t aux_3266;
			    {	/* ./Llib/struct.scm 1457 */
			       obj_t aux_3267;
			       aux_3267 =
				  CAR(env_1075);
			       aux_3266 =
				  STRUCT_REF(aux_3267, ((long) 0));
			    }
			    test_3265 =
			       equal__25___r4_equivalence_6_2(aux_3266, pair_45);
			 }
			 if (test_3265)
			   {	/* Cnst/alloc.scm 429 */
			      old_1067 =
				 CAR(env_1075);
			   }
			 else
			   {	/* Cnst/alloc.scm 429 */
			      {
				 obj_t env_3272;
				 env_3272 =
				    CDR(env_1075);
				 env_1075 = env_3272;
				 goto loop_1076;
			      }
			   }
		      }
		 }
	       else
		 {	/* Cnst/alloc.scm 424 */
		    old_1067 = BFALSE;
		 }
	    }
	    if (
	       CBOOL(old_1067))
	      {		/* Cnst/alloc.scm 434 */
		 {	/* Cnst/alloc.scm 435 */
		    bool_t test1728_1068;
		    {	/* Cnst/alloc.scm 435 */
		       obj_t obj1_2109;
		       obj1_2109 = _init_mode__183_engine_param;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3276;
			  aux_3276 =
			     CNST_TABLE_REF(((long) 14));
			  test1728_1068 =
			     (obj1_2109 == aux_3276);
		       }
		    }
		    if (test1728_1068)
		      {		/* Cnst/alloc.scm 436 */
			 type_bglt arg1730_1070;
			 obj_t arg1731_1071;
			 arg1730_1070 =
			    get_default_type_181_type_cache();
			 arg1731_1071 =
			    STRUCT_REF(old_1067, ((long) 1));
			 {	/* Cnst/alloc.scm 436 */
			    var_bglt res2028_2124;
			    {	/* Cnst/alloc.scm 436 */
			       variable_bglt variable_2116;
			       variable_2116 =
				  (variable_bglt) (arg1731_1071);
			       {	/* ./Ast/node.scm 1530 */
				  var_bglt new1236_2117;
				  new1236_2117 =
				     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				  {	/* ./Ast/node.scm 1530 */
				     long arg1969_2118;
				     arg1969_2118 =
					class_num_218___object(var_ast_node);
				     {	/* ./Ast/node.scm 1530 */
					obj_t obj_2122;
					obj_2122 =
					   (obj_t) (new1236_2117);
					(((obj_t) CREF(obj_2122))->header = MAKE_HEADER(arg1969_2118, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Ast/node.scm 1530 */
				     object_bglt aux_3287;
				     aux_3287 =
					(object_bglt) (new1236_2117);
				     OBJECT_WIDENING_SET(aux_3287, BFALSE);
				  }
				  ((((var_bglt) CREF(new1236_2117))->loc) = ((obj_t) loc_46), BUNSPEC);
				  ((((var_bglt) CREF(new1236_2117))->type) = ((type_bglt) arg1730_1070), BUNSPEC);
				  ((((var_bglt) CREF(new1236_2117))->variable) = ((variable_bglt) variable_2116), BUNSPEC);
				  res2028_2124 = new1236_2117;
			       }
			    }
			    return
			       (node_bglt) (res2028_2124);
			 }
		      }
		    else
		      {		/* Cnst/alloc.scm 440 */
			 app_bglt aux_3294;
			 aux_3294 =
			    make_cnst_table_ref_93_cnst_alloc(
			    STRUCT_REF(old_1067, ((long) 1)), loc_46);
			 return
			    (node_bglt) (aux_3294);
		      }
		 }
	      }
	    else
	      {		/* Cnst/alloc.scm 441 */
		 bool_t test1733_1073;
		 {	/* Cnst/alloc.scm 441 */
		    obj_t obj1_2128;
		    obj1_2128 = _init_mode__183_engine_param;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_3298;
		       aux_3298 =
			  CNST_TABLE_REF(((long) 14));
		       test1733_1073 =
			  (obj1_2128 == aux_3298);
		    }
		 }
		 if (test1733_1073)
		   {	/* Cnst/alloc.scm 441 */
		      {		/* Cnst/alloc.scm 442 */
			 var_bglt aux_3302;
			 {	/* Cnst/alloc.scm 405 */
			    global_bglt var_1086;
			    {	/* Cnst/alloc.scm 405 */
			       obj_t arg1762_1105;
			       obj_t arg1763_1106;
			       obj_t arg1764_1107;
			       {	/* Cnst/alloc.scm 405 */
				  obj_t arg1765_1108;
				  arg1765_1108 =
				     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				     CNST_TABLE_REF(((long) 24)), BEOA);
				  {	/* Cnst/alloc.scm 405 */
				     obj_t list1767_1110;
				     {	/* Cnst/alloc.scm 405 */
					obj_t arg1768_1111;
					{	/* Cnst/alloc.scm 405 */
					   obj_t aux_3306;
					   aux_3306 =
					      CNST_TABLE_REF(((long) 25));
					   arg1768_1111 =
					      MAKE_PAIR(aux_3306, BNIL);
					}
					list1767_1110 =
					   MAKE_PAIR(arg1765_1108, arg1768_1111);
				     }
				     arg1762_1105 =
					symbol_append_197___r4_symbols_6_4(list1767_1110);
				  }
			       }
			       arg1763_1106 =
				  CNST_TABLE_REF(((long) 26));
			       arg1764_1107 =
				  CNST_TABLE_REF(((long) 3));
			       var_1086 =
				  def_global_svar__184_ast_glo_def_117(arg1762_1105, _module__166_module_module, arg1763_1106, arg1764_1107);
			    }
			    if (
			       CBOOL(_shared_cnst___67_engine_param))
			      {		/* Cnst/alloc.scm 410 */
				 obj_t arg1743_1087;
				 {	/* Cnst/alloc.scm 51 */
				    obj_t new_2151;
				    {	/* Cnst/alloc.scm 51 */
				       obj_t aux_3316;
				       aux_3316 =
					  CNST_TABLE_REF(((long) 8));
				       new_2151 =
					  create_struct(aux_3316, ((long) 2));
				    }
				    {	/* ./Llib/struct.scm 1463 */
				       obj_t aux_3319;
				       aux_3319 =
					  (obj_t) (var_1086);
				       STRUCT_SET(new_2151, ((long) 1), aux_3319);
				    }
				    STRUCT_SET(new_2151, ((long) 0), pair_45);
				    arg1743_1087 = new_2151;
				 }
				 {	/* Cnst/alloc.scm 410 */
				    obj_t obj2_2163;
				    obj2_2163 = _list_env__66_cnst_alloc;
				    _list_env__66_cnst_alloc =
				       MAKE_PAIR(arg1743_1087, obj2_2163);
				 }
			      }
			    else
			      {		/* Cnst/alloc.scm 409 */
				 BUNSPEC;
			      }
			    {	/* Cnst/alloc.scm 411 */
			       obj_t arg1744_1088;
			       {	/* Cnst/alloc.scm 411 */
				  obj_t arg1745_1089;
				  obj_t arg1746_1090;
				  arg1745_1089 =
				     CNST_TABLE_REF(((long) 12));
				  {	/* Cnst/alloc.scm 411 */
				     obj_t arg1747_1091;
				     obj_t arg1748_1092;
				     {	/* Cnst/alloc.scm 411 */
					obj_t arg1749_1093;
					obj_t arg1750_1094;
					arg1749_1093 =
					   CNST_TABLE_REF(((long) 13));
					{	/* Cnst/alloc.scm 411 */
					   obj_t arg1751_1095;
					   obj_t arg1752_1096;
					   arg1751_1095 =
					      (((global_bglt) CREF(var_1086))->id);
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_3327;
					      aux_3327 =
						 (((global_bglt) CREF(var_1086))->module);
					      arg1752_1096 =
						 MAKE_PAIR(aux_3327, BNIL);
					   }
					   arg1750_1094 =
					      MAKE_PAIR(arg1751_1095, arg1752_1096);
					}
					arg1747_1091 =
					   MAKE_PAIR(arg1749_1093, arg1750_1094);
				     }
				     {	/* Cnst/alloc.scm 412 */
					node_bglt arg1755_1099;
					{	/* Cnst/alloc.scm 412 */
					   obj_t arg1758_1101;
					   arg1758_1101 =
					      cnst_list_66_cnst_alloc(loc_46, pair_45);
					   arg1755_1099 =
					      coerce__182_coerce_coerce(
					      (node_bglt) (arg1758_1101),
					      (type_bglt) (_obj__252_type_cache));
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_3336;
					   aux_3336 =
					      (obj_t) (arg1755_1099);
					   arg1748_1092 =
					      MAKE_PAIR(aux_3336, BNIL);
					}
				     }
				     arg1746_1090 =
					MAKE_PAIR(arg1747_1091, arg1748_1092);
				  }
				  arg1744_1088 =
				     MAKE_PAIR(arg1745_1089, arg1746_1090);
			       }
			       {	/* Cnst/alloc.scm 88 */
				  obj_t obj2_2180;
				  obj2_2180 = _global_sexp__67_cnst_alloc;
				  _global_sexp__67_cnst_alloc =
				     MAKE_PAIR(arg1744_1088, obj2_2180);
			       }
			    }
			    {	/* Cnst/alloc.scm 413 */
			       type_bglt arg1760_1103;
			       {	/* Cnst/alloc.scm 415 */
				  variable_bglt obj_2181;
				  obj_2181 =
				     (variable_bglt) (var_1086);
				  arg1760_1103 =
				     (((variable_bglt) CREF(obj_2181))->type);
			       }
			       {	/* Cnst/alloc.scm 413 */
				  var_bglt res2029_2192;
				  {	/* Cnst/alloc.scm 413 */
				     variable_bglt variable_2184;
				     variable_2184 =
					(variable_bglt) (var_1086);
				     {	/* ./Ast/node.scm 1530 */
					var_bglt new1236_2185;
					new1236_2185 =
					   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					{	/* ./Ast/node.scm 1530 */
					   long arg1969_2186;
					   arg1969_2186 =
					      class_num_218___object(var_ast_node);
					   {	/* ./Ast/node.scm 1530 */
					      obj_t obj_2190;
					      obj_2190 =
						 (obj_t) (new1236_2185);
					      (((obj_t) CREF(obj_2190))->header = MAKE_HEADER(arg1969_2186, 0), BUNSPEC);
					   }
					}
					{	/* ./Ast/node.scm 1530 */
					   object_bglt aux_3349;
					   aux_3349 =
					      (object_bglt) (new1236_2185);
					   OBJECT_WIDENING_SET(aux_3349, BFALSE);
					}
					((((var_bglt) CREF(new1236_2185))->loc) = ((obj_t) loc_46), BUNSPEC);
					((((var_bglt) CREF(new1236_2185))->type) = ((type_bglt) arg1760_1103), BUNSPEC);
					((((var_bglt) CREF(new1236_2185))->variable) = ((variable_bglt) variable_2184), BUNSPEC);
					res2029_2192 = new1236_2185;
				     }
				  }
				  aux_3302 = res2029_2192;
			       }
			    }
			 }
			 return
			    (node_bglt) (aux_3302);
		      }
		   }
		 else
		   {	/* Cnst/alloc.scm 441 */
		      {		/* Cnst/alloc.scm 444 */
			 app_bglt aux_3356;
			 {	/* Cnst/alloc.scm 418 */
			    long offset_1083;
			    offset_1083 = _cnst_offset__211_cnst_alloc;
			    {	/* Cnst/alloc.scm 419 */
			       long z2_2131;
			       z2_2131 = _cnst_offset__211_cnst_alloc;
			       _cnst_offset__211_cnst_alloc =
				  (((long) 1) + z2_2131);
			    }
			    {	/* Cnst/alloc.scm 420 */
			       obj_t obj2_2133;
			       obj2_2133 = _global_set__17_cnst_alloc;
			       _global_set__17_cnst_alloc =
				  MAKE_PAIR(pair_45, obj2_2133);
			    }
			    if (
			       CBOOL(_shared_cnst___67_engine_param))
			      {		/* Cnst/alloc.scm 422 */
				 obj_t arg1741_1084;
				 {	/* Cnst/alloc.scm 51 */
				    obj_t new_2136;
				    {	/* Cnst/alloc.scm 51 */
				       obj_t aux_3361;
				       aux_3361 =
					  CNST_TABLE_REF(((long) 8));
				       new_2136 =
					  create_struct(aux_3361, ((long) 2));
				    }
				    {	/* ./Llib/struct.scm 1463 */
				       obj_t aux_3364;
				       aux_3364 =
					  BINT(offset_1083);
				       STRUCT_SET(new_2136, ((long) 1), aux_3364);
				    }
				    STRUCT_SET(new_2136, ((long) 0), pair_45);
				    arg1741_1084 = new_2136;
				 }
				 {	/* Cnst/alloc.scm 422 */
				    obj_t obj2_2148;
				    obj2_2148 = _list_env__66_cnst_alloc;
				    _list_env__66_cnst_alloc =
				       MAKE_PAIR(arg1741_1084, obj2_2148);
				 }
			      }
			    else
			      {		/* Cnst/alloc.scm 421 */
				 BUNSPEC;
			      }
			    aux_3356 =
			       make_cnst_table_ref_93_cnst_alloc(
			       BINT(offset_1083), loc_46);
			 }
			 return
			    (node_bglt) (aux_3356);
		      }
		   }
	      }
	 }
      }
   }
}



/* cnst-list */
obj_t 
cnst_list_66_cnst_alloc(obj_t loc_2676, obj_t pair_1112)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 381 */
      return
	 loop_cnst_alloc(loc_2676, pair_1112);
   }
}



/* loop */
obj_t 
loop_cnst_alloc(obj_t loc_2677, obj_t pair_1114)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 382 */
      if (
	 NULLP(pair_1114))
	{	/* Cnst/alloc.scm 384 */
	   {	/* Cnst/alloc.scm 385 */
	      obj_t arg1772_1118;
	      arg1772_1118 = _bnil__15_type_cache;
	      {		/* Cnst/alloc.scm 385 */
		 atom_bglt res2030_2204;
		 {	/* Cnst/alloc.scm 385 */
		    type_bglt type_2195;
		    type_2195 =
		       (type_bglt) (arg1772_1118);
		    {	/* ./Ast/node.scm 1525 */
		       atom_bglt new1228_2197;
		       new1228_2197 =
			  ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
		       {	/* ./Ast/node.scm 1525 */
			  long arg1971_2198;
			  arg1971_2198 =
			     class_num_218___object(atom_ast_node);
			  {	/* ./Ast/node.scm 1525 */
			     obj_t obj_2202;
			     obj_2202 =
				(obj_t) (new1228_2197);
			     (((obj_t) CREF(obj_2202))->header = MAKE_HEADER(arg1971_2198, 0), BUNSPEC);
			  }
		       }
		       {	/* ./Ast/node.scm 1525 */
			  object_bglt aux_3380;
			  aux_3380 =
			     (object_bglt) (new1228_2197);
			  OBJECT_WIDENING_SET(aux_3380, BFALSE);
		       }
		       ((((atom_bglt) CREF(new1228_2197))->loc) = ((obj_t) loc_2677), BUNSPEC);
		       ((((atom_bglt) CREF(new1228_2197))->type) = ((type_bglt) type_2195), BUNSPEC);
		       ((((atom_bglt) CREF(new1228_2197))->value) = ((obj_t) BNIL), BUNSPEC);
		       res2030_2204 = new1228_2197;
		    }
		 }
		 return
		    (obj_t) (res2030_2204);
	      }
	   }
	}
      else
	{	/* Cnst/alloc.scm 384 */
	   if (
	      PAIRP(pair_1114))
	     {	/* Cnst/alloc.scm 386 */
		{	/* Cnst/alloc.scm 392 */
		   obj_t arg1776_1122;
		   var_bglt arg1778_1124;
		   obj_t arg1779_1125;
		   arg1776_1122 = _pair__244_type_cache;
		   {	/* Cnst/alloc.scm 395 */
		      type_bglt arg1781_1127;
		      obj_t arg1782_1128;
		      {		/* Cnst/alloc.scm 397 */
			 variable_bglt obj_2206;
			 obj_2206 =
			    (variable_bglt) (_cons__148_cnst_cache);
			 arg1781_1127 =
			    (((variable_bglt) CREF(obj_2206))->type);
		      }
		      arg1782_1128 = _cons__148_cnst_cache;
		      {		/* Cnst/alloc.scm 395 */
			 var_bglt res2031_2217;
			 {	/* Cnst/alloc.scm 395 */
			    variable_bglt variable_2209;
			    variable_2209 =
			       (variable_bglt) (arg1782_1128);
			    {	/* ./Ast/node.scm 1530 */
			       var_bglt new1236_2210;
			       new1236_2210 =
				  ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
			       {	/* ./Ast/node.scm 1530 */
				  long arg1969_2211;
				  arg1969_2211 =
				     class_num_218___object(var_ast_node);
				  {	/* ./Ast/node.scm 1530 */
				     obj_t obj_2215;
				     obj_2215 =
					(obj_t) (new1236_2210);
				     (((obj_t) CREF(obj_2215))->header = MAKE_HEADER(arg1969_2211, 0), BUNSPEC);
				  }
			       }
			       {	/* ./Ast/node.scm 1530 */
				  object_bglt aux_3396;
				  aux_3396 =
				     (object_bglt) (new1236_2210);
				  OBJECT_WIDENING_SET(aux_3396, BFALSE);
			       }
			       ((((var_bglt) CREF(new1236_2210))->loc) = ((obj_t) loc_2677), BUNSPEC);
			       ((((var_bglt) CREF(new1236_2210))->type) = ((type_bglt) arg1781_1127), BUNSPEC);
			       ((((var_bglt) CREF(new1236_2210))->variable) = ((variable_bglt) variable_2209), BUNSPEC);
			       res2031_2217 = new1236_2210;
			    }
			 }
			 arg1778_1124 = res2031_2217;
		      }
		   }
		   {	/* Cnst/alloc.scm 399 */
		      node_bglt arg1783_1129;
		      obj_t arg1784_1130;
		      {		/* Cnst/alloc.scm 399 */
			 kwote_bglt arg1787_1133;
			 {	/* Cnst/alloc.scm 399 */
			    type_bglt arg1789_1135;
			    obj_t arg1790_1136;
			    arg1789_1135 =
			       get_default_type_181_type_cache();
			    arg1790_1136 =
			       CAR(pair_1114);
			    {	/* Cnst/alloc.scm 399 */
			       kwote_bglt res2032_2229;
			       {	/* ./Ast/node.scm 1538 */
				  kwote_bglt new1251_2222;
				  new1251_2222 =
				     ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
				  {	/* ./Ast/node.scm 1538 */
				     long arg1965_2223;
				     arg1965_2223 =
					class_num_218___object(kwote_ast_node);
				     {	/* ./Ast/node.scm 1538 */
					obj_t obj_2227;
					obj_2227 =
					   (obj_t) (new1251_2222);
					(((obj_t) CREF(obj_2227))->header = MAKE_HEADER(arg1965_2223, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Ast/node.scm 1538 */
				     object_bglt aux_3408;
				     aux_3408 =
					(object_bglt) (new1251_2222);
				     OBJECT_WIDENING_SET(aux_3408, BFALSE);
				  }
				  ((((kwote_bglt) CREF(new1251_2222))->loc) = ((obj_t) loc_2677), BUNSPEC);
				  ((((kwote_bglt) CREF(new1251_2222))->type) = ((type_bglt) arg1789_1135), BUNSPEC);
				  ((((kwote_bglt) CREF(new1251_2222))->value) = ((obj_t) arg1790_1136), BUNSPEC);
				  res2032_2229 = new1251_2222;
			       }
			       arg1787_1133 = res2032_2229;
			    }
			 }
			 arg1783_1129 =
			    cnst__44_cnst_node(
			    (node_bglt) (arg1787_1133));
		      }
		      arg1784_1130 =
			 loop_cnst_alloc(loc_2677,
			 CDR(pair_1114));
		      {		/* Cnst/alloc.scm 399 */
			 obj_t list1785_1131;
			 {	/* Cnst/alloc.scm 399 */
			    obj_t arg1786_1132;
			    arg1786_1132 =
			       MAKE_PAIR(arg1784_1130, BNIL);
			    {	/* Cnst/alloc.scm 399 */
			       obj_t aux_3419;
			       aux_3419 =
				  (obj_t) (arg1783_1129);
			       list1785_1131 =
				  MAKE_PAIR(aux_3419, arg1786_1132);
			    }
			 }
			 arg1779_1125 = list1785_1131;
		      }
		   }
		   {	/* Cnst/alloc.scm 392 */
		      app_bglt res2033_2250;
		      {		/* Cnst/alloc.scm 392 */
			 type_bglt type_2233;
			 obj_t key_2235;
			 type_2233 =
			    (type_bglt) (arg1776_1122);
			 key_2235 =
			    BINT(((long) -1));
			 {	/* ./Ast/node.scm 1547 */
			    app_bglt new1274_2239;
			    new1274_2239 =
			       ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
			    {	/* ./Ast/node.scm 1547 */
			       long arg1961_2240;
			       arg1961_2240 =
				  class_num_218___object(app_ast_node);
			       {	/* ./Ast/node.scm 1547 */
				  obj_t obj_2248;
				  obj_2248 =
				     (obj_t) (new1274_2239);
				  (((obj_t) CREF(obj_2248))->header = MAKE_HEADER(arg1961_2240, 0), BUNSPEC);
			       }
			    }
			    {	/* ./Ast/node.scm 1547 */
			       object_bglt aux_3428;
			       aux_3428 =
				  (object_bglt) (new1274_2239);
			       OBJECT_WIDENING_SET(aux_3428, BFALSE);
			    }
			    ((((app_bglt) CREF(new1274_2239))->loc) = ((obj_t) loc_2677), BUNSPEC);
			    ((((app_bglt) CREF(new1274_2239))->type) = ((type_bglt) type_2233), BUNSPEC);
			    ((((app_bglt) CREF(new1274_2239))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
			    ((((app_bglt) CREF(new1274_2239))->key) = ((obj_t) key_2235), BUNSPEC);
			    ((((app_bglt) CREF(new1274_2239))->fun) = ((var_bglt) arg1778_1124), BUNSPEC);
			    ((((app_bglt) CREF(new1274_2239))->args) = ((obj_t) arg1779_1125), BUNSPEC);
			    ((((app_bglt) CREF(new1274_2239))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
			    res2033_2250 = new1274_2239;
			 }
		      }
		      return
			 (obj_t) (res2033_2250);
		   }
		}
	     }
	   else
	     {	/* Cnst/alloc.scm 386 */
		{	/* Cnst/alloc.scm 387 */
		   kwote_bglt arg1792_1138;
		   {	/* Cnst/alloc.scm 387 */
		      obj_t arg1794_1140;
		      arg1794_1140 = _pair__244_type_cache;
		      {		/* Cnst/alloc.scm 387 */
			 kwote_bglt res2034_2261;
			 {	/* Cnst/alloc.scm 387 */
			    type_bglt type_2252;
			    type_2252 =
			       (type_bglt) (arg1794_1140);
			    {	/* ./Ast/node.scm 1538 */
			       kwote_bglt new1251_2254;
			       new1251_2254 =
				  ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
			       {	/* ./Ast/node.scm 1538 */
				  long arg1965_2255;
				  arg1965_2255 =
				     class_num_218___object(kwote_ast_node);
				  {	/* ./Ast/node.scm 1538 */
				     obj_t obj_2259;
				     obj_2259 =
					(obj_t) (new1251_2254);
				     (((obj_t) CREF(obj_2259))->header = MAKE_HEADER(arg1965_2255, 0), BUNSPEC);
				  }
			       }
			       {	/* ./Ast/node.scm 1538 */
				  object_bglt aux_3444;
				  aux_3444 =
				     (object_bglt) (new1251_2254);
				  OBJECT_WIDENING_SET(aux_3444, BFALSE);
			       }
			       ((((kwote_bglt) CREF(new1251_2254))->loc) = ((obj_t) loc_2677), BUNSPEC);
			       ((((kwote_bglt) CREF(new1251_2254))->type) = ((type_bglt) type_2252), BUNSPEC);
			       ((((kwote_bglt) CREF(new1251_2254))->value) = ((obj_t) pair_1114), BUNSPEC);
			       res2034_2261 = new1251_2254;
			    }
			 }
			 arg1792_1138 = res2034_2261;
		      }
		   }
		   {	/* Cnst/alloc.scm 387 */
		      node_bglt aux_3450;
		      aux_3450 =
			 cnst__44_cnst_node(
			 (node_bglt) (arg1792_1138));
		      return
			 (obj_t) (aux_3450);
		   }
		}
	     }
	}
   }
}



/* _cnst-alloc-list */
obj_t 
_cnst_alloc_list_46_cnst_alloc(obj_t env_2667, obj_t pair_2668, obj_t loc_2669)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 380 */
      {		/* Cnst/alloc.scm 380 */
	 node_bglt aux_3454;
	 aux_3454 =
	    cnst_alloc_list_56_cnst_alloc(pair_2668, loc_2669);
	 return
	    (obj_t) (aux_3454);
      }
   }
}



/* cnst-alloc-vector */
node_bglt 
cnst_alloc_vector_65_cnst_alloc(obj_t vec_47, obj_t loc_48)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 449 */
      {

	 {	/* Cnst/alloc.scm 522 */
	    obj_t old_1148;
	    {	/* Cnst/alloc.scm 522 */
	       obj_t _andtest_1501_1155;
	       _andtest_1501_1155 = _shared_cnst___67_engine_param;
	       if (
		  CBOOL(_andtest_1501_1155))
		 {
		    obj_t env_1156;
		    env_1156 = _vector_env__150_cnst_alloc;
		  loop_1157:
		    if (
		       NULLP(env_1156))
		      {		/* Cnst/alloc.scm 525 */
			 old_1148 = BFALSE;
		      }
		    else
		      {		/* Cnst/alloc.scm 527 */
			 bool_t test_3461;
			 {	/* Cnst/alloc.scm 527 */
			    obj_t aux_3462;
			    {	/* ./Llib/struct.scm 1457 */
			       obj_t aux_3463;
			       aux_3463 =
				  CAR(env_1156);
			       aux_3462 =
				  STRUCT_REF(aux_3463, ((long) 0));
			    }
			    test_3461 =
			       equal__25___r4_equivalence_6_2(aux_3462, vec_47);
			 }
			 if (test_3461)
			   {	/* Cnst/alloc.scm 527 */
			      old_1148 =
				 CAR(env_1156);
			   }
			 else
			   {	/* Cnst/alloc.scm 527 */
			      {
				 obj_t env_3468;
				 env_3468 =
				    CDR(env_1156);
				 env_1156 = env_3468;
				 goto loop_1157;
			      }
			   }
		      }
		 }
	       else
		 {	/* Cnst/alloc.scm 522 */
		    old_1148 = BFALSE;
		 }
	    }
	    if (
	       CBOOL(old_1148))
	      {		/* Cnst/alloc.scm 532 */
		 {	/* Cnst/alloc.scm 533 */
		    bool_t test1796_1149;
		    {	/* Cnst/alloc.scm 533 */
		       obj_t obj1_2269;
		       obj1_2269 = _init_mode__183_engine_param;
		       {	/* ./Ieee/equiv.scm 5508 */
			  obj_t aux_3472;
			  aux_3472 =
			     CNST_TABLE_REF(((long) 14));
			  test1796_1149 =
			     (obj1_2269 == aux_3472);
		       }
		    }
		    if (test1796_1149)
		      {		/* Cnst/alloc.scm 534 */
			 type_bglt arg1798_1151;
			 obj_t arg1800_1152;
			 arg1798_1151 =
			    get_default_type_181_type_cache();
			 arg1800_1152 =
			    STRUCT_REF(old_1148, ((long) 1));
			 {	/* Cnst/alloc.scm 534 */
			    var_bglt res2035_2284;
			    {	/* Cnst/alloc.scm 534 */
			       variable_bglt variable_2276;
			       variable_2276 =
				  (variable_bglt) (arg1800_1152);
			       {	/* ./Ast/node.scm 1530 */
				  var_bglt new1236_2277;
				  new1236_2277 =
				     ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				  {	/* ./Ast/node.scm 1530 */
				     long arg1969_2278;
				     arg1969_2278 =
					class_num_218___object(var_ast_node);
				     {	/* ./Ast/node.scm 1530 */
					obj_t obj_2282;
					obj_2282 =
					   (obj_t) (new1236_2277);
					(((obj_t) CREF(obj_2282))->header = MAKE_HEADER(arg1969_2278, 0), BUNSPEC);
				     }
				  }
				  {	/* ./Ast/node.scm 1530 */
				     object_bglt aux_3483;
				     aux_3483 =
					(object_bglt) (new1236_2277);
				     OBJECT_WIDENING_SET(aux_3483, BFALSE);
				  }
				  ((((var_bglt) CREF(new1236_2277))->loc) = ((obj_t) loc_48), BUNSPEC);
				  ((((var_bglt) CREF(new1236_2277))->type) = ((type_bglt) arg1798_1151), BUNSPEC);
				  ((((var_bglt) CREF(new1236_2277))->variable) = ((variable_bglt) variable_2276), BUNSPEC);
				  res2035_2284 = new1236_2277;
			       }
			    }
			    return
			       (node_bglt) (res2035_2284);
			 }
		      }
		    else
		      {		/* Cnst/alloc.scm 538 */
			 app_bglt aux_3490;
			 aux_3490 =
			    make_cnst_table_ref_93_cnst_alloc(
			    STRUCT_REF(old_1148, ((long) 1)), loc_48);
			 return
			    (node_bglt) (aux_3490);
		      }
		 }
	      }
	    else
	      {		/* Cnst/alloc.scm 539 */
		 bool_t test1802_1154;
		 {	/* Cnst/alloc.scm 539 */
		    obj_t obj1_2288;
		    obj1_2288 = _init_mode__183_engine_param;
		    {	/* ./Ieee/equiv.scm 5508 */
		       obj_t aux_3494;
		       aux_3494 =
			  CNST_TABLE_REF(((long) 14));
		       test1802_1154 =
			  (obj1_2288 == aux_3494);
		    }
		 }
		 if (test1802_1154)
		   {	/* Cnst/alloc.scm 539 */
		      {		/* Cnst/alloc.scm 540 */
			 var_bglt aux_3498;
			 {	/* Cnst/alloc.scm 510 */
			    global_bglt var_1164;
			    {	/* Cnst/alloc.scm 510 */
			       obj_t arg1827_1182;
			       obj_t arg1828_1183;
			       obj_t arg1830_1184;
			       {	/* Cnst/alloc.scm 510 */
				  obj_t arg1831_1185;
				  arg1831_1185 =
				     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				     CNST_TABLE_REF(((long) 27)), BEOA);
				  {	/* Cnst/alloc.scm 510 */
				     obj_t list1833_1187;
				     {	/* Cnst/alloc.scm 510 */
					obj_t arg1834_1188;
					{	/* Cnst/alloc.scm 510 */
					   obj_t aux_3502;
					   aux_3502 =
					      CNST_TABLE_REF(((long) 28));
					   arg1834_1188 =
					      MAKE_PAIR(aux_3502, BNIL);
					}
					list1833_1187 =
					   MAKE_PAIR(arg1831_1185, arg1834_1188);
				     }
				     arg1827_1182 =
					symbol_append_197___r4_symbols_6_4(list1833_1187);
				  }
			       }
			       arg1828_1183 =
				  CNST_TABLE_REF(((long) 2));
			       arg1830_1184 =
				  CNST_TABLE_REF(((long) 3));
			       var_1164 =
				  def_global_svar__184_ast_glo_def_117(arg1827_1182, _module__166_module_module, arg1828_1183, arg1830_1184);
			    }
			    if (
			       CBOOL(_shared_cnst___67_engine_param))
			      {		/* Cnst/alloc.scm 515 */
				 obj_t arg1809_1165;
				 {	/* Cnst/alloc.scm 51 */
				    obj_t new_2292;
				    {	/* Cnst/alloc.scm 51 */
				       obj_t aux_3512;
				       aux_3512 =
					  CNST_TABLE_REF(((long) 8));
				       new_2292 =
					  create_struct(aux_3512, ((long) 2));
				    }
				    {	/* ./Llib/struct.scm 1463 */
				       obj_t aux_3515;
				       aux_3515 =
					  (obj_t) (var_1164);
				       STRUCT_SET(new_2292, ((long) 1), aux_3515);
				    }
				    STRUCT_SET(new_2292, ((long) 0), vec_47);
				    arg1809_1165 = new_2292;
				 }
				 {	/* Cnst/alloc.scm 515 */
				    obj_t obj2_2304;
				    obj2_2304 = _vector_env__150_cnst_alloc;
				    _vector_env__150_cnst_alloc =
				       MAKE_PAIR(arg1809_1165, obj2_2304);
				 }
			      }
			    else
			      {		/* Cnst/alloc.scm 514 */
				 BUNSPEC;
			      }
			    {	/* Cnst/alloc.scm 516 */
			       obj_t arg1810_1166;
			       {	/* Cnst/alloc.scm 516 */
				  obj_t arg1811_1167;
				  obj_t arg1812_1168;
				  arg1811_1167 =
				     CNST_TABLE_REF(((long) 12));
				  {	/* Cnst/alloc.scm 516 */
				     obj_t arg1813_1169;
				     obj_t arg1814_1170;
				     {	/* Cnst/alloc.scm 516 */
					obj_t arg1815_1171;
					obj_t arg1816_1172;
					arg1815_1171 =
					   CNST_TABLE_REF(((long) 13));
					{	/* Cnst/alloc.scm 516 */
					   obj_t arg1817_1173;
					   obj_t arg1818_1174;
					   arg1817_1173 =
					      (((global_bglt) CREF(var_1164))->id);
					   {	/* ./Ieee/pair-list.scm 5689 */
					      obj_t aux_3523;
					      aux_3523 =
						 (((global_bglt) CREF(var_1164))->module);
					      arg1818_1174 =
						 MAKE_PAIR(aux_3523, BNIL);
					   }
					   arg1816_1172 =
					      MAKE_PAIR(arg1817_1173, arg1818_1174);
					}
					arg1813_1169 =
					   MAKE_PAIR(arg1815_1171, arg1816_1172);
				     }
				     {	/* Cnst/alloc.scm 517 */
					node_bglt arg1822_1177;
					{	/* Cnst/alloc.scm 453 */
					   node_bglt arg1838_1193;
					   {	/* Cnst/alloc.scm 453 */
					      let_var_6_bglt arg1839_1194;
					      {		/* Cnst/alloc.scm 453 */
						 local_bglt var_1195;
						 var_1195 =
						    make_local_svar_140_ast_local(
						    CNST_TABLE_REF(((long) 29)),
						    (type_bglt) (_vector__240_type_cache));
						 {	/* Cnst/alloc.scm 454 */
						    obj_t arg1842_1197;
						    obj_t arg1844_1199;
						    obj_t arg1845_1200;
						    arg1842_1197 = _obj__252_type_cache;
						    {	/* Cnst/alloc.scm 460 */
						       obj_t arg1846_1201;
						       {	/* Cnst/alloc.scm 460 */
							  app_bglt arg1848_1203;
							  {	/* Cnst/alloc.scm 460 */
							     obj_t arg1850_1205;
							     var_bglt arg1852_1207;
							     obj_t arg1853_1208;
							     arg1850_1205 = _vector__240_type_cache;
							     {	/* Cnst/alloc.scm 463 */
								type_bglt arg1855_1210;
								obj_t arg1856_1211;
								{	/* Cnst/alloc.scm 465 */
								   variable_bglt obj_2353;
								   obj_2353 =
								      (variable_bglt) (_list__vector__161_cnst_cache);
								   arg1855_1210 =
								      (((variable_bglt) CREF(obj_2353))->type);
								}
								arg1856_1211 = _list__vector__161_cnst_cache;
								{	/* Cnst/alloc.scm 463 */
								   var_bglt res2037_2364;
								   {	/* Cnst/alloc.scm 463 */
								      variable_bglt variable_2356;
								      variable_2356 =
									 (variable_bglt) (arg1856_1211);
								      {		/* ./Ast/node.scm 1530 */
									 var_bglt new1236_2357;
									 new1236_2357 =
									    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
									 {	/* ./Ast/node.scm 1530 */
									    long arg1969_2358;
									    arg1969_2358 =
									       class_num_218___object(var_ast_node);
									    {	/* ./Ast/node.scm 1530 */
									       obj_t obj_2362;
									       obj_2362 =
										  (obj_t) (new1236_2357);
									       (((obj_t) CREF(obj_2362))->header = MAKE_HEADER(arg1969_2358, 0), BUNSPEC);
									    }
									 }
									 {	/* ./Ast/node.scm 1530 */
									    object_bglt aux_3538;
									    aux_3538 =
									       (object_bglt) (new1236_2357);
									    OBJECT_WIDENING_SET(aux_3538, BFALSE);
									 }
									 ((((var_bglt) CREF(new1236_2357))->loc) = ((obj_t) loc_48), BUNSPEC);
									 ((((var_bglt) CREF(new1236_2357))->type) = ((type_bglt) arg1855_1210), BUNSPEC);
									 ((((var_bglt) CREF(new1236_2357))->variable) = ((variable_bglt) variable_2356), BUNSPEC);
									 res2037_2364 = new1236_2357;
								      }
								   }
								   arg1852_1207 = res2037_2364;
								}
							     }
							     {	/* Cnst/alloc.scm 468 */
								kwote_bglt arg1857_1212;
								{	/* Cnst/alloc.scm 468 */
								   obj_t arg1860_1215;
								   obj_t arg1861_1216;
								   arg1860_1215 = _obj__252_type_cache;
								   arg1861_1216 =
								      vector__list_155___r4_vectors_6_8(vec_47);
								   {	/* Cnst/alloc.scm 468 */
								      kwote_bglt res2038_2375;
								      {		/* Cnst/alloc.scm 468 */
									 type_bglt type_2366;
									 type_2366 =
									    (type_bglt) (arg1860_1215);
									 {	/* ./Ast/node.scm 1538 */
									    kwote_bglt new1251_2368;
									    new1251_2368 =
									       ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
									    {	/* ./Ast/node.scm 1538 */
									       long arg1965_2369;
									       arg1965_2369 =
										  class_num_218___object(kwote_ast_node);
									       {	/* ./Ast/node.scm 1538 */
										  obj_t obj_2373;
										  obj_2373 =
										     (obj_t) (new1251_2368);
										  (((obj_t) CREF(obj_2373))->header = MAKE_HEADER(arg1965_2369, 0), BUNSPEC);
									       }
									    }
									    {	/* ./Ast/node.scm 1538 */
									       object_bglt aux_3550;
									       aux_3550 =
										  (object_bglt) (new1251_2368);
									       OBJECT_WIDENING_SET(aux_3550, BFALSE);
									    }
									    ((((kwote_bglt) CREF(new1251_2368))->loc) = ((obj_t) loc_48), BUNSPEC);
									    ((((kwote_bglt) CREF(new1251_2368))->type) = ((type_bglt) type_2366), BUNSPEC);
									    ((((kwote_bglt) CREF(new1251_2368))->value) = ((obj_t) arg1861_1216), BUNSPEC);
									    res2038_2375 = new1251_2368;
									 }
								      }
								      arg1857_1212 = res2038_2375;
								   }
								}
								{	/* Cnst/alloc.scm 467 */
								   obj_t list1858_1213;
								   {	/* Cnst/alloc.scm 467 */
								      obj_t aux_3556;
								      aux_3556 =
									 (obj_t) (arg1857_1212);
								      list1858_1213 =
									 MAKE_PAIR(aux_3556, BNIL);
								   }
								   arg1853_1208 = list1858_1213;
								}
							     }
							     {	/* Cnst/alloc.scm 460 */
								app_bglt res2039_2395;
								{	/* Cnst/alloc.scm 460 */
								   type_bglt type_2378;
								   obj_t key_2380;
								   type_2378 =
								      (type_bglt) (arg1850_1205);
								   key_2380 =
								      BINT(((long) -1));
								   {	/* ./Ast/node.scm 1547 */
								      app_bglt new1274_2384;
								      new1274_2384 =
									 ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
								      {		/* ./Ast/node.scm 1547 */
									 long arg1961_2385;
									 arg1961_2385 =
									    class_num_218___object(app_ast_node);
									 {	/* ./Ast/node.scm 1547 */
									    obj_t obj_2393;
									    obj_2393 =
									       (obj_t) (new1274_2384);
									    (((obj_t) CREF(obj_2393))->header = MAKE_HEADER(arg1961_2385, 0), BUNSPEC);
									 }
								      }
								      {		/* ./Ast/node.scm 1547 */
									 object_bglt aux_3565;
									 aux_3565 =
									    (object_bglt) (new1274_2384);
									 OBJECT_WIDENING_SET(aux_3565, BFALSE);
								      }
								      ((((app_bglt) CREF(new1274_2384))->loc) = ((obj_t) loc_48), BUNSPEC);
								      ((((app_bglt) CREF(new1274_2384))->type) = ((type_bglt) type_2378), BUNSPEC);
								      ((((app_bglt) CREF(new1274_2384))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
								      ((((app_bglt) CREF(new1274_2384))->key) = ((obj_t) key_2380), BUNSPEC);
								      ((((app_bglt) CREF(new1274_2384))->fun) = ((var_bglt) arg1852_1207), BUNSPEC);
								      ((((app_bglt) CREF(new1274_2384))->args) = ((obj_t) arg1853_1208), BUNSPEC);
								      ((((app_bglt) CREF(new1274_2384))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
								      res2039_2395 = new1274_2384;
								   }
								}
								arg1848_1203 = res2039_2395;
							     }
							  }
							  {	/* ./Ieee/pair-list.scm 5689 */
							     obj_t aux_3577;
							     obj_t aux_3575;
							     aux_3577 =
								(obj_t) (arg1848_1203);
							     aux_3575 =
								(obj_t) (var_1195);
							     arg1846_1201 =
								MAKE_PAIR(aux_3575, aux_3577);
							  }
						       }
						       {	/* Cnst/alloc.scm 457 */
							  obj_t list1847_1202;
							  list1847_1202 =
							     MAKE_PAIR(arg1846_1201, BNIL);
							  arg1844_1199 = list1847_1202;
						       }
						    }
						    {	/* Cnst/alloc.scm 472 */
						       var_bglt var_body_120_1217;
						       {	/* Cnst/alloc.scm 472 */
							  type_bglt arg1892_1247;
							  {	/* Cnst/alloc.scm 474 */
							     variable_bglt obj_2399;
							     obj_2399 =
								(variable_bglt) (var_1195);
							     arg1892_1247 =
								(((variable_bglt) CREF(obj_2399))->type);
							  }
							  {	/* Cnst/alloc.scm 472 */
							     var_bglt res2040_2410;
							     {	/* Cnst/alloc.scm 472 */
								variable_bglt variable_2402;
								variable_2402 =
								   (variable_bglt) (var_1195);
								{	/* ./Ast/node.scm 1530 */
								   var_bglt new1236_2403;
								   new1236_2403 =
								      ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
								   {	/* ./Ast/node.scm 1530 */
								      long arg1969_2404;
								      arg1969_2404 =
									 class_num_218___object(var_ast_node);
								      {		/* ./Ast/node.scm 1530 */
									 obj_t obj_2408;
									 obj_2408 =
									    (obj_t) (new1236_2403);
									 (((obj_t) CREF(obj_2408))->header = MAKE_HEADER(arg1969_2404, 0), BUNSPEC);
								      }
								   }
								   {	/* ./Ast/node.scm 1530 */
								      object_bglt aux_3588;
								      aux_3588 =
									 (object_bglt) (new1236_2403);
								      OBJECT_WIDENING_SET(aux_3588, BFALSE);
								   }
								   ((((var_bglt) CREF(new1236_2403))->loc) = ((obj_t) loc_48), BUNSPEC);
								   ((((var_bglt) CREF(new1236_2403))->type) = ((type_bglt) arg1892_1247), BUNSPEC);
								   ((((var_bglt) CREF(new1236_2403))->variable) = ((variable_bglt) variable_2402), BUNSPEC);
								   res2040_2410 = new1236_2403;
								}
							     }
							     var_body_120_1217 = res2040_2410;
							  }
						       }
						       {	/* Cnst/alloc.scm 476 */
							  bool_t test1862_1218;
							  {	/* Cnst/alloc.scm 476 */
							     long arg1889_1244;
							     arg1889_1244 =
								VECTOR_TAG(vec_47);
							     test1862_1218 =
								(arg1889_1244 > ((long) 0));
							  }
							  if (test1862_1218)
							    {	/* Cnst/alloc.scm 477 */
							       obj_t arg1864_1220;
							       obj_t arg1866_1222;
							       arg1864_1220 = _vector__240_type_cache;
							       {	/* Cnst/alloc.scm 482 */
								  app_bglt arg1867_1223;
								  {	/* Cnst/alloc.scm 482 */
								     obj_t arg1871_1227;
								     var_bglt arg1873_1229;
								     obj_t arg1874_1230;
								     arg1871_1227 = _obj__252_type_cache;
								     {	/* Cnst/alloc.scm 485 */
									type_bglt arg1876_1232;
									obj_t arg1877_1233;
									{	/* Cnst/alloc.scm 487 */
									   variable_bglt obj_2414;
									   obj_2414 =
									      (variable_bglt) (_vector_tag_set___225_cnst_cache);
									   arg1876_1232 =
									      (((variable_bglt) CREF(obj_2414))->type);
									}
									arg1877_1233 = _vector_tag_set___225_cnst_cache;
									{	/* Cnst/alloc.scm 485 */
									   var_bglt res2041_2425;
									   {	/* Cnst/alloc.scm 485 */
									      variable_bglt variable_2417;
									      variable_2417 =
										 (variable_bglt) (arg1877_1233);
									      {		/* ./Ast/node.scm 1530 */
										 var_bglt new1236_2418;
										 new1236_2418 =
										    ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
										 {	/* ./Ast/node.scm 1530 */
										    long arg1969_2419;
										    arg1969_2419 =
										       class_num_218___object(var_ast_node);
										    {	/* ./Ast/node.scm 1530 */
										       obj_t obj_2423;
										       obj_2423 =
											  (obj_t) (new1236_2418);
										       (((obj_t) CREF(obj_2423))->header = MAKE_HEADER(arg1969_2419, 0), BUNSPEC);
										    }
										 }
										 {	/* ./Ast/node.scm 1530 */
										    object_bglt aux_3604;
										    aux_3604 =
										       (object_bglt) (new1236_2418);
										    OBJECT_WIDENING_SET(aux_3604, BFALSE);
										 }
										 ((((var_bglt) CREF(new1236_2418))->loc) = ((obj_t) loc_48), BUNSPEC);
										 ((((var_bglt) CREF(new1236_2418))->type) = ((type_bglt) arg1876_1232), BUNSPEC);
										 ((((var_bglt) CREF(new1236_2418))->variable) = ((variable_bglt) variable_2417), BUNSPEC);
										 res2041_2425 = new1236_2418;
									      }
									   }
									   arg1873_1229 = res2041_2425;
									}
								     }
								     {	/* Cnst/alloc.scm 491 */
									var_bglt arg1879_1234;
									atom_bglt arg1880_1235;
									{	/* Cnst/alloc.scm 491 */
									   type_bglt arg1884_1239;
									   {	/* Cnst/alloc.scm 493 */
									      variable_bglt obj_2426;
									      obj_2426 =
										 (variable_bglt) (var_1195);
									      arg1884_1239 =
										 (((variable_bglt) CREF(obj_2426))->type);
									   }
									   {	/* Cnst/alloc.scm 491 */
									      var_bglt res2042_2437;
									      {		/* Cnst/alloc.scm 491 */
										 variable_bglt variable_2429;
										 variable_2429 =
										    (variable_bglt) (var_1195);
										 {	/* ./Ast/node.scm 1530 */
										    var_bglt new1236_2430;
										    new1236_2430 =
										       ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
										    {	/* ./Ast/node.scm 1530 */
										       long arg1969_2431;
										       arg1969_2431 =
											  class_num_218___object(var_ast_node);
										       {	/* ./Ast/node.scm 1530 */
											  obj_t obj_2435;
											  obj_2435 =
											     (obj_t) (new1236_2430);
											  (((obj_t) CREF(obj_2435))->header = MAKE_HEADER(arg1969_2431, 0), BUNSPEC);
										       }
										    }
										    {	/* ./Ast/node.scm 1530 */
										       object_bglt aux_3617;
										       aux_3617 =
											  (object_bglt) (new1236_2430);
										       OBJECT_WIDENING_SET(aux_3617, BFALSE);
										    }
										    ((((var_bglt) CREF(new1236_2430))->loc) = ((obj_t) loc_48), BUNSPEC);
										    ((((var_bglt) CREF(new1236_2430))->type) = ((type_bglt) arg1884_1239), BUNSPEC);
										    ((((var_bglt) CREF(new1236_2430))->variable) = ((variable_bglt) variable_2429), BUNSPEC);
										    res2042_2437 = new1236_2430;
										 }
									      }
									      arg1879_1234 = res2042_2437;
									   }
									}
									{	/* Cnst/alloc.scm 495 */
									   obj_t arg1887_1242;
									   long arg1888_1243;
									   arg1887_1242 = _obj__252_type_cache;
									   arg1888_1243 =
									      VECTOR_TAG(vec_47);
									   {	/* Cnst/alloc.scm 495 */
									      atom_bglt res2043_2449;
									      {		/* Cnst/alloc.scm 495 */
										 type_bglt type_2440;
										 obj_t value_2441;
										 type_2440 =
										    (type_bglt) (arg1887_1242);
										 value_2441 =
										    BINT(arg1888_1243);
										 {	/* ./Ast/node.scm 1525 */
										    atom_bglt new1228_2442;
										    new1228_2442 =
										       ((atom_bglt) BREF(GC_MALLOC(sizeof(struct atom))));
										    {	/* ./Ast/node.scm 1525 */
										       long arg1971_2443;
										       arg1971_2443 =
											  class_num_218___object(atom_ast_node);
										       {	/* ./Ast/node.scm 1525 */
											  obj_t obj_2447;
											  obj_2447 =
											     (obj_t) (new1228_2442);
											  (((obj_t) CREF(obj_2447))->header = MAKE_HEADER(arg1971_2443, 0), BUNSPEC);
										       }
										    }
										    {	/* ./Ast/node.scm 1525 */
										       object_bglt aux_3630;
										       aux_3630 =
											  (object_bglt) (new1228_2442);
										       OBJECT_WIDENING_SET(aux_3630, BFALSE);
										    }
										    ((((atom_bglt) CREF(new1228_2442))->loc) = ((obj_t) loc_48), BUNSPEC);
										    ((((atom_bglt) CREF(new1228_2442))->type) = ((type_bglt) type_2440), BUNSPEC);
										    ((((atom_bglt) CREF(new1228_2442))->value) = ((obj_t) value_2441), BUNSPEC);
										    res2043_2449 = new1228_2442;
										 }
									      }
									      arg1880_1235 = res2043_2449;
									   }
									}
									{	/* Cnst/alloc.scm 490 */
									   obj_t list1881_1236;
									   {	/* Cnst/alloc.scm 490 */
									      obj_t arg1882_1237;
									      {		/* Cnst/alloc.scm 490 */
										 obj_t aux_3636;
										 aux_3636 =
										    (obj_t) (arg1880_1235);
										 arg1882_1237 =
										    MAKE_PAIR(aux_3636, BNIL);
									      }
									      {		/* Cnst/alloc.scm 490 */
										 obj_t aux_3639;
										 aux_3639 =
										    (obj_t) (arg1879_1234);
										 list1881_1236 =
										    MAKE_PAIR(aux_3639, arg1882_1237);
									      }
									   }
									   arg1874_1230 = list1881_1236;
									}
								     }
								     {	/* Cnst/alloc.scm 482 */
									app_bglt res2044_2469;
									{	/* Cnst/alloc.scm 482 */
									   type_bglt type_2452;
									   obj_t key_2454;
									   type_2452 =
									      (type_bglt) (arg1871_1227);
									   key_2454 =
									      BINT(((long) -1));
									   {	/* ./Ast/node.scm 1547 */
									      app_bglt new1274_2458;
									      new1274_2458 =
										 ((app_bglt) BREF(GC_MALLOC(sizeof(struct app))));
									      {		/* ./Ast/node.scm 1547 */
										 long arg1961_2459;
										 arg1961_2459 =
										    class_num_218___object(app_ast_node);
										 {	/* ./Ast/node.scm 1547 */
										    obj_t obj_2467;
										    obj_2467 =
										       (obj_t) (new1274_2458);
										    (((obj_t) CREF(obj_2467))->header = MAKE_HEADER(arg1961_2459, 0), BUNSPEC);
										 }
									      }
									      {		/* ./Ast/node.scm 1547 */
										 object_bglt aux_3648;
										 aux_3648 =
										    (object_bglt) (new1274_2458);
										 OBJECT_WIDENING_SET(aux_3648, BFALSE);
									      }
									      ((((app_bglt) CREF(new1274_2458))->loc) = ((obj_t) loc_48), BUNSPEC);
									      ((((app_bglt) CREF(new1274_2458))->type) = ((type_bglt) type_2452), BUNSPEC);
									      ((((app_bglt) CREF(new1274_2458))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
									      ((((app_bglt) CREF(new1274_2458))->key) = ((obj_t) key_2454), BUNSPEC);
									      ((((app_bglt) CREF(new1274_2458))->fun) = ((var_bglt) arg1873_1229), BUNSPEC);
									      ((((app_bglt) CREF(new1274_2458))->args) = ((obj_t) arg1874_1230), BUNSPEC);
									      ((((app_bglt) CREF(new1274_2458))->stack_info_255) = ((obj_t) BUNSPEC), BUNSPEC);
									      res2044_2469 = new1274_2458;
									   }
									}
									arg1867_1223 = res2044_2469;
								     }
								  }
								  {	/* Cnst/alloc.scm 480 */
								     obj_t list1868_1224;
								     {	/* Cnst/alloc.scm 480 */
									obj_t arg1869_1225;
									{	/* Cnst/alloc.scm 480 */
									   obj_t aux_3658;
									   aux_3658 =
									      (obj_t) (var_body_120_1217);
									   arg1869_1225 =
									      MAKE_PAIR(aux_3658, BNIL);
									}
									{	/* Cnst/alloc.scm 480 */
									   obj_t aux_3661;
									   aux_3661 =
									      (obj_t) (arg1867_1223);
									   list1868_1224 =
									      MAKE_PAIR(aux_3661, arg1869_1225);
									}
								     }
								     arg1866_1222 = list1868_1224;
								  }
							       }
							       {	/* Cnst/alloc.scm 477 */
								  sequence_bglt res2045_2485;
								  {	/* Cnst/alloc.scm 477 */
								     type_bglt type_2472;
								     obj_t key_2474;
								     type_2472 =
									(type_bglt) (arg1864_1220);
								     key_2474 =
									BINT(((long) -1));
								     {	/* ./Ast/node.scm 1543 */
									sequence_bglt new1260_2476;
									new1260_2476 =
									   ((sequence_bglt) BREF(GC_MALLOC(sizeof(struct sequence))));
									{	/* ./Ast/node.scm 1543 */
									   long arg1963_2477;
									   arg1963_2477 =
									      class_num_218___object(sequence_ast_node);
									   {	/* ./Ast/node.scm 1543 */
									      obj_t obj_2483;
									      obj_2483 =
										 (obj_t) (new1260_2476);
									      (((obj_t) CREF(obj_2483))->header = MAKE_HEADER(arg1963_2477, 0), BUNSPEC);
									   }
									}
									{	/* ./Ast/node.scm 1543 */
									   object_bglt aux_3670;
									   aux_3670 =
									      (object_bglt) (new1260_2476);
									   OBJECT_WIDENING_SET(aux_3670, BFALSE);
									}
									((((sequence_bglt) CREF(new1260_2476))->loc) = ((obj_t) loc_48), BUNSPEC);
									((((sequence_bglt) CREF(new1260_2476))->type) = ((type_bglt) type_2472), BUNSPEC);
									((((sequence_bglt) CREF(new1260_2476))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
									((((sequence_bglt) CREF(new1260_2476))->key) = ((obj_t) key_2474), BUNSPEC);
									((((sequence_bglt) CREF(new1260_2476))->nodes) = ((obj_t) arg1866_1222), BUNSPEC);
									res2045_2485 = new1260_2476;
								     }
								  }
								  arg1845_1200 =
								     (obj_t) (res2045_2485);
							       }
							    }
							  else
							    {	/* Cnst/alloc.scm 476 */
							       arg1845_1200 =
								  (obj_t) (var_body_120_1217);
							    }
						       }
						    }
						    {	/* Cnst/alloc.scm 454 */
						       let_var_6_bglt res2046_2504;
						       {	/* Cnst/alloc.scm 454 */
							  type_bglt type_2487;
							  obj_t key_2489;
							  node_bglt body_2491;
							  type_2487 =
							     (type_bglt) (arg1842_1197);
							  key_2489 =
							     BINT(((long) -1));
							  body_2491 =
							     (node_bglt) (arg1845_1200);
							  {	/* ./Ast/node.scm 1623 */
							     let_var_6_bglt new1399_2493;
							     new1399_2493 =
								((let_var_6_bglt) BREF(GC_MALLOC(sizeof(struct let_var_6))));
							     {	/* ./Ast/node.scm 1623 */
								long arg1940_2494;
								arg1940_2494 =
								   class_num_218___object(let_var_6_ast_node);
								{	/* ./Ast/node.scm 1623 */
								   obj_t obj_2502;
								   obj_2502 =
								      (obj_t) (new1399_2493);
								   (((obj_t) CREF(obj_2502))->header = MAKE_HEADER(arg1940_2494, 0), BUNSPEC);
								}
							     }
							     {	/* ./Ast/node.scm 1623 */
								object_bglt aux_3687;
								aux_3687 =
								   (object_bglt) (new1399_2493);
								OBJECT_WIDENING_SET(aux_3687, BFALSE);
							     }
							     ((((let_var_6_bglt) CREF(new1399_2493))->loc) = ((obj_t) loc_48), BUNSPEC);
							     ((((let_var_6_bglt) CREF(new1399_2493))->type) = ((type_bglt) type_2487), BUNSPEC);
							     ((((let_var_6_bglt) CREF(new1399_2493))->side_effect__165) = ((obj_t) BUNSPEC), BUNSPEC);
							     ((((let_var_6_bglt) CREF(new1399_2493))->key) = ((obj_t) key_2489), BUNSPEC);
							     ((((let_var_6_bglt) CREF(new1399_2493))->bindings) = ((obj_t) arg1844_1199), BUNSPEC);
							     ((((let_var_6_bglt) CREF(new1399_2493))->body) = ((node_bglt) body_2491), BUNSPEC);
							     ((((let_var_6_bglt) CREF(new1399_2493))->removable__42) = ((bool_t) ((bool_t) 1)), BUNSPEC);
							     res2046_2504 = new1399_2493;
							  }
						       }
						       arg1839_1194 = res2046_2504;
						    }
						 }
					      }
					      arg1838_1193 =
						 coerce__182_coerce_coerce(
						 (node_bglt) (arg1839_1194),
						 (type_bglt) (_obj__252_type_cache));
					   }
					   arg1822_1177 =
					      cnst__44_cnst_node(arg1838_1193);
					}
					{	/* ./Ieee/pair-list.scm 5689 */
					   obj_t aux_3701;
					   aux_3701 =
					      (obj_t) (arg1822_1177);
					   arg1814_1170 =
					      MAKE_PAIR(aux_3701, BNIL);
					}
				     }
				     arg1812_1168 =
					MAKE_PAIR(arg1813_1169, arg1814_1170);
				  }
				  arg1810_1166 =
				     MAKE_PAIR(arg1811_1167, arg1812_1168);
			       }
			       {	/* Cnst/alloc.scm 88 */
				  obj_t obj2_2321;
				  obj2_2321 = _global_sexp__67_cnst_alloc;
				  _global_sexp__67_cnst_alloc =
				     MAKE_PAIR(arg1810_1166, obj2_2321);
			       }
			    }
			    {	/* Cnst/alloc.scm 518 */
			       type_bglt arg1825_1180;
			       {	/* Cnst/alloc.scm 520 */
				  variable_bglt obj_2322;
				  obj_2322 =
				     (variable_bglt) (var_1164);
				  arg1825_1180 =
				     (((variable_bglt) CREF(obj_2322))->type);
			       }
			       {	/* Cnst/alloc.scm 518 */
				  var_bglt res2036_2333;
				  {	/* Cnst/alloc.scm 518 */
				     variable_bglt variable_2325;
				     variable_2325 =
					(variable_bglt) (var_1164);
				     {	/* ./Ast/node.scm 1530 */
					var_bglt new1236_2326;
					new1236_2326 =
					   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
					{	/* ./Ast/node.scm 1530 */
					   long arg1969_2327;
					   arg1969_2327 =
					      class_num_218___object(var_ast_node);
					   {	/* ./Ast/node.scm 1530 */
					      obj_t obj_2331;
					      obj_2331 =
						 (obj_t) (new1236_2326);
					      (((obj_t) CREF(obj_2331))->header = MAKE_HEADER(arg1969_2327, 0), BUNSPEC);
					   }
					}
					{	/* ./Ast/node.scm 1530 */
					   object_bglt aux_3714;
					   aux_3714 =
					      (object_bglt) (new1236_2326);
					   OBJECT_WIDENING_SET(aux_3714, BFALSE);
					}
					((((var_bglt) CREF(new1236_2326))->loc) = ((obj_t) loc_48), BUNSPEC);
					((((var_bglt) CREF(new1236_2326))->type) = ((type_bglt) arg1825_1180), BUNSPEC);
					((((var_bglt) CREF(new1236_2326))->variable) = ((variable_bglt) variable_2325), BUNSPEC);
					res2036_2333 = new1236_2326;
				     }
				  }
				  aux_3498 = res2036_2333;
			       }
			    }
			 }
			 return
			    (node_bglt) (aux_3498);
		      }
		   }
		 else
		   {	/* Cnst/alloc.scm 539 */
		      {		/* Cnst/alloc.scm 542 */
			 app_bglt aux_3721;
			 {	/* Cnst/alloc.scm 503 */
			    long offset_1190;
			    offset_1190 = _cnst_offset__211_cnst_alloc;
			    {	/* Cnst/alloc.scm 504 */
			       long z2_2335;
			       z2_2335 = _cnst_offset__211_cnst_alloc;
			       _cnst_offset__211_cnst_alloc =
				  (((long) 1) + z2_2335);
			    }
			    {	/* Cnst/alloc.scm 505 */
			       obj_t obj2_2337;
			       obj2_2337 = _global_set__17_cnst_alloc;
			       _global_set__17_cnst_alloc =
				  MAKE_PAIR(vec_47, obj2_2337);
			    }
			    if (
			       CBOOL(_shared_cnst___67_engine_param))
			      {		/* Cnst/alloc.scm 507 */
				 obj_t arg1836_1191;
				 {	/* Cnst/alloc.scm 51 */
				    obj_t new_2340;
				    {	/* Cnst/alloc.scm 51 */
				       obj_t aux_3726;
				       aux_3726 =
					  CNST_TABLE_REF(((long) 8));
				       new_2340 =
					  create_struct(aux_3726, ((long) 2));
				    }
				    {	/* ./Llib/struct.scm 1463 */
				       obj_t aux_3729;
				       aux_3729 =
					  BINT(offset_1190);
				       STRUCT_SET(new_2340, ((long) 1), aux_3729);
				    }
				    STRUCT_SET(new_2340, ((long) 0), vec_47);
				    arg1836_1191 = new_2340;
				 }
				 {	/* Cnst/alloc.scm 507 */
				    obj_t obj2_2352;
				    obj2_2352 = _vector_env__150_cnst_alloc;
				    _vector_env__150_cnst_alloc =
				       MAKE_PAIR(arg1836_1191, obj2_2352);
				 }
			      }
			    else
			      {		/* Cnst/alloc.scm 506 */
				 BUNSPEC;
			      }
			    aux_3721 =
			       make_cnst_table_ref_93_cnst_alloc(
			       BINT(offset_1190), loc_48);
			 }
			 return
			    (node_bglt) (aux_3721);
		      }
		   }
	      }
	 }
      }
   }
}



/* _cnst-alloc-vector2055 */
obj_t 
_cnst_alloc_vector2055_94_cnst_alloc(obj_t env_2670, obj_t vec_2671, obj_t loc_2672)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 449 */
      {		/* Cnst/alloc.scm 449 */
	 node_bglt aux_3737;
	 aux_3737 =
	    cnst_alloc_vector_65_cnst_alloc(vec_2671, loc_2672);
	 return
	    (obj_t) (aux_3737);
      }
   }
}



/* cnst-alloc-tvector */
node_bglt 
cnst_alloc_tvector_190_cnst_alloc(obj_t tvec_49, obj_t loc_50)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 547 */
      {

	 {	/* Cnst/alloc.scm 577 */
	    bool_t test1894_1254;
	    test1894_1254 =
	       tvector_c_static__211_tvector_cnst(tvec_49);
	    if (test1894_1254)
	      {		/* Cnst/alloc.scm 578 */
		 var_bglt aux_3742;
		 {	/* Cnst/alloc.scm 549 */
		    global_bglt var_1258;
		    {	/* Cnst/alloc.scm 549 */
		       obj_t arg1923_1284;
		       obj_t arg1924_1285;
		       {	/* Cnst/alloc.scm 549 */
			  obj_t arg1925_1286;
			  arg1925_1286 =
			     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			     CNST_TABLE_REF(((long) 30)), BEOA);
			  {	/* Cnst/alloc.scm 549 */
			     obj_t list1927_1288;
			     {	/* Cnst/alloc.scm 549 */
				obj_t arg1928_1289;
				{	/* Cnst/alloc.scm 549 */
				   obj_t aux_3746;
				   aux_3746 =
				      CNST_TABLE_REF(((long) 31));
				   arg1928_1289 =
				      MAKE_PAIR(aux_3746, BNIL);
				}
				list1927_1288 =
				   MAKE_PAIR(arg1925_1286, arg1928_1289);
			     }
			     arg1923_1284 =
				symbol_append_197___r4_symbols_6_4(list1927_1288);
			  }
		       }
		       arg1924_1285 =
			  CNST_TABLE_REF(((long) 32));
		       var_1258 =
			  def_global_scnst__93_ast_glo_def_117(arg1923_1284, _module__166_module_module, tvec_49, arg1924_1285, loc_50);
		    }
		    {	/* Cnst/alloc.scm 554 */
		       obj_t id_1259;
		       {	/* Cnst/alloc.scm 554 */
			  type_bglt obj_2512;
			  {	/* Cnst/alloc.scm 554 */
			     obj_t aux_3753;
			     aux_3753 =
				STRUCT_REF(tvec_49, ((long) 0));
			     obj_2512 =
				(type_bglt) (aux_3753);
			  }
			  id_1259 =
			     (((type_bglt) CREF(obj_2512))->id);
		       }
		       {	/* Cnst/alloc.scm 554 */
			  node_bglt aid_1260;
			  {	/* Cnst/alloc.scm 555 */
			     kwote_bglt arg1914_1276;
			     {	/* Cnst/alloc.scm 555 */
				type_bglt arg1916_1278;
				arg1916_1278 =
				   get_default_type_181_type_cache();
				{	/* Cnst/alloc.scm 555 */
				   kwote_bglt res2047_2523;
				   {	/* ./Ast/node.scm 1538 */
				      kwote_bglt new1251_2516;
				      new1251_2516 =
					 ((kwote_bglt) BREF(GC_MALLOC(sizeof(struct kwote))));
				      {		/* ./Ast/node.scm 1538 */
					 long arg1965_2517;
					 arg1965_2517 =
					    class_num_218___object(kwote_ast_node);
					 {	/* ./Ast/node.scm 1538 */
					    obj_t obj_2521;
					    obj_2521 =
					       (obj_t) (new1251_2516);
					    (((obj_t) CREF(obj_2521))->header = MAKE_HEADER(arg1965_2517, 0), BUNSPEC);
					 }
				      }
				      {		/* ./Ast/node.scm 1538 */
					 object_bglt aux_3762;
					 aux_3762 =
					    (object_bglt) (new1251_2516);
					 OBJECT_WIDENING_SET(aux_3762, BFALSE);
				      }
				      ((((kwote_bglt) CREF(new1251_2516))->loc) = ((obj_t) loc_50), BUNSPEC);
				      ((((kwote_bglt) CREF(new1251_2516))->type) = ((type_bglt) arg1916_1278), BUNSPEC);
				      ((((kwote_bglt) CREF(new1251_2516))->value) = ((obj_t) id_1259), BUNSPEC);
				      res2047_2523 = new1251_2516;
				   }
				   arg1914_1276 = res2047_2523;
				}
			     }
			     aid_1260 =
				cnst__44_cnst_node(
				(node_bglt) (arg1914_1276));
			  }
			  {	/* Cnst/alloc.scm 555 */

			     {	/* Cnst/alloc.scm 562 */
				obj_t arg1897_1261;
				{	/* Cnst/alloc.scm 562 */
				   obj_t arg1898_1262;
				   obj_t arg1899_1263;
				   arg1898_1262 =
				      CNST_TABLE_REF(((long) 33));
				   {	/* Cnst/alloc.scm 563 */
				      obj_t arg1900_1264;
				      obj_t arg1901_1265;
				      {		/* Cnst/alloc.scm 563 */
					 obj_t arg1902_1266;
					 obj_t arg1903_1267;
					 arg1902_1266 =
					    CNST_TABLE_REF(((long) 13));
					 {	/* Cnst/alloc.scm 563 */
					    obj_t arg1904_1268;
					    obj_t arg1905_1269;
					    arg1904_1268 =
					       (((global_bglt) CREF(var_1258))->id);
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_3773;
					       aux_3773 =
						  (((global_bglt) CREF(var_1258))->module);
					       arg1905_1269 =
						  MAKE_PAIR(aux_3773, BNIL);
					    }
					    arg1903_1267 =
					       MAKE_PAIR(arg1904_1268, arg1905_1269);
					 }
					 arg1900_1264 =
					    MAKE_PAIR(arg1902_1266, arg1903_1267);
				      }
				      {		/* Cnst/alloc.scm 564 */
					 obj_t arg1909_1272;
					 {	/* Cnst/alloc.scm 564 */
					    obj_t arg1912_1274;
					    obj_t arg1913_1275;
					    arg1912_1274 =
					       CNST_TABLE_REF(((long) 34));
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_3779;
					       aux_3779 =
						  (obj_t) (aid_1260);
					       arg1913_1275 =
						  MAKE_PAIR(aux_3779, BNIL);
					    }
					    arg1909_1272 =
					       MAKE_PAIR(arg1912_1274, arg1913_1275);
					 }
					 arg1901_1265 =
					    MAKE_PAIR(arg1909_1272, BNIL);
				      }
				      arg1899_1263 =
					 MAKE_PAIR(arg1900_1264, arg1901_1265);
				   }
				   arg1897_1261 =
				      MAKE_PAIR(arg1898_1262, arg1899_1263);
				}
				{	/* Cnst/alloc.scm 88 */
				   obj_t obj2_2544;
				   obj2_2544 = _global_sexp__67_cnst_alloc;
				   _global_sexp__67_cnst_alloc =
				      MAKE_PAIR(arg1897_1261, obj2_2544);
				}
			     }
			  }
		       }
		    }
		    {	/* Cnst/alloc.scm 565 */
		       type_bglt arg1921_1282;
		       {	/* Cnst/alloc.scm 567 */
			  variable_bglt obj_2545;
			  obj_2545 =
			     (variable_bglt) (var_1258);
			  arg1921_1282 =
			     (((variable_bglt) CREF(obj_2545))->type);
		       }
		       {	/* Cnst/alloc.scm 565 */
			  var_bglt res2048_2556;
			  {	/* Cnst/alloc.scm 565 */
			     variable_bglt variable_2548;
			     variable_2548 =
				(variable_bglt) (var_1258);
			     {	/* ./Ast/node.scm 1530 */
				var_bglt new1236_2549;
				new1236_2549 =
				   ((var_bglt) BREF(GC_MALLOC(sizeof(struct var))));
				{	/* ./Ast/node.scm 1530 */
				   long arg1969_2550;
				   arg1969_2550 =
				      class_num_218___object(var_ast_node);
				   {	/* ./Ast/node.scm 1530 */
				      obj_t obj_2554;
				      obj_2554 =
					 (obj_t) (new1236_2549);
				      (((obj_t) CREF(obj_2554))->header = MAKE_HEADER(arg1969_2550, 0), BUNSPEC);
				   }
				}
				{	/* ./Ast/node.scm 1530 */
				   object_bglt aux_3794;
				   aux_3794 =
				      (object_bglt) (new1236_2549);
				   OBJECT_WIDENING_SET(aux_3794, BFALSE);
				}
				((((var_bglt) CREF(new1236_2549))->loc) = ((obj_t) loc_50), BUNSPEC);
				((((var_bglt) CREF(new1236_2549))->type) = ((type_bglt) arg1921_1282), BUNSPEC);
				((((var_bglt) CREF(new1236_2549))->variable) = ((variable_bglt) variable_2548), BUNSPEC);
				res2048_2556 = new1236_2549;
			     }
			  }
			  aux_3742 = res2048_2556;
		       }
		    }
		 }
		 return
		    (node_bglt) (aux_3742);
	      }
	    else
	      {		/* Cnst/alloc.scm 579 */
		 app_bglt aux_3801;
		 internal_error_43_tools_error(string2059_cnst_alloc, string2060_cnst_alloc, tvec_49);
		 {	/* Cnst/alloc.scm 573 */
		    long offset_1256;
		    offset_1256 = _cnst_offset__211_cnst_alloc;
		    {	/* Cnst/alloc.scm 574 */
		       long z2_2506;
		       z2_2506 = _cnst_offset__211_cnst_alloc;
		       _cnst_offset__211_cnst_alloc =
			  (((long) 1) + z2_2506);
		    }
		    {	/* Cnst/alloc.scm 575 */
		       obj_t obj2_2508;
		       obj2_2508 = _global_set__17_cnst_alloc;
		       _global_set__17_cnst_alloc =
			  MAKE_PAIR(tvec_49, obj2_2508);
		    }
		    aux_3801 =
		       make_cnst_table_ref_93_cnst_alloc(
		       BINT(offset_1256), loc_50);
		 }
		 return
		    (node_bglt) (aux_3801);
	      }
	 }
      }
   }
}



/* _cnst-alloc-tvector */
obj_t 
_cnst_alloc_tvector_13_cnst_alloc(obj_t env_2673, obj_t tvec_2674, obj_t loc_2675)
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 547 */
      {		/* Cnst/alloc.scm 547 */
	 node_bglt aux_3808;
	 aux_3808 =
	    cnst_alloc_tvector_190_cnst_alloc(tvec_2674, loc_2675);
	 return
	    (obj_t) (aux_3808);
      }
   }
}



/* method-init */
obj_t 
method_init_76_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 14 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_cnst_alloc()
{
   AN_OBJECT;
   {	/* Cnst/alloc.scm 14 */
      module_initialization_70_engine_param(((long) 0), "CNST_ALLOC");
      module_initialization_70_module_module(((long) 0), "CNST_ALLOC");
      module_initialization_70_tools_shape(((long) 0), "CNST_ALLOC");
      module_initialization_70_tools_error(((long) 0), "CNST_ALLOC");
      module_initialization_70_type_type(((long) 0), "CNST_ALLOC");
      module_initialization_70_type_cache(((long) 0), "CNST_ALLOC");
      module_initialization_70_tvector_tvector(((long) 0), "CNST_ALLOC");
      module_initialization_70_tvector_cnst(((long) 0), "CNST_ALLOC");
      module_initialization_70_ast_var(((long) 0), "CNST_ALLOC");
      module_initialization_70_ast_node(((long) 0), "CNST_ALLOC");
      module_initialization_70_ast_sexp(((long) 0), "CNST_ALLOC");
      module_initialization_70_ast_local(((long) 0), "CNST_ALLOC");
      module_initialization_70_ast_glo_def_117(((long) 0), "CNST_ALLOC");
      module_initialization_70_coerce_coerce(((long) 0), "CNST_ALLOC");
      module_initialization_70_cnst_cache(((long) 0), "CNST_ALLOC");
      return
	 module_initialization_70_cnst_node(((long) 0), "CNST_ALLOC");
   }
}
