/*===========================================================================*/
/*   (Globalize/ginfo.scm)                                                   */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct sfun_ginfo_98
  {
     bool_t g__219;
     obj_t cfrom;
     obj_t cfrom__119;
     obj_t cto;
     obj_t cto__14;
     obj_t cfunction;
     obj_t integrator;
     obj_t integrated;
     obj_t plugged_in_15;
     long mark;
     obj_t free_mark_81;
     obj_t the_global_201;
     obj_t kaptured;
     obj_t new_body_215;
     long bmark;
     long umark;
     obj_t free;
     obj_t bound;
  }
             *sfun_ginfo_98_bglt;

typedef struct svar_ginfo_131
  {
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
     bool_t celled__113;
  }
              *svar_ginfo_131_bglt;

typedef struct sexit_ginfo_81
  {
     bool_t g__219;
     bool_t kaptured__204;
     long free_mark_81;
     long mark;
  }
              *sexit_ginfo_81_bglt;

typedef struct local_ginfo_108
  {
     bool_t escape__117;
  }
               *local_ginfo_108_bglt;

typedef struct global_ginfo_75
  {
     bool_t escape__117;
     obj_t global_closure_229;
  }
               *global_ginfo_75_bglt;


extern obj_t global_ginfo_pragma_81_globalize_ginfo(global_bglt);
static obj_t _widening_global_ginfo_106_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_the_closure_142_globalize_ginfo(sfun_bglt);
extern long svar_ginfo_mark_222_globalize_ginfo(svar_ginfo_131_bglt);
obj_t local_ginfo_108_globalize_ginfo = BUNSPEC;
static obj_t _local_ginfo_name_80_globalize_ginfo(obj_t, obj_t);
static obj_t _local_ginfo_occurrence_42_globalize_ginfo(obj_t, obj_t);
static obj_t _svar_ginfo_free_mark_set__142_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t method_init_76_globalize_ginfo();
static obj_t _svar_ginfo_celled__set__105_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo_import_set__69_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_integrator_0_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _sfun_ginfo_mark_104_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_occurrence_97_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_the_global_234_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _sfun_ginfo_cfunction_245_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_cfunction_set__96_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _local_ginfo_access_set__98_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo_kaptured__96_globalize_ginfo(obj_t, obj_t);
extern value_bglt global_ginfo_value_89_globalize_ginfo(global_bglt);
extern bool_t local_ginfo__237_globalize_ginfo(obj_t);
extern obj_t global_ginfo_src_234_globalize_ginfo(global_bglt);
extern obj_t sfun_ginfo_integrated_166_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t svar_ginfo_loc_set__72_globalize_ginfo(svar_bglt, obj_t);
static obj_t _make_sexit_ginfo_31_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_dsssl_keywords_set__63_globalize_ginfo(sfun_bglt, obj_t);
extern obj_t global_ginfo_import_118_globalize_ginfo(global_bglt);
extern obj_t sfun_ginfo_the_closure_set__229_globalize_ginfo(sfun_bglt, obj_t);
extern obj_t svar_ginfo_mark_set__188_globalize_ginfo(svar_ginfo_131_bglt, long);
static obj_t _sfun_ginfo_mark_set__60_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo_detached__set__161_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo_src_set__207_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t global_ginfo_removable_set__202_globalize_ginfo(global_bglt, obj_t);
extern obj_t global_ginfo_library__set__196_globalize_ginfo(global_bglt, bool_t);
static obj_t _sfun_ginfo_kaptured_249_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_loc_64_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ginfo_name_set__6_globalize_ginfo(local_bglt, obj_t);
static obj_t _sfun_ginfo_predicate_of_91_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_escape__set__67_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_cto_set__98_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo_user__199_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ginfo_name_216_globalize_ginfo(local_bglt);
static obj_t struct_object__object_local_ginfo1597_81_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _svar_ginfo_free_mark_39_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_umark_set__215_globalize_ginfo(sfun_ginfo_98_bglt, long);
extern sfun_ginfo_98_bglt widening_sfun_ginfo_255_globalize_ginfo(bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, long, long, obj_t, obj_t);
extern obj_t local_ginfo_occurrence_set__71_globalize_ginfo(local_bglt, long);
static obj_t _global_ginfo_removable_35_globalize_ginfo(obj_t, obj_t);
extern obj_t global_ginfo_global_closure_set__44_globalize_ginfo(global_ginfo_75_bglt, obj_t);
static obj_t _sfun_ginfo_cfrom__set__27_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t local_ginfo_id_0_globalize_ginfo(local_bglt);
static obj_t _global_ginfo_type_116_globalize_ginfo(obj_t, obj_t);
static obj_t _allocate_sexit_ginfo_207_globalize_ginfo(obj_t);
static obj_t _svar_ginfo_kaptured__set__94_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _local_ginfo_access_162_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_occurrence_set__43_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _allocate_sfun_ginfo_166_globalize_ginfo(obj_t);
static obj_t _widening_local_ginfo_87_globalize_ginfo(obj_t, obj_t);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t global_ast_var;
extern sexit_ginfo_81_bglt make_sexit_ginfo_64_globalize_ginfo(obj_t, bool_t, bool_t, bool_t, long, long);
extern obj_t sfun_ginfo_g__set__43_globalize_ginfo(sfun_ginfo_98_bglt, bool_t);
extern obj_t global_ginfo_import_set__11_globalize_ginfo(global_bglt, obj_t);
extern obj_t sfun_ginfo_new_body_94_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _svar_ginfo_mark_140_globalize_ginfo(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern type_bglt global_ginfo_type_26_globalize_ginfo(global_bglt);
static obj_t _sfun_ginfo_args_set__97_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_side_effect__207_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_type_set__199_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_free_mark_set__172_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_bmark_119_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_cto__set__57_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _local_ginfo_value_set__165_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t global_ginfo_evaluable__set__37_globalize_ginfo(global_bglt, bool_t);
extern obj_t global_ginfo_module_155_globalize_ginfo(global_bglt);
extern bool_t is_a__118___object(obj_t, obj_t);
extern svar_ginfo_131_bglt widening_svar_ginfo_232_globalize_ginfo(bool_t, long, long, bool_t);
extern obj_t sfun_ginfo_plugged_in_96_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t sfun_ginfo_plugged_in_set__154_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
extern obj_t global_ginfo_id_159_globalize_ginfo(global_bglt);
static obj_t _local_ginfo_fast_alpha_201_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_cto__157_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _sexit_ginfo_mark_set__102_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _allocate_svar_ginfo_235_globalize_ginfo(obj_t);
static obj_t _sfun_ginfo_free_set__78_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo__15_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_cto_162_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_value_set__216_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t object__struct_sexit_ginfo1599_209_globalize_ginfo(obj_t, obj_t);
extern obj_t module_initialization_70_globalize_ginfo(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _sfun_ginfo_stack_allocator_set__72_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_dsssl_keywords_set__93_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_bmark_set__233_globalize_ginfo(obj_t, obj_t, obj_t);
extern bool_t sexit_ginfo_detached__158_globalize_ginfo(sexit_bglt);
static obj_t _global_ginfo_fast_alpha_125_globalize_ginfo(obj_t, obj_t);
extern bool_t global_ginfo_library__79_globalize_ginfo(global_bglt);
static obj_t _local_ginfo_value_88_globalize_ginfo(obj_t, obj_t);
static obj_t _allocate_global_ginfo_49_globalize_ginfo(obj_t);
extern obj_t sfun_ginfo_loc_36_globalize_ginfo(sfun_bglt);
extern obj_t global_ginfo_global_closure_105_globalize_ginfo(global_ginfo_75_bglt);
extern obj_t sfun_ginfo_cfunction_167_globalize_ginfo(sfun_ginfo_98_bglt);
extern bool_t sfun_ginfo_top__136_globalize_ginfo(sfun_bglt);
extern obj_t sfun_ginfo_bound_set__10_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _global_ginfo_escape__31_globalize_ginfo(obj_t, obj_t);
static obj_t _local_ginfo_fast_alpha_set__69_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo_g__set__97_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _local_ginfo__39_globalize_ginfo(obj_t, obj_t);
static obj_t struct_object__object_svar_ginfo1605_206_globalize_ginfo(obj_t, obj_t, obj_t);
extern long sfun_ginfo_bmark_99_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t sfun_ginfo_kaptured_55_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t sfun_ginfo_mark_set__52_globalize_ginfo(sfun_ginfo_98_bglt, long);
extern obj_t sexit_ginfo_detached__set__219_globalize_ginfo(sexit_bglt, bool_t);
extern value_bglt local_ginfo_value_118_globalize_ginfo(local_bglt);
extern long class_num_218___object(obj_t);
extern obj_t sfun_ginfo_side_effect__set__170_globalize_ginfo(sfun_bglt, obj_t);
static obj_t _global_ginfo_access_set__135_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t object__struct_sfun_ginfo1607_35_globalize_ginfo(obj_t, obj_t);
extern obj_t svar_ast_var;
static obj_t _sfun_ginfo_top__set__166_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_cto_set__23_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _sfun_ginfo_dsssl_keywords_15_globalize_ginfo(obj_t, obj_t);
extern bool_t sfun_ginfo_g__97_globalize_ginfo(sfun_ginfo_98_bglt);
extern global_ginfo_75_bglt widening_global_ginfo_207_globalize_ginfo(bool_t, obj_t);
extern long local_ginfo_key_185_globalize_ginfo(local_bglt);
static obj_t _global_ginfo_name_set__203_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _local_ginfo_escape__set__42_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_the_global_set__148_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_loc_set__190_globalize_ginfo(obj_t, obj_t, obj_t);
extern bool_t global_ginfo_evaluable__184_globalize_ginfo(global_bglt);
extern long svar_ginfo_free_mark_225_globalize_ginfo(svar_ginfo_131_bglt);
static obj_t _sfun_ginfo_free_mark_138_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ginfo_user__set__80_globalize_ginfo(local_bglt, bool_t);
extern obj_t sfun_ginfo_stack_allocator_set__224_globalize_ginfo(sfun_bglt, obj_t);
extern obj_t global_ginfo_user__set__96_globalize_ginfo(global_bglt, bool_t);
static obj_t _sfun_ginfo_integrator_set__68_globalize_ginfo(obj_t, obj_t, obj_t);
extern sfun_bglt allocate_sfun_ginfo_135_globalize_ginfo();
static obj_t imported_modules_init_94_globalize_ginfo();
extern sexit_bglt allocate_sexit_ginfo_150_globalize_ginfo();
static obj_t _svar_ginfo_celled__203_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_evaluable__set__222_globalize_ginfo(obj_t, obj_t, obj_t);
obj_t sfun_ginfo_98_globalize_ginfo = BUNSPEC;
extern local_ginfo_108_bglt widening_local_ginfo_191_globalize_ginfo(bool_t);
static obj_t _make_global_ginfo_161_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t sexit_ginfo_kaptured__46_globalize_ginfo(sexit_ginfo_81_bglt);
static obj_t _sexit_ginfo_handler_57_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_property_4_globalize_ginfo(obj_t, obj_t);
static obj_t _svar_ginfo_loc_170_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_id_46_globalize_ginfo(obj_t, obj_t);
static obj_t object__struct_local_ginfo1595_65_globalize_ginfo(obj_t, obj_t);
static obj_t _local_ginfo_type_92_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_cto__143_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_cto_17_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _widening_sfun_ginfo1858_135_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _local_ginfo_removable_228_globalize_ginfo(obj_t, obj_t);
extern obj_t global_ginfo_src_set__129_globalize_ginfo(global_bglt, obj_t);
static obj_t _sfun_ginfo_stack_allocator_12_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_args_set__144_globalize_ginfo(sfun_bglt, obj_t);
static obj_t _sexit_ginfo_mark_211_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_bound_51_globalize_ginfo(obj_t, obj_t);
extern obj_t svar_ginfo_free_mark_set__224_globalize_ginfo(svar_ginfo_131_bglt, long);
extern obj_t svar_ginfo_celled__set__234_globalize_ginfo(svar_ginfo_131_bglt, bool_t);
extern global_ginfo_75_bglt make_global_ginfo_116_globalize_ginfo(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, obj_t, obj_t, bool_t, bool_t, bool_t, obj_t, obj_t, bool_t, obj_t);
static obj_t _sexit_ginfo_g__85_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_the_closure_117_globalize_ginfo(obj_t, obj_t);
static obj_t _sexit_ginfo_free_mark_set__236_globalize_ginfo(obj_t, obj_t, obj_t);
extern long local_ginfo_occurrence_196_globalize_ginfo(local_bglt);
extern long global_ginfo_occurrence_12_globalize_ginfo(global_bglt);
extern obj_t local_ginfo_access_set__117_globalize_ginfo(local_bglt, obj_t);
obj_t sexit_ginfo_81_globalize_ginfo = BUNSPEC;
extern obj_t global_ginfo_access_set__63_globalize_ginfo(global_bglt, obj_t);
extern svar_bglt allocate_svar_ginfo_12_globalize_ginfo();
static obj_t library_modules_init_112_globalize_ginfo();
obj_t global_ginfo_75_globalize_ginfo = BUNSPEC;
static obj_t _sfun_ginfo_top__112_globalize_ginfo(obj_t, obj_t);
obj_t svar_ginfo_131_globalize_ginfo = BUNSPEC;
extern obj_t sfun_ginfo_free_set__132_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _sfun_ginfo_cfrom_60_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_side_effect__set__156_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_body_35_globalize_ginfo(sfun_bglt);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _make_local_ginfo_212_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _local_ginfo_type_set__58_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t local_ginfo_escape__set__30_globalize_ginfo(local_ginfo_108_bglt, bool_t);
static obj_t _sfun_ginfo_property_set__187_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_class_set__214_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_cfunction_set__5_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t global_ginfo_fast_alpha_set__195_globalize_ginfo(global_bglt, obj_t);
extern obj_t sexit_ginfo_g__set__228_globalize_ginfo(sexit_ginfo_81_bglt, bool_t);
extern type_bglt local_ginfo_type_222_globalize_ginfo(local_bglt);
static obj_t _global_ginfo_value_191_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_predicate_of_20_globalize_ginfo(sfun_bglt);
static obj_t toplevel_init_63_globalize_ginfo();
static obj_t _sfun_ginfo_kaptured_set__83_globalize_ginfo(obj_t, obj_t, obj_t);
extern bool_t global_ginfo_escape__39_globalize_ginfo(global_ginfo_75_bglt);
static obj_t _sfun_ginfo_cfrom_set__230_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo_free_mark_164_globalize_ginfo(obj_t, obj_t);
extern obj_t global_ginfo_escape__set__142_globalize_ginfo(global_ginfo_75_bglt, bool_t);
static obj_t _svar_ginfo_kaptured__36_globalize_ginfo(obj_t, obj_t);
extern bool_t global_ginfo_user__167_globalize_ginfo(global_bglt);
static obj_t _local_ginfo_key_243_globalize_ginfo(obj_t, obj_t);
extern long sexit_ginfo_mark_71_globalize_ginfo(sexit_ginfo_81_bglt);
extern obj_t sfun_ginfo_bound_35_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t create_vector(long);
extern obj_t open_input_string(obj_t);
extern sfun_ginfo_98_bglt make_sfun_ginfo_212_globalize_ginfo(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, long, long, obj_t, obj_t);
static obj_t _local_ginfo_removable_set__55_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_top__set__155_globalize_ginfo(sfun_bglt, bool_t);
extern obj_t sfun_ast_var;
extern obj_t svar_ginfo_kaptured__set__85_globalize_ginfo(svar_ginfo_131_bglt, bool_t);
extern obj_t local_ginfo_access_122_globalize_ginfo(local_bglt);
extern obj_t global_ginfo_removable_27_globalize_ginfo(global_bglt);
static obj_t _allocate_local_ginfo_111_globalize_ginfo(obj_t);
static obj_t _sfun_ginfo_integrator_140_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_cfrom__set__37_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
extern obj_t sfun_ginfo_loc_set__94_globalize_ginfo(sfun_bglt, obj_t);
static obj_t _sfun_ginfo_the_closure_set__17_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo_kaptured__set__154_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_body_set__72_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sexit_ginfo_mark_set__228_globalize_ginfo(sexit_ginfo_81_bglt, long);
extern obj_t svar_ginfo_loc_12_globalize_ginfo(svar_bglt);
extern obj_t sfun_ginfo_args_248_globalize_ginfo(sfun_bglt);
extern obj_t sfun_ginfo_cfrom_197_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _local_ginfo_escape__93_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_the_global_149_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_the_global_set__129_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _global_ginfo_removable_set__10_globalize_ginfo(obj_t, obj_t, obj_t);
extern local_ginfo_108_bglt make_local_ginfo_207_globalize_ginfo(obj_t, obj_t, type_bglt, value_bglt, obj_t, obj_t, obj_t, long, bool_t, long, bool_t);
extern obj_t sfun_ginfo_bmark_set__251_globalize_ginfo(sfun_ginfo_98_bglt, long);
static obj_t _sfun_ginfo_integrated_28_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_free_mark_233_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t sfun_ginfo_side_effect__156_globalize_ginfo(sfun_bglt);
static obj_t _global_ginfo_access_134_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_integrator_set__91_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
extern bool_t sexit_ginfo__159_globalize_ginfo(obj_t);
extern global_bglt allocate_global_ginfo_174_globalize_ginfo();
extern obj_t sexit_ginfo_handler_183_globalize_ginfo(sexit_bglt);
extern bool_t sexit_ginfo_g__71_globalize_ginfo(sexit_ginfo_81_bglt);
extern obj_t sfun_ginfo_free_mark_set__121_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _sfun_ginfo_integrated_set__125_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_property_59_globalize_ginfo(sfun_bglt);
static obj_t object__struct_svar_ginfo1603_25_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_name_159_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ast_var;
extern svar_ginfo_131_bglt make_svar_ginfo_120_globalize_ginfo(obj_t, bool_t, long, long, bool_t);
extern obj_t global_ginfo_type_set__85_globalize_ginfo(global_bglt, type_bglt);
static obj_t _svar_ginfo__189_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_g__set__123_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _local_ginfo_name_set__164_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _local_ginfo_occurrence_set__143_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _widening_sexit_ginfo1856_2_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_property_set__8_globalize_ginfo(sfun_bglt, obj_t);
extern obj_t local_ginfo_value_set__11_globalize_ginfo(local_bglt, value_bglt);
extern obj_t global_ginfo_value_set__149_globalize_ginfo(global_bglt, value_bglt);
extern bool_t global_ginfo__175_globalize_ginfo(obj_t);
static obj_t _sfun_ginfo_new_body_set__130_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t _global_ginfo_pragma_91_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ginfo_fast_alpha_set__62_globalize_ginfo(local_bglt, obj_t);
extern obj_t local_ginfo_fast_alpha_16_globalize_ginfo(local_bglt);
extern obj_t global_ginfo_fast_alpha_123_globalize_ginfo(global_bglt);
extern obj_t sfun_ginfo_stack_allocator_225_globalize_ginfo(sfun_bglt);
extern obj_t sfun_ginfo_kaptured_set__247_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _sfun_ginfo_body_12_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_umark_set__110_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo_handler_set__21_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t global_ginfo_name_179_globalize_ginfo(global_bglt);
static obj_t _global_ginfo_fast_alpha_set__99_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_predicate_of_set__49_globalize_ginfo(sfun_bglt, obj_t);
static obj_t _sfun_ginfo_arity_149_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_free_174_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t sexit_ginfo_free_mark_set__210_globalize_ginfo(sexit_ginfo_81_bglt, long);
static obj_t object_init_111_globalize_ginfo();
static obj_t _sfun_ginfo_umark_199_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo_class_139_globalize_ginfo(obj_t, obj_t);
extern bool_t svar_ginfo__247_globalize_ginfo(obj_t);
static obj_t object__struct_global_ginfo1591_167_globalize_ginfo(obj_t, obj_t);
static obj_t _sfun_ginfo__175_globalize_ginfo(obj_t, obj_t);
static obj_t _svar_ginfo_mark_set__68_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _svar_ginfo_loc_set__201_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo_library__set__55_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _make_sfun_ginfo_29_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _widening_svar_ginfo1857_103_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _global_ginfo_import_201_globalize_ginfo(obj_t, obj_t);
extern long sfun_ginfo_mark_177_globalize_ginfo(sfun_ginfo_98_bglt);
extern obj_t sexit_ast_var;
static obj_t _local_ginfo_user__17_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_dsssl_keywords_77_globalize_ginfo(sfun_bglt);
static obj_t _sfun_ginfo_plugged_in_98_globalize_ginfo(obj_t, obj_t);
static obj_t struct_object__object_global_ginfo1593_126_globalize_ginfo(obj_t, obj_t, obj_t);
extern bool_t svar_ginfo_kaptured__26_globalize_ginfo(svar_ginfo_131_bglt);
extern obj_t local_ginfo_removable_170_globalize_ginfo(local_bglt);
static obj_t _sfun_ginfo_args_85_globalize_ginfo(obj_t, obj_t);
extern obj_t read___reader(obj_t);
static obj_t _global_ginfo_global_closure_242_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ginfo_removable_set__201_globalize_ginfo(local_bglt, obj_t);
extern bool_t sfun_ginfo__192_globalize_ginfo(obj_t);
extern obj_t global_ginfo_name_set__78_globalize_ginfo(global_bglt, obj_t);
extern long sfun_ginfo_arity_67_globalize_ginfo(sfun_bglt);
static obj_t _sexit_ginfo_detached__10_globalize_ginfo(obj_t, obj_t);
extern bool_t local_ginfo_user__24_globalize_ginfo(local_bglt);
extern bool_t svar_ginfo_celled__246_globalize_ginfo(svar_ginfo_131_bglt);
static obj_t _global_ginfo_library__228_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_new_body_set__157_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
static obj_t _sfun_ginfo_cfrom__56_globalize_ginfo(obj_t, obj_t);
extern long sfun_ginfo_umark_66_globalize_ginfo(sfun_ginfo_98_bglt);
extern bool_t local_ginfo_escape__169_globalize_ginfo(local_ginfo_108_bglt);
extern local_bglt allocate_local_ginfo_201_globalize_ginfo();
static obj_t _sfun_ginfo_g__247_globalize_ginfo(obj_t, obj_t);
static obj_t _local_ginfo_user__set__23_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t sfun_ginfo_class_109_globalize_ginfo(sfun_bglt);
extern obj_t sexit_ginfo_handler_set__242_globalize_ginfo(sexit_bglt, obj_t);
extern obj_t sfun_ginfo_body_set__10_globalize_ginfo(sfun_bglt, obj_t);
extern obj_t sexit_ginfo_kaptured__set__207_globalize_ginfo(sexit_ginfo_81_bglt, bool_t);
static obj_t _make_svar_ginfo_118_globalize_ginfo(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_bound_set__169_globalize_ginfo(obj_t, obj_t, obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern obj_t global_ginfo_access_77_globalize_ginfo(global_bglt);
static obj_t _global_ginfo_global_closure_set__101_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo_evaluable__153_globalize_ginfo(obj_t, obj_t);
static obj_t _global_ginfo_src_46_globalize_ginfo(obj_t, obj_t);
extern obj_t local_ginfo_type_set__188_globalize_ginfo(local_bglt, type_bglt);
static obj_t require_initialization_114_globalize_ginfo = BUNSPEC;
extern sexit_ginfo_81_bglt widening_sexit_ginfo_80_globalize_ginfo(bool_t, bool_t, long, long);
static obj_t _global_ginfo_user__set__110_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t struct_object__object_sexit_ginfo1601_72_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_new_body_82_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_cfrom__184_globalize_ginfo(sfun_ginfo_98_bglt);
static obj_t _sfun_ginfo_predicate_of_set__167_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _local_ginfo_id_24_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_class_set__182_globalize_ginfo(sfun_bglt, obj_t);
static obj_t _sfun_ginfo_cto__set__232_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sexit_ginfo__121_globalize_ginfo(obj_t, obj_t);
extern obj_t sfun_ginfo_integrated_set__252_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
extern obj_t sfun_ginfo_cfrom_set__112_globalize_ginfo(sfun_ginfo_98_bglt, obj_t);
extern obj_t global_ginfo_occurrence_set__72_globalize_ginfo(global_bglt, long);
extern long sexit_ginfo_free_mark_205_globalize_ginfo(sexit_ginfo_81_bglt);
static obj_t cnst_init_137_globalize_ginfo();
static obj_t _sfun_ginfo_plugged_in_set__9_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _sfun_ginfo_free_179_globalize_ginfo(obj_t, obj_t);
static obj_t struct_object__object_sfun_ginfo1609_15_globalize_ginfo(obj_t, obj_t, obj_t);
static obj_t _global_ginfo_module_172_globalize_ginfo(obj_t, obj_t);
static obj_t __cnst[5];

DEFINE_EXPORT_PROCEDURE(global_ginfo_type_set__env_171_globalize_ginfo, _global_ginfo_type_set__199_globalize_ginfo1877, _global_ginfo_type_set__199_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_fast_alpha_env_165_globalize_ginfo, _local_ginfo_fast_alpha_201_globalize_ginfo1878, _local_ginfo_fast_alpha_201_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_sfun_ginfo_env_145_globalize_ginfo, _make_sfun_ginfo_29_globalize_ginfo1879, _make_sfun_ginfo_29_globalize_ginfo, 0L, 30);
DEFINE_EXPORT_PROCEDURE(allocate_local_ginfo_env_148_globalize_ginfo, _allocate_local_ginfo_111_globalize_ginfo1880, _allocate_local_ginfo_111_globalize_ginfo, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_args_set__env_243_globalize_ginfo, _sfun_ginfo_args_set__97_globalize_ginfo1881, _sfun_ginfo_args_set__97_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_occurrence_env_74_globalize_ginfo, _global_ginfo_occurrence_97_globalize_ginfo1882, _global_ginfo_occurrence_97_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_free_mark_set__env_100_globalize_ginfo, _sfun_ginfo_free_mark_set__172_globalize_ginfo1883, _sfun_ginfo_free_mark_set__172_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_handler_set__env_200_globalize_ginfo, _sexit_ginfo_handler_set__21_globalize_ginfo1884, _sexit_ginfo_handler_set__21_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo__env_30_globalize_ginfo, _local_ginfo__39_globalize_ginfo1885, _local_ginfo__39_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_free_mark_set__env_33_globalize_ginfo, _svar_ginfo_free_mark_set__142_globalize_ginfo1886, _svar_ginfo_free_mark_set__142_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_property_set__env_130_globalize_ginfo, _sfun_ginfo_property_set__187_globalize_ginfo1887, _sfun_ginfo_property_set__187_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_top__set__env_228_globalize_ginfo, _sfun_ginfo_top__set__166_globalize_ginfo1888, _sfun_ginfo_top__set__166_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_kaptured__set__env_8_globalize_ginfo, _sexit_ginfo_kaptured__set__154_globalize_ginfo1889, _sexit_ginfo_kaptured__set__154_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_celled__set__env_144_globalize_ginfo, _svar_ginfo_celled__set__105_globalize_ginfo1890, _svar_ginfo_celled__set__105_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_occurrence_set__env_13_globalize_ginfo, _global_ginfo_occurrence_set__43_globalize_ginfo1891, _global_ginfo_occurrence_set__43_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_access_set__env_111_globalize_ginfo, _global_ginfo_access_set__135_globalize_ginfo1892, _global_ginfo_access_set__135_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_mark_set__env_140_globalize_ginfo, _sexit_ginfo_mark_set__102_globalize_ginfo1893, _sexit_ginfo_mark_set__102_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_free_mark_env_76_globalize_ginfo, _sexit_ginfo_free_mark_164_globalize_ginfo1894, _sexit_ginfo_free_mark_164_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_removable_set__env_69_globalize_ginfo, _global_ginfo_removable_set__10_globalize_ginfo1895, _global_ginfo_removable_set__10_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_global_ginfo_env_8_globalize_ginfo, _widening_global_ginfo_106_globalize_ginfo1896, _widening_global_ginfo_106_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_kaptured__env_28_globalize_ginfo, _sexit_ginfo_kaptured__96_globalize_ginfo1897, _sexit_ginfo_kaptured__96_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cfrom_env_244_globalize_ginfo, _sfun_ginfo_cfrom_60_globalize_ginfo1898, _sfun_ginfo_cfrom_60_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_fast_alpha_set__env_57_globalize_ginfo, _global_ginfo_fast_alpha_set__99_globalize_ginfo1899, _global_ginfo_fast_alpha_set__99_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_sfun_ginfo_env_18_globalize_ginfo, _allocate_sfun_ginfo_166_globalize_ginfo1900, _allocate_sfun_ginfo_166_globalize_ginfo, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_free_env_156_globalize_ginfo, _sfun_ginfo_free_179_globalize_ginfo1901, _sfun_ginfo_free_179_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_dsssl_keywords_set__env_111_globalize_ginfo, _sfun_ginfo_dsssl_keywords_set__93_globalize_ginfo1902, _sfun_ginfo_dsssl_keywords_set__93_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_escape__env_182_globalize_ginfo, _local_ginfo_escape__93_globalize_ginfo1903, _local_ginfo_escape__93_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_fast_alpha_env_229_globalize_ginfo, _global_ginfo_fast_alpha_125_globalize_ginfo1904, _global_ginfo_fast_alpha_125_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_escape__env_230_globalize_ginfo, _global_ginfo_escape__31_globalize_ginfo1905, _global_ginfo_escape__31_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_free_mark_set__env_38_globalize_ginfo, _sexit_ginfo_free_mark_set__236_globalize_ginfo1906, _sexit_ginfo_free_mark_set__236_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_bmark_set__env_173_globalize_ginfo, _sfun_ginfo_bmark_set__233_globalize_ginfo1907, _sfun_ginfo_bmark_set__233_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_the_global_env_144_globalize_ginfo, _sfun_ginfo_the_global_149_globalize_ginfo1908, _sfun_ginfo_the_global_149_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_bmark_env_184_globalize_ginfo, _sfun_ginfo_bmark_119_globalize_ginfo1909, _sfun_ginfo_bmark_119_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_removable_set__env_148_globalize_ginfo, _local_ginfo_removable_set__55_globalize_ginfo1910, _local_ginfo_removable_set__55_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_kaptured_env_231_globalize_ginfo, _sfun_ginfo_kaptured_249_globalize_ginfo1911, _sfun_ginfo_kaptured_249_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_pragma_env_226_globalize_ginfo, _global_ginfo_pragma_91_globalize_ginfo1912, _global_ginfo_pragma_91_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_class_env_45_globalize_ginfo, _sfun_ginfo_class_139_globalize_ginfo1913, _sfun_ginfo_class_139_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cfunction_set__env_158_globalize_ginfo, _sfun_ginfo_cfunction_set__5_globalize_ginfo1914, _sfun_ginfo_cfunction_set__5_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_module_env_228_globalize_ginfo, _global_ginfo_module_172_globalize_ginfo1915, _global_ginfo_module_172_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cto_set__env_241_globalize_ginfo, _sfun_ginfo_cto_set__98_globalize_ginfo1916, _sfun_ginfo_cto_set__98_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_mark_env_97_globalize_ginfo, _svar_ginfo_mark_140_globalize_ginfo1917, _svar_ginfo_mark_140_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_the_closure_env_160_globalize_ginfo, _sfun_ginfo_the_closure_117_globalize_ginfo1918, _sfun_ginfo_the_closure_117_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1871_globalize_ginfo, struct_object__object_sfun_ginfo1609_15_globalize_ginfo1919, struct_object__object_sfun_ginfo1609_15_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1869_globalize_ginfo, struct_object__object_svar_ginfo1605_206_globalize_ginfo1920, struct_object__object_svar_ginfo1605_206_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1870_globalize_ginfo, object__struct_sfun_ginfo1607_35_globalize_ginfo1921, object__struct_sfun_ginfo1607_35_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1868_globalize_ginfo, object__struct_svar_ginfo1603_25_globalize_ginfo1922, object__struct_svar_ginfo1603_25_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1867_globalize_ginfo, struct_object__object_sexit_ginfo1601_72_globalize_ginfo1923, struct_object__object_sexit_ginfo1601_72_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1866_globalize_ginfo, object__struct_sexit_ginfo1599_209_globalize_ginfo1924, object__struct_sexit_ginfo1599_209_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1865_globalize_ginfo, struct_object__object_local_ginfo1597_81_globalize_ginfo1925, struct_object__object_local_ginfo1597_81_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1864_globalize_ginfo, object__struct_local_ginfo1595_65_globalize_ginfo1926, object__struct_local_ginfo1595_65_globalize_ginfo, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1863_globalize_ginfo, struct_object__object_global_ginfo1593_126_globalize_ginfo1927, struct_object__object_global_ginfo1593_126_globalize_ginfo, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1862_globalize_ginfo, object__struct_global_ginfo1591_167_globalize_ginfo1928, object__struct_global_ginfo1591_167_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_g__env_247_globalize_ginfo, _sfun_ginfo_g__247_globalize_ginfo1929, _sfun_ginfo_g__247_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_access_set__env_135_globalize_ginfo, _local_ginfo_access_set__98_globalize_ginfo1930, _local_ginfo_access_set__98_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_loc_set__env_0_globalize_ginfo, _sfun_ginfo_loc_set__190_globalize_ginfo1931, _sfun_ginfo_loc_set__190_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_sexit_ginfo_env_134_globalize_ginfo, _widening_sexit_ginfo1856_2_globalize_ginfo1932, _widening_sexit_ginfo1856_2_globalize_ginfo, 0L, 4);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_plugged_in_env_158_globalize_ginfo, _sfun_ginfo_plugged_in_98_globalize_ginfo1933, _sfun_ginfo_plugged_in_98_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_name_set__env_15_globalize_ginfo, _local_ginfo_name_set__164_globalize_ginfo1934, _local_ginfo_name_set__164_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_side_effect__set__env_89_globalize_ginfo, _sfun_ginfo_side_effect__set__156_globalize_ginfo1935, _sfun_ginfo_side_effect__set__156_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_user__env_187_globalize_ginfo, _global_ginfo_user__199_globalize_ginfo1936, _global_ginfo_user__199_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_stack_allocator_set__env_33_globalize_ginfo, _sfun_ginfo_stack_allocator_set__72_globalize_ginfo1937, _sfun_ginfo_stack_allocator_set__72_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_src_env_144_globalize_ginfo, _global_ginfo_src_46_globalize_ginfo1938, _global_ginfo_src_46_globalize_ginfo, 0L, 1);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(make_global_ginfo_env_159_globalize_ginfo, _make_global_ginfo_161_globalize_ginfo1939, _make_global_ginfo_161_globalize_ginfo, 0L, 17);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_umark_set__env_167_globalize_ginfo, _sfun_ginfo_umark_set__110_globalize_ginfo1940, _sfun_ginfo_umark_set__110_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_loc_env_174_globalize_ginfo, _sfun_ginfo_loc_64_globalize_ginfo1941, _sfun_ginfo_loc_64_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_mark_env_136_globalize_ginfo, _sexit_ginfo_mark_211_globalize_ginfo1942, _sexit_ginfo_mark_211_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_sfun_ginfo_env_194_globalize_ginfo, _widening_sfun_ginfo1858_135_globalize_ginfo1943, _widening_sfun_ginfo1858_135_globalize_ginfo, 0L, 18);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_integrator_env_93_globalize_ginfo, _sfun_ginfo_integrator_140_globalize_ginfo1944, _sfun_ginfo_integrator_140_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_type_env_97_globalize_ginfo, _local_ginfo_type_92_globalize_ginfo1945, _local_ginfo_type_92_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_g__set__env_140_globalize_ginfo, _sexit_ginfo_g__set__97_globalize_ginfo1946, _sexit_ginfo_g__set__97_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_svar_ginfo_env_192_globalize_ginfo, _make_svar_ginfo_118_globalize_ginfo1947, _make_svar_ginfo_118_globalize_ginfo, 0L, 5);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_dsssl_keywords_env_169_globalize_ginfo, _sfun_ginfo_dsssl_keywords_15_globalize_ginfo1948, _sfun_ginfo_dsssl_keywords_15_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_the_global_set__env_10_globalize_ginfo, _sfun_ginfo_the_global_set__148_globalize_ginfo1949, _sfun_ginfo_the_global_set__148_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo__env_139_globalize_ginfo, _sexit_ginfo__121_globalize_ginfo1950, _sexit_ginfo__121_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_src_set__env_10_globalize_ginfo, _global_ginfo_src_set__207_globalize_ginfo1951, _global_ginfo_src_set__207_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_escape__set__env_193_globalize_ginfo, _local_ginfo_escape__set__42_globalize_ginfo1952, _local_ginfo_escape__set__42_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_class_set__env_127_globalize_ginfo, _sfun_ginfo_class_set__214_globalize_ginfo1953, _sfun_ginfo_class_set__214_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_stack_allocator_env_118_globalize_ginfo, _sfun_ginfo_stack_allocator_12_globalize_ginfo1954, _sfun_ginfo_stack_allocator_12_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cto__set__env_240_globalize_ginfo, _sfun_ginfo_cto__set__232_globalize_ginfo1955, _sfun_ginfo_cto__set__232_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_sexit_ginfo_env_41_globalize_ginfo, _make_sexit_ginfo_31_globalize_ginfo1956, _make_sexit_ginfo_31_globalize_ginfo, 0L, 6);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_g__env_136_globalize_ginfo, _sexit_ginfo_g__85_globalize_ginfo1957, _sexit_ginfo_g__85_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_top__env_137_globalize_ginfo, _sfun_ginfo_top__112_globalize_ginfo1958, _sfun_ginfo_top__112_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_bound_set__env_71_globalize_ginfo, _sfun_ginfo_bound_set__169_globalize_ginfo1959, _sfun_ginfo_bound_set__169_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_type_env_252_globalize_ginfo, _global_ginfo_type_116_globalize_ginfo1960, _global_ginfo_type_116_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_removable_env_89_globalize_ginfo, _local_ginfo_removable_228_globalize_ginfo1961, _local_ginfo_removable_228_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_local_ginfo_env_2_globalize_ginfo, _widening_local_ginfo_87_globalize_ginfo1962, _widening_local_ginfo_87_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_value_set__env_186_globalize_ginfo, _local_ginfo_value_set__165_globalize_ginfo1963, _local_ginfo_value_set__165_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cfrom_set__env_202_globalize_ginfo, _sfun_ginfo_cfrom_set__230_globalize_ginfo1964, _sfun_ginfo_cfrom_set__230_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_side_effect__env_108_globalize_ginfo, _sfun_ginfo_side_effect__207_globalize_ginfo1965, _sfun_ginfo_side_effect__207_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_svar_ginfo_env_74_globalize_ginfo, _allocate_svar_ginfo_235_globalize_ginfo1966, _allocate_svar_ginfo_235_globalize_ginfo, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_plugged_in_set__env_58_globalize_ginfo, _sfun_ginfo_plugged_in_set__9_globalize_ginfo1967, _sfun_ginfo_plugged_in_set__9_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_user__env_6_globalize_ginfo, _local_ginfo_user__17_globalize_ginfo1968, _local_ginfo_user__17_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_integrator_set__env_87_globalize_ginfo, _sfun_ginfo_integrator_set__68_globalize_ginfo1969, _sfun_ginfo_integrator_set__68_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_args_env_124_globalize_ginfo, _sfun_ginfo_args_85_globalize_ginfo1970, _sfun_ginfo_args_85_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_celled__env_50_globalize_ginfo, _svar_ginfo_celled__203_globalize_ginfo1971, _svar_ginfo_celled__203_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_library__set__env_105_globalize_ginfo, _global_ginfo_library__set__55_globalize_ginfo1972, _global_ginfo_library__set__55_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cfrom__env_161_globalize_ginfo, _sfun_ginfo_cfrom__56_globalize_ginfo1973, _sfun_ginfo_cfrom__56_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_new_body_env_0_globalize_ginfo, _sfun_ginfo_new_body_82_globalize_ginfo1974, _sfun_ginfo_new_body_82_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cfunction_env_187_globalize_ginfo, _sfun_ginfo_cfunction_245_globalize_ginfo1975, _sfun_ginfo_cfunction_245_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_local_ginfo_env_8_globalize_ginfo, _make_local_ginfo_212_globalize_ginfo1976, _make_local_ginfo_212_globalize_ginfo, 0L, 11);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_umark_env_86_globalize_ginfo, _sfun_ginfo_umark_199_globalize_ginfo1977, _sfun_ginfo_umark_199_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_kaptured_set__env_62_globalize_ginfo, _sfun_ginfo_kaptured_set__83_globalize_ginfo1978, _sfun_ginfo_kaptured_set__83_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo__env_142_globalize_ginfo, _sfun_ginfo__175_globalize_ginfo1979, _sfun_ginfo__175_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_id_env_93_globalize_ginfo, _local_ginfo_id_24_globalize_ginfo1980, _local_ginfo_id_24_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_mark_set__env_14_globalize_ginfo, _svar_ginfo_mark_set__68_globalize_ginfo1981, _svar_ginfo_mark_set__68_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_the_closure_set__env_218_globalize_ginfo, _sfun_ginfo_the_closure_set__17_globalize_ginfo1982, _sfun_ginfo_the_closure_set__17_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_free_mark_env_118_globalize_ginfo, _svar_ginfo_free_mark_39_globalize_ginfo1983, _svar_ginfo_free_mark_39_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_type_set__env_14_globalize_ginfo, _local_ginfo_type_set__58_globalize_ginfo1984, _local_ginfo_type_set__58_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_name_set__env_249_globalize_ginfo, _global_ginfo_name_set__203_globalize_ginfo1985, _global_ginfo_name_set__203_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_kaptured__env_252_globalize_ginfo, _svar_ginfo_kaptured__36_globalize_ginfo1986, _svar_ginfo_kaptured__36_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_mark_set__env_59_globalize_ginfo, _sfun_ginfo_mark_set__60_globalize_ginfo1987, _sfun_ginfo_mark_set__60_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cfrom__set__env_121_globalize_ginfo, _sfun_ginfo_cfrom__set__27_globalize_ginfo1988, _sfun_ginfo_cfrom__set__27_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_free_mark_env_40_globalize_ginfo, _sfun_ginfo_free_mark_138_globalize_ginfo1989, _sfun_ginfo_free_mark_138_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_value_env_133_globalize_ginfo, _global_ginfo_value_191_globalize_ginfo1990, _global_ginfo_value_191_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_body_set__env_71_globalize_ginfo, _sfun_ginfo_body_set__72_globalize_ginfo1991, _sfun_ginfo_body_set__72_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_svar_ginfo_env_96_globalize_ginfo, _widening_svar_ginfo1857_103_globalize_ginfo1992, _widening_svar_ginfo1857_103_globalize_ginfo, 0L, 4);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_body_env_44_globalize_ginfo, _sfun_ginfo_body_12_globalize_ginfo1993, _sfun_ginfo_body_12_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_g__set__env_37_globalize_ginfo, _sfun_ginfo_g__set__123_globalize_ginfo1994, _sfun_ginfo_g__set__123_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_user__set__env_134_globalize_ginfo, _local_ginfo_user__set__23_globalize_ginfo1995, _local_ginfo_user__set__23_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_value_set__env_191_globalize_ginfo, _global_ginfo_value_set__216_globalize_ginfo1996, _global_ginfo_value_set__216_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo__env_176_globalize_ginfo, _global_ginfo__15_globalize_ginfo1997, _global_ginfo__15_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_bound_env_44_globalize_ginfo, _sfun_ginfo_bound_51_globalize_ginfo1998, _sfun_ginfo_bound_51_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cto_env_195_globalize_ginfo, _sfun_ginfo_cto_162_globalize_ginfo1999, _sfun_ginfo_cto_162_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_global_closure_set__env_43_globalize_ginfo, _global_ginfo_global_closure_set__101_globalize_ginfo2000, _global_ginfo_global_closure_set__101_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_predicate_of_set__env_110_globalize_ginfo, _sfun_ginfo_predicate_of_set__167_globalize_ginfo2001, _sfun_ginfo_predicate_of_set__167_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_key_env_203_globalize_ginfo, _local_ginfo_key_243_globalize_ginfo2002, _local_ginfo_key_243_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_predicate_of_env_49_globalize_ginfo, _sfun_ginfo_predicate_of_91_globalize_ginfo2003, _sfun_ginfo_predicate_of_91_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_ginfo__env_62_globalize_ginfo, _svar_ginfo__189_globalize_ginfo2004, _svar_ginfo__189_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_handler_env_122_globalize_ginfo, _sexit_ginfo_handler_57_globalize_ginfo2005, _sexit_ginfo_handler_57_globalize_ginfo, 0L, 1);
DEFINE_STRING(string1872_globalize_ginfo, string1872_globalize_ginfo2006, "GLOBAL/GINFO LOCAL/GINFO SEXIT/GINFO SVAR/GINFO SFUN/GINFO ", 59);
DEFINE_EXPORT_PROCEDURE(global_ginfo_removable_env_64_globalize_ginfo, _global_ginfo_removable_35_globalize_ginfo2007, _global_ginfo_removable_35_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_library__env_141_globalize_ginfo, _global_ginfo_library__228_globalize_ginfo2008, _global_ginfo_library__228_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_free_set__env_104_globalize_ginfo, _sfun_ginfo_free_set__78_globalize_ginfo2009, _sfun_ginfo_free_set__78_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_name_env_213_globalize_ginfo, _local_ginfo_name_80_globalize_ginfo2010, _local_ginfo_name_80_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_sexit_ginfo_env_9_globalize_ginfo, _allocate_sexit_ginfo_207_globalize_ginfo2011, _allocate_sexit_ginfo_207_globalize_ginfo, 0L, 0);
DEFINE_EXPORT_PROCEDURE(local_ginfo_occurrence_env_105_globalize_ginfo, _local_ginfo_occurrence_42_globalize_ginfo2012, _local_ginfo_occurrence_42_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_import_env_220_globalize_ginfo, _global_ginfo_import_201_globalize_ginfo2013, _global_ginfo_import_201_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_evaluable__env_161_globalize_ginfo, _global_ginfo_evaluable__153_globalize_ginfo2014, _global_ginfo_evaluable__153_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_evaluable__set__env_121_globalize_ginfo, _global_ginfo_evaluable__set__222_globalize_ginfo2015, _global_ginfo_evaluable__set__222_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_mark_env_7_globalize_ginfo, _sfun_ginfo_mark_104_globalize_ginfo2016, _sfun_ginfo_mark_104_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_arity_env_109_globalize_ginfo, _sfun_ginfo_arity_149_globalize_ginfo2017, _sfun_ginfo_arity_149_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_integrated_set__env_175_globalize_ginfo, _sfun_ginfo_integrated_set__125_globalize_ginfo2018, _sfun_ginfo_integrated_set__125_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_property_env_119_globalize_ginfo, _sfun_ginfo_property_4_globalize_ginfo2019, _sfun_ginfo_property_4_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_value_env_220_globalize_ginfo, _local_ginfo_value_88_globalize_ginfo2020, _local_ginfo_value_88_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_detached__set__env_11_globalize_ginfo, _sexit_ginfo_detached__set__161_globalize_ginfo2021, _sexit_ginfo_detached__set__161_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_escape__set__env_160_globalize_ginfo, _global_ginfo_escape__set__67_globalize_ginfo2022, _global_ginfo_escape__set__67_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_name_env_112_globalize_ginfo, _global_ginfo_name_159_globalize_ginfo2023, _global_ginfo_name_159_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_user__set__env_158_globalize_ginfo, _global_ginfo_user__set__110_globalize_ginfo2024, _global_ginfo_user__set__110_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_integrated_env_242_globalize_ginfo, _sfun_ginfo_integrated_28_globalize_ginfo2025, _sfun_ginfo_integrated_28_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_loc_env_74_globalize_ginfo, _svar_ginfo_loc_170_globalize_ginfo2026, _svar_ginfo_loc_170_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_id_env_139_globalize_ginfo, _global_ginfo_id_46_globalize_ginfo2027, _global_ginfo_id_46_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_global_closure_env_166_globalize_ginfo, _global_ginfo_global_closure_242_globalize_ginfo2028, _global_ginfo_global_closure_242_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(global_ginfo_import_set__env_186_globalize_ginfo, _global_ginfo_import_set__69_globalize_ginfo2029, _global_ginfo_import_set__69_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_loc_set__env_13_globalize_ginfo, _svar_ginfo_loc_set__201_globalize_ginfo2030, _svar_ginfo_loc_set__201_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_cto__env_24_globalize_ginfo, _sfun_ginfo_cto__143_globalize_ginfo2031, _sfun_ginfo_cto__143_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_ginfo_new_body_set__env_24_globalize_ginfo, _sfun_ginfo_new_body_set__130_globalize_ginfo2032, _sfun_ginfo_new_body_set__130_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(local_ginfo_occurrence_set__env_136_globalize_ginfo, _local_ginfo_occurrence_set__143_globalize_ginfo2033, _local_ginfo_occurrence_set__143_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_ginfo_detached__env_48_globalize_ginfo, _sexit_ginfo_detached__10_globalize_ginfo2034, _sexit_ginfo_detached__10_globalize_ginfo, 0L, 1);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(local_ginfo_access_env_238_globalize_ginfo, _local_ginfo_access_162_globalize_ginfo2035, _local_ginfo_access_162_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_ginfo_kaptured__set__env_171_globalize_ginfo, _svar_ginfo_kaptured__set__94_globalize_ginfo2036, _svar_ginfo_kaptured__set__94_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(global_ginfo_access_env_169_globalize_ginfo, _global_ginfo_access_134_globalize_ginfo2037, _global_ginfo_access_134_globalize_ginfo, 0L, 1);
DEFINE_EXPORT_PROCEDURE(local_ginfo_fast_alpha_set__env_3_globalize_ginfo, _local_ginfo_fast_alpha_set__69_globalize_ginfo2038, _local_ginfo_fast_alpha_set__69_globalize_ginfo, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_global_ginfo_env_156_globalize_ginfo, _allocate_global_ginfo_49_globalize_ginfo2039, _allocate_global_ginfo_49_globalize_ginfo, 0L, 0);



/* module-initialization */
obj_t 
module_initialization_70_globalize_ginfo(long checksum_2752, char *from_2753)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_globalize_ginfo))
	{
	   require_initialization_114_globalize_ginfo =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_globalize_ginfo();
	   cnst_init_137_globalize_ginfo();
	   imported_modules_init_94_globalize_ginfo();
	   object_init_111_globalize_ginfo();
	   method_init_76_globalize_ginfo();
	   toplevel_init_63_globalize_ginfo();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 14 */
      module_initialization_70___object(((long) 0), "GLOBALIZE_GINFO");
      module_initialization_70___reader(((long) 0), "GLOBALIZE_GINFO");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 14 */
      {		/* Globalize/ginfo.scm 14 */
	 obj_t cnst_port_138_2745;
	 cnst_port_138_2745 =
	    open_input_string(string1872_globalize_ginfo);
	 {
	    long i_2746;
	    i_2746 = ((long) 4);
	  loop_2747:
	    {	/* Globalize/ginfo.scm 14 */
	       bool_t test1873_2748;
	       test1873_2748 =
		  (i_2746 == ((long) -1));
	       if (test1873_2748)
		 {	/* Globalize/ginfo.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Globalize/ginfo.scm 14 */
		    {	/* Globalize/ginfo.scm 14 */
		       obj_t arg1874_2749;
		       {	/* Globalize/ginfo.scm 14 */
			  obj_t list1875_2750;
			  list1875_2750 =
			     MAKE_PAIR(cnst_port_138_2745, BNIL);
			  arg1874_2749 =
			     read___reader(list1875_2750);
		       }
		       CNST_TABLE_SET(i_2746, arg1874_2749);
		    }
		    {	/* Globalize/ginfo.scm 14 */
		       int aux_2751;
		       {	/* Globalize/ginfo.scm 14 */
			  long aux_2771;
			  aux_2771 =
			     (i_2746 - ((long) 1));
			  aux_2751 =
			     (int) (aux_2771);
		       }
		       {
			  long i_2774;
			  i_2774 =
			     (long) (aux_2751);
			  i_2746 = i_2774;
			  goto loop_2747;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 14 */
      {		/* Globalize/ginfo.scm 14 */
	 obj_t arg1610_1009;
	 obj_t arg1611_1010;
	 obj_t arg1614_1013;
	 arg1610_1009 =
	    CNST_TABLE_REF(((long) 0));
	 arg1611_1010 = sfun_ast_var;
	 {	/* Globalize/ginfo.scm 14 */
	    obj_t v1585_1014;
	    v1585_1014 =
	       create_vector(((long) 0));
	    arg1614_1013 = v1585_1014;
	 }
	 sfun_ginfo_98_globalize_ginfo =
	    register_class__225___object(arg1610_1009, arg1611_1010, allocate_sfun_ginfo_env_18_globalize_ginfo, ((long) 34613), BUNSPEC, BFALSE, arg1614_1013);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t arg1615_1015;
	 obj_t arg1616_1016;
	 obj_t arg1619_1019;
	 arg1615_1015 =
	    CNST_TABLE_REF(((long) 1));
	 arg1616_1016 = svar_ast_var;
	 {	/* Globalize/ginfo.scm 14 */
	    obj_t v1586_1020;
	    v1586_1020 =
	       create_vector(((long) 0));
	    arg1619_1019 = v1586_1020;
	 }
	 svar_ginfo_131_globalize_ginfo =
	    register_class__225___object(arg1615_1015, arg1616_1016, allocate_svar_ginfo_env_74_globalize_ginfo, ((long) 63184), BUNSPEC, BFALSE, arg1619_1019);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t arg1620_1021;
	 obj_t arg1621_1022;
	 obj_t arg1624_1025;
	 arg1620_1021 =
	    CNST_TABLE_REF(((long) 2));
	 arg1621_1022 = sexit_ast_var;
	 {	/* Globalize/ginfo.scm 14 */
	    obj_t v1587_1026;
	    v1587_1026 =
	       create_vector(((long) 0));
	    arg1624_1025 = v1587_1026;
	 }
	 sexit_ginfo_81_globalize_ginfo =
	    register_class__225___object(arg1620_1021, arg1621_1022, allocate_sexit_ginfo_env_9_globalize_ginfo, ((long) 40351), BUNSPEC, BFALSE, arg1624_1025);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t arg1625_1027;
	 obj_t arg1626_1028;
	 obj_t arg1629_1031;
	 arg1625_1027 =
	    CNST_TABLE_REF(((long) 3));
	 arg1626_1028 = local_ast_var;
	 {	/* Globalize/ginfo.scm 14 */
	    obj_t v1588_1032;
	    v1588_1032 =
	       create_vector(((long) 0));
	    arg1629_1031 = v1588_1032;
	 }
	 local_ginfo_108_globalize_ginfo =
	    register_class__225___object(arg1625_1027, arg1626_1028, allocate_local_ginfo_env_148_globalize_ginfo, ((long) 60317), BUNSPEC, BFALSE, arg1629_1031);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t arg1630_1033;
	 obj_t arg1631_1034;
	 obj_t arg1634_1037;
	 arg1630_1033 =
	    CNST_TABLE_REF(((long) 4));
	 arg1631_1034 = global_ast_var;
	 {	/* Globalize/ginfo.scm 14 */
	    obj_t v1589_1038;
	    v1589_1038 =
	       create_vector(((long) 0));
	    arg1634_1037 = v1589_1038;
	 }
	 global_ginfo_75_globalize_ginfo =
	    register_class__225___object(arg1630_1033, arg1631_1034, allocate_global_ginfo_env_156_globalize_ginfo, ((long) 8248), BUNSPEC, BFALSE, arg1634_1037);
      }
      return BUNSPEC;
   }
}



/* allocate-global/ginfo */
global_bglt 
allocate_global_ginfo_174_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 global_bglt new1578_1039;
	 new1578_1039 =
	    ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	 {	/* Globalize/ginfo.scm 80 */
	    long arg1635_1040;
	    arg1635_1040 =
	       class_num_218___object(global_ginfo_75_globalize_ginfo);
	    {	/* Globalize/ginfo.scm 80 */
	       obj_t obj_1611;
	       obj_1611 =
		  (obj_t) (new1578_1039);
	       (((obj_t) CREF(obj_1611))->header = MAKE_HEADER(arg1635_1040, 0), BUNSPEC);
	    }
	 }
	 {	/* Globalize/ginfo.scm 80 */
	    object_bglt aux_2795;
	    aux_2795 =
	       (object_bglt) (new1578_1039);
	    OBJECT_WIDENING_SET(aux_2795, BFALSE);
	 }
	 return new1578_1039;
      }
   }
}



/* _allocate-global/ginfo */
obj_t 
_allocate_global_ginfo_49_globalize_ginfo(obj_t env_2259)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 global_bglt aux_2798;
	 aux_2798 =
	    allocate_global_ginfo_174_globalize_ginfo();
	 return
	    (obj_t) (aux_2798);
      }
   }
}



/* global/ginfo? */
bool_t 
global_ginfo__175_globalize_ginfo(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 is_a__118___object(obj_4, global_ginfo_75_globalize_ginfo);
   }
}



/* _global/ginfo? */
obj_t 
_global_ginfo__15_globalize_ginfo(obj_t env_2260, obj_t obj_2261)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 bool_t aux_2802;
	 aux_2802 =
	    global_ginfo__175_globalize_ginfo(obj_2261);
	 return
	    BBOOL(aux_2802);
      }
   }
}



/* widening-global/ginfo */
global_ginfo_75_bglt 
widening_global_ginfo_207_globalize_ginfo(bool_t escape__117_5, obj_t global_closure_229_6)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 global_ginfo_75_bglt new1572_1613;
	 new1572_1613 =
	    ((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
	 ((((global_ginfo_75_bglt) CREF(new1572_1613))->escape__117) = ((bool_t) escape__117_5), BUNSPEC);
	 ((((global_ginfo_75_bglt) CREF(new1572_1613))->global_closure_229) = ((obj_t) global_closure_229_6), BUNSPEC);
	 return new1572_1613;
      }
   }
}



/* _widening-global/ginfo */
obj_t 
_widening_global_ginfo_106_globalize_ginfo(obj_t env_2262, obj_t escape__117_2263, obj_t global_closure_229_2264)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 global_ginfo_75_bglt aux_2808;
	 aux_2808 =
	    widening_global_ginfo_207_globalize_ginfo(
	    CBOOL(escape__117_2263), global_closure_229_2264);
	 return
	    (obj_t) (aux_2808);
      }
   }
}



/* make-global/ginfo */
global_ginfo_75_bglt 
make_global_ginfo_116_globalize_ginfo(obj_t id_7, obj_t name_8, type_bglt type_9, value_bglt value_10, obj_t access_11, obj_t fast_alpha_7_12, obj_t removable_13, long occurrence_14, obj_t module_15, obj_t import_16, bool_t evaluable__248_17, bool_t library__255_18, bool_t user__32_19, obj_t pragma_20, obj_t src_21, bool_t escape__117_22, obj_t global_closure_229_23)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 global_bglt aux1576_1616;
	 {	/* Globalize/ginfo.scm 80 */
	    global_bglt res1841_1654;
	    {	/* ./Ast/var.scm 438 */
	       global_bglt new1063_1635;
	       new1063_1635 =
		  ((global_bglt) BREF(GC_MALLOC(sizeof(struct global))));
	       {	/* ./Ast/var.scm 438 */
		  long arg1716_1636;
		  arg1716_1636 =
		     class_num_218___object(global_ast_var);
		  {	/* ./Ast/var.scm 438 */
		     obj_t obj_1652;
		     obj_1652 =
			(obj_t) (new1063_1635);
		     (((obj_t) CREF(obj_1652))->header = MAKE_HEADER(arg1716_1636, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 438 */
		  object_bglt aux_2816;
		  aux_2816 =
		     (object_bglt) (new1063_1635);
		  OBJECT_WIDENING_SET(aux_2816, BFALSE);
	       }
	       ((((global_bglt) CREF(new1063_1635))->id) = ((obj_t) id_7), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->name) = ((obj_t) name_8), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->type) = ((type_bglt) type_9), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->value) = ((value_bglt) value_10), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->access) = ((obj_t) access_11), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->fast_alpha_7) = ((obj_t) fast_alpha_7_12), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->removable) = ((obj_t) removable_13), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->occurrence) = ((long) occurrence_14), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->module) = ((obj_t) module_15), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->import) = ((obj_t) import_16), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->evaluable__248) = ((bool_t) evaluable__248_17), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->library__255) = ((bool_t) library__255_18), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->user__32) = ((bool_t) user__32_19), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->pragma) = ((obj_t) pragma_20), BUNSPEC);
	       ((((global_bglt) CREF(new1063_1635))->src) = ((obj_t) src_21), BUNSPEC);
	       res1841_1654 = new1063_1635;
	    }
	    aux1576_1616 = res1841_1654;
	 }
	 {	/* Globalize/ginfo.scm 80 */
	    global_ginfo_75_bglt new1577_1617;
	    new1577_1617 =
	       ((global_ginfo_75_bglt) (aux1576_1616));
	    {	/* Globalize/ginfo.scm 80 */
	       long arg1636_1618;
	       arg1636_1618 =
		  class_num_218___object(global_ginfo_75_globalize_ginfo);
	       {	/* Globalize/ginfo.scm 80 */
		  obj_t obj_1655;
		  obj_1655 =
		     (obj_t) (new1577_1617);
		  (((obj_t) CREF(obj_1655))->header = MAKE_HEADER(arg1636_1618, 0), BUNSPEC);
	       }
	    }
	    {	/* Globalize/ginfo.scm 80 */
	       global_ginfo_75_bglt arg1637_1619;
	       {	/* Globalize/ginfo.scm 80 */
		  global_ginfo_75_bglt res1842_1662;
		  {	/* Globalize/ginfo.scm 80 */
		     global_ginfo_75_bglt new1572_1659;
		     new1572_1659 =
			((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
		     ((((global_ginfo_75_bglt) CREF(new1572_1659))->escape__117) = ((bool_t) escape__117_22), BUNSPEC);
		     ((((global_ginfo_75_bglt) CREF(new1572_1659))->global_closure_229) = ((obj_t) global_closure_229_23), BUNSPEC);
		     res1842_1662 = new1572_1659;
		  }
		  arg1637_1619 = res1842_1662;
	       }
	       {	/* Globalize/ginfo.scm 80 */
		  obj_t aux_2843;
		  object_bglt aux_2841;
		  aux_2843 =
		     (obj_t) (arg1637_1619);
		  aux_2841 =
		     (object_bglt) (new1577_1617);
		  OBJECT_WIDENING_SET(aux_2841, aux_2843);
	       }
	    }
	    return new1577_1617;
	 }
      }
   }
}



/* _make-global/ginfo */
obj_t 
_make_global_ginfo_161_globalize_ginfo(obj_t env_2265, obj_t id_2266, obj_t name_2267, obj_t type_2268, obj_t value_2269, obj_t access_2270, obj_t fast_alpha_7_2271, obj_t removable_2272, obj_t occurrence_2273, obj_t module_2274, obj_t import_2275, obj_t evaluable__248_2276, obj_t library__255_2277, obj_t user__32_2278, obj_t pragma_2279, obj_t src_2280, obj_t escape__117_2281, obj_t global_closure_229_2282)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 global_ginfo_75_bglt aux_2846;
	 aux_2846 =
	    make_global_ginfo_116_globalize_ginfo(id_2266, name_2267,
	    (type_bglt) (type_2268),
	    (value_bglt) (value_2269), access_2270, fast_alpha_7_2271, removable_2272,
	    (long) CINT(occurrence_2273), module_2274, import_2275,
	    CBOOL(evaluable__248_2276),
	    CBOOL(library__255_2277),
	    CBOOL(user__32_2278), pragma_2279, src_2280,
	    CBOOL(escape__117_2281), global_closure_229_2282);
	 return
	    (obj_t) (aux_2846);
      }
   }
}



/* global/ginfo-id */
obj_t 
global_ginfo_id_159_globalize_ginfo(global_bglt obj_24)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 417 */
      return
	 (((global_bglt) CREF(obj_24))->id);
   }
}



/* _global/ginfo-id */
obj_t 
_global_ginfo_id_46_globalize_ginfo(obj_t env_2283, obj_t obj_2284)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 417 */
      return
	 global_ginfo_id_159_globalize_ginfo(
	 (global_bglt) (obj_2284));
   }
}



/* global/ginfo-name-set! */
obj_t 
global_ginfo_name_set__78_globalize_ginfo(global_bglt obj_25, obj_t val1558_26)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 ((((global_bglt) CREF(obj_25))->name) = ((obj_t) val1558_26), BUNSPEC);
   }
}



/* _global/ginfo-name-set! */
obj_t 
_global_ginfo_name_set__203_globalize_ginfo(obj_t env_2285, obj_t obj_2286, obj_t val1558_2287)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 global_ginfo_name_set__78_globalize_ginfo(
	 (global_bglt) (obj_2286), val1558_2287);
   }
}



/* global/ginfo-name */
obj_t 
global_ginfo_name_179_globalize_ginfo(global_bglt obj_27)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 (((global_bglt) CREF(obj_27))->name);
   }
}



/* _global/ginfo-name */
obj_t 
_global_ginfo_name_159_globalize_ginfo(obj_t env_2288, obj_t obj_2289)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 global_ginfo_name_179_globalize_ginfo(
	 (global_bglt) (obj_2289));
   }
}



/* global/ginfo-type-set! */
obj_t 
global_ginfo_type_set__85_globalize_ginfo(global_bglt obj_28, type_bglt val1559_29)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      return
	 ((((global_bglt) CREF(obj_28))->type) = ((type_bglt) val1559_29), BUNSPEC);
   }
}



/* _global/ginfo-type-set! */
obj_t 
_global_ginfo_type_set__199_globalize_ginfo(obj_t env_2290, obj_t obj_2291, obj_t val1559_2292)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      return
	 global_ginfo_type_set__85_globalize_ginfo(
	 (global_bglt) (obj_2291),
	 (type_bglt) (val1559_2292));
   }
}



/* global/ginfo-type */
type_bglt 
global_ginfo_type_26_globalize_ginfo(global_bglt obj_30)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      return
	 (((global_bglt) CREF(obj_30))->type);
   }
}



/* _global/ginfo-type */
obj_t 
_global_ginfo_type_116_globalize_ginfo(obj_t env_2293, obj_t obj_2294)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      {		/* ./Ast/var.scm 421 */
	 type_bglt aux_2870;
	 aux_2870 =
	    global_ginfo_type_26_globalize_ginfo(
	    (global_bglt) (obj_2294));
	 return
	    (obj_t) (aux_2870);
      }
   }
}



/* global/ginfo-value-set! */
obj_t 
global_ginfo_value_set__149_globalize_ginfo(global_bglt obj_31, value_bglt val1560_32)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 ((((global_bglt) CREF(obj_31))->value) = ((value_bglt) val1560_32), BUNSPEC);
   }
}



/* _global/ginfo-value-set! */
obj_t 
_global_ginfo_value_set__216_globalize_ginfo(obj_t env_2295, obj_t obj_2296, obj_t val1560_2297)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 global_ginfo_value_set__149_globalize_ginfo(
	 (global_bglt) (obj_2296),
	 (value_bglt) (val1560_2297));
   }
}



/* global/ginfo-value */
value_bglt 
global_ginfo_value_89_globalize_ginfo(global_bglt obj_33)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 (((global_bglt) CREF(obj_33))->value);
   }
}



/* _global/ginfo-value */
obj_t 
_global_ginfo_value_191_globalize_ginfo(obj_t env_2298, obj_t obj_2299)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {		/* Globalize/ginfo.scm 80 */
	 value_bglt aux_2879;
	 aux_2879 =
	    global_ginfo_value_89_globalize_ginfo(
	    (global_bglt) (obj_2299));
	 return
	    (obj_t) (aux_2879);
      }
   }
}



/* global/ginfo-access-set! */
obj_t 
global_ginfo_access_set__63_globalize_ginfo(global_bglt obj_34, obj_t val1561_35)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 ((((global_bglt) CREF(obj_34))->access) = ((obj_t) val1561_35), BUNSPEC);
   }
}



/* _global/ginfo-access-set! */
obj_t 
_global_ginfo_access_set__135_globalize_ginfo(obj_t env_2300, obj_t obj_2301, obj_t val1561_2302)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 global_ginfo_access_set__63_globalize_ginfo(
	 (global_bglt) (obj_2301), val1561_2302);
   }
}



/* global/ginfo-access */
obj_t 
global_ginfo_access_77_globalize_ginfo(global_bglt obj_36)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 (((global_bglt) CREF(obj_36))->access);
   }
}



/* _global/ginfo-access */
obj_t 
_global_ginfo_access_134_globalize_ginfo(obj_t env_2303, obj_t obj_2304)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 global_ginfo_access_77_globalize_ginfo(
	 (global_bglt) (obj_2304));
   }
}



/* global/ginfo-fast-alpha-set! */
obj_t 
global_ginfo_fast_alpha_set__195_globalize_ginfo(global_bglt obj_37, obj_t val1562_38)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 ((((global_bglt) CREF(obj_37))->fast_alpha_7) = ((obj_t) val1562_38), BUNSPEC);
   }
}



/* _global/ginfo-fast-alpha-set! */
obj_t 
_global_ginfo_fast_alpha_set__99_globalize_ginfo(obj_t env_2305, obj_t obj_2306, obj_t val1562_2307)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 global_ginfo_fast_alpha_set__195_globalize_ginfo(
	 (global_bglt) (obj_2306), val1562_2307);
   }
}



/* global/ginfo-fast-alpha */
obj_t 
global_ginfo_fast_alpha_123_globalize_ginfo(global_bglt obj_39)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 (((global_bglt) CREF(obj_39))->fast_alpha_7);
   }
}



/* _global/ginfo-fast-alpha */
obj_t 
_global_ginfo_fast_alpha_125_globalize_ginfo(obj_t env_2308, obj_t obj_2309)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 global_ginfo_fast_alpha_123_globalize_ginfo(
	 (global_bglt) (obj_2309));
   }
}



/* global/ginfo-removable-set! */
obj_t 
global_ginfo_removable_set__202_globalize_ginfo(global_bglt obj_40, obj_t val1563_41)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 ((((global_bglt) CREF(obj_40))->removable) = ((obj_t) val1563_41), BUNSPEC);
   }
}



/* _global/ginfo-removable-set! */
obj_t 
_global_ginfo_removable_set__10_globalize_ginfo(obj_t env_2310, obj_t obj_2311, obj_t val1563_2312)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 global_ginfo_removable_set__202_globalize_ginfo(
	 (global_bglt) (obj_2311), val1563_2312);
   }
}



/* global/ginfo-removable */
obj_t 
global_ginfo_removable_27_globalize_ginfo(global_bglt obj_42)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 (((global_bglt) CREF(obj_42))->removable);
   }
}



/* _global/ginfo-removable */
obj_t 
_global_ginfo_removable_35_globalize_ginfo(obj_t env_2313, obj_t obj_2314)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 global_ginfo_removable_27_globalize_ginfo(
	 (global_bglt) (obj_2314));
   }
}



/* global/ginfo-occurrence-set! */
obj_t 
global_ginfo_occurrence_set__72_globalize_ginfo(global_bglt obj_43, long val1564_44)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      return
	 ((((global_bglt) CREF(obj_43))->occurrence) = ((long) val1564_44), BUNSPEC);
   }
}



/* _global/ginfo-occurrence-set! */
obj_t 
_global_ginfo_occurrence_set__43_globalize_ginfo(obj_t env_2315, obj_t obj_2316, obj_t val1564_2317)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      return
	 global_ginfo_occurrence_set__72_globalize_ginfo(
	 (global_bglt) (obj_2316),
	 (long) CINT(val1564_2317));
   }
}



/* global/ginfo-occurrence */
long 
global_ginfo_occurrence_12_globalize_ginfo(global_bglt obj_45)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      return
	 (((global_bglt) CREF(obj_45))->occurrence);
   }
}



/* _global/ginfo-occurrence */
obj_t 
_global_ginfo_occurrence_97_globalize_ginfo(obj_t env_2318, obj_t obj_2319)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      {		/* ./Ast/var.scm 436 */
	 long aux_2906;
	 aux_2906 =
	    global_ginfo_occurrence_12_globalize_ginfo(
	    (global_bglt) (obj_2319));
	 return
	    BINT(aux_2906);
      }
   }
}



/* global/ginfo-module */
obj_t 
global_ginfo_module_155_globalize_ginfo(global_bglt obj_46)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 440 */
      return
	 (((global_bglt) CREF(obj_46))->module);
   }
}



/* _global/ginfo-module */
obj_t 
_global_ginfo_module_172_globalize_ginfo(obj_t env_2320, obj_t obj_2321)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 440 */
      return
	 global_ginfo_module_155_globalize_ginfo(
	 (global_bglt) (obj_2321));
   }
}



/* global/ginfo-import-set! */
obj_t 
global_ginfo_import_set__11_globalize_ginfo(global_bglt obj_47, obj_t val1565_48)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 442 */
      return
	 ((((global_bglt) CREF(obj_47))->import) = ((obj_t) val1565_48), BUNSPEC);
   }
}



/* _global/ginfo-import-set! */
obj_t 
_global_ginfo_import_set__69_globalize_ginfo(obj_t env_2322, obj_t obj_2323, obj_t val1565_2324)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 442 */
      return
	 global_ginfo_import_set__11_globalize_ginfo(
	 (global_bglt) (obj_2323), val1565_2324);
   }
}



/* global/ginfo-import */
obj_t 
global_ginfo_import_118_globalize_ginfo(global_bglt obj_49)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 442 */
      return
	 (((global_bglt) CREF(obj_49))->import);
   }
}



/* _global/ginfo-import */
obj_t 
_global_ginfo_import_201_globalize_ginfo(obj_t env_2325, obj_t obj_2326)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 442 */
      return
	 global_ginfo_import_118_globalize_ginfo(
	 (global_bglt) (obj_2326));
   }
}



/* global/ginfo-evaluable?-set! */
obj_t 
global_ginfo_evaluable__set__37_globalize_ginfo(global_bglt obj_50, bool_t val1566_51)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 ((((global_bglt) CREF(obj_50))->evaluable__248) = ((bool_t) val1566_51), BUNSPEC);
   }
}



/* _global/ginfo-evaluable?-set! */
obj_t 
_global_ginfo_evaluable__set__222_globalize_ginfo(obj_t env_2327, obj_t obj_2328, obj_t val1566_2329)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 global_ginfo_evaluable__set__37_globalize_ginfo(
	 (global_bglt) (obj_2328),
	 CBOOL(val1566_2329));
   }
}



/* global/ginfo-evaluable? */
bool_t 
global_ginfo_evaluable__184_globalize_ginfo(global_bglt obj_52)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 (((global_bglt) CREF(obj_52))->evaluable__248);
   }
}



/* _global/ginfo-evaluable? */
obj_t 
_global_ginfo_evaluable__153_globalize_ginfo(obj_t env_2330, obj_t obj_2331)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      {		/* ./Ast/var.scm 445 */
	 bool_t aux_2924;
	 aux_2924 =
	    global_ginfo_evaluable__184_globalize_ginfo(
	    (global_bglt) (obj_2331));
	 return
	    BBOOL(aux_2924);
      }
   }
}



/* global/ginfo-library?-set! */
obj_t 
global_ginfo_library__set__196_globalize_ginfo(global_bglt obj_53, bool_t val1567_54)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 ((((global_bglt) CREF(obj_53))->library__255) = ((bool_t) val1567_54), BUNSPEC);
   }
}



/* _global/ginfo-library?-set! */
obj_t 
_global_ginfo_library__set__55_globalize_ginfo(obj_t env_2332, obj_t obj_2333, obj_t val1567_2334)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 global_ginfo_library__set__196_globalize_ginfo(
	 (global_bglt) (obj_2333),
	 CBOOL(val1567_2334));
   }
}



/* global/ginfo-library? */
bool_t 
global_ginfo_library__79_globalize_ginfo(global_bglt obj_55)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 (((global_bglt) CREF(obj_55))->library__255);
   }
}



/* _global/ginfo-library? */
obj_t 
_global_ginfo_library__228_globalize_ginfo(obj_t env_2335, obj_t obj_2336)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      {		/* ./Ast/var.scm 447 */
	 bool_t aux_2933;
	 aux_2933 =
	    global_ginfo_library__79_globalize_ginfo(
	    (global_bglt) (obj_2336));
	 return
	    BBOOL(aux_2933);
      }
   }
}



/* global/ginfo-user?-set! */
obj_t 
global_ginfo_user__set__96_globalize_ginfo(global_bglt obj_56, bool_t val1568_57)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 452 */
      return
	 ((((global_bglt) CREF(obj_56))->user__32) = ((bool_t) val1568_57), BUNSPEC);
   }
}



/* _global/ginfo-user?-set! */
obj_t 
_global_ginfo_user__set__110_globalize_ginfo(obj_t env_2337, obj_t obj_2338, obj_t val1568_2339)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 452 */
      return
	 global_ginfo_user__set__96_globalize_ginfo(
	 (global_bglt) (obj_2338),
	 CBOOL(val1568_2339));
   }
}



/* global/ginfo-user? */
bool_t 
global_ginfo_user__167_globalize_ginfo(global_bglt obj_58)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 452 */
      return
	 (((global_bglt) CREF(obj_58))->user__32);
   }
}



/* _global/ginfo-user? */
obj_t 
_global_ginfo_user__199_globalize_ginfo(obj_t env_2340, obj_t obj_2341)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 452 */
      {		/* ./Ast/var.scm 452 */
	 bool_t aux_2942;
	 aux_2942 =
	    global_ginfo_user__167_globalize_ginfo(
	    (global_bglt) (obj_2341));
	 return
	    BBOOL(aux_2942);
      }
   }
}



/* global/ginfo-pragma */
obj_t 
global_ginfo_pragma_81_globalize_ginfo(global_bglt obj_59)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 454 */
      return
	 (((global_bglt) CREF(obj_59))->pragma);
   }
}



/* _global/ginfo-pragma */
obj_t 
_global_ginfo_pragma_91_globalize_ginfo(obj_t env_2342, obj_t obj_2343)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 454 */
      return
	 global_ginfo_pragma_81_globalize_ginfo(
	 (global_bglt) (obj_2343));
   }
}



/* global/ginfo-src-set! */
obj_t 
global_ginfo_src_set__129_globalize_ginfo(global_bglt obj_60, obj_t val1569_61)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 ((((global_bglt) CREF(obj_60))->src) = ((obj_t) val1569_61), BUNSPEC);
   }
}



/* _global/ginfo-src-set! */
obj_t 
_global_ginfo_src_set__207_globalize_ginfo(obj_t env_2344, obj_t obj_2345, obj_t val1569_2346)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 global_ginfo_src_set__129_globalize_ginfo(
	 (global_bglt) (obj_2345), val1569_2346);
   }
}



/* global/ginfo-src */
obj_t 
global_ginfo_src_234_globalize_ginfo(global_bglt obj_62)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 (((global_bglt) CREF(obj_62))->src);
   }
}



/* _global/ginfo-src */
obj_t 
_global_ginfo_src_46_globalize_ginfo(obj_t env_2347, obj_t obj_2348)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      return
	 global_ginfo_src_234_globalize_ginfo(
	 (global_bglt) (obj_2348));
   }
}



/* global/ginfo-escape?-set! */
obj_t 
global_ginfo_escape__set__142_globalize_ginfo(global_ginfo_75_bglt obj_63, bool_t val1570_64)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 82 */
      {
	 obj_t aux_2955;
	 {	/* Globalize/ginfo.scm 82 */
	    object_bglt aux_2956;
	    aux_2956 =
	       (object_bglt) (obj_63);
	    aux_2955 =
	       OBJECT_WIDENING(aux_2956);
	 }
	 return
	    ((((global_ginfo_75_bglt) CREF(aux_2955))->escape__117) = ((bool_t) val1570_64), BUNSPEC);
      }
   }
}



/* _global/ginfo-escape?-set! */
obj_t 
_global_ginfo_escape__set__67_globalize_ginfo(obj_t env_2349, obj_t obj_2350, obj_t val1570_2351)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 82 */
      return
	 global_ginfo_escape__set__142_globalize_ginfo(
	 (global_ginfo_75_bglt) (obj_2350),
	 CBOOL(val1570_2351));
   }
}



/* global/ginfo-escape? */
bool_t 
global_ginfo_escape__39_globalize_ginfo(global_ginfo_75_bglt obj_65)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 82 */
      {
	 obj_t aux_2963;
	 {	/* Globalize/ginfo.scm 82 */
	    object_bglt aux_2964;
	    aux_2964 =
	       (object_bglt) (obj_65);
	    aux_2963 =
	       OBJECT_WIDENING(aux_2964);
	 }
	 return
	    (((global_ginfo_75_bglt) CREF(aux_2963))->escape__117);
      }
   }
}



/* _global/ginfo-escape? */
obj_t 
_global_ginfo_escape__31_globalize_ginfo(obj_t env_2352, obj_t obj_2353)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 82 */
      {		/* Globalize/ginfo.scm 82 */
	 bool_t aux_2968;
	 aux_2968 =
	    global_ginfo_escape__39_globalize_ginfo(
	    (global_ginfo_75_bglt) (obj_2353));
	 return
	    BBOOL(aux_2968);
      }
   }
}



/* global/ginfo-global-closure-set! */
obj_t 
global_ginfo_global_closure_set__44_globalize_ginfo(global_ginfo_75_bglt obj_66, obj_t val1571_67)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 84 */
      {
	 obj_t aux_2972;
	 {	/* Globalize/ginfo.scm 84 */
	    object_bglt aux_2973;
	    aux_2973 =
	       (object_bglt) (obj_66);
	    aux_2972 =
	       OBJECT_WIDENING(aux_2973);
	 }
	 return
	    ((((global_ginfo_75_bglt) CREF(aux_2972))->global_closure_229) = ((obj_t) val1571_67), BUNSPEC);
      }
   }
}



/* _global/ginfo-global-closure-set! */
obj_t 
_global_ginfo_global_closure_set__101_globalize_ginfo(obj_t env_2354, obj_t obj_2355, obj_t val1571_2356)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 84 */
      return
	 global_ginfo_global_closure_set__44_globalize_ginfo(
	 (global_ginfo_75_bglt) (obj_2355), val1571_2356);
   }
}



/* global/ginfo-global-closure */
obj_t 
global_ginfo_global_closure_105_globalize_ginfo(global_ginfo_75_bglt obj_68)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 84 */
      {
	 obj_t aux_2979;
	 {	/* Globalize/ginfo.scm 84 */
	    object_bglt aux_2980;
	    aux_2980 =
	       (object_bglt) (obj_68);
	    aux_2979 =
	       OBJECT_WIDENING(aux_2980);
	 }
	 return
	    (((global_ginfo_75_bglt) CREF(aux_2979))->global_closure_229);
      }
   }
}



/* _global/ginfo-global-closure */
obj_t 
_global_ginfo_global_closure_242_globalize_ginfo(obj_t env_2357, obj_t obj_2358)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 84 */
      return
	 global_ginfo_global_closure_105_globalize_ginfo(
	 (global_ginfo_75_bglt) (obj_2358));
   }
}



/* allocate-local/ginfo */
local_bglt 
allocate_local_ginfo_201_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 local_bglt new1551_1048;
	 new1551_1048 =
	    ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	 {	/* Globalize/ginfo.scm 76 */
	    long arg1638_1049;
	    arg1638_1049 =
	       class_num_218___object(local_ginfo_108_globalize_ginfo);
	    {	/* Globalize/ginfo.scm 76 */
	       obj_t obj_1663;
	       obj_1663 =
		  (obj_t) (new1551_1048);
	       (((obj_t) CREF(obj_1663))->header = MAKE_HEADER(arg1638_1049, 0), BUNSPEC);
	    }
	 }
	 {	/* Globalize/ginfo.scm 76 */
	    object_bglt aux_2990;
	    aux_2990 =
	       (object_bglt) (new1551_1048);
	    OBJECT_WIDENING_SET(aux_2990, BFALSE);
	 }
	 return new1551_1048;
      }
   }
}



/* _allocate-local/ginfo */
obj_t 
_allocate_local_ginfo_111_globalize_ginfo(obj_t env_2258)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 local_bglt aux_2993;
	 aux_2993 =
	    allocate_local_ginfo_201_globalize_ginfo();
	 return
	    (obj_t) (aux_2993);
      }
   }
}



/* local/ginfo? */
bool_t 
local_ginfo__237_globalize_ginfo(obj_t obj_72)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      return
	 is_a__118___object(obj_72, local_ginfo_108_globalize_ginfo);
   }
}



/* _local/ginfo? */
obj_t 
_local_ginfo__39_globalize_ginfo(obj_t env_2359, obj_t obj_2360)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 bool_t aux_2997;
	 aux_2997 =
	    local_ginfo__237_globalize_ginfo(obj_2360);
	 return
	    BBOOL(aux_2997);
      }
   }
}



/* widening-local/ginfo */
local_ginfo_108_bglt 
widening_local_ginfo_191_globalize_ginfo(bool_t escape__117_73)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 local_ginfo_108_bglt new1546_1665;
	 new1546_1665 =
	    ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
	 ((((local_ginfo_108_bglt) CREF(new1546_1665))->escape__117) = ((bool_t) escape__117_73), BUNSPEC);
	 return new1546_1665;
      }
   }
}



/* _widening-local/ginfo */
obj_t 
_widening_local_ginfo_87_globalize_ginfo(obj_t env_2361, obj_t escape__117_2362)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 local_ginfo_108_bglt aux_3002;
	 aux_3002 =
	    widening_local_ginfo_191_globalize_ginfo(
	    CBOOL(escape__117_2362));
	 return
	    (obj_t) (aux_3002);
      }
   }
}



/* make-local/ginfo */
local_ginfo_108_bglt 
make_local_ginfo_207_globalize_ginfo(obj_t id_74, obj_t name_75, type_bglt type_76, value_bglt value_77, obj_t access_78, obj_t fast_alpha_7_79, obj_t removable_80, long occurrence_81, bool_t user__32_82, long key_83, bool_t escape__117_84)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 local_bglt aux1549_1667;
	 {	/* Globalize/ginfo.scm 76 */
	    local_bglt res1843_1695;
	    {	/* ./Ast/var.scm 458 */
	       local_bglt new1089_1681;
	       new1089_1681 =
		  ((local_bglt) BREF(GC_MALLOC(sizeof(struct local))));
	       {	/* ./Ast/var.scm 458 */
		  long arg1714_1682;
		  arg1714_1682 =
		     class_num_218___object(local_ast_var);
		  {	/* ./Ast/var.scm 458 */
		     obj_t obj_1693;
		     obj_1693 =
			(obj_t) (new1089_1681);
		     (((obj_t) CREF(obj_1693))->header = MAKE_HEADER(arg1714_1682, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 458 */
		  object_bglt aux_3010;
		  aux_3010 =
		     (object_bglt) (new1089_1681);
		  OBJECT_WIDENING_SET(aux_3010, BFALSE);
	       }
	       ((((local_bglt) CREF(new1089_1681))->id) = ((obj_t) id_74), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->name) = ((obj_t) name_75), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->type) = ((type_bglt) type_76), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->value) = ((value_bglt) value_77), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->access) = ((obj_t) access_78), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->fast_alpha_7) = ((obj_t) fast_alpha_7_79), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->removable) = ((obj_t) removable_80), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->occurrence) = ((long) occurrence_81), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->user__32) = ((bool_t) user__32_82), BUNSPEC);
	       ((((local_bglt) CREF(new1089_1681))->key) = ((long) key_83), BUNSPEC);
	       res1843_1695 = new1089_1681;
	    }
	    aux1549_1667 = res1843_1695;
	 }
	 {	/* Globalize/ginfo.scm 76 */
	    local_ginfo_108_bglt new1550_1668;
	    new1550_1668 =
	       ((local_ginfo_108_bglt) (aux1549_1667));
	    {	/* Globalize/ginfo.scm 76 */
	       long arg1639_1669;
	       arg1639_1669 =
		  class_num_218___object(local_ginfo_108_globalize_ginfo);
	       {	/* Globalize/ginfo.scm 76 */
		  obj_t obj_1696;
		  obj_1696 =
		     (obj_t) (new1550_1668);
		  (((obj_t) CREF(obj_1696))->header = MAKE_HEADER(arg1639_1669, 0), BUNSPEC);
	       }
	    }
	    {	/* Globalize/ginfo.scm 76 */
	       local_ginfo_108_bglt arg1640_1670;
	       {	/* Globalize/ginfo.scm 76 */
		  local_ginfo_108_bglt res1844_1701;
		  {	/* Globalize/ginfo.scm 76 */
		     local_ginfo_108_bglt new1546_1699;
		     new1546_1699 =
			((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
		     ((((local_ginfo_108_bglt) CREF(new1546_1699))->escape__117) = ((bool_t) escape__117_84), BUNSPEC);
		     res1844_1701 = new1546_1699;
		  }
		  arg1640_1670 = res1844_1701;
	       }
	       {	/* Globalize/ginfo.scm 76 */
		  obj_t aux_3031;
		  object_bglt aux_3029;
		  aux_3031 =
		     (obj_t) (arg1640_1670);
		  aux_3029 =
		     (object_bglt) (new1550_1668);
		  OBJECT_WIDENING_SET(aux_3029, aux_3031);
	       }
	    }
	    return new1550_1668;
	 }
      }
   }
}



/* _make-local/ginfo */
obj_t 
_make_local_ginfo_212_globalize_ginfo(obj_t env_2363, obj_t id_2364, obj_t name_2365, obj_t type_2366, obj_t value_2367, obj_t access_2368, obj_t fast_alpha_7_2369, obj_t removable_2370, obj_t occurrence_2371, obj_t user__32_2372, obj_t key_2373, obj_t escape__117_2374)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 local_ginfo_108_bglt aux_3034;
	 aux_3034 =
	    make_local_ginfo_207_globalize_ginfo(id_2364, name_2365,
	    (type_bglt) (type_2366),
	    (value_bglt) (value_2367), access_2368, fast_alpha_7_2369, removable_2370,
	    (long) CINT(occurrence_2371),
	    CBOOL(user__32_2372),
	    (long) CINT(key_2373),
	    CBOOL(escape__117_2374));
	 return
	    (obj_t) (aux_3034);
      }
   }
}



/* local/ginfo-id */
obj_t 
local_ginfo_id_0_globalize_ginfo(local_bglt obj_85)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 417 */
      return
	 (((local_bglt) CREF(obj_85))->id);
   }
}



/* _local/ginfo-id */
obj_t 
_local_ginfo_id_24_globalize_ginfo(obj_t env_2375, obj_t obj_2376)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 417 */
      return
	 local_ginfo_id_0_globalize_ginfo(
	 (local_bglt) (obj_2376));
   }
}



/* local/ginfo-name-set! */
obj_t 
local_ginfo_name_set__6_globalize_ginfo(local_bglt obj_86, obj_t val1537_87)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 ((((local_bglt) CREF(obj_86))->name) = ((obj_t) val1537_87), BUNSPEC);
   }
}



/* _local/ginfo-name-set! */
obj_t 
_local_ginfo_name_set__164_globalize_ginfo(obj_t env_2377, obj_t obj_2378, obj_t val1537_2379)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 local_ginfo_name_set__6_globalize_ginfo(
	 (local_bglt) (obj_2378), val1537_2379);
   }
}



/* local/ginfo-name */
obj_t 
local_ginfo_name_216_globalize_ginfo(local_bglt obj_88)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 (((local_bglt) CREF(obj_88))->name);
   }
}



/* _local/ginfo-name */
obj_t 
_local_ginfo_name_80_globalize_ginfo(obj_t env_2380, obj_t obj_2381)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 419 */
      return
	 local_ginfo_name_216_globalize_ginfo(
	 (local_bglt) (obj_2381));
   }
}



/* local/ginfo-type-set! */
obj_t 
local_ginfo_type_set__188_globalize_ginfo(local_bglt obj_89, type_bglt val1538_90)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      return
	 ((((local_bglt) CREF(obj_89))->type) = ((type_bglt) val1538_90), BUNSPEC);
   }
}



/* _local/ginfo-type-set! */
obj_t 
_local_ginfo_type_set__58_globalize_ginfo(obj_t env_2382, obj_t obj_2383, obj_t val1538_2384)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      return
	 local_ginfo_type_set__188_globalize_ginfo(
	 (local_bglt) (obj_2383),
	 (type_bglt) (val1538_2384));
   }
}



/* local/ginfo-type */
type_bglt 
local_ginfo_type_222_globalize_ginfo(local_bglt obj_91)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      return
	 (((local_bglt) CREF(obj_91))->type);
   }
}



/* _local/ginfo-type */
obj_t 
_local_ginfo_type_92_globalize_ginfo(obj_t env_2385, obj_t obj_2386)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 421 */
      {		/* ./Ast/var.scm 421 */
	 type_bglt aux_3057;
	 aux_3057 =
	    local_ginfo_type_222_globalize_ginfo(
	    (local_bglt) (obj_2386));
	 return
	    (obj_t) (aux_3057);
      }
   }
}



/* local/ginfo-value-set! */
obj_t 
local_ginfo_value_set__11_globalize_ginfo(local_bglt obj_92, value_bglt val1539_93)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      return
	 ((((local_bglt) CREF(obj_92))->value) = ((value_bglt) val1539_93), BUNSPEC);
   }
}



/* _local/ginfo-value-set! */
obj_t 
_local_ginfo_value_set__165_globalize_ginfo(obj_t env_2387, obj_t obj_2388, obj_t val1539_2389)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      return
	 local_ginfo_value_set__11_globalize_ginfo(
	 (local_bglt) (obj_2388),
	 (value_bglt) (val1539_2389));
   }
}



/* local/ginfo-value */
value_bglt 
local_ginfo_value_118_globalize_ginfo(local_bglt obj_94)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      return
	 (((local_bglt) CREF(obj_94))->value);
   }
}



/* _local/ginfo-value */
obj_t 
_local_ginfo_value_88_globalize_ginfo(obj_t env_2390, obj_t obj_2391)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {		/* Globalize/ginfo.scm 76 */
	 value_bglt aux_3066;
	 aux_3066 =
	    local_ginfo_value_118_globalize_ginfo(
	    (local_bglt) (obj_2391));
	 return
	    (obj_t) (aux_3066);
      }
   }
}



/* local/ginfo-access-set! */
obj_t 
local_ginfo_access_set__117_globalize_ginfo(local_bglt obj_95, obj_t val1540_96)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 ((((local_bglt) CREF(obj_95))->access) = ((obj_t) val1540_96), BUNSPEC);
   }
}



/* _local/ginfo-access-set! */
obj_t 
_local_ginfo_access_set__98_globalize_ginfo(obj_t env_2392, obj_t obj_2393, obj_t val1540_2394)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 local_ginfo_access_set__117_globalize_ginfo(
	 (local_bglt) (obj_2393), val1540_2394);
   }
}



/* local/ginfo-access */
obj_t 
local_ginfo_access_122_globalize_ginfo(local_bglt obj_97)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 (((local_bglt) CREF(obj_97))->access);
   }
}



/* _local/ginfo-access */
obj_t 
_local_ginfo_access_162_globalize_ginfo(obj_t env_2395, obj_t obj_2396)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 425 */
      return
	 local_ginfo_access_122_globalize_ginfo(
	 (local_bglt) (obj_2396));
   }
}



/* local/ginfo-fast-alpha-set! */
obj_t 
local_ginfo_fast_alpha_set__62_globalize_ginfo(local_bglt obj_98, obj_t val1541_99)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 ((((local_bglt) CREF(obj_98))->fast_alpha_7) = ((obj_t) val1541_99), BUNSPEC);
   }
}



/* _local/ginfo-fast-alpha-set! */
obj_t 
_local_ginfo_fast_alpha_set__69_globalize_ginfo(obj_t env_2397, obj_t obj_2398, obj_t val1541_2399)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 local_ginfo_fast_alpha_set__62_globalize_ginfo(
	 (local_bglt) (obj_2398), val1541_2399);
   }
}



/* local/ginfo-fast-alpha */
obj_t 
local_ginfo_fast_alpha_16_globalize_ginfo(local_bglt obj_100)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 (((local_bglt) CREF(obj_100))->fast_alpha_7);
   }
}



/* _local/ginfo-fast-alpha */
obj_t 
_local_ginfo_fast_alpha_201_globalize_ginfo(obj_t env_2400, obj_t obj_2401)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 432 */
      return
	 local_ginfo_fast_alpha_16_globalize_ginfo(
	 (local_bglt) (obj_2401));
   }
}



/* local/ginfo-removable-set! */
obj_t 
local_ginfo_removable_set__201_globalize_ginfo(local_bglt obj_101, obj_t val1542_102)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 ((((local_bglt) CREF(obj_101))->removable) = ((obj_t) val1542_102), BUNSPEC);
   }
}



/* _local/ginfo-removable-set! */
obj_t 
_local_ginfo_removable_set__55_globalize_ginfo(obj_t env_2402, obj_t obj_2403, obj_t val1542_2404)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 local_ginfo_removable_set__201_globalize_ginfo(
	 (local_bglt) (obj_2403), val1542_2404);
   }
}



/* local/ginfo-removable */
obj_t 
local_ginfo_removable_170_globalize_ginfo(local_bglt obj_103)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 (((local_bglt) CREF(obj_103))->removable);
   }
}



/* _local/ginfo-removable */
obj_t 
_local_ginfo_removable_228_globalize_ginfo(obj_t env_2405, obj_t obj_2406)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 434 */
      return
	 local_ginfo_removable_170_globalize_ginfo(
	 (local_bglt) (obj_2406));
   }
}



/* local/ginfo-occurrence-set! */
obj_t 
local_ginfo_occurrence_set__71_globalize_ginfo(local_bglt obj_104, long val1543_105)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      return
	 ((((local_bglt) CREF(obj_104))->occurrence) = ((long) val1543_105), BUNSPEC);
   }
}



/* _local/ginfo-occurrence-set! */
obj_t 
_local_ginfo_occurrence_set__143_globalize_ginfo(obj_t env_2407, obj_t obj_2408, obj_t val1543_2409)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      return
	 local_ginfo_occurrence_set__71_globalize_ginfo(
	 (local_bglt) (obj_2408),
	 (long) CINT(val1543_2409));
   }
}



/* local/ginfo-occurrence */
long 
local_ginfo_occurrence_196_globalize_ginfo(local_bglt obj_106)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      return
	 (((local_bglt) CREF(obj_106))->occurrence);
   }
}



/* _local/ginfo-occurrence */
obj_t 
_local_ginfo_occurrence_42_globalize_ginfo(obj_t env_2410, obj_t obj_2411)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 436 */
      {		/* ./Ast/var.scm 436 */
	 long aux_3093;
	 aux_3093 =
	    local_ginfo_occurrence_196_globalize_ginfo(
	    (local_bglt) (obj_2411));
	 return
	    BINT(aux_3093);
      }
   }
}



/* local/ginfo-user?-set! */
obj_t 
local_ginfo_user__set__80_globalize_ginfo(local_bglt obj_107, bool_t val1544_108)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 460 */
      return
	 ((((local_bglt) CREF(obj_107))->user__32) = ((bool_t) val1544_108), BUNSPEC);
   }
}



/* _local/ginfo-user?-set! */
obj_t 
_local_ginfo_user__set__23_globalize_ginfo(obj_t env_2412, obj_t obj_2413, obj_t val1544_2414)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 460 */
      return
	 local_ginfo_user__set__80_globalize_ginfo(
	 (local_bglt) (obj_2413),
	 CBOOL(val1544_2414));
   }
}



/* local/ginfo-user? */
bool_t 
local_ginfo_user__24_globalize_ginfo(local_bglt obj_109)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 460 */
      return
	 (((local_bglt) CREF(obj_109))->user__32);
   }
}



/* _local/ginfo-user? */
obj_t 
_local_ginfo_user__17_globalize_ginfo(obj_t env_2415, obj_t obj_2416)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 460 */
      {		/* ./Ast/var.scm 460 */
	 bool_t aux_3102;
	 aux_3102 =
	    local_ginfo_user__24_globalize_ginfo(
	    (local_bglt) (obj_2416));
	 return
	    BBOOL(aux_3102);
      }
   }
}



/* local/ginfo-key */
long 
local_ginfo_key_185_globalize_ginfo(local_bglt obj_110)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 462 */
      return
	 (((local_bglt) CREF(obj_110))->key);
   }
}



/* _local/ginfo-key */
obj_t 
_local_ginfo_key_243_globalize_ginfo(obj_t env_2417, obj_t obj_2418)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 462 */
      {		/* ./Ast/var.scm 462 */
	 long aux_3107;
	 aux_3107 =
	    local_ginfo_key_185_globalize_ginfo(
	    (local_bglt) (obj_2418));
	 return
	    BINT(aux_3107);
      }
   }
}



/* local/ginfo-escape?-set! */
obj_t 
local_ginfo_escape__set__30_globalize_ginfo(local_ginfo_108_bglt obj_111, bool_t val1545_112)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 78 */
      {
	 obj_t aux_3111;
	 {	/* Globalize/ginfo.scm 78 */
	    object_bglt aux_3112;
	    aux_3112 =
	       (object_bglt) (obj_111);
	    aux_3111 =
	       OBJECT_WIDENING(aux_3112);
	 }
	 return
	    ((((local_ginfo_108_bglt) CREF(aux_3111))->escape__117) = ((bool_t) val1545_112), BUNSPEC);
      }
   }
}



/* _local/ginfo-escape?-set! */
obj_t 
_local_ginfo_escape__set__42_globalize_ginfo(obj_t env_2419, obj_t obj_2420, obj_t val1545_2421)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 78 */
      return
	 local_ginfo_escape__set__30_globalize_ginfo(
	 (local_ginfo_108_bglt) (obj_2420),
	 CBOOL(val1545_2421));
   }
}



/* local/ginfo-escape? */
bool_t 
local_ginfo_escape__169_globalize_ginfo(local_ginfo_108_bglt obj_113)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 78 */
      {
	 obj_t aux_3119;
	 {	/* Globalize/ginfo.scm 78 */
	    object_bglt aux_3120;
	    aux_3120 =
	       (object_bglt) (obj_113);
	    aux_3119 =
	       OBJECT_WIDENING(aux_3120);
	 }
	 return
	    (((local_ginfo_108_bglt) CREF(aux_3119))->escape__117);
      }
   }
}



/* _local/ginfo-escape? */
obj_t 
_local_ginfo_escape__93_globalize_ginfo(obj_t env_2422, obj_t obj_2423)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 78 */
      {		/* Globalize/ginfo.scm 78 */
	 bool_t aux_3124;
	 aux_3124 =
	    local_ginfo_escape__169_globalize_ginfo(
	    (local_ginfo_108_bglt) (obj_2423));
	 return
	    BBOOL(aux_3124);
      }
   }
}



/* allocate-sexit/ginfo */
sexit_bglt 
allocate_sexit_ginfo_150_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 sexit_bglt new1530_1056;
	 new1530_1056 =
	    ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	 {	/* Globalize/ginfo.scm 66 */
	    long arg1641_1057;
	    arg1641_1057 =
	       class_num_218___object(sexit_ginfo_81_globalize_ginfo);
	    {	/* Globalize/ginfo.scm 66 */
	       obj_t obj_1702;
	       obj_1702 =
		  (obj_t) (new1530_1056);
	       (((obj_t) CREF(obj_1702))->header = MAKE_HEADER(arg1641_1057, 0), BUNSPEC);
	    }
	 }
	 {	/* Globalize/ginfo.scm 66 */
	    object_bglt aux_3132;
	    aux_3132 =
	       (object_bglt) (new1530_1056);
	    OBJECT_WIDENING_SET(aux_3132, BFALSE);
	 }
	 return new1530_1056;
      }
   }
}



/* _allocate-sexit/ginfo */
obj_t 
_allocate_sexit_ginfo_207_globalize_ginfo(obj_t env_2257)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 sexit_bglt aux_3135;
	 aux_3135 =
	    allocate_sexit_ginfo_150_globalize_ginfo();
	 return
	    (obj_t) (aux_3135);
      }
   }
}



/* sexit/ginfo? */
bool_t 
sexit_ginfo__159_globalize_ginfo(obj_t obj_117)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      return
	 is_a__118___object(obj_117, sexit_ginfo_81_globalize_ginfo);
   }
}



/* _sexit/ginfo? */
obj_t 
_sexit_ginfo__121_globalize_ginfo(obj_t env_2424, obj_t obj_2425)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 bool_t aux_3139;
	 aux_3139 =
	    sexit_ginfo__159_globalize_ginfo(obj_2425);
	 return
	    BBOOL(aux_3139);
      }
   }
}



/* widening-sexit/ginfo */
sexit_ginfo_81_bglt 
widening_sexit_ginfo_80_globalize_ginfo(bool_t g__219_118, bool_t kaptured__204_119, long free_mark_81_120, long mark_121)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 sexit_ginfo_81_bglt new1522_1704;
	 new1522_1704 =
	    ((sexit_ginfo_81_bglt) BREF(GC_MALLOC(sizeof(struct sexit_ginfo_81))));
	 ((((sexit_ginfo_81_bglt) CREF(new1522_1704))->g__219) = ((bool_t) g__219_118), BUNSPEC);
	 ((((sexit_ginfo_81_bglt) CREF(new1522_1704))->kaptured__204) = ((bool_t) kaptured__204_119), BUNSPEC);
	 ((((sexit_ginfo_81_bglt) CREF(new1522_1704))->free_mark_81) = ((long) free_mark_81_120), BUNSPEC);
	 ((((sexit_ginfo_81_bglt) CREF(new1522_1704))->mark) = ((long) mark_121), BUNSPEC);
	 return new1522_1704;
      }
   }
}



/* _widening-sexit/ginfo1856 */
obj_t 
_widening_sexit_ginfo1856_2_globalize_ginfo(obj_t env_2426, obj_t g__219_2427, obj_t kaptured__204_2428, obj_t free_mark_81_2429, obj_t mark_2430)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 sexit_ginfo_81_bglt aux_3147;
	 aux_3147 =
	    widening_sexit_ginfo_80_globalize_ginfo(
	    CBOOL(g__219_2427),
	    CBOOL(kaptured__204_2428),
	    (long) CINT(free_mark_81_2429),
	    (long) CINT(mark_2430));
	 return
	    (obj_t) (aux_3147);
      }
   }
}



/* make-sexit/ginfo */
sexit_ginfo_81_bglt 
make_sexit_ginfo_64_globalize_ginfo(obj_t handler_122, bool_t detached__120_123, bool_t g__219_124, bool_t kaptured__204_125, long free_mark_81_126, long mark_127)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 sexit_bglt aux1528_1709;
	 {	/* Globalize/ginfo.scm 66 */
	    sexit_bglt res1845_1721;
	    {	/* ./Ast/var.scm 527 */
	       sexit_bglt new1179_1715;
	       new1179_1715 =
		  ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	       {	/* ./Ast/var.scm 527 */
		  long arg1699_1716;
		  arg1699_1716 =
		     class_num_218___object(sexit_ast_var);
		  {	/* ./Ast/var.scm 527 */
		     obj_t obj_1719;
		     obj_1719 =
			(obj_t) (new1179_1715);
		     (((obj_t) CREF(obj_1719))->header = MAKE_HEADER(arg1699_1716, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 527 */
		  object_bglt aux_3158;
		  aux_3158 =
		     (object_bglt) (new1179_1715);
		  OBJECT_WIDENING_SET(aux_3158, BFALSE);
	       }
	       ((((sexit_bglt) CREF(new1179_1715))->handler) = ((obj_t) handler_122), BUNSPEC);
	       ((((sexit_bglt) CREF(new1179_1715))->detached__120) = ((bool_t) detached__120_123), BUNSPEC);
	       res1845_1721 = new1179_1715;
	    }
	    aux1528_1709 = res1845_1721;
	 }
	 {	/* Globalize/ginfo.scm 66 */
	    sexit_ginfo_81_bglt new1529_1710;
	    new1529_1710 =
	       ((sexit_ginfo_81_bglt) (aux1528_1709));
	    {	/* Globalize/ginfo.scm 66 */
	       long arg1642_1711;
	       arg1642_1711 =
		  class_num_218___object(sexit_ginfo_81_globalize_ginfo);
	       {	/* Globalize/ginfo.scm 66 */
		  obj_t obj_1722;
		  obj_1722 =
		     (obj_t) (new1529_1710);
		  (((obj_t) CREF(obj_1722))->header = MAKE_HEADER(arg1642_1711, 0), BUNSPEC);
	       }
	    }
	    {	/* Globalize/ginfo.scm 66 */
	       sexit_ginfo_81_bglt arg1643_1712;
	       {	/* Globalize/ginfo.scm 66 */
		  sexit_ginfo_81_bglt res1846_1733;
		  {	/* Globalize/ginfo.scm 66 */
		     sexit_ginfo_81_bglt new1522_1728;
		     new1522_1728 =
			((sexit_ginfo_81_bglt) BREF(GC_MALLOC(sizeof(struct sexit_ginfo_81))));
		     ((((sexit_ginfo_81_bglt) CREF(new1522_1728))->g__219) = ((bool_t) g__219_124), BUNSPEC);
		     ((((sexit_ginfo_81_bglt) CREF(new1522_1728))->kaptured__204) = ((bool_t) kaptured__204_125), BUNSPEC);
		     ((((sexit_ginfo_81_bglt) CREF(new1522_1728))->free_mark_81) = ((long) free_mark_81_126), BUNSPEC);
		     ((((sexit_ginfo_81_bglt) CREF(new1522_1728))->mark) = ((long) mark_127), BUNSPEC);
		     res1846_1733 = new1522_1728;
		  }
		  arg1643_1712 = res1846_1733;
	       }
	       {	/* Globalize/ginfo.scm 66 */
		  obj_t aux_3174;
		  object_bglt aux_3172;
		  aux_3174 =
		     (obj_t) (arg1643_1712);
		  aux_3172 =
		     (object_bglt) (new1529_1710);
		  OBJECT_WIDENING_SET(aux_3172, aux_3174);
	       }
	    }
	    return new1529_1710;
	 }
      }
   }
}



/* _make-sexit/ginfo */
obj_t 
_make_sexit_ginfo_31_globalize_ginfo(obj_t env_2431, obj_t handler_2432, obj_t detached__120_2433, obj_t g__219_2434, obj_t kaptured__204_2435, obj_t free_mark_81_2436, obj_t mark_2437)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {		/* Globalize/ginfo.scm 66 */
	 sexit_ginfo_81_bglt aux_3177;
	 aux_3177 =
	    make_sexit_ginfo_64_globalize_ginfo(handler_2432,
	    CBOOL(detached__120_2433),
	    CBOOL(g__219_2434),
	    CBOOL(kaptured__204_2435),
	    (long) CINT(free_mark_81_2436),
	    (long) CINT(mark_2437));
	 return
	    (obj_t) (aux_3177);
      }
   }
}



/* sexit/ginfo-handler-set! */
obj_t 
sexit_ginfo_handler_set__242_globalize_ginfo(sexit_bglt obj_128, obj_t val1516_129)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      return
	 ((((sexit_bglt) CREF(obj_128))->handler) = ((obj_t) val1516_129), BUNSPEC);
   }
}



/* _sexit/ginfo-handler-set! */
obj_t 
_sexit_ginfo_handler_set__21_globalize_ginfo(obj_t env_2438, obj_t obj_2439, obj_t val1516_2440)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      return
	 sexit_ginfo_handler_set__242_globalize_ginfo(
	 (sexit_bglt) (obj_2439), val1516_2440);
   }
}



/* sexit/ginfo-handler */
obj_t 
sexit_ginfo_handler_183_globalize_ginfo(sexit_bglt obj_130)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      return
	 (((sexit_bglt) CREF(obj_130))->handler);
   }
}



/* _sexit/ginfo-handler */
obj_t 
_sexit_ginfo_handler_57_globalize_ginfo(obj_t env_2441, obj_t obj_2442)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      return
	 sexit_ginfo_handler_183_globalize_ginfo(
	 (sexit_bglt) (obj_2442));
   }
}



/* sexit/ginfo-detached?-set! */
obj_t 
sexit_ginfo_detached__set__219_globalize_ginfo(sexit_bglt obj_131, bool_t val1517_132)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 531 */
      return
	 ((((sexit_bglt) CREF(obj_131))->detached__120) = ((bool_t) val1517_132), BUNSPEC);
   }
}



/* _sexit/ginfo-detached?-set! */
obj_t 
_sexit_ginfo_detached__set__161_globalize_ginfo(obj_t env_2443, obj_t obj_2444, obj_t val1517_2445)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 531 */
      return
	 sexit_ginfo_detached__set__219_globalize_ginfo(
	 (sexit_bglt) (obj_2444),
	 CBOOL(val1517_2445));
   }
}



/* sexit/ginfo-detached? */
bool_t 
sexit_ginfo_detached__158_globalize_ginfo(sexit_bglt obj_133)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 531 */
      return
	 (((sexit_bglt) CREF(obj_133))->detached__120);
   }
}



/* _sexit/ginfo-detached? */
obj_t 
_sexit_ginfo_detached__10_globalize_ginfo(obj_t env_2446, obj_t obj_2447)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 531 */
      {		/* ./Ast/var.scm 531 */
	 bool_t aux_3196;
	 aux_3196 =
	    sexit_ginfo_detached__158_globalize_ginfo(
	    (sexit_bglt) (obj_2447));
	 return
	    BBOOL(aux_3196);
      }
   }
}



/* sexit/ginfo-g?-set! */
obj_t 
sexit_ginfo_g__set__228_globalize_ginfo(sexit_ginfo_81_bglt obj_134, bool_t val1518_135)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 68 */
      {
	 obj_t aux_3200;
	 {	/* Globalize/ginfo.scm 68 */
	    object_bglt aux_3201;
	    aux_3201 =
	       (object_bglt) (obj_134);
	    aux_3200 =
	       OBJECT_WIDENING(aux_3201);
	 }
	 return
	    ((((sexit_ginfo_81_bglt) CREF(aux_3200))->g__219) = ((bool_t) val1518_135), BUNSPEC);
      }
   }
}



/* _sexit/ginfo-g?-set! */
obj_t 
_sexit_ginfo_g__set__97_globalize_ginfo(obj_t env_2448, obj_t obj_2449, obj_t val1518_2450)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 68 */
      return
	 sexit_ginfo_g__set__228_globalize_ginfo(
	 (sexit_ginfo_81_bglt) (obj_2449),
	 CBOOL(val1518_2450));
   }
}



/* sexit/ginfo-g? */
bool_t 
sexit_ginfo_g__71_globalize_ginfo(sexit_ginfo_81_bglt obj_136)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 68 */
      {
	 obj_t aux_3208;
	 {	/* Globalize/ginfo.scm 68 */
	    object_bglt aux_3209;
	    aux_3209 =
	       (object_bglt) (obj_136);
	    aux_3208 =
	       OBJECT_WIDENING(aux_3209);
	 }
	 return
	    (((sexit_ginfo_81_bglt) CREF(aux_3208))->g__219);
      }
   }
}



/* _sexit/ginfo-g? */
obj_t 
_sexit_ginfo_g__85_globalize_ginfo(obj_t env_2451, obj_t obj_2452)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 68 */
      {		/* Globalize/ginfo.scm 68 */
	 bool_t aux_3213;
	 aux_3213 =
	    sexit_ginfo_g__71_globalize_ginfo(
	    (sexit_ginfo_81_bglt) (obj_2452));
	 return
	    BBOOL(aux_3213);
      }
   }
}



/* sexit/ginfo-kaptured?-set! */
obj_t 
sexit_ginfo_kaptured__set__207_globalize_ginfo(sexit_ginfo_81_bglt obj_137, bool_t val1519_138)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 70 */
      {
	 obj_t aux_3217;
	 {	/* Globalize/ginfo.scm 70 */
	    object_bglt aux_3218;
	    aux_3218 =
	       (object_bglt) (obj_137);
	    aux_3217 =
	       OBJECT_WIDENING(aux_3218);
	 }
	 return
	    ((((sexit_ginfo_81_bglt) CREF(aux_3217))->kaptured__204) = ((bool_t) val1519_138), BUNSPEC);
      }
   }
}



/* _sexit/ginfo-kaptured?-set! */
obj_t 
_sexit_ginfo_kaptured__set__154_globalize_ginfo(obj_t env_2453, obj_t obj_2454, obj_t val1519_2455)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 70 */
      return
	 sexit_ginfo_kaptured__set__207_globalize_ginfo(
	 (sexit_ginfo_81_bglt) (obj_2454),
	 CBOOL(val1519_2455));
   }
}



/* sexit/ginfo-kaptured? */
bool_t 
sexit_ginfo_kaptured__46_globalize_ginfo(sexit_ginfo_81_bglt obj_139)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 70 */
      {
	 obj_t aux_3225;
	 {	/* Globalize/ginfo.scm 70 */
	    object_bglt aux_3226;
	    aux_3226 =
	       (object_bglt) (obj_139);
	    aux_3225 =
	       OBJECT_WIDENING(aux_3226);
	 }
	 return
	    (((sexit_ginfo_81_bglt) CREF(aux_3225))->kaptured__204);
      }
   }
}



/* _sexit/ginfo-kaptured? */
obj_t 
_sexit_ginfo_kaptured__96_globalize_ginfo(obj_t env_2456, obj_t obj_2457)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 70 */
      {		/* Globalize/ginfo.scm 70 */
	 bool_t aux_3230;
	 aux_3230 =
	    sexit_ginfo_kaptured__46_globalize_ginfo(
	    (sexit_ginfo_81_bglt) (obj_2457));
	 return
	    BBOOL(aux_3230);
      }
   }
}



/* sexit/ginfo-free-mark-set! */
obj_t 
sexit_ginfo_free_mark_set__210_globalize_ginfo(sexit_ginfo_81_bglt obj_140, long val1520_141)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 72 */
      {
	 obj_t aux_3234;
	 {	/* Globalize/ginfo.scm 72 */
	    object_bglt aux_3235;
	    aux_3235 =
	       (object_bglt) (obj_140);
	    aux_3234 =
	       OBJECT_WIDENING(aux_3235);
	 }
	 return
	    ((((sexit_ginfo_81_bglt) CREF(aux_3234))->free_mark_81) = ((long) val1520_141), BUNSPEC);
      }
   }
}



/* _sexit/ginfo-free-mark-set! */
obj_t 
_sexit_ginfo_free_mark_set__236_globalize_ginfo(obj_t env_2458, obj_t obj_2459, obj_t val1520_2460)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 72 */
      return
	 sexit_ginfo_free_mark_set__210_globalize_ginfo(
	 (sexit_ginfo_81_bglt) (obj_2459),
	 (long) CINT(val1520_2460));
   }
}



/* sexit/ginfo-free-mark */
long 
sexit_ginfo_free_mark_205_globalize_ginfo(sexit_ginfo_81_bglt obj_142)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 72 */
      {
	 obj_t aux_3242;
	 {	/* Globalize/ginfo.scm 72 */
	    object_bglt aux_3243;
	    aux_3243 =
	       (object_bglt) (obj_142);
	    aux_3242 =
	       OBJECT_WIDENING(aux_3243);
	 }
	 return
	    (((sexit_ginfo_81_bglt) CREF(aux_3242))->free_mark_81);
      }
   }
}



/* _sexit/ginfo-free-mark */
obj_t 
_sexit_ginfo_free_mark_164_globalize_ginfo(obj_t env_2461, obj_t obj_2462)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 72 */
      {		/* Globalize/ginfo.scm 72 */
	 long aux_3247;
	 aux_3247 =
	    sexit_ginfo_free_mark_205_globalize_ginfo(
	    (sexit_ginfo_81_bglt) (obj_2462));
	 return
	    BINT(aux_3247);
      }
   }
}



/* sexit/ginfo-mark-set! */
obj_t 
sexit_ginfo_mark_set__228_globalize_ginfo(sexit_ginfo_81_bglt obj_143, long val1521_144)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 74 */
      {
	 obj_t aux_3251;
	 {	/* Globalize/ginfo.scm 74 */
	    object_bglt aux_3252;
	    aux_3252 =
	       (object_bglt) (obj_143);
	    aux_3251 =
	       OBJECT_WIDENING(aux_3252);
	 }
	 return
	    ((((sexit_ginfo_81_bglt) CREF(aux_3251))->mark) = ((long) val1521_144), BUNSPEC);
      }
   }
}



/* _sexit/ginfo-mark-set! */
obj_t 
_sexit_ginfo_mark_set__102_globalize_ginfo(obj_t env_2463, obj_t obj_2464, obj_t val1521_2465)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 74 */
      return
	 sexit_ginfo_mark_set__228_globalize_ginfo(
	 (sexit_ginfo_81_bglt) (obj_2464),
	 (long) CINT(val1521_2465));
   }
}



/* sexit/ginfo-mark */
long 
sexit_ginfo_mark_71_globalize_ginfo(sexit_ginfo_81_bglt obj_145)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 74 */
      {
	 obj_t aux_3259;
	 {	/* Globalize/ginfo.scm 74 */
	    object_bglt aux_3260;
	    aux_3260 =
	       (object_bglt) (obj_145);
	    aux_3259 =
	       OBJECT_WIDENING(aux_3260);
	 }
	 return
	    (((sexit_ginfo_81_bglt) CREF(aux_3259))->mark);
      }
   }
}



/* _sexit/ginfo-mark */
obj_t 
_sexit_ginfo_mark_211_globalize_ginfo(obj_t env_2466, obj_t obj_2467)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 74 */
      {		/* Globalize/ginfo.scm 74 */
	 long aux_3264;
	 aux_3264 =
	    sexit_ginfo_mark_71_globalize_ginfo(
	    (sexit_ginfo_81_bglt) (obj_2467));
	 return
	    BINT(aux_3264);
      }
   }
}



/* allocate-svar/ginfo */
svar_bglt 
allocate_svar_ginfo_12_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 svar_bglt new1509_1067;
	 new1509_1067 =
	    ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	 {	/* Globalize/ginfo.scm 56 */
	    long arg1644_1068;
	    arg1644_1068 =
	       class_num_218___object(svar_ginfo_131_globalize_ginfo);
	    {	/* Globalize/ginfo.scm 56 */
	       obj_t obj_1734;
	       obj_1734 =
		  (obj_t) (new1509_1067);
	       (((obj_t) CREF(obj_1734))->header = MAKE_HEADER(arg1644_1068, 0), BUNSPEC);
	    }
	 }
	 {	/* Globalize/ginfo.scm 56 */
	    object_bglt aux_3272;
	    aux_3272 =
	       (object_bglt) (new1509_1067);
	    OBJECT_WIDENING_SET(aux_3272, BFALSE);
	 }
	 return new1509_1067;
      }
   }
}



/* _allocate-svar/ginfo */
obj_t 
_allocate_svar_ginfo_235_globalize_ginfo(obj_t env_2256)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 svar_bglt aux_3275;
	 aux_3275 =
	    allocate_svar_ginfo_12_globalize_ginfo();
	 return
	    (obj_t) (aux_3275);
      }
   }
}



/* svar/ginfo? */
bool_t 
svar_ginfo__247_globalize_ginfo(obj_t obj_149)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      return
	 is_a__118___object(obj_149, svar_ginfo_131_globalize_ginfo);
   }
}



/* _svar/ginfo? */
obj_t 
_svar_ginfo__189_globalize_ginfo(obj_t env_2468, obj_t obj_2469)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 bool_t aux_3279;
	 aux_3279 =
	    svar_ginfo__247_globalize_ginfo(obj_2469);
	 return
	    BBOOL(aux_3279);
      }
   }
}



/* widening-svar/ginfo */
svar_ginfo_131_bglt 
widening_svar_ginfo_232_globalize_ginfo(bool_t kaptured__204_150, long free_mark_81_151, long mark_152, bool_t celled__113_153)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 svar_ginfo_131_bglt new1501_1736;
	 new1501_1736 =
	    ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
	 ((((svar_ginfo_131_bglt) CREF(new1501_1736))->kaptured__204) = ((bool_t) kaptured__204_150), BUNSPEC);
	 ((((svar_ginfo_131_bglt) CREF(new1501_1736))->free_mark_81) = ((long) free_mark_81_151), BUNSPEC);
	 ((((svar_ginfo_131_bglt) CREF(new1501_1736))->mark) = ((long) mark_152), BUNSPEC);
	 ((((svar_ginfo_131_bglt) CREF(new1501_1736))->celled__113) = ((bool_t) celled__113_153), BUNSPEC);
	 return new1501_1736;
      }
   }
}



/* _widening-svar/ginfo1857 */
obj_t 
_widening_svar_ginfo1857_103_globalize_ginfo(obj_t env_2470, obj_t kaptured__204_2471, obj_t free_mark_81_2472, obj_t mark_2473, obj_t celled__113_2474)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 svar_ginfo_131_bglt aux_3287;
	 aux_3287 =
	    widening_svar_ginfo_232_globalize_ginfo(
	    CBOOL(kaptured__204_2471),
	    (long) CINT(free_mark_81_2472),
	    (long) CINT(mark_2473),
	    CBOOL(celled__113_2474));
	 return
	    (obj_t) (aux_3287);
      }
   }
}



/* make-svar/ginfo */
svar_ginfo_131_bglt 
make_svar_ginfo_120_globalize_ginfo(obj_t loc_154, bool_t kaptured__204_155, long free_mark_81_156, long mark_157, bool_t celled__113_158)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 svar_bglt aux1507_1741;
	 {	/* Globalize/ginfo.scm 56 */
	    svar_bglt res1847_1751;
	    {	/* ./Ast/var.scm 507 */
	       svar_bglt new1161_1746;
	       new1161_1746 =
		  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	       {	/* ./Ast/var.scm 507 */
		  long arg1705_1747;
		  arg1705_1747 =
		     class_num_218___object(svar_ast_var);
		  {	/* ./Ast/var.scm 507 */
		     obj_t obj_1749;
		     obj_1749 =
			(obj_t) (new1161_1746);
		     (((obj_t) CREF(obj_1749))->header = MAKE_HEADER(arg1705_1747, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 507 */
		  object_bglt aux_3298;
		  aux_3298 =
		     (object_bglt) (new1161_1746);
		  OBJECT_WIDENING_SET(aux_3298, BFALSE);
	       }
	       ((((svar_bglt) CREF(new1161_1746))->loc) = ((obj_t) loc_154), BUNSPEC);
	       res1847_1751 = new1161_1746;
	    }
	    aux1507_1741 = res1847_1751;
	 }
	 {	/* Globalize/ginfo.scm 56 */
	    svar_ginfo_131_bglt new1508_1742;
	    new1508_1742 =
	       ((svar_ginfo_131_bglt) (aux1507_1741));
	    {	/* Globalize/ginfo.scm 56 */
	       long arg1646_1743;
	       arg1646_1743 =
		  class_num_218___object(svar_ginfo_131_globalize_ginfo);
	       {	/* Globalize/ginfo.scm 56 */
		  obj_t obj_1752;
		  obj_1752 =
		     (obj_t) (new1508_1742);
		  (((obj_t) CREF(obj_1752))->header = MAKE_HEADER(arg1646_1743, 0), BUNSPEC);
	       }
	    }
	    {	/* Globalize/ginfo.scm 56 */
	       svar_ginfo_131_bglt arg1647_1744;
	       {	/* Globalize/ginfo.scm 56 */
		  svar_ginfo_131_bglt res1848_1763;
		  {	/* Globalize/ginfo.scm 56 */
		     svar_ginfo_131_bglt new1501_1758;
		     new1501_1758 =
			((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
		     ((((svar_ginfo_131_bglt) CREF(new1501_1758))->kaptured__204) = ((bool_t) kaptured__204_155), BUNSPEC);
		     ((((svar_ginfo_131_bglt) CREF(new1501_1758))->free_mark_81) = ((long) free_mark_81_156), BUNSPEC);
		     ((((svar_ginfo_131_bglt) CREF(new1501_1758))->mark) = ((long) mark_157), BUNSPEC);
		     ((((svar_ginfo_131_bglt) CREF(new1501_1758))->celled__113) = ((bool_t) celled__113_158), BUNSPEC);
		     res1848_1763 = new1501_1758;
		  }
		  arg1647_1744 = res1848_1763;
	       }
	       {	/* Globalize/ginfo.scm 56 */
		  obj_t aux_3313;
		  object_bglt aux_3311;
		  aux_3313 =
		     (obj_t) (arg1647_1744);
		  aux_3311 =
		     (object_bglt) (new1508_1742);
		  OBJECT_WIDENING_SET(aux_3311, aux_3313);
	       }
	    }
	    return new1508_1742;
	 }
      }
   }
}



/* _make-svar/ginfo */
obj_t 
_make_svar_ginfo_118_globalize_ginfo(obj_t env_2475, obj_t loc_2476, obj_t kaptured__204_2477, obj_t free_mark_81_2478, obj_t mark_2479, obj_t celled__113_2480)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {		/* Globalize/ginfo.scm 56 */
	 svar_ginfo_131_bglt aux_3316;
	 aux_3316 =
	    make_svar_ginfo_120_globalize_ginfo(loc_2476,
	    CBOOL(kaptured__204_2477),
	    (long) CINT(free_mark_81_2478),
	    (long) CINT(mark_2479),
	    CBOOL(celled__113_2480));
	 return
	    (obj_t) (aux_3316);
      }
   }
}



/* svar/ginfo-loc-set! */
obj_t 
svar_ginfo_loc_set__72_globalize_ginfo(svar_bglt obj_159, obj_t val1496_160)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 509 */
      return
	 ((((svar_bglt) CREF(obj_159))->loc) = ((obj_t) val1496_160), BUNSPEC);
   }
}



/* _svar/ginfo-loc-set! */
obj_t 
_svar_ginfo_loc_set__201_globalize_ginfo(obj_t env_2481, obj_t obj_2482, obj_t val1496_2483)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 509 */
      return
	 svar_ginfo_loc_set__72_globalize_ginfo(
	 (svar_bglt) (obj_2482), val1496_2483);
   }
}



/* svar/ginfo-loc */
obj_t 
svar_ginfo_loc_12_globalize_ginfo(svar_bglt obj_161)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 509 */
      return
	 (((svar_bglt) CREF(obj_161))->loc);
   }
}



/* _svar/ginfo-loc */
obj_t 
_svar_ginfo_loc_170_globalize_ginfo(obj_t env_2484, obj_t obj_2485)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 509 */
      return
	 svar_ginfo_loc_12_globalize_ginfo(
	 (svar_bglt) (obj_2485));
   }
}



/* svar/ginfo-kaptured?-set! */
obj_t 
svar_ginfo_kaptured__set__85_globalize_ginfo(svar_ginfo_131_bglt obj_162, bool_t val1497_163)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 58 */
      {
	 obj_t aux_3329;
	 {	/* Globalize/ginfo.scm 58 */
	    object_bglt aux_3330;
	    aux_3330 =
	       (object_bglt) (obj_162);
	    aux_3329 =
	       OBJECT_WIDENING(aux_3330);
	 }
	 return
	    ((((svar_ginfo_131_bglt) CREF(aux_3329))->kaptured__204) = ((bool_t) val1497_163), BUNSPEC);
      }
   }
}



/* _svar/ginfo-kaptured?-set! */
obj_t 
_svar_ginfo_kaptured__set__94_globalize_ginfo(obj_t env_2486, obj_t obj_2487, obj_t val1497_2488)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 58 */
      return
	 svar_ginfo_kaptured__set__85_globalize_ginfo(
	 (svar_ginfo_131_bglt) (obj_2487),
	 CBOOL(val1497_2488));
   }
}



/* svar/ginfo-kaptured? */
bool_t 
svar_ginfo_kaptured__26_globalize_ginfo(svar_ginfo_131_bglt obj_164)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 58 */
      {
	 obj_t aux_3337;
	 {	/* Globalize/ginfo.scm 58 */
	    object_bglt aux_3338;
	    aux_3338 =
	       (object_bglt) (obj_164);
	    aux_3337 =
	       OBJECT_WIDENING(aux_3338);
	 }
	 return
	    (((svar_ginfo_131_bglt) CREF(aux_3337))->kaptured__204);
      }
   }
}



/* _svar/ginfo-kaptured? */
obj_t 
_svar_ginfo_kaptured__36_globalize_ginfo(obj_t env_2489, obj_t obj_2490)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 58 */
      {		/* Globalize/ginfo.scm 58 */
	 bool_t aux_3342;
	 aux_3342 =
	    svar_ginfo_kaptured__26_globalize_ginfo(
	    (svar_ginfo_131_bglt) (obj_2490));
	 return
	    BBOOL(aux_3342);
      }
   }
}



/* svar/ginfo-free-mark-set! */
obj_t 
svar_ginfo_free_mark_set__224_globalize_ginfo(svar_ginfo_131_bglt obj_165, long val1498_166)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 60 */
      {
	 obj_t aux_3346;
	 {	/* Globalize/ginfo.scm 60 */
	    object_bglt aux_3347;
	    aux_3347 =
	       (object_bglt) (obj_165);
	    aux_3346 =
	       OBJECT_WIDENING(aux_3347);
	 }
	 return
	    ((((svar_ginfo_131_bglt) CREF(aux_3346))->free_mark_81) = ((long) val1498_166), BUNSPEC);
      }
   }
}



/* _svar/ginfo-free-mark-set! */
obj_t 
_svar_ginfo_free_mark_set__142_globalize_ginfo(obj_t env_2491, obj_t obj_2492, obj_t val1498_2493)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 60 */
      return
	 svar_ginfo_free_mark_set__224_globalize_ginfo(
	 (svar_ginfo_131_bglt) (obj_2492),
	 (long) CINT(val1498_2493));
   }
}



/* svar/ginfo-free-mark */
long 
svar_ginfo_free_mark_225_globalize_ginfo(svar_ginfo_131_bglt obj_167)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 60 */
      {
	 obj_t aux_3354;
	 {	/* Globalize/ginfo.scm 60 */
	    object_bglt aux_3355;
	    aux_3355 =
	       (object_bglt) (obj_167);
	    aux_3354 =
	       OBJECT_WIDENING(aux_3355);
	 }
	 return
	    (((svar_ginfo_131_bglt) CREF(aux_3354))->free_mark_81);
      }
   }
}



/* _svar/ginfo-free-mark */
obj_t 
_svar_ginfo_free_mark_39_globalize_ginfo(obj_t env_2494, obj_t obj_2495)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 60 */
      {		/* Globalize/ginfo.scm 60 */
	 long aux_3359;
	 aux_3359 =
	    svar_ginfo_free_mark_225_globalize_ginfo(
	    (svar_ginfo_131_bglt) (obj_2495));
	 return
	    BINT(aux_3359);
      }
   }
}



/* svar/ginfo-mark-set! */
obj_t 
svar_ginfo_mark_set__188_globalize_ginfo(svar_ginfo_131_bglt obj_168, long val1499_169)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 62 */
      {
	 obj_t aux_3363;
	 {	/* Globalize/ginfo.scm 62 */
	    object_bglt aux_3364;
	    aux_3364 =
	       (object_bglt) (obj_168);
	    aux_3363 =
	       OBJECT_WIDENING(aux_3364);
	 }
	 return
	    ((((svar_ginfo_131_bglt) CREF(aux_3363))->mark) = ((long) val1499_169), BUNSPEC);
      }
   }
}



/* _svar/ginfo-mark-set! */
obj_t 
_svar_ginfo_mark_set__68_globalize_ginfo(obj_t env_2496, obj_t obj_2497, obj_t val1499_2498)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 62 */
      return
	 svar_ginfo_mark_set__188_globalize_ginfo(
	 (svar_ginfo_131_bglt) (obj_2497),
	 (long) CINT(val1499_2498));
   }
}



/* svar/ginfo-mark */
long 
svar_ginfo_mark_222_globalize_ginfo(svar_ginfo_131_bglt obj_170)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 62 */
      {
	 obj_t aux_3371;
	 {	/* Globalize/ginfo.scm 62 */
	    object_bglt aux_3372;
	    aux_3372 =
	       (object_bglt) (obj_170);
	    aux_3371 =
	       OBJECT_WIDENING(aux_3372);
	 }
	 return
	    (((svar_ginfo_131_bglt) CREF(aux_3371))->mark);
      }
   }
}



/* _svar/ginfo-mark */
obj_t 
_svar_ginfo_mark_140_globalize_ginfo(obj_t env_2499, obj_t obj_2500)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 62 */
      {		/* Globalize/ginfo.scm 62 */
	 long aux_3376;
	 aux_3376 =
	    svar_ginfo_mark_222_globalize_ginfo(
	    (svar_ginfo_131_bglt) (obj_2500));
	 return
	    BINT(aux_3376);
      }
   }
}



/* svar/ginfo-celled?-set! */
obj_t 
svar_ginfo_celled__set__234_globalize_ginfo(svar_ginfo_131_bglt obj_171, bool_t val1500_172)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 64 */
      {
	 obj_t aux_3380;
	 {	/* Globalize/ginfo.scm 64 */
	    object_bglt aux_3381;
	    aux_3381 =
	       (object_bglt) (obj_171);
	    aux_3380 =
	       OBJECT_WIDENING(aux_3381);
	 }
	 return
	    ((((svar_ginfo_131_bglt) CREF(aux_3380))->celled__113) = ((bool_t) val1500_172), BUNSPEC);
      }
   }
}



/* _svar/ginfo-celled?-set! */
obj_t 
_svar_ginfo_celled__set__105_globalize_ginfo(obj_t env_2501, obj_t obj_2502, obj_t val1500_2503)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 64 */
      return
	 svar_ginfo_celled__set__234_globalize_ginfo(
	 (svar_ginfo_131_bglt) (obj_2502),
	 CBOOL(val1500_2503));
   }
}



/* svar/ginfo-celled? */
bool_t 
svar_ginfo_celled__246_globalize_ginfo(svar_ginfo_131_bglt obj_173)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 64 */
      {
	 obj_t aux_3388;
	 {	/* Globalize/ginfo.scm 64 */
	    object_bglt aux_3389;
	    aux_3389 =
	       (object_bglt) (obj_173);
	    aux_3388 =
	       OBJECT_WIDENING(aux_3389);
	 }
	 return
	    (((svar_ginfo_131_bglt) CREF(aux_3388))->celled__113);
      }
   }
}



/* _svar/ginfo-celled? */
obj_t 
_svar_ginfo_celled__203_globalize_ginfo(obj_t env_2504, obj_t obj_2505)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 64 */
      {		/* Globalize/ginfo.scm 64 */
	 bool_t aux_3393;
	 aux_3393 =
	    svar_ginfo_celled__246_globalize_ginfo(
	    (svar_ginfo_131_bglt) (obj_2505));
	 return
	    BBOOL(aux_3393);
      }
   }
}



/* allocate-sfun/ginfo */
sfun_bglt 
allocate_sfun_ginfo_135_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 sfun_bglt new1488_1078;
	 new1488_1078 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Globalize/ginfo.scm 18 */
	    long arg1648_1079;
	    arg1648_1079 =
	       class_num_218___object(sfun_ginfo_98_globalize_ginfo);
	    {	/* Globalize/ginfo.scm 18 */
	       obj_t obj_1764;
	       obj_1764 =
		  (obj_t) (new1488_1078);
	       (((obj_t) CREF(obj_1764))->header = MAKE_HEADER(arg1648_1079, 0), BUNSPEC);
	    }
	 }
	 {	/* Globalize/ginfo.scm 18 */
	    object_bglt aux_3401;
	    aux_3401 =
	       (object_bglt) (new1488_1078);
	    OBJECT_WIDENING_SET(aux_3401, BFALSE);
	 }
	 return new1488_1078;
      }
   }
}



/* _allocate-sfun/ginfo */
obj_t 
_allocate_sfun_ginfo_166_globalize_ginfo(obj_t env_2255)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 sfun_bglt aux_3404;
	 aux_3404 =
	    allocate_sfun_ginfo_135_globalize_ginfo();
	 return
	    (obj_t) (aux_3404);
      }
   }
}



/* sfun/ginfo? */
bool_t 
sfun_ginfo__192_globalize_ginfo(obj_t obj_177)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      return
	 is_a__118___object(obj_177, sfun_ginfo_98_globalize_ginfo);
   }
}



/* _sfun/ginfo? */
obj_t 
_sfun_ginfo__175_globalize_ginfo(obj_t env_2506, obj_t obj_2507)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 bool_t aux_3408;
	 aux_3408 =
	    sfun_ginfo__192_globalize_ginfo(obj_2507);
	 return
	    BBOOL(aux_3408);
      }
   }
}



/* widening-sfun/ginfo */
sfun_ginfo_98_bglt 
widening_sfun_ginfo_255_globalize_ginfo(bool_t g__219_178, obj_t cfrom_179, obj_t cfrom__119_180, obj_t cto_181, obj_t cto__14_182, obj_t cfunction_183, obj_t integrator_184, obj_t integrated_185, obj_t plugged_in_15_186, long mark_187, obj_t free_mark_81_188, obj_t the_global_201_189, obj_t kaptured_190, obj_t new_body_215_191, long bmark_192, long umark_193, obj_t free_194, obj_t bound_195)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 sfun_ginfo_98_bglt new1466_1766;
	 new1466_1766 =
	    ((sfun_ginfo_98_bglt) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->g__219) = ((bool_t) g__219_178), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->cfrom) = ((obj_t) cfrom_179), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->cfrom__119) = ((obj_t) cfrom__119_180), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->cto) = ((obj_t) cto_181), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->cto__14) = ((obj_t) cto__14_182), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->cfunction) = ((obj_t) cfunction_183), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->integrator) = ((obj_t) integrator_184), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->integrated) = ((obj_t) integrated_185), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->plugged_in_15) = ((obj_t) plugged_in_15_186), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->mark) = ((long) mark_187), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->free_mark_81) = ((obj_t) free_mark_81_188), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->the_global_201) = ((obj_t) the_global_201_189), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->kaptured) = ((obj_t) kaptured_190), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->new_body_215) = ((obj_t) new_body_215_191), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->bmark) = ((long) bmark_192), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->umark) = ((long) umark_193), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->free) = ((obj_t) free_194), BUNSPEC);
	 ((((sfun_ginfo_98_bglt) CREF(new1466_1766))->bound) = ((obj_t) bound_195), BUNSPEC);
	 return new1466_1766;
      }
   }
}



/* _widening-sfun/ginfo1858 */
obj_t 
_widening_sfun_ginfo1858_135_globalize_ginfo(obj_t env_2508, obj_t g__219_2509, obj_t cfrom_2510, obj_t cfrom__119_2511, obj_t cto_2512, obj_t cto__14_2513, obj_t cfunction_2514, obj_t integrator_2515, obj_t integrated_2516, obj_t plugged_in_15_2517, obj_t mark_2518, obj_t free_mark_81_2519, obj_t the_global_201_2520, obj_t kaptured_2521, obj_t new_body_215_2522, obj_t bmark_2523, obj_t umark_2524, obj_t free_2525, obj_t bound_2526)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 sfun_ginfo_98_bglt aux_3430;
	 aux_3430 =
	    widening_sfun_ginfo_255_globalize_ginfo(
	    CBOOL(g__219_2509), cfrom_2510, cfrom__119_2511, cto_2512, cto__14_2513, cfunction_2514, integrator_2515, integrated_2516, plugged_in_15_2517,
	    (long) CINT(mark_2518), free_mark_81_2519, the_global_201_2520, kaptured_2521, new_body_215_2522,
	    (long) CINT(bmark_2523),
	    (long) CINT(umark_2524), free_2525, bound_2526);
	 return
	    (obj_t) (aux_3430);
      }
   }
}



/* make-sfun/ginfo */
sfun_ginfo_98_bglt 
make_sfun_ginfo_212_globalize_ginfo(long arity_196, obj_t side_effect__165_197, obj_t predicate_of_78_198, obj_t stack_allocator_172_199, bool_t top__138_200, obj_t the_closure_238_201, obj_t property_202, obj_t args_203, obj_t body_204, obj_t class_205, obj_t dsssl_keywords_243_206, obj_t loc_207, bool_t g__219_208, obj_t cfrom_209, obj_t cfrom__119_210, obj_t cto_211, obj_t cto__14_212, obj_t cfunction_213, obj_t integrator_214, obj_t integrated_215, obj_t plugged_in_15_216, long mark_217, obj_t free_mark_81_218, obj_t the_global_201_219, obj_t kaptured_220, obj_t new_body_215_221, long bmark_222, long umark_223, obj_t free_224, obj_t bound_225)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 sfun_bglt aux1486_1785;
	 {	/* Globalize/ginfo.scm 18 */
	    sfun_bglt res1849_1817;
	    {	/* ./Ast/var.scm 478 */
	       sfun_bglt new1127_1801;
	       new1127_1801 =
		  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	       {	/* ./Ast/var.scm 478 */
		  long arg1709_1802;
		  arg1709_1802 =
		     class_num_218___object(sfun_ast_var);
		  {	/* ./Ast/var.scm 478 */
		     obj_t obj_1815;
		     obj_1815 =
			(obj_t) (new1127_1801);
		     (((obj_t) CREF(obj_1815))->header = MAKE_HEADER(arg1709_1802, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 478 */
		  object_bglt aux_3441;
		  aux_3441 =
		     (object_bglt) (new1127_1801);
		  OBJECT_WIDENING_SET(aux_3441, BFALSE);
	       }
	       ((((sfun_bglt) CREF(new1127_1801))->arity) = ((long) arity_196), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->side_effect__165) = ((obj_t) side_effect__165_197), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->predicate_of_78) = ((obj_t) predicate_of_78_198), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->stack_allocator_172) = ((obj_t) stack_allocator_172_199), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->top__138) = ((bool_t) top__138_200), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->the_closure_238) = ((obj_t) the_closure_238_201), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->property) = ((obj_t) property_202), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->args) = ((obj_t) args_203), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->body) = ((obj_t) body_204), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->class) = ((obj_t) class_205), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_206), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1801))->loc) = ((obj_t) loc_207), BUNSPEC);
	       res1849_1817 = new1127_1801;
	    }
	    aux1486_1785 = res1849_1817;
	 }
	 {	/* Globalize/ginfo.scm 18 */
	    sfun_ginfo_98_bglt new1487_1786;
	    new1487_1786 =
	       ((sfun_ginfo_98_bglt) (aux1486_1785));
	    {	/* Globalize/ginfo.scm 18 */
	       long arg1649_1787;
	       arg1649_1787 =
		  class_num_218___object(sfun_ginfo_98_globalize_ginfo);
	       {	/* Globalize/ginfo.scm 18 */
		  obj_t obj_1818;
		  obj_1818 =
		     (obj_t) (new1487_1786);
		  (((obj_t) CREF(obj_1818))->header = MAKE_HEADER(arg1649_1787, 0), BUNSPEC);
	       }
	    }
	    {	/* Globalize/ginfo.scm 18 */
	       sfun_ginfo_98_bglt arg1650_1788;
	       {	/* Globalize/ginfo.scm 18 */
		  sfun_ginfo_98_bglt res1850_1857;
		  {	/* Globalize/ginfo.scm 18 */
		     sfun_ginfo_98_bglt new1466_1838;
		     new1466_1838 =
			((sfun_ginfo_98_bglt) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->g__219) = ((bool_t) g__219_208), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->cfrom) = ((obj_t) cfrom_209), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->cfrom__119) = ((obj_t) cfrom__119_210), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->cto) = ((obj_t) cto_211), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->cto__14) = ((obj_t) cto__14_212), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->cfunction) = ((obj_t) cfunction_213), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->integrator) = ((obj_t) integrator_214), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->integrated) = ((obj_t) integrated_215), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->plugged_in_15) = ((obj_t) plugged_in_15_216), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->mark) = ((long) mark_217), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->free_mark_81) = ((obj_t) free_mark_81_218), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->the_global_201) = ((obj_t) the_global_201_219), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->kaptured) = ((obj_t) kaptured_220), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->new_body_215) = ((obj_t) new_body_215_221), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->bmark) = ((long) bmark_222), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->umark) = ((long) umark_223), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->free) = ((obj_t) free_224), BUNSPEC);
		     ((((sfun_ginfo_98_bglt) CREF(new1466_1838))->bound) = ((obj_t) bound_225), BUNSPEC);
		     res1850_1857 = new1466_1838;
		  }
		  arg1650_1788 = res1850_1857;
	       }
	       {	/* Globalize/ginfo.scm 18 */
		  obj_t aux_3481;
		  object_bglt aux_3479;
		  aux_3481 =
		     (obj_t) (arg1650_1788);
		  aux_3479 =
		     (object_bglt) (new1487_1786);
		  OBJECT_WIDENING_SET(aux_3479, aux_3481);
	       }
	    }
	    return new1487_1786;
	 }
      }
   }
}



/* _make-sfun/ginfo */
obj_t 
_make_sfun_ginfo_29_globalize_ginfo(obj_t env_2527, obj_t arity_2528, obj_t side_effect__165_2529, obj_t predicate_of_78_2530, obj_t stack_allocator_172_2531, obj_t top__138_2532, obj_t the_closure_238_2533, obj_t property_2534, obj_t args_2535, obj_t body_2536, obj_t class_2537, obj_t dsssl_keywords_243_2538, obj_t loc_2539, obj_t g__219_2540, obj_t cfrom_2541, obj_t cfrom__119_2542, obj_t cto_2543, obj_t cto__14_2544, obj_t cfunction_2545, obj_t integrator_2546, obj_t integrated_2547, obj_t plugged_in_15_2548, obj_t mark_2549, obj_t free_mark_81_2550, obj_t the_global_201_2551, obj_t kaptured_2552, obj_t new_body_215_2553, obj_t bmark_2554, obj_t umark_2555, obj_t free_2556, obj_t bound_2557)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {		/* Globalize/ginfo.scm 18 */
	 sfun_ginfo_98_bglt aux_3484;
	 aux_3484 =
	    make_sfun_ginfo_212_globalize_ginfo(
	    (long) CINT(arity_2528), side_effect__165_2529, predicate_of_78_2530, stack_allocator_172_2531,
	    CBOOL(top__138_2532), the_closure_238_2533, property_2534, args_2535, body_2536, class_2537, dsssl_keywords_243_2538, loc_2539,
	    CBOOL(g__219_2540), cfrom_2541, cfrom__119_2542, cto_2543, cto__14_2544, cfunction_2545, integrator_2546, integrated_2547, plugged_in_15_2548,
	    (long) CINT(mark_2549), free_mark_81_2550, the_global_201_2551, kaptured_2552, new_body_215_2553,
	    (long) CINT(bmark_2554),
	    (long) CINT(umark_2555), free_2556, bound_2557);
	 return
	    (obj_t) (aux_3484);
      }
   }
}



/* sfun/ginfo-arity */
long 
sfun_ginfo_arity_67_globalize_ginfo(sfun_bglt obj_226)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 466 */
      return
	 (((sfun_bglt) CREF(obj_226))->arity);
   }
}



/* _sfun/ginfo-arity */
obj_t 
_sfun_ginfo_arity_149_globalize_ginfo(obj_t env_2558, obj_t obj_2559)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 466 */
      {		/* ./Ast/var.scm 466 */
	 long aux_3494;
	 aux_3494 =
	    sfun_ginfo_arity_67_globalize_ginfo(
	    (sfun_bglt) (obj_2559));
	 return
	    BINT(aux_3494);
      }
   }
}



/* sfun/ginfo-side-effect?-set! */
obj_t 
sfun_ginfo_side_effect__set__170_globalize_ginfo(sfun_bglt obj_227, obj_t val1437_228)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 468 */
      return
	 ((((sfun_bglt) CREF(obj_227))->side_effect__165) = ((obj_t) val1437_228), BUNSPEC);
   }
}



/* _sfun/ginfo-side-effect?-set! */
obj_t 
_sfun_ginfo_side_effect__set__156_globalize_ginfo(obj_t env_2560, obj_t obj_2561, obj_t val1437_2562)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 468 */
      return
	 sfun_ginfo_side_effect__set__170_globalize_ginfo(
	 (sfun_bglt) (obj_2561), val1437_2562);
   }
}



/* sfun/ginfo-side-effect? */
obj_t 
sfun_ginfo_side_effect__156_globalize_ginfo(sfun_bglt obj_229)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 468 */
      return
	 (((sfun_bglt) CREF(obj_229))->side_effect__165);
   }
}



/* _sfun/ginfo-side-effect? */
obj_t 
_sfun_ginfo_side_effect__207_globalize_ginfo(obj_t env_2563, obj_t obj_2564)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 468 */
      return
	 sfun_ginfo_side_effect__156_globalize_ginfo(
	 (sfun_bglt) (obj_2564));
   }
}



/* sfun/ginfo-predicate-of-set! */
obj_t 
sfun_ginfo_predicate_of_set__49_globalize_ginfo(sfun_bglt obj_230, obj_t val1438_231)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 470 */
      return
	 ((((sfun_bglt) CREF(obj_230))->predicate_of_78) = ((obj_t) val1438_231), BUNSPEC);
   }
}



/* _sfun/ginfo-predicate-of-set! */
obj_t 
_sfun_ginfo_predicate_of_set__167_globalize_ginfo(obj_t env_2565, obj_t obj_2566, obj_t val1438_2567)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 470 */
      return
	 sfun_ginfo_predicate_of_set__49_globalize_ginfo(
	 (sfun_bglt) (obj_2566), val1438_2567);
   }
}



/* sfun/ginfo-predicate-of */
obj_t 
sfun_ginfo_predicate_of_20_globalize_ginfo(sfun_bglt obj_232)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 470 */
      return
	 (((sfun_bglt) CREF(obj_232))->predicate_of_78);
   }
}



/* _sfun/ginfo-predicate-of */
obj_t 
_sfun_ginfo_predicate_of_91_globalize_ginfo(obj_t env_2568, obj_t obj_2569)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 470 */
      return
	 sfun_ginfo_predicate_of_20_globalize_ginfo(
	 (sfun_bglt) (obj_2569));
   }
}



/* sfun/ginfo-stack-allocator-set! */
obj_t 
sfun_ginfo_stack_allocator_set__224_globalize_ginfo(sfun_bglt obj_233, obj_t val1439_234)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 ((((sfun_bglt) CREF(obj_233))->stack_allocator_172) = ((obj_t) val1439_234), BUNSPEC);
   }
}



/* _sfun/ginfo-stack-allocator-set! */
obj_t 
_sfun_ginfo_stack_allocator_set__72_globalize_ginfo(obj_t env_2570, obj_t obj_2571, obj_t val1439_2572)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 sfun_ginfo_stack_allocator_set__224_globalize_ginfo(
	 (sfun_bglt) (obj_2571), val1439_2572);
   }
}



/* sfun/ginfo-stack-allocator */
obj_t 
sfun_ginfo_stack_allocator_225_globalize_ginfo(sfun_bglt obj_235)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 (((sfun_bglt) CREF(obj_235))->stack_allocator_172);
   }
}



/* _sfun/ginfo-stack-allocator */
obj_t 
_sfun_ginfo_stack_allocator_12_globalize_ginfo(obj_t env_2573, obj_t obj_2574)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 sfun_ginfo_stack_allocator_225_globalize_ginfo(
	 (sfun_bglt) (obj_2574));
   }
}



/* sfun/ginfo-top?-set! */
obj_t 
sfun_ginfo_top__set__155_globalize_ginfo(sfun_bglt obj_236, bool_t val1440_237)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 474 */
      return
	 ((((sfun_bglt) CREF(obj_236))->top__138) = ((bool_t) val1440_237), BUNSPEC);
   }
}



/* _sfun/ginfo-top?-set! */
obj_t 
_sfun_ginfo_top__set__166_globalize_ginfo(obj_t env_2575, obj_t obj_2576, obj_t val1440_2577)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 474 */
      return
	 sfun_ginfo_top__set__155_globalize_ginfo(
	 (sfun_bglt) (obj_2576),
	 CBOOL(val1440_2577));
   }
}



/* sfun/ginfo-top? */
bool_t 
sfun_ginfo_top__136_globalize_ginfo(sfun_bglt obj_238)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 474 */
      return
	 (((sfun_bglt) CREF(obj_238))->top__138);
   }
}



/* _sfun/ginfo-top? */
obj_t 
_sfun_ginfo_top__112_globalize_ginfo(obj_t env_2578, obj_t obj_2579)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 474 */
      {		/* ./Ast/var.scm 474 */
	 bool_t aux_3521;
	 aux_3521 =
	    sfun_ginfo_top__136_globalize_ginfo(
	    (sfun_bglt) (obj_2579));
	 return
	    BBOOL(aux_3521);
      }
   }
}



/* sfun/ginfo-the-closure-set! */
obj_t 
sfun_ginfo_the_closure_set__229_globalize_ginfo(sfun_bglt obj_239, obj_t val1441_240)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 476 */
      return
	 ((((sfun_bglt) CREF(obj_239))->the_closure_238) = ((obj_t) val1441_240), BUNSPEC);
   }
}



/* _sfun/ginfo-the-closure-set! */
obj_t 
_sfun_ginfo_the_closure_set__17_globalize_ginfo(obj_t env_2580, obj_t obj_2581, obj_t val1441_2582)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 476 */
      return
	 sfun_ginfo_the_closure_set__229_globalize_ginfo(
	 (sfun_bglt) (obj_2581), val1441_2582);
   }
}



/* sfun/ginfo-the-closure */
obj_t 
sfun_ginfo_the_closure_142_globalize_ginfo(sfun_bglt obj_241)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 476 */
      return
	 (((sfun_bglt) CREF(obj_241))->the_closure_238);
   }
}



/* _sfun/ginfo-the-closure */
obj_t 
_sfun_ginfo_the_closure_117_globalize_ginfo(obj_t env_2583, obj_t obj_2584)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 476 */
      return
	 sfun_ginfo_the_closure_142_globalize_ginfo(
	 (sfun_bglt) (obj_2584));
   }
}



/* sfun/ginfo-property-set! */
obj_t 
sfun_ginfo_property_set__8_globalize_ginfo(sfun_bglt obj_242, obj_t val1442_243)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 480 */
      return
	 ((((sfun_bglt) CREF(obj_242))->property) = ((obj_t) val1442_243), BUNSPEC);
   }
}



/* _sfun/ginfo-property-set! */
obj_t 
_sfun_ginfo_property_set__187_globalize_ginfo(obj_t env_2585, obj_t obj_2586, obj_t val1442_2587)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 480 */
      return
	 sfun_ginfo_property_set__8_globalize_ginfo(
	 (sfun_bglt) (obj_2586), val1442_2587);
   }
}



/* sfun/ginfo-property */
obj_t 
sfun_ginfo_property_59_globalize_ginfo(sfun_bglt obj_244)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 480 */
      return
	 (((sfun_bglt) CREF(obj_244))->property);
   }
}



/* _sfun/ginfo-property */
obj_t 
_sfun_ginfo_property_4_globalize_ginfo(obj_t env_2588, obj_t obj_2589)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 480 */
      return
	 sfun_ginfo_property_59_globalize_ginfo(
	 (sfun_bglt) (obj_2589));
   }
}



/* sfun/ginfo-args-set! */
obj_t 
sfun_ginfo_args_set__144_globalize_ginfo(sfun_bglt obj_245, obj_t val1443_246)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 482 */
      return
	 ((((sfun_bglt) CREF(obj_245))->args) = ((obj_t) val1443_246), BUNSPEC);
   }
}



/* _sfun/ginfo-args-set! */
obj_t 
_sfun_ginfo_args_set__97_globalize_ginfo(obj_t env_2590, obj_t obj_2591, obj_t val1443_2592)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 482 */
      return
	 sfun_ginfo_args_set__144_globalize_ginfo(
	 (sfun_bglt) (obj_2591), val1443_2592);
   }
}



/* sfun/ginfo-args */
obj_t 
sfun_ginfo_args_248_globalize_ginfo(sfun_bglt obj_247)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 482 */
      return
	 (((sfun_bglt) CREF(obj_247))->args);
   }
}



/* _sfun/ginfo-args */
obj_t 
_sfun_ginfo_args_85_globalize_ginfo(obj_t env_2593, obj_t obj_2594)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 482 */
      return
	 sfun_ginfo_args_248_globalize_ginfo(
	 (sfun_bglt) (obj_2594));
   }
}



/* sfun/ginfo-body-set! */
obj_t 
sfun_ginfo_body_set__10_globalize_ginfo(sfun_bglt obj_248, obj_t val1444_249)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 ((((sfun_bglt) CREF(obj_248))->body) = ((obj_t) val1444_249), BUNSPEC);
   }
}



/* _sfun/ginfo-body-set! */
obj_t 
_sfun_ginfo_body_set__72_globalize_ginfo(obj_t env_2595, obj_t obj_2596, obj_t val1444_2597)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 sfun_ginfo_body_set__10_globalize_ginfo(
	 (sfun_bglt) (obj_2596), val1444_2597);
   }
}



/* sfun/ginfo-body */
obj_t 
sfun_ginfo_body_35_globalize_ginfo(sfun_bglt obj_250)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 (((sfun_bglt) CREF(obj_250))->body);
   }
}



/* _sfun/ginfo-body */
obj_t 
_sfun_ginfo_body_12_globalize_ginfo(obj_t env_2598, obj_t obj_2599)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 sfun_ginfo_body_35_globalize_ginfo(
	 (sfun_bglt) (obj_2599));
   }
}



/* sfun/ginfo-class-set! */
obj_t 
sfun_ginfo_class_set__182_globalize_ginfo(sfun_bglt obj_251, obj_t val1445_252)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 486 */
      return
	 ((((sfun_bglt) CREF(obj_251))->class) = ((obj_t) val1445_252), BUNSPEC);
   }
}



/* _sfun/ginfo-class-set! */
obj_t 
_sfun_ginfo_class_set__214_globalize_ginfo(obj_t env_2600, obj_t obj_2601, obj_t val1445_2602)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 486 */
      return
	 sfun_ginfo_class_set__182_globalize_ginfo(
	 (sfun_bglt) (obj_2601), val1445_2602);
   }
}



/* sfun/ginfo-class */
obj_t 
sfun_ginfo_class_109_globalize_ginfo(sfun_bglt obj_253)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 486 */
      return
	 (((sfun_bglt) CREF(obj_253))->class);
   }
}



/* _sfun/ginfo-class */
obj_t 
_sfun_ginfo_class_139_globalize_ginfo(obj_t env_2603, obj_t obj_2604)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 486 */
      return
	 sfun_ginfo_class_109_globalize_ginfo(
	 (sfun_bglt) (obj_2604));
   }
}



/* sfun/ginfo-dsssl-keywords-set! */
obj_t 
sfun_ginfo_dsssl_keywords_set__63_globalize_ginfo(sfun_bglt obj_254, obj_t val1446_255)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 492 */
      return
	 ((((sfun_bglt) CREF(obj_254))->dsssl_keywords_243) = ((obj_t) val1446_255), BUNSPEC);
   }
}



/* _sfun/ginfo-dsssl-keywords-set! */
obj_t 
_sfun_ginfo_dsssl_keywords_set__93_globalize_ginfo(obj_t env_2605, obj_t obj_2606, obj_t val1446_2607)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 492 */
      return
	 sfun_ginfo_dsssl_keywords_set__63_globalize_ginfo(
	 (sfun_bglt) (obj_2606), val1446_2607);
   }
}



/* sfun/ginfo-dsssl-keywords */
obj_t 
sfun_ginfo_dsssl_keywords_77_globalize_ginfo(sfun_bglt obj_256)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 492 */
      return
	 (((sfun_bglt) CREF(obj_256))->dsssl_keywords_243);
   }
}



/* _sfun/ginfo-dsssl-keywords */
obj_t 
_sfun_ginfo_dsssl_keywords_15_globalize_ginfo(obj_t env_2608, obj_t obj_2609)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 492 */
      return
	 sfun_ginfo_dsssl_keywords_77_globalize_ginfo(
	 (sfun_bglt) (obj_2609));
   }
}



/* sfun/ginfo-loc-set! */
obj_t 
sfun_ginfo_loc_set__94_globalize_ginfo(sfun_bglt obj_257, obj_t val1447_258)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 ((((sfun_bglt) CREF(obj_257))->loc) = ((obj_t) val1447_258), BUNSPEC);
   }
}



/* _sfun/ginfo-loc-set! */
obj_t 
_sfun_ginfo_loc_set__190_globalize_ginfo(obj_t env_2610, obj_t obj_2611, obj_t val1447_2612)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 sfun_ginfo_loc_set__94_globalize_ginfo(
	 (sfun_bglt) (obj_2611), val1447_2612);
   }
}



/* sfun/ginfo-loc */
obj_t 
sfun_ginfo_loc_36_globalize_ginfo(sfun_bglt obj_259)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 (((sfun_bglt) CREF(obj_259))->loc);
   }
}



/* _sfun/ginfo-loc */
obj_t 
_sfun_ginfo_loc_64_globalize_ginfo(obj_t env_2613, obj_t obj_2614)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 497 */
      return
	 sfun_ginfo_loc_36_globalize_ginfo(
	 (sfun_bglt) (obj_2614));
   }
}



/* sfun/ginfo-g?-set! */
obj_t 
sfun_ginfo_g__set__43_globalize_ginfo(sfun_ginfo_98_bglt obj_260, bool_t val1448_261)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 20 */
      {
	 obj_t aux_3567;
	 {	/* Globalize/ginfo.scm 20 */
	    object_bglt aux_3568;
	    aux_3568 =
	       (object_bglt) (obj_260);
	    aux_3567 =
	       OBJECT_WIDENING(aux_3568);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3567))->g__219) = ((bool_t) val1448_261), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-g?-set! */
obj_t 
_sfun_ginfo_g__set__123_globalize_ginfo(obj_t env_2615, obj_t obj_2616, obj_t val1448_2617)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 20 */
      return
	 sfun_ginfo_g__set__43_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2616),
	 CBOOL(val1448_2617));
   }
}



/* sfun/ginfo-g? */
bool_t 
sfun_ginfo_g__97_globalize_ginfo(sfun_ginfo_98_bglt obj_262)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 20 */
      {
	 obj_t aux_3575;
	 {	/* Globalize/ginfo.scm 20 */
	    object_bglt aux_3576;
	    aux_3576 =
	       (object_bglt) (obj_262);
	    aux_3575 =
	       OBJECT_WIDENING(aux_3576);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3575))->g__219);
      }
   }
}



/* _sfun/ginfo-g? */
obj_t 
_sfun_ginfo_g__247_globalize_ginfo(obj_t env_2618, obj_t obj_2619)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 20 */
      {		/* Globalize/ginfo.scm 20 */
	 bool_t aux_3580;
	 aux_3580 =
	    sfun_ginfo_g__97_globalize_ginfo(
	    (sfun_ginfo_98_bglt) (obj_2619));
	 return
	    BBOOL(aux_3580);
      }
   }
}



/* sfun/ginfo-cfrom-set! */
obj_t 
sfun_ginfo_cfrom_set__112_globalize_ginfo(sfun_ginfo_98_bglt obj_263, obj_t val1449_264)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 22 */
      {
	 obj_t aux_3584;
	 {	/* Globalize/ginfo.scm 22 */
	    object_bglt aux_3585;
	    aux_3585 =
	       (object_bglt) (obj_263);
	    aux_3584 =
	       OBJECT_WIDENING(aux_3585);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3584))->cfrom) = ((obj_t) val1449_264), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-cfrom-set! */
obj_t 
_sfun_ginfo_cfrom_set__230_globalize_ginfo(obj_t env_2620, obj_t obj_2621, obj_t val1449_2622)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 22 */
      return
	 sfun_ginfo_cfrom_set__112_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2621), val1449_2622);
   }
}



/* sfun/ginfo-cfrom */
obj_t 
sfun_ginfo_cfrom_197_globalize_ginfo(sfun_ginfo_98_bglt obj_265)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 22 */
      {
	 obj_t aux_3591;
	 {	/* Globalize/ginfo.scm 22 */
	    object_bglt aux_3592;
	    aux_3592 =
	       (object_bglt) (obj_265);
	    aux_3591 =
	       OBJECT_WIDENING(aux_3592);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3591))->cfrom);
      }
   }
}



/* _sfun/ginfo-cfrom */
obj_t 
_sfun_ginfo_cfrom_60_globalize_ginfo(obj_t env_2623, obj_t obj_2624)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 22 */
      return
	 sfun_ginfo_cfrom_197_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2624));
   }
}



/* sfun/ginfo-cfrom*-set! */
obj_t 
sfun_ginfo_cfrom__set__37_globalize_ginfo(sfun_ginfo_98_bglt obj_266, obj_t val1450_267)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 24 */
      {
	 obj_t aux_3598;
	 {	/* Globalize/ginfo.scm 24 */
	    object_bglt aux_3599;
	    aux_3599 =
	       (object_bglt) (obj_266);
	    aux_3598 =
	       OBJECT_WIDENING(aux_3599);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3598))->cfrom__119) = ((obj_t) val1450_267), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-cfrom*-set! */
obj_t 
_sfun_ginfo_cfrom__set__27_globalize_ginfo(obj_t env_2625, obj_t obj_2626, obj_t val1450_2627)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 24 */
      return
	 sfun_ginfo_cfrom__set__37_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2626), val1450_2627);
   }
}



/* sfun/ginfo-cfrom* */
obj_t 
sfun_ginfo_cfrom__184_globalize_ginfo(sfun_ginfo_98_bglt obj_268)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 24 */
      {
	 obj_t aux_3605;
	 {	/* Globalize/ginfo.scm 24 */
	    object_bglt aux_3606;
	    aux_3606 =
	       (object_bglt) (obj_268);
	    aux_3605 =
	       OBJECT_WIDENING(aux_3606);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3605))->cfrom__119);
      }
   }
}



/* _sfun/ginfo-cfrom* */
obj_t 
_sfun_ginfo_cfrom__56_globalize_ginfo(obj_t env_2628, obj_t obj_2629)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 24 */
      return
	 sfun_ginfo_cfrom__184_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2629));
   }
}



/* sfun/ginfo-cto-set! */
obj_t 
sfun_ginfo_cto_set__23_globalize_ginfo(sfun_ginfo_98_bglt obj_269, obj_t val1451_270)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 26 */
      {
	 obj_t aux_3612;
	 {	/* Globalize/ginfo.scm 26 */
	    object_bglt aux_3613;
	    aux_3613 =
	       (object_bglt) (obj_269);
	    aux_3612 =
	       OBJECT_WIDENING(aux_3613);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3612))->cto) = ((obj_t) val1451_270), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-cto-set! */
obj_t 
_sfun_ginfo_cto_set__98_globalize_ginfo(obj_t env_2630, obj_t obj_2631, obj_t val1451_2632)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 26 */
      return
	 sfun_ginfo_cto_set__23_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2631), val1451_2632);
   }
}



/* sfun/ginfo-cto */
obj_t 
sfun_ginfo_cto_17_globalize_ginfo(sfun_ginfo_98_bglt obj_271)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 26 */
      {
	 obj_t aux_3619;
	 {	/* Globalize/ginfo.scm 26 */
	    object_bglt aux_3620;
	    aux_3620 =
	       (object_bglt) (obj_271);
	    aux_3619 =
	       OBJECT_WIDENING(aux_3620);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3619))->cto);
      }
   }
}



/* _sfun/ginfo-cto */
obj_t 
_sfun_ginfo_cto_162_globalize_ginfo(obj_t env_2633, obj_t obj_2634)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 26 */
      return
	 sfun_ginfo_cto_17_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2634));
   }
}



/* sfun/ginfo-cto*-set! */
obj_t 
sfun_ginfo_cto__set__57_globalize_ginfo(sfun_ginfo_98_bglt obj_272, obj_t val1452_273)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 28 */
      {
	 obj_t aux_3626;
	 {	/* Globalize/ginfo.scm 28 */
	    object_bglt aux_3627;
	    aux_3627 =
	       (object_bglt) (obj_272);
	    aux_3626 =
	       OBJECT_WIDENING(aux_3627);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3626))->cto__14) = ((obj_t) val1452_273), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-cto*-set! */
obj_t 
_sfun_ginfo_cto__set__232_globalize_ginfo(obj_t env_2635, obj_t obj_2636, obj_t val1452_2637)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 28 */
      return
	 sfun_ginfo_cto__set__57_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2636), val1452_2637);
   }
}



/* sfun/ginfo-cto* */
obj_t 
sfun_ginfo_cto__157_globalize_ginfo(sfun_ginfo_98_bglt obj_274)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 28 */
      {
	 obj_t aux_3633;
	 {	/* Globalize/ginfo.scm 28 */
	    object_bglt aux_3634;
	    aux_3634 =
	       (object_bglt) (obj_274);
	    aux_3633 =
	       OBJECT_WIDENING(aux_3634);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3633))->cto__14);
      }
   }
}



/* _sfun/ginfo-cto* */
obj_t 
_sfun_ginfo_cto__143_globalize_ginfo(obj_t env_2638, obj_t obj_2639)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 28 */
      return
	 sfun_ginfo_cto__157_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2639));
   }
}



/* sfun/ginfo-cfunction-set! */
obj_t 
sfun_ginfo_cfunction_set__96_globalize_ginfo(sfun_ginfo_98_bglt obj_275, obj_t val1453_276)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 30 */
      {
	 obj_t aux_3640;
	 {	/* Globalize/ginfo.scm 30 */
	    object_bglt aux_3641;
	    aux_3641 =
	       (object_bglt) (obj_275);
	    aux_3640 =
	       OBJECT_WIDENING(aux_3641);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3640))->cfunction) = ((obj_t) val1453_276), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-cfunction-set! */
obj_t 
_sfun_ginfo_cfunction_set__5_globalize_ginfo(obj_t env_2640, obj_t obj_2641, obj_t val1453_2642)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 30 */
      return
	 sfun_ginfo_cfunction_set__96_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2641), val1453_2642);
   }
}



/* sfun/ginfo-cfunction */
obj_t 
sfun_ginfo_cfunction_167_globalize_ginfo(sfun_ginfo_98_bglt obj_277)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 30 */
      {
	 obj_t aux_3647;
	 {	/* Globalize/ginfo.scm 30 */
	    object_bglt aux_3648;
	    aux_3648 =
	       (object_bglt) (obj_277);
	    aux_3647 =
	       OBJECT_WIDENING(aux_3648);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3647))->cfunction);
      }
   }
}



/* _sfun/ginfo-cfunction */
obj_t 
_sfun_ginfo_cfunction_245_globalize_ginfo(obj_t env_2643, obj_t obj_2644)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 30 */
      return
	 sfun_ginfo_cfunction_167_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2644));
   }
}



/* sfun/ginfo-integrator-set! */
obj_t 
sfun_ginfo_integrator_set__91_globalize_ginfo(sfun_ginfo_98_bglt obj_278, obj_t val1454_279)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 32 */
      {
	 obj_t aux_3654;
	 {	/* Globalize/ginfo.scm 32 */
	    object_bglt aux_3655;
	    aux_3655 =
	       (object_bglt) (obj_278);
	    aux_3654 =
	       OBJECT_WIDENING(aux_3655);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3654))->integrator) = ((obj_t) val1454_279), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-integrator-set! */
obj_t 
_sfun_ginfo_integrator_set__68_globalize_ginfo(obj_t env_2645, obj_t obj_2646, obj_t val1454_2647)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 32 */
      return
	 sfun_ginfo_integrator_set__91_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2646), val1454_2647);
   }
}



/* sfun/ginfo-integrator */
obj_t 
sfun_ginfo_integrator_0_globalize_ginfo(sfun_ginfo_98_bglt obj_280)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 32 */
      {
	 obj_t aux_3661;
	 {	/* Globalize/ginfo.scm 32 */
	    object_bglt aux_3662;
	    aux_3662 =
	       (object_bglt) (obj_280);
	    aux_3661 =
	       OBJECT_WIDENING(aux_3662);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3661))->integrator);
      }
   }
}



/* _sfun/ginfo-integrator */
obj_t 
_sfun_ginfo_integrator_140_globalize_ginfo(obj_t env_2648, obj_t obj_2649)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 32 */
      return
	 sfun_ginfo_integrator_0_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2649));
   }
}



/* sfun/ginfo-integrated-set! */
obj_t 
sfun_ginfo_integrated_set__252_globalize_ginfo(sfun_ginfo_98_bglt obj_281, obj_t val1455_282)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 34 */
      {
	 obj_t aux_3668;
	 {	/* Globalize/ginfo.scm 34 */
	    object_bglt aux_3669;
	    aux_3669 =
	       (object_bglt) (obj_281);
	    aux_3668 =
	       OBJECT_WIDENING(aux_3669);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3668))->integrated) = ((obj_t) val1455_282), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-integrated-set! */
obj_t 
_sfun_ginfo_integrated_set__125_globalize_ginfo(obj_t env_2650, obj_t obj_2651, obj_t val1455_2652)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 34 */
      return
	 sfun_ginfo_integrated_set__252_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2651), val1455_2652);
   }
}



/* sfun/ginfo-integrated */
obj_t 
sfun_ginfo_integrated_166_globalize_ginfo(sfun_ginfo_98_bglt obj_283)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 34 */
      {
	 obj_t aux_3675;
	 {	/* Globalize/ginfo.scm 34 */
	    object_bglt aux_3676;
	    aux_3676 =
	       (object_bglt) (obj_283);
	    aux_3675 =
	       OBJECT_WIDENING(aux_3676);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3675))->integrated);
      }
   }
}



/* _sfun/ginfo-integrated */
obj_t 
_sfun_ginfo_integrated_28_globalize_ginfo(obj_t env_2653, obj_t obj_2654)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 34 */
      return
	 sfun_ginfo_integrated_166_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2654));
   }
}



/* sfun/ginfo-plugged-in-set! */
obj_t 
sfun_ginfo_plugged_in_set__154_globalize_ginfo(sfun_ginfo_98_bglt obj_284, obj_t val1456_285)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 36 */
      {
	 obj_t aux_3682;
	 {	/* Globalize/ginfo.scm 36 */
	    object_bglt aux_3683;
	    aux_3683 =
	       (object_bglt) (obj_284);
	    aux_3682 =
	       OBJECT_WIDENING(aux_3683);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3682))->plugged_in_15) = ((obj_t) val1456_285), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-plugged-in-set! */
obj_t 
_sfun_ginfo_plugged_in_set__9_globalize_ginfo(obj_t env_2655, obj_t obj_2656, obj_t val1456_2657)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 36 */
      return
	 sfun_ginfo_plugged_in_set__154_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2656), val1456_2657);
   }
}



/* sfun/ginfo-plugged-in */
obj_t 
sfun_ginfo_plugged_in_96_globalize_ginfo(sfun_ginfo_98_bglt obj_286)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 36 */
      {
	 obj_t aux_3689;
	 {	/* Globalize/ginfo.scm 36 */
	    object_bglt aux_3690;
	    aux_3690 =
	       (object_bglt) (obj_286);
	    aux_3689 =
	       OBJECT_WIDENING(aux_3690);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3689))->plugged_in_15);
      }
   }
}



/* _sfun/ginfo-plugged-in */
obj_t 
_sfun_ginfo_plugged_in_98_globalize_ginfo(obj_t env_2658, obj_t obj_2659)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 36 */
      return
	 sfun_ginfo_plugged_in_96_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2659));
   }
}



/* sfun/ginfo-mark-set! */
obj_t 
sfun_ginfo_mark_set__52_globalize_ginfo(sfun_ginfo_98_bglt obj_287, long val1457_288)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 38 */
      {
	 obj_t aux_3696;
	 {	/* Globalize/ginfo.scm 38 */
	    object_bglt aux_3697;
	    aux_3697 =
	       (object_bglt) (obj_287);
	    aux_3696 =
	       OBJECT_WIDENING(aux_3697);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3696))->mark) = ((long) val1457_288), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-mark-set! */
obj_t 
_sfun_ginfo_mark_set__60_globalize_ginfo(obj_t env_2660, obj_t obj_2661, obj_t val1457_2662)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 38 */
      return
	 sfun_ginfo_mark_set__52_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2661),
	 (long) CINT(val1457_2662));
   }
}



/* sfun/ginfo-mark */
long 
sfun_ginfo_mark_177_globalize_ginfo(sfun_ginfo_98_bglt obj_289)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 38 */
      {
	 obj_t aux_3704;
	 {	/* Globalize/ginfo.scm 38 */
	    object_bglt aux_3705;
	    aux_3705 =
	       (object_bglt) (obj_289);
	    aux_3704 =
	       OBJECT_WIDENING(aux_3705);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3704))->mark);
      }
   }
}



/* _sfun/ginfo-mark */
obj_t 
_sfun_ginfo_mark_104_globalize_ginfo(obj_t env_2663, obj_t obj_2664)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 38 */
      {		/* Globalize/ginfo.scm 38 */
	 long aux_3709;
	 aux_3709 =
	    sfun_ginfo_mark_177_globalize_ginfo(
	    (sfun_ginfo_98_bglt) (obj_2664));
	 return
	    BINT(aux_3709);
      }
   }
}



/* sfun/ginfo-free-mark-set! */
obj_t 
sfun_ginfo_free_mark_set__121_globalize_ginfo(sfun_ginfo_98_bglt obj_290, obj_t val1458_291)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 40 */
      {
	 obj_t aux_3713;
	 {	/* Globalize/ginfo.scm 40 */
	    object_bglt aux_3714;
	    aux_3714 =
	       (object_bglt) (obj_290);
	    aux_3713 =
	       OBJECT_WIDENING(aux_3714);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3713))->free_mark_81) = ((obj_t) val1458_291), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-free-mark-set! */
obj_t 
_sfun_ginfo_free_mark_set__172_globalize_ginfo(obj_t env_2665, obj_t obj_2666, obj_t val1458_2667)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 40 */
      return
	 sfun_ginfo_free_mark_set__121_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2666), val1458_2667);
   }
}



/* sfun/ginfo-free-mark */
obj_t 
sfun_ginfo_free_mark_233_globalize_ginfo(sfun_ginfo_98_bglt obj_292)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 40 */
      {
	 obj_t aux_3720;
	 {	/* Globalize/ginfo.scm 40 */
	    object_bglt aux_3721;
	    aux_3721 =
	       (object_bglt) (obj_292);
	    aux_3720 =
	       OBJECT_WIDENING(aux_3721);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3720))->free_mark_81);
      }
   }
}



/* _sfun/ginfo-free-mark */
obj_t 
_sfun_ginfo_free_mark_138_globalize_ginfo(obj_t env_2668, obj_t obj_2669)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 40 */
      return
	 sfun_ginfo_free_mark_233_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2669));
   }
}



/* sfun/ginfo-the-global-set! */
obj_t 
sfun_ginfo_the_global_set__129_globalize_ginfo(sfun_ginfo_98_bglt obj_293, obj_t val1459_294)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 42 */
      {
	 obj_t aux_3727;
	 {	/* Globalize/ginfo.scm 42 */
	    object_bglt aux_3728;
	    aux_3728 =
	       (object_bglt) (obj_293);
	    aux_3727 =
	       OBJECT_WIDENING(aux_3728);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3727))->the_global_201) = ((obj_t) val1459_294), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-the-global-set! */
obj_t 
_sfun_ginfo_the_global_set__148_globalize_ginfo(obj_t env_2670, obj_t obj_2671, obj_t val1459_2672)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 42 */
      return
	 sfun_ginfo_the_global_set__129_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2671), val1459_2672);
   }
}



/* sfun/ginfo-the-global */
obj_t 
sfun_ginfo_the_global_234_globalize_ginfo(sfun_ginfo_98_bglt obj_295)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 42 */
      {
	 obj_t aux_3734;
	 {	/* Globalize/ginfo.scm 42 */
	    object_bglt aux_3735;
	    aux_3735 =
	       (object_bglt) (obj_295);
	    aux_3734 =
	       OBJECT_WIDENING(aux_3735);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3734))->the_global_201);
      }
   }
}



/* _sfun/ginfo-the-global */
obj_t 
_sfun_ginfo_the_global_149_globalize_ginfo(obj_t env_2673, obj_t obj_2674)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 42 */
      return
	 sfun_ginfo_the_global_234_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2674));
   }
}



/* sfun/ginfo-kaptured-set! */
obj_t 
sfun_ginfo_kaptured_set__247_globalize_ginfo(sfun_ginfo_98_bglt obj_296, obj_t val1460_297)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 44 */
      {
	 obj_t aux_3741;
	 {	/* Globalize/ginfo.scm 44 */
	    object_bglt aux_3742;
	    aux_3742 =
	       (object_bglt) (obj_296);
	    aux_3741 =
	       OBJECT_WIDENING(aux_3742);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3741))->kaptured) = ((obj_t) val1460_297), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-kaptured-set! */
obj_t 
_sfun_ginfo_kaptured_set__83_globalize_ginfo(obj_t env_2675, obj_t obj_2676, obj_t val1460_2677)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 44 */
      return
	 sfun_ginfo_kaptured_set__247_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2676), val1460_2677);
   }
}



/* sfun/ginfo-kaptured */
obj_t 
sfun_ginfo_kaptured_55_globalize_ginfo(sfun_ginfo_98_bglt obj_298)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 44 */
      {
	 obj_t aux_3748;
	 {	/* Globalize/ginfo.scm 44 */
	    object_bglt aux_3749;
	    aux_3749 =
	       (object_bglt) (obj_298);
	    aux_3748 =
	       OBJECT_WIDENING(aux_3749);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3748))->kaptured);
      }
   }
}



/* _sfun/ginfo-kaptured */
obj_t 
_sfun_ginfo_kaptured_249_globalize_ginfo(obj_t env_2678, obj_t obj_2679)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 44 */
      return
	 sfun_ginfo_kaptured_55_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2679));
   }
}



/* sfun/ginfo-new-body-set! */
obj_t 
sfun_ginfo_new_body_set__157_globalize_ginfo(sfun_ginfo_98_bglt obj_299, obj_t val1461_300)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 46 */
      {
	 obj_t aux_3755;
	 {	/* Globalize/ginfo.scm 46 */
	    object_bglt aux_3756;
	    aux_3756 =
	       (object_bglt) (obj_299);
	    aux_3755 =
	       OBJECT_WIDENING(aux_3756);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3755))->new_body_215) = ((obj_t) val1461_300), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-new-body-set! */
obj_t 
_sfun_ginfo_new_body_set__130_globalize_ginfo(obj_t env_2680, obj_t obj_2681, obj_t val1461_2682)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 46 */
      return
	 sfun_ginfo_new_body_set__157_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2681), val1461_2682);
   }
}



/* sfun/ginfo-new-body */
obj_t 
sfun_ginfo_new_body_94_globalize_ginfo(sfun_ginfo_98_bglt obj_301)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 46 */
      {
	 obj_t aux_3762;
	 {	/* Globalize/ginfo.scm 46 */
	    object_bglt aux_3763;
	    aux_3763 =
	       (object_bglt) (obj_301);
	    aux_3762 =
	       OBJECT_WIDENING(aux_3763);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3762))->new_body_215);
      }
   }
}



/* _sfun/ginfo-new-body */
obj_t 
_sfun_ginfo_new_body_82_globalize_ginfo(obj_t env_2683, obj_t obj_2684)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 46 */
      return
	 sfun_ginfo_new_body_94_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2684));
   }
}



/* sfun/ginfo-bmark-set! */
obj_t 
sfun_ginfo_bmark_set__251_globalize_ginfo(sfun_ginfo_98_bglt obj_302, long val1462_303)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 48 */
      {
	 obj_t aux_3769;
	 {	/* Globalize/ginfo.scm 48 */
	    object_bglt aux_3770;
	    aux_3770 =
	       (object_bglt) (obj_302);
	    aux_3769 =
	       OBJECT_WIDENING(aux_3770);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3769))->bmark) = ((long) val1462_303), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-bmark-set! */
obj_t 
_sfun_ginfo_bmark_set__233_globalize_ginfo(obj_t env_2685, obj_t obj_2686, obj_t val1462_2687)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 48 */
      return
	 sfun_ginfo_bmark_set__251_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2686),
	 (long) CINT(val1462_2687));
   }
}



/* sfun/ginfo-bmark */
long 
sfun_ginfo_bmark_99_globalize_ginfo(sfun_ginfo_98_bglt obj_304)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 48 */
      {
	 obj_t aux_3777;
	 {	/* Globalize/ginfo.scm 48 */
	    object_bglt aux_3778;
	    aux_3778 =
	       (object_bglt) (obj_304);
	    aux_3777 =
	       OBJECT_WIDENING(aux_3778);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3777))->bmark);
      }
   }
}



/* _sfun/ginfo-bmark */
obj_t 
_sfun_ginfo_bmark_119_globalize_ginfo(obj_t env_2688, obj_t obj_2689)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 48 */
      {		/* Globalize/ginfo.scm 48 */
	 long aux_3782;
	 aux_3782 =
	    sfun_ginfo_bmark_99_globalize_ginfo(
	    (sfun_ginfo_98_bglt) (obj_2689));
	 return
	    BINT(aux_3782);
      }
   }
}



/* sfun/ginfo-umark-set! */
obj_t 
sfun_ginfo_umark_set__215_globalize_ginfo(sfun_ginfo_98_bglt obj_305, long val1463_306)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 50 */
      {
	 obj_t aux_3786;
	 {	/* Globalize/ginfo.scm 50 */
	    object_bglt aux_3787;
	    aux_3787 =
	       (object_bglt) (obj_305);
	    aux_3786 =
	       OBJECT_WIDENING(aux_3787);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3786))->umark) = ((long) val1463_306), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-umark-set! */
obj_t 
_sfun_ginfo_umark_set__110_globalize_ginfo(obj_t env_2690, obj_t obj_2691, obj_t val1463_2692)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 50 */
      return
	 sfun_ginfo_umark_set__215_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2691),
	 (long) CINT(val1463_2692));
   }
}



/* sfun/ginfo-umark */
long 
sfun_ginfo_umark_66_globalize_ginfo(sfun_ginfo_98_bglt obj_307)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 50 */
      {
	 obj_t aux_3794;
	 {	/* Globalize/ginfo.scm 50 */
	    object_bglt aux_3795;
	    aux_3795 =
	       (object_bglt) (obj_307);
	    aux_3794 =
	       OBJECT_WIDENING(aux_3795);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3794))->umark);
      }
   }
}



/* _sfun/ginfo-umark */
obj_t 
_sfun_ginfo_umark_199_globalize_ginfo(obj_t env_2693, obj_t obj_2694)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 50 */
      {		/* Globalize/ginfo.scm 50 */
	 long aux_3799;
	 aux_3799 =
	    sfun_ginfo_umark_66_globalize_ginfo(
	    (sfun_ginfo_98_bglt) (obj_2694));
	 return
	    BINT(aux_3799);
      }
   }
}



/* sfun/ginfo-free-set! */
obj_t 
sfun_ginfo_free_set__132_globalize_ginfo(sfun_ginfo_98_bglt obj_308, obj_t val1464_309)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 52 */
      {
	 obj_t aux_3803;
	 {	/* Globalize/ginfo.scm 52 */
	    object_bglt aux_3804;
	    aux_3804 =
	       (object_bglt) (obj_308);
	    aux_3803 =
	       OBJECT_WIDENING(aux_3804);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3803))->free) = ((obj_t) val1464_309), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-free-set! */
obj_t 
_sfun_ginfo_free_set__78_globalize_ginfo(obj_t env_2695, obj_t obj_2696, obj_t val1464_2697)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 52 */
      return
	 sfun_ginfo_free_set__132_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2696), val1464_2697);
   }
}



/* sfun/ginfo-free */
obj_t 
sfun_ginfo_free_174_globalize_ginfo(sfun_ginfo_98_bglt obj_310)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 52 */
      {
	 obj_t aux_3810;
	 {	/* Globalize/ginfo.scm 52 */
	    object_bglt aux_3811;
	    aux_3811 =
	       (object_bglt) (obj_310);
	    aux_3810 =
	       OBJECT_WIDENING(aux_3811);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3810))->free);
      }
   }
}



/* _sfun/ginfo-free */
obj_t 
_sfun_ginfo_free_179_globalize_ginfo(obj_t env_2698, obj_t obj_2699)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 52 */
      return
	 sfun_ginfo_free_174_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2699));
   }
}



/* sfun/ginfo-bound-set! */
obj_t 
sfun_ginfo_bound_set__10_globalize_ginfo(sfun_ginfo_98_bglt obj_311, obj_t val1465_312)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 54 */
      {
	 obj_t aux_3817;
	 {	/* Globalize/ginfo.scm 54 */
	    object_bglt aux_3818;
	    aux_3818 =
	       (object_bglt) (obj_311);
	    aux_3817 =
	       OBJECT_WIDENING(aux_3818);
	 }
	 return
	    ((((sfun_ginfo_98_bglt) CREF(aux_3817))->bound) = ((obj_t) val1465_312), BUNSPEC);
      }
   }
}



/* _sfun/ginfo-bound-set! */
obj_t 
_sfun_ginfo_bound_set__169_globalize_ginfo(obj_t env_2700, obj_t obj_2701, obj_t val1465_2702)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 54 */
      return
	 sfun_ginfo_bound_set__10_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2701), val1465_2702);
   }
}



/* sfun/ginfo-bound */
obj_t 
sfun_ginfo_bound_35_globalize_ginfo(sfun_ginfo_98_bglt obj_313)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 54 */
      {
	 obj_t aux_3824;
	 {	/* Globalize/ginfo.scm 54 */
	    object_bglt aux_3825;
	    aux_3825 =
	       (object_bglt) (obj_313);
	    aux_3824 =
	       OBJECT_WIDENING(aux_3825);
	 }
	 return
	    (((sfun_ginfo_98_bglt) CREF(aux_3824))->bound);
      }
   }
}



/* _sfun/ginfo-bound */
obj_t 
_sfun_ginfo_bound_51_globalize_ginfo(obj_t env_2703, obj_t obj_2704)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 54 */
      return
	 sfun_ginfo_bound_35_globalize_ginfo(
	 (sfun_ginfo_98_bglt) (obj_2704));
   }
}



/* method-init */
obj_t 
method_init_76_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 14 */
      {		/* Globalize/ginfo.scm 14 */
	 obj_t object__struct_global_ginfo1591_167_2719;
	 object__struct_global_ginfo1591_167_2719 = proc1862_globalize_ginfo;
	 add_method__1___object(object__struct_env_210___object, global_ginfo_75_globalize_ginfo, object__struct_global_ginfo1591_167_2719);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t struct_object__object_global_ginfo1593_126_2718;
	 struct_object__object_global_ginfo1593_126_2718 = proc1863_globalize_ginfo;
	 add_method__1___object(struct_object__object_env_209___object, global_ginfo_75_globalize_ginfo, struct_object__object_global_ginfo1593_126_2718);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t object__struct_local_ginfo1595_65_2717;
	 object__struct_local_ginfo1595_65_2717 = proc1864_globalize_ginfo;
	 add_method__1___object(object__struct_env_210___object, local_ginfo_108_globalize_ginfo, object__struct_local_ginfo1595_65_2717);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t struct_object__object_local_ginfo1597_81_2716;
	 struct_object__object_local_ginfo1597_81_2716 = proc1865_globalize_ginfo;
	 add_method__1___object(struct_object__object_env_209___object, local_ginfo_108_globalize_ginfo, struct_object__object_local_ginfo1597_81_2716);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t object__struct_sexit_ginfo1599_209_2715;
	 object__struct_sexit_ginfo1599_209_2715 = proc1866_globalize_ginfo;
	 add_method__1___object(object__struct_env_210___object, sexit_ginfo_81_globalize_ginfo, object__struct_sexit_ginfo1599_209_2715);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t struct_object__object_sexit_ginfo1601_72_2714;
	 struct_object__object_sexit_ginfo1601_72_2714 = proc1867_globalize_ginfo;
	 add_method__1___object(struct_object__object_env_209___object, sexit_ginfo_81_globalize_ginfo, struct_object__object_sexit_ginfo1601_72_2714);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t object__struct_svar_ginfo1603_25_2713;
	 object__struct_svar_ginfo1603_25_2713 = proc1868_globalize_ginfo;
	 add_method__1___object(object__struct_env_210___object, svar_ginfo_131_globalize_ginfo, object__struct_svar_ginfo1603_25_2713);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t struct_object__object_svar_ginfo1605_206_2712;
	 struct_object__object_svar_ginfo1605_206_2712 = proc1869_globalize_ginfo;
	 add_method__1___object(struct_object__object_env_209___object, svar_ginfo_131_globalize_ginfo, struct_object__object_svar_ginfo1605_206_2712);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t object__struct_sfun_ginfo1607_35_2709;
	 object__struct_sfun_ginfo1607_35_2709 = proc1870_globalize_ginfo;
	 add_method__1___object(object__struct_env_210___object, sfun_ginfo_98_globalize_ginfo, object__struct_sfun_ginfo1607_35_2709);
      }
      {		/* Globalize/ginfo.scm 14 */
	 obj_t struct_object__object_sfun_ginfo1609_15_2705;
	 struct_object__object_sfun_ginfo1609_15_2705 = proc1871_globalize_ginfo;
	 return
	    add_method__1___object(struct_object__object_env_209___object, sfun_ginfo_98_globalize_ginfo, struct_object__object_sfun_ginfo1609_15_2705);
      }
   }
}



/* struct+object->object-sfun/ginfo1609 */
obj_t 
struct_object__object_sfun_ginfo1609_15_globalize_ginfo(obj_t env_2720, obj_t o_2721, obj_t s_2722)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {
	 sfun_ginfo_98_bglt o_1582;
	 obj_t s_1583;
	 {	/* Globalize/ginfo.scm 18 */
	    sfun_ginfo_98_bglt aux_3841;
	    o_1582 =
	       (sfun_ginfo_98_bglt) (o_2721);
	    s_1583 = s_2722;
	    {

	       {	/* Globalize/ginfo.scm 18 */
		  obj_t old1493_1586;
		  obj_t aux1494_1587;
		  {	/* Globalize/ginfo.scm 18 */
		     obj_t next_method1608_16_1609;
		     next_method1608_16_1609 =
			find_super_class_method_167___object(
			(object_bglt) (o_1582), struct_object__object_env_209___object, sfun_ginfo_98_globalize_ginfo);
		     if (
			PROCEDUREP(next_method1608_16_1609))
		       {	/* Globalize/ginfo.scm 18 */
			  old1493_1586 =
			     PROCEDURE_ENTRY(next_method1608_16_1609) (next_method1608_16_1609,
			     (obj_t) (o_1582), s_1583, BEOA);
		       }
		     else
		       {	/* Globalize/ginfo.scm 18 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1608_16_1609);
			  {	/* Globalize/ginfo.scm 18 */
			     object_bglt aux_3850;
			     aux_3850 =
				struct_object__object_93___object(
				(object_bglt) (o_1582), s_1583);
			     old1493_1586 =
				(obj_t) (aux_3850);
			  }
		       }
		  }
		  aux1494_1587 =
		     STRUCT_REF(s_1583, ((long) 0));
		  {	/* Globalize/ginfo.scm 18 */
		     sfun_ginfo_98_bglt new1495_1588;
		     new1495_1588 =
			((sfun_ginfo_98_bglt) (old1493_1586));
		     {	/* Globalize/ginfo.scm 18 */
			long arg1817_1589;
			arg1817_1589 =
			   class_num_218___object(sfun_ginfo_98_globalize_ginfo);
			{	/* Globalize/ginfo.scm 18 */
			   obj_t obj_2177;
			   obj_2177 =
			      (obj_t) (new1495_1588);
			   (((obj_t) CREF(obj_2177))->header = MAKE_HEADER(arg1817_1589, 0), BUNSPEC);
			}
		     }
		     {	/* Globalize/ginfo.scm 18 */
			sfun_ginfo_98_bglt arg1818_1590;
			{	/* Globalize/ginfo.scm 18 */
			   obj_t arg1821_1592;
			   obj_t arg1822_1593;
			   obj_t arg1823_1594;
			   obj_t arg1824_1595;
			   obj_t arg1825_1596;
			   obj_t arg1826_1597;
			   obj_t arg1827_1598;
			   obj_t arg1828_1599;
			   obj_t arg1831_1601;
			   obj_t arg1832_1602;
			   obj_t arg1833_1603;
			   obj_t arg1834_1604;
			   obj_t arg1838_1607;
			   obj_t arg1839_1608;
			   arg1821_1592 =
			      STRUCT_REF(aux1494_1587, ((long) 1));
			   arg1822_1593 =
			      STRUCT_REF(aux1494_1587, ((long) 2));
			   arg1823_1594 =
			      STRUCT_REF(aux1494_1587, ((long) 3));
			   arg1824_1595 =
			      STRUCT_REF(aux1494_1587, ((long) 4));
			   arg1825_1596 =
			      STRUCT_REF(aux1494_1587, ((long) 5));
			   arg1826_1597 =
			      STRUCT_REF(aux1494_1587, ((long) 6));
			   arg1827_1598 =
			      STRUCT_REF(aux1494_1587, ((long) 7));
			   arg1828_1599 =
			      STRUCT_REF(aux1494_1587, ((long) 8));
			   arg1831_1601 =
			      STRUCT_REF(aux1494_1587, ((long) 10));
			   arg1832_1602 =
			      STRUCT_REF(aux1494_1587, ((long) 11));
			   arg1833_1603 =
			      STRUCT_REF(aux1494_1587, ((long) 12));
			   arg1834_1604 =
			      STRUCT_REF(aux1494_1587, ((long) 13));
			   arg1838_1607 =
			      STRUCT_REF(aux1494_1587, ((long) 16));
			   arg1839_1608 =
			      STRUCT_REF(aux1494_1587, ((long) 17));
			   {	/* Globalize/ginfo.scm 18 */
			      sfun_ginfo_98_bglt res1855_2252;
			      {		/* Globalize/ginfo.scm 18 */
				 bool_t g__219_2215;
				 long mark_2224;
				 long bmark_2229;
				 long umark_2230;
				 {	/* Globalize/ginfo.scm 18 */
				    obj_t aux_3873;
				    aux_3873 =
				       STRUCT_REF(aux1494_1587, ((long) 0));
				    g__219_2215 =
				       CBOOL(aux_3873);
				 }
				 {	/* Globalize/ginfo.scm 18 */
				    obj_t aux_3876;
				    aux_3876 =
				       STRUCT_REF(aux1494_1587, ((long) 9));
				    mark_2224 =
				       (long) CINT(aux_3876);
				 }
				 {	/* Globalize/ginfo.scm 18 */
				    obj_t aux_3879;
				    aux_3879 =
				       STRUCT_REF(aux1494_1587, ((long) 14));
				    bmark_2229 =
				       (long) CINT(aux_3879);
				 }
				 {	/* Globalize/ginfo.scm 18 */
				    obj_t aux_3882;
				    aux_3882 =
				       STRUCT_REF(aux1494_1587, ((long) 15));
				    umark_2230 =
				       (long) CINT(aux_3882);
				 }
				 {	/* Globalize/ginfo.scm 18 */
				    sfun_ginfo_98_bglt new1466_2233;
				    new1466_2233 =
				       ((sfun_ginfo_98_bglt) BREF(GC_MALLOC(sizeof(struct sfun_ginfo_98))));
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->g__219) = ((bool_t) g__219_2215), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->cfrom) = ((obj_t) arg1821_1592), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->cfrom__119) = ((obj_t) arg1822_1593), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->cto) = ((obj_t) arg1823_1594), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->cto__14) = ((obj_t) arg1824_1595), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->cfunction) = ((obj_t) arg1825_1596), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->integrator) = ((obj_t) arg1826_1597), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->integrated) = ((obj_t) arg1827_1598), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->plugged_in_15) = ((obj_t) arg1828_1599), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->mark) = ((long) mark_2224), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->free_mark_81) = ((obj_t) arg1831_1601), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->the_global_201) = ((obj_t) arg1832_1602), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->kaptured) = ((obj_t) arg1833_1603), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->new_body_215) = ((obj_t) arg1834_1604), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->bmark) = ((long) bmark_2229), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->umark) = ((long) umark_2230), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->free) = ((obj_t) arg1838_1607), BUNSPEC);
				    ((((sfun_ginfo_98_bglt) CREF(new1466_2233))->bound) = ((obj_t) arg1839_1608), BUNSPEC);
				    res1855_2252 = new1466_2233;
				 }
			      }
			      arg1818_1590 = res1855_2252;
			   }
			}
			{	/* Globalize/ginfo.scm 18 */
			   obj_t aux_3906;
			   object_bglt aux_3904;
			   aux_3906 =
			      (obj_t) (arg1818_1590);
			   aux_3904 =
			      (object_bglt) (new1495_1588);
			   OBJECT_WIDENING_SET(aux_3904, aux_3906);
			}
		     }
		     aux_3841 = new1495_1588;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3841);
	 }
      }
   }
}



/* object->struct-sfun/ginfo1607 */
obj_t 
object__struct_sfun_ginfo1607_35_globalize_ginfo(obj_t env_2723, obj_t obj1490_2724)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 18 */
      {
	 sfun_ginfo_98_bglt obj1490_1538;
	 obj1490_1538 =
	    (sfun_ginfo_98_bglt) (obj1490_2724);
	 {

	    {	/* Globalize/ginfo.scm 18 */
	       obj_t res1491_1541;
	       {	/* Globalize/ginfo.scm 18 */
		  obj_t next_method1606_175_1580;
		  next_method1606_175_1580 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1490_1538), object__struct_env_210___object, sfun_ginfo_98_globalize_ginfo);
		  if (
		     PROCEDUREP(next_method1606_175_1580))
		    {	/* Globalize/ginfo.scm 18 */
		       res1491_1541 =
			  PROCEDURE_ENTRY(next_method1606_175_1580) (next_method1606_175_1580,
			  (obj_t) (obj1490_1538), BEOA);
		    }
		  else
		    {	/* Globalize/ginfo.scm 18 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1606_175_1580);
		       res1491_1541 =
			  object__struct_50___object(
			  (object_bglt) (obj1490_1538));
		    }
	       }
	       {	/* Globalize/ginfo.scm 18 */
		  obj_t aux1492_1542;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3921;
		     aux_3921 =
			CNST_TABLE_REF(((long) 0));
		     aux1492_1542 =
			make_struct(aux_3921, ((long) 18), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3924;
		     {	/* Globalize/ginfo.scm 18 */
			bool_t aux_3925;
			{
			   obj_t aux_3926;
			   {	/* Globalize/ginfo.scm 20 */
			      object_bglt aux_3927;
			      aux_3927 =
				 (object_bglt) (obj1490_1538);
			      aux_3926 =
				 OBJECT_WIDENING(aux_3927);
			   }
			   aux_3925 =
			      (((sfun_ginfo_98_bglt) CREF(aux_3926))->g__219);
			}
			aux_3924 =
			   BBOOL(aux_3925);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 0), aux_3924);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3933;
		     {
			obj_t aux_3934;
			{	/* Globalize/ginfo.scm 22 */
			   object_bglt aux_3935;
			   aux_3935 =
			      (object_bglt) (obj1490_1538);
			   aux_3934 =
			      OBJECT_WIDENING(aux_3935);
			}
			aux_3933 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3934))->cfrom);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 1), aux_3933);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3940;
		     {
			obj_t aux_3941;
			{	/* Globalize/ginfo.scm 24 */
			   object_bglt aux_3942;
			   aux_3942 =
			      (object_bglt) (obj1490_1538);
			   aux_3941 =
			      OBJECT_WIDENING(aux_3942);
			}
			aux_3940 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3941))->cfrom__119);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 2), aux_3940);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3947;
		     {
			obj_t aux_3948;
			{	/* Globalize/ginfo.scm 26 */
			   object_bglt aux_3949;
			   aux_3949 =
			      (object_bglt) (obj1490_1538);
			   aux_3948 =
			      OBJECT_WIDENING(aux_3949);
			}
			aux_3947 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3948))->cto);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 3), aux_3947);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3954;
		     {
			obj_t aux_3955;
			{	/* Globalize/ginfo.scm 28 */
			   object_bglt aux_3956;
			   aux_3956 =
			      (object_bglt) (obj1490_1538);
			   aux_3955 =
			      OBJECT_WIDENING(aux_3956);
			}
			aux_3954 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3955))->cto__14);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 4), aux_3954);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3961;
		     {
			obj_t aux_3962;
			{	/* Globalize/ginfo.scm 30 */
			   object_bglt aux_3963;
			   aux_3963 =
			      (object_bglt) (obj1490_1538);
			   aux_3962 =
			      OBJECT_WIDENING(aux_3963);
			}
			aux_3961 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3962))->cfunction);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 5), aux_3961);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3968;
		     {
			obj_t aux_3969;
			{	/* Globalize/ginfo.scm 32 */
			   object_bglt aux_3970;
			   aux_3970 =
			      (object_bglt) (obj1490_1538);
			   aux_3969 =
			      OBJECT_WIDENING(aux_3970);
			}
			aux_3968 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3969))->integrator);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 6), aux_3968);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3975;
		     {
			obj_t aux_3976;
			{	/* Globalize/ginfo.scm 34 */
			   object_bglt aux_3977;
			   aux_3977 =
			      (object_bglt) (obj1490_1538);
			   aux_3976 =
			      OBJECT_WIDENING(aux_3977);
			}
			aux_3975 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3976))->integrated);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 7), aux_3975);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3982;
		     {
			obj_t aux_3983;
			{	/* Globalize/ginfo.scm 36 */
			   object_bglt aux_3984;
			   aux_3984 =
			      (object_bglt) (obj1490_1538);
			   aux_3983 =
			      OBJECT_WIDENING(aux_3984);
			}
			aux_3982 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3983))->plugged_in_15);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 8), aux_3982);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3989;
		     {	/* Globalize/ginfo.scm 18 */
			long aux_3990;
			{
			   obj_t aux_3991;
			   {	/* Globalize/ginfo.scm 38 */
			      object_bglt aux_3992;
			      aux_3992 =
				 (object_bglt) (obj1490_1538);
			      aux_3991 =
				 OBJECT_WIDENING(aux_3992);
			   }
			   aux_3990 =
			      (((sfun_ginfo_98_bglt) CREF(aux_3991))->mark);
			}
			aux_3989 =
			   BINT(aux_3990);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 9), aux_3989);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3998;
		     {
			obj_t aux_3999;
			{	/* Globalize/ginfo.scm 40 */
			   object_bglt aux_4000;
			   aux_4000 =
			      (object_bglt) (obj1490_1538);
			   aux_3999 =
			      OBJECT_WIDENING(aux_4000);
			}
			aux_3998 =
			   (((sfun_ginfo_98_bglt) CREF(aux_3999))->free_mark_81);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 10), aux_3998);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4005;
		     {
			obj_t aux_4006;
			{	/* Globalize/ginfo.scm 42 */
			   object_bglt aux_4007;
			   aux_4007 =
			      (object_bglt) (obj1490_1538);
			   aux_4006 =
			      OBJECT_WIDENING(aux_4007);
			}
			aux_4005 =
			   (((sfun_ginfo_98_bglt) CREF(aux_4006))->the_global_201);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 11), aux_4005);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4012;
		     {
			obj_t aux_4013;
			{	/* Globalize/ginfo.scm 44 */
			   object_bglt aux_4014;
			   aux_4014 =
			      (object_bglt) (obj1490_1538);
			   aux_4013 =
			      OBJECT_WIDENING(aux_4014);
			}
			aux_4012 =
			   (((sfun_ginfo_98_bglt) CREF(aux_4013))->kaptured);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 12), aux_4012);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4019;
		     {
			obj_t aux_4020;
			{	/* Globalize/ginfo.scm 46 */
			   object_bglt aux_4021;
			   aux_4021 =
			      (object_bglt) (obj1490_1538);
			   aux_4020 =
			      OBJECT_WIDENING(aux_4021);
			}
			aux_4019 =
			   (((sfun_ginfo_98_bglt) CREF(aux_4020))->new_body_215);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 13), aux_4019);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4026;
		     {	/* Globalize/ginfo.scm 18 */
			long aux_4027;
			{
			   obj_t aux_4028;
			   {	/* Globalize/ginfo.scm 48 */
			      object_bglt aux_4029;
			      aux_4029 =
				 (object_bglt) (obj1490_1538);
			      aux_4028 =
				 OBJECT_WIDENING(aux_4029);
			   }
			   aux_4027 =
			      (((sfun_ginfo_98_bglt) CREF(aux_4028))->bmark);
			}
			aux_4026 =
			   BINT(aux_4027);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 14), aux_4026);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4035;
		     {	/* Globalize/ginfo.scm 18 */
			long aux_4036;
			{
			   obj_t aux_4037;
			   {	/* Globalize/ginfo.scm 50 */
			      object_bglt aux_4038;
			      aux_4038 =
				 (object_bglt) (obj1490_1538);
			      aux_4037 =
				 OBJECT_WIDENING(aux_4038);
			   }
			   aux_4036 =
			      (((sfun_ginfo_98_bglt) CREF(aux_4037))->umark);
			}
			aux_4035 =
			   BINT(aux_4036);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 15), aux_4035);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4044;
		     {
			obj_t aux_4045;
			{	/* Globalize/ginfo.scm 52 */
			   object_bglt aux_4046;
			   aux_4046 =
			      (object_bglt) (obj1490_1538);
			   aux_4045 =
			      OBJECT_WIDENING(aux_4046);
			}
			aux_4044 =
			   (((sfun_ginfo_98_bglt) CREF(aux_4045))->free);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 16), aux_4044);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4051;
		     {
			obj_t aux_4052;
			{	/* Globalize/ginfo.scm 54 */
			   object_bglt aux_4053;
			   aux_4053 =
			      (object_bglt) (obj1490_1538);
			   aux_4052 =
			      OBJECT_WIDENING(aux_4053);
			}
			aux_4051 =
			   (((sfun_ginfo_98_bglt) CREF(aux_4052))->bound);
		     }
		     STRUCT_SET(aux1492_1542, ((long) 17), aux_4051);
		  }
		  STRUCT_SET(res1491_1541, ((long) 0), aux1492_1542);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4059;
		     aux_4059 =
			STRUCT_KEY(res1491_1541);
		     STRUCT_KEY_SET(aux1492_1542, aux_4059);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4062;
		     aux_4062 =
			CNST_TABLE_REF(((long) 0));
		     STRUCT_KEY_SET(res1491_1541, aux_4062);
		  }
		  return res1491_1541;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-svar/ginfo1605 */
obj_t 
struct_object__object_svar_ginfo1605_206_globalize_ginfo(obj_t env_2725, obj_t o_2726, obj_t s_2727)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {
	 svar_ginfo_131_bglt o_1523;
	 obj_t s_1524;
	 {	/* Globalize/ginfo.scm 56 */
	    svar_ginfo_131_bglt aux_4066;
	    o_1523 =
	       (svar_ginfo_131_bglt) (o_2726);
	    s_1524 = s_2727;
	    {

	       {	/* Globalize/ginfo.scm 56 */
		  obj_t old1513_1527;
		  obj_t aux1514_1528;
		  {	/* Globalize/ginfo.scm 56 */
		     obj_t next_method1604_100_1536;
		     next_method1604_100_1536 =
			find_super_class_method_167___object(
			(object_bglt) (o_1523), struct_object__object_env_209___object, svar_ginfo_131_globalize_ginfo);
		     if (
			PROCEDUREP(next_method1604_100_1536))
		       {	/* Globalize/ginfo.scm 56 */
			  old1513_1527 =
			     PROCEDURE_ENTRY(next_method1604_100_1536) (next_method1604_100_1536,
			     (obj_t) (o_1523), s_1524, BEOA);
		       }
		     else
		       {	/* Globalize/ginfo.scm 56 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1604_100_1536);
			  {	/* Globalize/ginfo.scm 56 */
			     object_bglt aux_4075;
			     aux_4075 =
				struct_object__object_93___object(
				(object_bglt) (o_1523), s_1524);
			     old1513_1527 =
				(obj_t) (aux_4075);
			  }
		       }
		  }
		  aux1514_1528 =
		     STRUCT_REF(s_1524, ((long) 0));
		  {	/* Globalize/ginfo.scm 56 */
		     svar_ginfo_131_bglt new1515_1529;
		     new1515_1529 =
			((svar_ginfo_131_bglt) (old1513_1527));
		     {	/* Globalize/ginfo.scm 56 */
			long arg1770_1530;
			arg1770_1530 =
			   class_num_218___object(svar_ginfo_131_globalize_ginfo);
			{	/* Globalize/ginfo.scm 56 */
			   obj_t obj_2068;
			   obj_2068 =
			      (obj_t) (new1515_1529);
			   (((obj_t) CREF(obj_2068))->header = MAKE_HEADER(arg1770_1530, 0), BUNSPEC);
			}
		     }
		     {	/* Globalize/ginfo.scm 56 */
			svar_ginfo_131_bglt arg1771_1531;
			{	/* Globalize/ginfo.scm 56 */
			   svar_ginfo_131_bglt res1854_2087;
			   {	/* Globalize/ginfo.scm 56 */
			      bool_t kaptured__204_2078;
			      long free_mark_81_2079;
			      long mark_2080;
			      bool_t celled__113_2081;
			      {		/* Globalize/ginfo.scm 56 */
				 obj_t aux_4084;
				 aux_4084 =
				    STRUCT_REF(aux1514_1528, ((long) 0));
				 kaptured__204_2078 =
				    CBOOL(aux_4084);
			      }
			      {		/* Globalize/ginfo.scm 56 */
				 obj_t aux_4087;
				 aux_4087 =
				    STRUCT_REF(aux1514_1528, ((long) 1));
				 free_mark_81_2079 =
				    (long) CINT(aux_4087);
			      }
			      {		/* Globalize/ginfo.scm 56 */
				 obj_t aux_4090;
				 aux_4090 =
				    STRUCT_REF(aux1514_1528, ((long) 2));
				 mark_2080 =
				    (long) CINT(aux_4090);
			      }
			      {		/* Globalize/ginfo.scm 56 */
				 obj_t aux_4093;
				 aux_4093 =
				    STRUCT_REF(aux1514_1528, ((long) 3));
				 celled__113_2081 =
				    CBOOL(aux_4093);
			      }
			      {		/* Globalize/ginfo.scm 56 */
				 svar_ginfo_131_bglt new1501_2082;
				 new1501_2082 =
				    ((svar_ginfo_131_bglt) BREF(GC_MALLOC(sizeof(struct svar_ginfo_131))));
				 ((((svar_ginfo_131_bglt) CREF(new1501_2082))->kaptured__204) = ((bool_t) kaptured__204_2078), BUNSPEC);
				 ((((svar_ginfo_131_bglt) CREF(new1501_2082))->free_mark_81) = ((long) free_mark_81_2079), BUNSPEC);
				 ((((svar_ginfo_131_bglt) CREF(new1501_2082))->mark) = ((long) mark_2080), BUNSPEC);
				 ((((svar_ginfo_131_bglt) CREF(new1501_2082))->celled__113) = ((bool_t) celled__113_2081), BUNSPEC);
				 res1854_2087 = new1501_2082;
			      }
			   }
			   arg1771_1531 = res1854_2087;
			}
			{	/* Globalize/ginfo.scm 56 */
			   obj_t aux_4103;
			   object_bglt aux_4101;
			   aux_4103 =
			      (obj_t) (arg1771_1531);
			   aux_4101 =
			      (object_bglt) (new1515_1529);
			   OBJECT_WIDENING_SET(aux_4101, aux_4103);
			}
		     }
		     aux_4066 = new1515_1529;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_4066);
	 }
      }
   }
}



/* object->struct-svar/ginfo1603 */
obj_t 
object__struct_svar_ginfo1603_25_globalize_ginfo(obj_t env_2728, obj_t obj1510_2729)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 56 */
      {
	 svar_ginfo_131_bglt obj1510_1507;
	 obj1510_1507 =
	    (svar_ginfo_131_bglt) (obj1510_2729);
	 {

	    {	/* Globalize/ginfo.scm 56 */
	       obj_t res1511_1510;
	       {	/* Globalize/ginfo.scm 56 */
		  obj_t next_method1602_166_1521;
		  next_method1602_166_1521 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1510_1507), object__struct_env_210___object, svar_ginfo_131_globalize_ginfo);
		  if (
		     PROCEDUREP(next_method1602_166_1521))
		    {	/* Globalize/ginfo.scm 56 */
		       res1511_1510 =
			  PROCEDURE_ENTRY(next_method1602_166_1521) (next_method1602_166_1521,
			  (obj_t) (obj1510_1507), BEOA);
		    }
		  else
		    {	/* Globalize/ginfo.scm 56 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1602_166_1521);
		       res1511_1510 =
			  object__struct_50___object(
			  (object_bglt) (obj1510_1507));
		    }
	       }
	       {	/* Globalize/ginfo.scm 56 */
		  obj_t aux1512_1511;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_4118;
		     aux_4118 =
			CNST_TABLE_REF(((long) 1));
		     aux1512_1511 =
			make_struct(aux_4118, ((long) 4), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4121;
		     {	/* Globalize/ginfo.scm 56 */
			bool_t aux_4122;
			{
			   obj_t aux_4123;
			   {	/* Globalize/ginfo.scm 58 */
			      object_bglt aux_4124;
			      aux_4124 =
				 (object_bglt) (obj1510_1507);
			      aux_4123 =
				 OBJECT_WIDENING(aux_4124);
			   }
			   aux_4122 =
			      (((svar_ginfo_131_bglt) CREF(aux_4123))->kaptured__204);
			}
			aux_4121 =
			   BBOOL(aux_4122);
		     }
		     STRUCT_SET(aux1512_1511, ((long) 0), aux_4121);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4130;
		     {	/* Globalize/ginfo.scm 56 */
			long aux_4131;
			{
			   obj_t aux_4132;
			   {	/* Globalize/ginfo.scm 60 */
			      object_bglt aux_4133;
			      aux_4133 =
				 (object_bglt) (obj1510_1507);
			      aux_4132 =
				 OBJECT_WIDENING(aux_4133);
			   }
			   aux_4131 =
			      (((svar_ginfo_131_bglt) CREF(aux_4132))->free_mark_81);
			}
			aux_4130 =
			   BINT(aux_4131);
		     }
		     STRUCT_SET(aux1512_1511, ((long) 1), aux_4130);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4139;
		     {	/* Globalize/ginfo.scm 56 */
			long aux_4140;
			{
			   obj_t aux_4141;
			   {	/* Globalize/ginfo.scm 62 */
			      object_bglt aux_4142;
			      aux_4142 =
				 (object_bglt) (obj1510_1507);
			      aux_4141 =
				 OBJECT_WIDENING(aux_4142);
			   }
			   aux_4140 =
			      (((svar_ginfo_131_bglt) CREF(aux_4141))->mark);
			}
			aux_4139 =
			   BINT(aux_4140);
		     }
		     STRUCT_SET(aux1512_1511, ((long) 2), aux_4139);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4148;
		     {	/* Globalize/ginfo.scm 56 */
			bool_t aux_4149;
			{
			   obj_t aux_4150;
			   {	/* Globalize/ginfo.scm 64 */
			      object_bglt aux_4151;
			      aux_4151 =
				 (object_bglt) (obj1510_1507);
			      aux_4150 =
				 OBJECT_WIDENING(aux_4151);
			   }
			   aux_4149 =
			      (((svar_ginfo_131_bglt) CREF(aux_4150))->celled__113);
			}
			aux_4148 =
			   BBOOL(aux_4149);
		     }
		     STRUCT_SET(aux1512_1511, ((long) 3), aux_4148);
		  }
		  STRUCT_SET(res1511_1510, ((long) 0), aux1512_1511);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4158;
		     aux_4158 =
			STRUCT_KEY(res1511_1510);
		     STRUCT_KEY_SET(aux1512_1511, aux_4158);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4161;
		     aux_4161 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1511_1510, aux_4161);
		  }
		  return res1511_1510;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sexit/ginfo1601 */
obj_t 
struct_object__object_sexit_ginfo1601_72_globalize_ginfo(obj_t env_2730, obj_t o_2731, obj_t s_2732)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {
	 sexit_ginfo_81_bglt o_1492;
	 obj_t s_1493;
	 {	/* Globalize/ginfo.scm 66 */
	    sexit_ginfo_81_bglt aux_4165;
	    o_1492 =
	       (sexit_ginfo_81_bglt) (o_2731);
	    s_1493 = s_2732;
	    {

	       {	/* Globalize/ginfo.scm 66 */
		  obj_t old1534_1496;
		  obj_t aux1535_1497;
		  {	/* Globalize/ginfo.scm 66 */
		     obj_t next_method1600_50_1505;
		     next_method1600_50_1505 =
			find_super_class_method_167___object(
			(object_bglt) (o_1492), struct_object__object_env_209___object, sexit_ginfo_81_globalize_ginfo);
		     if (
			PROCEDUREP(next_method1600_50_1505))
		       {	/* Globalize/ginfo.scm 66 */
			  old1534_1496 =
			     PROCEDURE_ENTRY(next_method1600_50_1505) (next_method1600_50_1505,
			     (obj_t) (o_1492), s_1493, BEOA);
		       }
		     else
		       {	/* Globalize/ginfo.scm 66 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1600_50_1505);
			  {	/* Globalize/ginfo.scm 66 */
			     object_bglt aux_4174;
			     aux_4174 =
				struct_object__object_93___object(
				(object_bglt) (o_1492), s_1493);
			     old1534_1496 =
				(obj_t) (aux_4174);
			  }
		       }
		  }
		  aux1535_1497 =
		     STRUCT_REF(s_1493, ((long) 0));
		  {	/* Globalize/ginfo.scm 66 */
		     sexit_ginfo_81_bglt new1536_1498;
		     new1536_1498 =
			((sexit_ginfo_81_bglt) (old1534_1496));
		     {	/* Globalize/ginfo.scm 66 */
			long arg1752_1499;
			arg1752_1499 =
			   class_num_218___object(sexit_ginfo_81_globalize_ginfo);
			{	/* Globalize/ginfo.scm 66 */
			   obj_t obj_2015;
			   obj_2015 =
			      (obj_t) (new1536_1498);
			   (((obj_t) CREF(obj_2015))->header = MAKE_HEADER(arg1752_1499, 0), BUNSPEC);
			}
		     }
		     {	/* Globalize/ginfo.scm 66 */
			sexit_ginfo_81_bglt arg1753_1500;
			{	/* Globalize/ginfo.scm 66 */
			   sexit_ginfo_81_bglt res1853_2034;
			   {	/* Globalize/ginfo.scm 66 */
			      bool_t g__219_2025;
			      bool_t kaptured__204_2026;
			      long free_mark_81_2027;
			      long mark_2028;
			      {		/* Globalize/ginfo.scm 66 */
				 obj_t aux_4183;
				 aux_4183 =
				    STRUCT_REF(aux1535_1497, ((long) 0));
				 g__219_2025 =
				    CBOOL(aux_4183);
			      }
			      {		/* Globalize/ginfo.scm 66 */
				 obj_t aux_4186;
				 aux_4186 =
				    STRUCT_REF(aux1535_1497, ((long) 1));
				 kaptured__204_2026 =
				    CBOOL(aux_4186);
			      }
			      {		/* Globalize/ginfo.scm 66 */
				 obj_t aux_4189;
				 aux_4189 =
				    STRUCT_REF(aux1535_1497, ((long) 2));
				 free_mark_81_2027 =
				    (long) CINT(aux_4189);
			      }
			      {		/* Globalize/ginfo.scm 66 */
				 obj_t aux_4192;
				 aux_4192 =
				    STRUCT_REF(aux1535_1497, ((long) 3));
				 mark_2028 =
				    (long) CINT(aux_4192);
			      }
			      {		/* Globalize/ginfo.scm 66 */
				 sexit_ginfo_81_bglt new1522_2029;
				 new1522_2029 =
				    ((sexit_ginfo_81_bglt) BREF(GC_MALLOC(sizeof(struct sexit_ginfo_81))));
				 ((((sexit_ginfo_81_bglt) CREF(new1522_2029))->g__219) = ((bool_t) g__219_2025), BUNSPEC);
				 ((((sexit_ginfo_81_bglt) CREF(new1522_2029))->kaptured__204) = ((bool_t) kaptured__204_2026), BUNSPEC);
				 ((((sexit_ginfo_81_bglt) CREF(new1522_2029))->free_mark_81) = ((long) free_mark_81_2027), BUNSPEC);
				 ((((sexit_ginfo_81_bglt) CREF(new1522_2029))->mark) = ((long) mark_2028), BUNSPEC);
				 res1853_2034 = new1522_2029;
			      }
			   }
			   arg1753_1500 = res1853_2034;
			}
			{	/* Globalize/ginfo.scm 66 */
			   obj_t aux_4202;
			   object_bglt aux_4200;
			   aux_4202 =
			      (obj_t) (arg1753_1500);
			   aux_4200 =
			      (object_bglt) (new1536_1498);
			   OBJECT_WIDENING_SET(aux_4200, aux_4202);
			}
		     }
		     aux_4165 = new1536_1498;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_4165);
	 }
      }
   }
}



/* object->struct-sexit/ginfo1599 */
obj_t 
object__struct_sexit_ginfo1599_209_globalize_ginfo(obj_t env_2733, obj_t obj1531_2734)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 66 */
      {
	 sexit_ginfo_81_bglt obj1531_1476;
	 obj1531_1476 =
	    (sexit_ginfo_81_bglt) (obj1531_2734);
	 {

	    {	/* Globalize/ginfo.scm 66 */
	       obj_t res1532_1479;
	       {	/* Globalize/ginfo.scm 66 */
		  obj_t next_method1598_10_1490;
		  next_method1598_10_1490 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1531_1476), object__struct_env_210___object, sexit_ginfo_81_globalize_ginfo);
		  if (
		     PROCEDUREP(next_method1598_10_1490))
		    {	/* Globalize/ginfo.scm 66 */
		       res1532_1479 =
			  PROCEDURE_ENTRY(next_method1598_10_1490) (next_method1598_10_1490,
			  (obj_t) (obj1531_1476), BEOA);
		    }
		  else
		    {	/* Globalize/ginfo.scm 66 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1598_10_1490);
		       res1532_1479 =
			  object__struct_50___object(
			  (object_bglt) (obj1531_1476));
		    }
	       }
	       {	/* Globalize/ginfo.scm 66 */
		  obj_t aux1533_1480;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_4217;
		     aux_4217 =
			CNST_TABLE_REF(((long) 2));
		     aux1533_1480 =
			make_struct(aux_4217, ((long) 4), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4220;
		     {	/* Globalize/ginfo.scm 66 */
			bool_t aux_4221;
			{
			   obj_t aux_4222;
			   {	/* Globalize/ginfo.scm 68 */
			      object_bglt aux_4223;
			      aux_4223 =
				 (object_bglt) (obj1531_1476);
			      aux_4222 =
				 OBJECT_WIDENING(aux_4223);
			   }
			   aux_4221 =
			      (((sexit_ginfo_81_bglt) CREF(aux_4222))->g__219);
			}
			aux_4220 =
			   BBOOL(aux_4221);
		     }
		     STRUCT_SET(aux1533_1480, ((long) 0), aux_4220);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4229;
		     {	/* Globalize/ginfo.scm 66 */
			bool_t aux_4230;
			{
			   obj_t aux_4231;
			   {	/* Globalize/ginfo.scm 70 */
			      object_bglt aux_4232;
			      aux_4232 =
				 (object_bglt) (obj1531_1476);
			      aux_4231 =
				 OBJECT_WIDENING(aux_4232);
			   }
			   aux_4230 =
			      (((sexit_ginfo_81_bglt) CREF(aux_4231))->kaptured__204);
			}
			aux_4229 =
			   BBOOL(aux_4230);
		     }
		     STRUCT_SET(aux1533_1480, ((long) 1), aux_4229);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4238;
		     {	/* Globalize/ginfo.scm 66 */
			long aux_4239;
			{
			   obj_t aux_4240;
			   {	/* Globalize/ginfo.scm 72 */
			      object_bglt aux_4241;
			      aux_4241 =
				 (object_bglt) (obj1531_1476);
			      aux_4240 =
				 OBJECT_WIDENING(aux_4241);
			   }
			   aux_4239 =
			      (((sexit_ginfo_81_bglt) CREF(aux_4240))->free_mark_81);
			}
			aux_4238 =
			   BINT(aux_4239);
		     }
		     STRUCT_SET(aux1533_1480, ((long) 2), aux_4238);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4247;
		     {	/* Globalize/ginfo.scm 66 */
			long aux_4248;
			{
			   obj_t aux_4249;
			   {	/* Globalize/ginfo.scm 74 */
			      object_bglt aux_4250;
			      aux_4250 =
				 (object_bglt) (obj1531_1476);
			      aux_4249 =
				 OBJECT_WIDENING(aux_4250);
			   }
			   aux_4248 =
			      (((sexit_ginfo_81_bglt) CREF(aux_4249))->mark);
			}
			aux_4247 =
			   BINT(aux_4248);
		     }
		     STRUCT_SET(aux1533_1480, ((long) 3), aux_4247);
		  }
		  STRUCT_SET(res1532_1479, ((long) 0), aux1533_1480);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4257;
		     aux_4257 =
			STRUCT_KEY(res1532_1479);
		     STRUCT_KEY_SET(aux1533_1480, aux_4257);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4260;
		     aux_4260 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1532_1479, aux_4260);
		  }
		  return res1532_1479;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-local/ginfo1597 */
obj_t 
struct_object__object_local_ginfo1597_81_globalize_ginfo(obj_t env_2735, obj_t o_2736, obj_t s_2737)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {
	 local_ginfo_108_bglt o_1464;
	 obj_t s_1465;
	 {	/* Globalize/ginfo.scm 76 */
	    local_ginfo_108_bglt aux_4264;
	    o_1464 =
	       (local_ginfo_108_bglt) (o_2736);
	    s_1465 = s_2737;
	    {

	       {	/* Globalize/ginfo.scm 76 */
		  obj_t old1555_1468;
		  obj_t aux1556_1469;
		  {	/* Globalize/ginfo.scm 76 */
		     obj_t next_method1596_131_1474;
		     next_method1596_131_1474 =
			find_super_class_method_167___object(
			(object_bglt) (o_1464), struct_object__object_env_209___object, local_ginfo_108_globalize_ginfo);
		     if (
			PROCEDUREP(next_method1596_131_1474))
		       {	/* Globalize/ginfo.scm 76 */
			  old1555_1468 =
			     PROCEDURE_ENTRY(next_method1596_131_1474) (next_method1596_131_1474,
			     (obj_t) (o_1464), s_1465, BEOA);
		       }
		     else
		       {	/* Globalize/ginfo.scm 76 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1596_131_1474);
			  {	/* Globalize/ginfo.scm 76 */
			     object_bglt aux_4273;
			     aux_4273 =
				struct_object__object_93___object(
				(object_bglt) (o_1464), s_1465);
			     old1555_1468 =
				(obj_t) (aux_4273);
			  }
		       }
		  }
		  aux1556_1469 =
		     STRUCT_REF(s_1465, ((long) 0));
		  {	/* Globalize/ginfo.scm 76 */
		     local_ginfo_108_bglt new1557_1470;
		     new1557_1470 =
			((local_ginfo_108_bglt) (old1555_1468));
		     {	/* Globalize/ginfo.scm 76 */
			long arg1738_1471;
			arg1738_1471 =
			   class_num_218___object(local_ginfo_108_globalize_ginfo);
			{	/* Globalize/ginfo.scm 76 */
			   obj_t obj_1974;
			   obj_1974 =
			      (obj_t) (new1557_1470);
			   (((obj_t) CREF(obj_1974))->header = MAKE_HEADER(arg1738_1471, 0), BUNSPEC);
			}
		     }
		     {	/* Globalize/ginfo.scm 76 */
			local_ginfo_108_bglt arg1739_1472;
			{	/* Globalize/ginfo.scm 76 */
			   local_ginfo_108_bglt res1852_1981;
			   {	/* Globalize/ginfo.scm 76 */
			      bool_t escape__117_1978;
			      {		/* Globalize/ginfo.scm 76 */
				 obj_t aux_4282;
				 aux_4282 =
				    STRUCT_REF(aux1556_1469, ((long) 0));
				 escape__117_1978 =
				    CBOOL(aux_4282);
			      }
			      {		/* Globalize/ginfo.scm 76 */
				 local_ginfo_108_bglt new1546_1979;
				 new1546_1979 =
				    ((local_ginfo_108_bglt) BREF(GC_MALLOC(sizeof(struct local_ginfo_108))));
				 ((((local_ginfo_108_bglt) CREF(new1546_1979))->escape__117) = ((bool_t) escape__117_1978), BUNSPEC);
				 res1852_1981 = new1546_1979;
			      }
			   }
			   arg1739_1472 = res1852_1981;
			}
			{	/* Globalize/ginfo.scm 76 */
			   obj_t aux_4289;
			   object_bglt aux_4287;
			   aux_4289 =
			      (obj_t) (arg1739_1472);
			   aux_4287 =
			      (object_bglt) (new1557_1470);
			   OBJECT_WIDENING_SET(aux_4287, aux_4289);
			}
		     }
		     aux_4264 = new1557_1470;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_4264);
	 }
      }
   }
}



/* object->struct-local/ginfo1595 */
obj_t 
object__struct_local_ginfo1595_65_globalize_ginfo(obj_t env_2738, obj_t obj1552_2739)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 76 */
      {
	 local_ginfo_108_bglt obj1552_1454;
	 obj1552_1454 =
	    (local_ginfo_108_bglt) (obj1552_2739);
	 {

	    {	/* Globalize/ginfo.scm 76 */
	       obj_t res1553_1457;
	       {	/* Globalize/ginfo.scm 76 */
		  obj_t next_method1594_229_1462;
		  next_method1594_229_1462 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1552_1454), object__struct_env_210___object, local_ginfo_108_globalize_ginfo);
		  if (
		     PROCEDUREP(next_method1594_229_1462))
		    {	/* Globalize/ginfo.scm 76 */
		       res1553_1457 =
			  PROCEDURE_ENTRY(next_method1594_229_1462) (next_method1594_229_1462,
			  (obj_t) (obj1552_1454), BEOA);
		    }
		  else
		    {	/* Globalize/ginfo.scm 76 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1594_229_1462);
		       res1553_1457 =
			  object__struct_50___object(
			  (object_bglt) (obj1552_1454));
		    }
	       }
	       {	/* Globalize/ginfo.scm 76 */
		  obj_t aux1554_1458;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_4304;
		     aux_4304 =
			CNST_TABLE_REF(((long) 3));
		     aux1554_1458 =
			make_struct(aux_4304, ((long) 1), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4307;
		     {	/* Globalize/ginfo.scm 76 */
			bool_t aux_4308;
			{
			   obj_t aux_4309;
			   {	/* Globalize/ginfo.scm 78 */
			      object_bglt aux_4310;
			      aux_4310 =
				 (object_bglt) (obj1552_1454);
			      aux_4309 =
				 OBJECT_WIDENING(aux_4310);
			   }
			   aux_4308 =
			      (((local_ginfo_108_bglt) CREF(aux_4309))->escape__117);
			}
			aux_4307 =
			   BBOOL(aux_4308);
		     }
		     STRUCT_SET(aux1554_1458, ((long) 0), aux_4307);
		  }
		  STRUCT_SET(res1553_1457, ((long) 0), aux1554_1458);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4317;
		     aux_4317 =
			STRUCT_KEY(res1553_1457);
		     STRUCT_KEY_SET(aux1554_1458, aux_4317);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4320;
		     aux_4320 =
			CNST_TABLE_REF(((long) 3));
		     STRUCT_KEY_SET(res1553_1457, aux_4320);
		  }
		  return res1553_1457;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-global/ginfo1593 */
obj_t 
struct_object__object_global_ginfo1593_126_globalize_ginfo(obj_t env_2740, obj_t o_2741, obj_t s_2742)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {
	 global_ginfo_75_bglt o_1441;
	 obj_t s_1442;
	 {	/* Globalize/ginfo.scm 80 */
	    global_ginfo_75_bglt aux_4324;
	    o_1441 =
	       (global_ginfo_75_bglt) (o_2741);
	    s_1442 = s_2742;
	    {

	       {	/* Globalize/ginfo.scm 80 */
		  obj_t old1582_1445;
		  obj_t aux1583_1446;
		  {	/* Globalize/ginfo.scm 80 */
		     obj_t next_method1592_76_1452;
		     next_method1592_76_1452 =
			find_super_class_method_167___object(
			(object_bglt) (o_1441), struct_object__object_env_209___object, global_ginfo_75_globalize_ginfo);
		     if (
			PROCEDUREP(next_method1592_76_1452))
		       {	/* Globalize/ginfo.scm 80 */
			  old1582_1445 =
			     PROCEDURE_ENTRY(next_method1592_76_1452) (next_method1592_76_1452,
			     (obj_t) (o_1441), s_1442, BEOA);
		       }
		     else
		       {	/* Globalize/ginfo.scm 80 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1592_76_1452);
			  {	/* Globalize/ginfo.scm 80 */
			     object_bglt aux_4333;
			     aux_4333 =
				struct_object__object_93___object(
				(object_bglt) (o_1441), s_1442);
			     old1582_1445 =
				(obj_t) (aux_4333);
			  }
		       }
		  }
		  aux1583_1446 =
		     STRUCT_REF(s_1442, ((long) 0));
		  {	/* Globalize/ginfo.scm 80 */
		     global_ginfo_75_bglt new1584_1447;
		     new1584_1447 =
			((global_ginfo_75_bglt) (old1582_1445));
		     {	/* Globalize/ginfo.scm 80 */
			long arg1729_1448;
			arg1729_1448 =
			   class_num_218___object(global_ginfo_75_globalize_ginfo);
			{	/* Globalize/ginfo.scm 80 */
			   obj_t obj_1941;
			   obj_1941 =
			      (obj_t) (new1584_1447);
			   (((obj_t) CREF(obj_1941))->header = MAKE_HEADER(arg1729_1448, 0), BUNSPEC);
			}
		     }
		     {	/* Globalize/ginfo.scm 80 */
			global_ginfo_75_bglt arg1730_1449;
			{	/* Globalize/ginfo.scm 80 */
			   obj_t arg1732_1451;
			   arg1732_1451 =
			      STRUCT_REF(aux1583_1446, ((long) 1));
			   {	/* Globalize/ginfo.scm 80 */
			      global_ginfo_75_bglt res1851_1952;
			      {		/* Globalize/ginfo.scm 80 */
				 bool_t escape__117_1947;
				 {	/* Globalize/ginfo.scm 80 */
				    obj_t aux_4343;
				    aux_4343 =
				       STRUCT_REF(aux1583_1446, ((long) 0));
				    escape__117_1947 =
				       CBOOL(aux_4343);
				 }
				 {	/* Globalize/ginfo.scm 80 */
				    global_ginfo_75_bglt new1572_1949;
				    new1572_1949 =
				       ((global_ginfo_75_bglt) BREF(GC_MALLOC(sizeof(struct global_ginfo_75))));
				    ((((global_ginfo_75_bglt) CREF(new1572_1949))->escape__117) = ((bool_t) escape__117_1947), BUNSPEC);
				    ((((global_ginfo_75_bglt) CREF(new1572_1949))->global_closure_229) = ((obj_t) arg1732_1451), BUNSPEC);
				    res1851_1952 = new1572_1949;
				 }
			      }
			      arg1730_1449 = res1851_1952;
			   }
			}
			{	/* Globalize/ginfo.scm 80 */
			   obj_t aux_4351;
			   object_bglt aux_4349;
			   aux_4351 =
			      (obj_t) (arg1730_1449);
			   aux_4349 =
			      (object_bglt) (new1584_1447);
			   OBJECT_WIDENING_SET(aux_4349, aux_4351);
			}
		     }
		     aux_4324 = new1584_1447;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_4324);
	 }
      }
   }
}



/* object->struct-global/ginfo1591 */
obj_t 
object__struct_global_ginfo1591_167_globalize_ginfo(obj_t env_2743, obj_t obj1579_2744)
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 80 */
      {
	 global_ginfo_75_bglt obj1579_1429;
	 obj1579_1429 =
	    (global_ginfo_75_bglt) (obj1579_2744);
	 {

	    {	/* Globalize/ginfo.scm 80 */
	       obj_t res1580_1432;
	       {	/* Globalize/ginfo.scm 80 */
		  obj_t next_method1590_209_1439;
		  next_method1590_209_1439 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1579_1429), object__struct_env_210___object, global_ginfo_75_globalize_ginfo);
		  if (
		     PROCEDUREP(next_method1590_209_1439))
		    {	/* Globalize/ginfo.scm 80 */
		       res1580_1432 =
			  PROCEDURE_ENTRY(next_method1590_209_1439) (next_method1590_209_1439,
			  (obj_t) (obj1579_1429), BEOA);
		    }
		  else
		    {	/* Globalize/ginfo.scm 80 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1590_209_1439);
		       res1580_1432 =
			  object__struct_50___object(
			  (object_bglt) (obj1579_1429));
		    }
	       }
	       {	/* Globalize/ginfo.scm 80 */
		  obj_t aux1581_1433;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_4366;
		     aux_4366 =
			CNST_TABLE_REF(((long) 4));
		     aux1581_1433 =
			make_struct(aux_4366, ((long) 2), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4369;
		     {	/* Globalize/ginfo.scm 80 */
			bool_t aux_4370;
			{
			   obj_t aux_4371;
			   {	/* Globalize/ginfo.scm 82 */
			      object_bglt aux_4372;
			      aux_4372 =
				 (object_bglt) (obj1579_1429);
			      aux_4371 =
				 OBJECT_WIDENING(aux_4372);
			   }
			   aux_4370 =
			      (((global_ginfo_75_bglt) CREF(aux_4371))->escape__117);
			}
			aux_4369 =
			   BBOOL(aux_4370);
		     }
		     STRUCT_SET(aux1581_1433, ((long) 0), aux_4369);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_4378;
		     {
			obj_t aux_4379;
			{	/* Globalize/ginfo.scm 84 */
			   object_bglt aux_4380;
			   aux_4380 =
			      (object_bglt) (obj1579_1429);
			   aux_4379 =
			      OBJECT_WIDENING(aux_4380);
			}
			aux_4378 =
			   (((global_ginfo_75_bglt) CREF(aux_4379))->global_closure_229);
		     }
		     STRUCT_SET(aux1581_1433, ((long) 1), aux_4378);
		  }
		  STRUCT_SET(res1580_1432, ((long) 0), aux1581_1433);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4386;
		     aux_4386 =
			STRUCT_KEY(res1580_1432);
		     STRUCT_KEY_SET(aux1581_1433, aux_4386);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_4389;
		     aux_4389 =
			CNST_TABLE_REF(((long) 4));
		     STRUCT_KEY_SET(res1580_1432, aux_4389);
		  }
		  return res1580_1432;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_globalize_ginfo()
{
   AN_OBJECT;
   {	/* Globalize/ginfo.scm 14 */
      module_initialization_70_type_type(((long) 0), "GLOBALIZE_GINFO");
      module_initialization_70_ast_var(((long) 0), "GLOBALIZE_GINFO");
      return
	 module_initialization_70_ast_node(((long) 0), "GLOBALIZE_GINFO");
   }
}
