/*===========================================================================*/
/*   (Integrate/iinfo.scm)                                                   */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct node
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
  }
    *node_bglt;

typedef struct node_effect_213
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
  }
               *node_effect_213_bglt;

typedef struct atom
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
    *atom_bglt;

typedef struct var
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
   *var_bglt;

typedef struct closure
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct variable *variable;
  }
       *closure_bglt;

typedef struct kwote
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t value;
  }
     *kwote_bglt;

typedef struct sequence
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t nodes;
  }
        *sequence_bglt;

typedef struct app
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *fun;
     obj_t args;
     obj_t stack_info_255;
  }
   *app_bglt;

typedef struct app_ly_162
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     struct node *arg;
  }
          *app_ly_162_bglt;

typedef struct funcall
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *fun;
     obj_t args;
     obj_t strength;
  }
       *funcall_bglt;

typedef struct pragma
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t format;
     obj_t args;
  }
      *pragma_bglt;

typedef struct cast
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *arg;
  }
    *cast_bglt;

typedef struct setq
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
    *setq_bglt;

typedef struct conditional
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     struct node *true;
     struct node *false;
  }
           *conditional_bglt;

typedef struct fail
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *proc;
     struct node *msg;
     struct node *obj;
  }
    *fail_bglt;

typedef struct select
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *test;
     obj_t clauses;
     struct type *item_type_130;
  }
      *select_bglt;

typedef struct let_fun_218
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t locals;
     struct node *body;
  }
           *let_fun_218_bglt;

typedef struct let_var_6
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     obj_t bindings;
     struct node *body;
     bool_t removable__42;
  }
         *let_var_6_bglt;

typedef struct set_ex_it_116
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *body;
  }
             *set_ex_it_116_bglt;

typedef struct jump_ex_it_184
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct node *exit;
     struct node *value;
  }
              *jump_ex_it_184_bglt;

typedef struct make_box_202
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct node *value;
  }
            *make_box_202_bglt;

typedef struct box_ref_242
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     obj_t side_effect__165;
     obj_t key;
     struct var *var;
  }
           *box_ref_242_bglt;

typedef struct box_set__221
  {
     header_t header;
     obj_t widening;
     obj_t loc;
     struct type *type;
     struct var *var;
     struct node *value;
  }
            *box_set__221_bglt;

typedef struct svar_iinfo_76
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
             *svar_iinfo_76_bglt;

typedef struct sexit_iinfo_190
  {
     obj_t f_mark_181;
     obj_t u_mark_209;
     bool_t kaptured__204;
     bool_t celled__113;
  }
               *sexit_iinfo_190_bglt;

typedef struct sfun_iinfo_105
  {
     obj_t owner;
     obj_t free;
     obj_t bound;
     obj_t cfrom;
     obj_t cto;
     obj_t k;
     obj_t k__190;
     obj_t u;
     obj_t cn;
     obj_t ct;
     obj_t kont;
     bool_t g__219;
     obj_t l;
     obj_t led;
     obj_t istamp;
     obj_t global;
     obj_t kaptured;
  }
              *sfun_iinfo_105_bglt;


static obj_t _sexit_iinfo_celled__set_1821_22_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_l1802_76_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_g__set_1799_169_integrate_info(obj_t, obj_t, obj_t);
static obj_t method_init_76_integrate_info();
extern obj_t sfun_iinfo_body_set__218_integrate_info(sfun_bglt, obj_t);
static obj_t _sfun_iinfo_global1808_127_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_stack_allocator_set_1759_176_integrate_info(obj_t, obj_t, obj_t);
extern svar_iinfo_76_bglt widening_svar_iinfo_47_integrate_info(obj_t, obj_t, bool_t, bool_t);
extern obj_t sexit_iinfo_f_mark_103_integrate_info(sexit_iinfo_190_bglt);
extern obj_t sfun_iinfo_side_effect__set__248_integrate_info(sfun_bglt, obj_t);
static obj_t struct_object__object_sexit_iinfo1547_91_integrate_info(obj_t, obj_t, obj_t);
extern bool_t sfun_iinfo__133_integrate_info(obj_t);
static obj_t _sfun_iinfo_kaptured1810_108_integrate_info(obj_t, obj_t);
static obj_t _allocate_svar_iinfo_246_integrate_info(obj_t);
extern obj_t sfun_iinfo_owner_223_integrate_info(sfun_iinfo_105_bglt);
static obj_t _sfun_iinfo_body1770_231_integrate_info(obj_t, obj_t);
extern obj_t svar_iinfo_loc_set__64_integrate_info(svar_bglt, obj_t);
extern obj_t sfun_iinfo_g__set__207_integrate_info(sfun_iinfo_105_bglt, bool_t);
static obj_t struct_object__object_sfun_iinfo1543_95_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_cto_set_1785_234_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_owner1778_254_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_kaptured_set_1809_191_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_loc_set_1775_113_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sexit_iinfo_f_mark_set_1815_153_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sexit_iinfo__65_integrate_info(obj_t, obj_t);
static obj_t _sexit_iinfo_handler1812_235_integrate_info(obj_t, obj_t);
static obj_t _svar_iinfo_celled__set_1831_123_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_bound_208_integrate_info(sfun_iinfo_105_bglt);
extern bool_t sfun_iinfo_top__215_integrate_info(sfun_bglt);
extern object_bglt struct_object__object_93___object(object_bglt, obj_t);
extern obj_t sexit_iinfo_f_mark_set__25_integrate_info(sexit_iinfo_190_bglt, obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern obj_t svar_iinfo_celled__set__209_integrate_info(svar_iinfo_76_bglt, bool_t);
static obj_t _sexit_iinfo_kaptured__set_1819_139_integrate_info(obj_t, obj_t, obj_t);
extern obj_t svar_iinfo_f_mark_86_integrate_info(svar_iinfo_76_bglt);
extern obj_t sfun_iinfo_dsssl_keywords_229_integrate_info(sfun_bglt);
extern obj_t sfun_iinfo_the_closure_5_integrate_info(sfun_bglt);
static obj_t _sfun_iinfo_bound1782_239_integrate_info(obj_t, obj_t);
static obj_t _svar_iinfo_u_mark1828_101_integrate_info(obj_t, obj_t);
extern obj_t find_super_class_method_167___object(object_bglt, obj_t, obj_t);
extern obj_t sfun_iinfo_cfrom_145_integrate_info(sfun_iinfo_105_bglt);
static obj_t _sfun_iinfo_ct_set_1795_9_integrate_info(obj_t, obj_t, obj_t);
extern sfun_bglt allocate_sfun_iinfo_8_integrate_info();
extern sexit_bglt allocate_sexit_iinfo_139_integrate_info();
obj_t sfun_iinfo_105_integrate_info = BUNSPEC;
extern obj_t sfun_iinfo_bound_set__116_integrate_info(sfun_iinfo_105_bglt, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
static obj_t _sexit_iinfo_detached_1814_207_integrate_info(obj_t, obj_t);
extern obj_t sfun_iinfo_l_set__126_integrate_info(sfun_iinfo_105_bglt, obj_t);
extern obj_t sexit_iinfo_kaptured__set__138_integrate_info(sexit_iinfo_190_bglt, bool_t);
static obj_t _svar_iinfo_kaptured_1830_50_integrate_info(obj_t, obj_t);
extern obj_t sfun_iinfo_predicate_of_199_integrate_info(sfun_bglt);
static obj_t _sfun_iinfo_led_set_1803_21_integrate_info(obj_t, obj_t, obj_t);
extern obj_t module_initialization_70_integrate_info(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_node(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
static obj_t _sfun_iinfo_body_set_1769_44_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_istamp_set_1805_240_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sexit_iinfo_u_mark1818_87_integrate_info(obj_t, obj_t);
obj_t sexit_iinfo_190_integrate_info = BUNSPEC;
extern svar_bglt allocate_svar_iinfo_15_integrate_info();
static obj_t _sfun_iinfo_arity1754_35_integrate_info(obj_t, obj_t);
obj_t svar_iinfo_76_integrate_info = BUNSPEC;
extern obj_t sfun_iinfo_ct_set__108_integrate_info(sfun_iinfo_105_bglt, obj_t);
extern obj_t sexit_iinfo_u_mark_set__37_integrate_info(sexit_iinfo_190_bglt, obj_t);
extern obj_t sfun_iinfo_dsssl_keywords_set__223_integrate_info(sfun_bglt, obj_t);
extern long class_num_218___object(obj_t);
extern obj_t sfun_iinfo_kaptured_239_integrate_info(sfun_iinfo_105_bglt);
extern obj_t svar_ast_var;
extern obj_t svar_iinfo_f_mark_set__34_integrate_info(svar_iinfo_76_bglt, obj_t);
extern obj_t sfun_iinfo_side_effect__11_integrate_info(sfun_bglt);
static obj_t _sfun_iinfo_loc1776_221_integrate_info(obj_t, obj_t);
static obj_t object__struct_sexit_iinfo1545_115_integrate_info(obj_t, obj_t);
extern obj_t sfun_iinfo_body_74_integrate_info(sfun_bglt);
extern bool_t sexit_iinfo_detached__106_integrate_info(sexit_bglt);
extern obj_t sfun_iinfo_cto_set__217_integrate_info(sfun_iinfo_105_bglt, obj_t);
extern obj_t sfun_iinfo_loc_114_integrate_info(sfun_bglt);
static obj_t _svar_iinfo_f_mark1826_199_integrate_info(obj_t, obj_t);
extern sfun_iinfo_105_bglt make_sfun_iinfo_248_integrate_info(long, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_global_set_1807_106_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_led_56_integrate_info(sfun_iinfo_105_bglt);
static obj_t _sexit_iinfo_kaptured_1820_129_integrate_info(obj_t, obj_t);
static obj_t imported_modules_init_94_integrate_info();
static obj_t _sfun_iinfo_free_set_1779_175_integrate_info(obj_t, obj_t, obj_t);
static obj_t struct_object__object_svar_iinfo1551_146_integrate_info(obj_t, obj_t, obj_t);
extern long sfun_iinfo_arity_150_integrate_info(sfun_bglt);
extern obj_t sexit_iinfo_celled__set__58_integrate_info(sexit_iinfo_190_bglt, bool_t);
static obj_t _svar_iinfo_u_mark_set_1827_74_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_kont_set_1797_10_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_side_effect__set_1755_205_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_istamp1806_153_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_kont1798_89_integrate_info(obj_t, obj_t);
static obj_t object__struct_sfun_iinfo1541_137_integrate_info(obj_t, obj_t);
extern obj_t sfun_iinfo_predicate_of_set__110_integrate_info(sfun_bglt, obj_t);
extern obj_t sfun_iinfo_owner_set__183_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_cn1794_230_integrate_info(obj_t, obj_t);
extern obj_t sfun_iinfo_class_146_integrate_info(sfun_bglt);
static obj_t _sfun_iinfo_owner_set_1777_159_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_global_63_integrate_info(sfun_iinfo_105_bglt);
static obj_t _make_sfun_iinfo1753_152_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _widening_sexit_iinfo_132_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_args_84_integrate_info(sfun_bglt);
extern obj_t sfun_iinfo_u_set__118_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sexit_iinfo_f_mark1816_102_integrate_info(obj_t, obj_t);
extern svar_iinfo_76_bglt make_svar_iinfo_142_integrate_info(obj_t, obj_t, obj_t, bool_t, bool_t);
extern obj_t svar_iinfo_u_mark_set__220_integrate_info(svar_iinfo_76_bglt, obj_t);
static obj_t library_modules_init_112_integrate_info();
static obj_t _sfun_iinfo_stack_allocator1760_140_integrate_info(obj_t, obj_t);
static obj_t _svar_iinfo_kaptured__set_1829_172_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_istamp_147_integrate_info(sfun_iinfo_105_bglt);
extern bool_t sexit_iinfo_kaptured__6_integrate_info(sexit_iinfo_190_bglt);
extern obj_t sfun_iinfo_u_241_integrate_info(sfun_iinfo_105_bglt);
extern obj_t sfun_iinfo_l_178_integrate_info(sfun_iinfo_105_bglt);
extern obj_t sfun_iinfo_k_88_integrate_info(sfun_iinfo_105_bglt);
extern obj_t make_struct(obj_t, long, obj_t);
static obj_t _sfun_iinfo_l_set_1801_109_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_kont_set__215_integrate_info(sfun_iinfo_105_bglt, obj_t);
extern obj_t sfun_iinfo_cto_152_integrate_info(sfun_iinfo_105_bglt);
static obj_t _sfun_iinfo_side_effect_1756_235_integrate_info(obj_t, obj_t);
extern bool_t sexit_iinfo_celled__92_integrate_info(sexit_iinfo_190_bglt);
extern obj_t sfun_iinfo_args_set__174_integrate_info(sfun_bglt, obj_t);
static obj_t _sfun_iinfo_free1780_193_integrate_info(obj_t, obj_t);
static obj_t toplevel_init_63_integrate_info();
extern obj_t sexit_iinfo_handler_249_integrate_info(sexit_bglt);
static obj_t _sfun_iinfo_u1792_203_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_cfrom1784_162_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_property_set_1765_69_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_the_closure1764_144_integrate_info(obj_t, obj_t);
extern obj_t sexit_iinfo_handler_set__83_integrate_info(sexit_bglt, obj_t);
extern obj_t create_vector(long);
static obj_t _sfun_iinfo_k1788_138_integrate_info(obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t sfun_iinfo_free_138_integrate_info(sfun_iinfo_105_bglt);
static obj_t _sfun_iinfo_k_set_1787_255_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_ast_var;
static obj_t _sfun_iinfo_args_set_1767_36_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_free_set__172_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_the_closure_set_1763_94_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_loc_set__90_integrate_info(sfun_bglt, obj_t);
extern obj_t sfun_iinfo_k_set__165_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sexit_iinfo_celled_1822_106_integrate_info(obj_t, obj_t);
extern obj_t sexit_iinfo_detached__set__74_integrate_info(sexit_bglt, bool_t);
static obj_t _widening_sfun_iinfo_17_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_cn_set_1793_135_integrate_info(obj_t, obj_t, obj_t);
static obj_t _svar_iinfo_f_mark_set_1825_58_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_led_set__27_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_class1772_27_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_top__set_1761_42_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_property_7_integrate_info(sfun_bglt);
static obj_t _make_svar_iinfo_96_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_top__set__103_integrate_info(sfun_bglt, bool_t);
extern obj_t sfun_iinfo_stack_allocator_146_integrate_info(sfun_bglt);
static obj_t _sexit_iinfo_handler_set_1811_71_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_property1766_201_integrate_info(obj_t, obj_t);
extern obj_t register_class__225___object(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
extern sexit_iinfo_190_bglt widening_sexit_iinfo_204_integrate_info(obj_t, obj_t, bool_t, bool_t);
extern obj_t svar_iinfo_loc_108_integrate_info(svar_bglt);
extern obj_t sfun_iinfo_kont_66_integrate_info(sfun_iinfo_105_bglt);
extern obj_t sfun_iinfo_istamp_set__89_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_cto1786_90_integrate_info(obj_t, obj_t);
static obj_t _svar_iinfo_loc_set_1823_139_integrate_info(obj_t, obj_t, obj_t);
static obj_t _widening_svar_iinfo_62_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t svar_iinfo_celled__54_integrate_info(svar_iinfo_76_bglt);
static obj_t object_init_111_integrate_info();
extern obj_t sexit_iinfo_u_mark_184_integrate_info(sexit_iinfo_190_bglt);
static obj_t _sfun_iinfo_k_1790_250_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_k__set_1789_224_integrate_info(obj_t, obj_t, obj_t);
static obj_t object__struct_svar_iinfo1549_158_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_top_1762_40_integrate_info(obj_t, obj_t);
extern obj_t sfun_iinfo_cn_set__18_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_u_set_1791_128_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_g_1800_152_integrate_info(obj_t, obj_t);
static obj_t _svar_iinfo_celled_1832_54_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_dsssl_keywords_set_1773_56_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_k__set__29_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_predicate_of1758_100_integrate_info(obj_t, obj_t);
extern obj_t sexit_ast_var;
static obj_t _sfun_iinfo_ct1796_49_integrate_info(obj_t, obj_t);
extern bool_t sexit_iinfo__64_integrate_info(obj_t);
static obj_t _make_sexit_iinfo_46_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_class_set__53_integrate_info(sfun_bglt, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t sfun_iinfo_property_set__178_integrate_info(sfun_bglt, obj_t);
static obj_t _sexit_iinfo_u_mark_set_1817_145_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_cfrom_set__158_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _svar_iinfo__104_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_class_set_1771_255_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_kaptured_set__173_integrate_info(sfun_iinfo_105_bglt, obj_t);
static obj_t _sfun_iinfo_args1768_142_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_bound_set_1781_95_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo_led1804_201_integrate_info(obj_t, obj_t);
static obj_t _sfun_iinfo_predicate_of_set_1757_8_integrate_info(obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_the_closure_set__128_integrate_info(sfun_bglt, obj_t);
extern obj_t object__struct_50___object(object_bglt);
extern obj_t svar_iinfo_u_mark_255_integrate_info(svar_iinfo_76_bglt);
extern obj_t sfun_iinfo_stack_allocator_set__53_integrate_info(sfun_bglt, obj_t);
static obj_t _sfun_iinfo_dsssl_keywords1774_190_integrate_info(obj_t, obj_t);
extern sfun_iinfo_105_bglt widening_sfun_iinfo_241_integrate_info(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t sfun_iinfo_k__50_integrate_info(sfun_iinfo_105_bglt);
extern bool_t sfun_iinfo_g__46_integrate_info(sfun_iinfo_105_bglt);
static obj_t require_initialization_114_integrate_info = BUNSPEC;
extern obj_t sfun_iinfo_global_set__36_integrate_info(sfun_iinfo_105_bglt, obj_t);
extern obj_t sfun_iinfo_ct_151_integrate_info(sfun_iinfo_105_bglt);
extern obj_t sfun_iinfo_cn_214_integrate_info(sfun_iinfo_105_bglt);
static obj_t _allocate_sexit_iinfo_189_integrate_info(obj_t);
static obj_t _svar_iinfo_loc1824_41_integrate_info(obj_t, obj_t);
static obj_t _allocate_sfun_iinfo_52_integrate_info(obj_t);
extern bool_t svar_iinfo_kaptured__141_integrate_info(svar_iinfo_76_bglt);
extern bool_t svar_iinfo__34_integrate_info(obj_t);
extern obj_t svar_iinfo_kaptured__set__147_integrate_info(svar_iinfo_76_bglt, bool_t);
static obj_t _sexit_iinfo_detached__set_1813_152_integrate_info(obj_t, obj_t, obj_t);
static obj_t _sfun_iinfo__181_integrate_info(obj_t, obj_t);
extern sexit_iinfo_190_bglt make_sexit_iinfo_29_integrate_info(obj_t, bool_t, obj_t, obj_t, bool_t, bool_t);
static obj_t cnst_init_137_integrate_info();
static obj_t _sfun_iinfo_cfrom_set_1783_61_integrate_info(obj_t, obj_t, obj_t);
static obj_t __cnst[3];

DEFINE_EXPORT_PROCEDURE(sfun_iinfo_kont_set__env_167_integrate_info, _sfun_iinfo_kont_set_1797_10_integrate_info1847, _sfun_iinfo_kont_set_1797_10_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_stack_allocator_set__env_92_integrate_info, _sfun_iinfo_stack_allocator_set_1759_176_integrate_info1848, _sfun_iinfo_stack_allocator_set_1759_176_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_side_effect__set__env_124_integrate_info, _sfun_iinfo_side_effect__set_1755_205_integrate_info1849, _sfun_iinfo_side_effect__set_1755_205_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_global_set__env_174_integrate_info, _sfun_iinfo_global_set_1807_106_integrate_info1850, _sfun_iinfo_global_set_1807_106_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_u_env_180_integrate_info, _sfun_iinfo_u1792_203_integrate_info1851, _sfun_iinfo_u1792_203_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_ct_set__env_26_integrate_info, _sfun_iinfo_ct_set_1795_9_integrate_info1852, _sfun_iinfo_ct_set_1795_9_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_kont_env_86_integrate_info, _sfun_iinfo_kont1798_89_integrate_info1853, _sfun_iinfo_kont1798_89_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_sfun_iinfo_env_124_integrate_info, _make_sfun_iinfo1753_152_integrate_info1854, _make_sfun_iinfo1753_152_integrate_info, 0L, 29);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_k_env_168_integrate_info, _sfun_iinfo_k1788_138_integrate_info1855, _sfun_iinfo_k1788_138_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_detached__env_17_integrate_info, _sexit_iinfo_detached_1814_207_integrate_info1856, _sexit_iinfo_detached_1814_207_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_u_mark_set__env_155_integrate_info, _svar_iinfo_u_mark_set_1827_74_integrate_info1857, _svar_iinfo_u_mark_set_1827_74_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_led_set__env_64_integrate_info, _sfun_iinfo_led_set_1803_21_integrate_info1858, _sfun_iinfo_led_set_1803_21_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_detached__set__env_52_integrate_info, _sexit_iinfo_detached__set_1813_152_integrate_info1859, _sexit_iinfo_detached__set_1813_152_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_the_closure_set__env_80_integrate_info, _sfun_iinfo_the_closure_set_1763_94_integrate_info1860, _sfun_iinfo_the_closure_set_1763_94_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_args_set__env_156_integrate_info, _sfun_iinfo_args_set_1767_36_integrate_info1861, _sfun_iinfo_args_set_1767_36_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_u_mark_env_161_integrate_info, _sexit_iinfo_u_mark1818_87_integrate_info1862, _sexit_iinfo_u_mark1818_87_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_f_mark_env_138_integrate_info, _svar_iinfo_f_mark1826_199_integrate_info1863, _svar_iinfo_f_mark1826_199_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_celled__set__env_81_integrate_info, _sexit_iinfo_celled__set_1821_22_integrate_info1864, _sexit_iinfo_celled__set_1821_22_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_free_env_67_integrate_info, _sfun_iinfo_free1780_193_integrate_info1865, _sfun_iinfo_free1780_193_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_loc_env_16_integrate_info, _sfun_iinfo_loc1776_221_integrate_info1866, _sfun_iinfo_loc1776_221_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_istamp_env_177_integrate_info, _sfun_iinfo_istamp1806_153_integrate_info1867, _sfun_iinfo_istamp1806_153_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_kaptured__set__env_177_integrate_info, _svar_iinfo_kaptured__set_1829_172_integrate_info1868, _svar_iinfo_kaptured__set_1829_172_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo__env_41_integrate_info, _sexit_iinfo__65_integrate_info1869, _sexit_iinfo__65_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_k__env_210_integrate_info, _sfun_iinfo_k_1790_250_integrate_info1870, _sfun_iinfo_k_1790_250_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_cfrom_env_1_integrate_info, _sfun_iinfo_cfrom1784_162_integrate_info1871, _sfun_iinfo_cfrom1784_162_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_the_closure_env_185_integrate_info, _sfun_iinfo_the_closure1764_144_integrate_info1872, _sfun_iinfo_the_closure1764_144_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_top__set__env_21_integrate_info, _sfun_iinfo_top__set_1761_42_integrate_info1873, _sfun_iinfo_top__set_1761_42_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_sfun_iinfo_env_130_integrate_info, _allocate_sfun_iinfo_52_integrate_info1874, _allocate_sfun_iinfo_52_integrate_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_g__env_28_integrate_info, _sfun_iinfo_g_1800_152_integrate_info1875, _sfun_iinfo_g_1800_152_integrate_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1841_integrate_info, struct_object__object_svar_iinfo1551_146_integrate_info1876, struct_object__object_svar_iinfo1551_146_integrate_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1839_integrate_info, struct_object__object_sexit_iinfo1547_91_integrate_info1877, struct_object__object_sexit_iinfo1547_91_integrate_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1840_integrate_info, object__struct_svar_iinfo1549_158_integrate_info1878, object__struct_svar_iinfo1549_158_integrate_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1838_integrate_info, object__struct_sexit_iinfo1545_115_integrate_info1879, object__struct_sexit_iinfo1545_115_integrate_info, 0L, 1);
DEFINE_STATIC_PROCEDURE(proc1837_integrate_info, struct_object__object_sfun_iinfo1543_95_integrate_info1880, struct_object__object_sfun_iinfo1543_95_integrate_info, 0L, 2);
DEFINE_STATIC_PROCEDURE(proc1836_integrate_info, object__struct_sfun_iinfo1541_137_integrate_info1881, object__struct_sfun_iinfo1541_137_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_dsssl_keywords_set__env_126_integrate_info, _sfun_iinfo_dsssl_keywords_set_1773_56_integrate_info1882, _sfun_iinfo_dsssl_keywords_set_1773_56_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_kaptured__env_15_integrate_info, _sexit_iinfo_kaptured_1820_129_integrate_info1883, _sexit_iinfo_kaptured_1820_129_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_ct_env_101_integrate_info, _sfun_iinfo_ct1796_49_integrate_info1884, _sfun_iinfo_ct1796_49_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_kaptured_set__env_56_integrate_info, _sfun_iinfo_kaptured_set_1809_191_integrate_info1885, _sfun_iinfo_kaptured_set_1809_191_integrate_info, 0L, 2);
extern obj_t struct_object__object_env_209___object;
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_l_set__env_178_integrate_info, _sfun_iinfo_l_set_1801_109_integrate_info1886, _sfun_iinfo_l_set_1801_109_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_owner_set__env_122_integrate_info, _sfun_iinfo_owner_set_1777_159_integrate_info1887, _sfun_iinfo_owner_set_1777_159_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_class_env_211_integrate_info, _sfun_iinfo_class1772_27_integrate_info1888, _sfun_iinfo_class1772_27_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_f_mark_set__env_70_integrate_info, _svar_iinfo_f_mark_set_1825_58_integrate_info1889, _svar_iinfo_f_mark_set_1825_58_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_kaptured__set__env_67_integrate_info, _sexit_iinfo_kaptured__set_1819_139_integrate_info1890, _sexit_iinfo_kaptured__set_1819_139_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_side_effect__env_186_integrate_info, _sfun_iinfo_side_effect_1756_235_integrate_info1891, _sfun_iinfo_side_effect_1756_235_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(widening_sexit_iinfo_env_236_integrate_info, _widening_sexit_iinfo_132_integrate_info1892, _widening_sexit_iinfo_132_integrate_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_f_mark_env_21_integrate_info, _sexit_iinfo_f_mark1816_102_integrate_info1893, _sexit_iinfo_f_mark1816_102_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_k_set__env_35_integrate_info, _sfun_iinfo_k_set_1787_255_integrate_info1894, _sfun_iinfo_k_set_1787_255_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_sfun_iinfo_env_180_integrate_info, _widening_sfun_iinfo_17_integrate_info1895, _widening_sfun_iinfo_17_integrate_info, 0L, 17);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_top__env_167_integrate_info, _sfun_iinfo_top_1762_40_integrate_info1896, _sfun_iinfo_top_1762_40_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_svar_iinfo_env_160_integrate_info, _make_svar_iinfo_96_integrate_info1897, _make_svar_iinfo_96_integrate_info, 0L, 5);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo__env_248_integrate_info, _sfun_iinfo__181_integrate_info1898, _sfun_iinfo__181_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_l_env_204_integrate_info, _sfun_iinfo_l1802_76_integrate_info1899, _sfun_iinfo_l1802_76_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_sexit_iinfo_env_117_integrate_info, _make_sexit_iinfo_46_integrate_info1900, _make_sexit_iinfo_46_integrate_info, 0L, 6);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_predicate_of_set__env_128_integrate_info, _sfun_iinfo_predicate_of_set_1757_8_integrate_info1901, _sfun_iinfo_predicate_of_set_1757_8_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_celled__env_29_integrate_info, _sexit_iinfo_celled_1822_106_integrate_info1902, _sexit_iinfo_celled_1822_106_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_args_env_72_integrate_info, _sfun_iinfo_args1768_142_integrate_info1903, _sfun_iinfo_args1768_142_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_cn_set__env_90_integrate_info, _sfun_iinfo_cn_set_1793_135_integrate_info1904, _sfun_iinfo_cn_set_1793_135_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_property_env_183_integrate_info, _sfun_iinfo_property1766_201_integrate_info1905, _sfun_iinfo_property1766_201_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_u_set__env_220_integrate_info, _sfun_iinfo_u_set_1791_128_integrate_info1906, _sfun_iinfo_u_set_1791_128_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(allocate_svar_iinfo_env_27_integrate_info, _allocate_svar_iinfo_246_integrate_info1907, _allocate_svar_iinfo_246_integrate_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_dsssl_keywords_env_218_integrate_info, _sfun_iinfo_dsssl_keywords1774_190_integrate_info1908, _sfun_iinfo_dsssl_keywords1774_190_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_loc_set__env_41_integrate_info, _svar_iinfo_loc_set_1823_139_integrate_info1909, _svar_iinfo_loc_set_1823_139_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(svar_iinfo__env_70_integrate_info, _svar_iinfo__104_integrate_info1910, _svar_iinfo__104_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_cto_env_114_integrate_info, _sfun_iinfo_cto1786_90_integrate_info1911, _sfun_iinfo_cto1786_90_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_predicate_of_env_206_integrate_info, _sfun_iinfo_predicate_of1758_100_integrate_info1912, _sfun_iinfo_predicate_of1758_100_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_k__set__env_117_integrate_info, _sfun_iinfo_k__set_1789_224_integrate_info1913, _sfun_iinfo_k__set_1789_224_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_stack_allocator_env_211_integrate_info, _sfun_iinfo_stack_allocator1760_140_integrate_info1914, _sfun_iinfo_stack_allocator1760_140_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_u_mark_set__env_121_integrate_info, _sexit_iinfo_u_mark_set_1817_145_integrate_info1915, _sexit_iinfo_u_mark_set_1817_145_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_body_env_52_integrate_info, _sfun_iinfo_body1770_231_integrate_info1916, _sfun_iinfo_body1770_231_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_celled__env_19_integrate_info, _svar_iinfo_celled_1832_54_integrate_info1917, _svar_iinfo_celled_1832_54_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_class_set__env_92_integrate_info, _sfun_iinfo_class_set_1771_255_integrate_info1918, _sfun_iinfo_class_set_1771_255_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_owner_env_126_integrate_info, _sfun_iinfo_owner1778_254_integrate_info1919, _sfun_iinfo_owner1778_254_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_bound_set__env_159_integrate_info, _sfun_iinfo_bound_set_1781_95_integrate_info1920, _sfun_iinfo_bound_set_1781_95_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(widening_svar_iinfo_env_61_integrate_info, _widening_svar_iinfo_62_integrate_info1921, _widening_svar_iinfo_62_integrate_info, 0L, 4);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_led_env_88_integrate_info, _sfun_iinfo_led1804_201_integrate_info1922, _sfun_iinfo_led1804_201_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_property_set__env_204_integrate_info, _sfun_iinfo_property_set_1765_69_integrate_info1923, _sfun_iinfo_property_set_1765_69_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_global_env_111_integrate_info, _sfun_iinfo_global1808_127_integrate_info1924, _sfun_iinfo_global1808_127_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_kaptured__env_232_integrate_info, _svar_iinfo_kaptured_1830_50_integrate_info1925, _svar_iinfo_kaptured_1830_50_integrate_info, 0L, 1);
DEFINE_STRING(string1842_integrate_info, string1842_integrate_info1926, "SFUN/IINFO SEXIT/IINFO SVAR/IINFO ", 34);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_loc_env_26_integrate_info, _svar_iinfo_loc1824_41_integrate_info1927, _svar_iinfo_loc1824_41_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_body_set__env_12_integrate_info, _sfun_iinfo_body_set_1769_44_integrate_info1928, _sfun_iinfo_body_set_1769_44_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_bound_env_54_integrate_info, _sfun_iinfo_bound1782_239_integrate_info1929, _sfun_iinfo_bound1782_239_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_cfrom_set__env_48_integrate_info, _sfun_iinfo_cfrom_set_1783_61_integrate_info1930, _sfun_iinfo_cfrom_set_1783_61_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_g__set__env_8_integrate_info, _sfun_iinfo_g__set_1799_169_integrate_info1931, _sfun_iinfo_g__set_1799_169_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_cn_env_103_integrate_info, _sfun_iinfo_cn1794_230_integrate_info1932, _sfun_iinfo_cn1794_230_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_kaptured_env_251_integrate_info, _sfun_iinfo_kaptured1810_108_integrate_info1933, _sfun_iinfo_kaptured1810_108_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(allocate_sexit_iinfo_env_116_integrate_info, _allocate_sexit_iinfo_189_integrate_info1934, _allocate_sexit_iinfo_189_integrate_info, 0L, 0);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_handler_set__env_245_integrate_info, _sexit_iinfo_handler_set_1811_71_integrate_info1935, _sexit_iinfo_handler_set_1811_71_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_f_mark_set__env_47_integrate_info, _sexit_iinfo_f_mark_set_1815_153_integrate_info1936, _sexit_iinfo_f_mark_set_1815_153_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_cto_set__env_152_integrate_info, _sfun_iinfo_cto_set_1785_234_integrate_info1937, _sfun_iinfo_cto_set_1785_234_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_istamp_set__env_133_integrate_info, _sfun_iinfo_istamp_set_1805_240_integrate_info1938, _sfun_iinfo_istamp_set_1805_240_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_arity_env_9_integrate_info, _sfun_iinfo_arity1754_35_integrate_info1939, _sfun_iinfo_arity1754_35_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(svar_iinfo_celled__set__env_78_integrate_info, _svar_iinfo_celled__set_1831_123_integrate_info1940, _svar_iinfo_celled__set_1831_123_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_loc_set__env_237_integrate_info, _sfun_iinfo_loc_set_1775_113_integrate_info1941, _sfun_iinfo_loc_set_1775_113_integrate_info, 0L, 2);
DEFINE_EXPORT_PROCEDURE(sfun_iinfo_free_set__env_224_integrate_info, _sfun_iinfo_free_set_1779_175_integrate_info1942, _sfun_iinfo_free_set_1779_175_integrate_info, 0L, 2);
extern obj_t object__struct_env_210___object;
DEFINE_EXPORT_PROCEDURE(svar_iinfo_u_mark_env_194_integrate_info, _svar_iinfo_u_mark1828_101_integrate_info1943, _svar_iinfo_u_mark1828_101_integrate_info, 0L, 1);
DEFINE_EXPORT_PROCEDURE(sexit_iinfo_handler_env_215_integrate_info, _sexit_iinfo_handler1812_235_integrate_info1944, _sexit_iinfo_handler1812_235_integrate_info, 0L, 1);



/* module-initialization */
obj_t 
module_initialization_70_integrate_info(long checksum_2166, char *from_2167)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_integrate_info))
	{
	   require_initialization_114_integrate_info =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_integrate_info();
	   cnst_init_137_integrate_info();
	   imported_modules_init_94_integrate_info();
	   object_init_111_integrate_info();
	   method_init_76_integrate_info();
	   toplevel_init_63_integrate_info();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 14 */
      module_initialization_70___object(((long) 0), "INTEGRATE_INFO");
      module_initialization_70___reader(((long) 0), "INTEGRATE_INFO");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 14 */
      {		/* Integrate/iinfo.scm 14 */
	 obj_t cnst_port_138_2159;
	 cnst_port_138_2159 =
	    open_input_string(string1842_integrate_info);
	 {
	    long i_2160;
	    i_2160 = ((long) 2);
	  loop_2161:
	    {	/* Integrate/iinfo.scm 14 */
	       bool_t test1843_2162;
	       test1843_2162 =
		  (i_2160 == ((long) -1));
	       if (test1843_2162)
		 {	/* Integrate/iinfo.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Integrate/iinfo.scm 14 */
		    {	/* Integrate/iinfo.scm 14 */
		       obj_t arg1844_2163;
		       {	/* Integrate/iinfo.scm 14 */
			  obj_t list1845_2164;
			  list1845_2164 =
			     MAKE_PAIR(cnst_port_138_2159, BNIL);
			  arg1844_2163 =
			     read___reader(list1845_2164);
		       }
		       CNST_TABLE_SET(i_2160, arg1844_2163);
		    }
		    {	/* Integrate/iinfo.scm 14 */
		       int aux_2165;
		       {	/* Integrate/iinfo.scm 14 */
			  long aux_2185;
			  aux_2185 =
			     (i_2160 - ((long) 1));
			  aux_2165 =
			     (int) (aux_2185);
		       }
		       {
			  long i_2188;
			  i_2188 =
			     (long) (aux_2165);
			  i_2160 = i_2188;
			  goto loop_2161;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 14 */
      return BUNSPEC;
   }
}



/* object-init */
obj_t 
object_init_111_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 14 */
      {		/* Integrate/iinfo.scm 14 */
	 obj_t arg1552_891;
	 obj_t arg1553_892;
	 obj_t arg1557_895;
	 arg1552_891 =
	    CNST_TABLE_REF(((long) 0));
	 arg1553_892 = svar_ast_var;
	 {	/* Integrate/iinfo.scm 14 */
	    obj_t v1537_896;
	    v1537_896 =
	       create_vector(((long) 0));
	    arg1557_895 = v1537_896;
	 }
	 svar_iinfo_76_integrate_info =
	    register_class__225___object(arg1552_891, arg1553_892, allocate_svar_iinfo_env_27_integrate_info, ((long) 23564), BUNSPEC, BFALSE, arg1557_895);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t arg1558_897;
	 obj_t arg1559_898;
	 obj_t arg1562_901;
	 arg1558_897 =
	    CNST_TABLE_REF(((long) 1));
	 arg1559_898 = sexit_ast_var;
	 {	/* Integrate/iinfo.scm 14 */
	    obj_t v1538_902;
	    v1538_902 =
	       create_vector(((long) 0));
	    arg1562_901 = v1538_902;
	 }
	 sexit_iinfo_190_integrate_info =
	    register_class__225___object(arg1558_897, arg1559_898, allocate_sexit_iinfo_env_116_integrate_info, ((long) 7261), BUNSPEC, BFALSE, arg1562_901);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t arg1563_903;
	 obj_t arg1564_904;
	 obj_t arg1567_907;
	 arg1563_903 =
	    CNST_TABLE_REF(((long) 2));
	 arg1564_904 = sfun_ast_var;
	 {	/* Integrate/iinfo.scm 14 */
	    obj_t v1539_908;
	    v1539_908 =
	       create_vector(((long) 0));
	    arg1567_907 = v1539_908;
	 }
	 sfun_iinfo_105_integrate_info =
	    register_class__225___object(arg1563_903, arg1564_904, allocate_sfun_iinfo_env_130_integrate_info, ((long) 8433), BUNSPEC, BFALSE, arg1567_907);
      }
      return BUNSPEC;
   }
}



/* allocate-sfun/iinfo */
sfun_bglt 
allocate_sfun_iinfo_8_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 sfun_bglt new1529_909;
	 new1529_909 =
	    ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	 {	/* Integrate/iinfo.scm 40 */
	    long arg1568_910;
	    arg1568_910 =
	       class_num_218___object(sfun_iinfo_105_integrate_info);
	    {	/* Integrate/iinfo.scm 40 */
	       obj_t obj_1413;
	       obj_1413 =
		  (obj_t) (new1529_909);
	       (((obj_t) CREF(obj_1413))->header = MAKE_HEADER(arg1568_910, 0), BUNSPEC);
	    }
	 }
	 {	/* Integrate/iinfo.scm 40 */
	    object_bglt aux_2203;
	    aux_2203 =
	       (object_bglt) (new1529_909);
	    OBJECT_WIDENING_SET(aux_2203, BFALSE);
	 }
	 return new1529_909;
      }
   }
}



/* _allocate-sfun/iinfo */
obj_t 
_allocate_sfun_iinfo_52_integrate_info(obj_t env_1858)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 sfun_bglt aux_2206;
	 aux_2206 =
	    allocate_sfun_iinfo_8_integrate_info();
	 return
	    (obj_t) (aux_2206);
      }
   }
}



/* sfun/iinfo? */
bool_t 
sfun_iinfo__133_integrate_info(obj_t obj_4)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      return
	 is_a__118___object(obj_4, sfun_iinfo_105_integrate_info);
   }
}



/* _sfun/iinfo? */
obj_t 
_sfun_iinfo__181_integrate_info(obj_t env_1859, obj_t obj_1860)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 bool_t aux_2210;
	 aux_2210 =
	    sfun_iinfo__133_integrate_info(obj_1860);
	 return
	    BBOOL(aux_2210);
      }
   }
}



/* widening-sfun/iinfo */
sfun_iinfo_105_bglt 
widening_sfun_iinfo_241_integrate_info(obj_t owner_5, obj_t free_6, obj_t bound_7, obj_t cfrom_8, obj_t cto_9, obj_t k_10, obj_t k__190_11, obj_t u_12, obj_t cn_13, obj_t ct_14, obj_t kont_15, bool_t g__219_16, obj_t l_17, obj_t led_18, obj_t istamp_19, obj_t global_20, obj_t kaptured_21)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 sfun_iinfo_105_bglt new1508_1415;
	 new1508_1415 =
	    ((sfun_iinfo_105_bglt) BREF(GC_MALLOC(sizeof(struct sfun_iinfo_105))));
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->owner) = ((obj_t) owner_5), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->free) = ((obj_t) free_6), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->bound) = ((obj_t) bound_7), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->cfrom) = ((obj_t) cfrom_8), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->cto) = ((obj_t) cto_9), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->k) = ((obj_t) k_10), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->k__190) = ((obj_t) k__190_11), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->u) = ((obj_t) u_12), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->cn) = ((obj_t) cn_13), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->ct) = ((obj_t) ct_14), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->kont) = ((obj_t) kont_15), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->g__219) = ((bool_t) g__219_16), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->l) = ((obj_t) l_17), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->led) = ((obj_t) led_18), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->istamp) = ((obj_t) istamp_19), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->global) = ((obj_t) global_20), BUNSPEC);
	 ((((sfun_iinfo_105_bglt) CREF(new1508_1415))->kaptured) = ((obj_t) kaptured_21), BUNSPEC);
	 return new1508_1415;
      }
   }
}



/* _widening-sfun/iinfo */
obj_t 
_widening_sfun_iinfo_17_integrate_info(obj_t env_1861, obj_t owner_1862, obj_t free_1863, obj_t bound_1864, obj_t cfrom_1865, obj_t cto_1866, obj_t k_1867, obj_t k__190_1868, obj_t u_1869, obj_t cn_1870, obj_t ct_1871, obj_t kont_1872, obj_t g__219_1873, obj_t l_1874, obj_t led_1875, obj_t istamp_1876, obj_t global_1877, obj_t kaptured_1878)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 sfun_iinfo_105_bglt aux_2231;
	 aux_2231 =
	    widening_sfun_iinfo_241_integrate_info(owner_1862, free_1863, bound_1864, cfrom_1865, cto_1866, k_1867, k__190_1868, u_1869, cn_1870, ct_1871, kont_1872,
	    CBOOL(g__219_1873), l_1874, led_1875, istamp_1876, global_1877, kaptured_1878);
	 return
	    (obj_t) (aux_2231);
      }
   }
}



/* make-sfun/iinfo */
sfun_iinfo_105_bglt 
make_sfun_iinfo_248_integrate_info(long arity_22, obj_t side_effect__165_23, obj_t predicate_of_78_24, obj_t stack_allocator_172_25, bool_t top__138_26, obj_t the_closure_238_27, obj_t property_28, obj_t args_29, obj_t body_30, obj_t class_31, obj_t dsssl_keywords_243_32, obj_t loc_33, obj_t owner_34, obj_t free_35, obj_t bound_36, obj_t cfrom_37, obj_t cto_38, obj_t k_39, obj_t k__190_40, obj_t u_41, obj_t cn_42, obj_t ct_43, obj_t kont_44, bool_t g__219_45, obj_t l_46, obj_t led_47, obj_t istamp_48, obj_t global_49, obj_t kaptured_50)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 sfun_bglt aux1527_1433;
	 {	/* Integrate/iinfo.scm 40 */
	    sfun_bglt res1744_1465;
	    {	/* ./Ast/var.scm 453 */
	       sfun_bglt new1127_1449;
	       new1127_1449 =
		  ((sfun_bglt) BREF(GC_MALLOC(sizeof(struct sfun))));
	       {	/* ./Ast/var.scm 453 */
		  long arg1637_1450;
		  arg1637_1450 =
		     class_num_218___object(sfun_ast_var);
		  {	/* ./Ast/var.scm 453 */
		     obj_t obj_1463;
		     obj_1463 =
			(obj_t) (new1127_1449);
		     (((obj_t) CREF(obj_1463))->header = MAKE_HEADER(arg1637_1450, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 453 */
		  object_bglt aux_2239;
		  aux_2239 =
		     (object_bglt) (new1127_1449);
		  OBJECT_WIDENING_SET(aux_2239, BFALSE);
	       }
	       ((((sfun_bglt) CREF(new1127_1449))->arity) = ((long) arity_22), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->side_effect__165) = ((obj_t) side_effect__165_23), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->predicate_of_78) = ((obj_t) predicate_of_78_24), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->stack_allocator_172) = ((obj_t) stack_allocator_172_25), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->top__138) = ((bool_t) top__138_26), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->the_closure_238) = ((obj_t) the_closure_238_27), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->property) = ((obj_t) property_28), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->args) = ((obj_t) args_29), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->body) = ((obj_t) body_30), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->class) = ((obj_t) class_31), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->dsssl_keywords_243) = ((obj_t) dsssl_keywords_243_32), BUNSPEC);
	       ((((sfun_bglt) CREF(new1127_1449))->loc) = ((obj_t) loc_33), BUNSPEC);
	       res1744_1465 = new1127_1449;
	    }
	    aux1527_1433 = res1744_1465;
	 }
	 {	/* Integrate/iinfo.scm 40 */
	    sfun_iinfo_105_bglt new1528_1434;
	    new1528_1434 =
	       ((sfun_iinfo_105_bglt) (aux1527_1433));
	    {	/* Integrate/iinfo.scm 40 */
	       long arg1569_1435;
	       arg1569_1435 =
		  class_num_218___object(sfun_iinfo_105_integrate_info);
	       {	/* Integrate/iinfo.scm 40 */
		  obj_t obj_1466;
		  obj_1466 =
		     (obj_t) (new1528_1434);
		  (((obj_t) CREF(obj_1466))->header = MAKE_HEADER(arg1569_1435, 0), BUNSPEC);
	       }
	    }
	    {	/* Integrate/iinfo.scm 40 */
	       sfun_iinfo_105_bglt arg1571_1436;
	       {	/* Integrate/iinfo.scm 40 */
		  sfun_iinfo_105_bglt res1745_1503;
		  {	/* Integrate/iinfo.scm 40 */
		     sfun_iinfo_105_bglt new1508_1485;
		     new1508_1485 =
			((sfun_iinfo_105_bglt) BREF(GC_MALLOC(sizeof(struct sfun_iinfo_105))));
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->owner) = ((obj_t) owner_34), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->free) = ((obj_t) free_35), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->bound) = ((obj_t) bound_36), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->cfrom) = ((obj_t) cfrom_37), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->cto) = ((obj_t) cto_38), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->k) = ((obj_t) k_39), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->k__190) = ((obj_t) k__190_40), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->u) = ((obj_t) u_41), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->cn) = ((obj_t) cn_42), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->ct) = ((obj_t) ct_43), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->kont) = ((obj_t) kont_44), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->g__219) = ((bool_t) g__219_45), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->l) = ((obj_t) l_46), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->led) = ((obj_t) led_47), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->istamp) = ((obj_t) istamp_48), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->global) = ((obj_t) global_49), BUNSPEC);
		     ((((sfun_iinfo_105_bglt) CREF(new1508_1485))->kaptured) = ((obj_t) kaptured_50), BUNSPEC);
		     res1745_1503 = new1508_1485;
		  }
		  arg1571_1436 = res1745_1503;
	       }
	       {	/* Integrate/iinfo.scm 40 */
		  obj_t aux_2278;
		  object_bglt aux_2276;
		  aux_2278 =
		     (obj_t) (arg1571_1436);
		  aux_2276 =
		     (object_bglt) (new1528_1434);
		  OBJECT_WIDENING_SET(aux_2276, aux_2278);
	       }
	    }
	    return new1528_1434;
	 }
      }
   }
}



/* _make-sfun/iinfo1753 */
obj_t 
_make_sfun_iinfo1753_152_integrate_info(obj_t env_1879, obj_t arity_1880, obj_t side_effect__165_1881, obj_t predicate_of_78_1882, obj_t stack_allocator_172_1883, obj_t top__138_1884, obj_t the_closure_238_1885, obj_t property_1886, obj_t args_1887, obj_t body_1888, obj_t class_1889, obj_t dsssl_keywords_243_1890, obj_t loc_1891, obj_t owner_1892, obj_t free_1893, obj_t bound_1894, obj_t cfrom_1895, obj_t cto_1896, obj_t k_1897, obj_t k__190_1898, obj_t u_1899, obj_t cn_1900, obj_t ct_1901, obj_t kont_1902, obj_t g__219_1903, obj_t l_1904, obj_t led_1905, obj_t istamp_1906, obj_t global_1907, obj_t kaptured_1908)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 sfun_iinfo_105_bglt aux_2281;
	 aux_2281 =
	    make_sfun_iinfo_248_integrate_info(
	    (long) CINT(arity_1880), side_effect__165_1881, predicate_of_78_1882, stack_allocator_172_1883,
	    CBOOL(top__138_1884), the_closure_238_1885, property_1886, args_1887, body_1888, class_1889, dsssl_keywords_243_1890, loc_1891, owner_1892, free_1893, bound_1894, cfrom_1895, cto_1896, k_1897, k__190_1898, u_1899, cn_1900, ct_1901, kont_1902,
	    CBOOL(g__219_1903), l_1904, led_1905, istamp_1906, global_1907, kaptured_1908);
	 return
	    (obj_t) (aux_2281);
      }
   }
}



/* sfun/iinfo-arity */
long 
sfun_iinfo_arity_150_integrate_info(sfun_bglt obj_51)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 441 */
      return
	 (((sfun_bglt) CREF(obj_51))->arity);
   }
}



/* _sfun/iinfo-arity1754 */
obj_t 
_sfun_iinfo_arity1754_35_integrate_info(obj_t env_1909, obj_t obj_1910)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 441 */
      {		/* ./Ast/var.scm 441 */
	 long aux_2288;
	 aux_2288 =
	    sfun_iinfo_arity_150_integrate_info(
	    (sfun_bglt) (obj_1910));
	 return
	    BINT(aux_2288);
      }
   }
}



/* sfun/iinfo-side-effect?-set! */
obj_t 
sfun_iinfo_side_effect__set__248_integrate_info(sfun_bglt obj_52, obj_t val1480_53)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 443 */
      return
	 ((((sfun_bglt) CREF(obj_52))->side_effect__165) = ((obj_t) val1480_53), BUNSPEC);
   }
}



/* _sfun/iinfo-side-effect?-set!1755 */
obj_t 
_sfun_iinfo_side_effect__set_1755_205_integrate_info(obj_t env_1911, obj_t obj_1912, obj_t val1480_1913)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 443 */
      return
	 sfun_iinfo_side_effect__set__248_integrate_info(
	 (sfun_bglt) (obj_1912), val1480_1913);
   }
}



/* sfun/iinfo-side-effect? */
obj_t 
sfun_iinfo_side_effect__11_integrate_info(sfun_bglt obj_54)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 443 */
      return
	 (((sfun_bglt) CREF(obj_54))->side_effect__165);
   }
}



/* _sfun/iinfo-side-effect?1756 */
obj_t 
_sfun_iinfo_side_effect_1756_235_integrate_info(obj_t env_1914, obj_t obj_1915)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 443 */
      return
	 sfun_iinfo_side_effect__11_integrate_info(
	 (sfun_bglt) (obj_1915));
   }
}



/* sfun/iinfo-predicate-of-set! */
obj_t 
sfun_iinfo_predicate_of_set__110_integrate_info(sfun_bglt obj_55, obj_t val1481_56)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 ((((sfun_bglt) CREF(obj_55))->predicate_of_78) = ((obj_t) val1481_56), BUNSPEC);
   }
}



/* _sfun/iinfo-predicate-of-set!1757 */
obj_t 
_sfun_iinfo_predicate_of_set_1757_8_integrate_info(obj_t env_1916, obj_t obj_1917, obj_t val1481_1918)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 sfun_iinfo_predicate_of_set__110_integrate_info(
	 (sfun_bglt) (obj_1917), val1481_1918);
   }
}



/* sfun/iinfo-predicate-of */
obj_t 
sfun_iinfo_predicate_of_199_integrate_info(sfun_bglt obj_57)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 (((sfun_bglt) CREF(obj_57))->predicate_of_78);
   }
}



/* _sfun/iinfo-predicate-of1758 */
obj_t 
_sfun_iinfo_predicate_of1758_100_integrate_info(obj_t env_1919, obj_t obj_1920)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 445 */
      return
	 sfun_iinfo_predicate_of_199_integrate_info(
	 (sfun_bglt) (obj_1920));
   }
}



/* sfun/iinfo-stack-allocator-set! */
obj_t 
sfun_iinfo_stack_allocator_set__53_integrate_info(sfun_bglt obj_58, obj_t val1482_59)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 ((((sfun_bglt) CREF(obj_58))->stack_allocator_172) = ((obj_t) val1482_59), BUNSPEC);
   }
}



/* _sfun/iinfo-stack-allocator-set!1759 */
obj_t 
_sfun_iinfo_stack_allocator_set_1759_176_integrate_info(obj_t env_1921, obj_t obj_1922, obj_t val1482_1923)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 sfun_iinfo_stack_allocator_set__53_integrate_info(
	 (sfun_bglt) (obj_1922), val1482_1923);
   }
}



/* sfun/iinfo-stack-allocator */
obj_t 
sfun_iinfo_stack_allocator_146_integrate_info(sfun_bglt obj_60)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 (((sfun_bglt) CREF(obj_60))->stack_allocator_172);
   }
}



/* _sfun/iinfo-stack-allocator1760 */
obj_t 
_sfun_iinfo_stack_allocator1760_140_integrate_info(obj_t env_1924, obj_t obj_1925)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 447 */
      return
	 sfun_iinfo_stack_allocator_146_integrate_info(
	 (sfun_bglt) (obj_1925));
   }
}



/* sfun/iinfo-top?-set! */
obj_t 
sfun_iinfo_top__set__103_integrate_info(sfun_bglt obj_61, bool_t val1483_62)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 449 */
      return
	 ((((sfun_bglt) CREF(obj_61))->top__138) = ((bool_t) val1483_62), BUNSPEC);
   }
}



/* _sfun/iinfo-top?-set!1761 */
obj_t 
_sfun_iinfo_top__set_1761_42_integrate_info(obj_t env_1926, obj_t obj_1927, obj_t val1483_1928)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 449 */
      return
	 sfun_iinfo_top__set__103_integrate_info(
	 (sfun_bglt) (obj_1927),
	 CBOOL(val1483_1928));
   }
}



/* sfun/iinfo-top? */
bool_t 
sfun_iinfo_top__215_integrate_info(sfun_bglt obj_63)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 449 */
      return
	 (((sfun_bglt) CREF(obj_63))->top__138);
   }
}



/* _sfun/iinfo-top?1762 */
obj_t 
_sfun_iinfo_top_1762_40_integrate_info(obj_t env_1929, obj_t obj_1930)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 449 */
      {		/* ./Ast/var.scm 449 */
	 bool_t aux_2315;
	 aux_2315 =
	    sfun_iinfo_top__215_integrate_info(
	    (sfun_bglt) (obj_1930));
	 return
	    BBOOL(aux_2315);
      }
   }
}



/* sfun/iinfo-the-closure-set! */
obj_t 
sfun_iinfo_the_closure_set__128_integrate_info(sfun_bglt obj_64, obj_t val1484_65)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 451 */
      return
	 ((((sfun_bglt) CREF(obj_64))->the_closure_238) = ((obj_t) val1484_65), BUNSPEC);
   }
}



/* _sfun/iinfo-the-closure-set!1763 */
obj_t 
_sfun_iinfo_the_closure_set_1763_94_integrate_info(obj_t env_1931, obj_t obj_1932, obj_t val1484_1933)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 451 */
      return
	 sfun_iinfo_the_closure_set__128_integrate_info(
	 (sfun_bglt) (obj_1932), val1484_1933);
   }
}



/* sfun/iinfo-the-closure */
obj_t 
sfun_iinfo_the_closure_5_integrate_info(sfun_bglt obj_66)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 451 */
      return
	 (((sfun_bglt) CREF(obj_66))->the_closure_238);
   }
}



/* _sfun/iinfo-the-closure1764 */
obj_t 
_sfun_iinfo_the_closure1764_144_integrate_info(obj_t env_1934, obj_t obj_1935)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 451 */
      return
	 sfun_iinfo_the_closure_5_integrate_info(
	 (sfun_bglt) (obj_1935));
   }
}



/* sfun/iinfo-property-set! */
obj_t 
sfun_iinfo_property_set__178_integrate_info(sfun_bglt obj_67, obj_t val1485_68)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 455 */
      return
	 ((((sfun_bglt) CREF(obj_67))->property) = ((obj_t) val1485_68), BUNSPEC);
   }
}



/* _sfun/iinfo-property-set!1765 */
obj_t 
_sfun_iinfo_property_set_1765_69_integrate_info(obj_t env_1936, obj_t obj_1937, obj_t val1485_1938)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 455 */
      return
	 sfun_iinfo_property_set__178_integrate_info(
	 (sfun_bglt) (obj_1937), val1485_1938);
   }
}



/* sfun/iinfo-property */
obj_t 
sfun_iinfo_property_7_integrate_info(sfun_bglt obj_69)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 455 */
      return
	 (((sfun_bglt) CREF(obj_69))->property);
   }
}



/* _sfun/iinfo-property1766 */
obj_t 
_sfun_iinfo_property1766_201_integrate_info(obj_t env_1939, obj_t obj_1940)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 455 */
      return
	 sfun_iinfo_property_7_integrate_info(
	 (sfun_bglt) (obj_1940));
   }
}



/* sfun/iinfo-args-set! */
obj_t 
sfun_iinfo_args_set__174_integrate_info(sfun_bglt obj_70, obj_t val1486_71)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 457 */
      return
	 ((((sfun_bglt) CREF(obj_70))->args) = ((obj_t) val1486_71), BUNSPEC);
   }
}



/* _sfun/iinfo-args-set!1767 */
obj_t 
_sfun_iinfo_args_set_1767_36_integrate_info(obj_t env_1941, obj_t obj_1942, obj_t val1486_1943)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 457 */
      return
	 sfun_iinfo_args_set__174_integrate_info(
	 (sfun_bglt) (obj_1942), val1486_1943);
   }
}



/* sfun/iinfo-args */
obj_t 
sfun_iinfo_args_84_integrate_info(sfun_bglt obj_72)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 457 */
      return
	 (((sfun_bglt) CREF(obj_72))->args);
   }
}



/* _sfun/iinfo-args1768 */
obj_t 
_sfun_iinfo_args1768_142_integrate_info(obj_t env_1944, obj_t obj_1945)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 457 */
      return
	 sfun_iinfo_args_84_integrate_info(
	 (sfun_bglt) (obj_1945));
   }
}



/* sfun/iinfo-body-set! */
obj_t 
sfun_iinfo_body_set__218_integrate_info(sfun_bglt obj_73, obj_t val1487_74)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 459 */
      return
	 ((((sfun_bglt) CREF(obj_73))->body) = ((obj_t) val1487_74), BUNSPEC);
   }
}



/* _sfun/iinfo-body-set!1769 */
obj_t 
_sfun_iinfo_body_set_1769_44_integrate_info(obj_t env_1946, obj_t obj_1947, obj_t val1487_1948)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 459 */
      return
	 sfun_iinfo_body_set__218_integrate_info(
	 (sfun_bglt) (obj_1947), val1487_1948);
   }
}



/* sfun/iinfo-body */
obj_t 
sfun_iinfo_body_74_integrate_info(sfun_bglt obj_75)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 459 */
      return
	 (((sfun_bglt) CREF(obj_75))->body);
   }
}



/* _sfun/iinfo-body1770 */
obj_t 
_sfun_iinfo_body1770_231_integrate_info(obj_t env_1949, obj_t obj_1950)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 459 */
      return
	 sfun_iinfo_body_74_integrate_info(
	 (sfun_bglt) (obj_1950));
   }
}



/* sfun/iinfo-class-set! */
obj_t 
sfun_iinfo_class_set__53_integrate_info(sfun_bglt obj_76, obj_t val1488_77)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 461 */
      return
	 ((((sfun_bglt) CREF(obj_76))->class) = ((obj_t) val1488_77), BUNSPEC);
   }
}



/* _sfun/iinfo-class-set!1771 */
obj_t 
_sfun_iinfo_class_set_1771_255_integrate_info(obj_t env_1951, obj_t obj_1952, obj_t val1488_1953)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 461 */
      return
	 sfun_iinfo_class_set__53_integrate_info(
	 (sfun_bglt) (obj_1952), val1488_1953);
   }
}



/* sfun/iinfo-class */
obj_t 
sfun_iinfo_class_146_integrate_info(sfun_bglt obj_78)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 461 */
      return
	 (((sfun_bglt) CREF(obj_78))->class);
   }
}



/* _sfun/iinfo-class1772 */
obj_t 
_sfun_iinfo_class1772_27_integrate_info(obj_t env_1954, obj_t obj_1955)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 461 */
      return
	 sfun_iinfo_class_146_integrate_info(
	 (sfun_bglt) (obj_1955));
   }
}



/* sfun/iinfo-dsssl-keywords-set! */
obj_t 
sfun_iinfo_dsssl_keywords_set__223_integrate_info(sfun_bglt obj_79, obj_t val1489_80)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 467 */
      return
	 ((((sfun_bglt) CREF(obj_79))->dsssl_keywords_243) = ((obj_t) val1489_80), BUNSPEC);
   }
}



/* _sfun/iinfo-dsssl-keywords-set!1773 */
obj_t 
_sfun_iinfo_dsssl_keywords_set_1773_56_integrate_info(obj_t env_1956, obj_t obj_1957, obj_t val1489_1958)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 467 */
      return
	 sfun_iinfo_dsssl_keywords_set__223_integrate_info(
	 (sfun_bglt) (obj_1957), val1489_1958);
   }
}



/* sfun/iinfo-dsssl-keywords */
obj_t 
sfun_iinfo_dsssl_keywords_229_integrate_info(sfun_bglt obj_81)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 467 */
      return
	 (((sfun_bglt) CREF(obj_81))->dsssl_keywords_243);
   }
}



/* _sfun/iinfo-dsssl-keywords1774 */
obj_t 
_sfun_iinfo_dsssl_keywords1774_190_integrate_info(obj_t env_1959, obj_t obj_1960)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 467 */
      return
	 sfun_iinfo_dsssl_keywords_229_integrate_info(
	 (sfun_bglt) (obj_1960));
   }
}



/* sfun/iinfo-loc-set! */
obj_t 
sfun_iinfo_loc_set__90_integrate_info(sfun_bglt obj_82, obj_t val1490_83)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 ((((sfun_bglt) CREF(obj_82))->loc) = ((obj_t) val1490_83), BUNSPEC);
   }
}



/* _sfun/iinfo-loc-set!1775 */
obj_t 
_sfun_iinfo_loc_set_1775_113_integrate_info(obj_t env_1961, obj_t obj_1962, obj_t val1490_1963)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 sfun_iinfo_loc_set__90_integrate_info(
	 (sfun_bglt) (obj_1962), val1490_1963);
   }
}



/* sfun/iinfo-loc */
obj_t 
sfun_iinfo_loc_114_integrate_info(sfun_bglt obj_84)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 (((sfun_bglt) CREF(obj_84))->loc);
   }
}



/* _sfun/iinfo-loc1776 */
obj_t 
_sfun_iinfo_loc1776_221_integrate_info(obj_t env_1964, obj_t obj_1965)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 472 */
      return
	 sfun_iinfo_loc_114_integrate_info(
	 (sfun_bglt) (obj_1965));
   }
}



/* sfun/iinfo-owner-set! */
obj_t 
sfun_iinfo_owner_set__183_integrate_info(sfun_iinfo_105_bglt obj_85, obj_t val1491_86)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {
	 obj_t aux_2361;
	 {	/* Integrate/iinfo.scm 40 */
	    object_bglt aux_2362;
	    aux_2362 =
	       (object_bglt) (obj_85);
	    aux_2361 =
	       OBJECT_WIDENING(aux_2362);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2361))->owner) = ((obj_t) val1491_86), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-owner-set!1777 */
obj_t 
_sfun_iinfo_owner_set_1777_159_integrate_info(obj_t env_1966, obj_t obj_1967, obj_t val1491_1968)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      return
	 sfun_iinfo_owner_set__183_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1967), val1491_1968);
   }
}



/* sfun/iinfo-owner */
obj_t 
sfun_iinfo_owner_223_integrate_info(sfun_iinfo_105_bglt obj_87)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {
	 obj_t aux_2368;
	 {	/* Integrate/iinfo.scm 40 */
	    object_bglt aux_2369;
	    aux_2369 =
	       (object_bglt) (obj_87);
	    aux_2368 =
	       OBJECT_WIDENING(aux_2369);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2368))->owner);
      }
   }
}



/* _sfun/iinfo-owner1778 */
obj_t 
_sfun_iinfo_owner1778_254_integrate_info(obj_t env_1969, obj_t obj_1970)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      return
	 sfun_iinfo_owner_223_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1970));
   }
}



/* sfun/iinfo-free-set! */
obj_t 
sfun_iinfo_free_set__172_integrate_info(sfun_iinfo_105_bglt obj_88, obj_t val1492_89)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 44 */
      {
	 obj_t aux_2375;
	 {	/* Integrate/iinfo.scm 44 */
	    object_bglt aux_2376;
	    aux_2376 =
	       (object_bglt) (obj_88);
	    aux_2375 =
	       OBJECT_WIDENING(aux_2376);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2375))->free) = ((obj_t) val1492_89), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-free-set!1779 */
obj_t 
_sfun_iinfo_free_set_1779_175_integrate_info(obj_t env_1971, obj_t obj_1972, obj_t val1492_1973)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 44 */
      return
	 sfun_iinfo_free_set__172_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1972), val1492_1973);
   }
}



/* sfun/iinfo-free */
obj_t 
sfun_iinfo_free_138_integrate_info(sfun_iinfo_105_bglt obj_90)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 44 */
      {
	 obj_t aux_2382;
	 {	/* Integrate/iinfo.scm 44 */
	    object_bglt aux_2383;
	    aux_2383 =
	       (object_bglt) (obj_90);
	    aux_2382 =
	       OBJECT_WIDENING(aux_2383);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2382))->free);
      }
   }
}



/* _sfun/iinfo-free1780 */
obj_t 
_sfun_iinfo_free1780_193_integrate_info(obj_t env_1974, obj_t obj_1975)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 44 */
      return
	 sfun_iinfo_free_138_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1975));
   }
}



/* sfun/iinfo-bound-set! */
obj_t 
sfun_iinfo_bound_set__116_integrate_info(sfun_iinfo_105_bglt obj_91, obj_t val1493_92)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 46 */
      {
	 obj_t aux_2389;
	 {	/* Integrate/iinfo.scm 46 */
	    object_bglt aux_2390;
	    aux_2390 =
	       (object_bglt) (obj_91);
	    aux_2389 =
	       OBJECT_WIDENING(aux_2390);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2389))->bound) = ((obj_t) val1493_92), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-bound-set!1781 */
obj_t 
_sfun_iinfo_bound_set_1781_95_integrate_info(obj_t env_1976, obj_t obj_1977, obj_t val1493_1978)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 46 */
      return
	 sfun_iinfo_bound_set__116_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1977), val1493_1978);
   }
}



/* sfun/iinfo-bound */
obj_t 
sfun_iinfo_bound_208_integrate_info(sfun_iinfo_105_bglt obj_93)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 46 */
      {
	 obj_t aux_2396;
	 {	/* Integrate/iinfo.scm 46 */
	    object_bglt aux_2397;
	    aux_2397 =
	       (object_bglt) (obj_93);
	    aux_2396 =
	       OBJECT_WIDENING(aux_2397);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2396))->bound);
      }
   }
}



/* _sfun/iinfo-bound1782 */
obj_t 
_sfun_iinfo_bound1782_239_integrate_info(obj_t env_1979, obj_t obj_1980)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 46 */
      return
	 sfun_iinfo_bound_208_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1980));
   }
}



/* sfun/iinfo-cfrom-set! */
obj_t 
sfun_iinfo_cfrom_set__158_integrate_info(sfun_iinfo_105_bglt obj_94, obj_t val1494_95)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 48 */
      {
	 obj_t aux_2403;
	 {	/* Integrate/iinfo.scm 48 */
	    object_bglt aux_2404;
	    aux_2404 =
	       (object_bglt) (obj_94);
	    aux_2403 =
	       OBJECT_WIDENING(aux_2404);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2403))->cfrom) = ((obj_t) val1494_95), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-cfrom-set!1783 */
obj_t 
_sfun_iinfo_cfrom_set_1783_61_integrate_info(obj_t env_1981, obj_t obj_1982, obj_t val1494_1983)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 48 */
      return
	 sfun_iinfo_cfrom_set__158_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1982), val1494_1983);
   }
}



/* sfun/iinfo-cfrom */
obj_t 
sfun_iinfo_cfrom_145_integrate_info(sfun_iinfo_105_bglt obj_96)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 48 */
      {
	 obj_t aux_2410;
	 {	/* Integrate/iinfo.scm 48 */
	    object_bglt aux_2411;
	    aux_2411 =
	       (object_bglt) (obj_96);
	    aux_2410 =
	       OBJECT_WIDENING(aux_2411);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2410))->cfrom);
      }
   }
}



/* _sfun/iinfo-cfrom1784 */
obj_t 
_sfun_iinfo_cfrom1784_162_integrate_info(obj_t env_1984, obj_t obj_1985)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 48 */
      return
	 sfun_iinfo_cfrom_145_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1985));
   }
}



/* sfun/iinfo-cto-set! */
obj_t 
sfun_iinfo_cto_set__217_integrate_info(sfun_iinfo_105_bglt obj_97, obj_t val1495_98)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 50 */
      {
	 obj_t aux_2417;
	 {	/* Integrate/iinfo.scm 50 */
	    object_bglt aux_2418;
	    aux_2418 =
	       (object_bglt) (obj_97);
	    aux_2417 =
	       OBJECT_WIDENING(aux_2418);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2417))->cto) = ((obj_t) val1495_98), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-cto-set!1785 */
obj_t 
_sfun_iinfo_cto_set_1785_234_integrate_info(obj_t env_1986, obj_t obj_1987, obj_t val1495_1988)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 50 */
      return
	 sfun_iinfo_cto_set__217_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1987), val1495_1988);
   }
}



/* sfun/iinfo-cto */
obj_t 
sfun_iinfo_cto_152_integrate_info(sfun_iinfo_105_bglt obj_99)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 50 */
      {
	 obj_t aux_2424;
	 {	/* Integrate/iinfo.scm 50 */
	    object_bglt aux_2425;
	    aux_2425 =
	       (object_bglt) (obj_99);
	    aux_2424 =
	       OBJECT_WIDENING(aux_2425);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2424))->cto);
      }
   }
}



/* _sfun/iinfo-cto1786 */
obj_t 
_sfun_iinfo_cto1786_90_integrate_info(obj_t env_1989, obj_t obj_1990)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 50 */
      return
	 sfun_iinfo_cto_152_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1990));
   }
}



/* sfun/iinfo-k-set! */
obj_t 
sfun_iinfo_k_set__165_integrate_info(sfun_iinfo_105_bglt obj_100, obj_t val1496_101)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 52 */
      {
	 obj_t aux_2431;
	 {	/* Integrate/iinfo.scm 52 */
	    object_bglt aux_2432;
	    aux_2432 =
	       (object_bglt) (obj_100);
	    aux_2431 =
	       OBJECT_WIDENING(aux_2432);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2431))->k) = ((obj_t) val1496_101), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-k-set!1787 */
obj_t 
_sfun_iinfo_k_set_1787_255_integrate_info(obj_t env_1991, obj_t obj_1992, obj_t val1496_1993)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 52 */
      return
	 sfun_iinfo_k_set__165_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1992), val1496_1993);
   }
}



/* sfun/iinfo-k */
obj_t 
sfun_iinfo_k_88_integrate_info(sfun_iinfo_105_bglt obj_102)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 52 */
      {
	 obj_t aux_2438;
	 {	/* Integrate/iinfo.scm 52 */
	    object_bglt aux_2439;
	    aux_2439 =
	       (object_bglt) (obj_102);
	    aux_2438 =
	       OBJECT_WIDENING(aux_2439);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2438))->k);
      }
   }
}



/* _sfun/iinfo-k1788 */
obj_t 
_sfun_iinfo_k1788_138_integrate_info(obj_t env_1994, obj_t obj_1995)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 52 */
      return
	 sfun_iinfo_k_88_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1995));
   }
}



/* sfun/iinfo-k*-set! */
obj_t 
sfun_iinfo_k__set__29_integrate_info(sfun_iinfo_105_bglt obj_103, obj_t val1497_104)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 54 */
      {
	 obj_t aux_2445;
	 {	/* Integrate/iinfo.scm 54 */
	    object_bglt aux_2446;
	    aux_2446 =
	       (object_bglt) (obj_103);
	    aux_2445 =
	       OBJECT_WIDENING(aux_2446);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2445))->k__190) = ((obj_t) val1497_104), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-k*-set!1789 */
obj_t 
_sfun_iinfo_k__set_1789_224_integrate_info(obj_t env_1996, obj_t obj_1997, obj_t val1497_1998)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 54 */
      return
	 sfun_iinfo_k__set__29_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_1997), val1497_1998);
   }
}



/* sfun/iinfo-k* */
obj_t 
sfun_iinfo_k__50_integrate_info(sfun_iinfo_105_bglt obj_105)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 54 */
      {
	 obj_t aux_2452;
	 {	/* Integrate/iinfo.scm 54 */
	    object_bglt aux_2453;
	    aux_2453 =
	       (object_bglt) (obj_105);
	    aux_2452 =
	       OBJECT_WIDENING(aux_2453);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2452))->k__190);
      }
   }
}



/* _sfun/iinfo-k*1790 */
obj_t 
_sfun_iinfo_k_1790_250_integrate_info(obj_t env_1999, obj_t obj_2000)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 54 */
      return
	 sfun_iinfo_k__50_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2000));
   }
}



/* sfun/iinfo-u-set! */
obj_t 
sfun_iinfo_u_set__118_integrate_info(sfun_iinfo_105_bglt obj_106, obj_t val1498_107)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 56 */
      {
	 obj_t aux_2459;
	 {	/* Integrate/iinfo.scm 56 */
	    object_bglt aux_2460;
	    aux_2460 =
	       (object_bglt) (obj_106);
	    aux_2459 =
	       OBJECT_WIDENING(aux_2460);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2459))->u) = ((obj_t) val1498_107), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-u-set!1791 */
obj_t 
_sfun_iinfo_u_set_1791_128_integrate_info(obj_t env_2001, obj_t obj_2002, obj_t val1498_2003)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 56 */
      return
	 sfun_iinfo_u_set__118_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2002), val1498_2003);
   }
}



/* sfun/iinfo-u */
obj_t 
sfun_iinfo_u_241_integrate_info(sfun_iinfo_105_bglt obj_108)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 56 */
      {
	 obj_t aux_2466;
	 {	/* Integrate/iinfo.scm 56 */
	    object_bglt aux_2467;
	    aux_2467 =
	       (object_bglt) (obj_108);
	    aux_2466 =
	       OBJECT_WIDENING(aux_2467);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2466))->u);
      }
   }
}



/* _sfun/iinfo-u1792 */
obj_t 
_sfun_iinfo_u1792_203_integrate_info(obj_t env_2004, obj_t obj_2005)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 56 */
      return
	 sfun_iinfo_u_241_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2005));
   }
}



/* sfun/iinfo-cn-set! */
obj_t 
sfun_iinfo_cn_set__18_integrate_info(sfun_iinfo_105_bglt obj_109, obj_t val1499_110)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 58 */
      {
	 obj_t aux_2473;
	 {	/* Integrate/iinfo.scm 58 */
	    object_bglt aux_2474;
	    aux_2474 =
	       (object_bglt) (obj_109);
	    aux_2473 =
	       OBJECT_WIDENING(aux_2474);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2473))->cn) = ((obj_t) val1499_110), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-cn-set!1793 */
obj_t 
_sfun_iinfo_cn_set_1793_135_integrate_info(obj_t env_2006, obj_t obj_2007, obj_t val1499_2008)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 58 */
      return
	 sfun_iinfo_cn_set__18_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2007), val1499_2008);
   }
}



/* sfun/iinfo-cn */
obj_t 
sfun_iinfo_cn_214_integrate_info(sfun_iinfo_105_bglt obj_111)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 58 */
      {
	 obj_t aux_2480;
	 {	/* Integrate/iinfo.scm 58 */
	    object_bglt aux_2481;
	    aux_2481 =
	       (object_bglt) (obj_111);
	    aux_2480 =
	       OBJECT_WIDENING(aux_2481);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2480))->cn);
      }
   }
}



/* _sfun/iinfo-cn1794 */
obj_t 
_sfun_iinfo_cn1794_230_integrate_info(obj_t env_2009, obj_t obj_2010)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 58 */
      return
	 sfun_iinfo_cn_214_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2010));
   }
}



/* sfun/iinfo-ct-set! */
obj_t 
sfun_iinfo_ct_set__108_integrate_info(sfun_iinfo_105_bglt obj_112, obj_t val1500_113)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 60 */
      {
	 obj_t aux_2487;
	 {	/* Integrate/iinfo.scm 60 */
	    object_bglt aux_2488;
	    aux_2488 =
	       (object_bglt) (obj_112);
	    aux_2487 =
	       OBJECT_WIDENING(aux_2488);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2487))->ct) = ((obj_t) val1500_113), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-ct-set!1795 */
obj_t 
_sfun_iinfo_ct_set_1795_9_integrate_info(obj_t env_2011, obj_t obj_2012, obj_t val1500_2013)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 60 */
      return
	 sfun_iinfo_ct_set__108_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2012), val1500_2013);
   }
}



/* sfun/iinfo-ct */
obj_t 
sfun_iinfo_ct_151_integrate_info(sfun_iinfo_105_bglt obj_114)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 60 */
      {
	 obj_t aux_2494;
	 {	/* Integrate/iinfo.scm 60 */
	    object_bglt aux_2495;
	    aux_2495 =
	       (object_bglt) (obj_114);
	    aux_2494 =
	       OBJECT_WIDENING(aux_2495);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2494))->ct);
      }
   }
}



/* _sfun/iinfo-ct1796 */
obj_t 
_sfun_iinfo_ct1796_49_integrate_info(obj_t env_2014, obj_t obj_2015)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 60 */
      return
	 sfun_iinfo_ct_151_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2015));
   }
}



/* sfun/iinfo-kont-set! */
obj_t 
sfun_iinfo_kont_set__215_integrate_info(sfun_iinfo_105_bglt obj_115, obj_t val1501_116)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 62 */
      {
	 obj_t aux_2501;
	 {	/* Integrate/iinfo.scm 62 */
	    object_bglt aux_2502;
	    aux_2502 =
	       (object_bglt) (obj_115);
	    aux_2501 =
	       OBJECT_WIDENING(aux_2502);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2501))->kont) = ((obj_t) val1501_116), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-kont-set!1797 */
obj_t 
_sfun_iinfo_kont_set_1797_10_integrate_info(obj_t env_2016, obj_t obj_2017, obj_t val1501_2018)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 62 */
      return
	 sfun_iinfo_kont_set__215_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2017), val1501_2018);
   }
}



/* sfun/iinfo-kont */
obj_t 
sfun_iinfo_kont_66_integrate_info(sfun_iinfo_105_bglt obj_117)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 62 */
      {
	 obj_t aux_2508;
	 {	/* Integrate/iinfo.scm 62 */
	    object_bglt aux_2509;
	    aux_2509 =
	       (object_bglt) (obj_117);
	    aux_2508 =
	       OBJECT_WIDENING(aux_2509);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2508))->kont);
      }
   }
}



/* _sfun/iinfo-kont1798 */
obj_t 
_sfun_iinfo_kont1798_89_integrate_info(obj_t env_2019, obj_t obj_2020)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 62 */
      return
	 sfun_iinfo_kont_66_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2020));
   }
}



/* sfun/iinfo-g?-set! */
obj_t 
sfun_iinfo_g__set__207_integrate_info(sfun_iinfo_105_bglt obj_118, bool_t val1502_119)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {
	 obj_t aux_2515;
	 {	/* Integrate/iinfo.scm 40 */
	    object_bglt aux_2516;
	    aux_2516 =
	       (object_bglt) (obj_118);
	    aux_2515 =
	       OBJECT_WIDENING(aux_2516);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2515))->g__219) = ((bool_t) val1502_119), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-g?-set!1799 */
obj_t 
_sfun_iinfo_g__set_1799_169_integrate_info(obj_t env_2021, obj_t obj_2022, obj_t val1502_2023)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      return
	 sfun_iinfo_g__set__207_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2022),
	 CBOOL(val1502_2023));
   }
}



/* sfun/iinfo-g? */
bool_t 
sfun_iinfo_g__46_integrate_info(sfun_iinfo_105_bglt obj_120)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {
	 obj_t aux_2523;
	 {	/* Integrate/iinfo.scm 40 */
	    object_bglt aux_2524;
	    aux_2524 =
	       (object_bglt) (obj_120);
	    aux_2523 =
	       OBJECT_WIDENING(aux_2524);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2523))->g__219);
      }
   }
}



/* _sfun/iinfo-g?1800 */
obj_t 
_sfun_iinfo_g_1800_152_integrate_info(obj_t env_2024, obj_t obj_2025)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {		/* Integrate/iinfo.scm 40 */
	 bool_t aux_2528;
	 aux_2528 =
	    sfun_iinfo_g__46_integrate_info(
	    (sfun_iinfo_105_bglt) (obj_2025));
	 return
	    BBOOL(aux_2528);
      }
   }
}



/* sfun/iinfo-l-set! */
obj_t 
sfun_iinfo_l_set__126_integrate_info(sfun_iinfo_105_bglt obj_121, obj_t val1503_122)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 66 */
      {
	 obj_t aux_2532;
	 {	/* Integrate/iinfo.scm 66 */
	    object_bglt aux_2533;
	    aux_2533 =
	       (object_bglt) (obj_121);
	    aux_2532 =
	       OBJECT_WIDENING(aux_2533);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2532))->l) = ((obj_t) val1503_122), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-l-set!1801 */
obj_t 
_sfun_iinfo_l_set_1801_109_integrate_info(obj_t env_2026, obj_t obj_2027, obj_t val1503_2028)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 66 */
      return
	 sfun_iinfo_l_set__126_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2027), val1503_2028);
   }
}



/* sfun/iinfo-l */
obj_t 
sfun_iinfo_l_178_integrate_info(sfun_iinfo_105_bglt obj_123)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 66 */
      {
	 obj_t aux_2539;
	 {	/* Integrate/iinfo.scm 66 */
	    object_bglt aux_2540;
	    aux_2540 =
	       (object_bglt) (obj_123);
	    aux_2539 =
	       OBJECT_WIDENING(aux_2540);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2539))->l);
      }
   }
}



/* _sfun/iinfo-l1802 */
obj_t 
_sfun_iinfo_l1802_76_integrate_info(obj_t env_2029, obj_t obj_2030)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 66 */
      return
	 sfun_iinfo_l_178_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2030));
   }
}



/* sfun/iinfo-led-set! */
obj_t 
sfun_iinfo_led_set__27_integrate_info(sfun_iinfo_105_bglt obj_124, obj_t val1504_125)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 68 */
      {
	 obj_t aux_2546;
	 {	/* Integrate/iinfo.scm 68 */
	    object_bglt aux_2547;
	    aux_2547 =
	       (object_bglt) (obj_124);
	    aux_2546 =
	       OBJECT_WIDENING(aux_2547);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2546))->led) = ((obj_t) val1504_125), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-led-set!1803 */
obj_t 
_sfun_iinfo_led_set_1803_21_integrate_info(obj_t env_2031, obj_t obj_2032, obj_t val1504_2033)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 68 */
      return
	 sfun_iinfo_led_set__27_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2032), val1504_2033);
   }
}



/* sfun/iinfo-led */
obj_t 
sfun_iinfo_led_56_integrate_info(sfun_iinfo_105_bglt obj_126)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 68 */
      {
	 obj_t aux_2553;
	 {	/* Integrate/iinfo.scm 68 */
	    object_bglt aux_2554;
	    aux_2554 =
	       (object_bglt) (obj_126);
	    aux_2553 =
	       OBJECT_WIDENING(aux_2554);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2553))->led);
      }
   }
}



/* _sfun/iinfo-led1804 */
obj_t 
_sfun_iinfo_led1804_201_integrate_info(obj_t env_2034, obj_t obj_2035)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 68 */
      return
	 sfun_iinfo_led_56_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2035));
   }
}



/* sfun/iinfo-istamp-set! */
obj_t 
sfun_iinfo_istamp_set__89_integrate_info(sfun_iinfo_105_bglt obj_127, obj_t val1505_128)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 70 */
      {
	 obj_t aux_2560;
	 {	/* Integrate/iinfo.scm 70 */
	    object_bglt aux_2561;
	    aux_2561 =
	       (object_bglt) (obj_127);
	    aux_2560 =
	       OBJECT_WIDENING(aux_2561);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2560))->istamp) = ((obj_t) val1505_128), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-istamp-set!1805 */
obj_t 
_sfun_iinfo_istamp_set_1805_240_integrate_info(obj_t env_2036, obj_t obj_2037, obj_t val1505_2038)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 70 */
      return
	 sfun_iinfo_istamp_set__89_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2037), val1505_2038);
   }
}



/* sfun/iinfo-istamp */
obj_t 
sfun_iinfo_istamp_147_integrate_info(sfun_iinfo_105_bglt obj_129)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 70 */
      {
	 obj_t aux_2567;
	 {	/* Integrate/iinfo.scm 70 */
	    object_bglt aux_2568;
	    aux_2568 =
	       (object_bglt) (obj_129);
	    aux_2567 =
	       OBJECT_WIDENING(aux_2568);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2567))->istamp);
      }
   }
}



/* _sfun/iinfo-istamp1806 */
obj_t 
_sfun_iinfo_istamp1806_153_integrate_info(obj_t env_2039, obj_t obj_2040)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 70 */
      return
	 sfun_iinfo_istamp_147_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2040));
   }
}



/* sfun/iinfo-global-set! */
obj_t 
sfun_iinfo_global_set__36_integrate_info(sfun_iinfo_105_bglt obj_130, obj_t val1506_131)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 72 */
      {
	 obj_t aux_2574;
	 {	/* Integrate/iinfo.scm 72 */
	    object_bglt aux_2575;
	    aux_2575 =
	       (object_bglt) (obj_130);
	    aux_2574 =
	       OBJECT_WIDENING(aux_2575);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2574))->global) = ((obj_t) val1506_131), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-global-set!1807 */
obj_t 
_sfun_iinfo_global_set_1807_106_integrate_info(obj_t env_2041, obj_t obj_2042, obj_t val1506_2043)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 72 */
      return
	 sfun_iinfo_global_set__36_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2042), val1506_2043);
   }
}



/* sfun/iinfo-global */
obj_t 
sfun_iinfo_global_63_integrate_info(sfun_iinfo_105_bglt obj_132)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 72 */
      {
	 obj_t aux_2581;
	 {	/* Integrate/iinfo.scm 72 */
	    object_bglt aux_2582;
	    aux_2582 =
	       (object_bglt) (obj_132);
	    aux_2581 =
	       OBJECT_WIDENING(aux_2582);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2581))->global);
      }
   }
}



/* _sfun/iinfo-global1808 */
obj_t 
_sfun_iinfo_global1808_127_integrate_info(obj_t env_2044, obj_t obj_2045)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 72 */
      return
	 sfun_iinfo_global_63_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2045));
   }
}



/* sfun/iinfo-kaptured-set! */
obj_t 
sfun_iinfo_kaptured_set__173_integrate_info(sfun_iinfo_105_bglt obj_133, obj_t val1507_134)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 74 */
      {
	 obj_t aux_2588;
	 {	/* Integrate/iinfo.scm 74 */
	    object_bglt aux_2589;
	    aux_2589 =
	       (object_bglt) (obj_133);
	    aux_2588 =
	       OBJECT_WIDENING(aux_2589);
	 }
	 return
	    ((((sfun_iinfo_105_bglt) CREF(aux_2588))->kaptured) = ((obj_t) val1507_134), BUNSPEC);
      }
   }
}



/* _sfun/iinfo-kaptured-set!1809 */
obj_t 
_sfun_iinfo_kaptured_set_1809_191_integrate_info(obj_t env_2046, obj_t obj_2047, obj_t val1507_2048)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 74 */
      return
	 sfun_iinfo_kaptured_set__173_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2047), val1507_2048);
   }
}



/* sfun/iinfo-kaptured */
obj_t 
sfun_iinfo_kaptured_239_integrate_info(sfun_iinfo_105_bglt obj_135)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 74 */
      {
	 obj_t aux_2595;
	 {	/* Integrate/iinfo.scm 74 */
	    object_bglt aux_2596;
	    aux_2596 =
	       (object_bglt) (obj_135);
	    aux_2595 =
	       OBJECT_WIDENING(aux_2596);
	 }
	 return
	    (((sfun_iinfo_105_bglt) CREF(aux_2595))->kaptured);
      }
   }
}



/* _sfun/iinfo-kaptured1810 */
obj_t 
_sfun_iinfo_kaptured1810_108_integrate_info(obj_t env_2049, obj_t obj_2050)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 74 */
      return
	 sfun_iinfo_kaptured_239_integrate_info(
	 (sfun_iinfo_105_bglt) (obj_2050));
   }
}



/* allocate-sexit/iinfo */
sexit_bglt 
allocate_sexit_iinfo_139_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 sexit_bglt new1473_933;
	 new1473_933 =
	    ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	 {	/* Integrate/iinfo.scm 30 */
	    long arg1572_934;
	    arg1572_934 =
	       class_num_218___object(sexit_iinfo_190_integrate_info);
	    {	/* Integrate/iinfo.scm 30 */
	       obj_t obj_1504;
	       obj_1504 =
		  (obj_t) (new1473_933);
	       (((obj_t) CREF(obj_1504))->header = MAKE_HEADER(arg1572_934, 0), BUNSPEC);
	    }
	 }
	 {	/* Integrate/iinfo.scm 30 */
	    object_bglt aux_2606;
	    aux_2606 =
	       (object_bglt) (new1473_933);
	    OBJECT_WIDENING_SET(aux_2606, BFALSE);
	 }
	 return new1473_933;
      }
   }
}



/* _allocate-sexit/iinfo */
obj_t 
_allocate_sexit_iinfo_189_integrate_info(obj_t env_1857)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 sexit_bglt aux_2609;
	 aux_2609 =
	    allocate_sexit_iinfo_139_integrate_info();
	 return
	    (obj_t) (aux_2609);
      }
   }
}



/* sexit/iinfo? */
bool_t 
sexit_iinfo__64_integrate_info(obj_t obj_139)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      return
	 is_a__118___object(obj_139, sexit_iinfo_190_integrate_info);
   }
}



/* _sexit/iinfo? */
obj_t 
_sexit_iinfo__65_integrate_info(obj_t env_2051, obj_t obj_2052)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 bool_t aux_2613;
	 aux_2613 =
	    sexit_iinfo__64_integrate_info(obj_2052);
	 return
	    BBOOL(aux_2613);
      }
   }
}



/* widening-sexit/iinfo */
sexit_iinfo_190_bglt 
widening_sexit_iinfo_204_integrate_info(obj_t f_mark_181_140, obj_t u_mark_209_141, bool_t kaptured__204_142, bool_t celled__113_143)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 sexit_iinfo_190_bglt new1465_1506;
	 new1465_1506 =
	    ((sexit_iinfo_190_bglt) BREF(GC_MALLOC(sizeof(struct sexit_iinfo_190))));
	 ((((sexit_iinfo_190_bglt) CREF(new1465_1506))->f_mark_181) = ((obj_t) f_mark_181_140), BUNSPEC);
	 ((((sexit_iinfo_190_bglt) CREF(new1465_1506))->u_mark_209) = ((obj_t) u_mark_209_141), BUNSPEC);
	 ((((sexit_iinfo_190_bglt) CREF(new1465_1506))->kaptured__204) = ((bool_t) kaptured__204_142), BUNSPEC);
	 ((((sexit_iinfo_190_bglt) CREF(new1465_1506))->celled__113) = ((bool_t) celled__113_143), BUNSPEC);
	 return new1465_1506;
      }
   }
}



/* _widening-sexit/iinfo */
obj_t 
_widening_sexit_iinfo_132_integrate_info(obj_t env_2053, obj_t f_mark_181_2054, obj_t u_mark_209_2055, obj_t kaptured__204_2056, obj_t celled__113_2057)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 sexit_iinfo_190_bglt aux_2621;
	 aux_2621 =
	    widening_sexit_iinfo_204_integrate_info(f_mark_181_2054, u_mark_209_2055,
	    CBOOL(kaptured__204_2056),
	    CBOOL(celled__113_2057));
	 return
	    (obj_t) (aux_2621);
      }
   }
}



/* make-sexit/iinfo */
sexit_iinfo_190_bglt 
make_sexit_iinfo_29_integrate_info(obj_t handler_144, bool_t detached__120_145, obj_t f_mark_181_146, obj_t u_mark_209_147, bool_t kaptured__204_148, bool_t celled__113_149)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 sexit_bglt aux1471_1511;
	 {	/* Integrate/iinfo.scm 30 */
	    sexit_bglt res1746_1523;
	    {	/* ./Ast/var.scm 502 */
	       sexit_bglt new1179_1517;
	       new1179_1517 =
		  ((sexit_bglt) BREF(GC_MALLOC(sizeof(struct sexit))));
	       {	/* ./Ast/var.scm 502 */
		  long arg1627_1518;
		  arg1627_1518 =
		     class_num_218___object(sexit_ast_var);
		  {	/* ./Ast/var.scm 502 */
		     obj_t obj_1521;
		     obj_1521 =
			(obj_t) (new1179_1517);
		     (((obj_t) CREF(obj_1521))->header = MAKE_HEADER(arg1627_1518, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 502 */
		  object_bglt aux_2630;
		  aux_2630 =
		     (object_bglt) (new1179_1517);
		  OBJECT_WIDENING_SET(aux_2630, BFALSE);
	       }
	       ((((sexit_bglt) CREF(new1179_1517))->handler) = ((obj_t) handler_144), BUNSPEC);
	       ((((sexit_bglt) CREF(new1179_1517))->detached__120) = ((bool_t) detached__120_145), BUNSPEC);
	       res1746_1523 = new1179_1517;
	    }
	    aux1471_1511 = res1746_1523;
	 }
	 {	/* Integrate/iinfo.scm 30 */
	    sexit_iinfo_190_bglt new1472_1512;
	    new1472_1512 =
	       ((sexit_iinfo_190_bglt) (aux1471_1511));
	    {	/* Integrate/iinfo.scm 30 */
	       long arg1573_1513;
	       arg1573_1513 =
		  class_num_218___object(sexit_iinfo_190_integrate_info);
	       {	/* Integrate/iinfo.scm 30 */
		  obj_t obj_1524;
		  obj_1524 =
		     (obj_t) (new1472_1512);
		  (((obj_t) CREF(obj_1524))->header = MAKE_HEADER(arg1573_1513, 0), BUNSPEC);
	       }
	    }
	    {	/* Integrate/iinfo.scm 30 */
	       sexit_iinfo_190_bglt arg1576_1514;
	       {	/* Integrate/iinfo.scm 30 */
		  sexit_iinfo_190_bglt res1747_1535;
		  {	/* Integrate/iinfo.scm 30 */
		     sexit_iinfo_190_bglt new1465_1530;
		     new1465_1530 =
			((sexit_iinfo_190_bglt) BREF(GC_MALLOC(sizeof(struct sexit_iinfo_190))));
		     ((((sexit_iinfo_190_bglt) CREF(new1465_1530))->f_mark_181) = ((obj_t) f_mark_181_146), BUNSPEC);
		     ((((sexit_iinfo_190_bglt) CREF(new1465_1530))->u_mark_209) = ((obj_t) u_mark_209_147), BUNSPEC);
		     ((((sexit_iinfo_190_bglt) CREF(new1465_1530))->kaptured__204) = ((bool_t) kaptured__204_148), BUNSPEC);
		     ((((sexit_iinfo_190_bglt) CREF(new1465_1530))->celled__113) = ((bool_t) celled__113_149), BUNSPEC);
		     res1747_1535 = new1465_1530;
		  }
		  arg1576_1514 = res1747_1535;
	       }
	       {	/* Integrate/iinfo.scm 30 */
		  obj_t aux_2646;
		  object_bglt aux_2644;
		  aux_2646 =
		     (obj_t) (arg1576_1514);
		  aux_2644 =
		     (object_bglt) (new1472_1512);
		  OBJECT_WIDENING_SET(aux_2644, aux_2646);
	       }
	    }
	    return new1472_1512;
	 }
      }
   }
}



/* _make-sexit/iinfo */
obj_t 
_make_sexit_iinfo_46_integrate_info(obj_t env_2058, obj_t handler_2059, obj_t detached__120_2060, obj_t f_mark_181_2061, obj_t u_mark_209_2062, obj_t kaptured__204_2063, obj_t celled__113_2064)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {		/* Integrate/iinfo.scm 30 */
	 sexit_iinfo_190_bglt aux_2649;
	 aux_2649 =
	    make_sexit_iinfo_29_integrate_info(handler_2059,
	    CBOOL(detached__120_2060), f_mark_181_2061, u_mark_209_2062,
	    CBOOL(kaptured__204_2063),
	    CBOOL(celled__113_2064));
	 return
	    (obj_t) (aux_2649);
      }
   }
}



/* sexit/iinfo-handler-set! */
obj_t 
sexit_iinfo_handler_set__83_integrate_info(sexit_bglt obj_150, obj_t val1459_151)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      return
	 ((((sexit_bglt) CREF(obj_150))->handler) = ((obj_t) val1459_151), BUNSPEC);
   }
}



/* _sexit/iinfo-handler-set!1811 */
obj_t 
_sexit_iinfo_handler_set_1811_71_integrate_info(obj_t env_2065, obj_t obj_2066, obj_t val1459_2067)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      return
	 sexit_iinfo_handler_set__83_integrate_info(
	 (sexit_bglt) (obj_2066), val1459_2067);
   }
}



/* sexit/iinfo-handler */
obj_t 
sexit_iinfo_handler_249_integrate_info(sexit_bglt obj_152)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      return
	 (((sexit_bglt) CREF(obj_152))->handler);
   }
}



/* _sexit/iinfo-handler1812 */
obj_t 
_sexit_iinfo_handler1812_235_integrate_info(obj_t env_2068, obj_t obj_2069)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      return
	 sexit_iinfo_handler_249_integrate_info(
	 (sexit_bglt) (obj_2069));
   }
}



/* sexit/iinfo-detached?-set! */
obj_t 
sexit_iinfo_detached__set__74_integrate_info(sexit_bglt obj_153, bool_t val1460_154)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 ((((sexit_bglt) CREF(obj_153))->detached__120) = ((bool_t) val1460_154), BUNSPEC);
   }
}



/* _sexit/iinfo-detached?-set!1813 */
obj_t 
_sexit_iinfo_detached__set_1813_152_integrate_info(obj_t env_2070, obj_t obj_2071, obj_t val1460_2072)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 sexit_iinfo_detached__set__74_integrate_info(
	 (sexit_bglt) (obj_2071),
	 CBOOL(val1460_2072));
   }
}



/* sexit/iinfo-detached? */
bool_t 
sexit_iinfo_detached__106_integrate_info(sexit_bglt obj_155)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      return
	 (((sexit_bglt) CREF(obj_155))->detached__120);
   }
}



/* _sexit/iinfo-detached?1814 */
obj_t 
_sexit_iinfo_detached_1814_207_integrate_info(obj_t env_2073, obj_t obj_2074)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 506 */
      {		/* ./Ast/var.scm 506 */
	 bool_t aux_2666;
	 aux_2666 =
	    sexit_iinfo_detached__106_integrate_info(
	    (sexit_bglt) (obj_2074));
	 return
	    BBOOL(aux_2666);
      }
   }
}



/* sexit/iinfo-f-mark-set! */
obj_t 
sexit_iinfo_f_mark_set__25_integrate_info(sexit_iinfo_190_bglt obj_156, obj_t val1461_157)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 32 */
      {
	 obj_t aux_2670;
	 {	/* Integrate/iinfo.scm 32 */
	    object_bglt aux_2671;
	    aux_2671 =
	       (object_bglt) (obj_156);
	    aux_2670 =
	       OBJECT_WIDENING(aux_2671);
	 }
	 return
	    ((((sexit_iinfo_190_bglt) CREF(aux_2670))->f_mark_181) = ((obj_t) val1461_157), BUNSPEC);
      }
   }
}



/* _sexit/iinfo-f-mark-set!1815 */
obj_t 
_sexit_iinfo_f_mark_set_1815_153_integrate_info(obj_t env_2075, obj_t obj_2076, obj_t val1461_2077)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 32 */
      return
	 sexit_iinfo_f_mark_set__25_integrate_info(
	 (sexit_iinfo_190_bglt) (obj_2076), val1461_2077);
   }
}



/* sexit/iinfo-f-mark */
obj_t 
sexit_iinfo_f_mark_103_integrate_info(sexit_iinfo_190_bglt obj_158)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 32 */
      {
	 obj_t aux_2677;
	 {	/* Integrate/iinfo.scm 32 */
	    object_bglt aux_2678;
	    aux_2678 =
	       (object_bglt) (obj_158);
	    aux_2677 =
	       OBJECT_WIDENING(aux_2678);
	 }
	 return
	    (((sexit_iinfo_190_bglt) CREF(aux_2677))->f_mark_181);
      }
   }
}



/* _sexit/iinfo-f-mark1816 */
obj_t 
_sexit_iinfo_f_mark1816_102_integrate_info(obj_t env_2078, obj_t obj_2079)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 32 */
      return
	 sexit_iinfo_f_mark_103_integrate_info(
	 (sexit_iinfo_190_bglt) (obj_2079));
   }
}



/* sexit/iinfo-u-mark-set! */
obj_t 
sexit_iinfo_u_mark_set__37_integrate_info(sexit_iinfo_190_bglt obj_159, obj_t val1462_160)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 34 */
      {
	 obj_t aux_2684;
	 {	/* Integrate/iinfo.scm 34 */
	    object_bglt aux_2685;
	    aux_2685 =
	       (object_bglt) (obj_159);
	    aux_2684 =
	       OBJECT_WIDENING(aux_2685);
	 }
	 return
	    ((((sexit_iinfo_190_bglt) CREF(aux_2684))->u_mark_209) = ((obj_t) val1462_160), BUNSPEC);
      }
   }
}



/* _sexit/iinfo-u-mark-set!1817 */
obj_t 
_sexit_iinfo_u_mark_set_1817_145_integrate_info(obj_t env_2080, obj_t obj_2081, obj_t val1462_2082)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 34 */
      return
	 sexit_iinfo_u_mark_set__37_integrate_info(
	 (sexit_iinfo_190_bglt) (obj_2081), val1462_2082);
   }
}



/* sexit/iinfo-u-mark */
obj_t 
sexit_iinfo_u_mark_184_integrate_info(sexit_iinfo_190_bglt obj_161)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 34 */
      {
	 obj_t aux_2691;
	 {	/* Integrate/iinfo.scm 34 */
	    object_bglt aux_2692;
	    aux_2692 =
	       (object_bglt) (obj_161);
	    aux_2691 =
	       OBJECT_WIDENING(aux_2692);
	 }
	 return
	    (((sexit_iinfo_190_bglt) CREF(aux_2691))->u_mark_209);
      }
   }
}



/* _sexit/iinfo-u-mark1818 */
obj_t 
_sexit_iinfo_u_mark1818_87_integrate_info(obj_t env_2083, obj_t obj_2084)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 34 */
      return
	 sexit_iinfo_u_mark_184_integrate_info(
	 (sexit_iinfo_190_bglt) (obj_2084));
   }
}



/* sexit/iinfo-kaptured?-set! */
obj_t 
sexit_iinfo_kaptured__set__138_integrate_info(sexit_iinfo_190_bglt obj_162, bool_t val1463_163)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 36 */
      {
	 obj_t aux_2698;
	 {	/* Integrate/iinfo.scm 36 */
	    object_bglt aux_2699;
	    aux_2699 =
	       (object_bglt) (obj_162);
	    aux_2698 =
	       OBJECT_WIDENING(aux_2699);
	 }
	 return
	    ((((sexit_iinfo_190_bglt) CREF(aux_2698))->kaptured__204) = ((bool_t) val1463_163), BUNSPEC);
      }
   }
}



/* _sexit/iinfo-kaptured?-set!1819 */
obj_t 
_sexit_iinfo_kaptured__set_1819_139_integrate_info(obj_t env_2085, obj_t obj_2086, obj_t val1463_2087)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 36 */
      return
	 sexit_iinfo_kaptured__set__138_integrate_info(
	 (sexit_iinfo_190_bglt) (obj_2086),
	 CBOOL(val1463_2087));
   }
}



/* sexit/iinfo-kaptured? */
bool_t 
sexit_iinfo_kaptured__6_integrate_info(sexit_iinfo_190_bglt obj_164)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 36 */
      {
	 obj_t aux_2706;
	 {	/* Integrate/iinfo.scm 36 */
	    object_bglt aux_2707;
	    aux_2707 =
	       (object_bglt) (obj_164);
	    aux_2706 =
	       OBJECT_WIDENING(aux_2707);
	 }
	 return
	    (((sexit_iinfo_190_bglt) CREF(aux_2706))->kaptured__204);
      }
   }
}



/* _sexit/iinfo-kaptured?1820 */
obj_t 
_sexit_iinfo_kaptured_1820_129_integrate_info(obj_t env_2088, obj_t obj_2089)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 36 */
      {		/* Integrate/iinfo.scm 36 */
	 bool_t aux_2711;
	 aux_2711 =
	    sexit_iinfo_kaptured__6_integrate_info(
	    (sexit_iinfo_190_bglt) (obj_2089));
	 return
	    BBOOL(aux_2711);
      }
   }
}



/* sexit/iinfo-celled?-set! */
obj_t 
sexit_iinfo_celled__set__58_integrate_info(sexit_iinfo_190_bglt obj_165, bool_t val1464_166)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 38 */
      {
	 obj_t aux_2715;
	 {	/* Integrate/iinfo.scm 38 */
	    object_bglt aux_2716;
	    aux_2716 =
	       (object_bglt) (obj_165);
	    aux_2715 =
	       OBJECT_WIDENING(aux_2716);
	 }
	 return
	    ((((sexit_iinfo_190_bglt) CREF(aux_2715))->celled__113) = ((bool_t) val1464_166), BUNSPEC);
      }
   }
}



/* _sexit/iinfo-celled?-set!1821 */
obj_t 
_sexit_iinfo_celled__set_1821_22_integrate_info(obj_t env_2090, obj_t obj_2091, obj_t val1464_2092)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 38 */
      return
	 sexit_iinfo_celled__set__58_integrate_info(
	 (sexit_iinfo_190_bglt) (obj_2091),
	 CBOOL(val1464_2092));
   }
}



/* sexit/iinfo-celled? */
bool_t 
sexit_iinfo_celled__92_integrate_info(sexit_iinfo_190_bglt obj_167)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 38 */
      {
	 obj_t aux_2723;
	 {	/* Integrate/iinfo.scm 38 */
	    object_bglt aux_2724;
	    aux_2724 =
	       (object_bglt) (obj_167);
	    aux_2723 =
	       OBJECT_WIDENING(aux_2724);
	 }
	 return
	    (((sexit_iinfo_190_bglt) CREF(aux_2723))->celled__113);
      }
   }
}



/* _sexit/iinfo-celled?1822 */
obj_t 
_sexit_iinfo_celled_1822_106_integrate_info(obj_t env_2093, obj_t obj_2094)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 38 */
      {		/* Integrate/iinfo.scm 38 */
	 bool_t aux_2728;
	 aux_2728 =
	    sexit_iinfo_celled__92_integrate_info(
	    (sexit_iinfo_190_bglt) (obj_2094));
	 return
	    BBOOL(aux_2728);
      }
   }
}



/* allocate-svar/iinfo */
svar_bglt 
allocate_svar_iinfo_15_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 svar_bglt new1450_944;
	 new1450_944 =
	    ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	 {	/* Integrate/iinfo.scm 20 */
	    long arg1577_945;
	    arg1577_945 =
	       class_num_218___object(svar_iinfo_76_integrate_info);
	    {	/* Integrate/iinfo.scm 20 */
	       obj_t obj_1536;
	       obj_1536 =
		  (obj_t) (new1450_944);
	       (((obj_t) CREF(obj_1536))->header = MAKE_HEADER(arg1577_945, 0), BUNSPEC);
	    }
	 }
	 {	/* Integrate/iinfo.scm 20 */
	    object_bglt aux_2736;
	    aux_2736 =
	       (object_bglt) (new1450_944);
	    OBJECT_WIDENING_SET(aux_2736, BFALSE);
	 }
	 return new1450_944;
      }
   }
}



/* _allocate-svar/iinfo */
obj_t 
_allocate_svar_iinfo_246_integrate_info(obj_t env_1856)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 svar_bglt aux_2739;
	 aux_2739 =
	    allocate_svar_iinfo_15_integrate_info();
	 return
	    (obj_t) (aux_2739);
      }
   }
}



/* svar/iinfo? */
bool_t 
svar_iinfo__34_integrate_info(obj_t obj_171)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      return
	 is_a__118___object(obj_171, svar_iinfo_76_integrate_info);
   }
}



/* _svar/iinfo? */
obj_t 
_svar_iinfo__104_integrate_info(obj_t env_2095, obj_t obj_2096)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 bool_t aux_2743;
	 aux_2743 =
	    svar_iinfo__34_integrate_info(obj_2096);
	 return
	    BBOOL(aux_2743);
      }
   }
}



/* widening-svar/iinfo */
svar_iinfo_76_bglt 
widening_svar_iinfo_47_integrate_info(obj_t f_mark_181_172, obj_t u_mark_209_173, bool_t kaptured__204_174, bool_t celled__113_175)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 svar_iinfo_76_bglt new1442_1538;
	 new1442_1538 =
	    ((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
	 ((((svar_iinfo_76_bglt) CREF(new1442_1538))->f_mark_181) = ((obj_t) f_mark_181_172), BUNSPEC);
	 ((((svar_iinfo_76_bglt) CREF(new1442_1538))->u_mark_209) = ((obj_t) u_mark_209_173), BUNSPEC);
	 ((((svar_iinfo_76_bglt) CREF(new1442_1538))->kaptured__204) = ((bool_t) kaptured__204_174), BUNSPEC);
	 ((((svar_iinfo_76_bglt) CREF(new1442_1538))->celled__113) = ((bool_t) celled__113_175), BUNSPEC);
	 return new1442_1538;
      }
   }
}



/* _widening-svar/iinfo */
obj_t 
_widening_svar_iinfo_62_integrate_info(obj_t env_2097, obj_t f_mark_181_2098, obj_t u_mark_209_2099, obj_t kaptured__204_2100, obj_t celled__113_2101)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 svar_iinfo_76_bglt aux_2751;
	 aux_2751 =
	    widening_svar_iinfo_47_integrate_info(f_mark_181_2098, u_mark_209_2099,
	    CBOOL(kaptured__204_2100),
	    CBOOL(celled__113_2101));
	 return
	    (obj_t) (aux_2751);
      }
   }
}



/* make-svar/iinfo */
svar_iinfo_76_bglt 
make_svar_iinfo_142_integrate_info(obj_t loc_176, obj_t f_mark_181_177, obj_t u_mark_209_178, bool_t kaptured__204_179, bool_t celled__113_180)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 svar_bglt aux1448_1543;
	 {	/* Integrate/iinfo.scm 20 */
	    svar_bglt res1748_1553;
	    {	/* ./Ast/var.scm 482 */
	       svar_bglt new1161_1548;
	       new1161_1548 =
		  ((svar_bglt) BREF(GC_MALLOC(sizeof(struct svar))));
	       {	/* ./Ast/var.scm 482 */
		  long arg1633_1549;
		  arg1633_1549 =
		     class_num_218___object(svar_ast_var);
		  {	/* ./Ast/var.scm 482 */
		     obj_t obj_1551;
		     obj_1551 =
			(obj_t) (new1161_1548);
		     (((obj_t) CREF(obj_1551))->header = MAKE_HEADER(arg1633_1549, 0), BUNSPEC);
		  }
	       }
	       {	/* ./Ast/var.scm 482 */
		  object_bglt aux_2760;
		  aux_2760 =
		     (object_bglt) (new1161_1548);
		  OBJECT_WIDENING_SET(aux_2760, BFALSE);
	       }
	       ((((svar_bglt) CREF(new1161_1548))->loc) = ((obj_t) loc_176), BUNSPEC);
	       res1748_1553 = new1161_1548;
	    }
	    aux1448_1543 = res1748_1553;
	 }
	 {	/* Integrate/iinfo.scm 20 */
	    svar_iinfo_76_bglt new1449_1544;
	    new1449_1544 =
	       ((svar_iinfo_76_bglt) (aux1448_1543));
	    {	/* Integrate/iinfo.scm 20 */
	       long arg1578_1545;
	       arg1578_1545 =
		  class_num_218___object(svar_iinfo_76_integrate_info);
	       {	/* Integrate/iinfo.scm 20 */
		  obj_t obj_1554;
		  obj_1554 =
		     (obj_t) (new1449_1544);
		  (((obj_t) CREF(obj_1554))->header = MAKE_HEADER(arg1578_1545, 0), BUNSPEC);
	       }
	    }
	    {	/* Integrate/iinfo.scm 20 */
	       svar_iinfo_76_bglt arg1579_1546;
	       {	/* Integrate/iinfo.scm 20 */
		  svar_iinfo_76_bglt res1749_1565;
		  {	/* Integrate/iinfo.scm 20 */
		     svar_iinfo_76_bglt new1442_1560;
		     new1442_1560 =
			((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
		     ((((svar_iinfo_76_bglt) CREF(new1442_1560))->f_mark_181) = ((obj_t) f_mark_181_177), BUNSPEC);
		     ((((svar_iinfo_76_bglt) CREF(new1442_1560))->u_mark_209) = ((obj_t) u_mark_209_178), BUNSPEC);
		     ((((svar_iinfo_76_bglt) CREF(new1442_1560))->kaptured__204) = ((bool_t) kaptured__204_179), BUNSPEC);
		     ((((svar_iinfo_76_bglt) CREF(new1442_1560))->celled__113) = ((bool_t) celled__113_180), BUNSPEC);
		     res1749_1565 = new1442_1560;
		  }
		  arg1579_1546 = res1749_1565;
	       }
	       {	/* Integrate/iinfo.scm 20 */
		  obj_t aux_2775;
		  object_bglt aux_2773;
		  aux_2775 =
		     (obj_t) (arg1579_1546);
		  aux_2773 =
		     (object_bglt) (new1449_1544);
		  OBJECT_WIDENING_SET(aux_2773, aux_2775);
	       }
	    }
	    return new1449_1544;
	 }
      }
   }
}



/* _make-svar/iinfo */
obj_t 
_make_svar_iinfo_96_integrate_info(obj_t env_2102, obj_t loc_2103, obj_t f_mark_181_2104, obj_t u_mark_209_2105, obj_t kaptured__204_2106, obj_t celled__113_2107)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {		/* Integrate/iinfo.scm 20 */
	 svar_iinfo_76_bglt aux_2778;
	 aux_2778 =
	    make_svar_iinfo_142_integrate_info(loc_2103, f_mark_181_2104, u_mark_209_2105,
	    CBOOL(kaptured__204_2106),
	    CBOOL(celled__113_2107));
	 return
	    (obj_t) (aux_2778);
      }
   }
}



/* svar/iinfo-loc-set! */
obj_t 
svar_iinfo_loc_set__64_integrate_info(svar_bglt obj_181, obj_t val1437_182)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 ((((svar_bglt) CREF(obj_181))->loc) = ((obj_t) val1437_182), BUNSPEC);
   }
}



/* _svar/iinfo-loc-set!1823 */
obj_t 
_svar_iinfo_loc_set_1823_139_integrate_info(obj_t env_2108, obj_t obj_2109, obj_t val1437_2110)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 svar_iinfo_loc_set__64_integrate_info(
	 (svar_bglt) (obj_2109), val1437_2110);
   }
}



/* svar/iinfo-loc */
obj_t 
svar_iinfo_loc_108_integrate_info(svar_bglt obj_183)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 (((svar_bglt) CREF(obj_183))->loc);
   }
}



/* _svar/iinfo-loc1824 */
obj_t 
_svar_iinfo_loc1824_41_integrate_info(obj_t env_2111, obj_t obj_2112)
{
   AN_OBJECT;
   {	/* ./Ast/var.scm 484 */
      return
	 svar_iinfo_loc_108_integrate_info(
	 (svar_bglt) (obj_2112));
   }
}



/* svar/iinfo-f-mark-set! */
obj_t 
svar_iinfo_f_mark_set__34_integrate_info(svar_iinfo_76_bglt obj_184, obj_t val1438_185)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 22 */
      {
	 obj_t aux_2789;
	 {	/* Integrate/iinfo.scm 22 */
	    object_bglt aux_2790;
	    aux_2790 =
	       (object_bglt) (obj_184);
	    aux_2789 =
	       OBJECT_WIDENING(aux_2790);
	 }
	 return
	    ((((svar_iinfo_76_bglt) CREF(aux_2789))->f_mark_181) = ((obj_t) val1438_185), BUNSPEC);
      }
   }
}



/* _svar/iinfo-f-mark-set!1825 */
obj_t 
_svar_iinfo_f_mark_set_1825_58_integrate_info(obj_t env_2113, obj_t obj_2114, obj_t val1438_2115)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 22 */
      return
	 svar_iinfo_f_mark_set__34_integrate_info(
	 (svar_iinfo_76_bglt) (obj_2114), val1438_2115);
   }
}



/* svar/iinfo-f-mark */
obj_t 
svar_iinfo_f_mark_86_integrate_info(svar_iinfo_76_bglt obj_186)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 22 */
      {
	 obj_t aux_2796;
	 {	/* Integrate/iinfo.scm 22 */
	    object_bglt aux_2797;
	    aux_2797 =
	       (object_bglt) (obj_186);
	    aux_2796 =
	       OBJECT_WIDENING(aux_2797);
	 }
	 return
	    (((svar_iinfo_76_bglt) CREF(aux_2796))->f_mark_181);
      }
   }
}



/* _svar/iinfo-f-mark1826 */
obj_t 
_svar_iinfo_f_mark1826_199_integrate_info(obj_t env_2116, obj_t obj_2117)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 22 */
      return
	 svar_iinfo_f_mark_86_integrate_info(
	 (svar_iinfo_76_bglt) (obj_2117));
   }
}



/* svar/iinfo-u-mark-set! */
obj_t 
svar_iinfo_u_mark_set__220_integrate_info(svar_iinfo_76_bglt obj_187, obj_t val1439_188)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 24 */
      {
	 obj_t aux_2803;
	 {	/* Integrate/iinfo.scm 24 */
	    object_bglt aux_2804;
	    aux_2804 =
	       (object_bglt) (obj_187);
	    aux_2803 =
	       OBJECT_WIDENING(aux_2804);
	 }
	 return
	    ((((svar_iinfo_76_bglt) CREF(aux_2803))->u_mark_209) = ((obj_t) val1439_188), BUNSPEC);
      }
   }
}



/* _svar/iinfo-u-mark-set!1827 */
obj_t 
_svar_iinfo_u_mark_set_1827_74_integrate_info(obj_t env_2118, obj_t obj_2119, obj_t val1439_2120)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 24 */
      return
	 svar_iinfo_u_mark_set__220_integrate_info(
	 (svar_iinfo_76_bglt) (obj_2119), val1439_2120);
   }
}



/* svar/iinfo-u-mark */
obj_t 
svar_iinfo_u_mark_255_integrate_info(svar_iinfo_76_bglt obj_189)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 24 */
      {
	 obj_t aux_2810;
	 {	/* Integrate/iinfo.scm 24 */
	    object_bglt aux_2811;
	    aux_2811 =
	       (object_bglt) (obj_189);
	    aux_2810 =
	       OBJECT_WIDENING(aux_2811);
	 }
	 return
	    (((svar_iinfo_76_bglt) CREF(aux_2810))->u_mark_209);
      }
   }
}



/* _svar/iinfo-u-mark1828 */
obj_t 
_svar_iinfo_u_mark1828_101_integrate_info(obj_t env_2121, obj_t obj_2122)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 24 */
      return
	 svar_iinfo_u_mark_255_integrate_info(
	 (svar_iinfo_76_bglt) (obj_2122));
   }
}



/* svar/iinfo-kaptured?-set! */
obj_t 
svar_iinfo_kaptured__set__147_integrate_info(svar_iinfo_76_bglt obj_190, bool_t val1440_191)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 26 */
      {
	 obj_t aux_2817;
	 {	/* Integrate/iinfo.scm 26 */
	    object_bglt aux_2818;
	    aux_2818 =
	       (object_bglt) (obj_190);
	    aux_2817 =
	       OBJECT_WIDENING(aux_2818);
	 }
	 return
	    ((((svar_iinfo_76_bglt) CREF(aux_2817))->kaptured__204) = ((bool_t) val1440_191), BUNSPEC);
      }
   }
}



/* _svar/iinfo-kaptured?-set!1829 */
obj_t 
_svar_iinfo_kaptured__set_1829_172_integrate_info(obj_t env_2123, obj_t obj_2124, obj_t val1440_2125)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 26 */
      return
	 svar_iinfo_kaptured__set__147_integrate_info(
	 (svar_iinfo_76_bglt) (obj_2124),
	 CBOOL(val1440_2125));
   }
}



/* svar/iinfo-kaptured? */
bool_t 
svar_iinfo_kaptured__141_integrate_info(svar_iinfo_76_bglt obj_192)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 26 */
      {
	 obj_t aux_2825;
	 {	/* Integrate/iinfo.scm 26 */
	    object_bglt aux_2826;
	    aux_2826 =
	       (object_bglt) (obj_192);
	    aux_2825 =
	       OBJECT_WIDENING(aux_2826);
	 }
	 return
	    (((svar_iinfo_76_bglt) CREF(aux_2825))->kaptured__204);
      }
   }
}



/* _svar/iinfo-kaptured?1830 */
obj_t 
_svar_iinfo_kaptured_1830_50_integrate_info(obj_t env_2126, obj_t obj_2127)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 26 */
      {		/* Integrate/iinfo.scm 26 */
	 bool_t aux_2830;
	 aux_2830 =
	    svar_iinfo_kaptured__141_integrate_info(
	    (svar_iinfo_76_bglt) (obj_2127));
	 return
	    BBOOL(aux_2830);
      }
   }
}



/* svar/iinfo-celled?-set! */
obj_t 
svar_iinfo_celled__set__209_integrate_info(svar_iinfo_76_bglt obj_193, bool_t val1441_194)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 28 */
      {
	 obj_t aux_2834;
	 {	/* Integrate/iinfo.scm 28 */
	    object_bglt aux_2835;
	    aux_2835 =
	       (object_bglt) (obj_193);
	    aux_2834 =
	       OBJECT_WIDENING(aux_2835);
	 }
	 return
	    ((((svar_iinfo_76_bglt) CREF(aux_2834))->celled__113) = ((bool_t) val1441_194), BUNSPEC);
      }
   }
}



/* _svar/iinfo-celled?-set!1831 */
obj_t 
_svar_iinfo_celled__set_1831_123_integrate_info(obj_t env_2128, obj_t obj_2129, obj_t val1441_2130)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 28 */
      return
	 svar_iinfo_celled__set__209_integrate_info(
	 (svar_iinfo_76_bglt) (obj_2129),
	 CBOOL(val1441_2130));
   }
}



/* svar/iinfo-celled? */
bool_t 
svar_iinfo_celled__54_integrate_info(svar_iinfo_76_bglt obj_195)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 28 */
      {
	 obj_t aux_2842;
	 {	/* Integrate/iinfo.scm 28 */
	    object_bglt aux_2843;
	    aux_2843 =
	       (object_bglt) (obj_195);
	    aux_2842 =
	       OBJECT_WIDENING(aux_2843);
	 }
	 return
	    (((svar_iinfo_76_bglt) CREF(aux_2842))->celled__113);
      }
   }
}



/* _svar/iinfo-celled?1832 */
obj_t 
_svar_iinfo_celled_1832_54_integrate_info(obj_t env_2131, obj_t obj_2132)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 28 */
      {		/* Integrate/iinfo.scm 28 */
	 bool_t aux_2847;
	 aux_2847 =
	    svar_iinfo_celled__54_integrate_info(
	    (svar_iinfo_76_bglt) (obj_2132));
	 return
	    BBOOL(aux_2847);
      }
   }
}



/* method-init */
obj_t 
method_init_76_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 14 */
      {		/* Integrate/iinfo.scm 14 */
	 obj_t object__struct_sfun_iinfo1541_137_2143;
	 object__struct_sfun_iinfo1541_137_2143 = proc1836_integrate_info;
	 add_method__1___object(object__struct_env_210___object, sfun_iinfo_105_integrate_info, object__struct_sfun_iinfo1541_137_2143);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t struct_object__object_sfun_iinfo1543_95_2142;
	 struct_object__object_sfun_iinfo1543_95_2142 = proc1837_integrate_info;
	 add_method__1___object(struct_object__object_env_209___object, sfun_iinfo_105_integrate_info, struct_object__object_sfun_iinfo1543_95_2142);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t object__struct_sexit_iinfo1545_115_2141;
	 object__struct_sexit_iinfo1545_115_2141 = proc1838_integrate_info;
	 add_method__1___object(object__struct_env_210___object, sexit_iinfo_190_integrate_info, object__struct_sexit_iinfo1545_115_2141);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t struct_object__object_sexit_iinfo1547_91_2140;
	 struct_object__object_sexit_iinfo1547_91_2140 = proc1839_integrate_info;
	 add_method__1___object(struct_object__object_env_209___object, sexit_iinfo_190_integrate_info, struct_object__object_sexit_iinfo1547_91_2140);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t object__struct_svar_iinfo1549_158_2137;
	 object__struct_svar_iinfo1549_158_2137 = proc1840_integrate_info;
	 add_method__1___object(object__struct_env_210___object, svar_iinfo_76_integrate_info, object__struct_svar_iinfo1549_158_2137);
      }
      {		/* Integrate/iinfo.scm 14 */
	 obj_t struct_object__object_svar_iinfo1551_146_2133;
	 struct_object__object_svar_iinfo1551_146_2133 = proc1841_integrate_info;
	 return
	    add_method__1___object(struct_object__object_env_209___object, svar_iinfo_76_integrate_info, struct_object__object_svar_iinfo1551_146_2133);
      }
   }
}



/* struct+object->object-svar/iinfo1551 */
obj_t 
struct_object__object_svar_iinfo1551_146_integrate_info(obj_t env_2144, obj_t o_2145, obj_t s_2146)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {
	 svar_iinfo_76_bglt o_1398;
	 obj_t s_1399;
	 {	/* Integrate/iinfo.scm 20 */
	    svar_iinfo_76_bglt aux_2857;
	    o_1398 =
	       (svar_iinfo_76_bglt) (o_2145);
	    s_1399 = s_2146;
	    {

	       {	/* Integrate/iinfo.scm 20 */
		  obj_t old1456_1402;
		  obj_t aux1457_1403;
		  {	/* Integrate/iinfo.scm 20 */
		     obj_t next_method1550_42_1411;
		     next_method1550_42_1411 =
			find_super_class_method_167___object(
			(object_bglt) (o_1398), struct_object__object_env_209___object, svar_iinfo_76_integrate_info);
		     if (
			PROCEDUREP(next_method1550_42_1411))
		       {	/* Integrate/iinfo.scm 20 */
			  old1456_1402 =
			     PROCEDURE_ENTRY(next_method1550_42_1411) (next_method1550_42_1411,
			     (obj_t) (o_1398), s_1399, BEOA);
		       }
		     else
		       {	/* Integrate/iinfo.scm 20 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1550_42_1411);
			  {	/* Integrate/iinfo.scm 20 */
			     object_bglt aux_2866;
			     aux_2866 =
				struct_object__object_93___object(
				(object_bglt) (o_1398), s_1399);
			     old1456_1402 =
				(obj_t) (aux_2866);
			  }
		       }
		  }
		  aux1457_1403 =
		     STRUCT_REF(s_1399, ((long) 0));
		  {	/* Integrate/iinfo.scm 20 */
		     svar_iinfo_76_bglt new1458_1404;
		     new1458_1404 =
			((svar_iinfo_76_bglt) (old1456_1402));
		     {	/* Integrate/iinfo.scm 20 */
			long arg1736_1405;
			arg1736_1405 =
			   class_num_218___object(svar_iinfo_76_integrate_info);
			{	/* Integrate/iinfo.scm 20 */
			   obj_t obj_1834;
			   obj_1834 =
			      (obj_t) (new1458_1404);
			   (((obj_t) CREF(obj_1834))->header = MAKE_HEADER(arg1736_1405, 0), BUNSPEC);
			}
		     }
		     {	/* Integrate/iinfo.scm 20 */
			svar_iinfo_76_bglt arg1738_1406;
			{	/* Integrate/iinfo.scm 20 */
			   obj_t arg1739_1407;
			   obj_t arg1740_1408;
			   arg1739_1407 =
			      STRUCT_REF(aux1457_1403, ((long) 0));
			   arg1740_1408 =
			      STRUCT_REF(aux1457_1403, ((long) 1));
			   {	/* Integrate/iinfo.scm 20 */
			      svar_iinfo_76_bglt res1752_1853;
			      {		/* Integrate/iinfo.scm 20 */
				 bool_t kaptured__204_1846;
				 bool_t celled__113_1847;
				 {	/* Integrate/iinfo.scm 20 */
				    obj_t aux_2877;
				    aux_2877 =
				       STRUCT_REF(aux1457_1403, ((long) 2));
				    kaptured__204_1846 =
				       CBOOL(aux_2877);
				 }
				 {	/* Integrate/iinfo.scm 20 */
				    obj_t aux_2880;
				    aux_2880 =
				       STRUCT_REF(aux1457_1403, ((long) 3));
				    celled__113_1847 =
				       CBOOL(aux_2880);
				 }
				 {	/* Integrate/iinfo.scm 20 */
				    svar_iinfo_76_bglt new1442_1848;
				    new1442_1848 =
				       ((svar_iinfo_76_bglt) BREF(GC_MALLOC(sizeof(struct svar_iinfo_76))));
				    ((((svar_iinfo_76_bglt) CREF(new1442_1848))->f_mark_181) = ((obj_t) arg1739_1407), BUNSPEC);
				    ((((svar_iinfo_76_bglt) CREF(new1442_1848))->u_mark_209) = ((obj_t) arg1740_1408), BUNSPEC);
				    ((((svar_iinfo_76_bglt) CREF(new1442_1848))->kaptured__204) = ((bool_t) kaptured__204_1846), BUNSPEC);
				    ((((svar_iinfo_76_bglt) CREF(new1442_1848))->celled__113) = ((bool_t) celled__113_1847), BUNSPEC);
				    res1752_1853 = new1442_1848;
				 }
			      }
			      arg1738_1406 = res1752_1853;
			   }
			}
			{	/* Integrate/iinfo.scm 20 */
			   obj_t aux_2890;
			   object_bglt aux_2888;
			   aux_2890 =
			      (obj_t) (arg1738_1406);
			   aux_2888 =
			      (object_bglt) (new1458_1404);
			   OBJECT_WIDENING_SET(aux_2888, aux_2890);
			}
		     }
		     aux_2857 = new1458_1404;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2857);
	 }
      }
   }
}



/* object->struct-svar/iinfo1549 */
obj_t 
object__struct_svar_iinfo1549_158_integrate_info(obj_t env_2147, obj_t obj1453_2148)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 20 */
      {
	 svar_iinfo_76_bglt obj1453_1382;
	 obj1453_1382 =
	    (svar_iinfo_76_bglt) (obj1453_2148);
	 {

	    {	/* Integrate/iinfo.scm 20 */
	       obj_t res1454_1385;
	       {	/* Integrate/iinfo.scm 20 */
		  obj_t next_method1548_240_1396;
		  next_method1548_240_1396 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1453_1382), object__struct_env_210___object, svar_iinfo_76_integrate_info);
		  if (
		     PROCEDUREP(next_method1548_240_1396))
		    {	/* Integrate/iinfo.scm 20 */
		       res1454_1385 =
			  PROCEDURE_ENTRY(next_method1548_240_1396) (next_method1548_240_1396,
			  (obj_t) (obj1453_1382), BEOA);
		    }
		  else
		    {	/* Integrate/iinfo.scm 20 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1548_240_1396);
		       res1454_1385 =
			  object__struct_50___object(
			  (object_bglt) (obj1453_1382));
		    }
	       }
	       {	/* Integrate/iinfo.scm 20 */
		  obj_t aux1455_1386;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2905;
		     aux_2905 =
			CNST_TABLE_REF(((long) 0));
		     aux1455_1386 =
			make_struct(aux_2905, ((long) 4), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2908;
		     {
			obj_t aux_2909;
			{	/* Integrate/iinfo.scm 22 */
			   object_bglt aux_2910;
			   aux_2910 =
			      (object_bglt) (obj1453_1382);
			   aux_2909 =
			      OBJECT_WIDENING(aux_2910);
			}
			aux_2908 =
			   (((svar_iinfo_76_bglt) CREF(aux_2909))->f_mark_181);
		     }
		     STRUCT_SET(aux1455_1386, ((long) 0), aux_2908);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2915;
		     {
			obj_t aux_2916;
			{	/* Integrate/iinfo.scm 24 */
			   object_bglt aux_2917;
			   aux_2917 =
			      (object_bglt) (obj1453_1382);
			   aux_2916 =
			      OBJECT_WIDENING(aux_2917);
			}
			aux_2915 =
			   (((svar_iinfo_76_bglt) CREF(aux_2916))->u_mark_209);
		     }
		     STRUCT_SET(aux1455_1386, ((long) 1), aux_2915);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2922;
		     {	/* Integrate/iinfo.scm 20 */
			bool_t aux_2923;
			{
			   obj_t aux_2924;
			   {	/* Integrate/iinfo.scm 26 */
			      object_bglt aux_2925;
			      aux_2925 =
				 (object_bglt) (obj1453_1382);
			      aux_2924 =
				 OBJECT_WIDENING(aux_2925);
			   }
			   aux_2923 =
			      (((svar_iinfo_76_bglt) CREF(aux_2924))->kaptured__204);
			}
			aux_2922 =
			   BBOOL(aux_2923);
		     }
		     STRUCT_SET(aux1455_1386, ((long) 2), aux_2922);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2931;
		     {	/* Integrate/iinfo.scm 20 */
			bool_t aux_2932;
			{
			   obj_t aux_2933;
			   {	/* Integrate/iinfo.scm 28 */
			      object_bglt aux_2934;
			      aux_2934 =
				 (object_bglt) (obj1453_1382);
			      aux_2933 =
				 OBJECT_WIDENING(aux_2934);
			   }
			   aux_2932 =
			      (((svar_iinfo_76_bglt) CREF(aux_2933))->celled__113);
			}
			aux_2931 =
			   BBOOL(aux_2932);
		     }
		     STRUCT_SET(aux1455_1386, ((long) 3), aux_2931);
		  }
		  STRUCT_SET(res1454_1385, ((long) 0), aux1455_1386);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2941;
		     aux_2941 =
			STRUCT_KEY(res1454_1385);
		     STRUCT_KEY_SET(aux1455_1386, aux_2941);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_2944;
		     aux_2944 =
			CNST_TABLE_REF(((long) 0));
		     STRUCT_KEY_SET(res1454_1385, aux_2944);
		  }
		  return res1454_1385;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sexit/iinfo1547 */
obj_t 
struct_object__object_sexit_iinfo1547_91_integrate_info(obj_t env_2149, obj_t o_2150, obj_t s_2151)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {
	 sexit_iinfo_190_bglt o_1367;
	 obj_t s_1368;
	 {	/* Integrate/iinfo.scm 30 */
	    sexit_iinfo_190_bglt aux_2948;
	    o_1367 =
	       (sexit_iinfo_190_bglt) (o_2150);
	    s_1368 = s_2151;
	    {

	       {	/* Integrate/iinfo.scm 30 */
		  obj_t old1477_1371;
		  obj_t aux1478_1372;
		  {	/* Integrate/iinfo.scm 30 */
		     obj_t next_method1546_155_1380;
		     next_method1546_155_1380 =
			find_super_class_method_167___object(
			(object_bglt) (o_1367), struct_object__object_env_209___object, sexit_iinfo_190_integrate_info);
		     if (
			PROCEDUREP(next_method1546_155_1380))
		       {	/* Integrate/iinfo.scm 30 */
			  old1477_1371 =
			     PROCEDURE_ENTRY(next_method1546_155_1380) (next_method1546_155_1380,
			     (obj_t) (o_1367), s_1368, BEOA);
		       }
		     else
		       {	/* Integrate/iinfo.scm 30 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1546_155_1380);
			  {	/* Integrate/iinfo.scm 30 */
			     object_bglt aux_2957;
			     aux_2957 =
				struct_object__object_93___object(
				(object_bglt) (o_1367), s_1368);
			     old1477_1371 =
				(obj_t) (aux_2957);
			  }
		       }
		  }
		  aux1478_1372 =
		     STRUCT_REF(s_1368, ((long) 0));
		  {	/* Integrate/iinfo.scm 30 */
		     sexit_iinfo_190_bglt new1479_1373;
		     new1479_1373 =
			((sexit_iinfo_190_bglt) (old1477_1371));
		     {	/* Integrate/iinfo.scm 30 */
			long arg1719_1374;
			arg1719_1374 =
			   class_num_218___object(sexit_iinfo_190_integrate_info);
			{	/* Integrate/iinfo.scm 30 */
			   obj_t obj_1781;
			   obj_1781 =
			      (obj_t) (new1479_1373);
			   (((obj_t) CREF(obj_1781))->header = MAKE_HEADER(arg1719_1374, 0), BUNSPEC);
			}
		     }
		     {	/* Integrate/iinfo.scm 30 */
			sexit_iinfo_190_bglt arg1720_1375;
			{	/* Integrate/iinfo.scm 30 */
			   obj_t arg1721_1376;
			   obj_t arg1722_1377;
			   arg1721_1376 =
			      STRUCT_REF(aux1478_1372, ((long) 0));
			   arg1722_1377 =
			      STRUCT_REF(aux1478_1372, ((long) 1));
			   {	/* Integrate/iinfo.scm 30 */
			      sexit_iinfo_190_bglt res1751_1800;
			      {		/* Integrate/iinfo.scm 30 */
				 bool_t kaptured__204_1793;
				 bool_t celled__113_1794;
				 {	/* Integrate/iinfo.scm 30 */
				    obj_t aux_2968;
				    aux_2968 =
				       STRUCT_REF(aux1478_1372, ((long) 2));
				    kaptured__204_1793 =
				       CBOOL(aux_2968);
				 }
				 {	/* Integrate/iinfo.scm 30 */
				    obj_t aux_2971;
				    aux_2971 =
				       STRUCT_REF(aux1478_1372, ((long) 3));
				    celled__113_1794 =
				       CBOOL(aux_2971);
				 }
				 {	/* Integrate/iinfo.scm 30 */
				    sexit_iinfo_190_bglt new1465_1795;
				    new1465_1795 =
				       ((sexit_iinfo_190_bglt) BREF(GC_MALLOC(sizeof(struct sexit_iinfo_190))));
				    ((((sexit_iinfo_190_bglt) CREF(new1465_1795))->f_mark_181) = ((obj_t) arg1721_1376), BUNSPEC);
				    ((((sexit_iinfo_190_bglt) CREF(new1465_1795))->u_mark_209) = ((obj_t) arg1722_1377), BUNSPEC);
				    ((((sexit_iinfo_190_bglt) CREF(new1465_1795))->kaptured__204) = ((bool_t) kaptured__204_1793), BUNSPEC);
				    ((((sexit_iinfo_190_bglt) CREF(new1465_1795))->celled__113) = ((bool_t) celled__113_1794), BUNSPEC);
				    res1751_1800 = new1465_1795;
				 }
			      }
			      arg1720_1375 = res1751_1800;
			   }
			}
			{	/* Integrate/iinfo.scm 30 */
			   obj_t aux_2981;
			   object_bglt aux_2979;
			   aux_2981 =
			      (obj_t) (arg1720_1375);
			   aux_2979 =
			      (object_bglt) (new1479_1373);
			   OBJECT_WIDENING_SET(aux_2979, aux_2981);
			}
		     }
		     aux_2948 = new1479_1373;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_2948);
	 }
      }
   }
}



/* object->struct-sexit/iinfo1545 */
obj_t 
object__struct_sexit_iinfo1545_115_integrate_info(obj_t env_2152, obj_t obj1474_2153)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 30 */
      {
	 sexit_iinfo_190_bglt obj1474_1351;
	 obj1474_1351 =
	    (sexit_iinfo_190_bglt) (obj1474_2153);
	 {

	    {	/* Integrate/iinfo.scm 30 */
	       obj_t res1475_1354;
	       {	/* Integrate/iinfo.scm 30 */
		  obj_t next_method1544_93_1365;
		  next_method1544_93_1365 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1474_1351), object__struct_env_210___object, sexit_iinfo_190_integrate_info);
		  if (
		     PROCEDUREP(next_method1544_93_1365))
		    {	/* Integrate/iinfo.scm 30 */
		       res1475_1354 =
			  PROCEDURE_ENTRY(next_method1544_93_1365) (next_method1544_93_1365,
			  (obj_t) (obj1474_1351), BEOA);
		    }
		  else
		    {	/* Integrate/iinfo.scm 30 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1544_93_1365);
		       res1475_1354 =
			  object__struct_50___object(
			  (object_bglt) (obj1474_1351));
		    }
	       }
	       {	/* Integrate/iinfo.scm 30 */
		  obj_t aux1476_1355;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_2996;
		     aux_2996 =
			CNST_TABLE_REF(((long) 1));
		     aux1476_1355 =
			make_struct(aux_2996, ((long) 4), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_2999;
		     {
			obj_t aux_3000;
			{	/* Integrate/iinfo.scm 32 */
			   object_bglt aux_3001;
			   aux_3001 =
			      (object_bglt) (obj1474_1351);
			   aux_3000 =
			      OBJECT_WIDENING(aux_3001);
			}
			aux_2999 =
			   (((sexit_iinfo_190_bglt) CREF(aux_3000))->f_mark_181);
		     }
		     STRUCT_SET(aux1476_1355, ((long) 0), aux_2999);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3006;
		     {
			obj_t aux_3007;
			{	/* Integrate/iinfo.scm 34 */
			   object_bglt aux_3008;
			   aux_3008 =
			      (object_bglt) (obj1474_1351);
			   aux_3007 =
			      OBJECT_WIDENING(aux_3008);
			}
			aux_3006 =
			   (((sexit_iinfo_190_bglt) CREF(aux_3007))->u_mark_209);
		     }
		     STRUCT_SET(aux1476_1355, ((long) 1), aux_3006);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3013;
		     {	/* Integrate/iinfo.scm 30 */
			bool_t aux_3014;
			{
			   obj_t aux_3015;
			   {	/* Integrate/iinfo.scm 36 */
			      object_bglt aux_3016;
			      aux_3016 =
				 (object_bglt) (obj1474_1351);
			      aux_3015 =
				 OBJECT_WIDENING(aux_3016);
			   }
			   aux_3014 =
			      (((sexit_iinfo_190_bglt) CREF(aux_3015))->kaptured__204);
			}
			aux_3013 =
			   BBOOL(aux_3014);
		     }
		     STRUCT_SET(aux1476_1355, ((long) 2), aux_3013);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3022;
		     {	/* Integrate/iinfo.scm 30 */
			bool_t aux_3023;
			{
			   obj_t aux_3024;
			   {	/* Integrate/iinfo.scm 38 */
			      object_bglt aux_3025;
			      aux_3025 =
				 (object_bglt) (obj1474_1351);
			      aux_3024 =
				 OBJECT_WIDENING(aux_3025);
			   }
			   aux_3023 =
			      (((sexit_iinfo_190_bglt) CREF(aux_3024))->celled__113);
			}
			aux_3022 =
			   BBOOL(aux_3023);
		     }
		     STRUCT_SET(aux1476_1355, ((long) 3), aux_3022);
		  }
		  STRUCT_SET(res1475_1354, ((long) 0), aux1476_1355);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3032;
		     aux_3032 =
			STRUCT_KEY(res1475_1354);
		     STRUCT_KEY_SET(aux1476_1355, aux_3032);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3035;
		     aux_3035 =
			CNST_TABLE_REF(((long) 1));
		     STRUCT_KEY_SET(res1475_1354, aux_3035);
		  }
		  return res1475_1354;
	       }
	    }
	 }
      }
   }
}



/* struct+object->object-sfun/iinfo1543 */
obj_t 
struct_object__object_sfun_iinfo1543_95_integrate_info(obj_t env_2154, obj_t o_2155, obj_t s_2156)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {
	 sfun_iinfo_105_bglt o_1323;
	 obj_t s_1324;
	 {	/* Integrate/iinfo.scm 40 */
	    sfun_iinfo_105_bglt aux_3039;
	    o_1323 =
	       (sfun_iinfo_105_bglt) (o_2155);
	    s_1324 = s_2156;
	    {

	       {	/* Integrate/iinfo.scm 40 */
		  obj_t old1534_1327;
		  obj_t aux1535_1328;
		  {	/* Integrate/iinfo.scm 40 */
		     obj_t next_method1542_3_1349;
		     next_method1542_3_1349 =
			find_super_class_method_167___object(
			(object_bglt) (o_1323), struct_object__object_env_209___object, sfun_iinfo_105_integrate_info);
		     if (
			PROCEDUREP(next_method1542_3_1349))
		       {	/* Integrate/iinfo.scm 40 */
			  old1534_1327 =
			     PROCEDURE_ENTRY(next_method1542_3_1349) (next_method1542_3_1349,
			     (obj_t) (o_1323), s_1324, BEOA);
		       }
		     else
		       {	/* Integrate/iinfo.scm 40 */
			  PROCEDURE_SET(struct_object__object_env_209___object, ((long) 2), next_method1542_3_1349);
			  {	/* Integrate/iinfo.scm 40 */
			     object_bglt aux_3048;
			     aux_3048 =
				struct_object__object_93___object(
				(object_bglt) (o_1323), s_1324);
			     old1534_1327 =
				(obj_t) (aux_3048);
			  }
		       }
		  }
		  aux1535_1328 =
		     STRUCT_REF(s_1324, ((long) 0));
		  {	/* Integrate/iinfo.scm 40 */
		     sfun_iinfo_105_bglt new1536_1329;
		     new1536_1329 =
			((sfun_iinfo_105_bglt) (old1534_1327));
		     {	/* Integrate/iinfo.scm 40 */
			long arg1688_1330;
			arg1688_1330 =
			   class_num_218___object(sfun_iinfo_105_integrate_info);
			{	/* Integrate/iinfo.scm 40 */
			   obj_t obj_1676;
			   obj_1676 =
			      (obj_t) (new1536_1329);
			   (((obj_t) CREF(obj_1676))->header = MAKE_HEADER(arg1688_1330, 0), BUNSPEC);
			}
		     }
		     {	/* Integrate/iinfo.scm 40 */
			sfun_iinfo_105_bglt arg1689_1331;
			{	/* Integrate/iinfo.scm 40 */
			   obj_t arg1690_1332;
			   obj_t arg1691_1333;
			   obj_t arg1692_1334;
			   obj_t arg1693_1335;
			   obj_t arg1694_1336;
			   obj_t arg1695_1337;
			   obj_t arg1696_1338;
			   obj_t arg1697_1339;
			   obj_t arg1698_1340;
			   obj_t arg1699_1341;
			   obj_t arg1700_1342;
			   obj_t arg1702_1344;
			   obj_t arg1703_1345;
			   obj_t arg1704_1346;
			   obj_t arg1705_1347;
			   obj_t arg1706_1348;
			   arg1690_1332 =
			      STRUCT_REF(aux1535_1328, ((long) 0));
			   arg1691_1333 =
			      STRUCT_REF(aux1535_1328, ((long) 1));
			   arg1692_1334 =
			      STRUCT_REF(aux1535_1328, ((long) 2));
			   arg1693_1335 =
			      STRUCT_REF(aux1535_1328, ((long) 3));
			   arg1694_1336 =
			      STRUCT_REF(aux1535_1328, ((long) 4));
			   arg1695_1337 =
			      STRUCT_REF(aux1535_1328, ((long) 5));
			   arg1696_1338 =
			      STRUCT_REF(aux1535_1328, ((long) 6));
			   arg1697_1339 =
			      STRUCT_REF(aux1535_1328, ((long) 7));
			   arg1698_1340 =
			      STRUCT_REF(aux1535_1328, ((long) 8));
			   arg1699_1341 =
			      STRUCT_REF(aux1535_1328, ((long) 9));
			   arg1700_1342 =
			      STRUCT_REF(aux1535_1328, ((long) 10));
			   arg1702_1344 =
			      STRUCT_REF(aux1535_1328, ((long) 12));
			   arg1703_1345 =
			      STRUCT_REF(aux1535_1328, ((long) 13));
			   arg1704_1346 =
			      STRUCT_REF(aux1535_1328, ((long) 14));
			   arg1705_1347 =
			      STRUCT_REF(aux1535_1328, ((long) 15));
			   arg1706_1348 =
			      STRUCT_REF(aux1535_1328, ((long) 16));
			   {	/* Integrate/iinfo.scm 40 */
			      sfun_iinfo_105_bglt res1750_1747;
			      {		/* Integrate/iinfo.scm 40 */
				 bool_t g__219_1723;
				 {	/* Integrate/iinfo.scm 40 */
				    obj_t aux_3073;
				    aux_3073 =
				       STRUCT_REF(aux1535_1328, ((long) 11));
				    g__219_1723 =
				       CBOOL(aux_3073);
				 }
				 {	/* Integrate/iinfo.scm 40 */
				    sfun_iinfo_105_bglt new1508_1729;
				    new1508_1729 =
				       ((sfun_iinfo_105_bglt) BREF(GC_MALLOC(sizeof(struct sfun_iinfo_105))));
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->owner) = ((obj_t) arg1690_1332), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->free) = ((obj_t) arg1691_1333), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->bound) = ((obj_t) arg1692_1334), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->cfrom) = ((obj_t) arg1693_1335), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->cto) = ((obj_t) arg1694_1336), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->k) = ((obj_t) arg1695_1337), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->k__190) = ((obj_t) arg1696_1338), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->u) = ((obj_t) arg1697_1339), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->cn) = ((obj_t) arg1698_1340), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->ct) = ((obj_t) arg1699_1341), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->kont) = ((obj_t) arg1700_1342), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->g__219) = ((bool_t) g__219_1723), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->l) = ((obj_t) arg1702_1344), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->led) = ((obj_t) arg1703_1345), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->istamp) = ((obj_t) arg1704_1346), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->global) = ((obj_t) arg1705_1347), BUNSPEC);
				    ((((sfun_iinfo_105_bglt) CREF(new1508_1729))->kaptured) = ((obj_t) arg1706_1348), BUNSPEC);
				    res1750_1747 = new1508_1729;
				 }
			      }
			      arg1689_1331 = res1750_1747;
			   }
			}
			{	/* Integrate/iinfo.scm 40 */
			   obj_t aux_3096;
			   object_bglt aux_3094;
			   aux_3096 =
			      (obj_t) (arg1689_1331);
			   aux_3094 =
			      (object_bglt) (new1536_1329);
			   OBJECT_WIDENING_SET(aux_3094, aux_3096);
			}
		     }
		     aux_3039 = new1536_1329;
		  }
	       }
	    }
	    return
	       (obj_t) (aux_3039);
	 }
      }
   }
}



/* object->struct-sfun/iinfo1541 */
obj_t 
object__struct_sfun_iinfo1541_137_integrate_info(obj_t env_2157, obj_t obj1531_2158)
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 40 */
      {
	 sfun_iinfo_105_bglt obj1531_1281;
	 obj1531_1281 =
	    (sfun_iinfo_105_bglt) (obj1531_2158);
	 {

	    {	/* Integrate/iinfo.scm 40 */
	       obj_t res1532_1284;
	       {	/* Integrate/iinfo.scm 40 */
		  obj_t next_method1540_9_1321;
		  next_method1540_9_1321 =
		     find_super_class_method_167___object(
		     (object_bglt) (obj1531_1281), object__struct_env_210___object, sfun_iinfo_105_integrate_info);
		  if (
		     PROCEDUREP(next_method1540_9_1321))
		    {	/* Integrate/iinfo.scm 40 */
		       res1532_1284 =
			  PROCEDURE_ENTRY(next_method1540_9_1321) (next_method1540_9_1321,
			  (obj_t) (obj1531_1281), BEOA);
		    }
		  else
		    {	/* Integrate/iinfo.scm 40 */
		       PROCEDURE_SET(object__struct_env_210___object, ((long) 2), next_method1540_9_1321);
		       res1532_1284 =
			  object__struct_50___object(
			  (object_bglt) (obj1531_1281));
		    }
	       }
	       {	/* Integrate/iinfo.scm 40 */
		  obj_t aux1533_1285;
		  {	/* ./Llib/struct.scm 1415 */
		     obj_t aux_3111;
		     aux_3111 =
			CNST_TABLE_REF(((long) 2));
		     aux1533_1285 =
			make_struct(aux_3111, ((long) 17), BUNSPEC);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3114;
		     {
			obj_t aux_3115;
			{	/* Integrate/iinfo.scm 40 */
			   object_bglt aux_3116;
			   aux_3116 =
			      (object_bglt) (obj1531_1281);
			   aux_3115 =
			      OBJECT_WIDENING(aux_3116);
			}
			aux_3114 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3115))->owner);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 0), aux_3114);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3121;
		     {
			obj_t aux_3122;
			{	/* Integrate/iinfo.scm 44 */
			   object_bglt aux_3123;
			   aux_3123 =
			      (object_bglt) (obj1531_1281);
			   aux_3122 =
			      OBJECT_WIDENING(aux_3123);
			}
			aux_3121 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3122))->free);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 1), aux_3121);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3128;
		     {
			obj_t aux_3129;
			{	/* Integrate/iinfo.scm 46 */
			   object_bglt aux_3130;
			   aux_3130 =
			      (object_bglt) (obj1531_1281);
			   aux_3129 =
			      OBJECT_WIDENING(aux_3130);
			}
			aux_3128 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3129))->bound);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 2), aux_3128);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3135;
		     {
			obj_t aux_3136;
			{	/* Integrate/iinfo.scm 48 */
			   object_bglt aux_3137;
			   aux_3137 =
			      (object_bglt) (obj1531_1281);
			   aux_3136 =
			      OBJECT_WIDENING(aux_3137);
			}
			aux_3135 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3136))->cfrom);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 3), aux_3135);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3142;
		     {
			obj_t aux_3143;
			{	/* Integrate/iinfo.scm 50 */
			   object_bglt aux_3144;
			   aux_3144 =
			      (object_bglt) (obj1531_1281);
			   aux_3143 =
			      OBJECT_WIDENING(aux_3144);
			}
			aux_3142 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3143))->cto);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 4), aux_3142);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3149;
		     {
			obj_t aux_3150;
			{	/* Integrate/iinfo.scm 52 */
			   object_bglt aux_3151;
			   aux_3151 =
			      (object_bglt) (obj1531_1281);
			   aux_3150 =
			      OBJECT_WIDENING(aux_3151);
			}
			aux_3149 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3150))->k);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 5), aux_3149);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3156;
		     {
			obj_t aux_3157;
			{	/* Integrate/iinfo.scm 54 */
			   object_bglt aux_3158;
			   aux_3158 =
			      (object_bglt) (obj1531_1281);
			   aux_3157 =
			      OBJECT_WIDENING(aux_3158);
			}
			aux_3156 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3157))->k__190);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 6), aux_3156);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3163;
		     {
			obj_t aux_3164;
			{	/* Integrate/iinfo.scm 56 */
			   object_bglt aux_3165;
			   aux_3165 =
			      (object_bglt) (obj1531_1281);
			   aux_3164 =
			      OBJECT_WIDENING(aux_3165);
			}
			aux_3163 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3164))->u);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 7), aux_3163);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3170;
		     {
			obj_t aux_3171;
			{	/* Integrate/iinfo.scm 58 */
			   object_bglt aux_3172;
			   aux_3172 =
			      (object_bglt) (obj1531_1281);
			   aux_3171 =
			      OBJECT_WIDENING(aux_3172);
			}
			aux_3170 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3171))->cn);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 8), aux_3170);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3177;
		     {
			obj_t aux_3178;
			{	/* Integrate/iinfo.scm 60 */
			   object_bglt aux_3179;
			   aux_3179 =
			      (object_bglt) (obj1531_1281);
			   aux_3178 =
			      OBJECT_WIDENING(aux_3179);
			}
			aux_3177 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3178))->ct);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 9), aux_3177);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3184;
		     {
			obj_t aux_3185;
			{	/* Integrate/iinfo.scm 62 */
			   object_bglt aux_3186;
			   aux_3186 =
			      (object_bglt) (obj1531_1281);
			   aux_3185 =
			      OBJECT_WIDENING(aux_3186);
			}
			aux_3184 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3185))->kont);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 10), aux_3184);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3191;
		     {	/* Integrate/iinfo.scm 40 */
			bool_t aux_3192;
			{
			   obj_t aux_3193;
			   {	/* Integrate/iinfo.scm 40 */
			      object_bglt aux_3194;
			      aux_3194 =
				 (object_bglt) (obj1531_1281);
			      aux_3193 =
				 OBJECT_WIDENING(aux_3194);
			   }
			   aux_3192 =
			      (((sfun_iinfo_105_bglt) CREF(aux_3193))->g__219);
			}
			aux_3191 =
			   BBOOL(aux_3192);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 11), aux_3191);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3200;
		     {
			obj_t aux_3201;
			{	/* Integrate/iinfo.scm 66 */
			   object_bglt aux_3202;
			   aux_3202 =
			      (object_bglt) (obj1531_1281);
			   aux_3201 =
			      OBJECT_WIDENING(aux_3202);
			}
			aux_3200 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3201))->l);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 12), aux_3200);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3207;
		     {
			obj_t aux_3208;
			{	/* Integrate/iinfo.scm 68 */
			   object_bglt aux_3209;
			   aux_3209 =
			      (object_bglt) (obj1531_1281);
			   aux_3208 =
			      OBJECT_WIDENING(aux_3209);
			}
			aux_3207 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3208))->led);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 13), aux_3207);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3214;
		     {
			obj_t aux_3215;
			{	/* Integrate/iinfo.scm 70 */
			   object_bglt aux_3216;
			   aux_3216 =
			      (object_bglt) (obj1531_1281);
			   aux_3215 =
			      OBJECT_WIDENING(aux_3216);
			}
			aux_3214 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3215))->istamp);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 14), aux_3214);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3221;
		     {
			obj_t aux_3222;
			{	/* Integrate/iinfo.scm 72 */
			   object_bglt aux_3223;
			   aux_3223 =
			      (object_bglt) (obj1531_1281);
			   aux_3222 =
			      OBJECT_WIDENING(aux_3223);
			}
			aux_3221 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3222))->global);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 15), aux_3221);
		  }
		  {	/* ./Llib/struct.scm 1463 */
		     obj_t aux_3228;
		     {
			obj_t aux_3229;
			{	/* Integrate/iinfo.scm 74 */
			   object_bglt aux_3230;
			   aux_3230 =
			      (object_bglt) (obj1531_1281);
			   aux_3229 =
			      OBJECT_WIDENING(aux_3230);
			}
			aux_3228 =
			   (((sfun_iinfo_105_bglt) CREF(aux_3229))->kaptured);
		     }
		     STRUCT_SET(aux1533_1285, ((long) 16), aux_3228);
		  }
		  STRUCT_SET(res1532_1284, ((long) 0), aux1533_1285);
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3236;
		     aux_3236 =
			STRUCT_KEY(res1532_1284);
		     STRUCT_KEY_SET(aux1533_1285, aux_3236);
		  }
		  {	/* ./Llib/struct.scm 1445 */
		     obj_t aux_3239;
		     aux_3239 =
			CNST_TABLE_REF(((long) 2));
		     STRUCT_KEY_SET(res1532_1284, aux_3239);
		  }
		  return res1532_1284;
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_integrate_info()
{
   AN_OBJECT;
   {	/* Integrate/iinfo.scm 14 */
      module_initialization_70_type_type(((long) 0), "INTEGRATE_INFO");
      module_initialization_70_ast_var(((long) 0), "INTEGRATE_INFO");
      return
	 module_initialization_70_ast_node(((long) 0), "INTEGRATE_INFO");
   }
}
