/*===========================================================================*/
/*   (Object/access.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Fri Oct 15 13:23:41 CEST 1999                  */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo2.1a.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct value
  {
     header_t header;
     obj_t widening;
  }
     *value_bglt;

typedef struct variable
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
  }
        *variable_bglt;

typedef struct global
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     obj_t module;
     obj_t import;
     bool_t evaluable__248;
     bool_t library__255;
     bool_t user__32;
     obj_t pragma;
     obj_t src;
  }
      *global_bglt;

typedef struct local
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     struct type *type;
     struct value *value;
     obj_t access;
     obj_t fast_alpha_7;
     obj_t removable;
     long occurrence;
     bool_t user__32;
     long key;
  }
     *local_bglt;

typedef struct fun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
  }
   *fun_bglt;

typedef struct sfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t property;
     obj_t args;
     obj_t body;
     obj_t class;
     obj_t dsssl_keywords_243;
     obj_t loc;
  }
    *sfun_bglt;

typedef struct cfun
  {
     header_t header;
     obj_t widening;
     long arity;
     obj_t side_effect__165;
     obj_t predicate_of_78;
     obj_t stack_allocator_172;
     bool_t top__138;
     obj_t the_closure_238;
     obj_t args_type_205;
     bool_t macro__33;
     bool_t infix__163;
  }
    *cfun_bglt;

typedef struct svar
  {
     header_t header;
     obj_t widening;
     obj_t loc;
  }
    *svar_bglt;

typedef struct scnst
  {
     header_t header;
     obj_t widening;
     obj_t node;
     obj_t class;
     obj_t loc;
  }
     *scnst_bglt;

typedef struct cvar
  {
     header_t header;
     obj_t widening;
     bool_t macro__33;
  }
    *cvar_bglt;

typedef struct sexit
  {
     header_t header;
     obj_t widening;
     obj_t handler;
     bool_t detached__120;
  }
     *sexit_bglt;

typedef struct tclass
  {
     obj_t its_super_214;
     obj_t slots;
     struct global *holder;
     obj_t widening;
     long depth;
     bool_t final__12;
     obj_t constructor;
     obj_t virtual_slots_number_200;
  }
      *tclass_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


extern obj_t append___r4_pairs_and_lists_6_3(obj_t);
static obj_t method_init_76_object_access();
static obj_t make_one_coercion_132_object_access(obj_t, obj_t, obj_t, obj_t);
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
static obj_t _make_class_makes__119_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _optim__89_engine_param;
extern obj_t string_append(obj_t, obj_t);
extern obj_t make_class_makes__132_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _res1__155___r5_control_features_6_4;
static obj_t import_slot_dyna_indexed_ref__108_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_class_pred_2635_231_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t import_slot_indexed_set__155_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t slot_virtual_ref_147_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_coercion_clause_178_object_access(obj_t, obj_t, obj_t);
extern obj_t gensym___r4_symbols_6_4;
static obj_t slot_indexed_ref_219_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_pred__174_object_access(obj_t, tclass_bglt, obj_t, obj_t);
static obj_t _make_class_slots_access__121_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t notify_assert_fail_37___eval(obj_t, obj_t, obj_t);
static obj_t slot_dyna_indexed_ref_48_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_direct_set__widening_17_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_coercers_236_object_access(obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_object_access(long, char *);
extern obj_t module_initialization_70_tools_trace(long, char *);
extern obj_t module_initialization_70_tools_error(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_type_env(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_cache(long, char *);
extern obj_t module_initialization_70_ast_var(long, char *);
extern obj_t module_initialization_70_ast_ident(long, char *);
extern obj_t module_initialization_70_object_class(long, char *);
extern obj_t module_initialization_70_object_struct(long, char *);
extern obj_t module_initialization_70_object_slots(long, char *);
extern obj_t module_initialization_70_object_tools(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70_module_impuse(long, char *);
extern obj_t module_initialization_70_engine_param(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___eval(long, char *);
extern obj_t module_initialization_70___evenv(long, char *);
extern obj_t module_initialization_70___r4_pairs_and_lists_6_3(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
extern obj_t module_initialization_70___r5_control_features_6_4(long, char *);
extern obj_t make_class_make_typed_formals_184_object_access(obj_t);
static obj_t _make_class_make_formals_78_object_access(obj_t, obj_t);
static obj_t make_class_slot_make__242_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t slot_virtual_set__86_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t import_slot_indexed_ref__208_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _import_class_makes_2639_212_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_class_slots_access__80_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t define_primop_ref__105___evenv(obj_t, obj_t);
static obj_t import_slot_set__215_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t imported_modules_init_94_object_access();
static obj_t slot_indexed_set__217_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t unbind_primop__163___evenv(obj_t);
extern obj_t make_coercion_clause_209_object_access(obj_t, obj_t);
extern obj_t make_pragma_indexed_ref_widening_28_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t);
extern obj_t produce_module_clause__172_module_module(obj_t);
extern obj_t append_2_18___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t import_parser_53_module_impuse(obj_t, obj_t);
extern obj_t epairify__149_object_access(obj_t, obj_t);
static obj_t slot_ref_85_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t library_modules_init_112_object_access();
static obj_t slot_set__144_object_access(tclass_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t import_class_slots_access__39_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t class__super_id_210_object_tools(obj_t, obj_t);
static obj_t toplevel_init_63_object_access();
static obj_t slot_direct_set__173_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t malloc_object_tools(type_bglt, obj_t);
static obj_t import_slot_ref__77_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t open_input_string(obj_t);
extern obj_t import_class_pred__91_object_access(obj_t, tclass_bglt, obj_t, obj_t);
static obj_t slot_direct_ref_183_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_class_allocate__22_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t class__obj_id_219_object_tools(obj_t);
extern obj_t tclass_object_class;
extern obj_t make_pragma_indexed_init_set__66_object_tools(type_bglt, obj_t, obj_t, obj_t);
extern obj_t memq___r4_pairs_and_lists_6_3(obj_t, obj_t);
extern obj_t super__class_id_210_object_tools(obj_t, obj_t);
extern obj_t make_class_make_formals_23_object_access(obj_t);
static obj_t import_slot_direct_set__76_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _res_number__75___r5_control_features_6_4;
static obj_t _import_class_pred_2636_91_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t slot_dyna_indexed_set__50_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _4dots_199_tools_misc;
extern obj_t class__id_80_object_tools(obj_t);
extern obj_t _unsafe_range__218_engine_param;
extern obj_t make_pragma_direct_set__7_object_tools(type_bglt, obj_t, obj_t, obj_t);
extern obj_t read___reader(obj_t);
extern obj_t _profile_mode__105_engine_param;
extern obj_t import_class_makes__192_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _epairify__213_object_access(obj_t, obj_t, obj_t);
static obj_t _import_class_slots_access_2640_107_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t make_class_make__196_object_access(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t obj__class_id_9_object_tools(obj_t);
static obj_t import_slot_dyna_indexed_set__203_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t make_pragma_direct_ref_widening_240_object_tools(type_bglt, obj_t, obj_t, obj_t);
extern obj_t make_class_allocate__44_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_object_access = BUNSPEC;
extern obj_t make_pragma_indexed_set__widening_24_object_tools(type_bglt, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t _make_class_make_typed_formals_151_object_access(obj_t, obj_t);
extern obj_t find_class_constructors_231_object_class(tclass_bglt);
static obj_t cnst_init_137_object_access();
extern obj_t reverse__39___r4_pairs_and_lists_6_3(obj_t);
static obj_t _make_class_coercers_12_object_access(obj_t, obj_t);
static obj_t import_slot_direct_ref__71_object_access(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[57];

DEFINE_EXPORT_PROCEDURE(make_class_coercers_env_94_object_access, _make_class_coercers_12_object_access2652, _make_class_coercers_12_object_access, 0L, 1);
DEFINE_EXPORT_PROCEDURE(make_class_slots_access__env_134_object_access, _make_class_slots_access__121_object_access2653, _make_class_slots_access__121_object_access, 0L, 6);
DEFINE_EXPORT_PROCEDURE(make_class_makes__env_104_object_access, _make_class_makes__119_object_access2654, _make_class_makes__119_object_access, 0L, 7);
DEFINE_EXPORT_PROCEDURE(import_class_slots_access__env_230_object_access, _import_class_slots_access_2640_107_object_access2655, _import_class_slots_access_2640_107_object_access, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_class_make_formals_env_241_object_access, _make_class_make_formals_78_object_access2656, _make_class_make_formals_78_object_access, 0L, 1);
extern obj_t malloc_env_105_object_tools;
DEFINE_EXPORT_PROCEDURE(import_class_makes__env_142_object_access, _import_class_makes_2639_212_object_access2657, _import_class_makes_2639_212_object_access, 0L, 6);
DEFINE_STRING(string2647_object_access, string2647_object_access2658, "CALL-VIRTUAL-SETTER VAL -SET! CALL-VIRTUAL-GETTER -REF SLOT ERROR <FX INDEX >=FX INDEX::LONG __OBJECT ALLOCATE- FREE-PRAGMA::LONG +FX DONE QUOTE =FX IF LABELS -LEN BEGIN LOOP OBJECT-WIDENING-SET! CLASS-NUM OBJECT-CLASS-NUM-SET! LET ALLOCATOR (INLINE) ::LONG I NEW - (\"/home/tahoe2/serrano/tmp/bigloo/comptime/Object/access.scm\" . 8255) (BEGIN (MEMQ WIDENING (QUOTE (WIDENING MAKE)))) (WIDENING) WIDENING (WIDENING MAKE) @ IS-A? DEFINE DEFINE-INLINE PREDICATE-OF ::OBJ INLINE SUPER SUPER- ?::BOOL ? MACRO NO-CFA-TOP SIDE-EFFECT-FREE PRAGMA -> OBJ TYPE COERCE ", 558);
DEFINE_STRING(string2646_object_access, string2646_object_access2659, "Type `extended pair' expected for expression", 44);
DEFINE_STRING(string2645_object_access, string2645_object_access2660, "cer", 3);
DEFINE_STRING(string2644_object_access, string2644_object_access2661, "Index out of bound", 18);
DEFINE_STRING(string2643_object_access, string2643_object_access2662, "(", 1);
DEFINE_STRING(string2642_object_access, string2642_object_access2663, ")", 1);
DEFINE_STRING(string2641_object_access, string2641_object_access2664, "obj_t", 5);
DEFINE_EXPORT_PROCEDURE(epairify__env_191_object_access, _epairify__213_object_access2665, va_generic_entry, _epairify__213_object_access, -2);
DEFINE_EXPORT_PROCEDURE(make_class_make_typed_formals_env_161_object_access, _make_class_make_typed_formals_151_object_access2666, _make_class_make_typed_formals_151_object_access, 0L, 1);
DEFINE_EXPORT_PROCEDURE(import_class_pred__env_87_object_access, _import_class_pred_2636_91_object_access2667, _import_class_pred_2636_91_object_access, 0L, 4);
DEFINE_EXPORT_PROCEDURE(make_class_allocate__env_43_object_access, _make_class_allocate__22_object_access2668, _make_class_allocate__22_object_access, 0L, 5);
DEFINE_EXPORT_PROCEDURE(make_coercion_clause_env_78_object_access, _make_coercion_clause_178_object_access2669, _make_coercion_clause_178_object_access, 0L, 2);
DEFINE_EXPORT_PROCEDURE(make_class_pred__env_156_object_access, _make_class_pred_2635_231_object_access2670, _make_class_pred_2635_231_object_access, 0L, 4);



/* module-initialization */
obj_t 
module_initialization_70_object_access(long checksum_4029, char *from_4030)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_object_access))
	{
	   require_initialization_114_object_access =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_object_access();
	   cnst_init_137_object_access();
	   imported_modules_init_94_object_access();
	   method_init_76_object_access();
	   toplevel_init_63_object_access();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_object_access()
{
   AN_OBJECT;
   {	/* Object/access.scm 20 */
      module_initialization_70___r4_pairs_and_lists_6_3(((long) 0), "OBJECT_ACCESS");
      module_initialization_70___r4_symbols_6_4(((long) 0), "OBJECT_ACCESS");
      module_initialization_70___r5_control_features_6_4(((long) 0), "OBJECT_ACCESS");
      module_initialization_70___eval(((long) 0), "OBJECT_ACCESS");
      module_initialization_70___object(((long) 0), "OBJECT_ACCESS");
      module_initialization_70___evenv(((long) 0), "OBJECT_ACCESS");
      module_initialization_70___reader(((long) 0), "OBJECT_ACCESS");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_object_access()
{
   AN_OBJECT;
   {	/* Object/access.scm 20 */
      {		/* Object/access.scm 20 */
	 obj_t cnst_port_138_4022;
	 cnst_port_138_4022 =
	    open_input_string(string2647_object_access);
	 {
	    long i_4023;
	    i_4023 = ((long) 56);
	  loop_4024:
	    {	/* Object/access.scm 20 */
	       bool_t test2648_4025;
	       test2648_4025 =
		  (i_4023 == ((long) -1));
	       if (test2648_4025)
		 {	/* Object/access.scm 20 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Object/access.scm 20 */
		    {	/* Object/access.scm 20 */
		       obj_t arg2649_4026;
		       {	/* Object/access.scm 20 */
			  obj_t list2650_4027;
			  list2650_4027 =
			     MAKE_PAIR(cnst_port_138_4022, BNIL);
			  arg2649_4026 =
			     read___reader(list2650_4027);
		       }
		       CNST_TABLE_SET(i_4023, arg2649_4026);
		    }
		    {	/* Object/access.scm 20 */
		       int aux_4028;
		       {	/* Object/access.scm 20 */
			  long aux_4052;
			  aux_4052 =
			     (i_4023 - ((long) 1));
			  aux_4028 =
			     (int) (aux_4052);
		       }
		       {
			  long i_4055;
			  i_4055 =
			     (long) (aux_4028);
			  i_4023 = i_4055;
			  goto loop_4024;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_object_access()
{
   AN_OBJECT;
   {	/* Object/access.scm 20 */
      return BUNSPEC;
   }
}



/* make-coercion-clause */
obj_t 
make_coercion_clause_209_object_access(obj_t c_id_230_71, obj_t super_72)
{
   AN_OBJECT;
   {	/* Object/access.scm 62 */
      {		/* Object/access.scm 63 */
	 obj_t class__obj_201_670;
	 class__obj_201_670 =
	    class__obj_id_219_object_tools(c_id_230_71);
	 {	/* Object/access.scm 63 */
	    obj_t obj__class_1_671;
	    obj__class_1_671 =
	       obj__class_id_9_object_tools(c_id_230_71);
	    {	/* Object/access.scm 64 */
	       obj_t class_id__3_672;
	       class_id__3_672 =
		  class__id_80_object_tools(c_id_230_71);
	       {	/* Object/access.scm 65 */

		  {
		     obj_t super_673;
		     obj_t coercer_674;
		     {	/* Object/access.scm 68 */
			obj_t arg1274_676;
			{	/* Object/access.scm 68 */
			   obj_t arg1276_677;
			   obj_t arg1277_678;
			   {	/* Object/access.scm 68 */
			      obj_t arg1281_681;
			      obj_t arg1282_682;
			      arg1281_681 =
				 CNST_TABLE_REF(((long) 0));
			      {		/* Object/access.scm 68 */
				 obj_t arg1286_683;
				 obj_t arg1287_684;
				 arg1286_683 =
				    CNST_TABLE_REF(((long) 2));
				 {	/* Object/access.scm 68 */
				    obj_t arg1289_685;
				    {	/* Object/access.scm 68 */
				       obj_t arg1290_686;
				       obj_t arg1291_687;
				       arg1290_686 =
					  MAKE_PAIR(class_id__3_672, BNIL);
				       {	/* Object/access.scm 68 */
					  obj_t arg1292_688;
					  arg1292_688 =
					     MAKE_PAIR(obj__class_1_671, BNIL);
					  arg1291_687 =
					     MAKE_PAIR(arg1292_688, BNIL);
				       }
				       arg1289_685 =
					  MAKE_PAIR(arg1290_686, arg1291_687);
				    }
				    arg1287_684 =
				       MAKE_PAIR(c_id_230_71, arg1289_685);
				 }
				 arg1282_682 =
				    MAKE_PAIR(arg1286_683, arg1287_684);
			      }
			      arg1276_677 =
				 MAKE_PAIR(arg1281_681, arg1282_682);
			   }
			   {	/* Object/access.scm 69 */
			      obj_t arg1294_690;
			      obj_t arg1295_691;
			      arg1294_690 =
				 CNST_TABLE_REF(((long) 0));
			      {		/* Object/access.scm 69 */
				 obj_t arg1296_692;
				 {	/* Object/access.scm 69 */
				    obj_t arg1297_693;
				    obj_t arg1298_694;
				    arg1297_693 =
				       CNST_TABLE_REF(((long) 2));
				    {	/* Object/access.scm 69 */
				       obj_t arg1300_696;
				       {	/* Object/access.scm 69 */
					  obj_t arg1301_697;
					  arg1301_697 =
					     MAKE_PAIR(class__obj_201_670, BNIL);
					  arg1300_696 =
					     MAKE_PAIR(arg1301_697, BNIL);
				       }
				       arg1298_694 =
					  MAKE_PAIR(BNIL, arg1300_696);
				    }
				    arg1296_692 =
				       MAKE_PAIR(arg1297_693, arg1298_694);
				 }
				 arg1295_691 =
				    MAKE_PAIR(c_id_230_71, arg1296_692);
			      }
			      arg1277_678 =
				 MAKE_PAIR(arg1294_690, arg1295_691);
			   }
			   {	/* Object/access.scm 67 */
			      obj_t list1278_679;
			      {		/* Object/access.scm 67 */
				 obj_t arg1280_680;
				 arg1280_680 =
				    MAKE_PAIR(arg1277_678, BNIL);
				 list1278_679 =
				    MAKE_PAIR(arg1276_677, arg1280_680);
			      }
			      arg1274_676 = list1278_679;
			   }
			}
			super_673 = super_72;
			coercer_674 = arg1274_676;
		      loop_675:
			{	/* Object/access.scm 70 */
			   bool_t test1303_699;
			   test1303_699 =
			      is_a__118___object(super_673, tclass_object_class);
			   if (test1303_699)
			     {	/* Object/access.scm 72 */
				obj_t super_id_153_700;
				{	/* Object/access.scm 72 */
				   type_bglt obj_2387;
				   obj_2387 =
				      (type_bglt) (super_673);
				   super_id_153_700 =
				      (((type_bglt) CREF(obj_2387))->id);
				}
				{	/* Object/access.scm 72 */
				   obj_t class__super_100_701;
				   class__super_100_701 =
				      class__super_id_210_object_tools(c_id_230_71, super_id_153_700);
				   {	/* Object/access.scm 73 */
				      obj_t super__class_100_702;
				      super__class_100_702 =
					 super__class_id_210_object_tools(super_id_153_700, c_id_230_71);
				      {		/* Object/access.scm 74 */

					 {	/* Object/access.scm 75 */
					    obj_t arg1304_703;
					    obj_t arg1305_704;
					    {	/* Object/access.scm 75 */
					       tclass_bglt obj_2388;
					       obj_2388 =
						  (tclass_bglt) (super_673);
					       {
						  obj_t aux_4086;
						  {	/* ./Object/class.scm 1778 */
						     object_bglt aux_4087;
						     aux_4087 =
							(object_bglt) (obj_2388);
						     aux_4086 =
							OBJECT_WIDENING(aux_4087);
						  }
						  arg1304_703 =
						     (((tclass_bglt) CREF(aux_4086))->its_super_214);
					       }
					    }
					    {	/* Object/access.scm 77 */
					       obj_t arg1307_705;
					       obj_t arg1308_706;
					       {	/* Object/access.scm 77 */
						  obj_t arg1309_707;
						  obj_t arg1313_708;
						  arg1309_707 =
						     CNST_TABLE_REF(((long) 0));
						  {	/* Object/access.scm 77 */
						     obj_t arg1314_709;
						     {	/* Object/access.scm 77 */
							obj_t arg1315_710;
							{	/* Object/access.scm 77 */
							   obj_t arg1317_711;
							   obj_t arg1318_712;
							   arg1317_711 =
							      MAKE_PAIR(class_id__3_672, BNIL);
							   {	/* Object/access.scm 77 */
							      obj_t arg1319_713;
							      arg1319_713 =
								 MAKE_PAIR(super__class_100_702, BNIL);
							      arg1318_712 =
								 MAKE_PAIR(arg1319_713, BNIL);
							   }
							   arg1315_710 =
							      MAKE_PAIR(arg1317_711, arg1318_712);
							}
							arg1314_709 =
							   MAKE_PAIR(c_id_230_71, arg1315_710);
						     }
						     arg1313_708 =
							MAKE_PAIR(super_id_153_700, arg1314_709);
						  }
						  arg1307_705 =
						     MAKE_PAIR(arg1309_707, arg1313_708);
					       }
					       {	/* Object/access.scm 79 */
						  obj_t arg1322_715;
						  {	/* Object/access.scm 79 */
						     obj_t arg1323_716;
						     obj_t arg1325_717;
						     arg1323_716 =
							CNST_TABLE_REF(((long) 0));
						     {	/* Object/access.scm 79 */
							obj_t arg1326_718;
							{	/* Object/access.scm 79 */
							   obj_t arg1327_719;
							   {	/* Object/access.scm 79 */
							      obj_t arg1330_721;
							      {		/* Object/access.scm 79 */
								 obj_t arg1331_722;
								 arg1331_722 =
								    MAKE_PAIR(class__super_100_701, BNIL);
								 arg1330_721 =
								    MAKE_PAIR(arg1331_722, BNIL);
							      }
							      arg1327_719 =
								 MAKE_PAIR(BNIL, arg1330_721);
							   }
							   arg1326_718 =
							      MAKE_PAIR(super_id_153_700, arg1327_719);
							}
							arg1325_717 =
							   MAKE_PAIR(c_id_230_71, arg1326_718);
						     }
						     arg1322_715 =
							MAKE_PAIR(arg1323_716, arg1325_717);
						  }
						  arg1308_706 =
						     MAKE_PAIR(arg1322_715, coercer_674);
					       }
					       arg1305_704 =
						  MAKE_PAIR(arg1307_705, arg1308_706);
					    }
					    {
					       obj_t coercer_4109;
					       obj_t super_4108;
					       super_4108 = arg1304_703;
					       coercer_4109 = arg1305_704;
					       coercer_674 = coercer_4109;
					       super_673 = super_4108;
					       goto loop_675;
					    }
					 }
				      }
				   }
				}
			     }
			   else
			     {	/* ./Ieee/pair-list.scm 5689 */
				obj_t aux_4112;
				obj_t aux_4110;
				aux_4112 =
				   append_2_18___r4_pairs_and_lists_6_3(coercer_674, BNIL);
				aux_4110 =
				   CNST_TABLE_REF(((long) 1));
				return
				   MAKE_PAIR(aux_4110, aux_4112);
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-coercion-clause */
obj_t 
_make_coercion_clause_178_object_access(obj_t env_3962, obj_t c_id_230_3963, obj_t super_3964)
{
   AN_OBJECT;
   {	/* Object/access.scm 62 */
      return
	 make_coercion_clause_209_object_access(c_id_230_3963, super_3964);
   }
}



/* make-class-coercers */
obj_t 
make_class_coercers_236_object_access(obj_t class_73)
{
   AN_OBJECT;
   {	/* Object/access.scm 96 */
      {		/* Object/access.scm 107 */
	 obj_t tid_727;
	 obj_t tname_728;
	 {	/* Object/access.scm 107 */
	    type_bglt obj_2421;
	    obj_2421 =
	       (type_bglt) (class_73);
	    tid_727 =
	       (((type_bglt) CREF(obj_2421))->id);
	 }
	 {	/* Object/access.scm 108 */
	    type_bglt obj_2422;
	    obj_2422 =
	       (type_bglt) (class_73);
	    tname_728 =
	       (((type_bglt) CREF(obj_2422))->name);
	 }
	 {
	    obj_t super_729;
	    obj_t coercer_730;
	    {	/* Object/access.scm 109 */
	       obj_t arg1335_732;
	       obj_t arg1336_733;
	       {	/* Object/access.scm 109 */
		  tclass_bglt obj_2423;
		  obj_2423 =
		     (tclass_bglt) (class_73);
		  {
		     obj_t aux_4121;
		     {	/* ./Object/class.scm 1778 */
			object_bglt aux_4122;
			aux_4122 =
			   (object_bglt) (obj_2423);
			aux_4121 =
			   OBJECT_WIDENING(aux_4122);
		     }
		     arg1335_732 =
			(((tclass_bglt) CREF(aux_4121))->its_super_214);
		  }
	       }
	       arg1336_733 =
		  make_one_coercion_132_object_access(tid_727, tname_728,
		  CNST_TABLE_REF(((long) 2)), string2641_object_access);
	       super_729 = arg1335_732;
	       coercer_730 = arg1336_733;
	     loop_731:
	       {	/* Object/access.scm 111 */
		  bool_t test1337_734;
		  test1337_734 =
		     is_a__118___object(super_729, tclass_object_class);
		  if (test1337_734)
		    {	/* Object/access.scm 115 */
		       obj_t arg1338_737;
		       obj_t arg1339_738;
		       {	/* Object/access.scm 115 */
			  tclass_bglt obj_2427;
			  obj_2427 =
			     (tclass_bglt) (super_729);
			  {
			     obj_t aux_4131;
			     {	/* ./Object/class.scm 1778 */
				object_bglt aux_4132;
				aux_4132 =
				   (object_bglt) (obj_2427);
				aux_4131 =
				   OBJECT_WIDENING(aux_4132);
			     }
			     arg1338_737 =
				(((tclass_bglt) CREF(aux_4131))->its_super_214);
			  }
		       }
		       {	/* Object/access.scm 116 */
			  obj_t arg1340_739;
			  {	/* Object/access.scm 116 */
			     obj_t aux_4139;
			     obj_t aux_4136;
			     {	/* Object/access.scm 114 */
				type_bglt obj_2426;
				obj_2426 =
				   (type_bglt) (super_729);
				aux_4139 =
				   (((type_bglt) CREF(obj_2426))->name);
			     }
			     {	/* Object/access.scm 113 */
				type_bglt obj_2425;
				obj_2425 =
				   (type_bglt) (super_729);
				aux_4136 =
				   (((type_bglt) CREF(obj_2425))->id);
			     }
			     arg1340_739 =
				make_one_coercion_132_object_access(tid_727, tname_728, aux_4136, aux_4139);
			  }
			  arg1339_738 =
			     append_2_18___r4_pairs_and_lists_6_3(arg1340_739, coercer_730);
		       }
		       {
			  obj_t coercer_4145;
			  obj_t super_4144;
			  super_4144 = arg1338_737;
			  coercer_4145 = arg1339_738;
			  coercer_730 = coercer_4145;
			  super_729 = super_4144;
			  goto loop_731;
		       }
		    }
		  else
		    {	/* Object/access.scm 111 */
		       return coercer_730;
		    }
	       }
	    }
	 }
      }
   }
}



/* make-one-coercion */
obj_t 
make_one_coercion_132_object_access(obj_t from_id_201_740, obj_t from_name_19_741, obj_t to_id_124_742, obj_t to_name_205_743)
{
   AN_OBJECT;
   {	/* Object/access.scm 97 */
      {		/* Object/access.scm 98 */
	 obj_t t__f_60_745;
	 obj_t f__t_46_746;
	 {	/* Object/access.scm 98 */
	    obj_t list1391_784;
	    {	/* Object/access.scm 98 */
	       obj_t arg1393_785;
	       {	/* Object/access.scm 98 */
		  obj_t arg1394_786;
		  obj_t arg1395_787;
		  arg1394_786 =
		     CNST_TABLE_REF(((long) 3));
		  arg1395_787 =
		     MAKE_PAIR(from_id_201_740, BNIL);
		  arg1393_785 =
		     MAKE_PAIR(arg1394_786, arg1395_787);
	       }
	       list1391_784 =
		  MAKE_PAIR(to_id_124_742, arg1393_785);
	    }
	    t__f_60_745 =
	       symbol_append_197___r4_symbols_6_4(list1391_784);
	 }
	 {	/* Object/access.scm 99 */
	    obj_t list1396_788;
	    {	/* Object/access.scm 99 */
	       obj_t arg1397_789;
	       {	/* Object/access.scm 99 */
		  obj_t arg1398_790;
		  obj_t arg1399_791;
		  arg1398_790 =
		     CNST_TABLE_REF(((long) 3));
		  arg1399_791 =
		     MAKE_PAIR(to_id_124_742, BNIL);
		  arg1397_789 =
		     MAKE_PAIR(arg1398_790, arg1399_791);
	       }
	       list1396_788 =
		  MAKE_PAIR(from_id_201_740, arg1397_789);
	    }
	    f__t_46_746 =
	       symbol_append_197___r4_symbols_6_4(list1396_788);
	 }
	 {	/* Object/access.scm 101 */
	    obj_t arg1342_747;
	    {	/* Object/access.scm 101 */
	       obj_t arg1343_748;
	       obj_t arg1344_749;
	       arg1343_748 =
		  CNST_TABLE_REF(((long) 4));
	       {	/* Object/access.scm 101 */
		  obj_t arg1346_750;
		  obj_t arg1347_751;
		  {	/* Object/access.scm 101 */
		     obj_t arg1348_752;
		     {	/* Object/access.scm 101 */
			obj_t arg1350_753;
			obj_t arg1354_754;
			arg1350_753 =
			   CNST_TABLE_REF(((long) 5));
			{	/* ./Ieee/pair-list.scm 5689 */
			   obj_t aux_4158;
			   aux_4158 =
			      CNST_TABLE_REF(((long) 6));
			   arg1354_754 =
			      MAKE_PAIR(aux_4158, BNIL);
			}
			arg1348_752 =
			   MAKE_PAIR(arg1350_753, arg1354_754);
		     }
		     arg1346_750 =
			MAKE_PAIR(t__f_60_745, arg1348_752);
		  }
		  {	/* Object/access.scm 102 */
		     obj_t arg1355_755;
		     {	/* Object/access.scm 102 */
			obj_t arg1357_757;
			{	/* Object/access.scm 102 */
			   obj_t arg1358_758;
			   obj_t arg1359_759;
			   arg1358_758 =
			      CNST_TABLE_REF(((long) 5));
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_4164;
			      aux_4164 =
				 CNST_TABLE_REF(((long) 6));
			      arg1359_759 =
				 MAKE_PAIR(aux_4164, BNIL);
			   }
			   arg1357_757 =
			      MAKE_PAIR(arg1358_758, arg1359_759);
			}
			arg1355_755 =
			   MAKE_PAIR(f__t_46_746, arg1357_757);
		     }
		     arg1347_751 =
			MAKE_PAIR(arg1355_755, BNIL);
		  }
		  arg1344_749 =
		     MAKE_PAIR(arg1346_750, arg1347_751);
	       }
	       arg1342_747 =
		  MAKE_PAIR(arg1343_748, arg1344_749);
	    }
	    produce_module_clause__172_module_module(arg1342_747);
	 }
	 {	/* Object/access.scm 103 */
	    obj_t arg1361_760;
	    obj_t arg1363_761;
	    {	/* Object/access.scm 103 */
	       obj_t arg1366_764;
	       obj_t arg1367_765;
	       arg1366_764 =
		  CNST_TABLE_REF(((long) 7));
	       {	/* Object/access.scm 103 */
		  obj_t arg1369_766;
		  {	/* Object/access.scm 103 */
		     obj_t arg1371_767;
		     {	/* Object/access.scm 103 */
			obj_t arg1372_768;
			obj_t arg1373_769;
			arg1372_768 =
			   MAKE_PAIR(to_id_124_742, BNIL);
			{	/* Object/access.scm 104 */
			   obj_t arg1374_770;
			   {	/* Object/access.scm 104 */
			      obj_t arg1377_773;
			      arg1377_773 =
				 string_append(from_name_19_741, string2642_object_access);
			      arg1374_770 =
				 string_append(string2643_object_access, arg1377_773);
			   }
			   arg1373_769 =
			      MAKE_PAIR(arg1374_770, BNIL);
			}
			arg1371_767 =
			   MAKE_PAIR(arg1372_768, arg1373_769);
		     }
		     arg1369_766 =
			MAKE_PAIR(t__f_60_745, arg1371_767);
		  }
		  arg1367_765 =
		     MAKE_PAIR(from_id_201_740, arg1369_766);
	       }
	       arg1361_760 =
		  MAKE_PAIR(arg1366_764, arg1367_765);
	    }
	    {	/* Object/access.scm 105 */
	       obj_t arg1378_774;
	       obj_t arg1379_775;
	       arg1378_774 =
		  CNST_TABLE_REF(((long) 7));
	       {	/* Object/access.scm 105 */
		  obj_t arg1380_776;
		  {	/* Object/access.scm 105 */
		     obj_t arg1381_777;
		     {	/* Object/access.scm 105 */
			obj_t arg1383_778;
			obj_t arg1384_779;
			arg1383_778 =
			   MAKE_PAIR(from_id_201_740, BNIL);
			{	/* Object/access.scm 106 */
			   obj_t arg1385_780;
			   {	/* Object/access.scm 106 */
			      obj_t arg1390_783;
			      arg1390_783 =
				 string_append(to_name_205_743, string2642_object_access);
			      arg1385_780 =
				 string_append(string2643_object_access, arg1390_783);
			   }
			   arg1384_779 =
			      MAKE_PAIR(arg1385_780, BNIL);
			}
			arg1381_777 =
			   MAKE_PAIR(arg1383_778, arg1384_779);
		     }
		     arg1380_776 =
			MAKE_PAIR(f__t_46_746, arg1381_777);
		  }
		  arg1379_775 =
		     MAKE_PAIR(to_id_124_742, arg1380_776);
	       }
	       arg1363_761 =
		  MAKE_PAIR(arg1378_774, arg1379_775);
	    }
	    {	/* Object/access.scm 103 */
	       obj_t list1364_762;
	       {	/* Object/access.scm 103 */
		  obj_t arg1365_763;
		  arg1365_763 =
		     MAKE_PAIR(arg1363_761, BNIL);
		  list1364_762 =
		     MAKE_PAIR(arg1361_760, arg1365_763);
	       }
	       return list1364_762;
	    }
	 }
      }
   }
}



/* _make-class-coercers */
obj_t 
_make_class_coercers_12_object_access(obj_t env_3965, obj_t class_3966)
{
   AN_OBJECT;
   {	/* Object/access.scm 96 */
      return
	 make_class_coercers_236_object_access(class_3966);
   }
}



/* make-class-pred! */
obj_t 
make_class_pred__174_object_access(obj_t id_74, tclass_bglt class_75, obj_t src_def_101_76, obj_t import_77)
{
   AN_OBJECT;
   {	/* Object/access.scm 125 */
      {		/* Object/access.scm 126 */
	 obj_t id__219_793;
	 {	/* Object/access.scm 126 */
	    obj_t list1471_860;
	    {	/* Object/access.scm 126 */
	       obj_t arg1472_861;
	       {	/* Object/access.scm 126 */
		  obj_t aux_4194;
		  aux_4194 =
		     CNST_TABLE_REF(((long) 8));
		  arg1472_861 =
		     MAKE_PAIR(aux_4194, BNIL);
	       }
	       list1471_860 =
		  MAKE_PAIR(id_74, arg1472_861);
	    }
	    id__219_793 =
	       symbol_append_197___r4_symbols_6_4(list1471_860);
	 }
	 {	/* Object/access.scm 126 */
	    obj_t pred_id_222_794;
	    {	/* Object/access.scm 127 */
	       obj_t list1469_858;
	       {	/* Object/access.scm 127 */
		  obj_t arg1470_859;
		  {	/* Object/access.scm 127 */
		     obj_t aux_4199;
		     aux_4199 =
			CNST_TABLE_REF(((long) 9));
		     arg1470_859 =
			MAKE_PAIR(aux_4199, BNIL);
		  }
		  list1469_858 =
		     MAKE_PAIR(id_74, arg1470_859);
	       }
	       pred_id_222_794 =
		  symbol_append_197___r4_symbols_6_4(list1469_858);
	    }
	    {	/* Object/access.scm 127 */
	       global_bglt holder_795;
	       {
		  obj_t aux_4204;
		  {	/* ./Object/class.scm 1784 */
		     object_bglt aux_4205;
		     aux_4205 =
			(object_bglt) (class_75);
		     aux_4204 =
			OBJECT_WIDENING(aux_4205);
		  }
		  holder_795 =
		     (((tclass_bglt) CREF(aux_4204))->holder);
	       }
	       {	/* Object/access.scm 128 */
		  obj_t super_796;
		  {
		     obj_t aux_4209;
		     {	/* ./Object/class.scm 1778 */
			object_bglt aux_4210;
			aux_4210 =
			   (object_bglt) (class_75);
			aux_4209 =
			   OBJECT_WIDENING(aux_4210);
		     }
		     super_796 =
			(((tclass_bglt) CREF(aux_4209))->its_super_214);
		  }
		  {	/* Object/access.scm 129 */
		     bool_t inline__228_797;
		     {	/* Object/access.scm 130 */
			bool_t _ortest_1221_856;
			{	/* Object/access.scm 130 */
			   bool_t test1468_857;
			   {	/* Object/access.scm 130 */
			      bool_t res2633_2477;
			      {		/* Object/access.scm 130 */
				 obj_t obj_2473;
				 obj_2473 = _profile_mode__105_engine_param;
				 if (
				    INTEGERP(obj_2473))
				   {	/* ./Ieee/number.scm 6283 */
				      res2633_2477 = ((bool_t) 1);
				   }
				 else
				   {	/* ./Ieee/number.scm 6283 */
				      res2633_2477 =
					 REALP(obj_2473);
				   }
			      }
			      test1468_857 = res2633_2477;
			   }
			   if (test1468_857)
			     {	/* Object/access.scm 130 */
				_ortest_1221_856 = ((bool_t) 0);
			     }
			   else
			     {	/* Object/access.scm 130 */
				_ortest_1221_856 = ((bool_t) 1);
			     }
			}
			if (_ortest_1221_856)
			  {	/* Object/access.scm 130 */
			     inline__228_797 = _ortest_1221_856;
			  }
			else
			  {	/* Object/access.scm 131 */
			     long n1_2478;
			     n1_2478 =
				(long) CINT(_profile_mode__105_engine_param);
			     inline__228_797 =
				(n1_2478 < ((long) 1));
			  }
		     }
		     {	/* Object/access.scm 130 */

			{	/* Object/access.scm 132 */
			   bool_t test1400_798;
			   test1400_798 =
			      is_a__118___object(super_796, tclass_object_class);
			   if (test1400_798)
			     {	/* Object/access.scm 136 */
				obj_t super_pred_id_124_799;
				obj_t super_typed_158_800;
				{	/* Object/access.scm 136 */
				   obj_t list1458_848;
				   {	/* Object/access.scm 136 */
				      obj_t arg1459_849;
				      obj_t arg1461_850;
				      arg1459_849 =
					 CNST_TABLE_REF(((long) 10));
				      arg1461_850 =
					 MAKE_PAIR(pred_id_222_794, BNIL);
				      list1458_848 =
					 MAKE_PAIR(arg1459_849, arg1461_850);
				   }
				   super_pred_id_124_799 =
				      symbol_append_197___r4_symbols_6_4(list1458_848);
				}
				{	/* Object/access.scm 137 */
				   obj_t arg1462_851;
				   arg1462_851 =
				      CNST_TABLE_REF(((long) 11));
				   {	/* Object/access.scm 137 */
				      obj_t list1464_853;
				      {		/* Object/access.scm 137 */
					 obj_t arg1466_854;
					 {	/* Object/access.scm 137 */
					    obj_t arg1467_855;
					    {	/* Object/access.scm 137 */
					       obj_t aux_4228;
					       {	/* Object/access.scm 137 */
						  type_bglt obj_2481;
						  obj_2481 =
						     (type_bglt) (super_796);
						  aux_4228 =
						     (((type_bglt) CREF(obj_2481))->id);
					       }
					       arg1467_855 =
						  MAKE_PAIR(aux_4228, BNIL);
					    }
					    arg1466_854 =
					       MAKE_PAIR(_4dots_199_tools_misc, arg1467_855);
					 }
					 list1464_853 =
					    MAKE_PAIR(arg1462_851, arg1466_854);
				      }
				      super_typed_158_800 =
					 symbol_append_197___r4_symbols_6_4(list1464_853);
				   }
				}
				if (inline__228_797)
				  {	/* Object/access.scm 141 */
				     obj_t arg1401_801;
				     {	/* Object/access.scm 141 */
					obj_t arg1402_802;
					{	/* Object/access.scm 141 */
					   obj_t arg1403_803;
					   {	/* Object/access.scm 141 */
					      obj_t arg1405_805;
					      obj_t arg1406_806;
					      arg1405_805 =
						 CNST_TABLE_REF(((long) 12));
					      {		/* Object/access.scm 141 */
						 obj_t arg1409_807;
						 {	/* ./Ieee/pair-list.scm 5689 */
						    obj_t aux_4237;
						    aux_4237 =
						       CNST_TABLE_REF(((long) 13));
						    arg1409_807 =
						       MAKE_PAIR(aux_4237, BNIL);
						 }
						 arg1406_806 =
						    MAKE_PAIR(pred_id_222_794, arg1409_807);
					      }
					      arg1403_803 =
						 MAKE_PAIR(arg1405_805, arg1406_806);
					   }
					   arg1402_802 =
					      MAKE_PAIR(arg1403_803, BNIL);
					}
					arg1401_801 =
					   MAKE_PAIR(import_77, arg1402_802);
				     }
				     produce_module_clause__172_module_module(arg1401_801);
				  }
				else
				  {	/* Object/access.scm 143 */
				     obj_t arg1410_808;
				     {	/* Object/access.scm 143 */
					obj_t arg1411_809;
					{	/* Object/access.scm 143 */
					   obj_t arg1412_810;
					   {	/* Object/access.scm 143 */
					      obj_t arg1416_812;
					      {		/* ./Ieee/pair-list.scm 5689 */
						 obj_t aux_4245;
						 aux_4245 =
						    CNST_TABLE_REF(((long) 13));
						 arg1416_812 =
						    MAKE_PAIR(aux_4245, BNIL);
					      }
					      arg1412_810 =
						 MAKE_PAIR(pred_id_222_794, arg1416_812);
					   }
					   arg1411_809 =
					      MAKE_PAIR(arg1412_810, BNIL);
					}
					arg1410_808 =
					   MAKE_PAIR(import_77, arg1411_809);
				     }
				     produce_module_clause__172_module_module(arg1410_808);
				  }
				{	/* Object/access.scm 145 */
				   obj_t arg1417_813;
				   {	/* Object/access.scm 145 */
				      obj_t arg1419_814;
				      obj_t arg1420_815;
				      arg1419_814 =
					 CNST_TABLE_REF(((long) 4));
				      {		/* Object/access.scm 145 */
					 obj_t arg1422_816;
					 {	/* Object/access.scm 145 */
					    obj_t arg1425_818;
					    {	/* Object/access.scm 145 */
					       obj_t arg1426_819;
					       obj_t arg1427_820;
					       {	/* Object/access.scm 145 */
						  obj_t arg1428_821;
						  obj_t arg1430_822;
						  arg1428_821 =
						     CNST_TABLE_REF(((long) 14));
						  {	/* ./Ieee/pair-list.scm 5689 */
						     obj_t aux_4254;
						     {	/* Object/access.scm 145 */
							type_bglt obj_2500;
							obj_2500 =
							   (type_bglt) (class_75);
							aux_4254 =
							   (((type_bglt) CREF(obj_2500))->id);
						     }
						     arg1430_822 =
							MAKE_PAIR(aux_4254, BNIL);
						  }
						  arg1426_819 =
						     MAKE_PAIR(arg1428_821, arg1430_822);
					       }
					       {	/* ./Ieee/pair-list.scm 5689 */
						  obj_t aux_4259;
						  aux_4259 =
						     CNST_TABLE_REF(((long) 6));
						  arg1427_820 =
						     MAKE_PAIR(aux_4259, BNIL);
					       }
					       arg1425_818 =
						  MAKE_PAIR(arg1426_819, arg1427_820);
					    }
					    arg1422_816 =
					       MAKE_PAIR(id__219_793, arg1425_818);
					 }
					 arg1420_815 =
					    MAKE_PAIR(arg1422_816, BNIL);
				      }
				      arg1417_813 =
					 MAKE_PAIR(arg1419_814, arg1420_815);
				   }
				   produce_module_clause__172_module_module(arg1417_813);
				}
				{	/* Object/access.scm 148 */
				   obj_t arg1433_825;
				   {	/* Object/access.scm 148 */
				      obj_t arg1435_827;
				      {		/* Object/access.scm 148 */
					 obj_t arg1437_829;
					 obj_t arg1438_830;
					 if (inline__228_797)
					   {	/* Object/access.scm 148 */
					      arg1437_829 =
						 CNST_TABLE_REF(((long) 15));
					   }
					 else
					   {	/* Object/access.scm 148 */
					      arg1437_829 =
						 CNST_TABLE_REF(((long) 16));
					   }
					 {	/* Object/access.scm 149 */
					    obj_t arg1439_831;
					    obj_t arg1440_832;
					    {	/* Object/access.scm 149 */
					       obj_t arg1441_833;
					       {	/* ./Ieee/pair-list.scm 5689 */
						  obj_t aux_4270;
						  aux_4270 =
						     CNST_TABLE_REF(((long) 2));
						  arg1441_833 =
						     MAKE_PAIR(aux_4270, BNIL);
					       }
					       arg1439_831 =
						  MAKE_PAIR(pred_id_222_794, arg1441_833);
					    }
					    {	/* Object/access.scm 150 */
					       obj_t arg1442_834;
					       {	/* Object/access.scm 150 */
						  obj_t arg1444_836;
						  obj_t arg1445_837;
						  arg1444_836 =
						     CNST_TABLE_REF(((long) 17));
						  {	/* Object/access.scm 150 */
						     obj_t arg1446_838;
						     obj_t arg1447_839;
						     arg1446_838 =
							CNST_TABLE_REF(((long) 2));
						     {	/* Object/access.scm 151 */
							obj_t arg1449_840;
							{	/* Object/access.scm 151 */
							   obj_t arg1451_842;
							   obj_t arg1452_843;
							   arg1451_842 =
							      CNST_TABLE_REF(((long) 18));
							   {	/* Object/access.scm 151 */
							      obj_t arg1454_844;
							      obj_t arg1455_845;
							      arg1454_844 =
								 (((global_bglt) CREF(holder_795))->id);
							      {		/* ./Ieee/pair-list.scm 5689 */
								 obj_t aux_4278;
								 aux_4278 =
								    (((global_bglt) CREF(holder_795))->module);
								 arg1455_845 =
								    MAKE_PAIR(aux_4278, BNIL);
							      }
							      arg1452_843 =
								 MAKE_PAIR(arg1454_844, arg1455_845);
							   }
							   arg1449_840 =
							      MAKE_PAIR(arg1451_842, arg1452_843);
							}
							arg1447_839 =
							   MAKE_PAIR(arg1449_840, BNIL);
						     }
						     arg1445_837 =
							MAKE_PAIR(arg1446_838, arg1447_839);
						  }
						  arg1442_834 =
						     MAKE_PAIR(arg1444_836, arg1445_837);
					       }
					       arg1440_832 =
						  MAKE_PAIR(arg1442_834, BNIL);
					    }
					    arg1438_830 =
					       MAKE_PAIR(arg1439_831, arg1440_832);
					 }
					 arg1435_827 =
					    MAKE_PAIR(arg1437_829, arg1438_830);
				      }
				      {		/* Object/access.scm 148 */
					 obj_t list1436_828;
					 list1436_828 =
					    MAKE_PAIR(src_def_101_76, BNIL);
					 arg1433_825 =
					    epairify__149_object_access(arg1435_827, list1436_828);
				      }
				   }
				   {	/* Object/access.scm 147 */
				      obj_t list1434_826;
				      list1434_826 =
					 MAKE_PAIR(arg1433_825, BNIL);
				      return list1434_826;
				   }
				}
			     }
			   else
			     {	/* Object/access.scm 132 */
				return BNIL;
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-class-pred!2635 */
obj_t 
_make_class_pred_2635_231_object_access(obj_t env_3967, obj_t id_3968, obj_t class_3969, obj_t src_def_101_3970, obj_t import_3971)
{
   AN_OBJECT;
   {	/* Object/access.scm 125 */
      return
	 make_class_pred__174_object_access(id_3968,
	 (tclass_bglt) (class_3969), src_def_101_3970, import_3971);
   }
}



/* import-class-pred! */
obj_t 
import_class_pred__91_object_access(obj_t id_78, tclass_bglt class_79, obj_t src_def_101_80, obj_t module_81)
{
   AN_OBJECT;
   {	/* Object/access.scm 158 */
      {		/* Object/access.scm 159 */
	 obj_t id__219_862;
	 {	/* Object/access.scm 159 */
	    obj_t list1486_881;
	    {	/* Object/access.scm 159 */
	       obj_t arg1488_882;
	       {	/* Object/access.scm 159 */
		  obj_t aux_4294;
		  aux_4294 =
		     CNST_TABLE_REF(((long) 8));
		  arg1488_882 =
		     MAKE_PAIR(aux_4294, BNIL);
	       }
	       list1486_881 =
		  MAKE_PAIR(id_78, arg1488_882);
	    }
	    id__219_862 =
	       symbol_append_197___r4_symbols_6_4(list1486_881);
	 }
	 {	/* Object/access.scm 159 */
	    obj_t pred_id_222_863;
	    {	/* Object/access.scm 160 */
	       obj_t list1484_879;
	       {	/* Object/access.scm 160 */
		  obj_t arg1485_880;
		  {	/* Object/access.scm 160 */
		     obj_t aux_4299;
		     aux_4299 =
			CNST_TABLE_REF(((long) 9));
		     arg1485_880 =
			MAKE_PAIR(aux_4299, BNIL);
		  }
		  list1484_879 =
		     MAKE_PAIR(id_78, arg1485_880);
	       }
	       pred_id_222_863 =
		  symbol_append_197___r4_symbols_6_4(list1484_879);
	    }
	    {	/* Object/access.scm 161 */
	       obj_t super_865;
	       {
		  obj_t aux_4304;
		  {	/* ./Object/class.scm 1778 */
		     object_bglt aux_4305;
		     aux_4305 =
			(object_bglt) (class_79);
		     aux_4304 =
			OBJECT_WIDENING(aux_4305);
		  }
		  super_865 =
		     (((tclass_bglt) CREF(aux_4304))->its_super_214);
	       }
	       {	/* Object/access.scm 162 */

		  {	/* Object/access.scm 163 */
		     bool_t test1473_866;
		     test1473_866 =
			is_a__118___object(super_865, tclass_object_class);
		     if (test1473_866)
		       {	/* Object/access.scm 164 */
			  obj_t super_pred_id_124_867;
			  obj_t super_typed_158_868;
			  {	/* Object/access.scm 164 */
			     obj_t list1476_871;
			     {	/* Object/access.scm 164 */
				obj_t arg1477_872;
				obj_t arg1478_873;
				arg1477_872 =
				   CNST_TABLE_REF(((long) 10));
				arg1478_873 =
				   MAKE_PAIR(pred_id_222_863, BNIL);
				list1476_871 =
				   MAKE_PAIR(arg1477_872, arg1478_873);
			     }
			     super_pred_id_124_867 =
				symbol_append_197___r4_symbols_6_4(list1476_871);
			  }
			  {	/* Object/access.scm 165 */
			     obj_t arg1479_874;
			     arg1479_874 =
				CNST_TABLE_REF(((long) 11));
			     {	/* Object/access.scm 165 */
				obj_t list1481_876;
				{	/* Object/access.scm 165 */
				   obj_t arg1482_877;
				   {	/* Object/access.scm 165 */
				      obj_t arg1483_878;
				      {		/* Object/access.scm 165 */
					 obj_t aux_4316;
					 {	/* Object/access.scm 165 */
					    type_bglt obj_2543;
					    obj_2543 =
					       (type_bglt) (super_865);
					    aux_4316 =
					       (((type_bglt) CREF(obj_2543))->id);
					 }
					 arg1483_878 =
					    MAKE_PAIR(aux_4316, BNIL);
				      }
				      arg1482_877 =
					 MAKE_PAIR(_4dots_199_tools_misc, arg1483_878);
				   }
				   list1481_876 =
				      MAKE_PAIR(arg1479_874, arg1482_877);
				}
				super_typed_158_868 =
				   symbol_append_197___r4_symbols_6_4(list1481_876);
			     }
			  }
			  {	/* Object/access.scm 167 */
			     obj_t arg1474_869;
			     {	/* Object/access.scm 167 */
				obj_t arg1475_870;
				{	/* ./Ieee/pair-list.scm 5689 */
				   obj_t aux_4323;
				   aux_4323 =
				      CNST_TABLE_REF(((long) 13));
				   arg1475_870 =
				      MAKE_PAIR(aux_4323, BNIL);
				}
				arg1474_869 =
				   MAKE_PAIR(pred_id_222_863, arg1475_870);
			     }
			     return
				import_parser_53_module_impuse(module_81, arg1474_869);
			  }
		       }
		     else
		       {	/* Object/access.scm 163 */
			  return BUNSPEC;
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* _import-class-pred!2636 */
obj_t 
_import_class_pred_2636_91_object_access(obj_t env_3972, obj_t id_3973, obj_t class_3974, obj_t src_def_101_3975, obj_t module_3976)
{
   AN_OBJECT;
   {	/* Object/access.scm 158 */
      return
	 import_class_pred__91_object_access(id_3973,
	 (tclass_bglt) (class_3974), src_def_101_3975, module_3976);
   }
}



/* make-class-makes! */
obj_t 
make_class_makes__132_object_access(obj_t widening_82, obj_t mk_id_77_83, obj_t id_84, obj_t type_85, obj_t slots_86, obj_t src_def_101_87, obj_t import_88)
{
   AN_OBJECT;
   {	/* Object/access.scm 172 */
      {		/* Object/access.scm 173 */
	 bool_t test_4330;
	 {	/* Object/access.scm 173 */
	    obj_t aux_4331;
	    aux_4331 =
	       memq___r4_pairs_and_lists_6_3(widening_82,
	       CNST_TABLE_REF(((long) 19)));
	    test_4330 =
	       CBOOL(aux_4331);
	 }
	 if (test_4330)
	   {	/* Object/access.scm 173 */
	      BUNSPEC;
	   }
	 else
	   {	/* Object/access.scm 173 */
	      {		/* Object/access.scm 173 */
		 obj_t arg1490_884;
		 obj_t arg1491_885;
		 arg1490_884 =
		    CNST_TABLE_REF(((long) 20));
		 arg1491_885 =
		    __EVMEANING_ADDRESS(widening_82);
		 define_primop_ref__105___evenv(arg1490_884, arg1491_885);
	      }
	      notify_assert_fail_37___eval(
		 CNST_TABLE_REF(((long) 21)),
		 CNST_TABLE_REF(((long) 22)),
		 CNST_TABLE_REF(((long) 23)));
	      unbind_primop__163___evenv(
		 CNST_TABLE_REF(((long) 20)));
	   }
      }
      {		/* Object/access.scm 174 */
	 obj_t mk_heap_id_73_886;
	 {	/* Object/access.scm 174 */
	    obj_t list1495_889;
	    {	/* Object/access.scm 174 */
	       obj_t arg1496_890;
	       {	/* Object/access.scm 174 */
		  obj_t arg1497_891;
		  obj_t arg1498_892;
		  arg1497_891 =
		     CNST_TABLE_REF(((long) 24));
		  arg1498_892 =
		     MAKE_PAIR(id_84, BNIL);
		  arg1496_890 =
		     MAKE_PAIR(arg1497_891, arg1498_892);
	       }
	       list1495_889 =
		  MAKE_PAIR(mk_id_77_83, arg1496_890);
	    }
	    mk_heap_id_73_886 =
	       symbol_append_197___r4_symbols_6_4(list1495_889);
	 }
	 {	/* Object/access.scm 175 */
	    obj_t arg1493_887;
	    arg1493_887 =
	       make_class_make__196_object_access(widening_82, malloc_env_105_object_tools, mk_heap_id_73_886, id_84, type_85, slots_86, src_def_101_87, import_88);
	    {	/* Object/access.scm 175 */
	       obj_t list1494_888;
	       list1494_888 =
		  MAKE_PAIR(arg1493_887, BNIL);
	       return list1494_888;
	    }
	 }
      }
   }
}



/* _make-class-makes! */
obj_t 
_make_class_makes__119_object_access(obj_t env_3977, obj_t widening_3978, obj_t mk_id_77_3979, obj_t id_3980, obj_t type_3981, obj_t slots_3982, obj_t src_def_101_3983, obj_t import_3984)
{
   AN_OBJECT;
   {	/* Object/access.scm 172 */
      return
	 make_class_makes__132_object_access(widening_3978, mk_id_77_3979, id_3980, type_3981, slots_3982, src_def_101_3983, import_3984);
   }
}



/* make-class-make-formals */
obj_t 
make_class_make_formals_23_object_access(obj_t slots_89)
{
   AN_OBJECT;
   {	/* Object/access.scm 182 */
      {
	 obj_t slots_893;
	 obj_t formals_894;
	 slots_893 = slots_89;
	 formals_894 = BNIL;
       loop_895:
	 if (
	    NULLP(slots_893))
	   {	/* Object/access.scm 186 */
	      return
		 reverse__39___r4_pairs_and_lists_6_3(formals_894);
	   }
	 else
	   {	/* Object/access.scm 188 */
	      bool_t test_4355;
	      {		/* ./Llib/struct.scm 1457 */
		 obj_t aux_4356;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_4357;
		    aux_4357 =
		       CAR(slots_893);
		    aux_4356 =
		       STRUCT_REF(aux_4357, ((long) 11));
		 }
		 test_4355 =
		    CBOOL(aux_4356);
	      }
	      if (test_4355)
		{	/* Object/access.scm 188 */
		   {
		      obj_t slots_4361;
		      slots_4361 =
			 CDR(slots_893);
		      slots_893 = slots_4361;
		      goto loop_895;
		   }
		}
	      else
		{	/* Object/access.scm 188 */
		   {	/* Object/access.scm 191 */
		      obj_t arg1502_899;
		      obj_t arg1503_900;
		      arg1502_899 =
			 CDR(slots_893);
		      {		/* ./Ieee/pair-list.scm 5689 */
			 obj_t aux_4364;
			 {	/* ./Llib/struct.scm 1457 */
			    obj_t aux_4365;
			    aux_4365 =
			       CAR(slots_893);
			    aux_4364 =
			       STRUCT_REF(aux_4365, ((long) 0));
			 }
			 arg1503_900 =
			    MAKE_PAIR(aux_4364, formals_894);
		      }
		      {
			 obj_t formals_4370;
			 obj_t slots_4369;
			 slots_4369 = arg1502_899;
			 formals_4370 = arg1503_900;
			 formals_894 = formals_4370;
			 slots_893 = slots_4369;
			 goto loop_895;
		      }
		   }
		}
	   }
      }
   }
}



/* _make-class-make-formals */
obj_t 
_make_class_make_formals_78_object_access(obj_t env_3988, obj_t slots_3989)
{
   AN_OBJECT;
   {	/* Object/access.scm 182 */
      return
	 make_class_make_formals_23_object_access(slots_3989);
   }
}



/* make-class-make-typed-formals */
obj_t 
make_class_make_typed_formals_184_object_access(obj_t slots_90)
{
   AN_OBJECT;
   {	/* Object/access.scm 198 */
      {
	 obj_t slots_904;
	 obj_t formals_905;
	 slots_904 = slots_90;
	 formals_905 = BNIL;
       loop_906:
	 if (
	    NULLP(slots_904))
	   {	/* Object/access.scm 202 */
	      return
		 reverse__39___r4_pairs_and_lists_6_3(formals_905);
	   }
	 else
	   {	/* Object/access.scm 204 */
	      bool_t test_4375;
	      {		/* ./Llib/struct.scm 1457 */
		 obj_t aux_4376;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_4377;
		    aux_4377 =
		       CAR(slots_904);
		    aux_4376 =
		       STRUCT_REF(aux_4377, ((long) 11));
		 }
		 test_4375 =
		    CBOOL(aux_4376);
	      }
	      if (test_4375)
		{	/* Object/access.scm 204 */
		   {
		      obj_t slots_4381;
		      slots_4381 =
			 CDR(slots_904);
		      slots_904 = slots_4381;
		      goto loop_906;
		   }
		}
	      else
		{	/* Object/access.scm 204 */
		   {	/* Object/access.scm 207 */
		      obj_t arg1510_910;
		      obj_t arg1511_911;
		      arg1510_910 =
			 CDR(slots_904);
		      {		/* Object/access.scm 208 */
			 obj_t arg1512_912;
			 {	/* Object/access.scm 208 */
			    obj_t arg1513_913;
			    {	/* ./Llib/struct.scm 1457 */
			       obj_t aux_4384;
			       aux_4384 =
				  CAR(slots_904);
			       arg1513_913 =
				  STRUCT_REF(aux_4384, ((long) 0));
			    }
			    {	/* Object/access.scm 208 */
			       obj_t list1515_915;
			       {	/* Object/access.scm 208 */
				  obj_t arg1516_916;
				  {	/* Object/access.scm 208 */
				     obj_t arg1517_917;
				     {	/* Object/access.scm 208 */
					obj_t aux_4387;
					{	/* Object/access.scm 210 */
					   type_bglt obj_2577;
					   {	/* Object/access.scm 210 */
					      obj_t aux_4388;
					      {		/* ./Llib/struct.scm 1457 */
						 obj_t aux_4389;
						 aux_4389 =
						    CAR(slots_904);
						 aux_4388 =
						    STRUCT_REF(aux_4389, ((long) 2));
					      }
					      obj_2577 =
						 (type_bglt) (aux_4388);
					   }
					   aux_4387 =
					      (((type_bglt) CREF(obj_2577))->id);
					}
					arg1517_917 =
					   MAKE_PAIR(aux_4387, BNIL);
				     }
				     arg1516_916 =
					MAKE_PAIR(_4dots_199_tools_misc, arg1517_917);
				  }
				  list1515_915 =
				     MAKE_PAIR(arg1513_913, arg1516_916);
			       }
			       arg1512_912 =
				  symbol_append_197___r4_symbols_6_4(list1515_915);
			    }
			 }
			 arg1511_911 =
			    MAKE_PAIR(arg1512_912, formals_905);
		      }
		      {
			 obj_t formals_4400;
			 obj_t slots_4399;
			 slots_4399 = arg1510_910;
			 formals_4400 = arg1511_911;
			 formals_905 = formals_4400;
			 slots_904 = slots_4399;
			 goto loop_906;
		      }
		   }
		}
	   }
      }
   }
}



/* _make-class-make-typed-formals */
obj_t 
_make_class_make_typed_formals_151_object_access(obj_t env_3990, obj_t slots_3991)
{
   AN_OBJECT;
   {	/* Object/access.scm 198 */
      return
	 make_class_make_typed_formals_184_object_access(slots_3991);
   }
}



/* make-class-make! */
obj_t 
make_class_make__196_object_access(obj_t widening_91, obj_t alloc_92, obj_t mk_id_77_93, obj_t id_94, obj_t type_95, obj_t slots_96, obj_t src_def_101_97, obj_t import_98)
{
   AN_OBJECT;
   {	/* Object/access.scm 219 */
      {		/* Object/access.scm 220 */
	 obj_t tid_922;
	 {	/* Object/access.scm 220 */
	    type_bglt obj_2580;
	    obj_2580 =
	       (type_bglt) (type_95);
	    tid_922 =
	       (((type_bglt) CREF(obj_2580))->id);
	 }
	 {	/* Object/access.scm 220 */
	    global_bglt holder_923;
	    {	/* Object/access.scm 221 */
	       tclass_bglt obj_2581;
	       obj_2581 =
		  (tclass_bglt) (type_95);
	       {
		  obj_t aux_4405;
		  {	/* ./Object/class.scm 1784 */
		     object_bglt aux_4406;
		     aux_4406 =
			(object_bglt) (obj_2581);
		     aux_4405 =
			OBJECT_WIDENING(aux_4406);
		  }
		  holder_923 =
		     (((tclass_bglt) CREF(aux_4405))->holder);
	       }
	    }
	    {	/* Object/access.scm 221 */
	       obj_t constrs_924;
	       constrs_924 =
		  find_class_constructors_231_object_class(
		  (tclass_bglt) (type_95));
	       {	/* Object/access.scm 222 */
		  obj_t mk_tid_99_925;
		  {	/* Object/access.scm 223 */
		     obj_t list1621_1040;
		     {	/* Object/access.scm 223 */
			obj_t arg1622_1041;
			{	/* Object/access.scm 223 */
			   obj_t arg1623_1042;
			   arg1623_1042 =
			      MAKE_PAIR(tid_922, BNIL);
			   arg1622_1041 =
			      MAKE_PAIR(_4dots_199_tools_misc, arg1623_1042);
			}
			list1621_1040 =
			   MAKE_PAIR(mk_id_77_93, arg1622_1041);
		     }
		     mk_tid_99_925 =
			symbol_append_197___r4_symbols_6_4(list1621_1040);
		  }
		  {	/* Object/access.scm 223 */
		     obj_t f_ids_164_926;
		     f_ids_164_926 =
			make_class_make_formals_23_object_access(slots_96);
		     {	/* Object/access.scm 224 */
			obj_t f_tids_193_927;
			f_tids_193_927 =
			   make_class_make_typed_formals_184_object_access(slots_96);
			{	/* Object/access.scm 225 */
			   obj_t new_928;
			   new_928 =
			      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			      CNST_TABLE_REF(((long) 25)), BEOA);
			   {	/* Object/access.scm 226 */
			      obj_t rid_929;
			      rid_929 =
				 PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				 CNST_TABLE_REF(((long) 26)), BEOA);
			      {		/* Object/access.scm 227 */
				 obj_t rtid_930;
				 {	/* Object/access.scm 228 */
				    obj_t list1619_1038;
				    {	/* Object/access.scm 228 */
				       obj_t arg1620_1039;
				       {	/* Object/access.scm 228 */
					  obj_t aux_4424;
					  aux_4424 =
					     CNST_TABLE_REF(((long) 27));
					  arg1620_1039 =
					     MAKE_PAIR(aux_4424, BNIL);
				       }
				       list1619_1038 =
					  MAKE_PAIR(rid_929, arg1620_1039);
				    }
				    rtid_930 =
				       symbol_append_197___r4_symbols_6_4(list1619_1038);
				 }
				 {	/* Object/access.scm 228 */
				    bool_t inline__228_931;
				    {	/* Object/access.scm 229 */
				       bool_t _andtest_1222_1035;
				       {	/* Object/access.scm 229 */
					  long n1_2582;
					  n1_2582 =
					     (long) CINT(_optim__89_engine_param);
					  _andtest_1222_1035 =
					     (n1_2582 >= ((long) 2));
				       }
				       if (_andtest_1222_1035)
					 {	/* Object/access.scm 230 */
					    bool_t _ortest_1223_1036;
					    {	/* Object/access.scm 230 */
					       bool_t test1618_1037;
					       {	/* Object/access.scm 230 */
						  bool_t res2634_2588;
						  {	/* Object/access.scm 230 */
						     obj_t obj_2584;
						     obj_2584 = _profile_mode__105_engine_param;
						     if (
							INTEGERP(obj_2584))
						       {	/* ./Ieee/number.scm 6283 */
							  res2634_2588 = ((bool_t) 1);
						       }
						     else
						       {	/* ./Ieee/number.scm 6283 */
							  res2634_2588 =
							     REALP(obj_2584);
						       }
						  }
						  test1618_1037 = res2634_2588;
					       }
					       if (test1618_1037)
						 {	/* Object/access.scm 230 */
						    _ortest_1223_1036 = ((bool_t) 0);
						 }
					       else
						 {	/* Object/access.scm 230 */
						    _ortest_1223_1036 = ((bool_t) 1);
						 }
					    }
					    if (_ortest_1223_1036)
					      {		/* Object/access.scm 230 */
						 inline__228_931 = _ortest_1223_1036;
					      }
					    else
					      {		/* Object/access.scm 231 */
						 long n1_2589;
						 n1_2589 =
						    (long) CINT(_profile_mode__105_engine_param);
						 inline__228_931 =
						    (n1_2589 < ((long) 1));
					      }
					 }
				       else
					 {	/* Object/access.scm 229 */
					    inline__228_931 = ((bool_t) 0);
					 }
				    }
				    {	/* Object/access.scm 229 */

				       {	/* Object/access.scm 234 */
					  obj_t arg1523_932;
					  {	/* Object/access.scm 234 */
					     obj_t arg1525_933;
					     {	/* Object/access.scm 234 */
						obj_t arg1526_934;
						{	/* Object/access.scm 234 */
						   obj_t arg1528_936;
						   obj_t arg1529_937;
						   if (inline__228_931)
						     {	/* Object/access.scm 234 */
							arg1528_936 =
							   CNST_TABLE_REF(((long) 28));
						     }
						   else
						     {	/* Object/access.scm 234 */
							arg1528_936 = BNIL;
						     }
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_4441;
						      aux_4441 =
							 append_2_18___r4_pairs_and_lists_6_3(f_tids_193_927, BNIL);
						      arg1529_937 =
							 MAKE_PAIR(mk_tid_99_925, aux_4441);
						   }
						   arg1526_934 =
						      append_2_18___r4_pairs_and_lists_6_3(arg1528_936, arg1529_937);
						}
						arg1525_933 =
						   MAKE_PAIR(arg1526_934, BNIL);
					     }
					     arg1523_932 =
						MAKE_PAIR(import_98, arg1525_933);
					  }
					  produce_module_clause__172_module_module(arg1523_932);
				       }
				       {	/* Object/access.scm 236 */
					  obj_t arg1532_939;
					  {	/* Object/access.scm 236 */
					     obj_t arg1533_940;
					     obj_t arg1534_941;
					     arg1533_940 =
						CNST_TABLE_REF(((long) 4));
					     {	/* Object/access.scm 236 */
						obj_t arg1535_942;
						{	/* Object/access.scm 236 */
						   obj_t arg1537_944;
						   {	/* ./Ieee/pair-list.scm 5689 */
						      obj_t aux_4449;
						      aux_4449 =
							 CNST_TABLE_REF(((long) 29));
						      arg1537_944 =
							 MAKE_PAIR(aux_4449, BNIL);
						   }
						   arg1535_942 =
						      MAKE_PAIR(mk_id_77_93, arg1537_944);
						}
						arg1534_941 =
						   MAKE_PAIR(arg1535_942, BNIL);
					     }
					     arg1532_939 =
						MAKE_PAIR(arg1533_940, arg1534_941);
					  }
					  produce_module_clause__172_module_module(arg1532_939);
				       }
				       {	/* Object/access.scm 239 */
					  obj_t arg1539_945;
					  {	/* Object/access.scm 239 */
					     obj_t arg1541_947;
					     obj_t arg1543_948;
					     if (inline__228_931)
					       {	/* Object/access.scm 239 */
						  arg1541_947 =
						     CNST_TABLE_REF(((long) 15));
					       }
					     else
					       {	/* Object/access.scm 239 */
						  arg1541_947 =
						     CNST_TABLE_REF(((long) 16));
					       }
					     {	/* Object/access.scm 240 */
						obj_t arg1544_949;
						obj_t arg1545_950;
						{	/* ./Ieee/pair-list.scm 5689 */
						   obj_t aux_4459;
						   aux_4459 =
						      append_2_18___r4_pairs_and_lists_6_3(f_tids_193_927, BNIL);
						   arg1544_949 =
						      MAKE_PAIR(mk_tid_99_925, aux_4459);
						}
						{	/* Object/access.scm 241 */
						   obj_t arg1548_952;
						   {	/* Object/access.scm 241 */
						      obj_t arg1550_954;
						      obj_t arg1551_955;
						      arg1550_954 =
							 CNST_TABLE_REF(((long) 30));
						      {		/* Object/access.scm 241 */
							 obj_t arg1552_956;
							 obj_t arg1553_957;
							 {	/* Object/access.scm 241 */
							    obj_t arg1555_958;
							    {	/* Object/access.scm 241 */
							       obj_t arg1557_960;
							       obj_t arg1558_961;
							       {	/* Object/access.scm 241 */
								  obj_t list1559_962;
								  {	/* Object/access.scm 241 */
								     obj_t arg1560_963;
								     {	/* Object/access.scm 241 */
									obj_t arg1561_964;
									arg1561_964 =
									   MAKE_PAIR(tid_922, BNIL);
									arg1560_963 =
									   MAKE_PAIR(_4dots_199_tools_misc, arg1561_964);
								     }
								     list1559_962 =
									MAKE_PAIR(new_928, arg1560_963);
								  }
								  arg1557_960 =
								     symbol_append_197___r4_symbols_6_4(list1559_962);
							       }
							       {	/* Object/access.scm 241 */
								  obj_t arg1562_965;
								  arg1562_965 =
								     PROCEDURE_ENTRY(alloc_92) (alloc_92, type_95,
								     BINT(((long) 1)), BEOA);
								  arg1558_961 =
								     MAKE_PAIR(arg1562_965, BNIL);
							       }
							       arg1555_958 =
								  MAKE_PAIR(arg1557_960, arg1558_961);
							    }
							    arg1552_956 =
							       MAKE_PAIR(arg1555_958, BNIL);
							 }
							 {	/* Object/access.scm 242 */
							    obj_t arg1564_967;
							    obj_t arg1565_968;
							    {	/* Object/access.scm 242 */
							       bool_t test_4473;
							       {	/* ./Ieee/equiv.scm 5508 */
								  obj_t aux_4474;
								  aux_4474 =
								     CNST_TABLE_REF(((long) 20));
								  test_4473 =
								     (widening_91 == aux_4474);
							       }
							       if (test_4473)
								 {	/* Object/access.scm 242 */
								    arg1564_967 = BNIL;
								 }
							       else
								 {	/* Object/access.scm 243 */
								    obj_t arg1567_970;
								    obj_t arg1568_971;
								    {	/* Object/access.scm 243 */
								       obj_t arg1569_972;
								       obj_t arg1571_973;
								       arg1569_972 =
									  CNST_TABLE_REF(((long) 31));
								       {	/* Object/access.scm 245 */
									  obj_t arg1572_974;
									  {	/* Object/access.scm 245 */
									     obj_t arg1573_975;
									     {	/* Object/access.scm 245 */
										obj_t arg1577_977;
										obj_t arg1578_978;
										arg1577_977 =
										   CNST_TABLE_REF(((long) 32));
										{	/* Object/access.scm 245 */
										   obj_t arg1579_979;
										   {	/* Object/access.scm 245 */
										      obj_t arg1581_981;
										      obj_t arg1582_982;
										      arg1581_981 =
											 CNST_TABLE_REF(((long) 18));
										      {		/* Object/access.scm 245 */
											 obj_t arg1583_983;
											 obj_t arg1584_984;
											 arg1583_983 =
											    (((global_bglt) CREF(holder_923))->id);
											 {	/* ./Ieee/pair-list.scm 5689 */
											    obj_t aux_4481;
											    aux_4481 =
											       (((global_bglt) CREF(holder_923))->module);
											    arg1584_984 =
											       MAKE_PAIR(aux_4481, BNIL);
											 }
											 arg1582_982 =
											    MAKE_PAIR(arg1583_983, arg1584_984);
										      }
										      arg1579_979 =
											 MAKE_PAIR(arg1581_981, arg1582_982);
										   }
										   arg1578_978 =
										      MAKE_PAIR(arg1579_979, BNIL);
										}
										arg1573_975 =
										   MAKE_PAIR(arg1577_977, arg1578_978);
									     }
									     arg1572_974 =
										MAKE_PAIR(arg1573_975, BNIL);
									  }
									  arg1571_973 =
									     MAKE_PAIR(new_928, arg1572_974);
								       }
								       arg1567_970 =
									  MAKE_PAIR(arg1569_972, arg1571_973);
								    }
								    {	/* Object/access.scm 247 */
								       obj_t arg1587_987;
								       {	/* Object/access.scm 247 */
									  obj_t arg1589_989;
									  obj_t arg1590_990;
									  arg1589_989 =
									     CNST_TABLE_REF(((long) 33));
									  {	/* Object/access.scm 247 */
									     obj_t arg1591_991;
									     arg1591_991 =
										MAKE_PAIR(BFALSE, BNIL);
									     arg1590_990 =
										MAKE_PAIR(new_928, arg1591_991);
									  }
									  arg1587_987 =
									     MAKE_PAIR(arg1589_989, arg1590_990);
								       }
								       arg1568_971 =
									  MAKE_PAIR(arg1587_987, BNIL);
								    }
								    arg1564_967 =
								       MAKE_PAIR(arg1567_970, arg1568_971);
								 }
							    }
							    {	/* Object/access.scm 249 */
							       obj_t arg1592_992;
							       {	/* Object/access.scm 249 */
								  obj_t arg1594_994;
								  obj_t arg1595_995;
								  arg1594_994 =
								     CNST_TABLE_REF(((long) 30));
								  {	/* Object/access.scm 249 */
								     obj_t arg1596_996;
								     obj_t arg1597_997;
								     if (
									NULLP(f_tids_193_927))
								       {	/* Object/access.scm 249 */
									  arg1596_996 = BNIL;
								       }
								     else
								       {	/* Object/access.scm 249 */
									  obj_t head1226_1001;
									  head1226_1001 =
									     MAKE_PAIR(BNIL, BNIL);
									  {
									     obj_t ll1224_1002;
									     obj_t ll1225_1003;
									     obj_t tail1227_1004;
									     ll1224_1002 = f_tids_193_927;
									     ll1225_1003 = f_ids_164_926;
									     tail1227_1004 = head1226_1001;
									   lname1229_1005:
									     if (
										NULLP(ll1224_1002))
									       {	/* Object/access.scm 249 */
										  arg1596_996 =
										     CDR(head1226_1001);
									       }
									     else
									       {	/* Object/access.scm 249 */
										  obj_t newtail1228_1007;
										  {	/* Object/access.scm 249 */
										     obj_t arg1602_1010;
										     {	/* Object/access.scm 249 */
											obj_t ft_1012;
											ft_1012 =
											   CAR(ll1224_1002);
											{	/* Object/access.scm 249 */
											   obj_t arg1604_1014;
											   {	/* ./Ieee/pair-list.scm 5689 */
											      obj_t aux_4505;
											      aux_4505 =
												 CAR(ll1225_1003);
											      arg1604_1014 =
												 MAKE_PAIR(aux_4505, BNIL);
											   }
											   arg1602_1010 =
											      MAKE_PAIR(ft_1012, arg1604_1014);
											}
										     }
										     newtail1228_1007 =
											MAKE_PAIR(arg1602_1010, BNIL);
										  }
										  SET_CDR(tail1227_1004, newtail1228_1007);
										  {
										     obj_t tail1227_4515;
										     obj_t ll1225_4513;
										     obj_t ll1224_4511;
										     ll1224_4511 =
											CDR(ll1224_1002);
										     ll1225_4513 =
											CDR(ll1225_1003);
										     tail1227_4515 = newtail1228_1007;
										     tail1227_1004 = tail1227_4515;
										     ll1225_1003 = ll1225_4513;
										     ll1224_1002 = ll1224_4511;
										     goto lname1229_1005;
										  }
									       }
									  }
								       }
								     {	/* Object/access.scm 250 */
									obj_t arg1605_1015;
									obj_t arg1606_1016;
									arg1605_1015 =
									   make_class_slot_make__242_object_access(type_95, new_928, rid_929, rtid_930, slots_96, f_ids_164_926);
									{	/* Object/access.scm 251 */
									   obj_t arg1607_1017;
									   obj_t arg1608_1018;
									   {	/* Object/access.scm 251 */
									      bool_t test_4517;
									      if (
										 PAIRP(constrs_924))
										{	/* Object/access.scm 252 */
										   bool_t test_4520;
										   {	/* ./Ieee/equiv.scm 5508 */
										      obj_t aux_4521;
										      aux_4521 =
											 CNST_TABLE_REF(((long) 20));
										      test_4520 =
											 (widening_91 == aux_4521);
										   }
										   if (test_4520)
										     {	/* Object/access.scm 252 */
											test_4517 = ((bool_t) 0)
											   ;
										     }
										   else
										     {	/* Object/access.scm 252 */
											test_4517 = ((bool_t) 1)
											   ;
										     }
										}
									      else
										{	/* Object/access.scm 251 */
										   test_4517 = ((bool_t) 0)
										      ;
										}
									      if (test_4517)
										{	/* Object/access.scm 251 */
										   if (
										      NULLP(constrs_924))
										     {	/* Object/access.scm 253 */
											arg1607_1017 = BNIL;
										     }
										   else
										     {	/* Object/access.scm 253 */
											obj_t head1232_1022;
											head1232_1022 =
											   MAKE_PAIR(BNIL, BNIL);
											{
											   obj_t l1230_1023;
											   obj_t tail1233_1024;
											   l1230_1023 = constrs_924;
											   tail1233_1024 = head1232_1022;
											 lname1231_1025:
											   if (
											      NULLP(l1230_1023))
											     {	/* Object/access.scm 253 */
												arg1607_1017 =
												   CDR(head1232_1022);
											     }
											   else
											     {	/* Object/access.scm 254 */
												obj_t newtail1234_1027;
												{	/* Object/access.scm 254 */
												   obj_t arg1613_1029;
												   {	/* Object/access.scm 254 */
												      obj_t constr_1031;
												      constr_1031 =
													 CAR(l1230_1023);
												      {		/* Object/access.scm 254 */
													 obj_t arg1615_1032;
													 arg1615_1032 =
													    MAKE_PAIR(new_928, BNIL);
													 arg1613_1029 =
													    MAKE_PAIR(constr_1031, arg1615_1032);
												      }
												   }
												   newtail1234_1027 =
												      MAKE_PAIR(arg1613_1029, BNIL);
												}
												SET_CDR(tail1233_1024, newtail1234_1027);
												{
												   obj_t tail1233_4537;
												   obj_t l1230_4535;
												   l1230_4535 =
												      CDR(l1230_1023);
												   tail1233_4537 = newtail1234_1027;
												   tail1233_1024 = tail1233_4537;
												   l1230_1023 = l1230_4535;
												   goto lname1231_1025;
												}
											     }
											}
										     }
										}
									      else
										{	/* Object/access.scm 251 */
										   arg1607_1017 = BNIL;
										}
									   }
									   arg1608_1018 =
									      MAKE_PAIR(new_928, BNIL);
									   arg1606_1016 =
									      append_2_18___r4_pairs_and_lists_6_3(arg1607_1017, arg1608_1018);
									}
									arg1597_997 =
									   append_2_18___r4_pairs_and_lists_6_3(arg1605_1015, arg1606_1016);
								     }
								     arg1595_995 =
									MAKE_PAIR(arg1596_996, arg1597_997);
								  }
								  arg1592_992 =
								     MAKE_PAIR(arg1594_994, arg1595_995);
							       }
							       arg1565_968 =
								  MAKE_PAIR(arg1592_992, BNIL);
							    }
							    arg1553_957 =
							       append_2_18___r4_pairs_and_lists_6_3(arg1564_967, arg1565_968);
							 }
							 arg1551_955 =
							    MAKE_PAIR(arg1552_956, arg1553_957);
						      }
						      arg1548_952 =
							 MAKE_PAIR(arg1550_954, arg1551_955);
						   }
						   arg1545_950 =
						      MAKE_PAIR(arg1548_952, BNIL);
						}
						arg1543_948 =
						   MAKE_PAIR(arg1544_949, arg1545_950);
					     }
					     arg1539_945 =
						MAKE_PAIR(arg1541_947, arg1543_948);
					  }
					  {	/* Object/access.scm 239 */
					     obj_t list1540_946;
					     list1540_946 =
						MAKE_PAIR(src_def_101_97, BNIL);
					     return
						epairify__149_object_access(arg1539_945, list1540_946);
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* make-class-slot-make! */
obj_t 
make_class_slot_make__242_object_access(obj_t type_99, obj_t new_100, obj_t rid_101, obj_t rtid_102, obj_t slots_103, obj_t f_ids_164_104)
{
   AN_OBJECT;
   {	/* Object/access.scm 263 */
      {
	 obj_t slot_1058;
	 obj_t formal_1059;
	 {
	    obj_t slots_1044;
	    obj_t f_ids_164_1045;
	    obj_t res_1046;
	    slots_1044 = slots_103;
	    f_ids_164_1045 = f_ids_164_104;
	    res_1046 = BNIL;
	  loop_1047:
	    if (
	       NULLP(slots_1044))
	      {		/* Object/access.scm 318 */
		 return
		    reverse__39___r4_pairs_and_lists_6_3(res_1046);
	      }
	    else
	      {		/* Object/access.scm 320 */
		 bool_t test_4555;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_4556;
		    {	/* ./Llib/struct.scm 1457 */
		       obj_t aux_4557;
		       aux_4557 =
			  CAR(slots_1044);
		       aux_4556 =
			  STRUCT_REF(aux_4557, ((long) 11));
		    }
		    test_4555 =
		       CBOOL(aux_4556);
		 }
		 if (test_4555)
		   {	/* Object/access.scm 320 */
		      {
			 obj_t slots_4561;
			 slots_4561 =
			    CDR(slots_1044);
			 slots_1044 = slots_4561;
			 goto loop_1047;
		      }
		   }
		 else
		   {	/* Object/access.scm 320 */
		      {		/* Object/access.scm 323 */
			 obj_t arg1627_1051;
			 obj_t arg1628_1052;
			 obj_t arg1629_1053;
			 arg1627_1051 =
			    CDR(slots_1044);
			 arg1628_1052 =
			    CDR(f_ids_164_1045);
			 {	/* Object/access.scm 325 */
			    obj_t arg1630_1054;
			    slot_1058 =
			       CAR(slots_1044);
			    formal_1059 =
			       CAR(f_ids_164_1045);
			    {	/* Object/access.scm 265 */
			       obj_t loop_1061;
			       loop_1061 =
				  PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
				  CNST_TABLE_REF(((long) 34)), BEOA);
			       {	/* Object/access.scm 267 */
				  bool_t test_4568;
				  {	/* ./Llib/struct.scm 1457 */
				     obj_t aux_4569;
				     aux_4569 =
					STRUCT_REF(slot_1058, ((long) 5));
				     test_4568 =
					CBOOL(aux_4569);
				  }
				  if (test_4568)
				    {	/* Object/access.scm 267 */
				       {	/* Object/access.scm 270 */
					  obj_t arg1636_1063;
					  obj_t arg1637_1064;
					  arg1636_1063 =
					     CNST_TABLE_REF(((long) 35));
					  {	/* Object/access.scm 275 */
					     obj_t arg1638_1065;
					     obj_t arg1639_1066;
					     {	/* Object/access.scm 275 */
						obj_t arg1640_1067;
						{	/* Object/access.scm 275 */
						   obj_t arg1641_1068;
						   obj_t arg1642_1069;
						   arg1641_1068 =
						      STRUCT_REF(slot_1058, ((long) 2));
						   {	/* Object/access.scm 276 */
						      obj_t list1643_1070;
						      {		/* Object/access.scm 276 */
							 obj_t arg1644_1071;
							 {	/* Object/access.scm 276 */
							    obj_t aux_4574;
							    aux_4574 =
							       CNST_TABLE_REF(((long) 36));
							    arg1644_1071 =
							       MAKE_PAIR(aux_4574, BNIL);
							 }
							 list1643_1070 =
							    MAKE_PAIR(formal_1059, arg1644_1071);
						      }
						      arg1642_1069 =
							 symbol_append_197___r4_symbols_6_4(list1643_1070);
						   }
						   arg1640_1067 =
						      malloc_object_tools(
						      (type_bglt) (arg1641_1068), arg1642_1069);
						}
						arg1638_1065 =
						   make_pragma_indexed_init_set__66_object_tools(
						   (type_bglt) (type_99), slot_1058, new_100, arg1640_1067);
					     }
					     {	/* Object/access.scm 278 */
						obj_t arg1646_1072;
						{	/* Object/access.scm 278 */
						   obj_t arg1648_1074;
						   obj_t arg1649_1075;
						   arg1648_1074 =
						      CNST_TABLE_REF(((long) 37));
						   {	/* Object/access.scm 278 */
						      obj_t arg1650_1076;
						      obj_t arg1651_1077;
						      {		/* Object/access.scm 278 */
							 obj_t arg1652_1078;
							 {	/* Object/access.scm 278 */
							    obj_t arg1654_1080;
							    {	/* Object/access.scm 278 */
							       obj_t arg1655_1081;
							       obj_t arg1656_1082;
							       arg1655_1081 =
								  MAKE_PAIR(rtid_102, BNIL);
							       {	/* Object/access.scm 279 */
								  obj_t arg1657_1083;
								  {	/* Object/access.scm 279 */
								     obj_t arg1659_1085;
								     obj_t arg1660_1086;
								     arg1659_1085 =
									CNST_TABLE_REF(((long) 38));
								     {	/* Object/access.scm 279 */
									obj_t arg1661_1087;
									obj_t arg1662_1088;
									{	/* Object/access.scm 279 */
									   obj_t arg1663_1089;
									   obj_t arg1664_1090;
									   arg1663_1089 =
									      CNST_TABLE_REF(((long) 39));
									   {	/* Object/access.scm 280 */
									      obj_t arg1665_1091;
									      {		/* Object/access.scm 280 */
										 obj_t arg1666_1092;
										 {	/* Object/access.scm 280 */
										    obj_t list1668_1094;
										    {	/* Object/access.scm 280 */
										       obj_t arg1669_1095;
										       {	/* Object/access.scm 280 */
											  obj_t aux_4587;
											  aux_4587 =
											     CNST_TABLE_REF(((long) 36));
											  arg1669_1095 =
											     MAKE_PAIR(aux_4587, BNIL);
										       }
										       list1668_1094 =
											  MAKE_PAIR(formal_1059, arg1669_1095);
										    }
										    arg1666_1092 =
										       symbol_append_197___r4_symbols_6_4(list1668_1094);
										 }
										 arg1665_1091 =
										    MAKE_PAIR(arg1666_1092, BNIL);
									      }
									      arg1664_1090 =
										 MAKE_PAIR(rid_101, arg1665_1091);
									   }
									   arg1661_1087 =
									      MAKE_PAIR(arg1663_1089, arg1664_1090);
									}
									{	/* Object/access.scm 281 */
									   obj_t arg1670_1096;
									   obj_t arg1671_1097;
									   {	/* Object/access.scm 281 */
									      obj_t arg1672_1098;
									      obj_t arg1673_1099;
									      arg1672_1098 =
										 CNST_TABLE_REF(((long) 40));
									      {		/* ./Ieee/pair-list.scm 5689 */
										 obj_t aux_4596;
										 aux_4596 =
										    CNST_TABLE_REF(((long) 41));
										 arg1673_1099 =
										    MAKE_PAIR(aux_4596, BNIL);
									      }
									      arg1670_1096 =
										 MAKE_PAIR(arg1672_1098, arg1673_1099);
									   }
									   {	/* Object/access.scm 282 */
									      obj_t arg1674_1100;
									      {		/* Object/access.scm 282 */
										 obj_t arg1676_1102;
										 obj_t arg1677_1103;
										 arg1676_1102 =
										    CNST_TABLE_REF(((long) 35));
										 {	/* Object/access.scm 283 */
										    obj_t arg1678_1104;
										    obj_t arg1679_1105;
										    arg1678_1104 =
										       make_pragma_indexed_set__widening_24_object_tools(
										       (type_bglt) (type_99), slot_1058, new_100, formal_1059, rid_101, BFALSE);
										    {	/* Object/access.scm 290 */
										       obj_t arg1680_1106;
										       {	/* Object/access.scm 290 */
											  obj_t arg1682_1108;
											  {	/* Object/access.scm 290 */
											     obj_t arg1683_1109;
											     {	/* Object/access.scm 290 */
												obj_t arg1685_1111;
												obj_t arg1686_1112;
												arg1685_1111 =
												   CNST_TABLE_REF(((long) 42));
												{	/* Object/access.scm 290 */
												   obj_t arg1687_1113;
												   {	/* ./Ieee/pair-list.scm 5689 */
												      obj_t aux_4604;
												      aux_4604 =
													 BINT(((long) 1));
												      arg1687_1113 =
													 MAKE_PAIR(aux_4604, BNIL);
												   }
												   arg1686_1112 =
												      MAKE_PAIR(rid_101, arg1687_1113);
												}
												arg1683_1109 =
												   MAKE_PAIR(arg1685_1111, arg1686_1112);
											     }
											     arg1682_1108 =
												MAKE_PAIR(arg1683_1109, BNIL);
											  }
											  arg1680_1106 =
											     MAKE_PAIR(loop_1061, arg1682_1108);
										       }
										       arg1679_1105 =
											  MAKE_PAIR(arg1680_1106, BNIL);
										    }
										    arg1677_1103 =
										       MAKE_PAIR(arg1678_1104, arg1679_1105);
										 }
										 arg1674_1100 =
										    MAKE_PAIR(arg1676_1102, arg1677_1103);
									      }
									      arg1671_1097 =
										 MAKE_PAIR(arg1674_1100, BNIL);
									   }
									   arg1662_1088 =
									      MAKE_PAIR(arg1670_1096, arg1671_1097);
									}
									arg1660_1086 =
									   MAKE_PAIR(arg1661_1087, arg1662_1088);
								     }
								     arg1657_1083 =
									MAKE_PAIR(arg1659_1085, arg1660_1086);
								  }
								  arg1656_1082 =
								     MAKE_PAIR(arg1657_1083, BNIL);
							       }
							       arg1654_1080 =
								  MAKE_PAIR(arg1655_1081, arg1656_1082);
							    }
							    arg1652_1078 =
							       MAKE_PAIR(loop_1061, arg1654_1080);
							 }
							 arg1650_1076 =
							    MAKE_PAIR(arg1652_1078, BNIL);
						      }
						      {		/* Object/access.scm 291 */
							 obj_t arg1688_1114;
							 {	/* Object/access.scm 291 */
							    obj_t arg1690_1116;
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_4622;
							       aux_4622 =
								  BINT(((long) 0));
							       arg1690_1116 =
								  MAKE_PAIR(aux_4622, BNIL);
							    }
							    arg1688_1114 =
							       MAKE_PAIR(loop_1061, arg1690_1116);
							 }
							 arg1651_1077 =
							    MAKE_PAIR(arg1688_1114, BNIL);
						      }
						      arg1649_1075 =
							 MAKE_PAIR(arg1650_1076, arg1651_1077);
						   }
						   arg1646_1072 =
						      MAKE_PAIR(arg1648_1074, arg1649_1075);
						}
						arg1639_1066 =
						   MAKE_PAIR(arg1646_1072, BNIL);
					     }
					     arg1637_1064 =
						MAKE_PAIR(arg1638_1065, arg1639_1066);
					  }
					  arg1630_1054 =
					     MAKE_PAIR(arg1636_1063, arg1637_1064);
				       }
				    }
				  else
				    {	/* Object/access.scm 292 */
				       bool_t test_4632;
				       {	/* ./Llib/struct.scm 1457 */
					  obj_t aux_4633;
					  aux_4633 =
					     STRUCT_REF(slot_1058, ((long) 3));
					  test_4632 =
					     CBOOL(aux_4633);
				       }
				       if (test_4632)
					 {	/* Object/access.scm 292 */
					    {	/* Object/access.scm 294 */
					       obj_t arg1692_1118;
					       obj_t arg1693_1119;
					       arg1692_1118 =
						  CNST_TABLE_REF(((long) 37));
					       {	/* Object/access.scm 294 */
						  obj_t arg1694_1120;
						  obj_t arg1695_1121;
						  {	/* Object/access.scm 294 */
						     obj_t arg1696_1122;
						     {	/* Object/access.scm 294 */
							obj_t arg1698_1124;
							{	/* Object/access.scm 294 */
							   obj_t arg1699_1125;
							   obj_t arg1700_1126;
							   arg1699_1125 =
							      MAKE_PAIR(rtid_102, BNIL);
							   {	/* Object/access.scm 295 */
							      obj_t arg1701_1127;
							      {		/* Object/access.scm 295 */
								 obj_t arg1703_1129;
								 obj_t arg1704_1130;
								 arg1703_1129 =
								    CNST_TABLE_REF(((long) 38));
								 {	/* Object/access.scm 295 */
								    obj_t arg1705_1131;
								    obj_t arg1706_1132;
								    {	/* Object/access.scm 295 */
								       obj_t arg1707_1133;
								       obj_t arg1708_1134;
								       arg1707_1133 =
									  CNST_TABLE_REF(((long) 39));
								       {	/* Object/access.scm 296 */
									  obj_t arg1709_1135;
									  {	/* Object/access.scm 296 */
									     obj_t arg1711_1136;
									     {	/* Object/access.scm 296 */
										obj_t arg1713_1138;
										obj_t arg1714_1139;
										arg1713_1138 =
										   CNST_TABLE_REF(((long) 43));
										{	/* ./Ieee/pair-list.scm 5689 */
										   obj_t aux_4641;
										   aux_4641 =
										      STRUCT_REF(slot_1058, ((long) 4));
										   arg1714_1139 =
										      MAKE_PAIR(aux_4641, BNIL);
										}
										arg1711_1136 =
										   MAKE_PAIR(arg1713_1138, arg1714_1139);
									     }
									     arg1709_1135 =
										MAKE_PAIR(arg1711_1136, BNIL);
									  }
									  arg1708_1134 =
									     MAKE_PAIR(rid_101, arg1709_1135);
								       }
								       arg1705_1131 =
									  MAKE_PAIR(arg1707_1133, arg1708_1134);
								    }
								    {	/* Object/access.scm 298 */
								       obj_t arg1717_1142;
								       obj_t arg1718_1143;
								       {	/* Object/access.scm 298 */
									  obj_t arg1719_1144;
									  obj_t arg1720_1145;
									  arg1719_1144 =
									     CNST_TABLE_REF(((long) 40));
									  {	/* ./Ieee/pair-list.scm 5689 */
									     obj_t aux_4649;
									     aux_4649 =
										CNST_TABLE_REF(((long) 41));
									     arg1720_1145 =
										MAKE_PAIR(aux_4649, BNIL);
									  }
									  arg1717_1142 =
									     MAKE_PAIR(arg1719_1144, arg1720_1145);
								       }
								       {	/* Object/access.scm 299 */
									  obj_t arg1721_1146;
									  {	/* Object/access.scm 299 */
									     obj_t arg1723_1148;
									     obj_t arg1724_1149;
									     arg1723_1148 =
										CNST_TABLE_REF(((long) 35));
									     {	/* Object/access.scm 300 */
										obj_t arg1725_1150;
										obj_t arg1726_1151;
										arg1725_1150 =
										   make_pragma_indexed_set__widening_24_object_tools(
										   (type_bglt) (type_99), slot_1058, new_100, formal_1059, rid_101, BFALSE);
										{	/* Object/access.scm 307 */
										   obj_t arg1727_1152;
										   {	/* Object/access.scm 307 */
										      obj_t arg1729_1154;
										      {		/* Object/access.scm 307 */
											 obj_t arg1730_1155;
											 {	/* Object/access.scm 307 */
											    obj_t arg1732_1157;
											    obj_t arg1733_1158;
											    arg1732_1157 =
											       CNST_TABLE_REF(((long) 42));
											    {	/* Object/access.scm 307 */
											       obj_t arg1734_1159;
											       {	/* ./Ieee/pair-list.scm 5689 */
												  obj_t aux_4657;
												  aux_4657 =
												     BINT(((long) 1));
												  arg1734_1159 =
												     MAKE_PAIR(aux_4657, BNIL);
											       }
											       arg1733_1158 =
												  MAKE_PAIR(rid_101, arg1734_1159);
											    }
											    arg1730_1155 =
											       MAKE_PAIR(arg1732_1157, arg1733_1158);
											 }
											 arg1729_1154 =
											    MAKE_PAIR(arg1730_1155, BNIL);
										      }
										      arg1727_1152 =
											 MAKE_PAIR(loop_1061, arg1729_1154);
										   }
										   arg1726_1151 =
										      MAKE_PAIR(arg1727_1152, BNIL);
										}
										arg1724_1149 =
										   MAKE_PAIR(arg1725_1150, arg1726_1151);
									     }
									     arg1721_1146 =
										MAKE_PAIR(arg1723_1148, arg1724_1149);
									  }
									  arg1718_1143 =
									     MAKE_PAIR(arg1721_1146, BNIL);
								       }
								       arg1706_1132 =
									  MAKE_PAIR(arg1717_1142, arg1718_1143);
								    }
								    arg1704_1130 =
								       MAKE_PAIR(arg1705_1131, arg1706_1132);
								 }
								 arg1701_1127 =
								    MAKE_PAIR(arg1703_1129, arg1704_1130);
							      }
							      arg1700_1126 =
								 MAKE_PAIR(arg1701_1127, BNIL);
							   }
							   arg1698_1124 =
							      MAKE_PAIR(arg1699_1125, arg1700_1126);
							}
							arg1696_1122 =
							   MAKE_PAIR(loop_1061, arg1698_1124);
						     }
						     arg1694_1120 =
							MAKE_PAIR(arg1696_1122, BNIL);
						  }
						  {	/* Object/access.scm 308 */
						     obj_t arg1735_1160;
						     {	/* Object/access.scm 308 */
							obj_t arg1738_1162;
							{	/* ./Ieee/pair-list.scm 5689 */
							   obj_t aux_4675;
							   aux_4675 =
							      BINT(((long) 0));
							   arg1738_1162 =
							      MAKE_PAIR(aux_4675, BNIL);
							}
							arg1735_1160 =
							   MAKE_PAIR(loop_1061, arg1738_1162);
						     }
						     arg1695_1121 =
							MAKE_PAIR(arg1735_1160, BNIL);
						  }
						  arg1693_1119 =
						     MAKE_PAIR(arg1694_1120, arg1695_1121);
					       }
					       arg1630_1054 =
						  MAKE_PAIR(arg1692_1118, arg1693_1119);
					    }
					 }
				       else
					 {	/* Object/access.scm 292 */
					    arg1630_1054 =
					       make_pragma_direct_set__7_object_tools(
					       (type_bglt) (type_99), slot_1058, new_100, formal_1059);
					 }
				    }
			       }
			    }
			    arg1629_1053 =
			       MAKE_PAIR(arg1630_1054, res_1046);
			 }
			 {
			    obj_t res_4689;
			    obj_t f_ids_164_4688;
			    obj_t slots_4687;
			    slots_4687 = arg1627_1051;
			    f_ids_164_4688 = arg1628_1052;
			    res_4689 = arg1629_1053;
			    res_1046 = res_4689;
			    f_ids_164_1045 = f_ids_164_4688;
			    slots_1044 = slots_4687;
			    goto loop_1047;
			 }
		      }
		   }
	      }
	 }
      }
   }
}



/* import-class-makes! */
obj_t 
import_class_makes__192_object_access(obj_t mk_id_77_105, obj_t id_106, obj_t type_107, obj_t slots_108, obj_t src_def_101_109, obj_t module_110)
{
   AN_OBJECT;
   {	/* Object/access.scm 330 */
      {		/* Object/access.scm 331 */
	 obj_t mk_heap_id_73_2838;
	 {	/* Object/access.scm 331 */
	    obj_t list1739_2839;
	    {	/* Object/access.scm 331 */
	       obj_t arg1740_2840;
	       {	/* Object/access.scm 331 */
		  obj_t arg1741_2841;
		  obj_t arg1742_2842;
		  arg1741_2841 =
		     CNST_TABLE_REF(((long) 24));
		  arg1742_2842 =
		     MAKE_PAIR(id_106, BNIL);
		  arg1740_2840 =
		     MAKE_PAIR(arg1741_2841, arg1742_2842);
	       }
	       list1739_2839 =
		  MAKE_PAIR(mk_id_77_105, arg1740_2840);
	    }
	    mk_heap_id_73_2838 =
	       symbol_append_197___r4_symbols_6_4(list1739_2839);
	 }
	 {	/* Object/access.scm 338 */
	    obj_t mk_tid_99_2850;
	    {	/* Object/access.scm 339 */
	       obj_t list1745_2851;
	       {	/* Object/access.scm 339 */
		  obj_t arg1746_2852;
		  {	/* Object/access.scm 339 */
		     obj_t arg1747_2853;
		     {	/* Object/access.scm 339 */
			obj_t aux_4695;
			{	/* Object/access.scm 338 */
			   type_bglt obj_2857;
			   obj_2857 =
			      (type_bglt) (type_107);
			   aux_4695 =
			      (((type_bglt) CREF(obj_2857))->id);
			}
			arg1747_2853 =
			   MAKE_PAIR(aux_4695, BNIL);
		     }
		     arg1746_2852 =
			MAKE_PAIR(_4dots_199_tools_misc, arg1747_2853);
		  }
		  list1745_2851 =
		     MAKE_PAIR(mk_heap_id_73_2838, arg1746_2852);
	       }
	       mk_tid_99_2850 =
		  symbol_append_197___r4_symbols_6_4(list1745_2851);
	    }
	    {	/* Object/access.scm 339 */
	       obj_t f_tids_193_2854;
	       f_tids_193_2854 =
		  make_class_make_typed_formals_184_object_access(slots_108);
	       {	/* Object/access.scm 340 */

		  {	/* Object/access.scm 342 */
		     obj_t arg1743_2855;
		     {	/* ./Ieee/pair-list.scm 5689 */
			obj_t aux_4703;
			aux_4703 =
			   append_2_18___r4_pairs_and_lists_6_3(f_tids_193_2854, BNIL);
			arg1743_2855 =
			   MAKE_PAIR(mk_tid_99_2850, aux_4703);
		     }
		     return
			import_parser_53_module_impuse(module_110, arg1743_2855);
		  }
	       }
	    }
	 }
      }
   }
}



/* _import-class-makes!2639 */
obj_t 
_import_class_makes_2639_212_object_access(obj_t env_3992, obj_t mk_id_77_3993, obj_t id_3994, obj_t type_3995, obj_t slots_3996, obj_t src_def_101_3997, obj_t module_3998)
{
   AN_OBJECT;
   {	/* Object/access.scm 330 */
      return
	 import_class_makes__192_object_access(mk_id_77_3993, id_3994, type_3995, slots_3996, src_def_101_3997, module_3998);
   }
}



/* make-class-allocate! */
obj_t 
make_class_allocate__44_object_access(obj_t id_118, obj_t type_119, obj_t holder_120, obj_t src_def_101_121, obj_t import_122)
{
   AN_OBJECT;
   {	/* Object/access.scm 347 */
      {		/* Object/access.scm 348 */
	 obj_t tid_1177;
	 {	/* Object/access.scm 348 */
	    type_bglt obj_2871;
	    obj_2871 =
	       (type_bglt) (type_119);
	    tid_1177 =
	       (((type_bglt) CREF(obj_2871))->id);
	 }
	 {	/* Object/access.scm 348 */
	    obj_t alloc_id_207_1178;
	    {	/* Object/access.scm 349 */
	       obj_t list1804_1235;
	       {	/* Object/access.scm 349 */
		  obj_t arg1805_1236;
		  obj_t arg1806_1237;
		  arg1805_1236 =
		     CNST_TABLE_REF(((long) 44));
		  arg1806_1237 =
		     MAKE_PAIR(id_118, BNIL);
		  list1804_1235 =
		     MAKE_PAIR(arg1805_1236, arg1806_1237);
	       }
	       alloc_id_207_1178 =
		  symbol_append_197___r4_symbols_6_4(list1804_1235);
	    }
	    {	/* Object/access.scm 349 */
	       obj_t alloc_tid_75_1179;
	       {	/* Object/access.scm 350 */
		  obj_t list1801_1232;
		  {	/* Object/access.scm 350 */
		     obj_t arg1802_1233;
		     {	/* Object/access.scm 350 */
			obj_t arg1803_1234;
			arg1803_1234 =
			   MAKE_PAIR(tid_1177, BNIL);
			arg1802_1233 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg1803_1234);
		     }
		     list1801_1232 =
			MAKE_PAIR(alloc_id_207_1178, arg1802_1233);
		  }
		  alloc_tid_75_1179 =
		     symbol_append_197___r4_symbols_6_4(list1801_1232);
	       }
	       {	/* Object/access.scm 350 */
		  obj_t new_1180;
		  new_1180 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 25)), BEOA);
		  {	/* Object/access.scm 351 */

		     {	/* Object/access.scm 352 */
			obj_t arg1748_1181;
			{	/* Object/access.scm 352 */
			   obj_t arg1749_1182;
			   {	/* Object/access.scm 352 */
			      obj_t arg1750_1183;
			      arg1750_1183 =
				 MAKE_PAIR(alloc_tid_75_1179, BNIL);
			      arg1749_1182 =
				 MAKE_PAIR(arg1750_1183, BNIL);
			   }
			   arg1748_1181 =
			      MAKE_PAIR(import_122, arg1749_1182);
			}
			produce_module_clause__172_module_module(arg1748_1181);
		     }
		     {	/* Object/access.scm 353 */
			obj_t arg1752_1185;
			{	/* Object/access.scm 353 */
			   obj_t arg1754_1187;
			   obj_t arg1755_1188;
			   arg1754_1187 =
			      CNST_TABLE_REF(((long) 16));
			   {	/* Object/access.scm 353 */
			      obj_t arg1756_1189;
			      obj_t arg1758_1190;
			      arg1756_1189 =
				 MAKE_PAIR(alloc_tid_75_1179, BNIL);
			      {		/* Object/access.scm 354 */
				 obj_t arg1759_1191;
				 {	/* Object/access.scm 354 */
				    obj_t arg1761_1193;
				    obj_t arg1762_1194;
				    arg1761_1193 =
				       CNST_TABLE_REF(((long) 30));
				    {	/* Object/access.scm 354 */
				       obj_t arg1763_1195;
				       obj_t arg1764_1196;
				       {	/* Object/access.scm 354 */
					  obj_t arg1765_1197;
					  {	/* Object/access.scm 354 */
					     obj_t arg1767_1199;
					     obj_t arg1768_1200;
					     {	/* Object/access.scm 354 */
						obj_t list1769_1201;
						{	/* Object/access.scm 354 */
						   obj_t arg1770_1202;
						   {	/* Object/access.scm 354 */
						      obj_t arg1771_1203;
						      arg1771_1203 =
							 MAKE_PAIR(tid_1177, BNIL);
						      arg1770_1202 =
							 MAKE_PAIR(_4dots_199_tools_misc, arg1771_1203);
						   }
						   list1769_1201 =
						      MAKE_PAIR(new_1180, arg1770_1202);
						}
						arg1767_1199 =
						   symbol_append_197___r4_symbols_6_4(list1769_1201);
					     }
					     {	/* Object/access.scm 354 */
						obj_t arg1772_1204;
						arg1772_1204 =
						   malloc_object_tools(
						   (type_bglt) (type_119),
						   BINT(((long) 1)));
						arg1768_1200 =
						   MAKE_PAIR(arg1772_1204, BNIL);
					     }
					     arg1765_1197 =
						MAKE_PAIR(arg1767_1199, arg1768_1200);
					  }
					  arg1763_1195 =
					     MAKE_PAIR(arg1765_1197, BNIL);
				       }
				       {	/* Object/access.scm 355 */
					  obj_t arg1774_1206;
					  obj_t arg1775_1207;
					  {	/* Object/access.scm 355 */
					     obj_t arg1776_1208;
					     obj_t arg1777_1209;
					     arg1776_1208 =
						CNST_TABLE_REF(((long) 31));
					     {	/* Object/access.scm 356 */
						obj_t arg1778_1210;
						{	/* Object/access.scm 356 */
						   obj_t arg1779_1211;
						   {	/* Object/access.scm 356 */
						      obj_t arg1781_1213;
						      obj_t arg1782_1214;
						      {		/* Object/access.scm 356 */
							 obj_t arg1783_1215;
							 obj_t arg1784_1216;
							 arg1783_1215 =
							    CNST_TABLE_REF(((long) 18));
							 {	/* Object/access.scm 356 */
							    obj_t arg1785_1217;
							    obj_t arg1786_1218;
							    arg1785_1217 =
							       CNST_TABLE_REF(((long) 32));
							    {	/* ./Ieee/pair-list.scm 5689 */
							       obj_t aux_4741;
							       aux_4741 =
								  CNST_TABLE_REF(((long) 45));
							       arg1786_1218 =
								  MAKE_PAIR(aux_4741, BNIL);
							    }
							    arg1784_1216 =
							       MAKE_PAIR(arg1785_1217, arg1786_1218);
							 }
							 arg1781_1213 =
							    MAKE_PAIR(arg1783_1215, arg1784_1216);
						      }
						      {		/* Object/access.scm 357 */
							 obj_t arg1787_1219;
							 {	/* Object/access.scm 357 */
							    obj_t arg1789_1221;
							    obj_t arg1790_1222;
							    arg1789_1221 =
							       CNST_TABLE_REF(((long) 18));
							    {	/* Object/access.scm 357 */
							       obj_t arg1791_1223;
							       obj_t arg1792_1224;
							       {	/* Object/access.scm 357 */
								  global_bglt obj_2892;
								  obj_2892 =
								     (global_bglt) (holder_120);
								  arg1791_1223 =
								     (((global_bglt) CREF(obj_2892))->id);
							       }
							       {	/* ./Ieee/pair-list.scm 5689 */
								  obj_t aux_4749;
								  {	/* Object/access.scm 358 */
								     global_bglt obj_2893;
								     obj_2893 =
									(global_bglt) (holder_120);
								     aux_4749 =
									(((global_bglt) CREF(obj_2893))->module);
								  }
								  arg1792_1224 =
								     MAKE_PAIR(aux_4749, BNIL);
							       }
							       arg1790_1222 =
								  MAKE_PAIR(arg1791_1223, arg1792_1224);
							    }
							    arg1787_1219 =
							       MAKE_PAIR(arg1789_1221, arg1790_1222);
							 }
							 arg1782_1214 =
							    MAKE_PAIR(arg1787_1219, BNIL);
						      }
						      arg1779_1211 =
							 MAKE_PAIR(arg1781_1213, arg1782_1214);
						   }
						   arg1778_1210 =
						      MAKE_PAIR(arg1779_1211, BNIL);
						}
						arg1777_1209 =
						   MAKE_PAIR(new_1180, arg1778_1210);
					     }
					     arg1774_1206 =
						MAKE_PAIR(arg1776_1208, arg1777_1209);
					  }
					  {	/* Object/access.scm 359 */
					     obj_t arg1795_1227;
					     obj_t arg1796_1228;
					     {	/* Object/access.scm 359 */
						obj_t arg1797_1229;
						obj_t arg1798_1230;
						arg1797_1229 =
						   CNST_TABLE_REF(((long) 33));
						{	/* Object/access.scm 359 */
						   obj_t arg1800_1231;
						   arg1800_1231 =
						      MAKE_PAIR(BFALSE, BNIL);
						   arg1798_1230 =
						      MAKE_PAIR(new_1180, arg1800_1231);
						}
						arg1795_1227 =
						   MAKE_PAIR(arg1797_1229, arg1798_1230);
					     }
					     arg1796_1228 =
						MAKE_PAIR(new_1180, BNIL);
					     arg1775_1207 =
						MAKE_PAIR(arg1795_1227, arg1796_1228);
					  }
					  arg1764_1196 =
					     MAKE_PAIR(arg1774_1206, arg1775_1207);
				       }
				       arg1762_1194 =
					  MAKE_PAIR(arg1763_1195, arg1764_1196);
				    }
				    arg1759_1191 =
				       MAKE_PAIR(arg1761_1193, arg1762_1194);
				 }
				 arg1758_1190 =
				    MAKE_PAIR(arg1759_1191, BNIL);
			      }
			      arg1755_1188 =
				 MAKE_PAIR(arg1756_1189, arg1758_1190);
			   }
			   arg1752_1185 =
			      MAKE_PAIR(arg1754_1187, arg1755_1188);
			}
			{	/* Object/access.scm 353 */
			   obj_t list1753_1186;
			   list1753_1186 =
			      MAKE_PAIR(src_def_101_121, BNIL);
			   return
			      epairify__149_object_access(arg1752_1185, list1753_1186);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* _make-class-allocate! */
obj_t 
_make_class_allocate__22_object_access(obj_t env_3999, obj_t id_4000, obj_t type_4001, obj_t holder_4002, obj_t src_def_101_4003, obj_t import_4004)
{
   AN_OBJECT;
   {	/* Object/access.scm 347 */
      return
	 make_class_allocate__44_object_access(id_4000, type_4001, holder_4002, src_def_101_4003, import_4004);
   }
}



/* make-class-slots-access! */
obj_t 
make_class_slots_access__80_object_access(tclass_bglt class_123, obj_t type_124, obj_t slots_125, obj_t widening_126, obj_t src_127, obj_t import_128)
{
   AN_OBJECT;
   {	/* Object/access.scm 382 */
      {
	 obj_t slots_1238;
	 obj_t res_1239;
	 obj_t virtuals_1240;
	 slots_1238 = slots_125;
	 res_1239 = BNIL;
	 virtuals_1240 = BNIL;
       loop_1241:
	 if (
	    NULLP(slots_1238))
	   {	/* Object/access.scm 388 */
	      obj_t val0_1235_1243;
	      obj_t val1_1236_1244;
	      val0_1235_1243 =
		 reverse__39___r4_pairs_and_lists_6_3(res_1239);
	      val1_1236_1244 =
		 reverse__39___r4_pairs_and_lists_6_3(virtuals_1240);
	      _res_number__75___r5_control_features_6_4 =
		 BINT(((long) 2));
	      _res1__155___r5_control_features_6_4 = val1_1236_1244;
	      return val0_1235_1243;
	   }
	 else
	   {	/* Object/access.scm 389 */
	      obj_t slot_1245;
	      slot_1245 =
		 CAR(slots_1238);
	      {		/* Object/access.scm 394 */
		 obj_t ref_1246;
		 ref_1246 =
		    slot_ref_85_object_access(class_123, type_124, slot_1245, widening_126, src_127, import_128);
		 {	/* Object/access.scm 396 */
		    obj_t vref_1247;
		    vref_1247 = _res1__155___r5_control_features_6_4;
		    {	/* Object/access.scm 396 */
		       bool_t test_4782;
		       {	/* ./Llib/struct.scm 1457 */
			  obj_t aux_4783;
			  aux_4783 =
			     STRUCT_REF(slot_1245, ((long) 7));
			  test_4782 =
			     CBOOL(aux_4783);
		       }
		       if (test_4782)
			 {	/* Object/access.scm 397 */
			    obj_t arg1809_1249;
			    obj_t arg1810_1250;
			    obj_t arg1811_1251;
			    arg1809_1249 =
			       CDR(slots_1238);
			    arg1810_1250 =
			       append_2_18___r4_pairs_and_lists_6_3(ref_1246, res_1239);
			    if (
			       CBOOL(vref_1247))
			      {		/* Object/access.scm 400 */
				 obj_t arg1812_1252;
				 {	/* Object/access.scm 400 */
				    obj_t arg1813_1253;
				    arg1813_1253 =
				       STRUCT_REF(slot_1245, ((long) 12));
				    {	/* Object/access.scm 400 */
				       obj_t list1814_1254;
				       {	/* Object/access.scm 400 */
					  obj_t arg1815_1255;
					  {	/* Object/access.scm 400 */
					     obj_t arg1816_1256;
					     arg1816_1256 =
						MAKE_PAIR(BFALSE, BNIL);
					     arg1815_1255 =
						MAKE_PAIR(vref_1247, arg1816_1256);
					  }
					  list1814_1254 =
					     MAKE_PAIR(arg1813_1253, arg1815_1255);
				       }
				       arg1812_1252 = list1814_1254;
				    }
				 }
				 arg1811_1251 =
				    MAKE_PAIR(arg1812_1252, virtuals_1240);
			      }
			    else
			      {		/* Object/access.scm 399 */
				 arg1811_1251 = virtuals_1240;
			      }
			    {
			       obj_t virtuals_4797;
			       obj_t res_4796;
			       obj_t slots_4795;
			       slots_4795 = arg1809_1249;
			       res_4796 = arg1810_1250;
			       virtuals_4797 = arg1811_1251;
			       virtuals_1240 = virtuals_4797;
			       res_1239 = res_4796;
			       slots_1238 = slots_4795;
			       goto loop_1241;
			    }
			 }
		       else
			 {	/* Object/access.scm 403 */
			    obj_t set_1257;
			    set_1257 =
			       slot_set__144_object_access(class_123, type_124, slot_1245, widening_126, src_127, import_128);
			    {	/* Object/access.scm 405 */
			       obj_t vset_1258;
			       vset_1258 = _res1__155___r5_control_features_6_4;
			       {	/* Object/access.scm 405 */
				  obj_t arg1817_1259;
				  obj_t arg1818_1260;
				  obj_t arg1820_1261;
				  arg1817_1259 =
				     CDR(slots_1238);
				  {	/* Object/access.scm 406 */
				     obj_t list1821_1262;
				     {	/* Object/access.scm 406 */
					obj_t arg1822_1263;
					{	/* Object/access.scm 406 */
					   obj_t arg1823_1264;
					   arg1823_1264 =
					      MAKE_PAIR(res_1239, BNIL);
					   arg1822_1263 =
					      MAKE_PAIR(set_1257, arg1823_1264);
					}
					list1821_1262 =
					   MAKE_PAIR(ref_1246, arg1822_1263);
				     }
				     arg1818_1260 =
					append___r4_pairs_and_lists_6_3(list1821_1262);
				  }
				  if (
				     CBOOL(vref_1247))
				    {	/* Object/access.scm 408 */
				       obj_t arg1824_1265;
				       {	/* Object/access.scm 408 */
					  obj_t arg1825_1266;
					  arg1825_1266 =
					     STRUCT_REF(slot_1245, ((long) 12));
					  {	/* Object/access.scm 408 */
					     obj_t list1826_1267;
					     {	/* Object/access.scm 408 */
						obj_t arg1827_1268;
						{	/* Object/access.scm 408 */
						   obj_t arg1828_1269;
						   arg1828_1269 =
						      MAKE_PAIR(vset_1258, BNIL);
						   arg1827_1268 =
						      MAKE_PAIR(vref_1247, arg1828_1269);
						}
						list1826_1267 =
						   MAKE_PAIR(arg1825_1266, arg1827_1268);
					     }
					     arg1824_1265 = list1826_1267;
					  }
				       }
				       arg1820_1261 =
					  MAKE_PAIR(arg1824_1265, virtuals_1240);
				    }
				  else
				    {	/* Object/access.scm 407 */
				       arg1820_1261 = virtuals_1240;
				    }
				  {
				     obj_t virtuals_4813;
				     obj_t res_4812;
				     obj_t slots_4811;
				     slots_4811 = arg1817_1259;
				     res_4812 = arg1818_1260;
				     virtuals_4813 = arg1820_1261;
				     virtuals_1240 = virtuals_4813;
				     res_1239 = res_4812;
				     slots_1238 = slots_4811;
				     goto loop_1241;
				  }
			       }
			    }
			 }
		    }
		 }
	      }
	   }
      }
   }
}



/* _make-class-slots-access! */
obj_t 
_make_class_slots_access__121_object_access(obj_t env_4005, obj_t class_4006, obj_t type_4007, obj_t slots_4008, obj_t widening_4009, obj_t src_4010, obj_t import_4011)
{
   AN_OBJECT;
   {	/* Object/access.scm 382 */
      return
	 make_class_slots_access__80_object_access(
	 (tclass_bglt) (class_4006), type_4007, slots_4008, widening_4009, src_4010, import_4011);
   }
}



/* slot-ref */
obj_t 
slot_ref_85_object_access(tclass_bglt class_129, obj_t type_130, obj_t slot_131, obj_t widening_132, obj_t src_def_101_133, obj_t import_134)
{
   AN_OBJECT;
   {	/* Object/access.scm 415 */
      {		/* Object/access.scm 416 */
	 obj_t class_id_86_1270;
	 {	/* Object/access.scm 416 */
	    type_bglt obj_2951;
	    obj_2951 =
	       (type_bglt) (class_129);
	    class_id_86_1270 =
	       (((type_bglt) CREF(obj_2951))->id);
	 }
	 {	/* Object/access.scm 418 */
	    bool_t test_4818;
	    {	/* ./Llib/struct.scm 1457 */
	       obj_t aux_4819;
	       aux_4819 =
		  STRUCT_REF(slot_131, ((long) 5));
	       test_4818 =
		  CBOOL(aux_4819);
	    }
	    if (test_4818)
	      {		/* Object/access.scm 418 */
		 {	/* Object/access.scm 419 */
		    obj_t val0_1237_1272;
		    val0_1237_1272 =
		       slot_dyna_indexed_ref_48_object_access(class_id_86_1270, type_130, slot_131, widening_132, src_def_101_133, import_134);
		    _res_number__75___r5_control_features_6_4 =
		       BINT(((long) 2));
		    _res1__155___r5_control_features_6_4 = BFALSE;
		    return val0_1237_1272;
		 }
	      }
	    else
	      {		/* Object/access.scm 422 */
		 bool_t test_4824;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_4825;
		    aux_4825 =
		       STRUCT_REF(slot_131, ((long) 3));
		    test_4824 =
		       CBOOL(aux_4825);
		 }
		 if (test_4824)
		   {	/* Object/access.scm 422 */
		      {		/* Object/access.scm 423 */
			 obj_t val0_1239_1275;
			 {	/* Object/access.scm 457 */
			    obj_t arg1844_2964;
			    {	/* Object/access.scm 457 */
			       obj_t arg1845_2965;
			       obj_t arg1846_2966;
			       arg1845_2965 =
				  CNST_TABLE_REF(((long) 43));
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_4829;
				  aux_4829 =
				     STRUCT_REF(slot_131, ((long) 4));
				  arg1846_2966 =
				     MAKE_PAIR(aux_4829, BNIL);
			       }
			       arg1844_2964 =
				  MAKE_PAIR(arg1845_2965, arg1846_2966);
			    }
			    val0_1239_1275 =
			       slot_indexed_ref_219_object_access(class_id_86_1270, type_130, slot_131, widening_132, arg1844_2964, src_def_101_133, import_134);
			 }
			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 _res1__155___r5_control_features_6_4 = BFALSE;
			 return val0_1239_1275;
		      }
		   }
		 else
		   {	/* Object/access.scm 426 */
		      bool_t test_4835;
		      {		/* ./Llib/struct.scm 1457 */
			 obj_t aux_4836;
			 aux_4836 =
			    STRUCT_REF(slot_131, ((long) 11));
			 test_4835 =
			    CBOOL(aux_4836);
		      }
		      if (test_4835)
			{	/* Object/access.scm 426 */
			   {	/* Object/access.scm 427 */
			      obj_t user_def_147_1278;
			      user_def_147_1278 =
				 slot_virtual_ref_147_object_access(class_129, type_130, slot_131, widening_132, src_def_101_133, import_134);
			      {		/* Object/access.scm 429 */
				 obj_t class_def_12_1279;
				 class_def_12_1279 = _res1__155___r5_control_features_6_4;
				 if (
				    CBOOL(class_def_12_1279))
				   {	/* Object/access.scm 429 */
				      _res_number__75___r5_control_features_6_4 =
					 BINT(((long) 2));
				      _res1__155___r5_control_features_6_4 = class_def_12_1279;
				      return user_def_147_1278;
				   }
				 else
				   {	/* Object/access.scm 429 */
				      _res_number__75___r5_control_features_6_4 =
					 BINT(((long) 2));
				      _res1__155___r5_control_features_6_4 = BFALSE;
				      return user_def_147_1278;
				   }
			      }
			   }
			}
		      else
			{	/* Object/access.scm 426 */
			   {	/* Object/access.scm 433 */
			      obj_t val0_1245_1284;
			      val0_1245_1284 =
				 slot_direct_ref_183_object_access(class_id_86_1270, type_130, slot_131, widening_132, src_def_101_133, import_134);
			      _res_number__75___r5_control_features_6_4 =
				 BINT(((long) 2));
			      _res1__155___r5_control_features_6_4 = BFALSE;
			      return val0_1245_1284;
			   }
			}
		   }
	      }
	 }
      }
   }
}



/* slot-dyna-indexed-ref */
obj_t 
slot_dyna_indexed_ref_48_object_access(obj_t class_id_86_135, obj_t type_136, obj_t slot_137, obj_t widening_138, obj_t src_def_101_139, obj_t import_140)
{
   AN_OBJECT;
   {	/* Object/access.scm 440 */
      {		/* Object/access.scm 445 */
	 obj_t arg1832_1286;
	 {	/* Object/access.scm 445 */
	    obj_t arg1833_1287;
	    obj_t arg1834_1288;
	    {	/* Object/access.scm 445 */
	       obj_t arg1835_1289;
	       obj_t arg1836_1290;
	       arg1835_1289 =
		  CNST_TABLE_REF(((long) 24));
	       arg1836_1290 =
		  STRUCT_REF(slot_137, ((long) 0));
	       {	/* Object/access.scm 445 */
		  obj_t list1839_1292;
		  {	/* Object/access.scm 445 */
		     obj_t arg1841_1293;
		     {	/* Object/access.scm 445 */
			obj_t arg1842_1294;
			{	/* Object/access.scm 445 */
			   obj_t arg1843_1295;
			   {	/* Object/access.scm 445 */
			      obj_t aux_4848;
			      aux_4848 =
				 CNST_TABLE_REF(((long) 36));
			      arg1843_1295 =
				 MAKE_PAIR(aux_4848, BNIL);
			   }
			   arg1842_1294 =
			      MAKE_PAIR(arg1836_1290, arg1843_1295);
			}
			arg1841_1293 =
			   MAKE_PAIR(arg1835_1289, arg1842_1294);
		     }
		     list1839_1292 =
			MAKE_PAIR(class_id_86_135, arg1841_1293);
		  }
		  arg1833_1287 =
		     symbol_append_197___r4_symbols_6_4(list1839_1292);
	       }
	    }
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_4855;
	       aux_4855 =
		  CNST_TABLE_REF(((long) 2));
	       arg1834_1288 =
		  MAKE_PAIR(aux_4855, BNIL);
	    }
	    arg1832_1286 =
	       MAKE_PAIR(arg1833_1287, arg1834_1288);
	 }
	 return
	    slot_indexed_ref_219_object_access(class_id_86_135, type_136, slot_137, widening_138, arg1832_1286, src_def_101_139, import_140);
      }
   }
}



/* slot-indexed-ref */
obj_t 
slot_indexed_ref_219_object_access(obj_t class_id_86_147, obj_t type_148, obj_t slot_149, obj_t widening_150, obj_t max_bound_128_151, obj_t src_def_101_152, obj_t import_153)
{
   AN_OBJECT;
   {	/* Object/access.scm 463 */
      {
	 obj_t slot_ref_id_128_1418;
	 obj_t slot_ref_tid_43_1419;
	 obj_t slot_ref_id_128_1356;
	 obj_t slot_ref_tid_43_1357;
	 {	/* Object/access.scm 494 */
	    obj_t slot_ref_id_128_1303;
	    {	/* Object/access.scm 494 */
	       obj_t arg1892_1349;
	       obj_t arg1893_1350;
	       arg1892_1349 =
		  CNST_TABLE_REF(((long) 24));
	       arg1893_1350 =
		  STRUCT_REF(slot_149, ((long) 0));
	       {	/* Object/access.scm 494 */
		  obj_t list1895_1352;
		  {	/* Object/access.scm 494 */
		     obj_t arg1896_1353;
		     {	/* Object/access.scm 494 */
			obj_t arg1897_1354;
			{	/* Object/access.scm 494 */
			   obj_t arg1898_1355;
			   {	/* Object/access.scm 494 */
			      obj_t aux_4862;
			      aux_4862 =
				 CNST_TABLE_REF(((long) 52));
			      arg1898_1355 =
				 MAKE_PAIR(aux_4862, BNIL);
			   }
			   arg1897_1354 =
			      MAKE_PAIR(arg1893_1350, arg1898_1355);
			}
			arg1896_1353 =
			   MAKE_PAIR(arg1892_1349, arg1897_1354);
		     }
		     list1895_1352 =
			MAKE_PAIR(class_id_86_147, arg1896_1353);
		  }
		  slot_ref_id_128_1303 =
		     symbol_append_197___r4_symbols_6_4(list1895_1352);
	       }
	    }
	    {	/* Object/access.scm 494 */
	       obj_t slot_ref_tid_43_1304;
	       {	/* Object/access.scm 495 */
		  obj_t list1888_1345;
		  {	/* Object/access.scm 495 */
		     obj_t arg1889_1346;
		     {	/* Object/access.scm 495 */
			obj_t arg1890_1347;
			{	/* Object/access.scm 495 */
			   obj_t aux_4869;
			   {	/* Object/access.scm 497 */
			      type_bglt obj_3004;
			      {		/* Object/access.scm 497 */
				 obj_t aux_4870;
				 aux_4870 =
				    STRUCT_REF(slot_149, ((long) 2));
				 obj_3004 =
				    (type_bglt) (aux_4870);
			      }
			      aux_4869 =
				 (((type_bglt) CREF(obj_3004))->id);
			   }
			   arg1890_1347 =
			      MAKE_PAIR(aux_4869, BNIL);
			}
			arg1889_1346 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg1890_1347);
		     }
		     list1888_1345 =
			MAKE_PAIR(slot_ref_id_128_1303, arg1889_1346);
		  }
		  slot_ref_tid_43_1304 =
		     symbol_append_197___r4_symbols_6_4(list1888_1345);
	       }
	       {	/* Object/access.scm 495 */
		  obj_t tid_1305;
		  {	/* Object/access.scm 498 */
		     obj_t list1885_1342;
		     {	/* Object/access.scm 498 */
			obj_t arg1886_1343;
			{	/* Object/access.scm 498 */
			   obj_t aux_4878;
			   {	/* Object/access.scm 498 */
			      type_bglt obj_3005;
			      obj_3005 =
				 (type_bglt) (type_148);
			      aux_4878 =
				 (((type_bglt) CREF(obj_3005))->id);
			   }
			   arg1886_1343 =
			      MAKE_PAIR(aux_4878, BNIL);
			}
			list1885_1342 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg1886_1343);
		     }
		     tid_1305 =
			symbol_append_197___r4_symbols_6_4(list1885_1342);
		  }
		  {	/* Object/access.scm 499 */

		     if (
			CBOOL(_unsafe_range__218_engine_param))
		       {	/* Object/access.scm 501 */
			  {	/* Object/access.scm 507 */
			     obj_t arg1849_1307;
			     {	/* Object/access.scm 507 */
				obj_t arg1850_1308;
				{	/* Object/access.scm 507 */
				   obj_t arg1851_1309;
				   {	/* Object/access.scm 507 */
				      obj_t arg1853_1311;
				      obj_t arg1854_1312;
				      arg1853_1311 =
					 CNST_TABLE_REF(((long) 12));
				      {		/* Object/access.scm 507 */
					 obj_t arg1855_1313;
					 {	/* Object/access.scm 507 */
					    obj_t arg1856_1314;
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_4887;
					       aux_4887 =
						  CNST_TABLE_REF(((long) 27));
					       arg1856_1314 =
						  MAKE_PAIR(aux_4887, BNIL);
					    }
					    arg1855_1313 =
					       MAKE_PAIR(tid_1305, arg1856_1314);
					 }
					 arg1854_1312 =
					    MAKE_PAIR(slot_ref_tid_43_1304, arg1855_1313);
				      }
				      arg1851_1309 =
					 MAKE_PAIR(arg1853_1311, arg1854_1312);
				   }
				   arg1850_1308 =
				      MAKE_PAIR(arg1851_1309, BNIL);
				}
				arg1849_1307 =
				   MAKE_PAIR(import_153, arg1850_1308);
			     }
			     produce_module_clause__172_module_module(arg1849_1307);
			  }
			  {	/* Object/access.scm 508 */
			     obj_t arg1857_1315;
			     {	/* Object/access.scm 508 */
				obj_t arg1858_1316;
				obj_t arg1859_1317;
				arg1858_1316 =
				   CNST_TABLE_REF(((long) 4));
				{	/* Object/access.scm 508 */
				   obj_t arg1860_1318;
				   {	/* Object/access.scm 508 */
				      obj_t arg1862_1320;
				      {		/* Object/access.scm 508 */
					 obj_t arg1863_1321;
					 obj_t arg1864_1322;
					 arg1863_1321 =
					    CNST_TABLE_REF(((long) 5));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_4898;
					    aux_4898 =
					       CNST_TABLE_REF(((long) 6));
					    arg1864_1322 =
					       MAKE_PAIR(aux_4898, BNIL);
					 }
					 arg1862_1320 =
					    MAKE_PAIR(arg1863_1321, arg1864_1322);
				      }
				      arg1860_1318 =
					 MAKE_PAIR(slot_ref_id_128_1303, arg1862_1320);
				   }
				   arg1859_1317 =
				      MAKE_PAIR(arg1860_1318, BNIL);
				}
				arg1857_1315 =
				   MAKE_PAIR(arg1858_1316, arg1859_1317);
			     }
			     produce_module_clause__172_module_module(arg1857_1315);
			  }
			  {	/* Object/access.scm 510 */
			     obj_t arg1865_1323;
			     slot_ref_id_128_1418 = slot_ref_id_128_1303;
			     slot_ref_tid_43_1419 = slot_ref_tid_43_1304;
			     {	/* Object/access.scm 465 */
				obj_t arg1964_1421;
				obj_t arg1965_1422;
				{	/* Object/access.scm 465 */
				   obj_t arg1968_1425;
				   obj_t arg1969_1426;
				   arg1968_1425 =
				      CNST_TABLE_REF(((long) 15));
				   {	/* Object/access.scm 466 */
				      obj_t arg1970_1427;
				      obj_t arg1971_1428;
				      {		/* Object/access.scm 466 */
					 obj_t arg1972_1429;
					 {	/* Object/access.scm 466 */
					    obj_t arg1973_1430;
					    obj_t arg1974_1431;
					    {	/* Object/access.scm 466 */
					       obj_t arg1976_1432;
					       arg1976_1432 =
						  CNST_TABLE_REF(((long) 2));
					       {	/* Object/access.scm 466 */
						  obj_t list1978_1434;
						  {	/* Object/access.scm 466 */
						     obj_t arg1979_1435;
						     {	/* Object/access.scm 466 */
							obj_t arg1980_1436;
							{	/* Object/access.scm 466 */
							   obj_t aux_4908;
							   {	/* Object/access.scm 466 */
							      type_bglt obj_3127;
							      obj_3127 =
								 (type_bglt) (type_148);
							      aux_4908 =
								 (((type_bglt) CREF(obj_3127))->id);
							   }
							   arg1980_1436 =
							      MAKE_PAIR(aux_4908, BNIL);
							}
							arg1979_1435 =
							   MAKE_PAIR(_4dots_199_tools_misc, arg1980_1436);
						     }
						     list1978_1434 =
							MAKE_PAIR(arg1976_1432, arg1979_1435);
						  }
						  arg1973_1430 =
						     symbol_append_197___r4_symbols_6_4(list1978_1434);
					       }
					    }
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_4915;
					       aux_4915 =
						  CNST_TABLE_REF(((long) 46));
					       arg1974_1431 =
						  MAKE_PAIR(aux_4915, BNIL);
					    }
					    arg1972_1429 =
					       MAKE_PAIR(arg1973_1430, arg1974_1431);
					 }
					 arg1970_1427 =
					    MAKE_PAIR(slot_ref_tid_43_1419, arg1972_1429);
				      }
				      {		/* Object/access.scm 468 */
					 obj_t arg1981_1437;
					 arg1981_1437 =
					    make_pragma_indexed_ref_widening_28_object_tools(
					    (type_bglt) (type_148), slot_149,
					    CNST_TABLE_REF(((long) 2)),
					    CNST_TABLE_REF(((long) 48)), widening_150);
					 arg1971_1428 =
					    MAKE_PAIR(arg1981_1437, BNIL);
				      }
				      arg1969_1426 =
					 MAKE_PAIR(arg1970_1427, arg1971_1428);
				   }
				   arg1964_1421 =
				      MAKE_PAIR(arg1968_1425, arg1969_1426);
				}
				{	/* Object/access.scm 473 */
				   bool_t test_4927;
				   if (
				      STRUCTP(slot_149))
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_4932;
					obj_t aux_4930;
					aux_4932 =
					   CNST_TABLE_REF(((long) 51));
					aux_4930 =
					   STRUCT_KEY(slot_149);
					test_4927 =
					   (aux_4930 == aux_4932);
				     }
				   else
				     {	/* ./Object/class.sch 1188 */
					test_4927 = ((bool_t) 0)
					   ;
				     }
				   if (test_4927)
				     {	/* Object/access.scm 473 */
					arg1965_1422 =
					   STRUCT_REF(slot_149, ((long) 15));
				     }
				   else
				     {	/* Object/access.scm 473 */
					arg1965_1422 = slot_149;
				     }
				}
				{	/* Object/access.scm 465 */
				   obj_t list1966_1423;
				   {	/* Object/access.scm 465 */
				      obj_t arg1967_1424;
				      arg1967_1424 =
					 MAKE_PAIR(src_def_101_152, BNIL);
				      list1966_1423 =
					 MAKE_PAIR(arg1965_1422, arg1967_1424);
				   }
				   arg1865_1323 =
				      epairify__149_object_access(arg1964_1421, list1966_1423);
				}
			     }
			     {	/* Object/access.scm 510 */
				obj_t list1866_1324;
				list1866_1324 =
				   MAKE_PAIR(arg1865_1323, BNIL);
				return list1866_1324;
			     }
			  }
		       }
		     else
		       {	/* Object/access.scm 501 */
			  {	/* Object/access.scm 502 */
			     obj_t arg1867_1325;
			     {	/* Object/access.scm 502 */
				obj_t arg1868_1326;
				{	/* Object/access.scm 502 */
				   obj_t arg1869_1327;
				   {	/* Object/access.scm 502 */
				      obj_t arg1871_1329;
				      {		/* Object/access.scm 502 */
					 obj_t arg1872_1330;
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_4940;
					    aux_4940 =
					       CNST_TABLE_REF(((long) 27));
					    arg1872_1330 =
					       MAKE_PAIR(aux_4940, BNIL);
					 }
					 arg1871_1329 =
					    MAKE_PAIR(tid_1305, arg1872_1330);
				      }
				      arg1869_1327 =
					 MAKE_PAIR(slot_ref_tid_43_1304, arg1871_1329);
				   }
				   arg1868_1326 =
				      MAKE_PAIR(arg1869_1327, BNIL);
				}
				arg1867_1325 =
				   MAKE_PAIR(import_153, arg1868_1326);
			     }
			     produce_module_clause__172_module_module(arg1867_1325);
			  }
			  {	/* Object/access.scm 503 */
			     obj_t arg1873_1331;
			     {	/* Object/access.scm 503 */
				obj_t arg1874_1332;
				obj_t arg1875_1333;
				arg1874_1332 =
				   CNST_TABLE_REF(((long) 4));
				{	/* Object/access.scm 503 */
				   obj_t arg1876_1334;
				   {	/* Object/access.scm 503 */
				      obj_t arg1879_1336;
				      {		/* Object/access.scm 503 */
					 obj_t arg1880_1337;
					 obj_t arg1881_1338;
					 arg1880_1337 =
					    CNST_TABLE_REF(((long) 5));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_4950;
					    aux_4950 =
					       CNST_TABLE_REF(((long) 6));
					    arg1881_1338 =
					       MAKE_PAIR(aux_4950, BNIL);
					 }
					 arg1879_1336 =
					    MAKE_PAIR(arg1880_1337, arg1881_1338);
				      }
				      arg1876_1334 =
					 MAKE_PAIR(slot_ref_id_128_1303, arg1879_1336);
				   }
				   arg1875_1333 =
				      MAKE_PAIR(arg1876_1334, BNIL);
				}
				arg1873_1331 =
				   MAKE_PAIR(arg1874_1332, arg1875_1333);
			     }
			     produce_module_clause__172_module_module(arg1873_1331);
			  }
			  {	/* Object/access.scm 505 */
			     obj_t arg1882_1339;
			     slot_ref_id_128_1356 = slot_ref_id_128_1303;
			     slot_ref_tid_43_1357 = slot_ref_tid_43_1304;
			     {	/* Object/access.scm 478 */
				obj_t arg1900_1359;
				obj_t arg1901_1360;
				{	/* Object/access.scm 478 */
				   obj_t arg1904_1363;
				   obj_t arg1905_1364;
				   arg1904_1363 =
				      CNST_TABLE_REF(((long) 16));
				   {	/* Object/access.scm 479 */
				      obj_t arg1906_1365;
				      obj_t arg1907_1366;
				      {		/* Object/access.scm 479 */
					 obj_t arg1909_1367;
					 {	/* Object/access.scm 479 */
					    obj_t arg1910_1368;
					    obj_t arg1912_1369;
					    {	/* Object/access.scm 479 */
					       obj_t arg1913_1370;
					       arg1913_1370 =
						  CNST_TABLE_REF(((long) 2));
					       {	/* Object/access.scm 479 */
						  obj_t list1915_1372;
						  {	/* Object/access.scm 479 */
						     obj_t arg1916_1373;
						     {	/* Object/access.scm 479 */
							obj_t arg1917_1374;
							{	/* Object/access.scm 479 */
							   obj_t aux_4960;
							   {	/* Object/access.scm 479 */
							      type_bglt obj_3051;
							      obj_3051 =
								 (type_bglt) (type_148);
							      aux_4960 =
								 (((type_bglt) CREF(obj_3051))->id);
							   }
							   arg1917_1374 =
							      MAKE_PAIR(aux_4960, BNIL);
							}
							arg1916_1373 =
							   MAKE_PAIR(_4dots_199_tools_misc, arg1917_1374);
						     }
						     list1915_1372 =
							MAKE_PAIR(arg1913_1370, arg1916_1373);
						  }
						  arg1910_1368 =
						     symbol_append_197___r4_symbols_6_4(list1915_1372);
					       }
					    }
					    {	/* ./Ieee/pair-list.scm 5689 */
					       obj_t aux_4967;
					       aux_4967 =
						  CNST_TABLE_REF(((long) 46));
					       arg1912_1369 =
						  MAKE_PAIR(aux_4967, BNIL);
					    }
					    arg1909_1367 =
					       MAKE_PAIR(arg1910_1368, arg1912_1369);
					 }
					 arg1906_1365 =
					    MAKE_PAIR(slot_ref_tid_43_1357, arg1909_1367);
				      }
				      {		/* Object/access.scm 481 */
					 obj_t arg1919_1375;
					 {	/* Object/access.scm 481 */
					    obj_t arg1921_1377;
					    obj_t arg1922_1378;
					    arg1921_1377 =
					       CNST_TABLE_REF(((long) 38));
					    {	/* Object/access.scm 481 */
					       obj_t arg1923_1379;
					       obj_t arg1924_1380;
					       {	/* Object/access.scm 481 */
						  obj_t arg1925_1381;
						  obj_t arg1926_1382;
						  arg1925_1381 =
						     CNST_TABLE_REF(((long) 47));
						  {	/* Object/access.scm 481 */
						     obj_t arg1927_1383;
						     obj_t arg1928_1384;
						     arg1927_1383 =
							CNST_TABLE_REF(((long) 48));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_4975;
							aux_4975 =
							   BINT(((long) 0));
							arg1928_1384 =
							   MAKE_PAIR(aux_4975, BNIL);
						     }
						     arg1926_1382 =
							MAKE_PAIR(arg1927_1383, arg1928_1384);
						  }
						  arg1923_1379 =
						     MAKE_PAIR(arg1925_1381, arg1926_1382);
					       }
					       {	/* Object/access.scm 482 */
						  obj_t arg1929_1385;
						  obj_t arg1930_1386;
						  {	/* Object/access.scm 482 */
						     obj_t arg1931_1387;
						     obj_t arg1932_1388;
						     arg1931_1387 =
							CNST_TABLE_REF(((long) 38));
						     {	/* Object/access.scm 482 */
							obj_t arg1933_1389;
							obj_t arg1934_1390;
							{	/* Object/access.scm 482 */
							   obj_t arg1935_1391;
							   obj_t arg1936_1392;
							   arg1935_1391 =
							      CNST_TABLE_REF(((long) 49));
							   {	/* Object/access.scm 482 */
							      obj_t arg1937_1393;
							      obj_t arg1938_1394;
							      arg1937_1393 =
								 CNST_TABLE_REF(((long) 48));
							      arg1938_1394 =
								 MAKE_PAIR(max_bound_128_151, BNIL);
							      arg1936_1392 =
								 MAKE_PAIR(arg1937_1393, arg1938_1394);
							   }
							   arg1933_1389 =
							      MAKE_PAIR(arg1935_1391, arg1936_1392);
							}
							{	/* Object/access.scm 483 */
							   obj_t arg1939_1395;
							   obj_t arg1940_1396;
							   arg1939_1395 =
							      make_pragma_indexed_ref_widening_28_object_tools(
							      (type_bglt) (type_148), slot_149,
							      CNST_TABLE_REF(((long) 2)),
							      CNST_TABLE_REF(((long) 48)), widening_150);
							   {	/* Object/access.scm 488 */
							      obj_t arg1941_1397;
							      {		/* Object/access.scm 488 */
								 obj_t arg1943_1399;
								 obj_t arg1944_1400;
								 arg1943_1399 =
								    CNST_TABLE_REF(((long) 50));
								 {	/* Object/access.scm 488 */
								    obj_t arg1945_1401;
								    obj_t arg1946_1402;
								    {	/* Object/access.scm 488 */
								       obj_t arg1948_1403;
								       obj_t arg1949_1404;
								       arg1948_1403 =
									  CNST_TABLE_REF(((long) 40));
								       arg1949_1404 =
									  MAKE_PAIR(slot_ref_id_128_1356, BNIL);
								       arg1945_1401 =
									  MAKE_PAIR(arg1948_1403, arg1949_1404);
								    }
								    {	/* Object/access.scm 488 */
								       obj_t arg1951_1406;
								       {	/* ./Ieee/pair-list.scm 5689 */
									  obj_t aux_4994;
									  aux_4994 =
									     CNST_TABLE_REF(((long) 48));
									  arg1951_1406 =
									     MAKE_PAIR(aux_4994, BNIL);
								       }
								       arg1946_1402 =
									  MAKE_PAIR(string2644_object_access, arg1951_1406);
								    }
								    arg1944_1400 =
								       MAKE_PAIR(arg1945_1401, arg1946_1402);
								 }
								 arg1941_1397 =
								    MAKE_PAIR(arg1943_1399, arg1944_1400);
							      }
							      arg1940_1396 =
								 MAKE_PAIR(arg1941_1397, BNIL);
							   }
							   arg1934_1390 =
							      MAKE_PAIR(arg1939_1395, arg1940_1396);
							}
							arg1932_1388 =
							   MAKE_PAIR(arg1933_1389, arg1934_1390);
						     }
						     arg1929_1385 =
							MAKE_PAIR(arg1931_1387, arg1932_1388);
						  }
						  {	/* Object/access.scm 489 */
						     obj_t arg1952_1407;
						     {	/* Object/access.scm 489 */
							obj_t arg1954_1409;
							obj_t arg1955_1410;
							arg1954_1409 =
							   CNST_TABLE_REF(((long) 50));
							{	/* Object/access.scm 489 */
							   obj_t arg1956_1411;
							   obj_t arg1957_1412;
							   {	/* Object/access.scm 489 */
							      obj_t arg1958_1413;
							      obj_t arg1959_1414;
							      arg1958_1413 =
								 CNST_TABLE_REF(((long) 40));
							      arg1959_1414 =
								 MAKE_PAIR(slot_ref_id_128_1356, BNIL);
							      arg1956_1411 =
								 MAKE_PAIR(arg1958_1413, arg1959_1414);
							   }
							   {	/* Object/access.scm 489 */
							      obj_t arg1961_1416;
							      {		/* ./Ieee/pair-list.scm 5689 */
								 obj_t aux_5008;
								 aux_5008 =
								    CNST_TABLE_REF(((long) 48));
								 arg1961_1416 =
								    MAKE_PAIR(aux_5008, BNIL);
							      }
							      arg1957_1412 =
								 MAKE_PAIR(string2644_object_access, arg1961_1416);
							   }
							   arg1955_1410 =
							      MAKE_PAIR(arg1956_1411, arg1957_1412);
							}
							arg1952_1407 =
							   MAKE_PAIR(arg1954_1409, arg1955_1410);
						     }
						     arg1930_1386 =
							MAKE_PAIR(arg1952_1407, BNIL);
						  }
						  arg1924_1380 =
						     MAKE_PAIR(arg1929_1385, arg1930_1386);
					       }
					       arg1922_1378 =
						  MAKE_PAIR(arg1923_1379, arg1924_1380);
					    }
					    arg1919_1375 =
					       MAKE_PAIR(arg1921_1377, arg1922_1378);
					 }
					 arg1907_1366 =
					    MAKE_PAIR(arg1919_1375, BNIL);
				      }
				      arg1905_1364 =
					 MAKE_PAIR(arg1906_1365, arg1907_1366);
				   }
				   arg1900_1359 =
				      MAKE_PAIR(arg1904_1363, arg1905_1364);
				}
				{	/* Object/access.scm 490 */
				   bool_t test_5021;
				   if (
				      STRUCTP(slot_149))
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_5026;
					obj_t aux_5024;
					aux_5026 =
					   CNST_TABLE_REF(((long) 51));
					aux_5024 =
					   STRUCT_KEY(slot_149);
					test_5021 =
					   (aux_5024 == aux_5026);
				     }
				   else
				     {	/* ./Object/class.sch 1188 */
					test_5021 = ((bool_t) 0)
					   ;
				     }
				   if (test_5021)
				     {	/* Object/access.scm 490 */
					arg1901_1360 =
					   STRUCT_REF(slot_149, ((long) 15));
				     }
				   else
				     {	/* Object/access.scm 490 */
					arg1901_1360 = slot_149;
				     }
				}
				{	/* Object/access.scm 478 */
				   obj_t list1902_1361;
				   {	/* Object/access.scm 478 */
				      obj_t arg1903_1362;
				      arg1903_1362 =
					 MAKE_PAIR(src_def_101_152, BNIL);
				      list1902_1361 =
					 MAKE_PAIR(arg1901_1360, arg1903_1362);
				   }
				   arg1882_1339 =
				      epairify__149_object_access(arg1900_1359, list1902_1361);
				}
			     }
			     {	/* Object/access.scm 505 */
				obj_t list1883_1340;
				list1883_1340 =
				   MAKE_PAIR(arg1882_1339, BNIL);
				return list1883_1340;
			     }
			  }
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* slot-virtual-ref */
obj_t 
slot_virtual_ref_147_object_access(tclass_bglt class_154, obj_t type_155, obj_t slot_156, obj_t widening_157, obj_t src_def_101_158, obj_t import_159)
{
   AN_OBJECT;
   {	/* Object/access.scm 515 */
      {		/* Object/access.scm 516 */
	 obj_t class_id_86_1442;
	 {	/* Object/access.scm 516 */
	    type_bglt obj_3151;
	    obj_3151 =
	       (type_bglt) (class_154);
	    class_id_86_1442 =
	       (((type_bglt) CREF(obj_3151))->id);
	 }
	 {	/* Object/access.scm 516 */
	    obj_t slot_ref_id_128_1443;
	    {	/* Object/access.scm 517 */
	       obj_t arg2076_1545;
	       arg2076_1545 =
		  CNST_TABLE_REF(((long) 24));
	       {	/* Object/access.scm 517 */
		  obj_t list2078_1547;
		  {	/* Object/access.scm 517 */
		     obj_t arg2079_1548;
		     {	/* Object/access.scm 517 */
			obj_t arg2080_1549;
			{	/* Object/access.scm 517 */
			   obj_t aux_5037;
			   aux_5037 =
			      STRUCT_REF(slot_156, ((long) 0));
			   arg2080_1549 =
			      MAKE_PAIR(aux_5037, BNIL);
			}
			arg2079_1548 =
			   MAKE_PAIR(arg2076_1545, arg2080_1549);
		     }
		     list2078_1547 =
			MAKE_PAIR(class_id_86_1442, arg2079_1548);
		  }
		  slot_ref_id_128_1443 =
		     symbol_append_197___r4_symbols_6_4(list2078_1547);
	       }
	    }
	    {	/* Object/access.scm 517 */
	       obj_t slot_ref_tid_43_1444;
	       {	/* Object/access.scm 518 */
		  obj_t list2071_1541;
		  {	/* Object/access.scm 518 */
		     obj_t arg2072_1542;
		     {	/* Object/access.scm 518 */
			obj_t arg2073_1543;
			{	/* Object/access.scm 518 */
			   obj_t aux_5043;
			   {	/* Object/access.scm 520 */
			      type_bglt obj_3158;
			      {		/* Object/access.scm 520 */
				 obj_t aux_5044;
				 aux_5044 =
				    STRUCT_REF(slot_156, ((long) 2));
				 obj_3158 =
				    (type_bglt) (aux_5044);
			      }
			      aux_5043 =
				 (((type_bglt) CREF(obj_3158))->id);
			   }
			   arg2073_1543 =
			      MAKE_PAIR(aux_5043, BNIL);
			}
			arg2072_1542 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg2073_1543);
		     }
		     list2071_1541 =
			MAKE_PAIR(slot_ref_id_128_1443, arg2072_1542);
		  }
		  slot_ref_tid_43_1444 =
		     symbol_append_197___r4_symbols_6_4(list2071_1541);
	       }
	       {	/* Object/access.scm 518 */
		  obj_t tid_1445;
		  {	/* Object/access.scm 521 */
		     obj_t list2068_1538;
		     {	/* Object/access.scm 521 */
			obj_t arg2069_1539;
			{	/* Object/access.scm 521 */
			   obj_t aux_5052;
			   {	/* Object/access.scm 521 */
			      type_bglt obj_3159;
			      obj_3159 =
				 (type_bglt) (type_155);
			      aux_5052 =
				 (((type_bglt) CREF(obj_3159))->id);
			   }
			   arg2069_1539 =
			      MAKE_PAIR(aux_5052, BNIL);
			}
			list2068_1538 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg2069_1539);
		     }
		     tid_1445 =
			symbol_append_197___r4_symbols_6_4(list2068_1538);
		  }
		  {	/* Object/access.scm 521 */
		     obj_t getter_1446;
		     getter_1446 =
			STRUCT_REF(slot_156, ((long) 13));
		     {	/* Object/access.scm 523 */
			obj_t obj_1448;
			obj_1448 =
			   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			   CNST_TABLE_REF(((long) 2)), BEOA);
			{	/* Object/access.scm 524 */
			   obj_t vnum_1449;
			   vnum_1449 =
			      STRUCT_REF(slot_156, ((long) 12));
			   {	/* Object/access.scm 525 */

			      {		/* Object/access.scm 527 */
				 bool_t test1984_1450;
				 {	/* Object/access.scm 527 */
				    long n1_3167;
				    n1_3167 =
				       (long) CINT(_optim__89_engine_param);
				    test1984_1450 =
				       (n1_3167 < ((long) 2));
				 }
				 if (test1984_1450)
				   {	/* Object/access.scm 527 */
				      {		/* Object/access.scm 528 */
					 obj_t arg1985_1451;
					 {	/* Object/access.scm 528 */
					    obj_t arg1986_1452;
					    {	/* Object/access.scm 528 */
					       obj_t arg1987_1453;
					       {	/* Object/access.scm 528 */
						  obj_t arg1989_1455;
						  arg1989_1455 =
						     MAKE_PAIR(tid_1445, BNIL);
						  arg1987_1453 =
						     MAKE_PAIR(slot_ref_tid_43_1444, arg1989_1455);
					       }
					       arg1986_1452 =
						  MAKE_PAIR(arg1987_1453, BNIL);
					    }
					    arg1985_1451 =
					       MAKE_PAIR(import_159, arg1986_1452);
					 }
					 produce_module_clause__172_module_module(arg1985_1451);
				      }
				      {		/* Object/access.scm 529 */
					 obj_t arg1990_1456;
					 {	/* Object/access.scm 529 */
					    obj_t arg1991_1457;
					    obj_t arg1992_1458;
					    arg1991_1457 =
					       CNST_TABLE_REF(((long) 4));
					    {	/* Object/access.scm 529 */
					       obj_t arg1993_1459;
					       {	/* Object/access.scm 529 */
						  obj_t arg1995_1461;
						  {	/* Object/access.scm 529 */
						     obj_t arg1996_1462;
						     obj_t arg1997_1463;
						     arg1996_1462 =
							CNST_TABLE_REF(((long) 5));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_5073;
							aux_5073 =
							   CNST_TABLE_REF(((long) 6));
							arg1997_1463 =
							   MAKE_PAIR(aux_5073, BNIL);
						     }
						     arg1995_1461 =
							MAKE_PAIR(arg1996_1462, arg1997_1463);
						  }
						  arg1993_1459 =
						     MAKE_PAIR(slot_ref_id_128_1443, arg1995_1461);
					       }
					       arg1992_1458 =
						  MAKE_PAIR(arg1993_1459, BNIL);
					    }
					    arg1990_1456 =
					       MAKE_PAIR(arg1991_1457, arg1992_1458);
					 }
					 produce_module_clause__172_module_module(arg1990_1456);
				      }
				      {		/* Object/access.scm 534 */
					 obj_t val0_1247_1464;
					 obj_t val1_1248_1465;
					 {	/* Object/access.scm 536 */
					    obj_t arg1998_1466;
					    {	/* Object/access.scm 536 */
					       obj_t arg2000_1468;
					       obj_t arg2001_1469;
					       {	/* Object/access.scm 536 */
						  obj_t arg2004_1472;
						  obj_t arg2005_1473;
						  arg2004_1472 =
						     CNST_TABLE_REF(((long) 16));
						  {	/* Object/access.scm 536 */
						     obj_t arg2006_1474;
						     obj_t arg2007_1475;
						     {	/* Object/access.scm 536 */
							obj_t arg2008_1476;
							{	/* Object/access.scm 536 */
							   obj_t arg2009_1477;
							   {	/* Object/access.scm 536 */
							      obj_t list2011_1479;
							      {		/* Object/access.scm 536 */
								 obj_t arg2012_1480;
								 arg2012_1480 =
								    MAKE_PAIR(tid_1445, BNIL);
								 list2011_1479 =
								    MAKE_PAIR(obj_1448, arg2012_1480);
							      }
							      arg2009_1477 =
								 symbol_append_197___r4_symbols_6_4(list2011_1479);
							   }
							   arg2008_1476 =
							      MAKE_PAIR(arg2009_1477, BNIL);
							}
							arg2006_1474 =
							   MAKE_PAIR(slot_ref_tid_43_1444, arg2008_1476);
						     }
						     {	/* Object/access.scm 537 */
							obj_t arg2013_1481;
							{	/* Object/access.scm 537 */
							   obj_t arg2015_1483;
							   obj_t arg2016_1484;
							   {	/* Object/access.scm 537 */
							      obj_t arg2017_1485;
							      obj_t arg2018_1486;
							      arg2017_1485 =
								 CNST_TABLE_REF(((long) 18));
							      {		/* Object/access.scm 537 */
								 obj_t arg2019_1487;
								 obj_t arg2020_1488;
								 arg2019_1487 =
								    CNST_TABLE_REF(((long) 53));
								 {	/* ./Ieee/pair-list.scm 5689 */
								    obj_t aux_5089;
								    aux_5089 =
								       CNST_TABLE_REF(((long) 45));
								    arg2020_1488 =
								       MAKE_PAIR(aux_5089, BNIL);
								 }
								 arg2018_1486 =
								    MAKE_PAIR(arg2019_1487, arg2020_1488);
							      }
							      arg2015_1483 =
								 MAKE_PAIR(arg2017_1485, arg2018_1486);
							   }
							   {	/* Object/access.scm 537 */
							      obj_t arg2021_1489;
							      arg2021_1489 =
								 MAKE_PAIR(vnum_1449, BNIL);
							      arg2016_1484 =
								 MAKE_PAIR(obj_1448, arg2021_1489);
							   }
							   arg2013_1481 =
							      MAKE_PAIR(arg2015_1483, arg2016_1484);
							}
							arg2007_1475 =
							   MAKE_PAIR(arg2013_1481, BNIL);
						     }
						     arg2005_1473 =
							MAKE_PAIR(arg2006_1474, arg2007_1475);
						  }
						  arg2000_1468 =
						     MAKE_PAIR(arg2004_1472, arg2005_1473);
					       }
					       {	/* Object/access.scm 538 */
						  bool_t test_5100;
						  if (
						     STRUCTP(slot_156))
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_5105;
						       obj_t aux_5103;
						       aux_5105 =
							  CNST_TABLE_REF(((long) 51));
						       aux_5103 =
							  STRUCT_KEY(slot_156);
						       test_5100 =
							  (aux_5103 == aux_5105);
						    }
						  else
						    {	/* ./Object/class.sch 1188 */
						       test_5100 = ((bool_t) 0)
							  ;
						    }
						  if (test_5100)
						    {	/* Object/access.scm 538 */
						       arg2001_1469 =
							  STRUCT_REF(slot_156, ((long) 15));
						    }
						  else
						    {	/* Object/access.scm 538 */
						       arg2001_1469 = slot_156;
						    }
					       }
					       {	/* Object/access.scm 536 */
						  obj_t list2002_1470;
						  {	/* Object/access.scm 536 */
						     obj_t arg2003_1471;
						     arg2003_1471 =
							MAKE_PAIR(src_def_101_158, BNIL);
						     list2002_1470 =
							MAKE_PAIR(arg2001_1469, arg2003_1471);
						  }
						  arg1998_1466 =
						     epairify__149_object_access(arg2000_1468, list2002_1470);
					       }
					    }
					    {	/* Object/access.scm 535 */
					       obj_t list1999_1467;
					       list1999_1467 =
						  MAKE_PAIR(arg1998_1466, BNIL);
					       val0_1247_1464 = list1999_1467;
					    }
					 }
					 {	/* Object/access.scm 542 */
					    bool_t test_5113;
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_5116;
					       obj_t aux_5114;
					       aux_5116 =
						  STRUCT_REF(slot_156, ((long) 16));
					       aux_5114 =
						  (obj_t) (class_154);
					       test_5113 =
						  (aux_5114 == aux_5116);
					    }
					    if (test_5113)
					      {		/* Object/access.scm 542 */
						 val1_1248_1465 = getter_1446;
					      }
					    else
					      {		/* Object/access.scm 542 */
						 val1_1248_1465 = BFALSE;
					      }
					 }
					 _res_number__75___r5_control_features_6_4 =
					    BINT(((long) 2));
					 _res1__155___r5_control_features_6_4 = val1_1248_1465;
					 return val0_1247_1464;
				      }
				   }
				 else
				   {	/* Object/access.scm 527 */
				      {		/* Object/access.scm 546 */
					 obj_t arg2025_1493;
					 {	/* Object/access.scm 546 */
					    obj_t arg2026_1494;
					    {	/* Object/access.scm 546 */
					       obj_t arg2027_1495;
					       {	/* Object/access.scm 546 */
						  obj_t arg2029_1497;
						  obj_t arg2030_1498;
						  arg2029_1497 =
						     CNST_TABLE_REF(((long) 12));
						  {	/* Object/access.scm 546 */
						     obj_t arg2031_1499;
						     arg2031_1499 =
							MAKE_PAIR(tid_1445, BNIL);
						     arg2030_1498 =
							MAKE_PAIR(slot_ref_tid_43_1444, arg2031_1499);
						  }
						  arg2027_1495 =
						     MAKE_PAIR(arg2029_1497, arg2030_1498);
					       }
					       arg2026_1494 =
						  MAKE_PAIR(arg2027_1495, BNIL);
					    }
					    arg2025_1493 =
					       MAKE_PAIR(import_159, arg2026_1494);
					 }
					 produce_module_clause__172_module_module(arg2025_1493);
				      }
				      {		/* Object/access.scm 547 */
					 obj_t arg2032_1500;
					 {	/* Object/access.scm 547 */
					    obj_t arg2033_1501;
					    obj_t arg2034_1502;
					    arg2033_1501 =
					       CNST_TABLE_REF(((long) 4));
					    {	/* Object/access.scm 547 */
					       obj_t arg2035_1503;
					       {	/* Object/access.scm 547 */
						  obj_t arg2037_1505;
						  {	/* Object/access.scm 547 */
						     obj_t arg2038_1506;
						     obj_t arg2039_1507;
						     arg2038_1506 =
							CNST_TABLE_REF(((long) 5));
						     {	/* ./Ieee/pair-list.scm 5689 */
							obj_t aux_5129;
							aux_5129 =
							   CNST_TABLE_REF(((long) 6));
							arg2039_1507 =
							   MAKE_PAIR(aux_5129, BNIL);
						     }
						     arg2037_1505 =
							MAKE_PAIR(arg2038_1506, arg2039_1507);
						  }
						  arg2035_1503 =
						     MAKE_PAIR(slot_ref_id_128_1443, arg2037_1505);
					       }
					       arg2034_1502 =
						  MAKE_PAIR(arg2035_1503, BNIL);
					    }
					    arg2032_1500 =
					       MAKE_PAIR(arg2033_1501, arg2034_1502);
					 }
					 produce_module_clause__172_module_module(arg2032_1500);
				      }
				      {		/* Object/access.scm 549 */
					 obj_t val0_1249_1508;
					 obj_t val1_1250_1509;
					 {	/* Object/access.scm 551 */
					    obj_t arg2040_1510;
					    {	/* Object/access.scm 551 */
					       obj_t arg2042_1512;
					       obj_t arg2043_1513;
					       {	/* Object/access.scm 551 */
						  obj_t arg2046_1516;
						  obj_t arg2047_1517;
						  arg2046_1516 =
						     CNST_TABLE_REF(((long) 15));
						  {	/* Object/access.scm 551 */
						     obj_t arg2048_1518;
						     obj_t arg2049_1519;
						     {	/* Object/access.scm 551 */
							obj_t arg2050_1520;
							{	/* Object/access.scm 551 */
							   obj_t arg2051_1521;
							   {	/* Object/access.scm 551 */
							      obj_t list2053_1523;
							      {		/* Object/access.scm 551 */
								 obj_t arg2054_1524;
								 arg2054_1524 =
								    MAKE_PAIR(tid_1445, BNIL);
								 list2053_1523 =
								    MAKE_PAIR(obj_1448, arg2054_1524);
							      }
							      arg2051_1521 =
								 symbol_append_197___r4_symbols_6_4(list2053_1523);
							   }
							   arg2050_1520 =
							      MAKE_PAIR(arg2051_1521, BNIL);
							}
							arg2048_1518 =
							   MAKE_PAIR(slot_ref_tid_43_1444, arg2050_1520);
						     }
						     {	/* Object/access.scm 552 */
							obj_t arg2055_1525;
							{	/* Object/access.scm 552 */
							   obj_t arg2057_1527;
							   obj_t arg2058_1528;
							   {	/* Object/access.scm 552 */
							      obj_t arg2059_1529;
							      obj_t arg2060_1530;
							      arg2059_1529 =
								 CNST_TABLE_REF(((long) 18));
							      {		/* Object/access.scm 552 */
								 obj_t arg2061_1531;
								 obj_t arg2062_1532;
								 arg2061_1531 =
								    CNST_TABLE_REF(((long) 53));
								 {	/* ./Ieee/pair-list.scm 5689 */
								    obj_t aux_5145;
								    aux_5145 =
								       CNST_TABLE_REF(((long) 45));
								    arg2062_1532 =
								       MAKE_PAIR(aux_5145, BNIL);
								 }
								 arg2060_1530 =
								    MAKE_PAIR(arg2061_1531, arg2062_1532);
							      }
							      arg2057_1527 =
								 MAKE_PAIR(arg2059_1529, arg2060_1530);
							   }
							   {	/* Object/access.scm 552 */
							      obj_t arg2063_1533;
							      arg2063_1533 =
								 MAKE_PAIR(vnum_1449, BNIL);
							      arg2058_1528 =
								 MAKE_PAIR(obj_1448, arg2063_1533);
							   }
							   arg2055_1525 =
							      MAKE_PAIR(arg2057_1527, arg2058_1528);
							}
							arg2049_1519 =
							   MAKE_PAIR(arg2055_1525, BNIL);
						     }
						     arg2047_1517 =
							MAKE_PAIR(arg2048_1518, arg2049_1519);
						  }
						  arg2042_1512 =
						     MAKE_PAIR(arg2046_1516, arg2047_1517);
					       }
					       {	/* Object/access.scm 553 */
						  bool_t test_5156;
						  if (
						     STRUCTP(slot_156))
						    {	/* ./Ieee/equiv.scm 5508 */
						       obj_t aux_5161;
						       obj_t aux_5159;
						       aux_5161 =
							  CNST_TABLE_REF(((long) 51));
						       aux_5159 =
							  STRUCT_KEY(slot_156);
						       test_5156 =
							  (aux_5159 == aux_5161);
						    }
						  else
						    {	/* ./Object/class.sch 1188 */
						       test_5156 = ((bool_t) 0)
							  ;
						    }
						  if (test_5156)
						    {	/* Object/access.scm 553 */
						       arg2043_1513 =
							  STRUCT_REF(slot_156, ((long) 15));
						    }
						  else
						    {	/* Object/access.scm 553 */
						       arg2043_1513 = slot_156;
						    }
					       }
					       {	/* Object/access.scm 551 */
						  obj_t list2044_1514;
						  {	/* Object/access.scm 551 */
						     obj_t arg2045_1515;
						     arg2045_1515 =
							MAKE_PAIR(src_def_101_158, BNIL);
						     list2044_1514 =
							MAKE_PAIR(arg2043_1513, arg2045_1515);
						  }
						  arg2040_1510 =
						     epairify__149_object_access(arg2042_1512, list2044_1514);
					       }
					    }
					    {	/* Object/access.scm 550 */
					       obj_t list2041_1511;
					       list2041_1511 =
						  MAKE_PAIR(arg2040_1510, BNIL);
					       val0_1249_1508 = list2041_1511;
					    }
					 }
					 {	/* Object/access.scm 557 */
					    bool_t test_5169;
					    {	/* ./Ieee/equiv.scm 5508 */
					       obj_t aux_5172;
					       obj_t aux_5170;
					       aux_5172 =
						  STRUCT_REF(slot_156, ((long) 16));
					       aux_5170 =
						  (obj_t) (class_154);
					       test_5169 =
						  (aux_5170 == aux_5172);
					    }
					    if (test_5169)
					      {		/* Object/access.scm 557 */
						 val1_1250_1509 = getter_1446;
					      }
					    else
					      {		/* Object/access.scm 557 */
						 val1_1250_1509 = BFALSE;
					      }
					 }
					 _res_number__75___r5_control_features_6_4 =
					    BINT(((long) 2));
					 _res1__155___r5_control_features_6_4 = val1_1250_1509;
					 return val0_1249_1508;
				      }
				   }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* slot-direct-ref */
obj_t 
slot_direct_ref_183_object_access(obj_t class_id_86_160, obj_t type_161, obj_t slot_162, obj_t widening_163, obj_t src_def_101_164, obj_t import_165)
{
   AN_OBJECT;
   {	/* Object/access.scm 564 */
      {		/* Object/access.scm 565 */
	 obj_t slot_ref_id_128_1550;
	 {	/* Object/access.scm 565 */
	    obj_t arg2165_1629;
	    arg2165_1629 =
	       CNST_TABLE_REF(((long) 24));
	    {	/* Object/access.scm 565 */
	       obj_t list2167_1631;
	       {	/* Object/access.scm 565 */
		  obj_t arg2168_1632;
		  {	/* Object/access.scm 565 */
		     obj_t arg2169_1633;
		     {	/* Object/access.scm 565 */
			obj_t aux_5177;
			aux_5177 =
			   STRUCT_REF(slot_162, ((long) 0));
			arg2169_1633 =
			   MAKE_PAIR(aux_5177, BNIL);
		     }
		     arg2168_1632 =
			MAKE_PAIR(arg2165_1629, arg2169_1633);
		  }
		  list2167_1631 =
		     MAKE_PAIR(class_id_86_160, arg2168_1632);
	       }
	       slot_ref_id_128_1550 =
		  symbol_append_197___r4_symbols_6_4(list2167_1631);
	    }
	 }
	 {	/* Object/access.scm 565 */
	    obj_t slot_ref_tid_43_1551;
	    {	/* Object/access.scm 566 */
	       obj_t list2160_1625;
	       {	/* Object/access.scm 566 */
		  obj_t arg2162_1626;
		  {	/* Object/access.scm 566 */
		     obj_t arg2163_1627;
		     {	/* Object/access.scm 566 */
			obj_t aux_5183;
			{	/* Object/access.scm 568 */
			   type_bglt obj_3291;
			   {	/* Object/access.scm 568 */
			      obj_t aux_5184;
			      aux_5184 =
				 STRUCT_REF(slot_162, ((long) 2));
			      obj_3291 =
				 (type_bglt) (aux_5184);
			   }
			   aux_5183 =
			      (((type_bglt) CREF(obj_3291))->id);
			}
			arg2163_1627 =
			   MAKE_PAIR(aux_5183, BNIL);
		     }
		     arg2162_1626 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2163_1627);
		  }
		  list2160_1625 =
		     MAKE_PAIR(slot_ref_id_128_1550, arg2162_1626);
	       }
	       slot_ref_tid_43_1551 =
		  symbol_append_197___r4_symbols_6_4(list2160_1625);
	    }
	    {	/* Object/access.scm 566 */
	       obj_t tid_1552;
	       {	/* Object/access.scm 569 */
		  obj_t list2157_1622;
		  {	/* Object/access.scm 569 */
		     obj_t arg2158_1623;
		     {	/* Object/access.scm 569 */
			obj_t aux_5192;
			{	/* Object/access.scm 569 */
			   type_bglt obj_3292;
			   obj_3292 =
			      (type_bglt) (type_161);
			   aux_5192 =
			      (((type_bglt) CREF(obj_3292))->id);
			}
			arg2158_1623 =
			   MAKE_PAIR(aux_5192, BNIL);
		     }
		     list2157_1622 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2158_1623);
		  }
		  tid_1552 =
		     symbol_append_197___r4_symbols_6_4(list2157_1622);
	       }
	       {	/* Object/access.scm 570 */

		  {	/* Object/access.scm 572 */
		     bool_t test2081_1554;
		     {	/* Object/access.scm 572 */
			long n1_3294;
			n1_3294 =
			   (long) CINT(_optim__89_engine_param);
			test2081_1554 =
			   (n1_3294 < ((long) 2));
		     }
		     if (test2081_1554)
		       {	/* Object/access.scm 572 */
			  {	/* Object/access.scm 573 */
			     obj_t arg2082_1555;
			     {	/* Object/access.scm 573 */
				obj_t arg2083_1556;
				{	/* Object/access.scm 573 */
				   obj_t arg2084_1557;
				   {	/* Object/access.scm 573 */
				      obj_t arg2086_1559;
				      arg2086_1559 =
					 MAKE_PAIR(tid_1552, BNIL);
				      arg2084_1557 =
					 MAKE_PAIR(slot_ref_tid_43_1551, arg2086_1559);
				   }
				   arg2083_1556 =
				      MAKE_PAIR(arg2084_1557, BNIL);
				}
				arg2082_1555 =
				   MAKE_PAIR(import_165, arg2083_1556);
			     }
			     produce_module_clause__172_module_module(arg2082_1555);
			  }
			  {	/* Object/access.scm 574 */
			     obj_t arg2087_1560;
			     {	/* Object/access.scm 574 */
				obj_t arg2088_1561;
				obj_t arg2090_1562;
				arg2088_1561 =
				   CNST_TABLE_REF(((long) 4));
				{	/* Object/access.scm 574 */
				   obj_t arg2091_1563;
				   {	/* Object/access.scm 574 */
				      obj_t arg2093_1565;
				      {		/* Object/access.scm 574 */
					 obj_t arg2094_1566;
					 obj_t arg2095_1567;
					 arg2094_1566 =
					    CNST_TABLE_REF(((long) 5));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_5208;
					    aux_5208 =
					       CNST_TABLE_REF(((long) 6));
					    arg2095_1567 =
					       MAKE_PAIR(aux_5208, BNIL);
					 }
					 arg2093_1565 =
					    MAKE_PAIR(arg2094_1566, arg2095_1567);
				      }
				      arg2091_1563 =
					 MAKE_PAIR(slot_ref_id_128_1550, arg2093_1565);
				   }
				   arg2090_1562 =
				      MAKE_PAIR(arg2091_1563, BNIL);
				}
				arg2087_1560 =
				   MAKE_PAIR(arg2088_1561, arg2090_1562);
			     }
			     produce_module_clause__172_module_module(arg2087_1560);
			  }
			  {	/* Object/access.scm 577 */
			     obj_t arg2096_1568;
			     {	/* Object/access.scm 577 */
				obj_t arg2098_1570;
				obj_t arg2099_1571;
				{	/* Object/access.scm 577 */
				   obj_t arg2103_1574;
				   obj_t arg2104_1575;
				   arg2103_1574 =
				      CNST_TABLE_REF(((long) 16));
				   {	/* Object/access.scm 577 */
				      obj_t arg2105_1576;
				      obj_t arg2106_1577;
				      {		/* Object/access.scm 577 */
					 obj_t arg2107_1578;
					 {	/* Object/access.scm 577 */
					    obj_t arg2108_1579;
					    {	/* Object/access.scm 577 */
					       obj_t list2110_1581;
					       {	/* Object/access.scm 577 */
						  obj_t arg2111_1582;
						  obj_t arg2112_1583;
						  arg2111_1582 =
						     CNST_TABLE_REF(((long) 2));
						  arg2112_1583 =
						     MAKE_PAIR(tid_1552, BNIL);
						  list2110_1581 =
						     MAKE_PAIR(arg2111_1582, arg2112_1583);
					       }
					       arg2108_1579 =
						  symbol_append_197___r4_symbols_6_4(list2110_1581);
					    }
					    arg2107_1578 =
					       MAKE_PAIR(arg2108_1579, BNIL);
					 }
					 arg2105_1576 =
					    MAKE_PAIR(slot_ref_tid_43_1551, arg2107_1578);
				      }
				      {		/* Object/access.scm 578 */
					 obj_t arg2113_1584;
					 arg2113_1584 =
					    make_pragma_direct_ref_widening_240_object_tools(
					    (type_bglt) (type_161), slot_162,
					    CNST_TABLE_REF(((long) 2)), widening_163);
					 arg2106_1577 =
					    MAKE_PAIR(arg2113_1584, BNIL);
				      }
				      arg2104_1575 =
					 MAKE_PAIR(arg2105_1576, arg2106_1577);
				   }
				   arg2098_1570 =
				      MAKE_PAIR(arg2103_1574, arg2104_1575);
				}
				{	/* Object/access.scm 580 */
				   bool_t test_5229;
				   if (
				      STRUCTP(slot_162))
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_5234;
					obj_t aux_5232;
					aux_5234 =
					   CNST_TABLE_REF(((long) 51));
					aux_5232 =
					   STRUCT_KEY(slot_162);
					test_5229 =
					   (aux_5232 == aux_5234);
				     }
				   else
				     {	/* ./Object/class.sch 1188 */
					test_5229 = ((bool_t) 0)
					   ;
				     }
				   if (test_5229)
				     {	/* Object/access.scm 580 */
					arg2099_1571 =
					   STRUCT_REF(slot_162, ((long) 15));
				     }
				   else
				     {	/* Object/access.scm 580 */
					arg2099_1571 = slot_162;
				     }
				}
				{	/* Object/access.scm 577 */
				   obj_t list2100_1572;
				   {	/* Object/access.scm 577 */
				      obj_t arg2101_1573;
				      arg2101_1573 =
					 MAKE_PAIR(src_def_101_164, BNIL);
				      list2100_1572 =
					 MAKE_PAIR(arg2099_1571, arg2101_1573);
				   }
				   arg2096_1568 =
				      epairify__149_object_access(arg2098_1570, list2100_1572);
				}
			     }
			     {	/* Object/access.scm 576 */
				obj_t list2097_1569;
				list2097_1569 =
				   MAKE_PAIR(arg2096_1568, BNIL);
				return list2097_1569;
			     }
			  }
		       }
		     else
		       {	/* Object/access.scm 572 */
			  {	/* Object/access.scm 585 */
			     obj_t arg2116_1587;
			     {	/* Object/access.scm 585 */
				obj_t arg2117_1588;
				{	/* Object/access.scm 585 */
				   obj_t arg2118_1589;
				   {	/* Object/access.scm 585 */
				      obj_t arg2120_1591;
				      obj_t arg2122_1592;
				      arg2120_1591 =
					 CNST_TABLE_REF(((long) 12));
				      {		/* Object/access.scm 585 */
					 obj_t arg2123_1593;
					 arg2123_1593 =
					    MAKE_PAIR(tid_1552, BNIL);
					 arg2122_1592 =
					    MAKE_PAIR(slot_ref_tid_43_1551, arg2123_1593);
				      }
				      arg2118_1589 =
					 MAKE_PAIR(arg2120_1591, arg2122_1592);
				   }
				   arg2117_1588 =
				      MAKE_PAIR(arg2118_1589, BNIL);
				}
				arg2116_1587 =
				   MAKE_PAIR(import_165, arg2117_1588);
			     }
			     produce_module_clause__172_module_module(arg2116_1587);
			  }
			  {	/* Object/access.scm 586 */
			     obj_t arg2124_1594;
			     {	/* Object/access.scm 586 */
				obj_t arg2125_1595;
				obj_t arg2126_1596;
				arg2125_1595 =
				   CNST_TABLE_REF(((long) 4));
				{	/* Object/access.scm 586 */
				   obj_t arg2127_1597;
				   {	/* Object/access.scm 586 */
				      obj_t arg2129_1599;
				      {		/* Object/access.scm 586 */
					 obj_t arg2131_1600;
					 obj_t arg2132_1601;
					 arg2131_1600 =
					    CNST_TABLE_REF(((long) 5));
					 {	/* ./Ieee/pair-list.scm 5689 */
					    obj_t aux_5251;
					    aux_5251 =
					       CNST_TABLE_REF(((long) 6));
					    arg2132_1601 =
					       MAKE_PAIR(aux_5251, BNIL);
					 }
					 arg2129_1599 =
					    MAKE_PAIR(arg2131_1600, arg2132_1601);
				      }
				      arg2127_1597 =
					 MAKE_PAIR(slot_ref_id_128_1550, arg2129_1599);
				   }
				   arg2126_1596 =
				      MAKE_PAIR(arg2127_1597, BNIL);
				}
				arg2124_1594 =
				   MAKE_PAIR(arg2125_1595, arg2126_1596);
			     }
			     produce_module_clause__172_module_module(arg2124_1594);
			  }
			  {	/* Object/access.scm 589 */
			     obj_t arg2133_1602;
			     {	/* Object/access.scm 589 */
				obj_t arg2135_1604;
				obj_t arg2136_1605;
				{	/* Object/access.scm 589 */
				   obj_t arg2139_1608;
				   obj_t arg2140_1609;
				   arg2139_1608 =
				      CNST_TABLE_REF(((long) 15));
				   {	/* Object/access.scm 589 */
				      obj_t arg2141_1610;
				      obj_t arg2144_1611;
				      {		/* Object/access.scm 589 */
					 obj_t arg2145_1612;
					 {	/* Object/access.scm 589 */
					    obj_t arg2146_1613;
					    {	/* Object/access.scm 589 */
					       obj_t list2149_1615;
					       {	/* Object/access.scm 589 */
						  obj_t arg2150_1616;
						  obj_t arg2151_1617;
						  arg2150_1616 =
						     CNST_TABLE_REF(((long) 2));
						  arg2151_1617 =
						     MAKE_PAIR(tid_1552, BNIL);
						  list2149_1615 =
						     MAKE_PAIR(arg2150_1616, arg2151_1617);
					       }
					       arg2146_1613 =
						  symbol_append_197___r4_symbols_6_4(list2149_1615);
					    }
					    arg2145_1612 =
					       MAKE_PAIR(arg2146_1613, BNIL);
					 }
					 arg2141_1610 =
					    MAKE_PAIR(slot_ref_tid_43_1551, arg2145_1612);
				      }
				      {		/* Object/access.scm 590 */
					 obj_t arg2153_1618;
					 arg2153_1618 =
					    make_pragma_direct_ref_widening_240_object_tools(
					    (type_bglt) (type_161), slot_162,
					    CNST_TABLE_REF(((long) 2)), widening_163);
					 arg2144_1611 =
					    MAKE_PAIR(arg2153_1618, BNIL);
				      }
				      arg2140_1609 =
					 MAKE_PAIR(arg2141_1610, arg2144_1611);
				   }
				   arg2135_1604 =
				      MAKE_PAIR(arg2139_1608, arg2140_1609);
				}
				{	/* Object/access.scm 592 */
				   bool_t test_5272;
				   if (
				      STRUCTP(slot_162))
				     {	/* ./Ieee/equiv.scm 5508 */
					obj_t aux_5277;
					obj_t aux_5275;
					aux_5277 =
					   CNST_TABLE_REF(((long) 51));
					aux_5275 =
					   STRUCT_KEY(slot_162);
					test_5272 =
					   (aux_5275 == aux_5277);
				     }
				   else
				     {	/* ./Object/class.sch 1188 */
					test_5272 = ((bool_t) 0)
					   ;
				     }
				   if (test_5272)
				     {	/* Object/access.scm 592 */
					arg2136_1605 =
					   STRUCT_REF(slot_162, ((long) 15));
				     }
				   else
				     {	/* Object/access.scm 592 */
					arg2136_1605 = slot_162;
				     }
				}
				{	/* Object/access.scm 589 */
				   obj_t list2137_1606;
				   {	/* Object/access.scm 589 */
				      obj_t arg2138_1607;
				      arg2138_1607 =
					 MAKE_PAIR(src_def_101_164, BNIL);
				      list2137_1606 =
					 MAKE_PAIR(arg2136_1605, arg2138_1607);
				   }
				   arg2133_1602 =
				      epairify__149_object_access(arg2135_1604, list2137_1606);
				}
			     }
			     {	/* Object/access.scm 588 */
				obj_t list2134_1603;
				list2134_1603 =
				   MAKE_PAIR(arg2133_1602, BNIL);
				return list2134_1603;
			     }
			  }
		       }
		  }
	       }
	    }
	 }
      }
   }
}



/* slot-set! */
obj_t 
slot_set__144_object_access(tclass_bglt class_166, obj_t type_167, obj_t slot_168, obj_t widening_169, obj_t src_def_101_170, obj_t import_171)
{
   AN_OBJECT;
   {	/* Object/access.scm 600 */
      {		/* Object/access.scm 601 */
	 obj_t class_id_86_1634;
	 {	/* Object/access.scm 601 */
	    type_bglt obj_3378;
	    obj_3378 =
	       (type_bglt) (class_166);
	    class_id_86_1634 =
	       (((type_bglt) CREF(obj_3378))->id);
	 }
	 {	/* Object/access.scm 603 */
	    bool_t test_5287;
	    {	/* ./Llib/struct.scm 1457 */
	       obj_t aux_5288;
	       aux_5288 =
		  STRUCT_REF(slot_168, ((long) 5));
	       test_5287 =
		  CBOOL(aux_5288);
	    }
	    if (test_5287)
	      {		/* Object/access.scm 603 */
		 {	/* Object/access.scm 604 */
		    obj_t val0_1251_1636;
		    val0_1251_1636 =
		       slot_dyna_indexed_set__50_object_access(class_id_86_1634, type_167, slot_168, widening_169, src_def_101_170, import_171);
		    _res_number__75___r5_control_features_6_4 =
		       BINT(((long) 2));
		    _res1__155___r5_control_features_6_4 = BFALSE;
		    return val0_1251_1636;
		 }
	      }
	    else
	      {		/* Object/access.scm 607 */
		 bool_t test_5293;
		 {	/* ./Llib/struct.scm 1457 */
		    obj_t aux_5294;
		    aux_5294 =
		       STRUCT_REF(slot_168, ((long) 3));
		    test_5293 =
		       CBOOL(aux_5294);
		 }
		 if (test_5293)
		   {	/* Object/access.scm 607 */
		      {		/* Object/access.scm 608 */
			 obj_t val0_1253_1639;
			 {	/* Object/access.scm 640 */
			    obj_t arg2184_3391;
			    {	/* Object/access.scm 640 */
			       obj_t arg2185_3392;
			       obj_t arg2187_3393;
			       arg2185_3392 =
				  CNST_TABLE_REF(((long) 43));
			       {	/* ./Ieee/pair-list.scm 5689 */
				  obj_t aux_5298;
				  aux_5298 =
				     STRUCT_REF(slot_168, ((long) 4));
				  arg2187_3393 =
				     MAKE_PAIR(aux_5298, BNIL);
			       }
			       arg2184_3391 =
				  MAKE_PAIR(arg2185_3392, arg2187_3393);
			    }
			    val0_1253_1639 =
			       slot_indexed_set__217_object_access(class_id_86_1634, type_167, slot_168, widening_169, arg2184_3391, src_def_101_170, import_171);
			 }
			 _res_number__75___r5_control_features_6_4 =
			    BINT(((long) 2));
			 _res1__155___r5_control_features_6_4 = BFALSE;
			 return val0_1253_1639;
		      }
		   }
		 else
		   {	/* Object/access.scm 611 */
		      bool_t test_5304;
		      {		/* ./Llib/struct.scm 1457 */
			 obj_t aux_5305;
			 aux_5305 =
			    STRUCT_REF(slot_168, ((long) 11));
			 test_5304 =
			    CBOOL(aux_5305);
		      }
		      if (test_5304)
			{	/* Object/access.scm 611 */
			   {	/* Object/access.scm 612 */
			      obj_t user_def_147_1642;
			      user_def_147_1642 =
				 slot_virtual_set__86_object_access(class_166, type_167, slot_168, widening_169, src_def_101_170, import_171);
			      {		/* Object/access.scm 614 */
				 obj_t class_def_12_1643;
				 class_def_12_1643 = _res1__155___r5_control_features_6_4;
				 _res_number__75___r5_control_features_6_4 =
				    BINT(((long) 2));
				 _res1__155___r5_control_features_6_4 = class_def_12_1643;
				 return user_def_147_1642;
			      }
			   }
			}
		      else
			{	/* Object/access.scm 611 */
			   {	/* Object/access.scm 616 */
			      obj_t val0_1257_1646;
			      val0_1257_1646 =
				 slot_direct_set__173_object_access(class_id_86_1634, type_167, slot_168, widening_169, src_def_101_170, import_171);
			      _res_number__75___r5_control_features_6_4 =
				 BINT(((long) 2));
			      _res1__155___r5_control_features_6_4 = BFALSE;
			      return val0_1257_1646;
			   }
			}
		   }
	      }
	 }
      }
   }
}



/* slot-dyna-indexed-set! */
obj_t 
slot_dyna_indexed_set__50_object_access(obj_t class_id_86_172, obj_t type_173, obj_t slot_174, obj_t widening_175, obj_t src_def_101_176, obj_t import_177)
{
   AN_OBJECT;
   {	/* Object/access.scm 623 */
      {		/* Object/access.scm 628 */
	 obj_t arg2173_1648;
	 {	/* Object/access.scm 628 */
	    obj_t arg2174_1649;
	    obj_t arg2175_1650;
	    {	/* Object/access.scm 628 */
	       obj_t arg2176_1651;
	       obj_t arg2177_1652;
	       arg2176_1651 =
		  CNST_TABLE_REF(((long) 24));
	       arg2177_1652 =
		  STRUCT_REF(slot_174, ((long) 0));
	       {	/* Object/access.scm 628 */
		  obj_t list2179_1654;
		  {	/* Object/access.scm 628 */
		     obj_t arg2180_1655;
		     {	/* Object/access.scm 628 */
			obj_t arg2181_1656;
			{	/* Object/access.scm 628 */
			   obj_t arg2183_1657;
			   {	/* Object/access.scm 628 */
			      obj_t aux_5314;
			      aux_5314 =
				 CNST_TABLE_REF(((long) 36));
			      arg2183_1657 =
				 MAKE_PAIR(aux_5314, BNIL);
			   }
			   arg2181_1656 =
			      MAKE_PAIR(arg2177_1652, arg2183_1657);
			}
			arg2180_1655 =
			   MAKE_PAIR(arg2176_1651, arg2181_1656);
		     }
		     list2179_1654 =
			MAKE_PAIR(class_id_86_172, arg2180_1655);
		  }
		  arg2174_1649 =
		     symbol_append_197___r4_symbols_6_4(list2179_1654);
	       }
	    }
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_5321;
	       aux_5321 =
		  CNST_TABLE_REF(((long) 2));
	       arg2175_1650 =
		  MAKE_PAIR(aux_5321, BNIL);
	    }
	    arg2173_1648 =
	       MAKE_PAIR(arg2174_1649, arg2175_1650);
	 }
	 return
	    slot_indexed_set__217_object_access(class_id_86_172, type_173, slot_174, widening_175, arg2173_1648, src_def_101_176, import_177);
      }
   }
}



/* slot-indexed-set! */
obj_t 
slot_indexed_set__217_object_access(obj_t class_id_86_184, obj_t type_185, obj_t slot_186, obj_t widening_187, obj_t max_bound_128_188, obj_t src_def_101_189, obj_t import_190)
{
   AN_OBJECT;
   {	/* Object/access.scm 647 */
      {
	 obj_t slot_set__id_195_1776;
	 obj_t slot_set__tid_15_1777;
	 obj_t val_id_206_1778;
	 obj_t val_tid_245_1779;
	 obj_t slot_set__id_195_1710;
	 obj_t slot_set__tid_15_1711;
	 obj_t val_id_206_1712;
	 obj_t val_tid_245_1713;
	 {	/* Object/access.scm 682 */
	    obj_t slot_set__id_195_1665;
	    {	/* Object/access.scm 682 */
	       obj_t arg2226_1703;
	       obj_t arg2227_1704;
	       arg2226_1703 =
		  CNST_TABLE_REF(((long) 24));
	       arg2227_1704 =
		  STRUCT_REF(slot_186, ((long) 0));
	       {	/* Object/access.scm 682 */
		  obj_t list2229_1706;
		  {	/* Object/access.scm 682 */
		     obj_t arg2230_1707;
		     {	/* Object/access.scm 682 */
			obj_t arg2231_1708;
			{	/* Object/access.scm 682 */
			   obj_t arg2232_1709;
			   {	/* Object/access.scm 682 */
			      obj_t aux_5328;
			      aux_5328 =
				 CNST_TABLE_REF(((long) 54));
			      arg2232_1709 =
				 MAKE_PAIR(aux_5328, BNIL);
			   }
			   arg2231_1708 =
			      MAKE_PAIR(arg2227_1704, arg2232_1709);
			}
			arg2230_1707 =
			   MAKE_PAIR(arg2226_1703, arg2231_1708);
		     }
		     list2229_1706 =
			MAKE_PAIR(class_id_86_184, arg2230_1707);
		  }
		  slot_set__id_195_1665 =
		     symbol_append_197___r4_symbols_6_4(list2229_1706);
	       }
	    }
	    {	/* Object/access.scm 682 */
	       obj_t slot_set__tid_15_1666;
	       {	/* Object/access.scm 683 */
		  obj_t list2224_1701;
		  {	/* Object/access.scm 683 */
		     obj_t arg2225_1702;
		     {	/* Object/access.scm 683 */
			obj_t aux_5335;
			aux_5335 =
			   CNST_TABLE_REF(((long) 13));
			arg2225_1702 =
			   MAKE_PAIR(aux_5335, BNIL);
		     }
		     list2224_1701 =
			MAKE_PAIR(slot_set__id_195_1665, arg2225_1702);
		  }
		  slot_set__tid_15_1666 =
		     symbol_append_197___r4_symbols_6_4(list2224_1701);
	       }
	       {	/* Object/access.scm 683 */
		  obj_t tid_1667;
		  {	/* Object/access.scm 684 */
		     obj_t list2222_1699;
		     {	/* Object/access.scm 684 */
			obj_t arg2223_1700;
			{	/* Object/access.scm 684 */
			   obj_t aux_5340;
			   {	/* Object/access.scm 684 */
			      type_bglt obj_3428;
			      obj_3428 =
				 (type_bglt) (type_185);
			      aux_5340 =
				 (((type_bglt) CREF(obj_3428))->id);
			   }
			   arg2223_1700 =
			      MAKE_PAIR(aux_5340, BNIL);
			}
			list2222_1699 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg2223_1700);
		     }
		     tid_1667 =
			symbol_append_197___r4_symbols_6_4(list2222_1699);
		  }
		  {	/* Object/access.scm 685 */
		     obj_t v_id_210_1669;
		     v_id_210_1669 =
			PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			CNST_TABLE_REF(((long) 55)), BEOA);
		     {	/* Object/access.scm 686 */
			obj_t v_tid_138_1670;
			{	/* Object/access.scm 687 */
			   obj_t list2216_1694;
			   {	/* Object/access.scm 687 */
			      obj_t arg2217_1695;
			      {		/* Object/access.scm 687 */
				 obj_t arg2219_1696;
				 {	/* Object/access.scm 687 */
				    obj_t aux_5349;
				    {	/* Object/access.scm 689 */
				       type_bglt obj_3433;
				       {	/* Object/access.scm 689 */
					  obj_t aux_5350;
					  aux_5350 =
					     STRUCT_REF(slot_186, ((long) 2));
					  obj_3433 =
					     (type_bglt) (aux_5350);
				       }
				       aux_5349 =
					  (((type_bglt) CREF(obj_3433))->id);
				    }
				    arg2219_1696 =
				       MAKE_PAIR(aux_5349, BNIL);
				 }
				 arg2217_1695 =
				    MAKE_PAIR(_4dots_199_tools_misc, arg2219_1696);
			      }
			      list2216_1694 =
				 MAKE_PAIR(v_id_210_1669, arg2217_1695);
			   }
			   v_tid_138_1670 =
			      symbol_append_197___r4_symbols_6_4(list2216_1694);
			}
			{	/* Object/access.scm 687 */

			   if (
			      CBOOL(_unsafe_range__218_engine_param))
			     {	/* Object/access.scm 691 */
				{	/* Object/access.scm 697 */
				   obj_t arg2190_1671;
				   {	/* Object/access.scm 697 */
				      obj_t arg2191_1672;
				      {		/* Object/access.scm 697 */
					 obj_t arg2192_1673;
					 {	/* Object/access.scm 697 */
					    obj_t arg2195_1675;
					    obj_t arg2197_1676;
					    arg2195_1675 =
					       CNST_TABLE_REF(((long) 12));
					    {	/* Object/access.scm 697 */
					       obj_t arg2198_1677;
					       {	/* Object/access.scm 697 */
						  obj_t arg2199_1678;
						  {	/* Object/access.scm 697 */
						     obj_t arg2200_1679;
						     obj_t arg2201_1680;
						     arg2200_1679 =
							CNST_TABLE_REF(((long) 27));
						     arg2201_1680 =
							MAKE_PAIR(v_tid_138_1670, BNIL);
						     arg2199_1678 =
							MAKE_PAIR(arg2200_1679, arg2201_1680);
						  }
						  arg2198_1677 =
						     MAKE_PAIR(tid_1667, arg2199_1678);
					       }
					       arg2197_1676 =
						  MAKE_PAIR(slot_set__tid_15_1666, arg2198_1677);
					    }
					    arg2192_1673 =
					       MAKE_PAIR(arg2195_1675, arg2197_1676);
					 }
					 arg2191_1672 =
					    MAKE_PAIR(arg2192_1673, BNIL);
				      }
				      arg2190_1671 =
					 MAKE_PAIR(import_190, arg2191_1672);
				   }
				   produce_module_clause__172_module_module(arg2190_1671);
				}
				{	/* Object/access.scm 702 */
				   obj_t arg2202_1681;
				   slot_set__id_195_1776 = slot_set__id_195_1665;
				   slot_set__tid_15_1777 = slot_set__tid_15_1666;
				   val_id_206_1778 = v_id_210_1669;
				   val_tid_245_1779 = v_tid_138_1670;
				   {	/* Object/access.scm 649 */
				      obj_t arg2302_1781;
				      obj_t arg2303_1782;
				      {		/* Object/access.scm 649 */
					 obj_t arg2306_1785;
					 obj_t arg2307_1786;
					 arg2306_1785 =
					    CNST_TABLE_REF(((long) 15));
					 {	/* Object/access.scm 650 */
					    obj_t arg2308_1787;
					    obj_t arg2309_1788;
					    {	/* Object/access.scm 650 */
					       obj_t arg2310_1789;
					       {	/* Object/access.scm 650 */
						  obj_t arg2311_1790;
						  obj_t arg2312_1791;
						  {	/* Object/access.scm 650 */
						     obj_t arg2313_1792;
						     arg2313_1792 =
							CNST_TABLE_REF(((long) 2));
						     {	/* Object/access.scm 650 */
							obj_t list2315_1794;
							{	/* Object/access.scm 650 */
							   obj_t arg2316_1795;
							   {	/* Object/access.scm 650 */
							      obj_t arg2317_1796;
							      {		/* Object/access.scm 650 */
								 obj_t aux_5372;
								 {	/* Object/access.scm 650 */
								    type_bglt obj_3540;
								    obj_3540 =
								       (type_bglt) (type_185);
								    aux_5372 =
								       (((type_bglt) CREF(obj_3540))->id);
								 }
								 arg2317_1796 =
								    MAKE_PAIR(aux_5372, BNIL);
							      }
							      arg2316_1795 =
								 MAKE_PAIR(_4dots_199_tools_misc, arg2317_1796);
							   }
							   list2315_1794 =
							      MAKE_PAIR(arg2313_1792, arg2316_1795);
							}
							arg2311_1790 =
							   symbol_append_197___r4_symbols_6_4(list2315_1794);
						     }
						  }
						  {	/* Object/access.scm 649 */
						     obj_t arg2318_1797;
						     obj_t arg2319_1798;
						     arg2318_1797 =
							CNST_TABLE_REF(((long) 46));
						     arg2319_1798 =
							MAKE_PAIR(val_tid_245_1779, BNIL);
						     arg2312_1791 =
							MAKE_PAIR(arg2318_1797, arg2319_1798);
						  }
						  arg2310_1789 =
						     MAKE_PAIR(arg2311_1790, arg2312_1791);
					       }
					       arg2308_1787 =
						  MAKE_PAIR(slot_set__tid_15_1777, arg2310_1789);
					    }
					    {	/* Object/access.scm 653 */
					       obj_t arg2320_1799;
					       arg2320_1799 =
						  make_pragma_indexed_set__widening_24_object_tools(
						  (type_bglt) (type_185), slot_186,
						  CNST_TABLE_REF(((long) 2)), val_id_206_1778,
						  CNST_TABLE_REF(((long) 48)), widening_187);
					       arg2309_1788 =
						  MAKE_PAIR(arg2320_1799, BNIL);
					    }
					    arg2307_1786 =
					       MAKE_PAIR(arg2308_1787, arg2309_1788);
					 }
					 arg2302_1781 =
					    MAKE_PAIR(arg2306_1785, arg2307_1786);
				      }
				      {		/* Object/access.scm 659 */
					 bool_t test_5391;
					 if (
					    STRUCTP(slot_186))
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_5396;
					      obj_t aux_5394;
					      aux_5396 =
						 CNST_TABLE_REF(((long) 51));
					      aux_5394 =
						 STRUCT_KEY(slot_186);
					      test_5391 =
						 (aux_5394 == aux_5396);
					   }
					 else
					   {	/* ./Object/class.sch 1188 */
					      test_5391 = ((bool_t) 0)
						 ;
					   }
					 if (test_5391)
					   {	/* Object/access.scm 659 */
					      arg2303_1782 =
						 STRUCT_REF(slot_186, ((long) 15));
					   }
					 else
					   {	/* Object/access.scm 659 */
					      arg2303_1782 = slot_186;
					   }
				      }
				      {		/* Object/access.scm 649 */
					 obj_t list2304_1783;
					 {	/* Object/access.scm 649 */
					    obj_t arg2305_1784;
					    arg2305_1784 =
					       MAKE_PAIR(src_def_101_189, BNIL);
					    list2304_1783 =
					       MAKE_PAIR(arg2303_1782, arg2305_1784);
					 }
					 arg2202_1681 =
					    epairify__149_object_access(arg2302_1781, list2304_1783);
				      }
				   }
				   {	/* Object/access.scm 701 */
				      obj_t list2203_1682;
				      list2203_1682 =
					 MAKE_PAIR(arg2202_1681, BNIL);
				      return list2203_1682;
				   }
				}
			     }
			   else
			     {	/* Object/access.scm 691 */
				{	/* Object/access.scm 692 */
				   obj_t arg2204_1683;
				   {	/* Object/access.scm 692 */
				      obj_t arg2206_1684;
				      {		/* Object/access.scm 692 */
					 obj_t arg2207_1685;
					 {	/* Object/access.scm 692 */
					    obj_t arg2209_1687;
					    {	/* Object/access.scm 692 */
					       obj_t arg2210_1688;
					       {	/* Object/access.scm 692 */
						  obj_t arg2211_1689;
						  obj_t arg2212_1690;
						  arg2211_1689 =
						     CNST_TABLE_REF(((long) 27));
						  arg2212_1690 =
						     MAKE_PAIR(v_tid_138_1670, BNIL);
						  arg2210_1688 =
						     MAKE_PAIR(arg2211_1689, arg2212_1690);
					       }
					       arg2209_1687 =
						  MAKE_PAIR(tid_1667, arg2210_1688);
					    }
					    arg2207_1685 =
					       MAKE_PAIR(slot_set__tid_15_1666, arg2209_1687);
					 }
					 arg2206_1684 =
					    MAKE_PAIR(arg2207_1685, BNIL);
				      }
				      arg2204_1683 =
					 MAKE_PAIR(import_190, arg2206_1684);
				   }
				   produce_module_clause__172_module_module(arg2204_1683);
				}
				{	/* Object/access.scm 695 */
				   obj_t arg2213_1691;
				   slot_set__id_195_1710 = slot_set__id_195_1665;
				   slot_set__tid_15_1711 = slot_set__tid_15_1666;
				   val_id_206_1712 = v_id_210_1669;
				   val_tid_245_1713 = v_tid_138_1670;
				   {	/* Object/access.scm 664 */
				      obj_t arg2234_1715;
				      obj_t arg2236_1716;
				      {		/* Object/access.scm 664 */
					 obj_t arg2240_1719;
					 obj_t arg2241_1720;
					 arg2240_1719 =
					    CNST_TABLE_REF(((long) 16));
					 {	/* Object/access.scm 665 */
					    obj_t arg2242_1721;
					    obj_t arg2243_1722;
					    {	/* Object/access.scm 665 */
					       obj_t arg2244_1723;
					       {	/* Object/access.scm 665 */
						  obj_t arg2245_1724;
						  obj_t arg2246_1725;
						  {	/* Object/access.scm 665 */
						     obj_t arg2247_1726;
						     arg2247_1726 =
							CNST_TABLE_REF(((long) 2));
						     {	/* Object/access.scm 665 */
							obj_t list2249_1728;
							{	/* Object/access.scm 665 */
							   obj_t arg2250_1729;
							   {	/* Object/access.scm 665 */
							      obj_t arg2251_1730;
							      {		/* Object/access.scm 665 */
								 obj_t aux_5414;
								 {	/* Object/access.scm 665 */
								    type_bglt obj_3462;
								    obj_3462 =
								       (type_bglt) (type_185);
								    aux_5414 =
								       (((type_bglt) CREF(obj_3462))->id);
								 }
								 arg2251_1730 =
								    MAKE_PAIR(aux_5414, BNIL);
							      }
							      arg2250_1729 =
								 MAKE_PAIR(_4dots_199_tools_misc, arg2251_1730);
							   }
							   list2249_1728 =
							      MAKE_PAIR(arg2247_1726, arg2250_1729);
							}
							arg2245_1724 =
							   symbol_append_197___r4_symbols_6_4(list2249_1728);
						     }
						  }
						  {	/* Object/access.scm 664 */
						     obj_t arg2253_1731;
						     obj_t arg2254_1732;
						     arg2253_1731 =
							CNST_TABLE_REF(((long) 46));
						     arg2254_1732 =
							MAKE_PAIR(val_tid_245_1713, BNIL);
						     arg2246_1725 =
							MAKE_PAIR(arg2253_1731, arg2254_1732);
						  }
						  arg2244_1723 =
						     MAKE_PAIR(arg2245_1724, arg2246_1725);
					       }
					       arg2242_1721 =
						  MAKE_PAIR(slot_set__tid_15_1711, arg2244_1723);
					    }
					    {	/* Object/access.scm 668 */
					       obj_t arg2255_1733;
					       {	/* Object/access.scm 668 */
						  obj_t arg2257_1735;
						  obj_t arg2258_1736;
						  arg2257_1735 =
						     CNST_TABLE_REF(((long) 38));
						  {	/* Object/access.scm 668 */
						     obj_t arg2259_1737;
						     obj_t arg2260_1738;
						     {	/* Object/access.scm 668 */
							obj_t arg2261_1739;
							obj_t arg2263_1740;
							arg2261_1739 =
							   CNST_TABLE_REF(((long) 47));
							{	/* Object/access.scm 668 */
							   obj_t arg2264_1741;
							   obj_t arg2265_1742;
							   arg2264_1741 =
							      CNST_TABLE_REF(((long) 48));
							   {	/* ./Ieee/pair-list.scm 5689 */
							      obj_t aux_5429;
							      aux_5429 =
								 BINT(((long) 0));
							      arg2265_1742 =
								 MAKE_PAIR(aux_5429, BNIL);
							   }
							   arg2263_1740 =
							      MAKE_PAIR(arg2264_1741, arg2265_1742);
							}
							arg2259_1737 =
							   MAKE_PAIR(arg2261_1739, arg2263_1740);
						     }
						     {	/* Object/access.scm 669 */
							obj_t arg2266_1743;
							obj_t arg2267_1744;
							{	/* Object/access.scm 669 */
							   obj_t arg2268_1745;
							   obj_t arg2269_1746;
							   arg2268_1745 =
							      CNST_TABLE_REF(((long) 38));
							   {	/* Object/access.scm 669 */
							      obj_t arg2270_1747;
							      obj_t arg2271_1748;
							      {		/* Object/access.scm 669 */
								 obj_t arg2272_1749;
								 obj_t arg2273_1750;
								 arg2272_1749 =
								    CNST_TABLE_REF(((long) 49));
								 {	/* Object/access.scm 669 */
								    obj_t arg2274_1751;
								    obj_t arg2276_1752;
								    arg2274_1751 =
								       CNST_TABLE_REF(((long) 48));
								    arg2276_1752 =
								       MAKE_PAIR(max_bound_128_188, BNIL);
								    arg2273_1750 =
								       MAKE_PAIR(arg2274_1751, arg2276_1752);
								 }
								 arg2270_1747 =
								    MAKE_PAIR(arg2272_1749, arg2273_1750);
							      }
							      {		/* Object/access.scm 670 */
								 obj_t arg2277_1753;
								 obj_t arg2279_1754;
								 arg2277_1753 =
								    make_pragma_indexed_set__widening_24_object_tools(
								    (type_bglt) (type_185), slot_186,
								    CNST_TABLE_REF(((long) 2)), val_id_206_1712,
								    CNST_TABLE_REF(((long) 48)), widening_187);
								 {	/* Object/access.scm 676 */
								    obj_t arg2280_1755;
								    {	/* Object/access.scm 676 */
								       obj_t arg2282_1757;
								       obj_t arg2283_1758;
								       arg2282_1757 =
									  CNST_TABLE_REF(((long) 50));
								       {	/* Object/access.scm 676 */
									  obj_t arg2284_1759;
									  obj_t arg2285_1760;
									  {	/* Object/access.scm 676 */
									     obj_t arg2286_1761;
									     obj_t arg2287_1762;
									     arg2286_1761 =
										CNST_TABLE_REF(((long) 40));
									     arg2287_1762 =
										MAKE_PAIR(slot_set__id_195_1710, BNIL);
									     arg2284_1759 =
										MAKE_PAIR(arg2286_1761, arg2287_1762);
									  }
									  {	/* Object/access.scm 676 */
									     obj_t arg2289_1764;
									     {	/* ./Ieee/pair-list.scm 5689 */
										obj_t aux_5448;
										aux_5448 =
										   CNST_TABLE_REF(((long) 48));
										arg2289_1764 =
										   MAKE_PAIR(aux_5448, BNIL);
									     }
									     arg2285_1760 =
										MAKE_PAIR(string2644_object_access, arg2289_1764);
									  }
									  arg2283_1758 =
									     MAKE_PAIR(arg2284_1759, arg2285_1760);
								       }
								       arg2280_1755 =
									  MAKE_PAIR(arg2282_1757, arg2283_1758);
								    }
								    arg2279_1754 =
								       MAKE_PAIR(arg2280_1755, BNIL);
								 }
								 arg2271_1748 =
								    MAKE_PAIR(arg2277_1753, arg2279_1754);
							      }
							      arg2269_1746 =
								 MAKE_PAIR(arg2270_1747, arg2271_1748);
							   }
							   arg2266_1743 =
							      MAKE_PAIR(arg2268_1745, arg2269_1746);
							}
							{	/* Object/access.scm 677 */
							   obj_t arg2290_1765;
							   {	/* Object/access.scm 677 */
							      obj_t arg2292_1767;
							      obj_t arg2293_1768;
							      arg2292_1767 =
								 CNST_TABLE_REF(((long) 50));
							      {		/* Object/access.scm 677 */
								 obj_t arg2294_1769;
								 obj_t arg2295_1770;
								 {	/* Object/access.scm 677 */
								    obj_t arg2296_1771;
								    obj_t arg2297_1772;
								    arg2296_1771 =
								       CNST_TABLE_REF(((long) 40));
								    arg2297_1772 =
								       MAKE_PAIR(slot_set__id_195_1710, BNIL);
								    arg2294_1769 =
								       MAKE_PAIR(arg2296_1771, arg2297_1772);
								 }
								 {	/* Object/access.scm 677 */
								    obj_t arg2299_1774;
								    {	/* ./Ieee/pair-list.scm 5689 */
								       obj_t aux_5462;
								       aux_5462 =
									  CNST_TABLE_REF(((long) 48));
								       arg2299_1774 =
									  MAKE_PAIR(aux_5462, BNIL);
								    }
								    arg2295_1770 =
								       MAKE_PAIR(string2644_object_access, arg2299_1774);
								 }
								 arg2293_1768 =
								    MAKE_PAIR(arg2294_1769, arg2295_1770);
							      }
							      arg2290_1765 =
								 MAKE_PAIR(arg2292_1767, arg2293_1768);
							   }
							   arg2267_1744 =
							      MAKE_PAIR(arg2290_1765, BNIL);
							}
							arg2260_1738 =
							   MAKE_PAIR(arg2266_1743, arg2267_1744);
						     }
						     arg2258_1736 =
							MAKE_PAIR(arg2259_1737, arg2260_1738);
						  }
						  arg2255_1733 =
						     MAKE_PAIR(arg2257_1735, arg2258_1736);
					       }
					       arg2243_1722 =
						  MAKE_PAIR(arg2255_1733, BNIL);
					    }
					    arg2241_1720 =
					       MAKE_PAIR(arg2242_1721, arg2243_1722);
					 }
					 arg2234_1715 =
					    MAKE_PAIR(arg2240_1719, arg2241_1720);
				      }
				      {		/* Object/access.scm 678 */
					 bool_t test_5475;
					 if (
					    STRUCTP(slot_186))
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_5480;
					      obj_t aux_5478;
					      aux_5480 =
						 CNST_TABLE_REF(((long) 51));
					      aux_5478 =
						 STRUCT_KEY(slot_186);
					      test_5475 =
						 (aux_5478 == aux_5480);
					   }
					 else
					   {	/* ./Object/class.sch 1188 */
					      test_5475 = ((bool_t) 0)
						 ;
					   }
					 if (test_5475)
					   {	/* Object/access.scm 678 */
					      arg2236_1716 =
						 STRUCT_REF(slot_186, ((long) 15));
					   }
					 else
					   {	/* Object/access.scm 678 */
					      arg2236_1716 = slot_186;
					   }
				      }
				      {		/* Object/access.scm 664 */
					 obj_t list2237_1717;
					 {	/* Object/access.scm 664 */
					    obj_t arg2239_1718;
					    arg2239_1718 =
					       MAKE_PAIR(src_def_101_189, BNIL);
					    list2237_1717 =
					       MAKE_PAIR(arg2236_1716, arg2239_1718);
					 }
					 arg2213_1691 =
					    epairify__149_object_access(arg2234_1715, list2237_1717);
				      }
				   }
				   {	/* Object/access.scm 695 */
				      obj_t list2214_1692;
				      list2214_1692 =
					 MAKE_PAIR(arg2213_1691, BNIL);
				      return list2214_1692;
				   }
				}
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* slot-virtual-set! */
obj_t 
slot_virtual_set__86_object_access(tclass_bglt class_191, obj_t type_192, obj_t slot_193, obj_t widening_194, obj_t src_195, obj_t import_196)
{
   AN_OBJECT;
   {	/* Object/access.scm 707 */
      {		/* Object/access.scm 708 */
	 obj_t class_id_86_1804;
	 {	/* Object/access.scm 708 */
	    type_bglt obj_3566;
	    obj_3566 =
	       (type_bglt) (class_191);
	    class_id_86_1804 =
	       (((type_bglt) CREF(obj_3566))->id);
	 }
	 {	/* Object/access.scm 708 */
	    obj_t slot_set__id_195_1805;
	    {	/* Object/access.scm 709 */
	       obj_t arg2404_1899;
	       obj_t arg2405_1900;
	       arg2404_1899 =
		  CNST_TABLE_REF(((long) 24));
	       arg2405_1900 =
		  STRUCT_REF(slot_193, ((long) 0));
	       {	/* Object/access.scm 709 */
		  obj_t list2407_1902;
		  {	/* Object/access.scm 709 */
		     obj_t arg2408_1903;
		     {	/* Object/access.scm 709 */
			obj_t arg2409_1904;
			{	/* Object/access.scm 709 */
			   obj_t arg2410_1905;
			   {	/* Object/access.scm 709 */
			      obj_t aux_5492;
			      aux_5492 =
				 CNST_TABLE_REF(((long) 54));
			      arg2410_1905 =
				 MAKE_PAIR(aux_5492, BNIL);
			   }
			   arg2409_1904 =
			      MAKE_PAIR(arg2405_1900, arg2410_1905);
			}
			arg2408_1903 =
			   MAKE_PAIR(arg2404_1899, arg2409_1904);
		     }
		     list2407_1902 =
			MAKE_PAIR(class_id_86_1804, arg2408_1903);
		  }
		  slot_set__id_195_1805 =
		     symbol_append_197___r4_symbols_6_4(list2407_1902);
	       }
	    }
	    {	/* Object/access.scm 709 */
	       obj_t slot_set__tid_15_1806;
	       {	/* Object/access.scm 710 */
		  obj_t list2402_1897;
		  {	/* Object/access.scm 710 */
		     obj_t arg2403_1898;
		     {	/* Object/access.scm 710 */
			obj_t aux_5499;
			aux_5499 =
			   CNST_TABLE_REF(((long) 13));
			arg2403_1898 =
			   MAKE_PAIR(aux_5499, BNIL);
		     }
		     list2402_1897 =
			MAKE_PAIR(slot_set__id_195_1805, arg2403_1898);
		  }
		  slot_set__tid_15_1806 =
		     symbol_append_197___r4_symbols_6_4(list2402_1897);
	       }
	       {	/* Object/access.scm 710 */
		  obj_t tid_1807;
		  {	/* Object/access.scm 711 */
		     obj_t list2400_1895;
		     {	/* Object/access.scm 711 */
			obj_t arg2401_1896;
			{	/* Object/access.scm 711 */
			   obj_t aux_5504;
			   {	/* Object/access.scm 711 */
			      type_bglt obj_3570;
			      obj_3570 =
				 (type_bglt) (type_192);
			      aux_5504 =
				 (((type_bglt) CREF(obj_3570))->id);
			   }
			   arg2401_1896 =
			      MAKE_PAIR(aux_5504, BNIL);
			}
			list2400_1895 =
			   MAKE_PAIR(_4dots_199_tools_misc, arg2401_1896);
		     }
		     tid_1807 =
			symbol_append_197___r4_symbols_6_4(list2400_1895);
		  }
		  {	/* Object/access.scm 712 */
		     obj_t setter_1809;
		     setter_1809 =
			STRUCT_REF(slot_193, ((long) 14));
		     {	/* Object/access.scm 713 */
			obj_t v_id_210_1810;
			v_id_210_1810 =
			   PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			   CNST_TABLE_REF(((long) 55)), BEOA);
			{	/* Object/access.scm 714 */
			   obj_t obj_1811;
			   obj_1811 =
			      PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
			      CNST_TABLE_REF(((long) 2)), BEOA);
			   {	/* Object/access.scm 715 */
			      obj_t v_tid_138_1812;
			      {		/* Object/access.scm 716 */
				 obj_t list2395_1890;
				 {	/* Object/access.scm 716 */
				    obj_t arg2396_1891;
				    {	/* Object/access.scm 716 */
				       obj_t arg2397_1892;
				       {	/* Object/access.scm 716 */
					  obj_t aux_5517;
					  {	/* Object/access.scm 718 */
					     type_bglt obj_3578;
					     {	/* Object/access.scm 718 */
						obj_t aux_5518;
						aux_5518 =
						   STRUCT_REF(slot_193, ((long) 2));
						obj_3578 =
						   (type_bglt) (aux_5518);
					     }
					     aux_5517 =
						(((type_bglt) CREF(obj_3578))->id);
					  }
					  arg2397_1892 =
					     MAKE_PAIR(aux_5517, BNIL);
				       }
				       arg2396_1891 =
					  MAKE_PAIR(_4dots_199_tools_misc, arg2397_1892);
				    }
				    list2395_1890 =
				       MAKE_PAIR(v_id_210_1810, arg2396_1891);
				 }
				 v_tid_138_1812 =
				    symbol_append_197___r4_symbols_6_4(list2395_1890);
			      }
			      {		/* Object/access.scm 716 */
				 obj_t vnum_1813;
				 vnum_1813 =
				    STRUCT_REF(slot_193, ((long) 12));
				 {	/* Object/access.scm 719 */

				    {	/* Object/access.scm 721 */
				       bool_t test2323_1814;
				       {	/* Object/access.scm 721 */
					  long n1_3582;
					  n1_3582 =
					     (long) CINT(_optim__89_engine_param);
					  test2323_1814 =
					     (n1_3582 < ((long) 2));
				       }
				       if (test2323_1814)
					 {	/* Object/access.scm 721 */
					    {	/* Object/access.scm 722 */
					       obj_t arg2324_1815;
					       {	/* Object/access.scm 722 */
						  obj_t arg2325_1816;
						  {	/* Object/access.scm 722 */
						     obj_t arg2326_1817;
						     {	/* Object/access.scm 722 */
							obj_t arg2328_1819;
							{	/* Object/access.scm 722 */
							   obj_t arg2329_1820;
							   arg2329_1820 =
							      MAKE_PAIR(v_tid_138_1812, BNIL);
							   arg2328_1819 =
							      MAKE_PAIR(tid_1807, arg2329_1820);
							}
							arg2326_1817 =
							   MAKE_PAIR(slot_set__tid_15_1806, arg2328_1819);
						     }
						     arg2325_1816 =
							MAKE_PAIR(arg2326_1817, BNIL);
						  }
						  arg2324_1815 =
						     MAKE_PAIR(import_196, arg2325_1816);
					       }
					       produce_module_clause__172_module_module(arg2324_1815);
					    }
					    {	/* Object/access.scm 723 */
					       obj_t val0_1259_1821;
					       obj_t val1_1260_1822;
					       {	/* Object/access.scm 725 */
						  obj_t arg2330_1823;
						  {	/* Object/access.scm 725 */
						     obj_t arg2332_1825;
						     obj_t arg2333_1826;
						     {	/* Object/access.scm 725 */
							obj_t arg2336_1829;
							obj_t arg2337_1830;
							arg2336_1829 =
							   CNST_TABLE_REF(((long) 16));
							{	/* Object/access.scm 725 */
							   obj_t arg2338_1831;
							   obj_t arg2339_1832;
							   {	/* Object/access.scm 725 */
							      obj_t arg2340_1833;
							      {		/* Object/access.scm 725 */
								 obj_t arg2341_1834;
								 obj_t arg2342_1835;
								 {	/* Object/access.scm 725 */
								    obj_t list2343_1836;
								    {	/* Object/access.scm 725 */
								       obj_t arg2344_1837;
								       arg2344_1837 =
									  MAKE_PAIR(tid_1807, BNIL);
								       list2343_1836 =
									  MAKE_PAIR(obj_1811, arg2344_1837);
								    }
								    arg2341_1834 =
								       symbol_append_197___r4_symbols_6_4(list2343_1836);
								 }
								 arg2342_1835 =
								    MAKE_PAIR(v_tid_138_1812, BNIL);
								 arg2340_1833 =
								    MAKE_PAIR(arg2341_1834, arg2342_1835);
							      }
							      arg2338_1831 =
								 MAKE_PAIR(slot_set__tid_15_1806, arg2340_1833);
							   }
							   {	/* Object/access.scm 727 */
							      obj_t arg2345_1838;
							      {		/* Object/access.scm 727 */
								 obj_t arg2347_1840;
								 obj_t arg2348_1841;
								 {	/* Object/access.scm 727 */
								    obj_t arg2349_1842;
								    obj_t arg2350_1843;
								    arg2349_1842 =
								       CNST_TABLE_REF(((long) 18));
								    {	/* Object/access.scm 727 */
								       obj_t arg2351_1844;
								       obj_t arg2352_1845;
								       arg2351_1844 =
									  CNST_TABLE_REF(((long) 56));
								       {	/* ./Ieee/pair-list.scm 5689 */
									  obj_t aux_5545;
									  aux_5545 =
									     CNST_TABLE_REF(((long) 45));
									  arg2352_1845 =
									     MAKE_PAIR(aux_5545, BNIL);
								       }
								       arg2350_1843 =
									  MAKE_PAIR(arg2351_1844, arg2352_1845);
								    }
								    arg2347_1840 =
								       MAKE_PAIR(arg2349_1842, arg2350_1843);
								 }
								 {	/* Object/access.scm 727 */
								    obj_t arg2353_1846;
								    {	/* Object/access.scm 727 */
								       obj_t arg2354_1847;
								       arg2354_1847 =
									  MAKE_PAIR(v_id_210_1810, BNIL);
								       arg2353_1846 =
									  MAKE_PAIR(vnum_1813, arg2354_1847);
								    }
								    arg2348_1841 =
								       MAKE_PAIR(obj_1811, arg2353_1846);
								 }
								 arg2345_1838 =
								    MAKE_PAIR(arg2347_1840, arg2348_1841);
							      }
							      arg2339_1832 =
								 MAKE_PAIR(arg2345_1838, BNIL);
							   }
							   arg2337_1830 =
							      MAKE_PAIR(arg2338_1831, arg2339_1832);
							}
							arg2332_1825 =
							   MAKE_PAIR(arg2336_1829, arg2337_1830);
						     }
						     {	/* Object/access.scm 728 */
							bool_t test_5557;
							if (
							   STRUCTP(slot_193))
							  {	/* ./Ieee/equiv.scm 5508 */
							     obj_t aux_5562;
							     obj_t aux_5560;
							     aux_5562 =
								CNST_TABLE_REF(((long) 51));
							     aux_5560 =
								STRUCT_KEY(slot_193);
							     test_5557 =
								(aux_5560 == aux_5562);
							  }
							else
							  {	/* ./Object/class.sch 1188 */
							     test_5557 = ((bool_t) 0)
								;
							  }
							if (test_5557)
							  {	/* Object/access.scm 728 */
							     arg2333_1826 =
								STRUCT_REF(slot_193, ((long) 15));
							  }
							else
							  {	/* Object/access.scm 728 */
							     arg2333_1826 = slot_193;
							  }
						     }
						     {	/* Object/access.scm 725 */
							obj_t list2334_1827;
							{	/* Object/access.scm 725 */
							   obj_t arg2335_1828;
							   arg2335_1828 =
							      MAKE_PAIR(src_195, BNIL);
							   list2334_1827 =
							      MAKE_PAIR(arg2333_1826, arg2335_1828);
							}
							arg2330_1823 =
							   epairify__149_object_access(arg2332_1825, list2334_1827);
						     }
						  }
						  {	/* Object/access.scm 724 */
						     obj_t list2331_1824;
						     list2331_1824 =
							MAKE_PAIR(arg2330_1823, BNIL);
						     val0_1259_1821 = list2331_1824;
						  }
					       }
					       {	/* Object/access.scm 732 */
						  bool_t test_5570;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_5573;
						     obj_t aux_5571;
						     aux_5573 =
							STRUCT_REF(slot_193, ((long) 16));
						     aux_5571 =
							(obj_t) (class_191);
						     test_5570 =
							(aux_5571 == aux_5573);
						  }
						  if (test_5570)
						    {	/* Object/access.scm 732 */
						       val1_1260_1822 = setter_1809;
						    }
						  else
						    {	/* Object/access.scm 732 */
						       val1_1260_1822 = BFALSE;
						    }
					       }
					       _res_number__75___r5_control_features_6_4 =
						  BINT(((long) 2));
					       _res1__155___r5_control_features_6_4 = val1_1260_1822;
					       return val0_1259_1821;
					    }
					 }
				       else
					 {	/* Object/access.scm 721 */
					    {	/* Object/access.scm 736 */
					       obj_t arg2358_1851;
					       {	/* Object/access.scm 736 */
						  obj_t arg2359_1852;
						  {	/* Object/access.scm 736 */
						     obj_t arg2360_1853;
						     {	/* Object/access.scm 736 */
							obj_t arg2362_1855;
							obj_t arg2363_1856;
							arg2362_1855 =
							   CNST_TABLE_REF(((long) 12));
							{	/* Object/access.scm 736 */
							   obj_t arg2364_1857;
							   {	/* Object/access.scm 736 */
							      obj_t arg2365_1858;
							      arg2365_1858 =
								 MAKE_PAIR(v_tid_138_1812, BNIL);
							      arg2364_1857 =
								 MAKE_PAIR(tid_1807, arg2365_1858);
							   }
							   arg2363_1856 =
							      MAKE_PAIR(slot_set__tid_15_1806, arg2364_1857);
							}
							arg2360_1853 =
							   MAKE_PAIR(arg2362_1855, arg2363_1856);
						     }
						     arg2359_1852 =
							MAKE_PAIR(arg2360_1853, BNIL);
						  }
						  arg2358_1851 =
						     MAKE_PAIR(import_196, arg2359_1852);
					       }
					       produce_module_clause__172_module_module(arg2358_1851);
					    }
					    {	/* Object/access.scm 739 */
					       obj_t val0_1261_1859;
					       obj_t val1_1262_1860;
					       {	/* Object/access.scm 741 */
						  obj_t arg2366_1861;
						  {	/* Object/access.scm 741 */
						     obj_t arg2368_1863;
						     obj_t arg2369_1864;
						     {	/* Object/access.scm 741 */
							obj_t arg2372_1867;
							obj_t arg2373_1868;
							arg2372_1867 =
							   CNST_TABLE_REF(((long) 15));
							{	/* Object/access.scm 741 */
							   obj_t arg2374_1869;
							   obj_t arg2375_1870;
							   {	/* Object/access.scm 741 */
							      obj_t arg2376_1871;
							      {		/* Object/access.scm 741 */
								 obj_t arg2377_1872;
								 obj_t arg2378_1873;
								 {	/* Object/access.scm 741 */
								    obj_t list2379_1874;
								    {	/* Object/access.scm 741 */
								       obj_t arg2380_1875;
								       arg2380_1875 =
									  MAKE_PAIR(tid_1807, BNIL);
								       list2379_1874 =
									  MAKE_PAIR(obj_1811, arg2380_1875);
								    }
								    arg2377_1872 =
								       symbol_append_197___r4_symbols_6_4(list2379_1874);
								 }
								 arg2378_1873 =
								    MAKE_PAIR(v_tid_138_1812, BNIL);
								 arg2376_1871 =
								    MAKE_PAIR(arg2377_1872, arg2378_1873);
							      }
							      arg2374_1869 =
								 MAKE_PAIR(slot_set__tid_15_1806, arg2376_1871);
							   }
							   {	/* Object/access.scm 743 */
							      obj_t arg2381_1876;
							      {		/* Object/access.scm 743 */
								 obj_t arg2383_1878;
								 obj_t arg2384_1879;
								 {	/* Object/access.scm 743 */
								    obj_t arg2385_1880;
								    obj_t arg2386_1881;
								    arg2385_1880 =
								       CNST_TABLE_REF(((long) 18));
								    {	/* Object/access.scm 743 */
								       obj_t arg2387_1882;
								       obj_t arg2388_1883;
								       arg2387_1882 =
									  CNST_TABLE_REF(((long) 56));
								       {	/* ./Ieee/pair-list.scm 5689 */
									  obj_t aux_5594;
									  aux_5594 =
									     CNST_TABLE_REF(((long) 45));
									  arg2388_1883 =
									     MAKE_PAIR(aux_5594, BNIL);
								       }
								       arg2386_1881 =
									  MAKE_PAIR(arg2387_1882, arg2388_1883);
								    }
								    arg2383_1878 =
								       MAKE_PAIR(arg2385_1880, arg2386_1881);
								 }
								 {	/* Object/access.scm 743 */
								    obj_t arg2389_1884;
								    {	/* Object/access.scm 743 */
								       obj_t arg2390_1885;
								       arg2390_1885 =
									  MAKE_PAIR(v_id_210_1810, BNIL);
								       arg2389_1884 =
									  MAKE_PAIR(vnum_1813, arg2390_1885);
								    }
								    arg2384_1879 =
								       MAKE_PAIR(obj_1811, arg2389_1884);
								 }
								 arg2381_1876 =
								    MAKE_PAIR(arg2383_1878, arg2384_1879);
							      }
							      arg2375_1870 =
								 MAKE_PAIR(arg2381_1876, BNIL);
							   }
							   arg2373_1868 =
							      MAKE_PAIR(arg2374_1869, arg2375_1870);
							}
							arg2368_1863 =
							   MAKE_PAIR(arg2372_1867, arg2373_1868);
						     }
						     {	/* Object/access.scm 744 */
							bool_t test_5606;
							if (
							   STRUCTP(slot_193))
							  {	/* ./Ieee/equiv.scm 5508 */
							     obj_t aux_5611;
							     obj_t aux_5609;
							     aux_5611 =
								CNST_TABLE_REF(((long) 51));
							     aux_5609 =
								STRUCT_KEY(slot_193);
							     test_5606 =
								(aux_5609 == aux_5611);
							  }
							else
							  {	/* ./Object/class.sch 1188 */
							     test_5606 = ((bool_t) 0)
								;
							  }
							if (test_5606)
							  {	/* Object/access.scm 744 */
							     arg2369_1864 =
								STRUCT_REF(slot_193, ((long) 15));
							  }
							else
							  {	/* Object/access.scm 744 */
							     arg2369_1864 = slot_193;
							  }
						     }
						     {	/* Object/access.scm 741 */
							obj_t list2370_1865;
							{	/* Object/access.scm 741 */
							   obj_t arg2371_1866;
							   arg2371_1866 =
							      MAKE_PAIR(src_195, BNIL);
							   list2370_1865 =
							      MAKE_PAIR(arg2369_1864, arg2371_1866);
							}
							arg2366_1861 =
							   epairify__149_object_access(arg2368_1863, list2370_1865);
						     }
						  }
						  {	/* Object/access.scm 740 */
						     obj_t list2367_1862;
						     list2367_1862 =
							MAKE_PAIR(arg2366_1861, BNIL);
						     val0_1261_1859 = list2367_1862;
						  }
					       }
					       {	/* Object/access.scm 748 */
						  bool_t test_5619;
						  {	/* ./Ieee/equiv.scm 5508 */
						     obj_t aux_5622;
						     obj_t aux_5620;
						     aux_5622 =
							STRUCT_REF(slot_193, ((long) 16));
						     aux_5620 =
							(obj_t) (class_191);
						     test_5619 =
							(aux_5620 == aux_5622);
						  }
						  if (test_5619)
						    {	/* Object/access.scm 748 */
						       val1_1262_1860 = setter_1809;
						    }
						  else
						    {	/* Object/access.scm 748 */
						       val1_1262_1860 = BFALSE;
						    }
					       }
					       _res_number__75___r5_control_features_6_4 =
						  BINT(((long) 2));
					       _res1__155___r5_control_features_6_4 = val1_1262_1860;
					       return val0_1261_1859;
					    }
					 }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* slot-direct-set! */
obj_t 
slot_direct_set__173_object_access(obj_t class_id_86_197, obj_t type_198, obj_t slot_199, obj_t widening_200, obj_t src_def_101_201, obj_t import_202)
{
   AN_OBJECT;
   {	/* Object/access.scm 755 */
      {		/* Object/access.scm 756 */
	 obj_t slot_set__id_195_1906;
	 {	/* Object/access.scm 756 */
	    obj_t arg2474_1975;
	    obj_t arg2475_1976;
	    arg2474_1975 =
	       CNST_TABLE_REF(((long) 24));
	    arg2475_1976 =
	       STRUCT_REF(slot_199, ((long) 0));
	    {	/* Object/access.scm 756 */
	       obj_t list2477_1978;
	       {	/* Object/access.scm 756 */
		  obj_t arg2478_1979;
		  {	/* Object/access.scm 756 */
		     obj_t arg2479_1980;
		     {	/* Object/access.scm 756 */
			obj_t arg2480_1981;
			{	/* Object/access.scm 756 */
			   obj_t aux_5628;
			   aux_5628 =
			      CNST_TABLE_REF(((long) 54));
			   arg2480_1981 =
			      MAKE_PAIR(aux_5628, BNIL);
			}
			arg2479_1980 =
			   MAKE_PAIR(arg2475_1976, arg2480_1981);
		     }
		     arg2478_1979 =
			MAKE_PAIR(arg2474_1975, arg2479_1980);
		  }
		  list2477_1978 =
		     MAKE_PAIR(class_id_86_197, arg2478_1979);
	       }
	       slot_set__id_195_1906 =
		  symbol_append_197___r4_symbols_6_4(list2477_1978);
	    }
	 }
	 {	/* Object/access.scm 756 */
	    obj_t slot_set__tid_15_1907;
	    {	/* Object/access.scm 757 */
	       obj_t list2472_1973;
	       {	/* Object/access.scm 757 */
		  obj_t arg2473_1974;
		  {	/* Object/access.scm 757 */
		     obj_t aux_5635;
		     aux_5635 =
			CNST_TABLE_REF(((long) 13));
		     arg2473_1974 =
			MAKE_PAIR(aux_5635, BNIL);
		  }
		  list2472_1973 =
		     MAKE_PAIR(slot_set__id_195_1906, arg2473_1974);
	       }
	       slot_set__tid_15_1907 =
		  symbol_append_197___r4_symbols_6_4(list2472_1973);
	    }
	    {	/* Object/access.scm 757 */
	       obj_t tid_1908;
	       {	/* Object/access.scm 758 */
		  obj_t list2470_1971;
		  {	/* Object/access.scm 758 */
		     obj_t arg2471_1972;
		     {	/* Object/access.scm 758 */
			obj_t aux_5640;
			{	/* Object/access.scm 758 */
			   type_bglt obj_3695;
			   obj_3695 =
			      (type_bglt) (type_198);
			   aux_5640 =
			      (((type_bglt) CREF(obj_3695))->id);
			}
			arg2471_1972 =
			   MAKE_PAIR(aux_5640, BNIL);
		     }
		     list2470_1971 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2471_1972);
		  }
		  tid_1908 =
		     symbol_append_197___r4_symbols_6_4(list2470_1971);
	       }
	       {	/* Object/access.scm 759 */
		  obj_t v_id_210_1910;
		  v_id_210_1910 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 55)), BEOA);
		  {	/* Object/access.scm 760 */
		     obj_t v_tid_138_1911;
		     {	/* Object/access.scm 761 */
			obj_t list2465_1966;
			{	/* Object/access.scm 761 */
			   obj_t arg2466_1967;
			   {	/* Object/access.scm 761 */
			      obj_t arg2467_1968;
			      {		/* Object/access.scm 761 */
				 obj_t aux_5649;
				 {	/* Object/access.scm 763 */
				    type_bglt obj_3700;
				    {	/* Object/access.scm 763 */
				       obj_t aux_5650;
				       aux_5650 =
					  STRUCT_REF(slot_199, ((long) 2));
				       obj_3700 =
					  (type_bglt) (aux_5650);
				    }
				    aux_5649 =
				       (((type_bglt) CREF(obj_3700))->id);
				 }
				 arg2467_1968 =
				    MAKE_PAIR(aux_5649, BNIL);
			      }
			      arg2466_1967 =
				 MAKE_PAIR(_4dots_199_tools_misc, arg2467_1968);
			   }
			   list2465_1966 =
			      MAKE_PAIR(v_id_210_1910, arg2466_1967);
			}
			v_tid_138_1911 =
			   symbol_append_197___r4_symbols_6_4(list2465_1966);
		     }
		     {	/* Object/access.scm 761 */

			{	/* Object/access.scm 765 */
			   bool_t test2411_1912;
			   {	/* Object/access.scm 765 */
			      long n1_3701;
			      n1_3701 =
				 (long) CINT(_optim__89_engine_param);
			      test2411_1912 =
				 (n1_3701 < ((long) 2));
			   }
			   if (test2411_1912)
			     {	/* Object/access.scm 765 */
				{	/* Object/access.scm 766 */
				   obj_t arg2412_1913;
				   {	/* Object/access.scm 766 */
				      obj_t arg2413_1914;
				      {		/* Object/access.scm 766 */
					 obj_t arg2414_1915;
					 {	/* Object/access.scm 766 */
					    obj_t arg2416_1917;
					    {	/* Object/access.scm 766 */
					       obj_t arg2417_1918;
					       arg2417_1918 =
						  MAKE_PAIR(v_tid_138_1911, BNIL);
					       arg2416_1917 =
						  MAKE_PAIR(tid_1908, arg2417_1918);
					    }
					    arg2414_1915 =
					       MAKE_PAIR(slot_set__tid_15_1907, arg2416_1917);
					 }
					 arg2413_1914 =
					    MAKE_PAIR(arg2414_1915, BNIL);
				      }
				      arg2412_1913 =
					 MAKE_PAIR(import_202, arg2413_1914);
				   }
				   produce_module_clause__172_module_module(arg2412_1913);
				}
				{	/* Object/access.scm 768 */
				   obj_t arg2418_1919;
				   {	/* Object/access.scm 768 */
				      obj_t arg2420_1921;
				      obj_t arg2421_1922;
				      {		/* Object/access.scm 768 */
					 obj_t arg2424_1925;
					 obj_t arg2425_1926;
					 arg2424_1925 =
					    CNST_TABLE_REF(((long) 16));
					 {	/* Object/access.scm 768 */
					    obj_t arg2426_1927;
					    obj_t arg2427_1928;
					    {	/* Object/access.scm 768 */
					       obj_t arg2428_1929;
					       {	/* Object/access.scm 768 */
						  obj_t arg2429_1930;
						  obj_t arg2430_1931;
						  {	/* Object/access.scm 768 */
						     obj_t list2431_1932;
						     {	/* Object/access.scm 768 */
							obj_t arg2432_1933;
							obj_t arg2433_1934;
							arg2432_1933 =
							   CNST_TABLE_REF(((long) 2));
							arg2433_1934 =
							   MAKE_PAIR(tid_1908, BNIL);
							list2431_1932 =
							   MAKE_PAIR(arg2432_1933, arg2433_1934);
						     }
						     arg2429_1930 =
							symbol_append_197___r4_symbols_6_4(list2431_1932);
						  }
						  arg2430_1931 =
						     MAKE_PAIR(v_tid_138_1911, BNIL);
						  arg2428_1929 =
						     MAKE_PAIR(arg2429_1930, arg2430_1931);
					       }
					       arg2426_1927 =
						  MAKE_PAIR(slot_set__tid_15_1907, arg2428_1929);
					    }
					    {	/* Object/access.scm 770 */
					       obj_t arg2434_1935;
					       arg2434_1935 =
						  make_pragma_direct_set__widening_17_object_tools(
						  (type_bglt) (type_198), slot_199,
						  CNST_TABLE_REF(((long) 2)), v_id_210_1910, widening_200);
					       arg2427_1928 =
						  MAKE_PAIR(arg2434_1935, BNIL);
					    }
					    arg2425_1926 =
					       MAKE_PAIR(arg2426_1927, arg2427_1928);
					 }
					 arg2420_1921 =
					    MAKE_PAIR(arg2424_1925, arg2425_1926);
				      }
				      {		/* Object/access.scm 775 */
					 bool_t test_5681;
					 if (
					    STRUCTP(slot_199))
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_5686;
					      obj_t aux_5684;
					      aux_5686 =
						 CNST_TABLE_REF(((long) 51));
					      aux_5684 =
						 STRUCT_KEY(slot_199);
					      test_5681 =
						 (aux_5684 == aux_5686);
					   }
					 else
					   {	/* ./Object/class.sch 1188 */
					      test_5681 = ((bool_t) 0)
						 ;
					   }
					 if (test_5681)
					   {	/* Object/access.scm 775 */
					      arg2421_1922 =
						 STRUCT_REF(slot_199, ((long) 15));
					   }
					 else
					   {	/* Object/access.scm 775 */
					      arg2421_1922 = slot_199;
					   }
				      }
				      {		/* Object/access.scm 768 */
					 obj_t list2422_1923;
					 {	/* Object/access.scm 768 */
					    obj_t arg2423_1924;
					    arg2423_1924 =
					       MAKE_PAIR(src_def_101_201, BNIL);
					    list2422_1923 =
					       MAKE_PAIR(arg2421_1922, arg2423_1924);
					 }
					 arg2418_1919 =
					    epairify__149_object_access(arg2420_1921, list2422_1923);
				      }
				   }
				   {	/* Object/access.scm 767 */
				      obj_t list2419_1920;
				      list2419_1920 =
					 MAKE_PAIR(arg2418_1919, BNIL);
				      return list2419_1920;
				   }
				}
			     }
			   else
			     {	/* Object/access.scm 765 */
				{	/* Object/access.scm 780 */
				   obj_t arg2437_1938;
				   {	/* Object/access.scm 780 */
				      obj_t arg2438_1939;
				      {		/* Object/access.scm 780 */
					 obj_t arg2439_1940;
					 {	/* Object/access.scm 780 */
					    obj_t arg2441_1942;
					    obj_t arg2442_1943;
					    arg2441_1942 =
					       CNST_TABLE_REF(((long) 12));
					    {	/* Object/access.scm 780 */
					       obj_t arg2443_1944;
					       {	/* Object/access.scm 780 */
						  obj_t arg2444_1945;
						  arg2444_1945 =
						     MAKE_PAIR(v_tid_138_1911, BNIL);
						  arg2443_1944 =
						     MAKE_PAIR(tid_1908, arg2444_1945);
					       }
					       arg2442_1943 =
						  MAKE_PAIR(slot_set__tid_15_1907, arg2443_1944);
					    }
					    arg2439_1940 =
					       MAKE_PAIR(arg2441_1942, arg2442_1943);
					 }
					 arg2438_1939 =
					    MAKE_PAIR(arg2439_1940, BNIL);
				      }
				      arg2437_1938 =
					 MAKE_PAIR(import_202, arg2438_1939);
				   }
				   produce_module_clause__172_module_module(arg2437_1938);
				}
				{	/* Object/access.scm 784 */
				   obj_t arg2445_1946;
				   {	/* Object/access.scm 784 */
				      obj_t arg2447_1948;
				      obj_t arg2448_1949;
				      {		/* Object/access.scm 784 */
					 obj_t arg2451_1952;
					 obj_t arg2452_1953;
					 arg2451_1952 =
					    CNST_TABLE_REF(((long) 15));
					 {	/* Object/access.scm 785 */
					    obj_t arg2453_1954;
					    obj_t arg2454_1955;
					    {	/* Object/access.scm 785 */
					       obj_t arg2455_1956;
					       {	/* Object/access.scm 785 */
						  obj_t arg2456_1957;
						  obj_t arg2457_1958;
						  {	/* Object/access.scm 785 */
						     obj_t list2458_1959;
						     {	/* Object/access.scm 785 */
							obj_t arg2459_1960;
							obj_t arg2460_1961;
							arg2459_1960 =
							   CNST_TABLE_REF(((long) 2));
							arg2460_1961 =
							   MAKE_PAIR(tid_1908, BNIL);
							list2458_1959 =
							   MAKE_PAIR(arg2459_1960, arg2460_1961);
						     }
						     arg2456_1957 =
							symbol_append_197___r4_symbols_6_4(list2458_1959);
						  }
						  arg2457_1958 =
						     MAKE_PAIR(v_tid_138_1911, BNIL);
						  arg2455_1956 =
						     MAKE_PAIR(arg2456_1957, arg2457_1958);
					       }
					       arg2453_1954 =
						  MAKE_PAIR(slot_set__tid_15_1907, arg2455_1956);
					    }
					    {	/* Object/access.scm 786 */
					       obj_t arg2461_1962;
					       arg2461_1962 =
						  make_pragma_direct_set__widening_17_object_tools(
						  (type_bglt) (type_198), slot_199,
						  CNST_TABLE_REF(((long) 2)), v_id_210_1910, widening_200);
					       arg2454_1955 =
						  MAKE_PAIR(arg2461_1962, BNIL);
					    }
					    arg2452_1953 =
					       MAKE_PAIR(arg2453_1954, arg2454_1955);
					 }
					 arg2447_1948 =
					    MAKE_PAIR(arg2451_1952, arg2452_1953);
				      }
				      {		/* Object/access.scm 791 */
					 bool_t test_5716;
					 if (
					    STRUCTP(slot_199))
					   {	/* ./Ieee/equiv.scm 5508 */
					      obj_t aux_5721;
					      obj_t aux_5719;
					      aux_5721 =
						 CNST_TABLE_REF(((long) 51));
					      aux_5719 =
						 STRUCT_KEY(slot_199);
					      test_5716 =
						 (aux_5719 == aux_5721);
					   }
					 else
					   {	/* ./Object/class.sch 1188 */
					      test_5716 = ((bool_t) 0)
						 ;
					   }
					 if (test_5716)
					   {	/* Object/access.scm 791 */
					      arg2448_1949 =
						 STRUCT_REF(slot_199, ((long) 15));
					   }
					 else
					   {	/* Object/access.scm 791 */
					      arg2448_1949 = slot_199;
					   }
				      }
				      {		/* Object/access.scm 784 */
					 obj_t list2449_1950;
					 {	/* Object/access.scm 784 */
					    obj_t arg2450_1951;
					    arg2450_1951 =
					       MAKE_PAIR(src_def_101_201, BNIL);
					    list2449_1950 =
					       MAKE_PAIR(arg2448_1949, arg2450_1951);
					 }
					 arg2445_1946 =
					    epairify__149_object_access(arg2447_1948, list2449_1950);
				      }
				   }
				   {	/* Object/access.scm 783 */
				      obj_t list2446_1947;
				      list2446_1947 =
					 MAKE_PAIR(arg2445_1946, BNIL);
				      return list2446_1947;
				   }
				}
			     }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* import-class-slots-access! */
obj_t 
import_class_slots_access__39_object_access(obj_t class_id_86_203, obj_t type_204, obj_t slots_205, obj_t src_def_101_206, obj_t module_207)
{
   AN_OBJECT;
   {	/* Object/access.scm 799 */
      {
	 obj_t l1263_1982;
	 {	/* Object/access.scm 800 */
	    bool_t aux_5729;
	    l1263_1982 = slots_205;
	  lname1264_1983:
	    if (
	       PAIRP(l1263_1982))
	      {		/* Object/access.scm 800 */
		 {	/* Object/access.scm 800 */
		    obj_t slot_1985;
		    slot_1985 =
		       CAR(l1263_1982);
		    import_slot_ref__77_object_access(class_id_86_203, type_204, slot_1985, src_def_101_206, module_207);
		    {	/* Object/access.scm 802 */
		       bool_t test_5734;
		       {	/* ./Llib/struct.scm 1457 */
			  obj_t aux_5735;
			  aux_5735 =
			     STRUCT_REF(slot_1985, ((long) 7));
			  test_5734 =
			     CBOOL(aux_5735);
		       }
		       if (test_5734)
			 {	/* Object/access.scm 802 */
			    BUNSPEC;
			 }
		       else
			 {	/* Object/access.scm 802 */
			    import_slot_set__215_object_access(class_id_86_203, type_204, slot_1985, src_def_101_206, module_207);
			 }
		    }
		 }
		 {
		    obj_t l1263_5739;
		    l1263_5739 =
		       CDR(l1263_1982);
		    l1263_1982 = l1263_5739;
		    goto lname1264_1983;
		 }
	      }
	    else
	      {		/* Object/access.scm 800 */
		 aux_5729 = ((bool_t) 1);
	      }
	    return
	       BBOOL(aux_5729);
	 }
      }
   }
}



/* _import-class-slots-access!2640 */
obj_t 
_import_class_slots_access_2640_107_object_access(obj_t env_4012, obj_t class_id_86_4013, obj_t type_4014, obj_t slots_4015, obj_t src_def_101_4016, obj_t module_4017)
{
   AN_OBJECT;
   {	/* Object/access.scm 799 */
      return
	 import_class_slots_access__39_object_access(class_id_86_4013, type_4014, slots_4015, src_def_101_4016, module_4017);
   }
}



/* import-slot-ref! */
obj_t 
import_slot_ref__77_object_access(obj_t class_id_86_208, obj_t type_209, obj_t slot_210, obj_t src_def_101_211, obj_t module_212)
{
   AN_OBJECT;
   {	/* Object/access.scm 809 */
      {		/* Object/access.scm 811 */
	 bool_t test_5743;
	 {	/* ./Llib/struct.scm 1457 */
	    obj_t aux_5744;
	    aux_5744 =
	       STRUCT_REF(slot_210, ((long) 5));
	    test_5743 =
	       CBOOL(aux_5744);
	 }
	 if (test_5743)
	   {	/* Object/access.scm 811 */
	      return
		 import_slot_dyna_indexed_ref__108_object_access(class_id_86_208, type_209, slot_210, src_def_101_211, module_212);
	   }
	 else
	   {	/* Object/access.scm 813 */
	      bool_t test_5748;
	      {		/* ./Llib/struct.scm 1457 */
		 obj_t aux_5749;
		 aux_5749 =
		    STRUCT_REF(slot_210, ((long) 3));
		 test_5748 =
		    CBOOL(aux_5749);
	      }
	      if (test_5748)
		{	/* Object/access.scm 813 */
		   {	/* Object/access.scm 837 */
		      obj_t arg2496_3790;
		      {		/* Object/access.scm 837 */
			 obj_t arg2497_3791;
			 obj_t arg2498_3792;
			 arg2497_3791 =
			    CNST_TABLE_REF(((long) 43));
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_5753;
			    aux_5753 =
			       STRUCT_REF(slot_210, ((long) 4));
			    arg2498_3792 =
			       MAKE_PAIR(aux_5753, BNIL);
			 }
			 arg2496_3790 =
			    MAKE_PAIR(arg2497_3791, arg2498_3792);
		      }
		      return
			 import_slot_indexed_ref__208_object_access(class_id_86_208, type_209, slot_210, arg2496_3790, src_def_101_211, module_212);
		   }
		}
	      else
		{	/* Object/access.scm 813 */
		   return
		      import_slot_direct_ref__71_object_access(class_id_86_208, type_209, slot_210, src_def_101_211, module_212);
		}
	   }
      }
   }
}



/* import-slot-dyna-indexed-ref! */
obj_t 
import_slot_dyna_indexed_ref__108_object_access(obj_t class_id_86_213, obj_t type_214, obj_t slot_215, obj_t src_def_101_216, obj_t module_217)
{
   AN_OBJECT;
   {	/* Object/access.scm 821 */
      {		/* Object/access.scm 825 */
	 obj_t arg2486_1990;
	 {	/* Object/access.scm 825 */
	    obj_t arg2487_1991;
	    obj_t arg2488_1992;
	    {	/* Object/access.scm 825 */
	       obj_t arg2489_1993;
	       obj_t arg2490_1994;
	       arg2489_1993 =
		  CNST_TABLE_REF(((long) 24));
	       arg2490_1994 =
		  STRUCT_REF(slot_215, ((long) 0));
	       {	/* Object/access.scm 825 */
		  obj_t list2492_1996;
		  {	/* Object/access.scm 825 */
		     obj_t arg2493_1997;
		     {	/* Object/access.scm 825 */
			obj_t arg2494_1998;
			{	/* Object/access.scm 825 */
			   obj_t arg2495_1999;
			   {	/* Object/access.scm 825 */
			      obj_t aux_5761;
			      aux_5761 =
				 CNST_TABLE_REF(((long) 36));
			      arg2495_1999 =
				 MAKE_PAIR(aux_5761, BNIL);
			   }
			   arg2494_1998 =
			      MAKE_PAIR(arg2490_1994, arg2495_1999);
			}
			arg2493_1997 =
			   MAKE_PAIR(arg2489_1993, arg2494_1998);
		     }
		     list2492_1996 =
			MAKE_PAIR(class_id_86_213, arg2493_1997);
		  }
		  arg2487_1991 =
		     symbol_append_197___r4_symbols_6_4(list2492_1996);
	       }
	    }
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_5768;
	       aux_5768 =
		  CNST_TABLE_REF(((long) 2));
	       arg2488_1992 =
		  MAKE_PAIR(aux_5768, BNIL);
	    }
	    arg2486_1990 =
	       MAKE_PAIR(arg2487_1991, arg2488_1992);
	 }
	 return
	    import_slot_indexed_ref__208_object_access(class_id_86_213, type_214, slot_215, arg2486_1990, src_def_101_216, module_217);
      }
   }
}



/* import-slot-indexed-ref! */
obj_t 
import_slot_indexed_ref__208_object_access(obj_t class_id_86_223, obj_t type_224, obj_t slot_225, obj_t max_bound_128_226, obj_t src_def_101_227, obj_t module_228)
{
   AN_OBJECT;
   {	/* Object/access.scm 844 */
      {		/* Object/access.scm 845 */
	 obj_t slot_ref_id_128_2005;
	 {	/* Object/access.scm 845 */
	    obj_t arg2512_2020;
	    obj_t arg2513_2021;
	    arg2512_2020 =
	       CNST_TABLE_REF(((long) 24));
	    arg2513_2021 =
	       STRUCT_REF(slot_225, ((long) 0));
	    {	/* Object/access.scm 845 */
	       obj_t list2515_2023;
	       {	/* Object/access.scm 845 */
		  obj_t arg2516_2024;
		  {	/* Object/access.scm 845 */
		     obj_t arg2517_2025;
		     {	/* Object/access.scm 845 */
			obj_t arg2518_2026;
			{	/* Object/access.scm 845 */
			   obj_t aux_5775;
			   aux_5775 =
			      CNST_TABLE_REF(((long) 52));
			   arg2518_2026 =
			      MAKE_PAIR(aux_5775, BNIL);
			}
			arg2517_2025 =
			   MAKE_PAIR(arg2513_2021, arg2518_2026);
		     }
		     arg2516_2024 =
			MAKE_PAIR(arg2512_2020, arg2517_2025);
		  }
		  list2515_2023 =
		     MAKE_PAIR(class_id_86_223, arg2516_2024);
	       }
	       slot_ref_id_128_2005 =
		  symbol_append_197___r4_symbols_6_4(list2515_2023);
	    }
	 }
	 {	/* Object/access.scm 845 */
	    obj_t slot_ref_tid_43_2006;
	    {	/* Object/access.scm 846 */
	       obj_t list2508_2016;
	       {	/* Object/access.scm 846 */
		  obj_t arg2509_2017;
		  {	/* Object/access.scm 846 */
		     obj_t arg2510_2018;
		     {	/* Object/access.scm 846 */
			obj_t aux_5782;
			{	/* Object/access.scm 848 */
			   type_bglt obj_3827;
			   {	/* Object/access.scm 848 */
			      obj_t aux_5783;
			      aux_5783 =
				 STRUCT_REF(slot_225, ((long) 2));
			      obj_3827 =
				 (type_bglt) (aux_5783);
			   }
			   aux_5782 =
			      (((type_bglt) CREF(obj_3827))->id);
			}
			arg2510_2018 =
			   MAKE_PAIR(aux_5782, BNIL);
		     }
		     arg2509_2017 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2510_2018);
		  }
		  list2508_2016 =
		     MAKE_PAIR(slot_ref_id_128_2005, arg2509_2017);
	       }
	       slot_ref_tid_43_2006 =
		  symbol_append_197___r4_symbols_6_4(list2508_2016);
	    }
	    {	/* Object/access.scm 846 */
	       obj_t tid_2007;
	       {	/* Object/access.scm 849 */
		  obj_t list2505_2013;
		  {	/* Object/access.scm 849 */
		     obj_t arg2506_2014;
		     {	/* Object/access.scm 849 */
			obj_t aux_5791;
			{	/* Object/access.scm 849 */
			   type_bglt obj_3828;
			   obj_3828 =
			      (type_bglt) (type_224);
			   aux_5791 =
			      (((type_bglt) CREF(obj_3828))->id);
			}
			arg2506_2014 =
			   MAKE_PAIR(aux_5791, BNIL);
		     }
		     list2505_2013 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2506_2014);
		  }
		  tid_2007 =
		     symbol_append_197___r4_symbols_6_4(list2505_2013);
	       }
	       {	/* Object/access.scm 850 */

		  {	/* Object/access.scm 851 */
		     obj_t arg2501_2009;
		     {	/* Object/access.scm 851 */
			obj_t arg2502_2010;
			{	/* Object/access.scm 851 */
			   obj_t arg2503_2011;
			   {	/* ./Ieee/pair-list.scm 5689 */
			      obj_t aux_5797;
			      aux_5797 =
				 CNST_TABLE_REF(((long) 27));
			      arg2503_2011 =
				 MAKE_PAIR(aux_5797, BNIL);
			   }
			   arg2502_2010 =
			      MAKE_PAIR(tid_2007, arg2503_2011);
			}
			arg2501_2009 =
			   MAKE_PAIR(slot_ref_tid_43_2006, arg2502_2010);
		     }
		     return
			import_parser_53_module_impuse(module_228, arg2501_2009);
		  }
	       }
	    }
	 }
      }
   }
}



/* import-slot-direct-ref! */
obj_t 
import_slot_direct_ref__71_object_access(obj_t class_id_86_229, obj_t type_230, obj_t slot_231, obj_t src_def_101_232, obj_t module_233)
{
   AN_OBJECT;
   {	/* Object/access.scm 856 */
      {		/* Object/access.scm 857 */
	 obj_t slot_ref_id_128_2027;
	 {	/* Object/access.scm 857 */
	    obj_t arg2530_2040;
	    arg2530_2040 =
	       CNST_TABLE_REF(((long) 24));
	    {	/* Object/access.scm 857 */
	       obj_t list2532_2042;
	       {	/* Object/access.scm 857 */
		  obj_t arg2533_2043;
		  {	/* Object/access.scm 857 */
		     obj_t arg2534_2044;
		     {	/* Object/access.scm 857 */
			obj_t aux_5804;
			aux_5804 =
			   STRUCT_REF(slot_231, ((long) 0));
			arg2534_2044 =
			   MAKE_PAIR(aux_5804, BNIL);
		     }
		     arg2533_2043 =
			MAKE_PAIR(arg2530_2040, arg2534_2044);
		  }
		  list2532_2042 =
		     MAKE_PAIR(class_id_86_229, arg2533_2043);
	       }
	       slot_ref_id_128_2027 =
		  symbol_append_197___r4_symbols_6_4(list2532_2042);
	    }
	 }
	 {	/* Object/access.scm 857 */
	    obj_t slot_ref_tid_43_2028;
	    {	/* Object/access.scm 858 */
	       obj_t list2525_2036;
	       {	/* Object/access.scm 858 */
		  obj_t arg2527_2037;
		  {	/* Object/access.scm 858 */
		     obj_t arg2528_2038;
		     {	/* Object/access.scm 858 */
			obj_t aux_5810;
			{	/* Object/access.scm 860 */
			   type_bglt obj_3842;
			   {	/* Object/access.scm 860 */
			      obj_t aux_5811;
			      aux_5811 =
				 STRUCT_REF(slot_231, ((long) 2));
			      obj_3842 =
				 (type_bglt) (aux_5811);
			   }
			   aux_5810 =
			      (((type_bglt) CREF(obj_3842))->id);
			}
			arg2528_2038 =
			   MAKE_PAIR(aux_5810, BNIL);
		     }
		     arg2527_2037 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2528_2038);
		  }
		  list2525_2036 =
		     MAKE_PAIR(slot_ref_id_128_2027, arg2527_2037);
	       }
	       slot_ref_tid_43_2028 =
		  symbol_append_197___r4_symbols_6_4(list2525_2036);
	    }
	    {	/* Object/access.scm 858 */
	       obj_t tid_2029;
	       {	/* Object/access.scm 861 */
		  obj_t list2522_2033;
		  {	/* Object/access.scm 861 */
		     obj_t arg2523_2034;
		     {	/* Object/access.scm 861 */
			obj_t aux_5819;
			{	/* Object/access.scm 861 */
			   type_bglt obj_3843;
			   obj_3843 =
			      (type_bglt) (type_230);
			   aux_5819 =
			      (((type_bglt) CREF(obj_3843))->id);
			}
			arg2523_2034 =
			   MAKE_PAIR(aux_5819, BNIL);
		     }
		     list2522_2033 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2523_2034);
		  }
		  tid_2029 =
		     symbol_append_197___r4_symbols_6_4(list2522_2033);
	       }
	       {	/* Object/access.scm 861 */

		  {	/* Object/access.scm 862 */
		     obj_t arg2519_2030;
		     {	/* Object/access.scm 862 */
			obj_t arg2520_2031;
			arg2520_2031 =
			   MAKE_PAIR(tid_2029, BNIL);
			arg2519_2030 =
			   MAKE_PAIR(slot_ref_tid_43_2028, arg2520_2031);
		     }
		     return
			import_parser_53_module_impuse(module_233, arg2519_2030);
		  }
	       }
	    }
	 }
      }
   }
}



/* import-slot-set! */
obj_t 
import_slot_set__215_object_access(obj_t class_id_86_234, obj_t type_235, obj_t slot_236, obj_t src_def_101_237, obj_t module_238)
{
   AN_OBJECT;
   {	/* Object/access.scm 867 */
      {		/* Object/access.scm 869 */
	 bool_t test_5828;
	 {	/* ./Llib/struct.scm 1457 */
	    obj_t aux_5829;
	    aux_5829 =
	       STRUCT_REF(slot_236, ((long) 5));
	    test_5828 =
	       CBOOL(aux_5829);
	 }
	 if (test_5828)
	   {	/* Object/access.scm 869 */
	      return
		 import_slot_dyna_indexed_set__203_object_access(class_id_86_234, type_235, slot_236, src_def_101_237, module_238);
	   }
	 else
	   {	/* Object/access.scm 871 */
	      bool_t test_5833;
	      {		/* ./Llib/struct.scm 1457 */
		 obj_t aux_5834;
		 aux_5834 =
		    STRUCT_REF(slot_236, ((long) 3));
		 test_5833 =
		    CBOOL(aux_5834);
	      }
	      if (test_5833)
		{	/* Object/access.scm 871 */
		   {	/* Object/access.scm 895 */
		      obj_t arg2547_3859;
		      {		/* Object/access.scm 895 */
			 obj_t arg2548_3860;
			 obj_t arg2549_3861;
			 arg2548_3860 =
			    CNST_TABLE_REF(((long) 43));
			 {	/* ./Ieee/pair-list.scm 5689 */
			    obj_t aux_5838;
			    aux_5838 =
			       STRUCT_REF(slot_236, ((long) 4));
			    arg2549_3861 =
			       MAKE_PAIR(aux_5838, BNIL);
			 }
			 arg2547_3859 =
			    MAKE_PAIR(arg2548_3860, arg2549_3861);
		      }
		      return
			 import_slot_indexed_set__155_object_access(class_id_86_234, type_235, slot_236, arg2547_3859, src_def_101_237, module_238);
		   }
		}
	      else
		{	/* Object/access.scm 871 */
		   return
		      import_slot_direct_set__76_object_access(class_id_86_234, type_235, slot_236, src_def_101_237, module_238);
		}
	   }
      }
   }
}



/* import-slot-dyna-indexed-set! */
obj_t 
import_slot_dyna_indexed_set__203_object_access(obj_t class_id_86_239, obj_t type_240, obj_t slot_241, obj_t src_def_101_242, obj_t module_243)
{
   AN_OBJECT;
   {	/* Object/access.scm 879 */
      {		/* Object/access.scm 883 */
	 obj_t arg2537_2047;
	 {	/* Object/access.scm 883 */
	    obj_t arg2538_2048;
	    obj_t arg2539_2049;
	    {	/* Object/access.scm 883 */
	       obj_t arg2540_2050;
	       obj_t arg2541_2051;
	       arg2540_2050 =
		  CNST_TABLE_REF(((long) 24));
	       arg2541_2051 =
		  STRUCT_REF(slot_241, ((long) 0));
	       {	/* Object/access.scm 883 */
		  obj_t list2543_2053;
		  {	/* Object/access.scm 883 */
		     obj_t arg2544_2054;
		     {	/* Object/access.scm 883 */
			obj_t arg2545_2055;
			{	/* Object/access.scm 883 */
			   obj_t arg2546_2056;
			   {	/* Object/access.scm 883 */
			      obj_t aux_5846;
			      aux_5846 =
				 CNST_TABLE_REF(((long) 36));
			      arg2546_2056 =
				 MAKE_PAIR(aux_5846, BNIL);
			   }
			   arg2545_2055 =
			      MAKE_PAIR(arg2541_2051, arg2546_2056);
			}
			arg2544_2054 =
			   MAKE_PAIR(arg2540_2050, arg2545_2055);
		     }
		     list2543_2053 =
			MAKE_PAIR(class_id_86_239, arg2544_2054);
		  }
		  arg2538_2048 =
		     symbol_append_197___r4_symbols_6_4(list2543_2053);
	       }
	    }
	    {	/* ./Ieee/pair-list.scm 5689 */
	       obj_t aux_5853;
	       aux_5853 =
		  CNST_TABLE_REF(((long) 2));
	       arg2539_2049 =
		  MAKE_PAIR(aux_5853, BNIL);
	    }
	    arg2537_2047 =
	       MAKE_PAIR(arg2538_2048, arg2539_2049);
	 }
	 return
	    import_slot_indexed_set__155_object_access(class_id_86_239, type_240, slot_241, arg2537_2047, src_def_101_242, module_243);
      }
   }
}



/* import-slot-indexed-set! */
obj_t 
import_slot_indexed_set__155_object_access(obj_t class_id_86_249, obj_t type_250, obj_t slot_251, obj_t max_bound_128_252, obj_t src_def_101_253, obj_t module_254)
{
   AN_OBJECT;
   {	/* Object/access.scm 902 */
      {		/* Object/access.scm 903 */
	 obj_t slot_set__id_195_2062;
	 {	/* Object/access.scm 903 */
	    obj_t arg2567_2082;
	    obj_t arg2568_2083;
	    arg2567_2082 =
	       CNST_TABLE_REF(((long) 24));
	    arg2568_2083 =
	       STRUCT_REF(slot_251, ((long) 0));
	    {	/* Object/access.scm 903 */
	       obj_t list2570_2085;
	       {	/* Object/access.scm 903 */
		  obj_t arg2571_2086;
		  {	/* Object/access.scm 903 */
		     obj_t arg2572_2087;
		     {	/* Object/access.scm 903 */
			obj_t arg2573_2088;
			{	/* Object/access.scm 903 */
			   obj_t aux_5860;
			   aux_5860 =
			      CNST_TABLE_REF(((long) 54));
			   arg2573_2088 =
			      MAKE_PAIR(aux_5860, BNIL);
			}
			arg2572_2087 =
			   MAKE_PAIR(arg2568_2083, arg2573_2088);
		     }
		     arg2571_2086 =
			MAKE_PAIR(arg2567_2082, arg2572_2087);
		  }
		  list2570_2085 =
		     MAKE_PAIR(class_id_86_249, arg2571_2086);
	       }
	       slot_set__id_195_2062 =
		  symbol_append_197___r4_symbols_6_4(list2570_2085);
	    }
	 }
	 {	/* Object/access.scm 903 */
	    obj_t slot_set__tid_15_2063;
	    {	/* Object/access.scm 904 */
	       obj_t list2565_2080;
	       {	/* Object/access.scm 904 */
		  obj_t arg2566_2081;
		  {	/* Object/access.scm 904 */
		     obj_t aux_5867;
		     aux_5867 =
			CNST_TABLE_REF(((long) 13));
		     arg2566_2081 =
			MAKE_PAIR(aux_5867, BNIL);
		  }
		  list2565_2080 =
		     MAKE_PAIR(slot_set__id_195_2062, arg2566_2081);
	       }
	       slot_set__tid_15_2063 =
		  symbol_append_197___r4_symbols_6_4(list2565_2080);
	    }
	    {	/* Object/access.scm 904 */
	       obj_t tid_2064;
	       {	/* Object/access.scm 905 */
		  obj_t list2563_2078;
		  {	/* Object/access.scm 905 */
		     obj_t arg2564_2079;
		     {	/* Object/access.scm 905 */
			obj_t aux_5872;
			{	/* Object/access.scm 905 */
			   type_bglt obj_3893;
			   obj_3893 =
			      (type_bglt) (type_250);
			   aux_5872 =
			      (((type_bglt) CREF(obj_3893))->id);
			}
			arg2564_2079 =
			   MAKE_PAIR(aux_5872, BNIL);
		     }
		     list2563_2078 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2564_2079);
		  }
		  tid_2064 =
		     symbol_append_197___r4_symbols_6_4(list2563_2078);
	       }
	       {	/* Object/access.scm 905 */
		  obj_t v_id_210_2065;
		  v_id_210_2065 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 55)), BEOA);
		  {	/* Object/access.scm 906 */
		     obj_t v_tid_138_2066;
		     {	/* Object/access.scm 907 */
			obj_t list2558_2073;
			{	/* Object/access.scm 907 */
			   obj_t arg2559_2074;
			   {	/* Object/access.scm 907 */
			      obj_t arg2560_2075;
			      {		/* Object/access.scm 907 */
				 obj_t aux_5881;
				 {	/* Object/access.scm 909 */
				    type_bglt obj_3897;
				    {	/* Object/access.scm 909 */
				       obj_t aux_5882;
				       aux_5882 =
					  STRUCT_REF(slot_251, ((long) 2));
				       obj_3897 =
					  (type_bglt) (aux_5882);
				    }
				    aux_5881 =
				       (((type_bglt) CREF(obj_3897))->id);
				 }
				 arg2560_2075 =
				    MAKE_PAIR(aux_5881, BNIL);
			      }
			      arg2559_2074 =
				 MAKE_PAIR(_4dots_199_tools_misc, arg2560_2075);
			   }
			   list2558_2073 =
			      MAKE_PAIR(v_id_210_2065, arg2559_2074);
			}
			v_tid_138_2066 =
			   symbol_append_197___r4_symbols_6_4(list2558_2073);
		     }
		     {	/* Object/access.scm 907 */

			{	/* Object/access.scm 910 */
			   obj_t arg2552_2067;
			   {	/* Object/access.scm 910 */
			      obj_t arg2553_2068;
			      {		/* Object/access.scm 910 */
				 obj_t arg2554_2069;
				 {	/* Object/access.scm 910 */
				    obj_t arg2555_2070;
				    obj_t arg2556_2071;
				    arg2555_2070 =
				       CNST_TABLE_REF(((long) 27));
				    arg2556_2071 =
				       MAKE_PAIR(v_tid_138_2066, BNIL);
				    arg2554_2069 =
				       MAKE_PAIR(arg2555_2070, arg2556_2071);
				 }
				 arg2553_2068 =
				    MAKE_PAIR(tid_2064, arg2554_2069);
			      }
			      arg2552_2067 =
				 MAKE_PAIR(slot_set__tid_15_2063, arg2553_2068);
			   }
			   return
			      import_parser_53_module_impuse(module_254, arg2552_2067);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* import-slot-direct-set! */
obj_t 
import_slot_direct_set__76_object_access(obj_t class_id_86_255, obj_t type_256, obj_t slot_257, obj_t src_def_101_258, obj_t module_259)
{
   AN_OBJECT;
   {	/* Object/access.scm 915 */
      {		/* Object/access.scm 916 */
	 obj_t slot_set__id_195_2089;
	 {	/* Object/access.scm 916 */
	    obj_t arg2588_2107;
	    obj_t arg2589_2108;
	    arg2588_2107 =
	       CNST_TABLE_REF(((long) 24));
	    arg2589_2108 =
	       STRUCT_REF(slot_257, ((long) 0));
	    {	/* Object/access.scm 916 */
	       obj_t list2591_2110;
	       {	/* Object/access.scm 916 */
		  obj_t arg2592_2111;
		  {	/* Object/access.scm 916 */
		     obj_t arg2593_2112;
		     {	/* Object/access.scm 916 */
			obj_t arg2594_2113;
			{	/* Object/access.scm 916 */
			   obj_t aux_5898;
			   aux_5898 =
			      CNST_TABLE_REF(((long) 54));
			   arg2594_2113 =
			      MAKE_PAIR(aux_5898, BNIL);
			}
			arg2593_2112 =
			   MAKE_PAIR(arg2589_2108, arg2594_2113);
		     }
		     arg2592_2111 =
			MAKE_PAIR(arg2588_2107, arg2593_2112);
		  }
		  list2591_2110 =
		     MAKE_PAIR(class_id_86_255, arg2592_2111);
	       }
	       slot_set__id_195_2089 =
		  symbol_append_197___r4_symbols_6_4(list2591_2110);
	    }
	 }
	 {	/* Object/access.scm 916 */
	    obj_t slot_set__tid_15_2090;
	    {	/* Object/access.scm 917 */
	       obj_t list2586_2105;
	       {	/* Object/access.scm 917 */
		  obj_t arg2587_2106;
		  {	/* Object/access.scm 917 */
		     obj_t aux_5905;
		     aux_5905 =
			CNST_TABLE_REF(((long) 13));
		     arg2587_2106 =
			MAKE_PAIR(aux_5905, BNIL);
		  }
		  list2586_2105 =
		     MAKE_PAIR(slot_set__id_195_2089, arg2587_2106);
	       }
	       slot_set__tid_15_2090 =
		  symbol_append_197___r4_symbols_6_4(list2586_2105);
	    }
	    {	/* Object/access.scm 917 */
	       obj_t tid_2091;
	       {	/* Object/access.scm 918 */
		  obj_t list2584_2103;
		  {	/* Object/access.scm 918 */
		     obj_t arg2585_2104;
		     {	/* Object/access.scm 918 */
			obj_t aux_5910;
			{	/* Object/access.scm 918 */
			   type_bglt obj_3909;
			   obj_3909 =
			      (type_bglt) (type_256);
			   aux_5910 =
			      (((type_bglt) CREF(obj_3909))->id);
			}
			arg2585_2104 =
			   MAKE_PAIR(aux_5910, BNIL);
		     }
		     list2584_2103 =
			MAKE_PAIR(_4dots_199_tools_misc, arg2585_2104);
		  }
		  tid_2091 =
		     symbol_append_197___r4_symbols_6_4(list2584_2103);
	       }
	       {	/* Object/access.scm 918 */
		  obj_t v_id_210_2092;
		  v_id_210_2092 =
		     PROCEDURE_ENTRY(gensym___r4_symbols_6_4) (gensym___r4_symbols_6_4,
		     CNST_TABLE_REF(((long) 55)), BEOA);
		  {	/* Object/access.scm 919 */
		     obj_t v_tid_138_2093;
		     {	/* Object/access.scm 920 */
			obj_t list2579_2098;
			{	/* Object/access.scm 920 */
			   obj_t arg2580_2099;
			   {	/* Object/access.scm 920 */
			      obj_t arg2581_2100;
			      {		/* Object/access.scm 920 */
				 obj_t aux_5919;
				 {	/* Object/access.scm 922 */
				    type_bglt obj_3913;
				    {	/* Object/access.scm 922 */
				       obj_t aux_5920;
				       aux_5920 =
					  STRUCT_REF(slot_257, ((long) 2));
				       obj_3913 =
					  (type_bglt) (aux_5920);
				    }
				    aux_5919 =
				       (((type_bglt) CREF(obj_3913))->id);
				 }
				 arg2581_2100 =
				    MAKE_PAIR(aux_5919, BNIL);
			      }
			      arg2580_2099 =
				 MAKE_PAIR(_4dots_199_tools_misc, arg2581_2100);
			   }
			   list2579_2098 =
			      MAKE_PAIR(v_id_210_2092, arg2580_2099);
			}
			v_tid_138_2093 =
			   symbol_append_197___r4_symbols_6_4(list2579_2098);
		     }
		     {	/* Object/access.scm 920 */

			{	/* Object/access.scm 923 */
			   obj_t arg2574_2094;
			   {	/* Object/access.scm 923 */
			      obj_t arg2575_2095;
			      {		/* Object/access.scm 923 */
				 obj_t arg2576_2096;
				 arg2576_2096 =
				    MAKE_PAIR(v_tid_138_2093, BNIL);
				 arg2575_2095 =
				    MAKE_PAIR(tid_2091, arg2576_2096);
			      }
			      arg2574_2094 =
				 MAKE_PAIR(slot_set__tid_15_2090, arg2575_2095);
			   }
			   return
			      import_parser_53_module_impuse(module_259, arg2574_2094);
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* epairify* */
obj_t 
epairify__149_object_access(obj_t def_260, obj_t srcs_261)
{
   AN_OBJECT;
   {	/* Object/access.scm 928 */
      {
	 obj_t srcs_2114;
	 srcs_2114 = srcs_261;
       loop_2115:
	 if (
	    NULLP(srcs_2114))
	   {	/* Object/access.scm 931 */
	      return def_260;
	   }
	 else
	   {	/* Object/access.scm 933 */
	      bool_t test2596_2117;
	      {		/* ./Ieee/pair-list.scm 5675 */
		 obj_t aux_5934;
		 aux_5934 =
		    CAR(srcs_2114);
		 test2596_2117 =
		    EXTENDED_PAIRP(aux_5934);
	      }
	      if (test2596_2117)
		{	/* Object/access.scm 933 */
		   {	/* Object/access.scm 934 */
		      obj_t arg2597_2118;
		      obj_t arg2598_2119;
		      obj_t arg2599_2120;
		      arg2597_2118 =
			 CAR(def_260);
		      arg2598_2119 =
			 CDR(def_260);
		      {		/* Object/access.scm 934 */
			 obj_t arg2600_2121;
			 arg2600_2121 =
			    CAR(srcs_2114);
			 {	/* ./Ieee/pair-list.scm 5713 */
			    bool_t test1136_3927;
			    test1136_3927 =
			       EXTENDED_PAIRP(arg2600_2121);
			    if (test1136_3927)
			      {		/* ./Ieee/pair-list.scm 5713 */
				 arg2599_2120 =
				    CER(arg2600_2121);
			      }
			    else
			      {		/* ./Ieee/pair-list.scm 5713 */
				 FAILURE(string2645_object_access, string2646_object_access, arg2600_2121);
			      }
			 }
		      }
		      return
			 MAKE_EXTENDED_PAIR(arg2597_2118, arg2598_2119, arg2599_2120);
		   }
		}
	      else
		{	/* Object/access.scm 933 */
		   {
		      obj_t srcs_5946;
		      srcs_5946 =
			 CDR(srcs_2114);
		      srcs_2114 = srcs_5946;
		      goto loop_2115;
		   }
		}
	   }
      }
   }
}



/* _epairify* */
obj_t 
_epairify__213_object_access(obj_t env_4018, obj_t def_4019, obj_t srcs_4020)
{
   AN_OBJECT;
   {	/* Object/access.scm 928 */
      return
	 epairify__149_object_access(def_4019, srcs_4020);
   }
}



/* method-init */
obj_t 
method_init_76_object_access()
{
   AN_OBJECT;
   {	/* Object/access.scm 20 */
      return BUNSPEC;
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_object_access()
{
   AN_OBJECT;
   {	/* Object/access.scm 20 */
      module_initialization_70_tools_trace(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_tools_error(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_tools_misc(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_type_type(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_type_env(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_type_tools(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_type_cache(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_ast_var(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_ast_ident(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_object_class(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_object_struct(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_object_slots(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_object_tools(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_module_module(((long) 0), "OBJECT_ACCESS");
      module_initialization_70_module_impuse(((long) 0), "OBJECT_ACCESS");
      return
	 module_initialization_70_engine_param(((long) 0), "OBJECT_ACCESS");
   }
}
